structure cnfTheory :> cnfTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading cnfTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open grammarDefTheory
  in end;
  val _ = Theory.link_parents
          ("cnf",Arbnum.fromString "1259562027",Arbnum.fromString "848705")
          [("grammarDef",
           Arbnum.fromString "1259448278",
           Arbnum.fromString "141041")];
  val _ = Theory.incorporate_types "cnf" [];
  val _ = Theory.incorporate_consts "cnf"
     [("trans2NT",
       ((alpha -->
         (T"symbol" "regexp" [alpha, beta] -->
          (T"symbol" "regexp" [alpha, beta] -->
           (T"grammar" "grammarDef" [alpha, beta] -->
            (T"grammar" "grammarDef" [alpha, beta] --> bool))))))),
      ("trans1Tmnl",
       ((alpha -->
         (T"symbol" "regexp" [alpha, beta] -->
          (T"grammar" "grammarDef" [alpha, beta] -->
           (T"grammar" "grammarDef" [alpha, beta] --> bool)))))),
      ("ruleTmnls",
       ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []))),
      ("ruleNonTmnls",
       ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []))),
      ("noNewNts",
       ((T"grammar" "grammarDef" [alpha, beta] -->
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
      ("eqLang",
       ((T"grammar" "grammarDef" [alpha, beta] -->
         (T"grammar" "grammarDef" [alpha, beta] --> bool)))),
      ("elim_tupled",
       ((T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("elimNT_tupled",
       ((T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("elimNT",
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         (T"rule" "grammarDef" [alpha, beta] -->
          T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
      ("elim",
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         (T"rule" "grammarDef" [alpha, beta] -->
          T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
      ("cnf",((T"grammar" "grammarDef" [alpha, beta] --> bool))),
      ("badTmnlRules",
       ((T"grammar" "grammarDef" [alpha, beta] --> T"num" "num" []))),
      ("badNtRules",
       ((T"grammar" "grammarDef" [alpha, beta] --> T"num" "num" [])))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((alpha --> bool) --> bool)), V"nt" (alpha),
   C"!" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"t" (T"symbol" "regexp" [alpha, beta]),
   C"!" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"g" (T"grammar" "grammarDef" [alpha, beta]),
   V"g'" (T"grammar" "grammarDef" [alpha, beta]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"trans1Tmnl" "cnf"
    ((alpha -->
      (T"symbol" "regexp" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] -->
        (T"grammar" "grammarDef" [alpha, beta] --> bool))))),
   C"?" "bool" (((alpha --> bool) --> bool)), V"l" (alpha),
   C"?" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"r" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"p" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"MEM" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"rule" "grammarDef"
    ((alpha -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"CONS" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"~" "bool" ((bool --> bool)),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"IN" "bool"
    ((T"symbol" "regexp" [alpha, beta] -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) --> bool))),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, beta])),
   C"nonTerminals" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"=" "min"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"delete" "listLemmas"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"CONS" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"NIL" "list" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] --> alpha)),
   C"=" "min"
    (((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []) -->
      ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []) -->
       bool))),
   C"ruleTmnls" "cnf"
    ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   C"WFREC" "relation"
    (((T"rule" "grammarDef" [alpha, beta] -->
       (T"rule" "grammarDef" [alpha, beta] --> bool)) -->
      (((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []) -->
        (T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])) -->
       (T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])))),
   C"@" "min"
    ((((T"rule" "grammarDef" [alpha, beta] -->
        (T"rule" "grammarDef" [alpha, beta] --> bool)) --> bool) -->
      (T"rule" "grammarDef" [alpha, beta] -->
       (T"rule" "grammarDef" [alpha, beta] --> bool)))),
   V"R"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"rule" "grammarDef" [alpha, beta] --> bool))),
   C"WF" "relation"
    (((T"rule" "grammarDef" [alpha, beta] -->
       (T"rule" "grammarDef" [alpha, beta] --> bool)) --> bool)),
   V"ruleTmnls" ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   V"a" (T"rule" "grammarDef" [alpha, beta]),
   C"rule_case" "grammarDef"
    (((alpha -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"num" "num" [])) -->
      (T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []))),
   V"v1" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"list_case" "list"
    ((T"num" "num" [] -->
      ((T"symbol" "regexp" [alpha, beta] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         T"num" "num" [])) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"num" "num" [])))),
   C"I" "combin" ((T"num" "num" [] --> T"num" "num" [])),
   C"LENGTH" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"num" "num" [])),
   C"FILTER" "list"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   V"v5" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"0" "num" (T"num" "num" []), V"v8" (T"symbol" "regexp" [alpha, beta]),
   V"v9" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"ruleNonTmnls" "cnf"
    ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   V"ruleNonTmnls"
    ((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   V"t2" (T"symbol" "regexp" [alpha, beta]),
   V"v12" (T"symbol" "regexp" [alpha, beta]),
   V"v13" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"isNonTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"badTmnlRules" "cnf"
    ((T"grammar" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   C"SUM" "list" ((T"list" "list" [T"num" "num" []] --> T"num" "num" [])),
   C"MAP" "list"
    (((T"rule" "grammarDef" [alpha, beta] --> T"num" "num" []) -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"num" "num" []]))),
   C"badNtRules" "cnf"
    ((T"grammar" "grammarDef" [alpha, beta] --> T"num" "num" [])),
   C"cnf" "cnf" ((T"grammar" "grammarDef" [alpha, beta] --> bool)),
   V"nt1" (T"symbol" "regexp" [alpha, beta]),
   V"nt2" (T"symbol" "regexp" [alpha, beta]),
   C"trans2NT" "cnf"
    ((alpha -->
      (T"symbol" "regexp" [alpha, beta] -->
       (T"symbol" "regexp" [alpha, beta] -->
        (T"grammar" "grammarDef" [alpha, beta] -->
         (T"grammar" "grammarDef" [alpha, beta] --> bool)))))),
   C"=" "min"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      ((T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]) --> bool))),
   C"elim_tupled" "cnf"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)) -->
      (((T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
        (T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        (T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)) --> bool)),
   V"elim_tupled"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"a"
    (T"prod" "pair"
      [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
       T"rule" "grammarDef" [alpha, beta]]),
   C"pair_case" "pair"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"rule" "grammarDef" [alpha, beta] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   V"sf" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"v1" (T"rule" "grammarDef" [alpha, beta]),
   C"rule_case" "grammarDef"
    (((alpha -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   V"v3" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"list_case" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      ((T"symbol" "regexp" [alpha, beta] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   C"ARB" "bool" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"I" "combin"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"MAP" "list"
    (((T"symbol" "regexp" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   V"e" (T"symbol" "regexp" [alpha, beta]),
   C"COND" "bool"
    ((bool -->
      (T"symbol" "regexp" [alpha, beta] -->
       (T"symbol" "regexp" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   V"v6" (T"symbol" "regexp" [alpha, beta]),
   V"v7" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"x" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"!" "bool" (((T"rule" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"x1" (T"rule" "grammarDef" [alpha, beta]),
   C"elim" "cnf"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"," "pair"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]]))),
   C"elimNT_tupled" "cnf"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"s" (T"symbol" "regexp" [alpha, beta]),
   C"==>" "min" ((bool --> (bool --> bool))),
   V"elimNT_tupled"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"v" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"v10" (T"symbol" "regexp" [alpha, beta]),
   V"v11" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"nt'" (alpha),
   V"v15" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"nt1'" (T"symbol" "regexp" [alpha, beta]),
   V"v17" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"nt2'" (T"symbol" "regexp" [alpha, beta]),
   V"v19" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"COND" "bool"
    ((bool -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   V"v20" (T"symbol" "regexp" [alpha, beta]),
   V"v21" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"elimNT" "cnf"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"noNewNts" "cnf"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"MEM" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"eqLang" "cnf"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"grammar" "grammarDef" [alpha, beta] --> bool))),
   C"=" "min"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       bool))),
   C"language" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"!" "bool"
    ((((T"rule" "grammarDef" [alpha, beta] --> bool) --> bool) --> bool)),
   V"P" ((T"rule" "grammarDef" [alpha, beta] --> bool)),
   V"v2" (T"symbol" "regexp" [alpha, beta]),
   V"v" (T"rule" "grammarDef" [alpha, beta]),
   C"COND" "bool"
    ((bool -->
      (T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" [])))),
   C"<=" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   V"t1" (T"symbol" "regexp" [alpha, beta]),
   C"!" "bool"
    ((((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        (T"rule" "grammarDef" [alpha, beta] --> bool)) --> bool) -->
      bool)),
   V"P"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"rule" "grammarDef" [alpha, beta] --> bool))),
   V"v22" (T"symbol" "regexp" [alpha, beta]),
   V"v23" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"RTC" "relation"
    (((T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] --> bool)) -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] --> bool)))),
   V"x" (T"grammar" "grammarDef" [alpha, beta]),
   V"y" (T"grammar" "grammarDef" [alpha, beta]),
   C"?" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"g''" (T"grammar" "grammarDef" [alpha, beta]),
   C"INFINITE" "pred_set" (((alpha --> bool) --> bool)),
   C"UNIV" "pred_set" ((alpha --> bool)),
   C"?" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool))]
  val DT = Thm.disk_thm share_table
  in
  val trans1Tmnl_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%4 (\%5. (%4 (\%6. ((%7 ((((%8 $3) $2) $1)
       $0)) (%9 (\%10. (%11 (\%12. (%11 (\%13. (%11 (\%14. ((%15 ((%16
       ((%17 $3) $2)) (%18 $5))) ((%15 ((%19 $2) ((%20 ((%20 $1) ((%21 $6)
       %22))) $0))) ((%15 ((%23 (%24 ((%19 $1) %22))) (%24 ((%19 $0)
       %22)))) ((%15 (%25 $6)) ((%15 (%24 ((%26 (%27 $7)) (%28 $5)))) ((%15
       ((%29 (%18 $4)) ((%30 ((%31 ((%17 $3) $2)) (%18 $5))) ((%32 ((%17
       $7) ((%21 $6) %22))) ((%32 ((%17 $3) ((%20 ((%20 $1) ((%21 (%27 $7))
       %22))) $0))) %33))))) ((%34 (%35 $4)) (%35
       $5)))))))))))))))))))))))))`)
  val ruleTmnls_primitive_def =
    DT([], [],
       `((%36 %37) ((%38 (%39 (\%40. (%41 $0)))) (\%42. (\%43. ((%44 (\%10.
       (\%45. (((%46 (%47 (%48 ((%49 %25) %22)))) (\%3. (\%50. (((%46 (%47
       %51)) (\%52. (\%53. (%47 (%48 ((%49 %25) ((%21 $3) ((%21 $1)
       $0)))))))) $0)))) $0)))) $0)))))`)
  val ruleNonTmnls_primitive_def =
    DT([], [],
       `((%36 %54) ((%38 (%39 (\%40. (%41 $0)))) (\%55. (\%43. ((%44 (\%10.
       (\%45. (((%46 (%47 %51)) (\%3. (\%50. (((%46 (%47 %51)) (\%56.
       (\%53. (((%46 (%47 %51)) (\%57. (\%58. (%47 (%48 ((%49 %59) ((%21
       $5) ((%21 $3) ((%21 $1) $0))))))))) $0)))) $0)))) $0)))) $0)))))`)
  val badTmnlRules_def =
    DT([], [], `(%4 (\%5. ((%60 (%61 $0)) (%62 ((%63 %37) (%18 $0))))))`)
  val badNtRules_def =
    DT([], [], `(%4 (\%5. ((%60 (%64 $0)) (%62 ((%63 %54) (%18 $0))))))`)
  val cnf_def =
    DT([], [],
       `(%4 (\%5. ((%7 (%65 $0)) ((%15 ((%60 (%64 $0)) %51)) ((%60 (%61
       $0)) %51)))))`)
  val trans2NT_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%66. (%2 (\%67. (%4 (\%5. (%4 (\%6. ((%7 (((((%68
       $4) $3) $2) $1) $0)) (%9 (\%10. (%11 (\%12. (%11 (\%13. (%11 (\%14.
       ((%15 ((%16 ((%17 $3) $2)) (%18 $5))) ((%15 ((%19 $2) ((%20 ((%20
       $1) ((%21 $7) ((%21 $6) %22)))) $0))) ((%15 ((%23 (%24 ((%19 $1)
       %22))) (%24 ((%19 $0) %22)))) ((%15 (%59 $7)) ((%15 (%59 $6)) ((%15
       (%24 ((%26 (%27 $8)) (%28 $5)))) ((%15 ((%29 (%18 $4)) ((%30 ((%31
       ((%17 $3) $2)) (%18 $5))) ((%32 ((%17 $8) ((%21 $7) ((%21 $6)
       %22)))) ((%32 ((%17 $3) ((%20 ((%20 $1) ((%21 (%27 $8)) %22))) $0)))
       %33))))) ((%34 (%35 $4)) (%35 $5))))))))))))))))))))))))))))`)
  val elim_tupled_primitive_def =
    DT([], [],
       `((%69 %70) ((%71 (%72 (\%73. (%74 $0)))) (\%75. (\%76. ((%77 (\%78.
       (\%79. ((%80 (\%1. (\%81. (((%82 %83) (\%3. (\%50. (((%82 (%84 ((%85
       (\%86. (((%87 ((%88 $0) (%27 $4))) $2) $0))) $5))) (\%89. (\%90.
       %83))) $0)))) $0)))) $0)))) $0)))))`)
  val elim_curried_def =
    DT([], [],
       `(%91 (\%92. (%93 (\%94. ((%19 ((%95 $1) $0)) (%70 ((%96 $1)
       $0)))))))`)
  val elimNT_tupled_primitive_def =
    DT([], [],
       `((%69 %97) ((%71 (%72 (\%73. ((%15 (%74 $0)) ((%15 (%2 (\%67. (%2
       (\%66. (%91 (\%78. (%0 (\%1. (%2 (\%98. ((%99 (%24 ((%88 $0) (%27
       $1)))) (($5 ((%96 $2) ((%17 $1) ((%21 $3) ((%21 $4) %22))))) ((%96
       ((%21 $0) $2)) ((%17 $1) ((%21 $3) ((%21 $4) %22)))))))))))))))))
       (%2 (\%67. (%2 (\%66. (%91 (\%78. (%0 (\%1. (%2 (\%98. ((%99 ((%88
       $0) (%27 $1))) (($5 ((%96 $2) ((%17 $1) ((%21 $3) ((%21 $4) %22)))))
       ((%96 ((%21 $0) $2)) ((%17 $1) ((%21 $3) ((%21 $4)
       %22))))))))))))))))))))) (\%100. (\%76. ((%77 (\%101. (\%79. (((%82
       ((%80 (\%1. (\%50. (((%82 %83) (\%66. (\%90. (((%82 %83) (\%67.
       (\%53. (((%82 (%84 %22)) (\%102. (\%103. %83))) $0)))) $0)))) $0))))
       $0)) (\%98. (\%78. ((%80 (\%104. (\%105. (((%82 %83) (\%106. (\%107.
       (((%82 %83) (\%108. (\%109. (((%82 (%84 (((%110 ((%88 $7) (%27 $5)))
       ((%20 ((%21 $3) ((%21 $1) %22))) ($11 ((%96 $6) ((%17 $5) ((%21 $3)
       ((%21 $1) %22))))))) ((%21 $7) ($11 ((%96 $6) ((%17 $5) ((%21 $3)
       ((%21 $1) %22))))))))) (\%111. (\%112. %83))) $0)))) $0)))) $0))))
       $2)))) $1)))) $0)))))`)
  val elimNT_curried_def =
    DT([], [],
       `(%91 (\%92. (%93 (\%94. ((%19 ((%113 $1) $0)) (%97 ((%96 $1)
       $0)))))))`)
  val noNewNts_def =
    DT([], [],
       `(%4 (\%5. (%91 (\%78. ((%7 ((%114 $1) $0)) (%2 (\%86. ((%99 ((%115
       $0) $1)) ((%99 (%59 $0)) ((%26 $0) (%28 $2)))))))))))`)
  val eqLang_def =
    DT([], [],
       `(%4 (\%5. (%4 (\%6. ((%7 ((%116 $1) $0)) ((%117 (%118 $1)) (%118
       $0)))))))`)
  val ruleTmnls_ind =
    DT(["DISK_THM"], [],
       `(%119 (\%120. ((%99 ((%15 (%0 (\%10. (%2 (\%3. ($2 ((%17 $1) ((%21
       $0) %22)))))))) ((%15 (%0 (\%10. ($1 ((%17 $0) %22))))) (%0 (\%10.
       (%2 (\%121. (%2 (\%89. (%91 (\%90. ($4 ((%17 $3) ((%21 $2) ((%21 $1)
       $0))))))))))))))) (%93 (\%122. ($1 $0))))))`)
  val ruleTmnls_def =
    DT(["DISK_THM"], [],
       `((%15 ((%60 (%37 ((%17 %10) ((%21 %3) %22)))) %51)) ((%15 ((%60
       (%37 ((%17 %10) %22))) (%48 ((%49 %25) %22)))) ((%60 (%37 ((%17 %10)
       ((%21 %121) ((%21 %89) %90))))) (%48 ((%49 %25) ((%21 %121) ((%21
       %89) %90)))))))`)
  val ruleTmnlsAlt =
    DT(["DISK_THM"], [],
       `(%0 (\%10. (%91 (\%12. ((%60 (%37 ((%17 $1) $0))) (((%123 ((%124
       (%48 $0)) (%125 (%126 %127)))) %51) (%48 ((%49 %25) $0))))))))`)
  val ruleNonTmnls_ind =
    DT(["DISK_THM"], [],
       `(%119 (\%120. ((%99 ((%15 (%0 (\%10. ($1 ((%17 $0) %22))))) ((%15
       (%0 (\%10. (%2 (\%3. ($2 ((%17 $1) ((%21 $0) %22)))))))) ((%15 (%0
       (\%10. (%2 (\%128. (%2 (\%56. ($3 ((%17 $2) ((%21 $1) ((%21 $0)
       %22))))))))))) (%0 (\%10. (%2 (\%121. (%2 (\%89. (%2 (\%102. (%91
       (\%103. ($5 ((%17 $4) ((%21 $3) ((%21 $2) ((%21 $1)
       $0))))))))))))))))))) (%93 (\%122. ($1 $0))))))`)
  val ruleNonTmnls_def =
    DT(["DISK_THM"], [],
       `((%15 ((%60 (%54 ((%17 %10) %22))) %51)) ((%15 ((%60 (%54 ((%17
       %10) ((%21 %3) %22)))) %51)) ((%15 ((%60 (%54 ((%17 %10) ((%21 %128)
       ((%21 %56) %22))))) %51)) ((%60 (%54 ((%17 %10) ((%21 %121) ((%21
       %89) ((%21 %102) %103)))))) (%48 ((%49 %59) ((%21 %121) ((%21 %89)
       ((%21 %102) %103)))))))))`)
  val elim_ind =
    DT(["DISK_THM"], [],
       `(%129 (\%130. ((%99 ((%15 (%91 (\%78. (%0 (\%1. (%2 (\%3. (($3 $2)
       ((%17 $1) ((%21 $0) %22)))))))))) ((%15 (%91 (\%78. (%0 (\%1. (($2
       $1) ((%17 $0) %22))))))) (%91 (\%78. (%0 (\%1. (%2 (\%3. (%2 (\%52.
       (%91 (\%53. (($5 $4) ((%17 $3) ((%21 $2) ((%21 $1)
       $0))))))))))))))))) (%91 (\%101. (%93 (\%79. (($2 $1) $0))))))))`)
  val elim_def =
    DT(["DISK_THM"], [],
       `((%19 ((%95 %78) ((%17 %1) ((%21 %3) %22)))) ((%85 (\%86. (((%87
       ((%88 $0) (%27 %1))) %3) $0))) %78))`)
  val elimNT_ind =
    DT(["DISK_THM"], [],
       `(%129 (\%130. ((%99 ((%15 (%0 (\%1. (%2 (\%66. (%2 (\%67. (($3 %22)
       ((%17 $2) ((%21 $1) ((%21 $0) %22))))))))))) ((%15 (%2 (\%98. (%91
       (\%78. (%0 (\%1. (%2 (\%66. (%2 (\%67. ((%99 ((%15 ((%99 (%24 ((%88
       $4) (%27 $2)))) (($5 $3) ((%17 $2) ((%21 $1) ((%21 $0) %22))))))
       ((%99 ((%88 $4) (%27 $2))) (($5 $3) ((%17 $2) ((%21 $1) ((%21 $0)
       %22))))))) (($5 ((%21 $4) $3)) ((%17 $2) ((%21 $1) ((%21 $0)
       %22)))))))))))))))) ((%15 (%0 (\%1. (($1 %22) ((%17 $0) %22)))))
       ((%15 (%0 (\%1. (%2 (\%66. (($2 %22) ((%17 $1) ((%21 $0) %22))))))))
       ((%15 (%0 (\%1. (%2 (\%66. (%2 (\%67. (%2 (\%57. (%91 (\%58. (($5
       %22) ((%17 $4) ((%21 $3) ((%21 $2) ((%21 $1) $0))))))))))))))))
       ((%15 (%2 (\%98. (%91 (\%78. (%0 (\%1. (($3 ((%21 $2) $1)) ((%17 $0)
       %22))))))))) ((%15 (%2 (\%98. (%91 (\%78. (%0 (\%1. (%2 (\%66. (($4
       ((%21 $3) $2)) ((%17 $1) ((%21 $0) %22)))))))))))) (%2 (\%98. (%91
       (\%78. (%0 (\%1. (%2 (\%66. (%2 (\%67. (%2 (\%131. (%91 (\%132. (($7
       ((%21 $6) $5)) ((%17 $4) ((%21 $3) ((%21 $2) ((%21 $1)
       $0))))))))))))))))))))))))))) (%91 (\%101. (%93 (\%79. (($2 $1)
       $0))))))))`)
  val elimNT_def =
    DT(["DISK_THM"], [],
       `((%15 (%2 (\%67. (%2 (\%66. (%0 (\%1. ((%19 ((%113 %22) ((%17 $0)
       ((%21 $1) ((%21 $2) %22))))) %22)))))))) (%91 (\%78. (%2 (\%98. (%2
       (\%67. (%2 (\%66. (%0 (\%1. ((%19 ((%113 ((%21 $3) $4)) ((%17 $0)
       ((%21 $1) ((%21 $2) %22))))) (((%110 ((%88 $3) (%27 $0))) ((%20
       ((%21 $1) ((%21 $2) %22))) ((%113 $4) ((%17 $0) ((%21 $1) ((%21 $2)
       %22)))))) ((%21 $3) ((%113 $4) ((%17 $0) ((%21 $1) ((%21 $2)
       %22))))))))))))))))))`)
  val cnf_lemma1 =
    DT(["DISK_THM"], [],
       `(%4 (\%5. (%4 (\%6. (%0 (\%1. (%2 (\%3. ((%99 ((((%8 $1) $0) $3)
       $2)) ((%117 (%118 $3)) (%118 $2)))))))))))`)
  val cnf_lemma2 =
    DT(["DISK_THM"], [],
       `(%4 (\%5. (%4 (\%6. ((%99 (((%133 (\%134. (\%135. (%9 (\%1. (%136
       (\%3. ((((%8 $1) $0) $3) $2)))))))) $1) $0)) ((%116 $1) $0))))))`)
  val cnf_lemma2NT =
    DT(["DISK_THM"], [],
       `(%4 (\%5. (%4 (\%6. ((%99 (((%133 (\%134. (\%135. (%9 (\%1. (%136
       (\%66. (%136 (\%67. (((((%68 $2) $1) $0) $4) $3)))))))))) $1) $0))
       ((%116 $1) $0))))))`)
  val cnf_lemma =
    DT(["DISK_THM"], [],
       `(%4 (\%5. (%4 (\%6. (%4 (\%137. ((%99 (((%133 (\%134. (\%135. (%9
       (\%1. (%136 (\%3. ((((%8 $1) $0) $3) $2)))))))) $2) $1)) ((%99
       (((%133 (\%134. (\%135. (%9 (\%1. (%136 (\%66. (%136 (\%67. (((((%68
       $2) $1) $0) $4) $3)))))))))) $1) $0)) ((%116 $2) $0)))))))))`)
  val lemma14_b =
    DT(["DISK_THM", "MK_THM"], [],
       `(%4 (\%5. (%4 (\%6. ((%99 (((%133 (\%134. (\%135. (%9 (\%1. (%136
       (\%66. (%136 (\%67. (((((%68 $2) $1) $0) $4) $3)))))))))) $1) $0))
       ((%99 ((%60 (%61 $1)) %51)) ((%60 (%61 $0)) %51)))))))`)
  val lemma9_a =
    DT(["DISK_THM", "MK_THM"], [],
       `((%99 (%138 %139)) (%140 (\%6. ((%15 (((%133 (\%134. (\%135. (%9
       (\%1. (%136 (\%3. ((((%8 $1) $0) $3) $2)))))))) %5) $0)) ((%60 (%61
       $0)) %51)))))`)
  val lemma9_b =
    DT(["DISK_THM", "MK_THM"], [],
       `((%99 (%138 %139)) ((%99 ((%60 (%61 %5)) %51)) (%140 (\%6. ((%15
       (((%133 (\%134. (\%135. (%9 (\%1. (%136 (\%66. (%136 (\%67. (((((%68
       $2) $1) $0) $4) $3)))))))))) %5) $0)) ((%60 (%64 $0)) %51))))))`)
  val thm4_5 =
    DT(["DISK_THM", "MK_THM"], [],
       `(%4 (\%5. ((%99 (%138 %139)) (%140 (\%6. ((%15 (%65 $0)) ((%116 $1)
       $0)))))))`)
  end
  val _ = DB.bindl "cnf"
  [("trans1Tmnl_def",trans1Tmnl_def,DB.Def),
   ("ruleTmnls_primitive_def",ruleTmnls_primitive_def,DB.Def),
   ("ruleNonTmnls_primitive_def",ruleNonTmnls_primitive_def,DB.Def),
   ("badTmnlRules_def",badTmnlRules_def,DB.Def),
   ("badNtRules_def",badNtRules_def,DB.Def), ("cnf_def",cnf_def,DB.Def),
   ("trans2NT_def",trans2NT_def,DB.Def),
   ("elim_tupled_primitive_def",elim_tupled_primitive_def,DB.Def),
   ("elim_curried_def",elim_curried_def,DB.Def),
   ("elimNT_tupled_primitive_def",elimNT_tupled_primitive_def,DB.Def),
   ("elimNT_curried_def",elimNT_curried_def,DB.Def),
   ("noNewNts_def",noNewNts_def,DB.Def), ("eqLang_def",eqLang_def,DB.Def),
   ("ruleTmnls_ind",ruleTmnls_ind,DB.Thm),
   ("ruleTmnls_def",ruleTmnls_def,DB.Thm),
   ("ruleTmnlsAlt",ruleTmnlsAlt,DB.Thm),
   ("ruleNonTmnls_ind",ruleNonTmnls_ind,DB.Thm),
   ("ruleNonTmnls_def",ruleNonTmnls_def,DB.Thm),
   ("elim_ind",elim_ind,DB.Thm), ("elim_def",elim_def,DB.Thm),
   ("elimNT_ind",elimNT_ind,DB.Thm), ("elimNT_def",elimNT_def,DB.Thm),
   ("cnf_lemma1",cnf_lemma1,DB.Thm), ("cnf_lemma2",cnf_lemma2,DB.Thm),
   ("cnf_lemma2NT",cnf_lemma2NT,DB.Thm), ("cnf_lemma",cnf_lemma,DB.Thm),
   ("lemma14_b",lemma14_b,DB.Thm), ("lemma9_a",lemma9_a,DB.Thm),
   ("lemma9_b",lemma9_b,DB.Thm), ("thm4_5",thm4_5,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("grammarDefTheory.grammarDef_grammars",
                          grammarDefTheory.grammarDef_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("trans1Tmnl", (Term.prim_mk_const { Name = "trans1Tmnl", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("ruleTmnls", (Term.prim_mk_const { Name = "ruleTmnls", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("ruleNonTmnls", (Term.prim_mk_const { Name = "ruleNonTmnls", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("badTmnlRules", (Term.prim_mk_const { Name = "badTmnlRules", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("badNtRules", (Term.prim_mk_const { Name = "badNtRules", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("cnf", (Term.prim_mk_const { Name = "cnf", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("trans2NT", (Term.prim_mk_const { Name = "trans2NT", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("elim_tupled", (Term.prim_mk_const { Name = "elim_tupled", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("elim", (Term.prim_mk_const { Name = "elim", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("elimNT_tupled", (Term.prim_mk_const { Name = "elimNT_tupled", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("elimNT", (Term.prim_mk_const { Name = "elimNT", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("noNewNts", (Term.prim_mk_const { Name = "noNewNts", Thy = "cnf"}))
  val _ = update_grms
       temp_overload_on
       ("eqLang", (Term.prim_mk_const { Name = "eqLang", Thy = "cnf"}))
  val cnf_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ = computeLib.add_funs [trans1Tmnl_def];  
  
  val _ = computeLib.add_funs [ruleTmnls_def];  
  
  val _ = computeLib.add_funs [ruleNonTmnls_def];  
  
  val _ = computeLib.add_funs [badTmnlRules_def];  
  
  val _ = computeLib.add_funs [badNtRules_def];  
  
  val _ = computeLib.add_funs [cnf_def];  
  
  val _ = computeLib.add_funs [trans2NT_def];  
  
  val _ = computeLib.add_funs [elim_def];  
  
  val _ = computeLib.add_funs [elimNT_def];  
  
  val _ = computeLib.add_funs [noNewNts_def];  
  
  val _ = computeLib.add_funs [eqLang_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
