signature generatingGrammarTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val usefulnts_def : thm
  
  (*  Theorems  *)
    val eq_startsym : thm
    val lemma4_1a : thm
    val subr4 : thm
    val subr4_rev : thm
    val subr5 : thm
    val subr5' : thm
    val use_exists : thm
  
  val generatingGrammar_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [grammarDef] Parent theory of "generatingGrammar"
   
   [usefulnts_def]  Definition
      
      |- ∀p s g'.
           usefulnts (G p s) g' ⇔
           (∀e.
              MEM e (rules g') ⇔
              e ∈
              {rule l r |
               MEM (rule l r) p ∧ gaw (G p s) (NTS l) ∧ EVERY (gaw (G p s)) r}) ∧
           (startSym g' = s)
   
   [eq_startsym]  Theorem
      
      |- usefulnts g g' ⇒ (startSym g' = startSym g)
   
   [lemma4_1a]  Theorem
      
      |- usefulnts g g' ⇒ (language g = language g')
   
   [subr4]  Theorem
      
      |- ∀v w.
           (derives g)^* v w ⇒
           usefulnts g g' ⇒
           EVERY isTmnlSym w ⇒
           (derives g')^* v w
   
   [subr4_rev]  Theorem
      
      |- ∀v w. (derives g')^* v w ⇒ usefulnts g g' ⇒ (derives g)^* v w
   
   [subr5]  Theorem
      
      |- gaw g a ⇒ usefulnts g g' ⇒ gaw g' a
   
   [subr5']  Theorem
      
      |- EVERY (gaw g) b ⇒ usefulnts g g' ⇒ EVERY (gaw g') b
   
   [use_exists]  Theorem
      
      [oracles: MK_THM] [axioms: ] [] |- ∀g. ∃g'. usefulnts g g'
   
   
*)
end
