signature boolLemmasTheory =
sig
  type thm = Thm.thm
  
  (*  Theorems  *)
    val if_rw_SOME : thm
    val if_rw_SOMEeqSOME : thm
    val lemma : thm
    val list_case_rwt : thm
    val option_case_rwt : thm
    val option_r1 : thm
    val setc_flem : thm
  
  val boolLemmas_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [container] Parent theory of "boolLemmas"
   
   [string] Parent theory of "boolLemmas"
   
   [if_rw_SOME]  Theorem
      
      |- ∃x' p'. (SOME x' = if p then NONE else p') ⇔ (p' = SOME x')
   
   [if_rw_SOMEeqSOME]  Theorem
      
      |- ((if p then SOME x else NONE) = SOME x') ⇔ (x = x') ∧ p
   
   [lemma]  Theorem
      
      |- FINITE {x | P x} ⇒ FINITE {l | EVERY P l ∧ ALL_DISTINCT l}
   
   [list_case_rwt]  Theorem
      
      |- (((case x of [] -> NONE || h::t -> f h t) = SOME z) ⇔
          ∃i j. (x = i::j) ∧ (f i j = SOME z)) ∧
         (((case x of [] -> y || h::t -> NONE) = SOME z) ⇔ (x = []) ∧ (y = SOME z))
   
   [option_case_rwt]  Theorem
      
      |- ((case x of NONE -> NONE || SOME y -> f y) = SOME z) ⇔
         ∃a. (x = SOME a) ∧ (f a = SOME z)
   
   [option_r1]  Theorem
      
      |- ∀f. f ≠ NONE ⇒ (x = THE f) ⇒ (SOME x = f)
   
   [setc_flem]  Theorem
      
      |- FINITE P ⇒ FINITE {l | EVERY P l ∧ ALL_DISTINCT l}
   
   
*)
end
