signature containerLemmasTheory =
sig
  type thm = Thm.thm
  
  (*  Theorems  *)
    val filter_seteq : thm
    val interInsertMemNil : thm
    val interNil : thm
    val len_card : thm
    val mem_in : thm
    val mem_subset : thm
    val setc_mem_in : thm
  
  val containerLemmas_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [container] Parent theory of "containerLemmas"
   
   [filter_seteq]  Theorem
      
      |- ∀p l. set (FILTER p l) = {x | p x ∧ MEM x l}
   
   [interInsertMemNil]  Theorem
      
      |- ∀s e t. e ∉ s ⇒ (s ∩ set t = {}) ⇒ (s ∩ set (e::t) = {})
   
   [interNil]  Theorem
      
      |- ∀s t. (s ∩ t = {}) ⇒ e ∈ s ⇒ e ∉ t
   
   [len_card]  Theorem
      
      |- ∀l. LENGTH l ≥ CARD (set l)
   
   [mem_in]  Theorem
      
      |- ∀e l. MEM e l ⇔ e ∈ set l
   
   [mem_subset]  Theorem
      
      |- ∀l1 l2. (∀e. MEM e l1 ⇒ MEM e l2) ⇒ set l1 ⊆ set l2
   
   [setc_mem_in]  Theorem
      
      |- {e | e ∈ set l} = {e | MEM e l}
   
   
*)
end
