signature grammarDefTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val allSymsML_def : thm
    val allSyms_def : thm
    val derivNts_def : thm
    val derivesNull_def : thm
    val derives_def : thm
    val gaw_def : thm
    val getRhs_curried_def : thm
    val getRhs_tupled_primitive_def : thm
    val getRules_curried_def : thm
    val getRules_tupled_primitive_def : thm
    val grammar_TY_DEF : thm
    val grammar_case_def : thm
    val grammar_repfns : thm
    val grammar_size_def : thm
    val is_null_def : thm
    val is_word_def : thm
    val language_def : thm
    val lderives_def : thm
    val lhsWithLastSym_curried_def : thm
    val lhsWithLastSym_tupled_primitive_def : thm
    val lhsWithNullSfx_curried_def : thm
    val lhsWithNullSfx_tupled_primitive_def : thm
    val llanguage_def : thm
    val nonTerminalsList_def : thm
    val nonTerminalsML_primitive_def : thm
    val nonTerminals_def : thm
    val nonTmnls_primitive_def : thm
    val nullableList_curried_def : thm
    val nullableList_tupled_primitive_def : thm
    val nullable_def : thm
    val numNonTmnls_primitive_def : thm
    val numTmnls_def : thm
    val rderives_def : thm
    val rhsWithSym_curried_def : thm
    val rhsWithSym_tupled_primitive_def : thm
    val rlanguage_def : thm
    val rsf_def : thm
    val ruleLhs_def : thm
    val ruleRhs_def : thm
    val rule_TY_DEF : thm
    val rule_case_def : thm
    val rule_nonterminals_def : thm
    val rule_repfns : thm
    val rule_size_def : thm
    val rule_terminals_def : thm
    val rulesWithSymInRhs_curried_def : thm
    val rulesWithSymInRhs_tupled_primitive_def : thm
    val rules_def : thm
    val sforms_def : thm
    val sfxNotNull_curried_def : thm
    val sfxNotNull_tupled_primitive_def : thm
    val startSym_def : thm
    val terminalsList_primitive_def : thm
    val terminalsML_primitive_def : thm
    val terminals_def : thm
  
  (*  Theorems  *)
    val EXISTS_rule : thm
    val NTS_IN_rule_terminals : thm
    val NTS_IN_terminals : thm
    val allNtSymsInGr : thm
    val allSymsEq : thm
    val allTmSymsInGr : thm
    val b1 : thm
    val datatype_grammar : thm
    val datatype_rule : thm
    val derivNtsMem : thm
    val derivNtsNotMem : thm
    val derivNtsNullable : thm
    val derivSubsetAppend : thm
    val derivSubsetAppendMem : thm
    val derivTlSubset : thm
    val derivesHdTmnl : thm
    val derivesImpLderives : thm
    val derivesImpRderives : thm
    val derives_append : thm
    val derives_same_append_left : thm
    val derives_same_append_right : thm
    val drd : thm
    val drd_langeq : thm
    val drd_ld : thm
    val drd_ld_langeq : thm
    val emptySetList : thm
    val finiteAllSyms : thm
    val finiteNtsList : thm
    val finiteTerminals : thm
    val finite_nts : thm
    val gawAllSyms : thm
    val gaw_l1 : thm
    val gaw_rderives : thm
    val gaw_rderives_single : thm
    val gaw_rhs : thm
    val gaw_rtc_rderives : thm
    val getRhsDistrib : thm
    val getRhs_def : thm
    val getRhs_ind : thm
    val getRules_def : thm
    val getRules_ind : thm
    val grammar_11 : thm
    val grammar_Axiom : thm
    val grammar_case_cong : thm
    val grammar_induction : thm
    val grammar_nchotomy : thm
    val inNonTerminals : thm
    val infiniteSyms : thm
    val key_result : thm
    val language_not_empty : thm
    val ldAllTmnls : thm
    val ldStartTs : thm
    val lderivesImpDerives : thm
    val lderivesPfxSame : thm
    val lderivesRtc2listPfxSame : thm
    val lderives_same_append_left : thm
    val lderives_same_append_right : thm
    val ldres1 : thm
    val lemma2 : thm
    val lemma2' : thm
    val lhsWithLastSym_def : thm
    val lhsWithLastSym_ind : thm
    val lhsWithNullSfx_def : thm
    val lhsWithNullSfx_ind : thm
    val listPairExistsD : thm
    val listPairExistsLd : thm
    val list_isp : thm
    val list_neq : thm
    val llemma2 : thm
    val lupgr_r11 : thm
    val lupgr_r17 : thm
    val lupgr_r19 : thm
    val lupgr_r7 : thm
    val lwls_r1 : thm
    val mem_r1 : thm
    val n0_1 : thm
    val n3 : thm
    val n4 : thm
    val n4_1 : thm
    val n4_2 : thm
    val n5 : thm
    val n6 : thm
    val nmlEq' : thm
    val nonTerminalsEq : thm
    val nonTerminalsML_def : thm
    val nonTerminalsML_ind : thm
    val nonTmnls_def : thm
    val nonTmnls_ind : thm
    val notNullGetRhs : thm
    val notNullGetRhs_1 : thm
    val notNullGetRhs_2 : thm
    val notNullLhsLastSym : thm
    val notTlDerives : thm
    val notTlRtcDerives : thm
    val notTlRtcDerives_r1 : thm
    val notTmnlDerives : thm
    val notTmnlRtcDerives : thm
    val notTmnlRtcDerives1 : thm
    val notTmnlRtcDerives2 : thm
    val nrc_drd : thm
    val nrc_drd_ld : thm
    val nrc_drdeq : thm
    val nrc_drdeq_ld : thm
    val ntsInGr : thm
    val ntsNotInTmnls : thm
    val ntsNotInTmnls1 : thm
    val nullableEq : thm
    val nullableEq1 : thm
    val nullableEq2 : thm
    val nullableImpML : thm
    val nullableML : thm
    val nullableMLEq : thm
    val nullableML_append : thm
    val nullableML_ind : thm
    val nullableSingNt : thm
    val nullable_APPEND : thm
    val numNonTmnls_def : thm
    val numNonTmnls_ind : thm
    val rdImpDg : thm
    val rderivesHdTmnl : thm
    val rderivesImpDerives : thm
    val rderivesNotNil : thm
    val rderivesRtc2list : thm
    val rderives_append : thm
    val rderives_has_tmnl : thm
    val rderives_same_append_left : thm
    val rdres1 : thm
    val res1 : thm
    val res2 : thm
    val res3 : thm
    val rgr_r8 : thm
    val rhsWithSym_def : thm
    val rhsWithSym_ind : thm
    val rnt : thm
    val rnt1 : thm
    val rsfDistribRtc2List : thm
    val rt : thm
    val rtc2listEveryMemNML : thm
    val rtc2listRtcldTmnls : thm
    val rtc2listTlHd : thm
    val rtc2listTlHdEveryMem : thm
    val rtc2list_exists : thm
    val rtc2list_isolate_NT : thm
    val rtc2list_isolate_NT' : thm
    val rtc2list_startSym_rtcRderives : thm
    val rtcDerivesInRuleRhs : thm
    val rtcDerivesInRuleRhs' : thm
    val rtcDerivesInRuleRhsLen : thm
    val rtcDerivesInRuleRhsLenGte1 : thm
    val rtcRdImpDg : thm
    val rtcRderivesInRuleRhs : thm
    val rtcRderivesInRuleRhsLen : thm
    val rtcRderivesLastTmnl : thm
    val rtc_derives_same_append_left : thm
    val rtc_derives_same_append_right : thm
    val rtc_lderives_same_append_left : thm
    val rtc_r1 : thm
    val rtc_rderives_has_tmnl : thm
    val rtc_rderives_same_append_left : thm
    val ruleRhsInAllSyms : thm
    val rule_11 : thm
    val rule_Axiom : thm
    val rule_case_cong : thm
    val rule_induction : thm
    val rule_nchotomy : thm
    val rulesWithSymInRhs_def : thm
    val rulesWithSymInRhs_ind : thm
    val sfxNotNull_def : thm
    val sfxNotNull_ind : thm
    val slemma1_3 : thm
    val slemma1_4 : thm
    val slemma1_4Tmnls : thm
    val slres : thm
    val slres2 : thm
    val sub_result : thm
    val sub_result_rev : thm
    val symInGr : thm
    val term_syms_gen_words : thm
    val terminalsEq : thm
    val terminalsList_def : thm
    val terminalsList_ind : thm
    val terminalsML_def : thm
    val terminalsML_ind : thm
    val tsNotInNonTmnls : thm
    val upgr_r11 : thm
    val upgr_r15 : thm
    val upgr_r17 : thm
    val upgr_r17_ld : thm
    val upgr_r18 : thm
    val upgr_r19 : thm
    val upgr_r7 : thm
    val x_1 : thm
  
  val grammarDef_grammars : type_grammar.grammar * term_grammar.grammar
  
  val grammarDef_rwts : simpLib.ssfrag
(*
   [regexp] Parent theory of "grammarDef"
   
   [relationLemmas] Parent theory of "grammarDef"
   
   [allSymsML_def]  Definition
      
      |- ∀g. allSymsML g = nonTerminalsML g ∪ terminalsML g
   
   [allSyms_def]  Definition
      
      |- ∀g. allSyms g = nonTerminals g ∪ terminals g
   
   [derivNts_def]  Definition
      
      |- ∀d. derivNts d = set (FLAT d)
   
   [derivesNull_def]  Definition
      
      |- (∀g ts. derivesNull g (TS ts) ⇔ T) ∧
         ∀g nt. derivesNull g (NTS nt) ⇔ MEM (rule nt []) (rules g)
   
   [derives_def]  Definition
      
      |- ∀g lsl rsl.
           derives g lsl rsl ⇔
           ∃s1 s2 rhs lhs.
             (s1 ++ [NTS lhs] ++ s2 = lsl) ∧ (s1 ++ rhs ++ s2 = rsl) ∧
             MEM (rule lhs rhs) (rules g)
   
   [gaw_def]  Definition
      
      |- ∀g nt. gaw g nt ⇔ ∃w. (derives g)^* [nt] w ∧ EVERY isTmnlSym w
   
   [getRhs_curried_def]  Definition
      
      |- ∀x x1. getRhs x x1 = getRhs_tupled (x,x1)
   
   [getRhs_tupled_primitive_def]  Definition
      
      |- getRhs_tupled =
         WFREC
           (@R.
              WF R ∧ (∀r rs l' l. l ≠ l' ⇒ R (l,rs) (l,rule l' r::rs)) ∧
              ∀r rs l' l. (l = l') ⇒ R (l,rs) (l,rule l' r::rs))
           (λgetRhs_tupled a.
              case a of
                 (l,[]) -> I []
              || (l,rule l' r::rs) ->
                   I
                     (if l = l' then
                        [r] ++ getRhs_tupled (l,rs)
                      else
                        getRhs_tupled (l,rs)))
   
   [getRules_curried_def]  Definition
      
      |- ∀x x1. getRules x x1 = getRules_tupled (x,x1)
   
   [getRules_tupled_primitive_def]  Definition
      
      |- getRules_tupled =
         WFREC
           (@R.
              WF R ∧ (∀r rs l sym. sym ≠ l ⇒ R (sym,rs) (sym,rule l r::rs)) ∧
              ∀r rs l sym. (sym = l) ⇒ R (sym,rs) (sym,rule l r::rs))
           (λgetRules_tupled a.
              case a of
                 (sym,[]) -> I []
              || (sym,rule l r::rs) ->
                   I
                     (if sym = l then
                        rule l r::getRules_tupled (sym,rs)
                      else
                        getRules_tupled (sym,rs)))
   
   [grammar_TY_DEF]  Definition
      
      |- ∃rep.
           TYPE_DEFINITION
             (λa0'.
                ∀'grammar' .
                  (∀a0'.
                     (∃a0 a1.
                        a0' =
                        (λa0 a1. ind_type$CONSTR 0 (a0,a1) (λn. ind_type$BOTTOM)) a0
                          a1) ⇒
                     'grammar' a0') ⇒
                  'grammar' a0') rep
   
   [grammar_case_def]  Definition
      
      |- ∀f a0 a1. grammar_case f (G a0 a1) = f a0 a1
   
   [grammar_repfns]  Definition
      
      |- (∀a. mk_grammar (dest_grammar a) = a) ∧
         ∀r.
           (λa0'.
              ∀'grammar' .
                (∀a0'.
                   (∃a0 a1.
                      a0' =
                      (λa0 a1. ind_type$CONSTR 0 (a0,a1) (λn. ind_type$BOTTOM)) a0
                        a1) ⇒
                   'grammar' a0') ⇒
                'grammar' a0') r ⇔ (dest_grammar (mk_grammar r) = r)
   
   [grammar_size_def]  Definition
      
      |- ∀f f1 a0 a1.
           grammar_size f f1 (G a0 a1) = 1 + (list_size (rule_size f f1) a0 + f a1)
   
   [is_null_def]  Definition
      
      |- ∀g r. is_null g r ⇔ ∀w. (derives g)^* r w ⇒ is_word w ⇒ (w = [])
   
   [is_word_def]  Definition
      
      |- ∀w. is_word w ⇔ EVERY isTmnlSym w
   
   [language_def]  Definition
      
      |- ∀g.
           language g =
           {tsl | (derives g)^* [NTS (startSym g)] tsl ∧ EVERY isTmnlSym tsl}
   
   [lderives_def]  Definition
      
      |- ∀g lsl rsl.
           lderives g lsl rsl ⇔
           ∃s1 s2 rhs lhs.
             (s1 ++ [NTS lhs] ++ s2 = lsl) ∧ EVERY isTmnlSym s1 ∧
             (s1 ++ rhs ++ s2 = rsl) ∧ MEM (rule lhs rhs) (rules g)
   
   [lhsWithLastSym_curried_def]  Definition
      
      |- ∀x x1. lhsWithLastSym x x1 = lhsWithLastSym_tupled (x,x1)
   
   [lhsWithLastSym_tupled_primitive_def]  Definition
      
      |- lhsWithLastSym_tupled =
         WFREC
           (@R.
              WF R ∧ (∀l rs sym. R (sym,rs) (sym,rule l []::rs)) ∧
              (∀l rs sym v7 v6.
                 LAST (v6::v7) ≠ sym ⇒ R (sym,rs) (sym,rule l (v6::v7)::rs)) ∧
              ∀l rs sym v7 v6.
                (LAST (v6::v7) = sym) ⇒ R (sym,rs) (sym,rule l (v6::v7)::rs))
           (λlhsWithLastSym_tupled a.
              case a of
                 (sym,[]) -> I []
              || (sym,rule l []::rs) -> I (rmDupes (lhsWithLastSym_tupled (sym,rs)))
              || (sym,rule l (v8::v9)::rs) ->
                   I
                     (if LAST (v8::v9) = sym then
                        rmDupes (NTS l::lhsWithLastSym_tupled (sym,rs))
                      else
                        rmDupes (lhsWithLastSym_tupled (sym,rs))))
   
   [lhsWithNullSfx_curried_def]  Definition
      
      |- ∀x x1. lhsWithNullSfx x x1 = lhsWithNullSfx_tupled (x,x1)
   
   [lhsWithNullSfx_tupled_primitive_def]  Definition
      
      |- lhsWithNullSfx_tupled =
         WFREC
           (@R.
              WF R ∧ (∀l rst sfx g. ¬nullable g sfx ⇒ R (g,rst) (g,(l,sfx)::rst)) ∧
              ∀l rst sfx g. nullable g sfx ⇒ R (g,rst) (g,(l,sfx)::rst))
           (λlhsWithNullSfx_tupled a.
              case a of
                 (g,[]) -> I []
              || (g,(l,sfx)::rst) ->
                   I
                     (if nullable g sfx then
                        [NTS l]::lhsWithNullSfx_tupled (g,rst)
                      else
                        lhsWithNullSfx_tupled (g,rst)))
   
   [llanguage_def]  Definition
      
      |- ∀g.
           llanguage g =
           {tsl | (lderives g)^* [NTS (startSym g)] tsl ∧ EVERY isTmnlSym tsl}
   
   [nonTerminalsList_def]  Definition
      
      |- ∀s rl. nonTerminalsList s rl = s::nonTmnls rl
   
   [nonTerminalsML_primitive_def]  Definition
      
      |- nonTerminalsML =
         WFREC (@R. WF R ∧ ∀r l s rs. R (G rs s) (G (rule l r::rs) s))
           (λnonTerminalsML a.
              case a of
                 G [] s -> I {NTS s}
              || G (rule l r::rs) s ->
                   I
                     (set (FILTER isNonTmnlSym (NTS l::r)) ∪
                      nonTerminalsML (G rs s)))
   
   [nonTerminals_def]  Definition
      
      |- ∀p s.
           nonTerminals (G p s) =
           NTS s INSERT BIGUNION (IMAGE rule_nonterminals (set p))
   
   [nonTmnls_primitive_def]  Definition
      
      |- nonTmnls =
         WFREC (@R. WF R ∧ ∀r l rst. R rst (rule l r::rst))
           (λnonTmnls a.
              case a of
                 [] -> I []
              || rule l r::rst ->
                   I (l::MAP nts2str (FILTER isNonTmnlSym r) ++ nonTmnls rst))
   
   [nullableList_curried_def]  Definition
      
      |- ∀x x1 x2. nullableML x x1 x2 ⇔ nullableList_tupled (x,x1,x2)
   
   [nullableList_tupled_primitive_def]  Definition
      
      |- nullableList_tupled =
         WFREC
           (@R.
              WF R ∧
              (∀g sn A a.
                 ¬MEM (NTS A) sn ∧ MEM a (getRhs A (rules g)) ⇒
                 R (g,NTS A::sn,a) (g,sn,[NTS A])) ∧
              (∀v11 v10 v6 sn g. R (g,sn,[NTS v6]) (g,sn,NTS v6::v10::v11)) ∧
              (∀v6 v11 v10 sn g. R (g,sn,v10::v11) (g,sn,NTS v6::v10::v11)) ∧
              (∀v7 v15 v14 sn g. R (g,sn,v14::v15) (g,sn,TS v7::v14::v15)) ∧
              ∀v15 v14 v7 sn g. R (g,sn,[TS v7]) (g,sn,TS v7::v14::v15))
           (λnullableList_tupled a'.
              case a' of
                 (g,sn,[]) -> I T
              || (g,sn,[NTS A]) ->
                   I
                     (if MEM (NTS A) sn then
                        F
                      else
                        EXISTS (λa. nullableList_tupled (g,NTS A::sn,a))
                          (getRhs A (rules g)))
              || (g,sn,NTS A::v12::v13) ->
                   I
                     (nullableList_tupled (g,sn,[NTS A]) ∧
                      nullableList_tupled (g,sn,v12::v13))
              || (g,sn,[TS ts]) -> I F
              || (g,sn,TS ts::v16::v17) ->
                   I
                     (nullableList_tupled (g,sn,[TS ts]) ∧
                      nullableList_tupled (g,sn,v16::v17)))
   
   [nullable_def]  Definition
      
      |- ∀g sl. nullable g sl ⇔ (derives g)^* sl []
   
   [numNonTmnls_primitive_def]  Definition
      
      |- numNonTmnls =
         WFREC (@R. WF R ∧ ∀r l rs. R rs (rule l r::rs))
           (λnumNonTmnls a.
              case a of
                 [] -> I 0
              || rule l r::rs ->
                   I (1 + LENGTH (FILTER isNonTmnlSym r) + numNonTmnls rs))
   
   [numTmnls_def]  Definition
      
      |- (numTmnls [] = 0) ∧
         ∀r rs.
           numTmnls (r::rs) = if isTmnlSym r then 1 + numTmnls rs else numTmnls rs
   
   [rderives_def]  Definition
      
      |- ∀g lsl rsl.
           rderives g lsl rsl ⇔
           ∃s1 s2 rhs lhs.
             (s1 ++ [NTS lhs] ++ s2 = lsl) ∧ EVERY isTmnlSym s2 ∧
             (s1 ++ rhs ++ s2 = rsl) ∧ MEM (rule lhs rhs) (rules g)
   
   [rhsWithSym_curried_def]  Definition
      
      |- ∀x x1. rhsWithSym x x1 = rhsWithSym_tupled (x,x1)
   
   [rhsWithSym_tupled_primitive_def]  Definition
      
      |- rhsWithSym_tupled =
         WFREC
           (@R.
              WF R ∧ (∀l rst r sym. ¬MEM sym r ⇒ R (sym,rst) (sym,rule l r::rst)) ∧
              ∀l rst r sym. MEM sym r ⇒ R (sym,rst) (sym,rule l r::rst))
           (λrhsWithSym_tupled a.
              case a of
                 (sym,[]) -> I []
              || (sym,rule l r::rst) ->
                   I
                     (if MEM sym r then
                        r::rhsWithSym_tupled (sym,rst)
                      else
                        rhsWithSym_tupled (sym,rst)))
   
   [rlanguage_def]  Definition
      
      |- ∀g.
           rlanguage g =
           {tsl | (rderives g)^* [NTS (startSym g)] tsl ∧ EVERY isTmnlSym tsl}
   
   [rsf_def]  Definition
      
      |- ∀g sf. rsf g sf ⇔ (rderives g)^* [NTS (startSym g)] sf
   
   [ruleLhs_def]  Definition
      
      |- ∀l r. ruleLhs (rule l r) = l
   
   [ruleRhs_def]  Definition
      
      |- ∀l r. ruleRhs (rule l r) = r
   
   [rule_TY_DEF]  Definition
      
      |- ∃rep.
           TYPE_DEFINITION
             (λa0'.
                ∀'rule' .
                  (∀a0'.
                     (∃a0 a1.
                        a0' =
                        (λa0 a1. ind_type$CONSTR 0 (a0,a1) (λn. ind_type$BOTTOM)) a0
                          a1) ⇒
                     'rule' a0') ⇒
                  'rule' a0') rep
   
   [rule_case_def]  Definition
      
      |- ∀f a0 a1. rule_case f (rule a0 a1) = f a0 a1
   
   [rule_nonterminals_def]  Definition
      
      |- ∀l r.
           rule_nonterminals (rule l r) =
           NTS l INSERT {nt | isNonTmnlSym nt ∧ MEM nt r}
   
   [rule_repfns]  Definition
      
      |- (∀a. mk_rule (dest_rule a) = a) ∧
         ∀r.
           (λa0'.
              ∀'rule' .
                (∀a0'.
                   (∃a0 a1.
                      a0' =
                      (λa0 a1. ind_type$CONSTR 0 (a0,a1) (λn. ind_type$BOTTOM)) a0
                        a1) ⇒
                   'rule' a0') ⇒
                'rule' a0') r ⇔ (dest_rule (mk_rule r) = r)
   
   [rule_size_def]  Definition
      
      |- ∀f f1 a0 a1.
           rule_size f f1 (rule a0 a1) = 1 + (f a0 + list_size (symbol_size f f1) a1)
   
   [rule_terminals_def]  Definition
      
      |- ∀l r. rule_terminals (rule l r) = {tmnl | isTmnlSym tmnl ∧ MEM tmnl r}
   
   [rulesWithSymInRhs_curried_def]  Definition
      
      |- ∀x x1. rulesWithSymInRhs x x1 = rulesWithSymInRhs_tupled (x,x1)
   
   [rulesWithSymInRhs_tupled_primitive_def]  Definition
      
      |- rulesWithSymInRhs_tupled =
         WFREC
           (@R.
              WF R ∧ (∀l rst r sym. ¬MEM sym r ⇒ R (sym,rst) (sym,rule l r::rst)) ∧
              ∀l rst r sym. MEM sym r ⇒ R (sym,rst) (sym,rule l r::rst))
           (λrulesWithSymInRhs_tupled a.
              case a of
                 (sym,[]) -> I []
              || (sym,rule l r::rst) ->
                   I
                     (if MEM sym r then
                        (l,breakAtElem sym r)::rulesWithSymInRhs_tupled (sym,rst)
                      else
                        rulesWithSymInRhs_tupled (sym,rst)))
   
   [rules_def]  Definition
      
      |- ∀p s. rules (G p s) = p
   
   [sforms_def]  Definition
      
      |- ∀g. sforms g = {tsl | (derives g)^* [NTS (startSym g)] tsl}
   
   [sfxNotNull_curried_def]  Definition
      
      |- ∀x x1. sfxNotNull x x1 = sfxNotNull_tupled (x,x1)
   
   [sfxNotNull_tupled_primitive_def]  Definition
      
      |- sfxNotNull_tupled =
         WFREC
           (@R.
              WF R ∧ (∀l rst sfx g. ¬ ¬nullable g sfx ⇒ R (g,rst) (g,(l,sfx)::rst)) ∧
              ∀l rst sfx g. ¬nullable g sfx ⇒ R (g,rst) (g,(l,sfx)::rst))
           (λsfxNotNull_tupled a.
              case a of
                 (g,[]) -> I []
              || (g,(l,sfx)::rst) ->
                   I
                     (if ¬nullable g sfx then
                        sfx::sfxNotNull_tupled (g,rst)
                      else
                        sfxNotNull_tupled (g,rst)))
   
   [startSym_def]  Definition
      
      |- ∀p s. startSym (G p s) = s
   
   [terminalsList_primitive_def]  Definition
      
      |- terminalsList =
         WFREC (@R. WF R ∧ ∀r l rst. R rst (rule l r::rst))
           (λterminalsList a.
              case a of
                 [] -> I []
              || rule l r::rst ->
                   I (MAP ts2str (FILTER isTmnlSym r) ++ terminalsList rst))
   
   [terminalsML_primitive_def]  Definition
      
      |- terminalsML =
         WFREC (@R. WF R ∧ ∀r l s rs. R (G rs s) (G (rule l r::rs) s))
           (λterminalsML a.
              case a of
                 G [] s -> I (set [])
              || G (rule l r::rs) s ->
                   I (set (FILTER isTmnlSym r) ∪ terminalsML (G rs s)))
   
   [terminals_def]  Definition
      
      |- ∀p s. terminals (G p s) = BIGUNION (IMAGE rule_terminals (set p))
   
   [EXISTS_rule]  Theorem
      
      |- (∃r. P r) ⇔ ∃N rhs. P (rule N rhs)
   
   [NTS_IN_rule_terminals]  Theorem
      
      |- NTS N ∉ rule_terminals r
   
   [NTS_IN_terminals]  Theorem
      
      |- NTS N ∉ terminals g
   
   [allNtSymsInGr]  Theorem
      
      |- ∀nt.
           NTS nt ∈ allSyms g ⇔
           (∃rhs. MEM (rule nt rhs) (rules g)) ∨
           (∃l p s. MEM (rule l (p ++ [NTS nt] ++ s)) (rules g)) ∨ (nt = startSym g)
   
   [allSymsEq]  Theorem
      
      |- allSyms g = allSymsML g
   
   [allTmSymsInGr]  Theorem
      
      |- ∀ts. TS ts ∈ allSyms g ⇔ ∃l p s. MEM (rule l (p ++ [TS ts] ++ s)) (rules g)
   
   [b1]  Theorem
      
      |- ∀rst. ¬(derives g)^* [] (fst::rst)
   
   [datatype_grammar]  Theorem
      
      |- DATATYPE (grammar G)
   
   [datatype_rule]  Theorem
      
      |- DATATYPE (rule rule)
   
   [derivNtsMem]  Theorem
      
      |- ∀dl e. e ∈ derivNts dl ⇔ ∃l. MEM l dl ∧ MEM e l
   
   [derivNtsNotMem]  Theorem
      
      |- ∀e dl. (∀l. MEM l dl ⇒ ¬MEM e l) ⇒ e ∉ derivNts dl
   
   [derivNtsNullable]  Theorem
      
      |- ∀dl.
           derives g ⊢ dl ◁ HD dl → [] ⇒
           dl ≠ [] ⇒
           ∀sym. sym ∈ derivNts dl ⇒ (derives g)^* [sym] []
   
   [derivSubsetAppend]  Theorem
      
      |- ∀d d'. derivNts d ⊆ derivNts d' ⇒ ∀p s. derivNts d ⊆ derivNts (p ++ d' ++ s)
   
   [derivSubsetAppendMem]  Theorem
      
      |- ∀d d'.
           derivNts d ⊆ derivNts d' ⇒
           ∀p s s' e. derivNts (d ++ [e]) ⊆ derivNts (p ++ d' ++ [s ++ e ++ s'])
   
   [derivTlSubset]  Theorem
      
      |- ∀dl. dl ≠ [] ⇒ derivNts (TL dl) ⊆ derivNts dl
   
   [derivesHdTmnl]  Theorem
      
      |- derives g u u' ⇒ isTmnlSym (HD u) ⇒ (HD u' = HD u)
   
   [derivesImpLderives]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀l0 l1. (derives g)^* l0 l1 ⇒ EVERY isTmnlSym l1 ⇒ (lderives g)^* l0 l1
   
   [derivesImpRderives]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀l0 l1. (derives g)^* l0 l1 ⇒ EVERY isTmnlSym l1 ⇒ (rderives g)^* l0 l1
   
   [derives_append]  Theorem
      
      |- (derives g)^* M N ∧ (derives g)^* P Q ⇒ (derives g)^* (M ++ P) (N ++ Q)
   
   [derives_same_append_left]  Theorem
      
      |- ∀g u v. derives g u v ⇒ ∀x. derives g (x ++ u) (x ++ v)
   
   [derives_same_append_right]  Theorem
      
      |- ∀g u v. derives g u v ⇒ ∀x. derives g (u ++ x) (v ++ x)
   
   [drd]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀l0 l1 l2.
           derives g l0 l1 ⇒
           rderives g l1 l2 ⇒
           ∃l'. rderives g l0 l' ∧ derives g l' l2
   
   [drd_langeq]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] [] |- ∀g. language g = rlanguage g
   
   [drd_ld]  Theorem
      
      [oracles: MK_THM] [axioms: ] []
      |- ∀l0 l1 l2.
           derives g l0 l1 ⇒
           lderives g l1 l2 ⇒
           ∃l'. lderives g l0 l' ∧ derives g l' l2
   
   [drd_ld_langeq]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] [] |- ∀g. language g = llanguage g
   
   [emptySetList]  Theorem
      
      |- ({} = set l) ⇔ (l = [])
   
   [finiteAllSyms]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀g. (s = set (rules g)) ⇒ FINITE (allSyms g)
   
   [finiteNtsList]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀g. (s = set (rules g)) ⇒ FINITE (nonTerminals g)
   
   [finiteTerminals]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀g. (s = set (rules g)) ⇒ FINITE (terminals g)
   
   [finite_nts]  Theorem
      
      |- FINITE (nonTerminals g)
   
   [gawAllSyms]  Theorem
      
      |- ∀e l.
           MEM e l ⇒
           (l = SET_TO_LIST (allSyms g)) ⇒
           (∀nt.
              nt ∈ nonTerminals g ⇒ ∃w. (derives g)^* [nt] w ∧ EVERY isTmnlSym w) ⇒
           gaw g e
   
   [gaw_l1]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀pfx sfx.
           (rderives g)^* [NTS (startSym g)] (pfx ++ r1 ++ [NTS nt] ++ r2 ++ sfx) ⇒
           (∀nt. nt ∈ nonTerminals g ⇒ gaw g nt) ⇒
           ∃w. (rderives g)^* (r2 ++ sfx) w ∧ EVERY isTmnlSym w
   
   [gaw_rderives]  Theorem
      
      |- ∀a b.
           EVERY (gaw g) a ⇒
           rderives g a b ⇒
           (∀nt. nt ∈ nonTerminals g ⇒ gaw g nt) ⇒
           EVERY (gaw g) b
   
   [gaw_rderives_single]  Theorem
      
      |- ∀a b.
           gaw g a ⇒
           rderives g [a] b ⇒
           (∀nt. nt ∈ nonTerminals g ⇒ gaw g nt) ⇒
           EVERY (gaw g) b
   
   [gaw_rhs]  Theorem
      
      |- ∀lhs rhs.
           MEM (rule lhs rhs) (rules g) ⇒
           (∀nt.
              nt ∈ nonTerminals g ⇒ ∃w. (derives g)^* [nt] w ∧ EVERY isTmnlSym w) ⇒
           EVERY (gaw g) rhs
   
   [gaw_rtc_rderives]  Theorem
      
      |- ∀a b.
           (rderives g)^* a b ⇒
           EVERY (gaw g) a ⇒
           (∀nt. nt ∈ nonTerminals g ⇒ gaw g nt) ⇒
           EVERY (gaw g) b
   
   [getRhsDistrib]  Theorem
      
      |- ∀l1 l2. getRhs A (l1 ++ l2) = getRhs A l1 ++ getRhs A l2
   
   [getRhs_def]  Theorem
      
      |- (∀l. getRhs l [] = []) ∧
         ∀rs r l' l.
           getRhs l (rule l' r::rs) =
           if l = l' then [r] ++ getRhs l rs else getRhs l rs
   
   [getRhs_ind]  Theorem
      
      |- ∀P.
           (∀l. P l []) ∧
           (∀l l' r rs.
              (l ≠ l' ⇒ P l rs) ∧ ((l = l') ⇒ P l rs) ⇒ P l (rule l' r::rs)) ⇒
           ∀v v1. P v v1
   
   [getRules_def]  Theorem
      
      |- (∀sym. getRules sym [] = []) ∧
         ∀sym rs r l.
           getRules sym (rule l r::rs) =
           if sym = l then rule l r::getRules sym rs else getRules sym rs
   
   [getRules_ind]  Theorem
      
      |- ∀P.
           (∀sym. P sym []) ∧
           (∀sym l r rs.
              (sym ≠ l ⇒ P sym rs) ∧ ((sym = l) ⇒ P sym rs) ⇒ P sym (rule l r::rs)) ⇒
           ∀v v1. P v v1
   
   [grammar_11]  Theorem
      
      |- ∀a0 a1 a0' a1'. (G a0 a1 = G a0' a1') ⇔ (a0 = a0') ∧ (a1 = a1')
   
   [grammar_Axiom]  Theorem
      
      |- ∀f. ∃fn. ∀a0 a1. fn (G a0 a1) = f a0 a1
   
   [grammar_case_cong]  Theorem
      
      |- ∀M M' f.
           (M = M') ∧ (∀a0 a1. (M' = G a0 a1) ⇒ (f a0 a1 = f' a0 a1)) ⇒
           (grammar_case f M = grammar_case f' M')
   
   [grammar_induction]  Theorem
      
      |- ∀P. (∀l n. P (G l n)) ⇒ ∀g. P g
   
   [grammar_nchotomy]  Theorem
      
      |- ∀gg. ∃l n. gg = G l n
   
   [inNonTerminals]  Theorem
      
      |- ∀l r g.
           MEM (rule l r) (rules g) ⇒ ∀nt. MEM (NTS nt) r ⇒ NTS nt ∈ nonTerminals g
   
   [infiniteSyms]  Theorem
      
      |- INFINITE UNIV ⇒ INFINITE UNIV
   
   [key_result]  Theorem
      
      |- EVERY (gaw g) v ∧ derives g u v ⇒ EVERY (gaw g) u
   
   [language_not_empty]  Theorem
      
      |- ∀g. gaw g (NTS (startSym g)) ⇒ language g ≠ {}
   
   [ldAllTmnls]  Theorem
      
      |- lderives g ⊢ h::t ◁ x → y ∧ EVERY isTmnlSym x ⇒ (t = [])
   
   [ldStartTs]  Theorem
      
      |- ∀dl ts syms y.
           derives g ⊢ dl ◁ TS ts::syms → y ⇒
           ∃rst dl'.
             (y = TS ts::rst) ∧ LENGTH dl' ≤ LENGTH dl ∧ derives g ⊢ dl' ◁ syms → rst
   
   [lderivesImpDerives]  Theorem
      
      |- ∀x y. (lderives g)^* x y ⇒ EVERY isTmnlSym y ⇒ (derives g)^* x y
   
   [lderivesPfxSame]  Theorem
      
      |- ∀dl s1 rst.
           lderives g ⊢ dl ◁ s1 ++ rst → v ∧ EVERY isTmnlSym s1 ⇒
           ∀e. MEM e dl ⇒ ∃sfx. s1 ++ sfx = e
   
   [lderivesRtc2listPfxSame]  Theorem
      
      |- ∀rst t.
           rtc2list (lderives g) ((h ++ rst)::t) ∧ EVERY isTmnlSym h ⇒
           ∀e. MEM e t ⇒ ∃sfx. h ++ sfx = e
   
   [lderives_same_append_left]  Theorem
      
      |- ∀g u v. lderives g u v ⇒ EVERY isTmnlSym x ⇒ lderives g (x ++ u) (x ++ v)
   
   [lderives_same_append_right]  Theorem
      
      |- ∀g u v. lderives g u v ⇒ ∀x. lderives g (u ++ x) (v ++ x)
   
   [ldres1]  Theorem
      
      |- ∀lhs rhs g. MEM (rule lhs rhs) (rules g) ⇒ lderives g [NTS lhs] rhs
   
   [lemma2]  Theorem
      
      |- ∀s1 s2 s1' s2'.
           derives g (s1 ++ s2) s ⇒
           (∃s1'. derives g s1 s1' ∧ (s = s1' ++ s2)) ∨
           ∃s2'. derives g s2 s2' ∧ (s = s1 ++ s2')
   
   [lemma2']  Theorem
      
      |- derives g (x ++ y) tgt ⇔
         (∃x'. derives g x x' ∧ (tgt = x' ++ y)) ∨
         ∃y'. derives g y y' ∧ (tgt = x ++ y')
   
   [lhsWithLastSym_def]  Theorem
      
      |- (∀sym. lhsWithLastSym sym [] = []) ∧
         (∀sym rs l.
            lhsWithLastSym sym (rule l []::rs) = rmDupes (lhsWithLastSym sym rs)) ∧
         ∀v7 v6 sym rs l.
           lhsWithLastSym sym (rule l (v6::v7)::rs) =
           if LAST (v6::v7) = sym then
             rmDupes (NTS l::lhsWithLastSym sym rs)
           else
             rmDupes (lhsWithLastSym sym rs)
   
   [lhsWithLastSym_ind]  Theorem
      
      |- ∀P.
           (∀sym. P sym []) ∧ (∀sym l rs. P sym rs ⇒ P sym (rule l []::rs)) ∧
           (∀sym l v6 v7 rs.
              (LAST (v6::v7) ≠ sym ⇒ P sym rs) ∧ ((LAST (v6::v7) = sym) ⇒ P sym rs) ⇒
              P sym (rule l (v6::v7)::rs)) ⇒
           ∀v v1. P v v1
   
   [lhsWithNullSfx_def]  Theorem
      
      |- (∀g. lhsWithNullSfx g [] = []) ∧
         ∀sfx rst l g.
           lhsWithNullSfx g ((l,sfx)::rst) =
           if nullable g sfx then
             [NTS l]::lhsWithNullSfx g rst
           else
             lhsWithNullSfx g rst
   
   [lhsWithNullSfx_ind]  Theorem
      
      |- ∀P.
           (∀g. P g []) ∧
           (∀g l sfx rst.
              (¬nullable g sfx ⇒ P g rst) ∧ (nullable g sfx ⇒ P g rst) ⇒
              P g ((l,sfx)::rst)) ⇒
           ∀v v1. P v v1
   
   [listPairExistsD]  Theorem
      
      |- ∀x y.
           derives g x y ⇒
           ∃l.
             (x = MAP FST l) ∧ (y = FLAT (MAP SND l)) ∧
             ∀a b. MEM (a,b) l ⇒ ∃dl'. LENGTH dl' ≤ 2 ∧ derives g ⊢ dl' ◁ [a] → b
   
   [listPairExistsLd]  Theorem
      
      |- ∀x y.
           derives g ⊢ dl ◁ x → y ⇒
           ∃l.
             (x = MAP FST l) ∧ (y = FLAT (MAP SND l)) ∧
             ∀a b.
               MEM (a,b) l ⇒ ∃dl'. LENGTH dl' ≤ LENGTH dl ∧ derives g ⊢ dl' ◁ [a] → b
   
   [list_isp]  Theorem
      
      |- ∀s1' s2' N l.
           (s1' ++ s2' = pfx ++ [NTS N] ++ l) ⇒
           EVERY isTmnlSym s2' ⇒
           EVERY isTmnlSym l ⇒
           pfx ++ [NTS N] ≼ s1'
   
   [list_neq]  Theorem
      
      |- ∀st n. st ≠ n ⇒ ¬∃pfx sfx. [NTS st] = pfx ++ [NTS n] ++ sfx
   
   [llemma2]  Theorem
      
      |- ∀s1 s2 s1' s2'.
           lderives g (s1 ++ s2) s ⇒
           (∃s1'. lderives g s1 s1' ∧ (s = s1' ++ s2)) ∨
           ∃s2'. lderives g s2 s2' ∧ (s = s1 ++ s2')
   
   [lupgr_r11]  Theorem
      
      |- lderives g [NTS lhs] [NTS rhs] ⇒ MEM (rule lhs [NTS rhs]) (rules g)
   
   [lupgr_r17]  Theorem
      
      |- ∀u v.
           (lderives g)^* u v ⇒
           (u = x ++ y) ⇒
           ∃x' y'. (v = x' ++ y') ∧ (lderives g)^* x x' ∧ (lderives g)^* y y'
   
   [lupgr_r19]  Theorem
      
      |- ∀u v.
           (lderives g)^* u v ⇒
           (u = x ++ y ++ z) ⇒
           ∃x' y' z'.
             (v = x' ++ y' ++ z') ∧ (lderives g)^* x x' ∧ (lderives g)^* y y' ∧
             (lderives g)^* z z'
   
   [lupgr_r7]  Theorem
      
      |- ∀u z.
           (lderives g)^* u z ⇒
           (u = x ++ y) ⇒
           ∃x' y'. (z = x' ++ y') ⇒ (lderives g)^* x x' ∧ (lderives g)^* y y'
   
   [lwls_r1]  Theorem
      
      |- lhsWithLastSym sym (rule s l::rs) ≠ [] ⇒
         lhsWithLastSym sym [rule s l] ≠ [] ∨ lhsWithLastSym sym rs ≠ []
   
   [mem_r1]  Theorem
      
      |- ∀l. l ≠ [] ⇔ ∃e. MEM e l
   
   [n0_1]  Theorem
      
      |- ∀l1 l2. derives g l1 l2 ⇒ MEM (TS ts) l1 ⇒ MEM (TS ts) l2
   
   [n3]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀s1 s2. nullableML g [] s1 ⇒ nullableML g [] s2 ⇒ nullableML g [] (s1 ++ s2)
   
   [n4]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀s1 s2. nullableML g sn (s1 ++ s2) ⇔ nullableML g sn s1 ∧ nullableML g sn s2
   
   [n4_1]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀s1 s2. nullableML g sn (s1 ++ s2) ⇒ nullableML g sn s1 ∧ nullableML g sn s2
   
   [n4_2]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀s1 s2. nullableML g sn s1 ∧ nullableML g sn s2 ⇒ nullableML g sn (s1 ++ s2)
   
   [n5]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- (derives g)^* [TS ts] [] ⇔ nullableML g sn [TS ts]
   
   [n6]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀h tl. nullableML g [] (h::tl) ⇔ nullableML g [] [h] ∧ nullableML g [] tl
   
   [nmlEq']  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀l. nullableML g sn l ⇔ ∀e. MEM e l ⇒ nullableML g sn [e]
   
   [nonTerminalsEq]  Theorem
      
      |- nonTerminals g = nonTerminalsML g
   
   [nonTerminalsML_def]  Theorem
      
      |- (∀s. nonTerminalsML (G [] s) = {NTS s}) ∧
         ∀s rs r l.
           nonTerminalsML (G (rule l r::rs) s) =
           set (FILTER isNonTmnlSym (NTS l::r)) ∪ nonTerminalsML (G rs s)
   
   [nonTerminalsML_ind]  Theorem
      
      |- ∀P.
           (∀s. P (G [] s)) ∧ (∀l r rs s. P (G rs s) ⇒ P (G (rule l r::rs) s)) ⇒
           ∀v. P v
   
   [nonTmnls_def]  Theorem
      
      |- (nonTmnls [] = []) ∧
         ∀rst r l.
           nonTmnls (rule l r::rst) =
           l::MAP nts2str (FILTER isNonTmnlSym r) ++ nonTmnls rst
   
   [nonTmnls_ind]  Theorem
      
      |- ∀P. P [] ∧ (∀l r rst. P rst ⇒ P (rule l r::rst)) ⇒ ∀v. P v
   
   [notNullGetRhs]  Theorem
      
      |- (∃r. MEM (rule nt r) (rules g)) ⇔ getRhs nt (rules g) ≠ []
   
   [notNullGetRhs_1]  Theorem
      
      |- ∀nt g. getRhs nt (rules g) ≠ [] ⇒ ∃r. MEM (rule nt r) (rules g)
   
   [notNullGetRhs_2]  Theorem
      
      |- (∃r. MEM (rule nt r) (rules g)) ⇒ getRhs nt (rules g) ≠ []
   
   [notNullLhsLastSym]  Theorem
      
      |- ∀sym rs. lhsWithLastSym sym rs ≠ [] ⇒ ∃l pfx. MEM (rule l (pfx ++ [sym])) rs
   
   [notTlDerives]  Theorem
      
      |- ∀l. ¬derives g (TS s::rst) []
   
   [notTlRtcDerives]  Theorem
      
      |- ∀tl l. ¬(derives g)^* (TS ts::rst) []
   
   [notTlRtcDerives_r1]  Theorem
      
      |- ∀x y. (derives g)^* x y ⇒ (∃ts. MEM (TS ts) x) ⇒ y ≠ []
   
   [notTmnlDerives]  Theorem
      
      |- ∀l. ¬derives g [TS s] l
   
   [notTmnlRtcDerives]  Theorem
      
      |- ∀tl l. (derives g)^* [TS ts] l ⇔ (l = [TS ts])
   
   [notTmnlRtcDerives1]  Theorem
      
      |- ∀ts l. (derives g)^* [TS ts] l ⇒ (l = [TS ts])
   
   [notTmnlRtcDerives2]  Theorem
      
      |- ∀tl l. (l = [TS ts]) ⇒ (derives g)^* [TS ts] l
   
   [nrc_drd]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀n l0 l1.
           NRC (derives g) (SUC n) l0 l1 ⇒
           EVERY isTmnlSym l1 ⇒
           ∃l'. rderives g l0 l' ∧ NRC (derives g) n l' l1
   
   [nrc_drd_ld]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀n l0 l1.
           NRC (derives g) (SUC n) l0 l1 ⇒
           EVERY isTmnlSym l1 ⇒
           ∃l'. lderives g l0 l' ∧ NRC (derives g) n l' l1
   
   [nrc_drdeq]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀n l0 l1.
           NRC (derives g) n l0 l1 ⇒ EVERY isTmnlSym l1 ⇒ NRC (rderives g) n l0 l1
   
   [nrc_drdeq_ld]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀n l0 l1.
           NRC (derives g) n l0 l1 ⇒ EVERY isTmnlSym l1 ⇒ NRC (lderives g) n l0 l1
   
   [ntsInGr]  Theorem
      
      |- ∀nt g. getRhs nt (rules g) ≠ [] ⇒ NTS nt ∈ nonTerminals g
   
   [ntsNotInTmnls]  Theorem
      
      |- ∀nt. NTS nt ∉ terminals g
   
   [ntsNotInTmnls1]  Theorem
      
      |- ∀nt. isNonTmnlSym nt ⇒ nt ∉ terminals g
   
   [nullableEq]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀g l. nullable g l ⇔ nullableML g [] l
   
   [nullableEq1]  Theorem
      
      [oracles: MK_THM] [axioms: ] [] |- ∀g sn l. nullableML g sn l ⇒ nullable g l
   
   [nullableEq2]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀g sn l. nullable g l ⇒ (sn = []) ⇒ nullableML g sn l
   
   [nullableImpML]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀l.
           nullable g l ⇒
           ∀sn. (∀sym. MEM sym sn ⇒ ¬nullable g [sym]) ⇒ nullableML g sn l
   
   [nullableML]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- (nullableML g sn [] ⇔ T) ∧ (nullableML g sn [TS ts] ⇔ F) ∧
         (nullableML g sn [NTS A] ⇔
          if MEM (NTS A) sn then
            F
          else
            EXISTS (λa. nullableML g (NTS A::sn) a) (getRhs A (rules g))) ∧
         (nullableML g sn (NTS v6::v10::v11) ⇔
          nullableML g sn [NTS v6] ∧ nullableML g sn (v10::v11)) ∧
         (nullableML g sn (TS v7::v14::v15) ⇔
          nullableML g sn [TS v7] ∧ nullableML g sn (v14::v15))
   
   [nullableMLEq]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀g sn l.
           nullableML g sn l ⇔ ∀e. MEM e l ⇒ isNonTmnlSym e ∧ nullableML g sn [e]
   
   [nullableML_append]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- nullableML g sn (l1 ++ l2) ⇔ nullableML g sn l1 ∧ nullableML g sn l2
   
   [nullableML_ind]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀P.
           (∀g sn. P g sn []) ∧ (∀g sn ts. P g sn [TS ts]) ∧
           (∀g sn A.
              (∀a.
                 ¬MEM (NTS A) sn ∧ MEM a (getRhs A (rules g)) ⇒ P g (NTS A::sn) a) ⇒
              P g sn [NTS A]) ∧
           (∀g sn v6 v10 v11.
              P g sn (v10::v11) ∧ P g sn [NTS v6] ⇒ P g sn (NTS v6::v10::v11)) ∧
           (∀g sn v7 v14 v15.
              P g sn (v14::v15) ∧ P g sn [TS v7] ⇒ P g sn (TS v7::v14::v15)) ⇒
           ∀v v1 v2. P v v1 v2
   
   [nullableSingNt]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀N sn.
           derives g ⊢ dl ◁ [NTS N] → [] ⇒
           dl ≠ [] ⇒
           (derivNts dl ∩ set sn = {}) ⇒
           (∀sf. MEM sf (TL dl) ⇒ ¬MEM (NTS N) sf) ⇒
           nullableML g sn [NTS N]
   
   [nullable_APPEND]  Theorem
      
      |- nullable g (x ++ y) ⇔ nullable g x ∧ nullable g y
   
   [numNonTmnls_def]  Theorem
      
      |- (numNonTmnls [] = 0) ∧
         ∀rs r l.
           numNonTmnls (rule l r::rs) =
           1 + LENGTH (FILTER isNonTmnlSym r) + numNonTmnls rs
   
   [numNonTmnls_ind]  Theorem
      
      |- ∀P. P [] ∧ (∀l r rs. P rs ⇒ P (rule l r::rs)) ⇒ ∀v. P v
   
   [rdImpDg]  Theorem
      
      |- ∀u v. rderives g u v ⇒ derives g u v
   
   [rderivesHdTmnl]  Theorem
      
      |- rderives g u u' ⇒ isTmnlSym (HD u) ⇒ (HD u' = HD u)
   
   [rderivesImpDerives]  Theorem
      
      |- ∀x y. (rderives g)^* x y ⇒ EVERY isTmnlSym y ⇒ (derives g)^* x y
   
   [rderivesNotNil]  Theorem
      
      |- ∀l l' g. rderives g l l' ⇒ l ≠ []
   
   [rderivesRtc2list]  Theorem
      
      |- ∀dl.
           rderives ag h h' ⇒
           rtc2list (rderives ag) (h'::dl) ⇒
           rtc2list (rderives ag) (h::h'::dl)
   
   [rderives_append]  Theorem
      
      |- ∀nt r.
           rderives g [NTS nt] r ⇒
           ∀sfx.
             EVERY isTmnlSym sfx ⇒
             ∀pfx. rderives g (pfx ++ [NTS nt] ++ sfx) (pfx ++ r ++ sfx)
   
   [rderives_has_tmnl]  Theorem
      
      |- ∀x x'. rderives g x x' ⇒ MEM (TS h) x ⇒ MEM (TS h) x'
   
   [rderives_same_append_left]  Theorem
      
      |- ∀g u v. rderives g u v ⇒ ∀x. rderives g (x ++ u) (x ++ v)
   
   [rdres1]  Theorem
      
      |- ∀lhs rhs g. MEM (rule lhs rhs) (rules g) ⇒ rderives g [NTS lhs] rhs
   
   [res1]  Theorem
      
      |- ∀lhs rhs g. MEM (rule lhs rhs) (rules g) ⇒ derives g [NTS lhs] rhs
   
   [res2]  Theorem
      
      |- ∀g a b. derives g a b ⇒ ∀c. derives g b c ⇒ (derives g)^* a c
   
   [res3]  Theorem
      
      |- ∀g a b. derives g a b ⇒ ∀c. (derives g)^* b c ⇒ (derives g)^* a c
   
   [rgr_r8]  Theorem
      
      |- (r = r1 ++ [sym] ++ r2) ⇒
         derives g [NTS l] r ⇒
         ∃a b. derives g [NTS l] (a ++ [sym] ++ b)
   
   [rhsWithSym_def]  Theorem
      
      |- (∀sym. rhsWithSym sym [] = []) ∧
         ∀sym rst r l.
           rhsWithSym sym (rule l r::rst) =
           if MEM sym r then r::rhsWithSym sym rst else rhsWithSym sym rst
   
   [rhsWithSym_ind]  Theorem
      
      |- ∀P.
           (∀sym. P sym []) ∧
           (∀sym l r rst.
              (¬MEM sym r ⇒ P sym rst) ∧ (MEM sym r ⇒ P sym rst) ⇒
              P sym (rule l r::rst)) ⇒
           ∀v v1. P v v1
   
   [rnt]  Theorem
      
      |- ∀e. (∃r. e ∈ rule_nonterminals r) ⇔ ¬isTmnlSym e
   
   [rnt1]  Theorem
      
      |- ∀e r. e ∈ rule_nonterminals r ⇒ ¬isTmnlSym e
   
   [rsfDistribRtc2List]  Theorem
      
      |- ∀h t. rtc2list (rderives ag) (h::t) ⇒ rsf ag h ⇒ ∀e. MEM e t ⇒ rsf ag e
   
   [rt]  Theorem
      
      |- ∀e. (∃r. e ∈ rule_terminals r) ⇔ ¬isNonTmnlSym e
   
   [rtc2listEveryMemNML]  Theorem
      
      |- LENGTH dl > 1 ⇒
         HD dl ≠ [] ⇒
         EVERY isNonTmnlSym (HD dl) ⇒
         derives g ⊢ dl ◁ HD dl → [] ⇒
         (∀sf. MEM sf dl ⇒ ¬MEM (NTS N) sf) ⇒
         (derivNts dl ∩ set sn = {}) ⇒
         (∀m.
            m < LENGTH dl + 1 ⇒
            ∀dl.
              (m = LENGTH dl) ⇒
              ∀N sn.
                derives g ⊢ dl ◁ [NTS N] → [] ⇒
                dl ≠ [] ⇒
                (derivNts dl ∩ set sn = {}) ⇒
                (∀sf. MEM sf (TL dl) ⇒ ¬MEM (NTS N) sf) ⇒
                nullableML g sn [NTS N]) ⇒
         ∀e. MEM e (HD dl) ⇒ nullableML g sn [e]
   
   [rtc2listRtcldTmnls]  Theorem
      
      |- ∀t. rtc2list (lderives g) (h::t) ∧ EVERY isTmnlSym h ⇒ (t = [])
   
   [rtc2listTlHd]  Theorem
      
      |- ∀dl.
           derives g ⊢ dl ◁ HD dl → [] ⇒
           LENGTH (TL dl) > 1 ⇒
           ∃pfx N sfx. HD (TL dl) = pfx ++ [NTS N] ++ sfx
   
   [rtc2listTlHdEveryMem]  Theorem
      
      |- ∀dl.
           derives g ⊢ dl ◁ HD dl → [] ⇒
           LENGTH (TL dl) > 1 ⇒
           ∀e. MEM e (HD (TL dl)) ⇒ isNonTmnlSym e
   
   [rtc2list_exists]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀e. e ∈ language g ⇒ ∃dl. rderives g ⊢ dl ◁ [NTS (startSym g)] → e
   
   [rtc2list_isolate_NT]  Theorem
      
      |- ∀dl pfx N sfx.
           derives g ⊢ dl ◁ pfx ++ [NTS N] ++ sfx → LAST dl ⇒
           ∃pfx' rhs sfx'.
             (LAST dl = pfx' ++ rhs ++ sfx') ∧
             ∃dl'. derives g ⊢ dl' ◁ [NTS N] → rhs ∧ LENGTH dl' ≤ LENGTH dl
   
   [rtc2list_isolate_NT']  Theorem
      
      |- ∀dl pfx N sfx.
           derives g ⊢ dl ◁ pfx ++ [NTS N] ++ sfx → LAST dl ⇒
           ∃pfx' rhs sfx'.
             (LAST dl = pfx' ++ rhs ++ sfx') ∧
             ∃dl'.
               derives g ⊢ dl' ◁ [NTS N] → rhs ∧ LENGTH dl' ≤ LENGTH dl ∧
               derivNts dl' ⊆ derivNts dl
   
   [rtc2list_startSym_rtcRderives]  Theorem
      
      |- ∀u v.
           (rderives g)^* u v ⇒
           (u = [NTS (startSym g)]) ⇒
           ∃dl.
             rtc2list (rderives g) dl ∧ (HD dl = [NTS (startSym g)]) ∧ (LAST dl = v)
   
   [rtcDerivesInRuleRhs]  Theorem
      
      |- (derives g)^* [NTS N] (pfx ++ [sym] ++ sfx) ⇒
         pfx ≠ [] ∨ sfx ≠ [] ⇒
         ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcDerivesInRuleRhs']  Theorem
      
      |- (derives g)^* [NTS N] (pfx ++ [sym] ++ sfx) ⇒
         [NTS N] ≠ pfx ++ [sym] ++ sfx ⇒
         ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcDerivesInRuleRhsLen]  Theorem
      
      |- ∀u v.
           (derives g)^* u v ⇒
           (u = [NTS N]) ⇒
           LENGTH v > 1 ⇒
           MEM sym v ⇒
           ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcDerivesInRuleRhsLenGte1]  Theorem
      
      |- ∀u v.
           (derives g)^* u v ⇒
           (u = [NTS N]) ⇒
           LENGTH v ≥ 1 ⇒
           u ≠ v ⇒
           MEM sym v ⇒
           ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcRdImpDg]  Theorem
      
      |- ∀u v. (rderives g)^* u v ⇒ (derives g)^* u v
   
   [rtcRderivesInRuleRhs]  Theorem
      
      |- (rderives g)^* [NTS N] (pfx ++ [sym] ++ sfx) ⇒
         pfx ≠ [] ∨ sfx ≠ [] ⇒
         ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcRderivesInRuleRhsLen]  Theorem
      
      |- ∀u v.
           (rderives g)^* u v ⇒
           (u = [NTS N]) ⇒
           LENGTH v > 1 ⇒
           MEM sym v ⇒
           ∃lhs rhs p s. MEM (rule lhs (p ++ [sym] ++ s)) (rules g)
   
   [rtcRderivesLastTmnl]  Theorem
      
      |- ∀u v. (rderives g)^* u v ⇒ (u = pfx ++ [TS ts]) ⇒ ∃pfx'. v = pfx' ++ [TS ts]
   
   [rtc_derives_same_append_left]  Theorem
      
      |- ∀u v. (derives g)^* u v ⇒ ∀x. (derives g)^* (x ++ u) (x ++ v)
   
   [rtc_derives_same_append_right]  Theorem
      
      |- ∀u v. (derives g)^* u v ⇒ ∀x. (derives g)^* (u ++ x) (v ++ x)
   
   [rtc_lderives_same_append_left]  Theorem
      
      |- ∀u v.
           (lderives g)^* u v ⇒ EVERY isTmnlSym x ⇒ (lderives g)^* (x ++ u) (x ++ v)
   
   [rtc_r1]  Theorem
      
      |- (derives g)^* s1 s2 ⇒ s1 ≠ s2 ⇒ ∃sf. derives g s1 sf ∧ (derives g)^* sf s2
   
   [rtc_rderives_has_tmnl]  Theorem
      
      |- ∀x y. (rderives g)^* x y ⇒ MEM (TS h) x ⇒ MEM (TS h) y
   
   [rtc_rderives_same_append_left]  Theorem
      
      |- ∀u v. (rderives g)^* u v ⇒ ∀x. (rderives g)^* (x ++ u) (x ++ v)
   
   [ruleRhsInAllSyms]  Theorem
      
      |- ∀lhs rhs. MEM (rule lhs rhs) (rules g) ⇒ ∀e. MEM e rhs ⇒ e ∈ allSyms g
   
   [rule_11]  Theorem
      
      |- ∀a0 a1 a0' a1'. (rule a0 a1 = rule a0' a1') ⇔ (a0 = a0') ∧ (a1 = a1')
   
   [rule_Axiom]  Theorem
      
      |- ∀f. ∃fn. ∀a0 a1. fn (rule a0 a1) = f a0 a1
   
   [rule_case_cong]  Theorem
      
      |- ∀M M' f.
           (M = M') ∧ (∀a0 a1. (M' = rule a0 a1) ⇒ (f a0 a1 = f' a0 a1)) ⇒
           (rule_case f M = rule_case f' M')
   
   [rule_induction]  Theorem
      
      |- ∀P. (∀n l. P (rule n l)) ⇒ ∀r. P r
   
   [rule_nchotomy]  Theorem
      
      |- ∀rr. ∃n l. rr = rule n l
   
   [rulesWithSymInRhs_def]  Theorem
      
      |- (∀sym. rulesWithSymInRhs sym [] = []) ∧
         ∀sym rst r l.
           rulesWithSymInRhs sym (rule l r::rst) =
           if MEM sym r then
             (l,breakAtElem sym r)::rulesWithSymInRhs sym rst
           else
             rulesWithSymInRhs sym rst
   
   [rulesWithSymInRhs_ind]  Theorem
      
      |- ∀P.
           (∀sym. P sym []) ∧
           (∀sym l r rst.
              (¬MEM sym r ⇒ P sym rst) ∧ (MEM sym r ⇒ P sym rst) ⇒
              P sym (rule l r::rst)) ⇒
           ∀v v1. P v v1
   
   [sfxNotNull_def]  Theorem
      
      |- (∀g. sfxNotNull g [] = []) ∧
         ∀sfx rst l g.
           sfxNotNull g ((l,sfx)::rst) =
           if ¬nullable g sfx then sfx::sfxNotNull g rst else sfxNotNull g rst
   
   [sfxNotNull_ind]  Theorem
      
      |- ∀P.
           (∀g. P g []) ∧
           (∀g l sfx rst.
              (¬ ¬nullable g sfx ⇒ P g rst) ∧ (¬nullable g sfx ⇒ P g rst) ⇒
              P g ((l,sfx)::rst)) ⇒
           ∀v v1. P v v1
   
   [slemma1_3]  Theorem
      
      |- NTS nt ∉ nonTerminals g ⇔
         ¬(∃rhs. MEM (rule nt rhs) (rules g)) ∧
         ¬(∃l p s. MEM (rule l (p ++ [NTS nt] ++ s)) (rules g)) ∧ nt ≠ startSym g
   
   [slemma1_4]  Theorem
      
      |- NTS nt ∈ nonTerminals g ⇔
         ∃rhs.
           MEM (rule nt rhs) (rules g) ∨
           ∃l p s. MEM (rule l (p ++ [NTS nt] ++ s)) (rules g) ∨ (nt = startSym g)
   
   [slemma1_4Tmnls]  Theorem
      
      |- TS t ∈ terminals g ⇔ ∃l p s. MEM (rule l (p ++ [TS t] ++ s)) (rules g)
   
   [slres]  Theorem
      
      |- (s1 ++ [NTS lhs] ++ s2 = [NTS s]) ⇒ (lhs = s)
   
   [slres2]  Theorem
      
      |- (s1 ++ [NTS lhs] ++ s2 = [NTS s]) ⇒ (s1 = []) ∧ (s2 = [])
   
   [sub_result]  Theorem
      
      |- ∀g symlist.
           EVERY (gaw g) symlist ⇒ ∃w. (derives g)^* symlist w ∧ EVERY isTmnlSym w
   
   [sub_result_rev]  Theorem
      
      |- ∀symlist.
           (∃w. (derives g)^* symlist w ∧ EVERY isTmnlSym w) ⇒ EVERY (gaw g) symlist
   
   [symInGr]  Theorem
      
      |- ∀sym g. lhsWithLastSym sym (rules g) ≠ [] ⇒ sym ∈ allSyms g
   
   [term_syms_gen_words]  Theorem
      
      |- EVERY isTmnlSym w ⇒ EVERY (gaw g) w
   
   [terminalsEq]  Theorem
      
      |- terminals g = terminalsML g
   
   [terminalsList_def]  Theorem
      
      |- (terminalsList [] = []) ∧
         ∀rst r l.
           terminalsList (rule l r::rst) =
           MAP ts2str (FILTER isTmnlSym r) ++ terminalsList rst
   
   [terminalsList_ind]  Theorem
      
      |- ∀P. P [] ∧ (∀l r rst. P rst ⇒ P (rule l r::rst)) ⇒ ∀v. P v
   
   [terminalsML_def]  Theorem
      
      |- (∀s. terminalsML (G [] s) = set []) ∧
         ∀s rs r l.
           terminalsML (G (rule l r::rs) s) =
           set (FILTER isTmnlSym r) ∪ terminalsML (G rs s)
   
   [terminalsML_ind]  Theorem
      
      |- ∀P.
           (∀s. P (G [] s)) ∧ (∀l r rs s. P (G rs s) ⇒ P (G (rule l r::rs) s)) ⇒
           ∀v. P v
   
   [tsNotInNonTmnls]  Theorem
      
      |- ∀ts. TS ts ∉ nonTerminals g
   
   [upgr_r11]  Theorem
      
      |- derives g [NTS lhs] [NTS rhs] ⇒ MEM (rule lhs [NTS rhs]) (rules g)
   
   [upgr_r15]  Theorem
      
      |- ∀u v.
           (derives g)^* u v ⇒
           (u = s1 ++ lhs' ++ s2) ⇒
           MEM (rule lhs lhs') (rules g) ⇒
           (derives g)^* (s1 ++ [NTS lhs] ++ s2) v
   
   [upgr_r17]  Theorem
      
      |- ∀u v.
           (derives g)^* u v ⇒
           (u = x ++ y) ⇒
           ∃x' y'. (v = x' ++ y') ∧ (derives g)^* x x' ∧ (derives g)^* y y'
   
   [upgr_r17_ld]  Theorem
      
      |- ∀dl x y v.
           derives g ⊢ dl ◁ u → v ⇒
           (u = [x] ++ [y]) ⇒
           ∃x' y' dl1 dl2.
             (v = x' ++ y') ∧ derives g ⊢ dl1 ◁ [x] → x' ∧
             derives g ⊢ dl2 ◁ [y] → y' ∧ LENGTH dl1 ≤ LENGTH dl ∧
             LENGTH dl2 ≤ LENGTH dl
   
   [upgr_r18]  Theorem
      
      |- derives g s s' ⇒ ∃pfx sfx. (s' = pfx ++ sfx) ∧ derives g s pfx
   
   [upgr_r19]  Theorem
      
      |- ∀u v.
           (derives g)^* u v ⇒
           (u = x ++ y ++ z) ⇒
           ∃x' y' z'.
             (v = x' ++ y' ++ z') ∧ (derives g)^* x x' ∧ (derives g)^* y y' ∧
             (derives g)^* z z'
   
   [upgr_r7]  Theorem
      
      |- ∀u z.
           (derives g)^* u z ⇒
           (u = x ++ y) ⇒
           ∃x' y'. (z = x' ++ y') ⇒ (derives g)^* x x' ∧ (derives g)^* y y'
   
   [x_1]  Theorem
      
      |- MEM e (getRhs A (rules g)) ⇔ derives g [NTS A] e
   
   
*)
end
