signature listLemmasTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val addFront_def : thm
    val addLast_def : thm
    val breakAtElem_def : thm
    val delete_def : thm
    val diff_curried_def : thm
    val diff_tupled_primitive_def : thm
    val isSuffix_def : thm
    val pop_def : thm
    val push_def : thm
    val rmDupes_defn_primitive_def : thm
    val take1_defn_curried_def : thm
    val take1_defn_tupled_primitive_def : thm
    val take_def : thm
  
  (*  Theorems  *)
    val FLAT_APPEND_DISTRIB : thm
    val addFrontAppList : thm
    val addFrontDrop : thm
    val addFrontImpDrop : thm
    val addFrontLast : thm
    val addFrontMem : thm
    val alld_delete : thm
    val alld_rmd : thm
    val append_eq_imp_pfx : thm
    val append_eq_imp_sfx : thm
    val c0 : thm
    val c1 : thm
    val cx : thm
    val delete_append : thm
    val delete_diff_elem : thm
    val delete_lts : thm
    val delete_lts_card : thm
    val delete_mem_len : thm
    val delete_mem_list : thm
    val delete_nil : thm
    val delete_not_mem : thm
    val delete_not_mem1 : thm
    val delete_not_mem2 : thm
    val delete_prop : thm
    val delete_twice : thm
    val diff_DIFF : thm
    val diff_def : thm
    val diff_ind : thm
    val diff_mem : thm
    val diff_mem1 : thm
    val diff_mem2 : thm
    val dropLen : thm
    val dropNotNil : thm
    val elMemLen : thm
    val elTlEq : thm
    val elem_eq : thm
    val everyFlat : thm
    val everyNotTwice : thm
    val filter_l1 : thm
    val filter_l2 : thm
    val finiteLists : thm
    val flatMem : thm
    val flatMemNot : thm
    val flat_map_mem : thm
    val frontAppendFst : thm
    val frontLen : thm
    val isSuffix_APPEND : thm
    val isSuffix_NIL2 : thm
    val isSuffix_lemma : thm
    val isSuffix_refl : thm
    val l_lemma1 : thm
    val lastElemEq : thm
    val lastListBdown : thm
    val last_append : thm
    val last_elem : thm
    val last_exists : thm
    val len0 : thm
    val len1 : thm
    val len2 : thm
    val len3 : thm
    val len_not_0 : thm
    val len_snoc : thm
    val listEq : thm
    val listEqRightAppend : thm
    val listHdTl : thm
    val listNotEmpty : thm
    val listNotNull : thm
    val listPairExists : thm
    val listStartSame : thm
    val list_exists_mem : thm
    val list_l1 : thm
    val list_lem1 : thm
    val list_lem2 : thm
    val list_lem3 : thm
    val list_lem4 : thm
    val list_mem1 : thm
    val list_mem2 : thm
    val list_r1 : thm
    val list_r2 : thm
    val list_r6 : thm
    val list_set_len : thm
    val listappnil : thm
    val listeq : thm
    val lres : thm
    val lresb : thm
    val lreseq : thm
    val mapDrop : thm
    val mapFstEq : thm
    val mapSndDropEq : thm
    val mapSndTakeEq : thm
    val map_pop : thm
    val map_rev : thm
    val memTl : thm
    val mem_subset_len : thm
    val notLen1 : thm
    val notMem_delete_len : thm
    val not_mem_delete : thm
    val pfxthm2 : thm
    val pop0 : thm
    val popAdd : thm
    val pop_eq : thm
    val pop_not_empty : thm
    val popl : thm
    val popnthm : thm
    val push_not_nil : thm
    val revTakeMap : thm
    val rev_len : thm
    val rev_nil : thm
    val rev_sing : thm
    val rgr_r9 : thm
    val rgr_r9b : thm
    val rgr_r9eq : thm
    val rmDupes : thm
    val rmDupes_ind : thm
    val rmDupes_len : thm
    val rmDupes_lts : thm
    val rmDupes_lts_card : thm
    val rmDupes_lts_card_eq : thm
    val rmDupes_not_nil : thm
    val rmDupes_prop : thm
    val rmDupes_twice : thm
    val rmdNil : thm
    val rmdNotMemLen : thm
    val rmd_del : thm
    val rmd_mem_list : thm
    val rmd_mem_list1 : thm
    val rmd_mem_list2 : thm
    val rmd_r2 : thm
    val rmd_r2_1 : thm
    val rmd_r2_2 : thm
    val rmda_del_rmda : thm
    val set_neq_len : thm
    val sl : thm
    val sl_l2 : thm
    val sl_l3 : thm
    val sl_l4 : thm
    val sl_l5 : thm
    val take0 : thm
    val take0out : thm
    val take1 : thm
    val take10 : thm
    val take1Map : thm
    val take1_ind : thm
    val takeCoMap : thm
    val take_len : thm
    val take_map : thm
    val take_mem : thm
    val take_pop : thm
    val take_valid : thm
    val takenthm : thm
    val twoListAppEq : thm
    val valid_take_map : thm
    val x : thm
  
  val listLemmas_grammars : type_grammar.grammar * term_grammar.grammar
  
  val listLemmas_rwts : simpLib.ssfrag
(*
   [containerLemmas] Parent theory of "listLemmas"
   
   [string] Parent theory of "listLemmas"
   
   [addFront_def]  Definition
      
      |- ∀l e. addFront l e = l ++ e
   
   [addLast_def]  Definition
      
      |- ∀l e. addLast l e = l ++ e
   
   [breakAtElem_def]  Definition
      
      |- (∀e. breakAtElem e [] = []) ∧
         ∀e l ls. breakAtElem e (l::ls) = if e = l then ls else breakAtElem e ls
   
   [delete_def]  Definition
      
      |- (∀x. delete x [] = []) ∧
         ∀x l ls. delete x (l::ls) = if x = l then delete x ls else l::delete x ls
   
   [diff_curried_def]  Definition
      
      |- ∀x x1. diff x x1 = diff_tupled (x,x1)
   
   [diff_tupled_primitive_def]  Definition
      
      |- diff_tupled =
         WFREC
           (@R.
              WF R ∧ (∀ls v5 v4 l. ¬MEM l (v4::v5) ⇒ R (v4::v5,ls) (v4::v5,l::ls)) ∧
              ∀ls v5 v4 l. MEM l (v4::v5) ⇒ R (delete l (v4::v5),ls) (v4::v5,l::ls))
           (λdiff_tupled a.
              case a of
                 ([],[]) -> I []
              || ([],v10::v11) -> I []
              || (v6::v7,[]) -> I (v6::v7)
              || (v6::v7,v12::v13) ->
                   I
                     (if MEM v12 (v6::v7) then
                        diff_tupled (delete v12 (v6::v7),v13)
                      else
                        diff_tupled (v6::v7,v13)))
   
   [isSuffix_def]  Definition
      
      |- ∀x l. isSuffix x l ⇔ REVERSE x ≼ REVERSE l
   
   [pop_def]  Definition
      
      |- (∀v0. pop [] v0 = []) ∧
         ∀h t num. pop (h::t) num = if num = 0 then h::t else pop t (num − 1)
   
   [push_def]  Definition
      
      |- ∀l e. push l e = e::l
   
   [rmDupes_defn_primitive_def]  Definition
      
      |- rmDupes =
         WFREC (@R. WF R ∧ ∀t h. R (delete h t) (h::t))
           (λrmDupes a. case a of [] -> I [] || h::t -> I (h::rmDupes (delete h t)))
   
   [take1_defn_curried_def]  Definition
      
      |- ∀x x1. take1 x x1 = take1_defn_tupled (x,x1)
   
   [take1_defn_tupled_primitive_def]  Definition
      
      |- take1_defn_tupled =
         WFREC
           (@R.
              WF R ∧ (∀x xs. 0 ≠ 0 ⇒ R (0 − 1,xs) (0,x::xs)) ∧
              ∀x xs v2. SUC v2 ≠ 0 ⇒ R (SUC v2 − 1,xs) (SUC v2,x::xs))
           (λtake1_defn_tupled a.
              case a of
                 (0,[]) -> I []
              || (0,v4::v5) ->
                   I (if 0 = 0 then [] else v4::take1_defn_tupled (0 − 1,v5))
              || (SUC v3,[]) -> ARB
              || (SUC v3,v6::v7) ->
                   I
                     (if SUC v3 = 0 then
                        []
                      else
                        v6::take1_defn_tupled (SUC v3 − 1,v7)))
   
   [take_def]  Definition
      
      |- ∀n l. take n l = if LENGTH l ≥ n then SOME (take1 n l) else NONE
   
   [FLAT_APPEND_DISTRIB]  Theorem
      
      |- ∀x y. FLAT (x ++ y) = FLAT x ++ FLAT y
   
   [addFrontAppList]  Theorem
      
      |- ∀dl'.
           (MAP (addFront rhs) dl' = p ++ [rhs ++ r' ++ [NTS B] ++ sfx] ++ s) ∧
           EVERY isTmnlSym (rhs ++ r') ∧
           MEM (rhs ++ r' ++ v ++ [NTS B] ++ w ++ sfx) s ⇒
           ∃p' s'.
             (dl' = p' ++ [r' ++ [NTS B] ++ sfx] ++ s') ∧
             MEM (r' ++ v ++ [NTS B] ++ w ++ sfx) s'
   
   [addFrontDrop]  Theorem
      
      |- ∀dl. dl = MAP (DROP (LENGTH rhs)) (MAP (addFront rhs) dl)
   
   [addFrontImpDrop]  Theorem
      
      |- ∀dl. (MAP (addFront rhs) dl = l) ⇒ (dl = MAP (DROP (LENGTH rhs)) l)
   
   [addFrontLast]  Theorem
      
      |- ∀l. l ≠ [] ⇒ (LAST (MAP (addFront rhs) l) = rhs ++ LAST l)
   
   [addFrontMem]  Theorem
      
      |- ∀e. MEM e (MAP (addFront rhs) l) ⇒ ∃sfx. MEM sfx l ∧ (e = rhs ++ sfx)
   
   [alld_delete]  Theorem
      
      |- ∀l. ALL_DISTINCT l ⇒ ∀h. ALL_DISTINCT (delete h l)
   
   [alld_rmd]  Theorem
      
      |- ∀l l'. (rmDupes l = l') ⇒ ALL_DISTINCT l'
   
   [append_eq_imp_pfx]  Theorem
      
      |- ∀l1 l2 m1 m2. (l1 ++ l2 = m1 ++ m2) ⇒ m1 ≼ l1 ∨ l1 ≼ m1
   
   [append_eq_imp_sfx]  Theorem
      
      |- ∀l1 l2 m1 m2. (l1 ++ l2 = m1 ++ m2) ⇒ isSuffix l2 m2 ∨ isSuffix m2 l2
   
   [c0]  Theorem
      
      |- ∀pfx stl l.
           (pfx ++ l = REVERSE (MAP FST (MAP FST stl))) ⇒
           (REVERSE (MAP FST (MAP FST (pop stl (LENGTH l)))) = pfx)
   
   [c1]  Theorem
      
      |- ∀pfx sfx. pfx ++ [e] ++ sfx = pfx ++ e::sfx
   
   [cx]  Theorem
      
      |- ∀stl pfx h e t sfx. h ≠ e ⇒ stl ++ [e] ≠ pfx ++ stl ++ h::t ++ sfx
   
   [delete_append]  Theorem
      
      |- ∀e l1 l2. delete e (l1 ++ l2) = delete e l1 ++ delete e l2
   
   [delete_diff_elem]  Theorem
      
      |- ∀h h' l. delete h (delete h' l) = delete h' (delete h l)
   
   [delete_lts]  Theorem
      
      |- ∀h l. MEM h l ⇒ (set l = h INSERT set (delete h l))
   
   [delete_lts_card]  Theorem
      
      |- ∀h l. MEM h l ⇒ CARD (set l) > CARD (set (delete h l))
   
   [delete_mem_len]  Theorem
      
      |- ∀e l. MEM e l ⇒ LENGTH (delete e l) < LENGTH l
   
   [delete_mem_list]  Theorem
      
      |- ∀e h l. h ≠ e ⇒ (MEM e l ⇔ MEM e (delete h l))
   
   [delete_nil]  Theorem
      
      |- ∀e l. (delete e l = []) ⇔ (l = []) ∨ ∀el. MEM el l ⇒ (el = e)
   
   [delete_not_mem]  Theorem
      
      |- ∀e l. (delete e l = l) ⇔ ¬MEM e l
   
   [delete_not_mem1]  Theorem
      
      |- ∀e l. ¬MEM e l ⇒ (delete e l = l)
   
   [delete_not_mem2]  Theorem
      
      |- ∀e l. (delete e l = l) ⇒ ¬MEM e l
   
   [delete_prop]  Theorem
      
      |- ∀P l. EVERY P l ⇒ EVERY P (delete h l)
   
   [delete_twice]  Theorem
      
      |- ∀h l. delete h l = delete h (delete h l)
   
   [diff_DIFF]  Theorem
      
      |- ∀l1 l2. set (diff l1 l2) = set l1 DIFF set l2
   
   [diff_def]  Theorem
      
      |- (diff [] [] = []) ∧ (∀v3 v2. diff (v2::v3) [] = v2::v3) ∧
         (∀v9 v8. diff [] (v8::v9) = []) ∧
         ∀v5 v4 ls l.
           diff (v4::v5) (l::ls) =
           if MEM l (v4::v5) then diff (delete l (v4::v5)) ls else diff (v4::v5) ls
   
   [diff_ind]  Theorem
      
      |- ∀P.
           P [] [] ∧ (∀v2 v3. P (v2::v3) []) ∧ (∀v8 v9. P [] (v8::v9)) ∧
           (∀v4 v5 l ls.
              (¬MEM l (v4::v5) ⇒ P (v4::v5) ls) ∧
              (MEM l (v4::v5) ⇒ P (delete l (v4::v5)) ls) ⇒
              P (v4::v5) (l::ls)) ⇒
           ∀v v1. P v v1
   
   [diff_mem]  Theorem
      
      |- ∀e l1 l2. MEM e (diff l1 l2) ⇔ MEM e l1 ∧ ¬MEM e l2
   
   [diff_mem1]  Theorem
      
      |- ∀e l1 l2. MEM e (diff l1 l2) ⇒ MEM e l1 ∧ ¬MEM e l2
   
   [diff_mem2]  Theorem
      
      |- ∀e l1 l2. MEM e l1 ⇒ ¬MEM e l2 ⇒ MEM e (diff l1 l2)
   
   [dropLen]  Theorem
      
      |- ∀l l1 l2. (l = l1 ++ l2) ∧ LENGTH l1 ≤ LENGTH l ⇒ (DROP (LENGTH l1) l = l2)
   
   [dropNotNil]  Theorem
      
      |- ∀l n. n < LENGTH l ⇒ DROP n l ≠ []
   
   [elMemLen]  Theorem
      
      |- ∀n l. n < LENGTH l ⇒ ∃p s. (l = p ++ [EL n l] ++ s) ∧ (LENGTH p = n)
   
   [elTlEq]  Theorem
      
      |- ∀t n. n + 1 < SUC (LENGTH t) ⇒ (EL n t = EL (n + 1) (h::t))
   
   [elem_eq]  Theorem
      
      |- ∀l1 l2 l3 e h. (l1 ++ [e] ++ l2 = l1 ++ [h] ++ l3) ⇒ (e = h)
   
   [everyFlat]  Theorem
      
      |- ∀l1 l2 x. EVERY P (FLAT (l1 ++ [x] ++ l2)) ⇒ EVERY P x
   
   [everyNotTwice]  Theorem
      
      |- EVERY ($~ o $~ o isTmnlSym) v ⇔ EVERY isTmnlSym v
   
   [filter_l1]  Theorem
      
      |- ∀p l. LENGTH (FILTER p l) > 0 ⇒ ∃e. MEM e l ∧ p e
   
   [filter_l2]  Theorem
      
      |- ∀f l. (LENGTH (FILTER f l) = 0) ⇔ ¬∃e. MEM e l ∧ f e
   
   [finiteLists]  Theorem
      
      |- ∀l. FINITE (set l)
   
   [flatMem]  Theorem
      
      |- ∀l s1 s2 x.
           (FLAT (MAP SND l) = s1 ++ [x] ++ s2) ⇒
           ∃p s p' s'.
             (MAP SND l = p ++ [p' ++ [x] ++ s'] ++ s) ∧ (s1 = FLAT p ++ p') ∧
             (s2 = s' ++ FLAT s)
   
   [flatMemNot]  Theorem
      
      |- ∀l' e. (∀l. MEM l l' ⇒ ¬MEM e l) ⇒ ¬MEM e (FLAT l')
   
   [flat_map_mem]  Theorem
      
      |- ∀e l. MEM e (FLAT (MAP f l)) ⇒ ∃e'. MEM e' (MAP f l) ∧ MEM e e'
   
   [frontAppendFst]  Theorem
      
      |- FRONT (l ++ [x]) = l
   
   [frontLen]  Theorem
      
      |- ∀l. l ≠ [] ⇒ LENGTH (FRONT l) < LENGTH l
   
   [isSuffix_APPEND]  Theorem
      
      |- ∀l1 l2. isSuffix l1 l2 ⇔ ∃l0. l2 = l0 ++ l1
   
   [isSuffix_NIL2]  Theorem
      
      |- ∀list. isSuffix list [] ⇔ (list = [])
   
   [isSuffix_lemma]  Theorem
      
      |- isSuffix m2 (m1 ++ m2)
   
   [isSuffix_refl]  Theorem
      
      |- isSuffix s1 s1
   
   [l_lemma1]  Theorem
      
      |- ∀r. 1 ≤ LENGTH r ⇒ ∃h' r'. r = h'::r'
   
   [lastElemEq]  Theorem
      
      |- ∀l l' e e'. (l ++ [e] = l' ++ [e']) ⇒ (e = e')
   
   [lastListBdown]  Theorem
      
      |- ∀l e. l ≠ [] ⇒ (LAST l = e) ⇒ ∃pfx. l = pfx ++ [e]
   
   [last_append]  Theorem
      
      |- ∀l1 l2. l2 ≠ [] ⇒ (LAST (l1 ++ l2) = LAST l2)
   
   [last_elem]  Theorem
      
      |- ∀l pfx e. (l = pfx ++ [e]) ⇒ (LAST l = e)
   
   [last_exists]  Theorem
      
      |- ∀l. l ≠ [] ⇒ ∃x. LAST l = x
   
   [len0]  Theorem
      
      |- ∀s. NULL s ⇔ (LENGTH s = 0)
   
   [len1]  Theorem
      
      |- ∀l1 l1' rst rst'.
           (l1 ++ rst = l1' ++ rst') ⇒ (LENGTH l1 = LENGTH l1') ⇒ (l1 = l1')
   
   [len2]  Theorem
      
      |- ∀l1 l1' rst rst'.
           (l1 ++ rst = l1' ++ rst') ⇒
           LENGTH l1' < LENGTH l1 ⇒
           ∃pfx sfx. (l1 = pfx ++ sfx) ∧ (l1' = pfx)
   
   [len3]  Theorem
      
      |- ∀l1 l1' rst rst'.
           (l1 ++ rst = l1' ++ rst') ⇒
           LENGTH l1' > LENGTH l1 ⇒
           ∃pfx sfx. (l1' = pfx ++ sfx) ∧ (l1 = pfx)
   
   [len_not_0]  Theorem
      
      |- ∀l. LENGTH l ≠ 0 ⇔ ∃h t. l = h::t
   
   [len_snoc]  Theorem
      
      |- ∀n. (LENGTH l = SUC n) ⇔ ∃pfx t. (l = pfx ++ [t]) ∧ (LENGTH pfx = n)
   
   [listEq]  Theorem
      
      |- ∀l l1. (l = l1 ++ l) ⇔ (l1 = [])
   
   [listEqRightAppend]  Theorem
      
      |- ∀l l1. (l = l ++ l1) ⇒ (l1 = [])
   
   [listHdTl]  Theorem
      
      |- ∀l. l ≠ [] ⇒ (l = [HD l] ++ TL l)
   
   [listNotEmpty]  Theorem
      
      |- ∀l. (∃e. MEM e l) ⇔ l ≠ []
   
   [listNotNull]  Theorem
      
      |- ∀p. ¬NULL p ⇔ ∃h t. p = h::t
   
   [listPairExists]  Theorem
      
      |- ∀l.
           ∃l'.
             (l = MAP FST l') ∧ (l = FLAT (MAP SND l')) ∧
             ∀a b. MEM (a,b) l' ⇒ (LENGTH b = 1) ∧ (a = HD b)
   
   [listStartSame]  Theorem
      
      |- ∀l l1 l1'. (l ++ l1 = l ++ l1') ⇒ (l1 = l1')
   
   [list_exists_mem]  Theorem
      
      |- ∀l. l ≠ [] ⇒ ∃e. MEM e l
   
   [list_l1]  Theorem
      
      |- ∀r. (r = []) ⇔ NULL r
   
   [list_lem1]  Theorem
      
      |- ∀l. (LENGTH l = 1) ⇔ ∃e. l = [e]
   
   [list_lem2]  Theorem
      
      |- ∀l. (LENGTH l = 2) ⇔ ∃e1 e2. l = [e1; e2]
   
   [list_lem3]  Theorem
      
      |- ∀l. LENGTH l ≥ 3 ⇔ ∃e1 e2 e3 r. l = [e1; e2; e3] ++ r
   
   [list_lem4]  Theorem
      
      |- ∀l. LENGTH l ≥ 2 ⇔ ∃e1 e2 r. l = [e1; e2] ++ r
   
   [list_mem1]  Theorem
      
      |- ∀l. l ≠ [] ⇔ ∃e. MEM e l
   
   [list_mem2]  Theorem
      
      |- ∀l. l ≠ [] ⇔ ∃h t. l = h::t
   
   [list_r1]  Theorem
      
      |- ∀v v' x. (v = v' ++ [x]) ⇒ MEM x v
   
   [list_r2]  Theorem
      
      |- ∀s1 s2 rhs x. (s1 ++ rhs ++ s2 = [x]) ⇒ rhs ≠ [] ⇒ (s1 = []) ∧ (s2 = [])
   
   [list_r6]  Theorem
      
      |- ∀s1 s2 s1' s2' x.
           (s1' ++ [x] ++ s2' = s1 ++ s2) ⇒
           ∃l1 l2.
             (s1 = s1' ++ [x] ++ l1) ∧ (s2 = l2) ∧ (s2' = l1 ++ l2) ∨
             (s2 = l2 ++ [x] ++ s2') ∧ (s1 = l1) ∧ (s1' = l1 ++ l2)
   
   [list_set_len]  Theorem
      
      |- ∀l1 l2. LENGTH (rmDupes l1) ≥ LENGTH l2 ⇒ CARD (set l1) ≥ CARD (set l2)
   
   [listappnil]  Theorem
      
      |- ∀x. (x = pfx ++ x) ⇒ (pfx = [])
   
   [listeq]  Theorem
      
      |- ∀l1 l2 e l1' l2' e'.
           (l1 ++ [e] ++ l2 = l1' ++ [e'] ++ l2') ⇒
           ¬P e ∧ ¬P e' ∧ EVERY P l2 ∧ EVERY P l2' ⇒
           (l1 = l1') ∧ (e = e') ∧ (l2 = l2')
   
   [lres]  Theorem
      
      |- (l1 ++ [x] ++ l2 = [y]) ⇒ (l1 = []) ∧ (l2 = []) ∧ (x = y)
   
   [lresb]  Theorem
      
      |- (l1 = []) ∧ (l2 = []) ∧ (x = y) ⇒ (l1 ++ [x] ++ l2 = [y])
   
   [lreseq]  Theorem
      
      |- (l1 ++ [x] ++ l2 = [y]) ⇔ (l1 = []) ∧ (l2 = []) ∧ (x = y)
   
   [mapDrop]  Theorem
      
      |- ∀l n. MAP SND (DROP n l) = DROP n (MAP SND l)
   
   [mapFstEq]  Theorem
      
      |- ∀l r1 x r2.
           (MAP SND l = r1 ++ [x] ++ r2) ⇒
           l ≠ [] ⇒
           (MAP FST l =
            MAP FST (TAKE (LENGTH r1) l) ++ [FST (HD (DROP (LENGTH r1) l))] ++
            MAP FST (DROP (1 + LENGTH r1) l))
   
   [mapSndDropEq]  Theorem
      
      |- ∀l r1' x r2'.
           (MAP SND l = r1' ++ [x] ++ r2') ⇒
           (MAP SND (DROP (1 + LENGTH r1') l) = r2')
   
   [mapSndTakeEq]  Theorem
      
      |- ∀l r1' x r2'.
           (MAP SND l = r1' ++ [x] ++ r2') ⇒ (MAP SND (TAKE (LENGTH r1') l) = r1')
   
   [map_pop]  Theorem
      
      |- ∀l. pop (MAP f l) n = MAP f (pop l n)
   
   [map_rev]  Theorem
      
      |- ∀l. MAP f (REVERSE l) = REVERSE (MAP f l)
   
   [memTl]  Theorem
      
      |- ∀l. l ≠ [] ⇒ ∀e. MEM e (TL l) ⇒ MEM e l
   
   [mem_subset_len]  Theorem
      
      |- ∀l1 l2.
           (∀e. MEM e (rmDupes l1) ⇒ MEM e l2) ⇒ LENGTH l2 ≥ LENGTH (rmDupes l1)
   
   [notLen1]  Theorem
      
      |- ∀p s. ¬NULL p ∨ ¬NULL s ⇒ ∀x. ¬(LENGTH (p ++ [x] ++ s) ≤ 1)
   
   [notMem_delete_len]  Theorem
      
      |- ∀l. ¬MEM e l ⇒ (LENGTH l = LENGTH (delete e l))
   
   [not_mem_delete]  Theorem
      
      |- ∀e l. ¬MEM e (delete e l)
   
   [pfxthm2]  Theorem
      
      |- ∀r1 sfx. r1 ++ sfx ≼ r1 ⇒ (sfx = [])
   
   [pop0]  Theorem
      
      |- ∀l. pop l 0 = l
   
   [popAdd]  Theorem
      
      |- ∀l n rst. LENGTH l ≥ n ⇒ ∀rst. pop (l ++ rst) n = pop l n ++ rst
   
   [pop_eq]  Theorem
      
      |- ∀l n. (LENGTH l = n) ⇒ (pop l n = [])
   
   [pop_not_empty]  Theorem
      
      |- ∀l n. LENGTH l > n ⇒ pop l n ≠ []
   
   [popl]  Theorem
      
      |- ∀l n. (x = pop l n) ⇒ ∃pfx sfx. (l = pfx ++ sfx) ∧ (sfx = x)
   
   [popnthm]  Theorem
      
      |- ∀pfx rst n. (LENGTH pfx = n) ⇒ (pop (pfx ++ rst) n = rst)
   
   [push_not_nil]  Theorem
      
      |- ∀e l. push l e ≠ []
   
   [revTakeMap]  Theorem
      
      |- ∀n f l.
           (take n (MAP f l) = SOME x) ⇒
           (REVERSE (THE (take n (MAP f l))) = REVERSE (MAP f (THE (take n l))))
   
   [rev_len]  Theorem
      
      |- ∀l. LENGTH l = LENGTH (REVERSE l)
   
   [rev_nil]  Theorem
      
      |- ∀l. (REVERSE l = []) ⇔ (l = [])
   
   [rev_sing]  Theorem
      
      |- ∀r. (REVERSE r = [a]) ⇔ (r = [a])
   
   [rgr_r9]  Theorem
      
      |- ∀r. MEM sym r ⇒ ∃r1 r2. r = r1 ++ [sym] ++ r2
   
   [rgr_r9b]  Theorem
      
      |- ∀r. (∃r1 r2. r = r1 ++ [sym] ++ r2) ⇒ MEM sym r
   
   [rgr_r9eq]  Theorem
      
      |- ∀r. MEM sym r ⇔ ∃r1 r2. r = r1 ++ [sym] ++ r2
   
   [rmDupes]  Theorem
      
      |- (rmDupes [] = []) ∧ (rmDupes (h::t) = h::rmDupes (delete h t))
   
   [rmDupes_ind]  Theorem
      
      |- ∀P. P [] ∧ (∀h t. P (delete h t) ⇒ P (h::t)) ⇒ ∀v. P v
   
   [rmDupes_len]  Theorem
      
      |- ∀l. LENGTH l ≥ LENGTH (rmDupes l)
   
   [rmDupes_lts]  Theorem
      
      |- ∀l. set l = set (rmDupes l)
   
   [rmDupes_lts_card]  Theorem
      
      |- ∀l. LENGTH (rmDupes l) = CARD (set (rmDupes l))
   
   [rmDupes_lts_card_eq]  Theorem
      
      |- ∀l. CARD (set l) = CARD (set (rmDupes l))
   
   [rmDupes_not_nil]  Theorem
      
      |- ∀x xs. rmDupes (x::xs) ≠ []
   
   [rmDupes_prop]  Theorem
      
      |- ∀l. EVERY P l ⇒ EVERY P (rmDupes l)
   
   [rmDupes_twice]  Theorem
      
      |- ∀l. rmDupes (rmDupes l) = rmDupes l
   
   [rmdNil]  Theorem
      
      |- ∀l. (rmDupes l = []) ⇔ (l = [])
   
   [rmdNotMemLen]  Theorem
      
      |- ∀l. ¬MEM e l ⇒ LENGTH (rmDupes l) < LENGTH (rmDupes (e::l))
   
   [rmd_del]  Theorem
      
      |- ∀l. rmDupes (delete h l) = delete h (rmDupes l)
   
   [rmd_mem_list]  Theorem
      
      |- ∀l. MEM e (rmDupes l) ⇔ MEM e l
   
   [rmd_mem_list1]  Theorem
      
      |- ∀l. MEM e l ⇒ MEM e (rmDupes l)
   
   [rmd_mem_list2]  Theorem
      
      |- ∀l. MEM e (rmDupes l) ⇒ MEM e l
   
   [rmd_r2]  Theorem
      
      |- ∀e l. MEM e l ⇔ MEM e (rmDupes l)
   
   [rmd_r2_1]  Theorem
      
      |- ∀l. MEM e l ⇒ MEM e (rmDupes l)
   
   [rmd_r2_2]  Theorem
      
      |- ∀l. MEM e (rmDupes l) ⇒ MEM e l
   
   [rmda_del_rmda]  Theorem
      
      |- ∀l. rmDupes (delete h l) = rmDupes (delete h (rmDupes (delete h l)))
   
   [set_neq_len]  Theorem
      
      |- ∀s1. FINITE s1 ⇒ s1 ≠ s2 ⇒ s2 ⊆ s1 ⇒ CARD s1 ≥ CARD s2 ⇒ CARD s1 > CARD s2
   
   [sl]  Theorem
      
      |- ∀p s x. LENGTH (p ++ [x] ++ s) ≥ 3 ⇒ ¬NULL s ∨ ¬NULL p
   
   [sl_l2]  Theorem
      
      |- ∀p s x. LENGTH (p ++ [NTS t1] ++ s) ≥ 2 ⇒ ¬NULL s ∨ ¬NULL p
   
   [sl_l3]  Theorem
      
      |- ∀p s. LENGTH p + LENGTH s ≥ 1 ⇒ ¬NULL s ∨ ¬NULL p
   
   [sl_l4]  Theorem
      
      |- ∀e t1 t2 p s. [e] ≠ p ++ [NTS t1; NTS t2] ++ s
   
   [sl_l5]  Theorem
      
      |- ∀e1 e2 t1 t2 p s. ([e1; e2] = p ++ [NTS t1; NTS t2] ++ s) ⇒ NULL p ∧ NULL s
   
   [take0]  Theorem
      
      |- take 0 l = SOME []
   
   [take0out]  Theorem
      
      |- ∀l. (take 0 l = SOME y) ⇒ (y = [])
   
   [take1]  Theorem
      
      |- (take1 0 [] = []) ∧
         (take1 0 (x::xs) = if 0 = 0 then [] else x::take1 (0 − 1) xs) ∧
         (take1 (SUC v2) (x::xs) =
          if SUC v2 = 0 then [] else x::take1 (SUC v2 − 1) xs)
   
   [take10]  Theorem
      
      |- ∀l. take1 0 l = []
   
   [take1Map]  Theorem
      
      |- ∀f l n. LENGTH l ≥ n ⇒ (take1 n (MAP f l) = MAP f (take1 n l))
   
   [take1_ind]  Theorem
      
      |- ∀P.
           P 0 [] ∧ (∀x xs. (0 ≠ 0 ⇒ P (0 − 1) xs) ⇒ P 0 (x::xs)) ∧
           (∀v2 x xs. (SUC v2 ≠ 0 ⇒ P (SUC v2 − 1) xs) ⇒ P (SUC v2) (x::xs)) ∧
           (∀v2. P (SUC v2) []) ⇒
           ∀v v1. P v v1
   
   [takeCoMap]  Theorem
      
      |- ∀f g l. (take n (MAP (f o g) l) = SOME x) ⇒ ∃x'. take n (MAP g l) = SOME x'
   
   [take_len]  Theorem
      
      |- ∀n l. take n l ≠ NONE ⇒ LENGTH l ≥ n
   
   [take_map]  Theorem
      
      |- ∀stl.
           (take (LENGTH r) stl = SOME x) ⇒
           (MAP SND (THE (take (LENGTH r) stl)) =
            THE (take (LENGTH r) (MAP SND stl)))
   
   [take_mem]  Theorem
      
      |- ∀n l. (take n l = SOME x) ⇒ ∀e. MEM e x ⇒ MEM e l
   
   [take_pop]  Theorem
      
      |- ∀l l' n. (take n l = SOME l') ⇒ (l = l' ++ pop l n)
   
   [take_valid]  Theorem
      
      |- ∀l. LENGTH l ≥ n ⇒ ∃x. take n l = SOME x
   
   [takenthm]  Theorem
      
      |- ∀pfx rst n. (LENGTH pfx = n) ⇒ (take n (pfx ++ rst) = SOME pfx)
   
   [twoListAppEq]  Theorem
      
      |- (l1 ++ rst = l1' ++ rst') ⇒
         (l1 = l1') ∧ (rst = rst') ∨
         (∃s1' s2'. (l1 = l1' ++ s1') ∧ (rst = s2') ∧ (rst' = s1' ++ s2')) ∨
         ∃s1 s2. (l1' = l1 ++ s1) ∧ (rst' = s2) ∧ (rst = s1 ++ s2)
   
   [valid_take_map]  Theorem
      
      |- ∀n l. (take n l = SOME x) ⇒ ∃x'. take n (MAP f l) = SOME x'
   
   [x]  Theorem
      
      |- ∀e t. (e::t = t ++ [e']) ⇒ (e = e')
   
   
*)
end
