structure parseTreeTheory :> parseTreeTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading parseTreeTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open grammarDefTheory
  in end;
  val _ = Theory.link_parents
          ("parseTree",
          Arbnum.fromString "1260381300",
          Arbnum.fromString "717833")
          [("grammarDef",
           Arbnum.fromString "1260380522",
           Arbnum.fromString "819046")];
  val _ = Theory.incorporate_types "parseTree" [("ptree",2)];
  val _ = Theory.incorporate_consts "parseTree"
     [("validptree_defn_tupled",
       ((T"prod" "pair"
          [T"grammar" "grammarDef" [alpha, beta],
           T"ptree" "parseTree" [alpha, beta]] --> bool))),
      ("validptree",
       ((T"grammar" "grammarDef" [alpha, beta] -->
         (T"ptree" "parseTree" [alpha, beta] --> bool)))),
      ("ptsizel",
       ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"num" "num" []))),
      ("ptsize",
       ((T"ptree" "parseTree" [alpha, beta] --> T"num" "num" []))),
      ("ptree_size",
       (((U"'nts" --> T"num" "num" []) -->
         ((U"'ts" --> T"num" "num" []) -->
          (T"ptree" "parseTree" [U"'nts", U"'ts"] --> T"num" "num" []))))),
      ("ptree_case",
       (((U"'ts" --> alpha) -->
         ((U"'nts" -->
           (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
            alpha)) -->
          (T"ptree" "parseTree" [U"'nts", U"'ts"] --> alpha))))),
      ("ptreeToRules2",
       ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
      ("ptreeToRules",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
      ("ptreeSubtree",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
      ("ptreeSubtSyms",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("ptreeNodeSym",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta]))),
      ("ptree2Sym",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta]))),
      ("ptree1_size",
       (((U"'nts" --> T"num" "num" []) -->
         ((U"'ts" --> T"num" "num" []) -->
          (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
           T"num" "num" []))))),
      ("ptheightl",
       ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"num" "num" []))),
      ("ptheight",
       ((T"ptree" "parseTree" [alpha, beta] --> T"num" "num" []))),
      ("mk_ptree",
       ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] -->
         T"ptree" "parseTree" [U"'nts", U"'ts"]))),
      ("leaves",
       ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]))),
      ("isNode",((T"ptree" "parseTree" [alpha, beta] --> bool))),
      ("isLeaf",((T"ptree" "parseTree" [alpha, beta] --> bool))),
      ("getSymbols",
       ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("dest_ptree",
       ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
         T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]))),
      ("cleaves",
       ((T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
         T"list" "list" [alpha]))),
      ("checkRules",
       ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool)))),
      ("Node",
       ((U"'nts" -->
         (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
          T"ptree" "parseTree" [U"'nts", U"'ts"])))),
      ("Leaf",((U"'ts" --> T"ptree" "parseTree" [U"'nts", U"'ts"])))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]) -->
       bool) --> bool)),
   V"rep"
    ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)
      -->
      ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]) -->
       bool))),
   V"a0'" (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   C"!" "bool"
    ((((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)
       --> bool) --> bool)),
   V"'ptree'"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)),
   V"'list @ind_typeparseTree0'"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)
      --> bool)), C"\\/" "bool" ((bool --> (bool --> bool))),
   C"?" "bool" (((U"'ts" --> bool) --> bool)), V"a" (U"'ts"),
   C"=" "min"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] -->
      (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] -->
       bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"prod" "pair" [U"'ts", U"'nts"] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]) -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]])))),
   C"0" "num" (T"num" "num" []),
   C"," "pair"
    ((U"'ts" --> (U"'nts" --> T"prod" "pair" [U"'ts", U"'nts"]))),
   C"ARB" "bool" (U"'nts"), V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   C"?" "bool" (((U"'nts" --> bool) --> bool)), V"a0" (U"'nts"),
   C"?" "bool"
    (((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] --> bool)
      --> bool)),
   V"a1" (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   C"SUC" "num" ((T"num" "num" [] --> T"num" "num" [])),
   C"ARB" "bool" (U"'ts"),
   C"FCONS" "ind_type"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] -->
      ((T"num" "num" [] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]) -->
       (T"num" "num" [] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]])))),
   V"a1'" (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   V"a0" (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   C"!" "bool"
    (((T"ptree" "parseTree" [U"'nts", U"'ts"] --> bool) --> bool)),
   V"a" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   C"=" "min"
    ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
      (T"ptree" "parseTree" [U"'nts", U"'ts"] --> bool))),
   C"mk_ptree" "parseTree"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]] -->
      T"ptree" "parseTree" [U"'nts", U"'ts"])),
   C"dest_ptree" "parseTree"
    ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]])),
   V"r" (T"recspace" "ind_type" [T"prod" "pair" [U"'ts", U"'nts"]]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"!" "bool" ((((U"'ts" --> alpha) --> bool) --> bool)),
   V"f" ((U"'ts" --> alpha)),
   C"!" "bool"
    ((((U"'nts" -->
        (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
         alpha)) --> bool) --> bool)),
   V"f1"
    ((U"'nts" -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       alpha))), C"!" "bool" (((U"'ts" --> bool) --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"ptree_case" "parseTree"
    (((U"'ts" --> alpha) -->
      ((U"'nts" -->
        (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
         alpha)) --> (T"ptree" "parseTree" [U"'nts", U"'ts"] --> alpha)))),
   C"Leaf" "parseTree"
    ((U"'ts" --> T"ptree" "parseTree" [U"'nts", U"'ts"])),
   C"!" "bool" (((U"'nts" --> bool) --> bool)),
   C"!" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> bool)
      --> bool)),
   V"a1" (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]]),
   C"Node" "parseTree"
    ((U"'nts" -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       T"ptree" "parseTree" [U"'nts", U"'ts"]))),
   C"!" "bool" ((((U"'nts" --> T"num" "num" []) --> bool) --> bool)),
   V"f" ((U"'nts" --> T"num" "num" [])),
   C"!" "bool" ((((U"'ts" --> T"num" "num" []) --> bool) --> bool)),
   V"f1" ((U"'ts" --> T"num" "num" [])),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"ptree_size" "parseTree"
    (((U"'nts" --> T"num" "num" []) -->
      ((U"'ts" --> T"num" "num" []) -->
       (T"ptree" "parseTree" [U"'nts", U"'ts"] --> T"num" "num" [])))),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   C"ptree1_size" "parseTree"
    (((U"'nts" --> T"num" "num" []) -->
      ((U"'ts" --> T"num" "num" []) -->
       (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
        T"num" "num" [])))),
   C"NIL" "list" (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]]),
   V"a0" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   C"CONS" "list"
    ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]]))),
   C"=" "min"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      ((T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta]) --> bool))),
   C"ptree2Sym" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (((T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta]) -->
        (T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))),
   C"@" "min"
    ((((T"ptree" "parseTree" [alpha, beta] -->
        (T"ptree" "parseTree" [alpha, beta] --> bool)) --> bool) -->
      (T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)))),
   V"R"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))),
   C"WF" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) --> bool)),
   V"ptree2Sym"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   V"a" (T"ptree" "parseTree" [alpha, beta]),
   C"ptree_case" "parseTree"
    (((beta --> T"symbol" "regexp" [alpha, beta]) -->
      ((alpha -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"symbol" "regexp" [alpha, beta])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))), V"tm" (beta),
   C"I" "combin"
    ((T"symbol" "regexp" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   C"TS" "regexp" ((beta --> T"symbol" "regexp" [alpha, beta])),
   V"nt" (alpha),
   V"ptl" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, beta])),
   C"=" "min"
    (((T"ptree" "parseTree" [alpha, beta] --> bool) -->
      ((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool))),
   C"isNode" "parseTree" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (((T"ptree" "parseTree" [alpha, beta] --> bool) -->
        (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)))),
   V"isNode" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"ptree_case" "parseTree"
    (((beta --> bool) -->
      ((alpha -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)))), V"v2" (beta),
   C"I" "combin" ((bool --> bool)), C"F" "bool" (bool), V"v0" (alpha),
   V"v1" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"T" "bool" (bool),
   C"isLeaf" "parseTree" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   V"isLeaf" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"!" "bool" (((beta --> bool) --> bool)), V"tmnl" (beta),
   C"ptsize" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] --> T"num" "num" [])),
   C"Leaf" "parseTree" ((beta --> T"ptree" "parseTree" [alpha, beta])),
   C"!" "bool" (((alpha --> bool) --> bool)),
   C"!" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool) -->
      bool)),
   V"ptlist" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"Node" "parseTree"
    ((alpha -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"ptree" "parseTree" [alpha, beta]))),
   C"ptsizel" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"num" "num" [])),
   C"NIL" "list" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"!" "bool" (((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool)),
   V"h" (T"ptree" "parseTree" [alpha, beta]),
   V"t" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"CONS" "list"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
   C"ptheight" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] --> T"num" "num" [])),
   C"ptheightl" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"num" "num" [])),
   C"=" "min"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]) --> bool))),
   C"getSymbols" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"WFREC" "relation"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
      (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   C"@" "min"
    ((((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
       bool) -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)))),
   V"R"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool))),
   C"WF" "relation"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
      bool)),
   V"getSymbols"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"a" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"list_case" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      ((T"ptree" "parseTree" [alpha, beta] -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   C"I" "combin"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"v" (T"ptree" "parseTree" [alpha, beta]),
   C"ptree_case" "parseTree"
    (((beta --> T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      ((alpha -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   C"CONS" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"=" "min"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"ptreeToRules" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   C"NIL" "list" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   C"CONS" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"rule" "grammarDef"
    ((alpha -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   C"ptreeToRules2" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   C"APPEND" "list"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"rls" (T"list" "list" [alpha]),
   C"checkRules" "parseTree"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"NIL" "list" (T"list" "list" [alpha]), V"h" (alpha),
   V"t" (T"list" "list" [alpha]),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"ptreeNodeSym" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   V"ptreeNodeSym"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   V"tl" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"=" "min"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      ((T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]) --> bool))),
   C"ptreeSubtSyms" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (((T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
        (T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"symbol" "regexp" [alpha, beta]])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"symbol" "regexp" [alpha, beta]])))),
   V"ptreeSubtSyms"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"MAP" "list"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"=" "min"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]) -->
      ((T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"ptree" "parseTree" [alpha, beta]]) --> bool))),
   C"ptreeSubtree" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"list" "list" [T"ptree" "parseTree" [alpha, beta]])),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (((T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"ptree" "parseTree" [alpha, beta]]) -->
        (T"ptree" "parseTree" [alpha, beta] -->
         T"list" "list" [T"ptree" "parseTree" [alpha, beta]])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"ptree" "parseTree" [alpha, beta]])))),
   V"ptreeSubtree"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"list" "list" [T"ptree" "parseTree" [alpha, beta]])),
   C"ptree_case" "parseTree"
    (((beta --> T"list" "list" [T"ptree" "parseTree" [alpha, beta]]) -->
      ((alpha -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"list" "list" [T"ptree" "parseTree" [alpha, beta]])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"list" "list" [T"ptree" "parseTree" [alpha, beta]])))),
   C"I" "combin"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"ptree" "parseTree" [alpha, beta]])), V"x" (alpha),
   V"l" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"=" "min"
    (((T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] --> bool) -->
      ((T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] --> bool) --> bool))),
   C"validptree_defn_tupled" "parseTree"
    ((T"prod" "pair"
       [T"grammar" "grammarDef" [alpha, beta],
        T"ptree" "parseTree" [alpha, beta]] --> bool)),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] -->
       (T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
      (((T"prod" "pair"
          [T"grammar" "grammarDef" [alpha, beta],
           T"ptree" "parseTree" [alpha, beta]] --> bool) -->
        (T"prod" "pair"
          [T"grammar" "grammarDef" [alpha, beta],
           T"ptree" "parseTree" [alpha, beta]] --> bool)) -->
       (T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] --> bool)))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] -->
        (T"prod" "pair"
          [T"grammar" "grammarDef" [alpha, beta],
           T"ptree" "parseTree" [alpha, beta]] --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] -->
       (T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"grammar" "grammarDef" [alpha, beta],
        T"ptree" "parseTree" [alpha, beta]] -->
      (T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] -->
       (T"prod" "pair"
         [T"grammar" "grammarDef" [alpha, beta],
          T"ptree" "parseTree" [alpha, beta]] --> bool)) --> bool)),
   V"n" (alpha),
   C"!" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"g" (T"grammar" "grammarDef" [alpha, beta]),
   V"e" (T"ptree" "parseTree" [alpha, beta]),
   C"MEM" "list"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool))),
   C"," "pair"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] -->
       T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]]))),
   V"validptree_defn_tupled"
    ((T"prod" "pair"
       [T"grammar" "grammarDef" [alpha, beta],
        T"ptree" "parseTree" [alpha, beta]] --> bool)),
   V"a"
    (T"prod" "pair"
      [T"grammar" "grammarDef" [alpha, beta],
       T"ptree" "parseTree" [alpha, beta]]),
   C"pair_case" "pair"
    (((T"grammar" "grammarDef" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (T"prod" "pair"
        [T"grammar" "grammarDef" [alpha, beta],
         T"ptree" "parseTree" [alpha, beta]] --> bool))),
   V"v1" (T"ptree" "parseTree" [alpha, beta]),
   C"MEM" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   V"x" (T"grammar" "grammarDef" [alpha, beta]),
   V"x1" (T"ptree" "parseTree" [alpha, beta]),
   C"validptree" "parseTree"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))), V"tm" (alpha),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"leaves" "parseTree"
    ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])),
   C"Leaf" "parseTree" ((alpha --> T"ptree" "parseTree" [beta, alpha])),
   V"nt" (beta),
   C"!" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [beta, alpha]] --> bool) -->
      bool)),
   V"ptlist" (T"list" "list" [T"ptree" "parseTree" [beta, alpha]]),
   C"Node" "parseTree"
    ((beta -->
      (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
       T"ptree" "parseTree" [beta, alpha]))),
   C"cleaves" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
      T"list" "list" [alpha])),
   C"NIL" "list" (T"list" "list" [T"ptree" "parseTree" [beta, alpha]]),
   C"!" "bool" (((T"ptree" "parseTree" [beta, alpha] --> bool) --> bool)),
   V"h" (T"ptree" "parseTree" [beta, alpha]),
   V"t" (T"list" "list" [T"ptree" "parseTree" [beta, alpha]]),
   C"CONS" "list"
    ((T"ptree" "parseTree" [beta, alpha] -->
      (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
       T"list" "list" [T"ptree" "parseTree" [beta, alpha]]))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"DATATYPE" "bool" ((bool --> bool)),
   V"ptree"
    (((U"'ts" --> T"ptree" "parseTree" [U"'nts", U"'ts"]) -->
      ((U"'nts" -->
        (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
         T"ptree" "parseTree" [U"'nts", U"'ts"])) --> bool))),
   V"a'" (U"'ts"), C"=" "min" ((U"'ts" --> (U"'ts" --> bool))),
   V"a0'" (U"'nts"),
   V"a1'" (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]]),
   C"=" "min" ((U"'nts" --> (U"'nts" --> bool))),
   C"=" "min"
    ((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> bool))),
   C"~" "bool" ((bool --> bool)),
   V"M" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   V"M'" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   V"f'" ((U"'ts" --> alpha)),
   V"f1'"
    ((U"'nts" -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       alpha))), V"pp" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   V"t" (U"'ts"), V"n" (U"'nts"),
   C"?" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> bool)
      --> bool)),
   V"l" (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]]),
   V"f0" ((U"'ts" --> alpha)),
   C"!" "bool"
    ((((U"'nts" -->
        (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
         (beta --> alpha))) --> bool) --> bool)),
   V"f1"
    ((U"'nts" -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       (beta --> alpha)))), V"f2" (beta),
   C"!" "bool"
    ((((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
        (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
         (alpha --> (beta --> beta)))) --> bool) --> bool)),
   V"f3"
    ((T"ptree" "parseTree" [U"'nts", U"'ts"] -->
      (T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] -->
       (alpha --> (beta --> beta))))),
   C"?" "bool"
    ((((T"ptree" "parseTree" [U"'nts", U"'ts"] --> alpha) --> bool) -->
      bool)), V"fn0" ((T"ptree" "parseTree" [U"'nts", U"'ts"] --> alpha)),
   C"?" "bool"
    ((((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> beta)
       --> bool) --> bool)),
   V"fn1"
    ((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> beta)),
   C"=" "min" ((beta --> (beta --> bool))),
   C"!" "bool"
    ((((T"ptree" "parseTree" [U"'nts", U"'ts"] --> bool) --> bool) -->
      bool)), V"P0" ((T"ptree" "parseTree" [U"'nts", U"'ts"] --> bool)),
   C"!" "bool"
    ((((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> bool)
       --> bool) --> bool)),
   V"P1"
    ((T"list" "list" [T"ptree" "parseTree" [U"'nts", U"'ts"]] --> bool)),
   V"p" (T"ptree" "parseTree" [U"'nts", U"'ts"]),
   C"!" "bool"
    ((((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool) --> bool)),
   V"P" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
   V"l1" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   V"l2" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"!" "bool"
    ((((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool) -->
       bool) --> bool)),
   V"P" ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool)),
   V"v" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"=" "min"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool))),
   C"!" "bool"
    ((((T"grammar" "grammarDef" [alpha, beta] -->
        (T"ptree" "parseTree" [alpha, beta] --> bool)) --> bool) -->
      bool)),
   V"P"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))),
   V"v" (T"grammar" "grammarDef" [alpha, beta]),
   C"=" "min"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   C"leaves" "parseTree"
    ((T"ptree" "parseTree" [alpha, beta] --> T"list" "list" [beta])),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [beta]] --> T"list" "list" [beta])),
   C"MAP" "list"
    (((T"ptree" "parseTree" [alpha, beta] --> T"list" "list" [beta]) -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"list" "list" [beta]]))),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"MAP" "list"
    (((T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list"
        [T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"o" "combin"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      ((T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]] -->
        T"ptree" "parseTree" [alpha, beta]) -->
       (T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]] -->
        T"symbol" "regexp" [alpha, beta])))),
   C"SND" "pair"
    ((T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]] -->
      T"ptree" "parseTree" [alpha, beta])),
   V"p"
    (T"list" "list"
      [T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]]]),
   C"MAP" "list"
    (((T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]] -->
       T"ptree" "parseTree" [alpha, beta]) -->
      (T"list" "list"
        [T"prod" "pair" [gamma, T"ptree" "parseTree" [alpha, beta]]] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
   C"LENGTH" "list"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"num" "num" [])),
   C"LENGTH" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"num" "num" [])),
   C"!" "bool" (((T"num" "num" [] --> bool) --> bool)),
   C">=" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"take1" "listLemmas"
    ((T"num" "num" [] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"take1" "listLemmas"
    ((T"num" "num" [] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair" [alpha, T"ptree" "parseTree" [beta, gamma]]] -->
       bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair" [alpha, T"ptree" "parseTree" [beta, gamma]]]),
   C"=" "min"
    ((T"option" "option"
       [T"list" "list" [T"ptree" "parseTree" [beta, gamma]]] -->
      (T"option" "option"
        [T"list" "list" [T"ptree" "parseTree" [beta, gamma]]] --> bool))),
   C"take" "listLemmas"
    ((T"num" "num" [] -->
      (T"list" "list" [T"ptree" "parseTree" [beta, gamma]] -->
       T"option" "option"
        [T"list" "list" [T"ptree" "parseTree" [beta, gamma]]]))),
   C"MAP" "list"
    (((T"prod" "pair" [alpha, T"ptree" "parseTree" [beta, gamma]] -->
       T"ptree" "parseTree" [beta, gamma]) -->
      (T"list" "list"
        [T"prod" "pair" [alpha, T"ptree" "parseTree" [beta, gamma]]] -->
       T"list" "list" [T"ptree" "parseTree" [beta, gamma]]))),
   C"SND" "pair"
    ((T"prod" "pair" [alpha, T"ptree" "parseTree" [beta, gamma]] -->
      T"ptree" "parseTree" [beta, gamma])),
   C"SOME" "option"
    ((T"list" "list" [T"ptree" "parseTree" [beta, gamma]] -->
      T"option" "option"
       [T"list" "list" [T"ptree" "parseTree" [beta, gamma]]])),
   V"x" (T"list" "list" [T"ptree" "parseTree" [beta, gamma]]),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool))),
   C"THE" "option"
    ((T"option" "option"
       [T"list" "list" [T"symbol" "regexp" [beta, gamma]]] -->
      T"list" "list" [T"symbol" "regexp" [beta, gamma]])),
   C"take" "listLemmas"
    ((T"num" "num" [] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       T"option" "option"
        [T"list" "list" [T"symbol" "regexp" [beta, gamma]]]))),
   C"getSymbols" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [beta, gamma]] -->
      T"list" "list" [T"symbol" "regexp" [beta, gamma]])),
   C"THE" "option"
    ((T"option" "option"
       [T"list" "list" [T"ptree" "parseTree" [beta, gamma]]] -->
      T"list" "list" [T"ptree" "parseTree" [beta, gamma]])),
   V"l1" (T"list" "list" [alpha]), V"l2" (T"list" "list" [alpha]),
   V"rs" (T"list" "list" [alpha]),
   C"REVERSE" "list"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"ptree" "parseTree" [alpha, beta]])),
   V"x" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"REVERSE" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]]))]
  val DT = Thm.disk_thm share_table
  in
  val ptree_TY_DEF =
    DT(["DISK_THM"], [],
       `(%0 (\%1. ((%2 (\%3. (%4 (\%5. (%4 (\%6. ((%7 ((%8 (%9 (\%3. ((%7
       ((%10 (%11 (\%12. ((%13 $1) ((\%12. (((%14 %15) ((%16 $0) %17))
       (\%18. %19))) $0))))) (%20 (\%21. (%22 (\%23. ((%8 ((%13 $2)
       (((\%21. (\%23. (((%14 (%24 %15)) ((%16 %25) $1)) ((%26 $0) (\%18.
       %19))))) $1) $0))) ($3 $0)))))))) ($2 $0))))) (%9 (\%27. ((%7 ((%10
       ((%13 $0) (((%14 (%24 (%24 %15))) ((%16 %25) %17)) (\%18. %19))))
       (%22 (\%28. (%22 (\%23. ((%8 ((%13 $2) (((\%28. (\%23. (((%14 (%24
       (%24 (%24 %15)))) ((%16 %25) %17)) ((%26 $1) ((%26 $0) (\%18.
       %19)))))) $1) $0))) ((%8 ($4 $1)) ($3 $0))))))))) ($1 $0)))))) ($1
       $2)))))))) $0)))`)
  val ptree_repfns =
    DT(["DISK_THM"], [],
       `((%8 (%29 (\%30. ((%31 (%32 (%33 $0))) $0)))) (%9 (\%34. ((%35
       ((\%3. (%4 (\%5. (%4 (\%6. ((%7 ((%8 (%9 (\%3. ((%7 ((%10 (%11
       (\%12. ((%13 $1) ((\%12. (((%14 %15) ((%16 $0) %17)) (\%18. %19)))
       $0))))) (%20 (\%21. (%22 (\%23. ((%8 ((%13 $2) (((\%21. (\%23.
       (((%14 (%24 %15)) ((%16 %25) $1)) ((%26 $0) (\%18. %19))))) $1)
       $0))) ($3 $0)))))))) ($2 $0))))) (%9 (\%27. ((%7 ((%10 ((%13 $0)
       (((%14 (%24 (%24 %15))) ((%16 %25) %17)) (\%18. %19)))) (%22 (\%28.
       (%22 (\%23. ((%8 ((%13 $2) (((\%28. (\%23. (((%14 (%24 (%24 (%24
       %15)))) ((%16 %25) %17)) ((%26 $1) ((%26 $0) (\%18. %19)))))) $1)
       $0))) ((%8 ($4 $1)) ($3 $0))))))))) ($1 $0)))))) ($1 $2))))))) $0))
       ((%13 (%33 (%32 $0))) $0)))))`)
  val ptree_case_def =
    DT(["DISK_THM"], [],
       `((%8 (%36 (\%37. (%38 (\%39. (%40 (\%12. ((%41 (((%42 $2) $1) (%43
       $0))) ($2 $0))))))))) (%36 (\%37. (%38 (\%39. (%44 (\%21. (%45
       (\%46. ((%41 (((%42 $3) $2) ((%47 $1) $0))) (($2 $1) $0)))))))))))`)
  val ptree_size_def =
    DT(["DISK_THM"], [],
       `((%8 (%48 (\%49. (%50 (\%51. (%40 (\%12. ((%52 (((%53 $2) $1) (%43
       $0))) ((%54 (%55 (%56 %57))) ($1 $0)))))))))) ((%8 (%48 (\%49. (%50
       (\%51. (%44 (\%21. (%45 (\%46. ((%52 (((%53 $3) $2) ((%47 $1) $0)))
       ((%54 (%55 (%56 %57))) ((%54 ($3 $1)) (((%58 $3) $2) $0)))))))))))))
       ((%8 (%48 (\%49. (%50 (\%51. ((%52 (((%58 $1) $0) %59)) %15))))))
       (%48 (\%49. (%50 (\%51. (%29 (\%60. (%45 (\%46. ((%52 (((%58 $3) $2)
       ((%61 $1) $0))) ((%54 (%55 (%56 %57))) ((%54 (((%53 $3) $2) $1))
       (((%58 $3) $2) $0)))))))))))))))`)
  val ptree2Sym_primitive_def =
    DT([], [],
       `((%62 %63) ((%64 (%65 (\%66. (%67 $0)))) (\%68. (\%69. (((%70
       (\%71. (%72 (%73 $0)))) (\%74. (\%75. (%72 (%76 $1))))) $0)))))`)
  val isNode_primitive_def =
    DT([], [],
       `((%77 %78) ((%79 (%65 (\%66. (%67 $0)))) (\%80. (\%69. (((%81
       (\%82. (%83 %84))) (\%85. (\%86. (%83 %87)))) $0)))))`)
  val isLeaf_primitive_def =
    DT([], [],
       `((%77 %88) ((%79 (%65 (\%66. (%67 $0)))) (\%89. (\%69. (((%81
       (\%82. (%83 %87))) (\%85. (\%86. (%83 %84)))) $0)))))`)
  val ptsize_def =
    DT(["DISK_THM"], [],
       `((%8 (%90 (\%91. ((%52 (%92 (%93 $0))) (%55 (%56 %57)))))) ((%8
       (%94 (\%74. (%95 (\%96. ((%52 (%92 ((%97 $1) $0))) ((%54 (%55 (%56
       %57))) (%98 $0)))))))) ((%8 ((%52 (%98 %99)) %15)) (%100 (\%101.
       (%95 (\%102. ((%52 (%98 ((%103 $1) $0))) ((%54 (%92 $1)) (%98
       $0))))))))))`)
  val ptheight_def =
    DT(["DISK_THM"], [],
       `((%8 (%90 (\%91. ((%52 (%104 (%93 $0))) %15)))) ((%8 (%94 (\%74.
       (%95 (\%96. ((%52 (%104 ((%97 $1) $0))) ((%54 (%55 (%56 %57))) (%105
       $0)))))))) ((%8 ((%52 (%105 %99)) %15)) (%100 (\%101. (%95 (\%102.
       ((%52 (%105 ((%103 $1) $0))) ((%54 (%104 $1)) (%105 $0))))))))))`)
  val getSymbols_primitive_def =
    DT([], [],
       `((%106 %107) ((%108 (%109 (\%110. ((%8 (%111 $0)) ((%8 (%90 (\%91.
       (%95 (\%102. (($2 $0) ((%103 (%93 $1)) $0))))))) (%95 (\%96. (%94
       (\%74. (%95 (\%102. (($3 $0) ((%103 ((%97 $1) $2)) $0)))))))))))))
       (\%112. (\%113. (((%114 (%115 %116)) (\%117. (\%102. (((%118 (\%91.
       (%115 ((%119 (%73 $0)) ($4 $1))))) (\%74. (\%96. (%115 ((%119 (%76
       $1)) ($5 $2)))))) $1)))) $0)))))`)
  val ptreeToRules_def =
    DT(["DISK_THM"], [],
       `((%8 (%90 (\%71. ((%120 (%121 (%93 $0))) %122)))) ((%8 (%94 (\%74.
       (%95 (\%75. ((%120 (%121 ((%97 $1) $0))) ((%123 ((%124 $1) (%107
       $0))) (%125 $0)))))))) ((%8 ((%120 (%125 %99)) %122)) (%100 (\%101.
       (%95 (\%102. ((%120 (%125 ((%103 $1) $0))) ((%126 (%121 $1)) (%125
       $0))))))))))`)
  val checkRules_def =
    DT(["DISK_THM"], [],
       `((%8 (%127 (\%128. ((%35 ((%129 %130) $0)) %87)))) (%94 (\%131.
       (%127 (\%132. (%127 (\%128. ((%35 ((%129 ((%133 $2) $1)) $0)) ((%8
       ((%134 $2) $0)) ((%129 $1) $0))))))))))`)
  val ptreeNodeSym_primitive_def =
    DT([], [],
       `((%62 %135) ((%64 (%65 (\%66. (%67 $0)))) (\%136. (\%69. (((%70
       (\%71. (%72 (%73 $0)))) (\%74. (\%137. (%72 (%76 $1))))) $0)))))`)
  val ptreeSubtSyms_primitive_def =
    DT([], [],
       `((%138 %139) ((%140 (%65 (\%66. (%67 $0)))) (\%141. (\%69. (((%118
       (\%71. (%115 %116))) (\%74. (\%137. (%115 ((%142 %135) $0)))))
       $0)))))`)
  val ptreeSubtree_primitive_def =
    DT([], [],
       `((%143 %144) ((%145 (%65 (\%66. (%67 $0)))) (\%146. (\%69. (((%147
       (\%71. (%148 %99))) (\%149. (\%150. (%148 $0)))) $0)))))`)
  val validptree_defn_tupled_primitive_def =
    DT([], [],
       `((%151 %152) ((%153 (%154 (\%155. ((%8 (%156 $0)) (%94 (\%157.
       (%158 (\%159. (%95 (\%75. (%100 (\%160. ((%7 ((%8 ((%161 $0) $1))
       (%78 $0))) (($4 ((%162 $2) $0)) ((%162 $2) ((%97 $3)
       $1)))))))))))))))) (\%163. (\%164. ((%165 (\%159. (\%166. (((%81
       (\%71. (%83 %84))) (\%157. (\%75. (%83 ((%8 ((%167 ((%124 $1) (%107
       $0))) (%168 $3))) (%100 (\%160. ((%7 ((%161 $0) $1)) ((%7 (%78 $0))
       ($6 ((%162 $4) $0))))))))))) $0)))) $0)))))`)
  val validptree_defn_curried_def =
    DT([], [],
       `(%158 (\%169. (%100 (\%170. ((%35 ((%171 $1) $0)) (%152 ((%162 $1)
       $0)))))))`)
  val leaves_def =
    DT(["DISK_THM"], [],
       `((%8 (%94 (\%172. ((%173 (%174 (%175 $0))) ((%133 $0) %130)))))
       ((%8 (%90 (\%176. (%177 (\%178. ((%173 (%174 ((%179 $1) $0))) (%180
       $0))))))) ((%8 ((%173 (%180 %181)) %130)) (%182 (\%183. (%177
       (\%184. ((%173 (%180 ((%185 $1) $0))) ((%186 (%174 $1)) (%180
       $0))))))))))`)
  val datatype_ptree = DT(["DISK_THM"], [], `(%187 ((%188 %43) %47))`)
  val ptree_11 =
    DT(["DISK_THM"], [],
       `((%8 (%40 (\%12. (%40 (\%189. ((%35 ((%31 (%43 $1)) (%43 $0)))
       ((%190 $1) $0))))))) (%44 (\%21. (%45 (\%46. (%44 (\%191. (%45
       (\%192. ((%35 ((%31 ((%47 $3) $2)) ((%47 $1) $0))) ((%8 ((%193 $3)
       $1)) ((%194 $2) $0))))))))))))`)
  val ptree_distinct =
    DT(["DISK_THM"], [],
       `(%45 (\%46. (%44 (\%21. (%40 (\%12. (%195 ((%31 (%43 $0)) ((%47 $1)
       $2)))))))))`)
  val ptree_case_cong =
    DT(["DISK_THM"], [],
       `(%29 (\%196. (%29 (\%197. (%36 (\%37. (%38 (\%39. ((%7 ((%8 ((%31
       $3) $2)) ((%8 (%40 (\%12. ((%7 ((%31 $3) (%43 $0))) ((%41 ($2 $0))
       (%198 $0)))))) (%44 (\%21. (%45 (\%46. ((%7 ((%31 $4) ((%47 $1)
       $0))) ((%41 (($2 $1) $0)) ((%199 $1) $0)))))))))) ((%41 (((%42 $1)
       $0) $3)) (((%42 %198) %199) $2)))))))))))`)
  val ptree_nchotomy =
    DT(["DISK_THM"], [],
       `(%29 (\%200. ((%10 (%11 (\%201. ((%31 $1) (%43 $0))))) (%20 (\%202.
       (%203 (\%204. ((%31 $2) ((%47 $1) $0)))))))))`)
  val ptree_Axiom =
    DT(["DISK_THM"], [],
       `(%36 (\%205. (%206 (\%207. (%90 (\%208. (%209 (\%210. (%211 (\%212.
       (%213 (\%214. ((%8 (%40 (\%12. ((%41 ($2 (%43 $0))) ($6 $0))))) ((%8
       (%44 (\%21. (%45 (\%46. ((%41 ($3 ((%47 $1) $0))) ((($6 $1) $0) ($2
       $0)))))))) ((%8 ((%215 ($0 %59)) $3)) (%29 (\%60. (%45 (\%46. ((%215
       ($2 ((%61 $1) $0))) (((($4 $1) $0) ($3 $1)) ($2
       $0))))))))))))))))))))))`)
  val ptree_induction =
    DT(["DISK_THM"], [],
       `(%216 (\%217. (%218 (\%219. ((%7 ((%8 (%40 (\%201. ($2 (%43 $0)))))
       ((%8 (%45 (\%204. ((%7 ($1 $0)) (%44 (\%202. ($3 ((%47 $0)
       $1)))))))) ((%8 ($0 %59)) (%29 (\%220. (%45 (\%204. ((%7 ((%8 ($3
       $1)) ($2 $0))) ($2 ((%61 $1) $0))))))))))) ((%8 (%29 (\%220. ($2
       $0)))) (%45 (\%204. ($1 $0)))))))))`)
  val ptree2Sym_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%74. (%95 (\%75. ($2 ((%97 $1)
       $0))))))) (%90 (\%71. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val ptree2Sym_def =
    DT(["DISK_THM"], [],
       `((%8 ((%223 (%63 ((%97 %74) %75))) (%76 %74))) ((%223 (%63 (%93
       %71))) (%73 %71)))`)
  val isNode_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%85. (%95 (\%86. ($2 ((%97 $1)
       $0))))))) (%90 (\%82. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val isNode_def =
    DT(["DISK_THM"], [],
       `((%8 ((%35 (%78 ((%97 %85) %86))) %87)) ((%35 (%78 (%93 %82)))
       %84))`)
  val isLeaf_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%85. (%95 (\%86. ($2 ((%97 $1)
       $0))))))) (%90 (\%82. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val isLeaf_def =
    DT(["DISK_THM"], [],
       `((%8 ((%35 (%88 ((%97 %85) %86))) %84)) ((%35 (%88 (%93 %82)))
       %87))`)
  val ptsizel_append =
    DT(["DISK_THM"], [],
       `((%52 (%98 ((%224 %225) %226))) ((%54 (%98 %225)) (%98 %226)))`)
  val getSymbols_ind =
    DT(["DISK_THM"], [],
       `(%227 (\%228. ((%7 ((%8 ($0 %99)) ((%8 (%90 (\%91. (%95 (\%102.
       ((%7 ($2 $0)) ($2 ((%103 (%93 $1)) $0)))))))) (%94 (\%74. (%95
       (\%96. (%95 (\%102. ((%7 ($3 $0)) ($3 ((%103 ((%97 $2) $1))
       $0)))))))))))) (%95 (\%229. ($1 $0))))))`)
  val getSymbols_def =
    DT(["DISK_THM"], [],
       `((%8 ((%230 (%107 %99)) %116)) ((%8 (%90 (\%91. (%95 (\%102. ((%230
       (%107 ((%103 (%93 $1)) $0))) ((%119 (%73 $1)) (%107 $0)))))))) (%95
       (\%102. (%95 (\%96. (%94 (\%74. ((%230 (%107 ((%103 ((%97 $0) $1))
       $2))) ((%119 (%76 $0)) (%107 $2)))))))))))`)
  val ptreeNodeSym_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%74. (%95 (\%137. ($2 ((%97 $1)
       $0))))))) (%90 (\%71. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val ptreeNodeSym_def =
    DT(["DISK_THM"], [],
       `((%8 ((%223 (%135 ((%97 %74) %137))) (%76 %74))) ((%223 (%135 (%93
       %71))) (%73 %71)))`)
  val ptreeSubtSyms_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%74. (%95 (\%137. ($2 ((%97 $1)
       $0))))))) (%90 (\%71. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val ptreeSubtSyms_def =
    DT(["DISK_THM"], [],
       `((%8 ((%230 (%139 ((%97 %74) %137))) ((%142 %135) %137))) ((%230
       (%139 (%93 %71))) %116))`)
  val ptreeSubtree_ind =
    DT(["DISK_THM"], [],
       `(%221 (\%222. ((%7 ((%8 (%94 (\%149. (%95 (\%150. ($2 ((%97 $1)
       $0))))))) (%90 (\%71. ($1 (%93 $0)))))) (%100 (\%117. ($1 $0))))))`)
  val ptreeSubtree_def =
    DT(["DISK_THM"], [],
       `((%8 ((%231 (%144 ((%97 %149) %150))) %150)) ((%231 (%144 (%93
       %71))) %99))`)
  val validptree =
    DT(["DISK_THM"], [],
       `((%8 ((%35 ((%171 %159) ((%97 %157) %75))) ((%8 ((%167 ((%124 %157)
       (%107 %75))) (%168 %159))) (%100 (\%160. ((%7 ((%161 $0) %75)) ((%7
       (%78 $0)) ((%171 %159) $0)))))))) ((%35 ((%171 %159) (%93 %71)))
       %84))`)
  val validptree_ind =
    DT(["DISK_THM"], [],
       `(%232 (\%233. ((%7 ((%8 (%158 (\%159. (%94 (\%157. (%95 (\%75. ((%7
       (%100 (\%160. ((%7 ((%8 ((%161 $0) $1)) (%78 $0))) (($4 $3) $0)))))
       (($3 $2) ((%97 $1) $0)))))))))) (%158 (\%159. (%90 (\%71. (($2 $1)
       (%93 $0)))))))) (%158 (\%234. (%100 (\%166. (($2 $1) $0))))))))`)
  val flat_leaves =
    DT(["DISK_THM"], [],
       `(%95 (\%150. ((%235 (%236 ((%97 %157) $0))) (%237 ((%238 %236)
       $0)))))`)
  val getSyms_append =
    DT(["DISK_THM"], [],
       `((%230 (%107 ((%224 %225) %226))) ((%239 (%107 %225)) (%107
       %226)))`)
  val getSymsEqptree2Sym =
    DT(["DISK_THM"], [], `((%230 (%107 %150)) ((%142 %63) %150))`)
  val mapSymsptree =
    DT(["DISK_THM"], [],
       `((%230 ((%240 ((%241 %63) %242)) %243)) (%107 ((%244 %242)
       %243)))`)
  val getSyms_len =
    DT(["DISK_THM"], [],
       `(%95 (\%150. ((%52 (%245 $0)) (%246 (%107 $0)))))`)
  val take1_getSyms =
    DT(["DISK_THM"], [],
       `(%95 (\%150. (%247 (\%18. ((%7 ((%248 (%245 $1)) $0)) ((%230 ((%249
       $0) (%107 $1))) (%107 ((%250 $0) $1))))))))`)
  val take_getSyms =
    DT(["DISK_THM"], [],
       `(%247 (\%18. (%251 (\%252. ((%7 ((%253 ((%254 $1) ((%255 %256)
       $0))) (%257 %258))) ((%259 (%260 ((%261 $1) (%262 ((%255 %256)
       $0))))) (%262 (%263 ((%254 $1) ((%255 %256) $0))))))))))`)
  val checkRules_append =
    DT(["DISK_THM"], [],
       `((%35 ((%129 ((%186 %264) %265)) %266)) ((%8 ((%129 %264) %266))
       ((%129 %265) %266)))`)
  val ptreeToRules_append =
    DT(["DISK_THM"], [],
       `((%120 (%125 ((%224 %225) %226))) ((%126 (%125 %225)) (%125
       %226)))`)
  val getSyms_nil =
    DT(["DISK_THM"], [],
       `((%7 ((%230 (%107 %150)) %116)) ((%231 %150) %99))`)
  val getSyms_rev =
    DT(["DISK_THM"], [], `((%230 (%107 (%267 %268))) (%269 (%107 %268)))`)
  end
  val _ = DB.bindl "parseTree"
  [("ptree_TY_DEF",ptree_TY_DEF,DB.Def),
   ("ptree_repfns",ptree_repfns,DB.Def),
   ("ptree_case_def",ptree_case_def,DB.Def),
   ("ptree_size_def",ptree_size_def,DB.Def),
   ("ptree2Sym_primitive_def",ptree2Sym_primitive_def,DB.Def),
   ("isNode_primitive_def",isNode_primitive_def,DB.Def),
   ("isLeaf_primitive_def",isLeaf_primitive_def,DB.Def),
   ("ptsize_def",ptsize_def,DB.Def), ("ptheight_def",ptheight_def,DB.Def),
   ("getSymbols_primitive_def",getSymbols_primitive_def,DB.Def),
   ("ptreeToRules_def",ptreeToRules_def,DB.Def),
   ("checkRules_def",checkRules_def,DB.Def),
   ("ptreeNodeSym_primitive_def",ptreeNodeSym_primitive_def,DB.Def),
   ("ptreeSubtSyms_primitive_def",ptreeSubtSyms_primitive_def,DB.Def),
   ("ptreeSubtree_primitive_def",ptreeSubtree_primitive_def,DB.Def),
   ("validptree_defn_tupled_primitive_def",
    validptree_defn_tupled_primitive_def,
    DB.Def),
   ("validptree_defn_curried_def",validptree_defn_curried_def,DB.Def),
   ("leaves_def",leaves_def,DB.Def),
   ("datatype_ptree",datatype_ptree,DB.Thm), ("ptree_11",ptree_11,DB.Thm),
   ("ptree_distinct",ptree_distinct,DB.Thm),
   ("ptree_case_cong",ptree_case_cong,DB.Thm),
   ("ptree_nchotomy",ptree_nchotomy,DB.Thm),
   ("ptree_Axiom",ptree_Axiom,DB.Thm),
   ("ptree_induction",ptree_induction,DB.Thm),
   ("ptree2Sym_ind",ptree2Sym_ind,DB.Thm),
   ("ptree2Sym_def",ptree2Sym_def,DB.Thm),
   ("isNode_ind",isNode_ind,DB.Thm), ("isNode_def",isNode_def,DB.Thm),
   ("isLeaf_ind",isLeaf_ind,DB.Thm), ("isLeaf_def",isLeaf_def,DB.Thm),
   ("ptsizel_append",ptsizel_append,DB.Thm),
   ("getSymbols_ind",getSymbols_ind,DB.Thm),
   ("getSymbols_def",getSymbols_def,DB.Thm),
   ("ptreeNodeSym_ind",ptreeNodeSym_ind,DB.Thm),
   ("ptreeNodeSym_def",ptreeNodeSym_def,DB.Thm),
   ("ptreeSubtSyms_ind",ptreeSubtSyms_ind,DB.Thm),
   ("ptreeSubtSyms_def",ptreeSubtSyms_def,DB.Thm),
   ("ptreeSubtree_ind",ptreeSubtree_ind,DB.Thm),
   ("ptreeSubtree_def",ptreeSubtree_def,DB.Thm),
   ("validptree",validptree,DB.Thm),
   ("validptree_ind",validptree_ind,DB.Thm),
   ("flat_leaves",flat_leaves,DB.Thm),
   ("getSyms_append",getSyms_append,DB.Thm),
   ("getSymsEqptree2Sym",getSymsEqptree2Sym,DB.Thm),
   ("mapSymsptree",mapSymsptree,DB.Thm),
   ("getSyms_len",getSyms_len,DB.Thm),
   ("take1_getSyms",take1_getSyms,DB.Thm),
   ("take_getSyms",take_getSyms,DB.Thm),
   ("checkRules_append",checkRules_append,DB.Thm),
   ("ptreeToRules_append",ptreeToRules_append,DB.Thm),
   ("getSyms_nil",getSyms_nil,DB.Thm), ("getSyms_rev",getSyms_rev,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("grammarDefTheory.grammarDef_grammars",
                          grammarDefTheory.grammarDef_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "ptree"
  val _ = update_grms
       temp_overload_on
       ("dest_ptree", (Term.prim_mk_const { Name = "dest_ptree", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("mk_ptree", (Term.prim_mk_const { Name = "mk_ptree", Thy = "parseTree"}))
  val _ = update_grms temp_add_type "list @ind_typeparseTree0"
  
  
  
  
  
  
  
  val _ = update_grms
       temp_overload_on
       ("Leaf", (Term.prim_mk_const { Name = "Leaf", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("Node", (Term.prim_mk_const { Name = "Node", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptree_case", (Term.prim_mk_const { Name = "ptree_case", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptree_size", (Term.prim_mk_const { Name = "ptree_size", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptree1_size", (Term.prim_mk_const { Name = "ptree1_size", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptree2Sym", (Term.prim_mk_const { Name = "ptree2Sym", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("isNode", (Term.prim_mk_const { Name = "isNode", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("isLeaf", (Term.prim_mk_const { Name = "isLeaf", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptsize", (Term.prim_mk_const { Name = "ptsize", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptsizel", (Term.prim_mk_const { Name = "ptsizel", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptheight", (Term.prim_mk_const { Name = "ptheight", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptheightl", (Term.prim_mk_const { Name = "ptheightl", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("getSymbols", (Term.prim_mk_const { Name = "getSymbols", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptreeToRules", (Term.prim_mk_const { Name = "ptreeToRules", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptreeToRules2", (Term.prim_mk_const { Name = "ptreeToRules2", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("checkRules", (Term.prim_mk_const { Name = "checkRules", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptreeNodeSym", (Term.prim_mk_const { Name = "ptreeNodeSym", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptreeSubtSyms", (Term.prim_mk_const { Name = "ptreeSubtSyms", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("ptreeSubtree", (Term.prim_mk_const { Name = "ptreeSubtree", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("validptree_defn_tupled", (Term.prim_mk_const { Name = "validptree_defn_tupled", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("validptree", (Term.prim_mk_const { Name = "validptree", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("leaves", (Term.prim_mk_const { Name = "leaves", Thy = "parseTree"}))
  val _ = update_grms
       temp_overload_on
       ("cleaves", (Term.prim_mk_const { Name = "cleaves", Thy = "parseTree"}))
  val parseTree_grammars = Parse.current_lgrms()
  end
  
  
  
  
  val parseTree_rwts = simpLib.named_rewrites "parseTree_rwts" [
            ptsize_def, ptheight_def];
  val _ = BasicProvers.augment_srw_ss [parseTree_rwts]

  
  val _ =
    TypeBase.write [
      let
        open TypeBasePure
        val tyinfo0 = mk_datatype_info
          {ax=ORIG ptree_Axiom,
           case_def=ptree_case_def,
           case_cong=ptree_case_cong,
           induction=ORIG ptree_induction,
           nchotomy=ptree_nchotomy,
           size=SOME(Parse.Term`(parseTree$ptree_size) :('nts -> (num$num)) ->
('ts -> (num$num)) -> (('nts, 'ts) parseTree$ptree) -> (num$num)`,
                     ORIG ptree_size_def),
           encode = NONE,
           lift=NONE,
           one_one=SOME ptree_11,
           distinct=SOME ptree_distinct,
           fields=let fun T t s A = mk_thy_type{Thy=t,Tyop=s,Args=A}
    val U = mk_vartype
in
[] end,
           accessors=[],
           updates=[]}
        val tyinfo0 = tyinfo0
        val () = computeLib.write_datatype_info tyinfo0
      in
        tyinfo0
      end
    ];
  
  
  val _ = computeLib.add_funs [ptree2Sym_def];  
  
  val _ = computeLib.add_funs [isNode_def];  
  
  val _ = computeLib.add_funs [isLeaf_def];  
  
  val _ = computeLib.add_funs [ptsize_def];  
  
  val _ = computeLib.add_funs [ptheight_def];  
  
  val _ = computeLib.add_funs [getSymbols_def];  
  
  val _ = computeLib.add_funs [ptreeToRules_def];  
  
  val _ = computeLib.add_funs [checkRules_def];  
  
  val _ = computeLib.add_funs [ptreeNodeSym_def];  
  
  val _ = computeLib.add_funs [ptreeSubtSyms_def];  
  
  val _ = computeLib.add_funs [ptreeSubtree_def];  
  
  val _ = computeLib.add_funs [leaves_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
