structure regexpTheory :> regexpTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading regexpTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open listLemmasTheory
  in end;
  val _ = Theory.link_parents
          ("regexp",
          Arbnum.fromString "1260376887",
          Arbnum.fromString "548581")
          [("listLemmas",
           Arbnum.fromString "1260376849",
           Arbnum.fromString "195631")];
  val _ = Theory.incorporate_types "regexp" [("symbol",2), ("rexp",2)];
  val _ = Theory.incorporate_consts "regexp"
     [("union",
       (((alpha --> bool) --> ((alpha --> bool) --> (alpha --> bool))))),
      ("ts2str",((T"symbol" "regexp" [beta, alpha] --> alpha))),
      ("toTmnlSym",((beta --> T"symbol" "regexp" [alpha, beta]))),
      ("tmnlSym",((T"symbol" "regexp" [beta, alpha] --> alpha))),
      ("symbol_size",
       (((U"'nts" --> T"num" "num" []) -->
         ((U"'ts" --> T"num" "num" []) -->
          (T"symbol" "regexp" [U"'nts", U"'ts"] --> T"num" "num" []))))),
      ("symbol_case",
       (((U"'nts" --> alpha) -->
         ((U"'ts" --> alpha) -->
          (T"symbol" "regexp" [U"'nts", U"'ts"] --> alpha))))),
      ("symToStr",((T"symbol" "regexp" [alpha, alpha] --> alpha))),
      ("starn_tupled",
       ((T"prod" "pair"
          [(T"list" "list" [alpha] --> bool), T"num" "num" []] -->
         (T"list" "list" [alpha] --> bool)))),
      ("starn",
       (((T"list" "list" [alpha] --> bool) -->
         (T"num" "num" [] --> (T"list" "list" [alpha] --> bool))))),
      ("star",
       (((T"list" "list" [alpha] --> bool) -->
         (T"list" "list" [alpha] --> bool)))),
      ("rexp_size",
       (((U"'nts" --> T"num" "num" []) -->
         ((U"'ts" --> T"num" "num" []) -->
          (T"rexp" "regexp" [U"'nts", U"'ts"] --> T"num" "num" []))))),
      ("rexp_case",
       ((alpha -->
         ((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha) -->
          ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
            (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)) -->
           ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
             (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)) -->
            ((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha) -->
             (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)))))))),
      ("nts2str",((T"symbol" "regexp" [alpha, beta] --> alpha))),
      ("nonTmnlSym",((T"symbol" "regexp" [alpha, beta] --> alpha))),
      ("mk_symbol",
       ((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] -->
         T"symbol" "regexp" [U"'nts", U"'ts"]))),
      ("mk_rexp",
       ((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
         T"rexp" "regexp" [U"'nts", U"'ts"]))),
      ("ldNts",
       ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
         --> T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("lang",
       ((T"rexp" "regexp" [alpha, alpha] -->
         (T"list" "list" [alpha] --> bool)))),
      ("isTmnlSym",((T"symbol" "regexp" [alpha, beta] --> bool))),
      ("isNonTmnlSym",((T"symbol" "regexp" [alpha, beta] --> bool))),
      ("distinctldNts",
       ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
         --> T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
      ("dest_symbol",
       ((T"symbol" "regexp" [U"'nts", U"'ts"] -->
         T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]))),
      ("dest_rexp",
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]))),
      ("conc",
       (((T"list" "list" [alpha] --> bool) -->
         ((T"list" "list" [alpha] --> bool) -->
          (T"list" "list" [alpha] --> bool))))),
      ("Union",
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         (T"rexp" "regexp" [U"'nts", U"'ts"] -->
          T"rexp" "regexp" [U"'nts", U"'ts"])))),
      ("TS",((U"'ts" --> T"symbol" "regexp" [U"'nts", U"'ts"]))),
      ("Star",
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         T"rexp" "regexp" [U"'nts", U"'ts"]))),
      ("NTS",((U"'nts" --> T"symbol" "regexp" [U"'nts", U"'ts"]))),
      ("EmptyLang",(T"rexp" "regexp" [U"'nts", U"'ts"])),
      ("Conc",
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         (T"rexp" "regexp" [U"'nts", U"'ts"] -->
          T"rexp" "regexp" [U"'nts", U"'ts"])))),
      ("Atom",
       ((T"symbol" "regexp" [U"'ts", U"'nts"] -->
         T"rexp" "regexp" [U"'nts", U"'ts"])))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"symbol" "regexp" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]) -->
       bool) --> bool)),
   V"rep"
    ((T"symbol" "regexp" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] --> bool)
      -->
      ((T"symbol" "regexp" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]) -->
       bool))),
   V"a0" (T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]),
   C"!" "bool"
    ((((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] --> bool)
       --> bool) --> bool)),
   V"'symbol'"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] --> bool)),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] --> bool)
      --> bool)), C"\\/" "bool" ((bool --> (bool --> bool))),
   C"?" "bool" (((U"'nts" --> bool) --> bool)), V"a" (U"'nts"),
   C"=" "min"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] -->
      (T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] -->
       bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"prod" "pair" [U"'nts", U"'ts"] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]) -->
        T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]])))),
   C"0" "num" (T"num" "num" []),
   C"," "pair"
    ((U"'nts" --> (U"'ts" --> T"prod" "pair" [U"'nts", U"'ts"]))),
   C"ARB" "bool" (U"'ts"), V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]),
   C"?" "bool" (((U"'ts" --> bool) --> bool)), V"a" (U"'ts"),
   C"SUC" "num" ((T"num" "num" [] --> T"num" "num" [])),
   C"ARB" "bool" (U"'nts"), C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"symbol" "regexp" [U"'nts", U"'ts"] --> bool) --> bool)),
   V"a" (T"symbol" "regexp" [U"'nts", U"'ts"]),
   C"=" "min"
    ((T"symbol" "regexp" [U"'nts", U"'ts"] -->
      (T"symbol" "regexp" [U"'nts", U"'ts"] --> bool))),
   C"mk_symbol" "regexp"
    ((T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]] -->
      T"symbol" "regexp" [U"'nts", U"'ts"])),
   C"dest_symbol" "regexp"
    ((T"symbol" "regexp" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]])),
   V"r" (T"recspace" "ind_type" [T"prod" "pair" [U"'nts", U"'ts"]]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"!" "bool" ((((U"'nts" --> alpha) --> bool) --> bool)),
   V"f" ((U"'nts" --> alpha)),
   C"!" "bool" ((((U"'ts" --> alpha) --> bool) --> bool)),
   V"f1" ((U"'ts" --> alpha)), C"!" "bool" (((U"'nts" --> bool) --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"symbol_case" "regexp"
    (((U"'nts" --> alpha) -->
      ((U"'ts" --> alpha) -->
       (T"symbol" "regexp" [U"'nts", U"'ts"] --> alpha)))),
   C"NTS" "regexp" ((U"'nts" --> T"symbol" "regexp" [U"'nts", U"'ts"])),
   C"!" "bool" (((U"'ts" --> bool) --> bool)),
   C"TS" "regexp" ((U"'ts" --> T"symbol" "regexp" [U"'nts", U"'ts"])),
   C"!" "bool" ((((U"'nts" --> T"num" "num" []) --> bool) --> bool)),
   V"f" ((U"'nts" --> T"num" "num" [])),
   C"!" "bool" ((((U"'ts" --> T"num" "num" []) --> bool) --> bool)),
   V"f1" ((U"'ts" --> T"num" "num" [])),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"symbol_size" "regexp"
    (((U"'nts" --> T"num" "num" []) -->
      ((U"'ts" --> T"num" "num" []) -->
       (T"symbol" "regexp" [U"'nts", U"'ts"] --> T"num" "num" [])))),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   C"!" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"sym" (T"symbol" "regexp" [alpha, beta]),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"?" "bool" (((beta --> bool) --> bool)), V"s" (beta),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"TS" "regexp" ((beta --> T"symbol" "regexp" [alpha, beta])),
   C"isNonTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"?" "bool" (((alpha --> bool) --> bool)), V"s" (alpha),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, beta])),
   C"F" "bool" (bool), C"!" "bool" (((alpha --> bool) --> bool)),
   V"tmnl" (alpha),
   C"tmnlSym" "regexp" ((T"symbol" "regexp" [beta, alpha] --> alpha)),
   C"TS" "regexp" ((alpha --> T"symbol" "regexp" [beta, alpha])),
   V"ntmnl" (alpha),
   C"nonTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> alpha)),
   C"nts2str" "regexp" ((T"symbol" "regexp" [alpha, beta] --> alpha)),
   C"ts2str" "regexp" ((T"symbol" "regexp" [beta, alpha] --> alpha)),
   C"!" "bool" (((beta --> bool) --> bool)),
   C"toTmnlSym" "regexp" ((beta --> T"symbol" "regexp" [alpha, beta])),
   C"symToStr" "regexp" ((T"symbol" "regexp" [alpha, alpha] --> alpha)),
   C"TS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, alpha])),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, alpha])),
   C"?" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]) -->
       bool) --> bool)),
   V"rep"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
       bool) -->
      ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
        T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]) -->
       bool))),
   V"a0'" (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   C"!" "bool"
    ((((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
        bool) --> bool) --> bool)),
   V"'rexp'"
    ((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
      bool)),
   C"!" "bool"
    (((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
       bool) --> bool)),
   C"=" "min"
    ((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
      (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
       bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"symbol" "regexp" [U"'ts", U"'nts"] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]) -->
        T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]])))),
   C"ARB" "bool" (T"symbol" "regexp" [U"'ts", U"'nts"]),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   C"?" "bool"
    (((T"symbol" "regexp" [U"'ts", U"'nts"] --> bool) --> bool)),
   V"a" (T"symbol" "regexp" [U"'ts", U"'nts"]),
   C"?" "bool"
    (((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
       bool) --> bool)),
   V"a0" (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   V"a1" (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   C"FCONS" "ind_type"
    ((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
      ((T"num" "num" [] -->
        T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]) -->
       (T"num" "num" [] -->
        T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]])))),
   V"a" (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   C"!" "bool" (((T"rexp" "regexp" [U"'nts", U"'ts"] --> bool) --> bool)),
   V"a" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   C"=" "min"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] --> bool))),
   C"mk_rexp" "regexp"
    ((T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]] -->
      T"rexp" "regexp" [U"'nts", U"'ts"])),
   C"dest_rexp" "regexp"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]])),
   V"r" (T"recspace" "ind_type" [T"symbol" "regexp" [U"'ts", U"'nts"]]),
   V"v" (alpha),
   C"!" "bool"
    ((((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha) --> bool) -->
      bool)), V"f" ((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha)),
   C"!" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] -->
        (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)) --> bool) -->
      bool)),
   V"f1"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha))),
   V"f2"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha))),
   C"!" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha) --> bool) --> bool)),
   V"f3" ((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)),
   C"rexp_case" "regexp"
    ((alpha -->
      ((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha) -->
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)) -->
        ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
          (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)) -->
         ((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha) -->
          (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha))))))),
   C"EmptyLang" "regexp" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   C"!" "bool"
    (((T"symbol" "regexp" [U"'ts", U"'nts"] --> bool) --> bool)),
   C"Atom" "regexp"
    ((T"symbol" "regexp" [U"'ts", U"'nts"] -->
      T"rexp" "regexp" [U"'nts", U"'ts"])),
   V"a0" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"a1" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   C"Union" "regexp"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] -->
       T"rexp" "regexp" [U"'nts", U"'ts"]))),
   C"Conc" "regexp"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] -->
       T"rexp" "regexp" [U"'nts", U"'ts"]))),
   C"Star" "regexp"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      T"rexp" "regexp" [U"'nts", U"'ts"])),
   C"rexp_size" "regexp"
    (((U"'nts" --> T"num" "num" []) -->
      ((U"'ts" --> T"num" "num" []) -->
       (T"rexp" "regexp" [U"'nts", U"'ts"] --> T"num" "num" [])))),
   C"symbol_size" "regexp"
    (((U"'ts" --> T"num" "num" []) -->
      ((U"'nts" --> T"num" "num" []) -->
       (T"symbol" "regexp" [U"'ts", U"'nts"] --> T"num" "num" [])))),
   C"!" "bool" ((((T"list" "list" [alpha] --> bool) --> bool) --> bool)),
   V"as" ((T"list" "list" [alpha] --> bool)),
   V"bs" ((T"list" "list" [alpha] --> bool)),
   C"=" "min"
    (((T"list" "list" [alpha] --> bool) -->
      ((T"list" "list" [alpha] --> bool) --> bool))),
   C"conc" "regexp"
    (((T"list" "list" [alpha] --> bool) -->
      ((T"list" "list" [alpha] --> bool) -->
       (T"list" "list" [alpha] --> bool)))),
   C"GSPEC" "pred_set"
    (((T"list" "list" [alpha] -->
       T"prod" "pair" [T"list" "list" [alpha], bool]) -->
      (T"list" "list" [alpha] --> bool))), V"s" (T"list" "list" [alpha]),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (bool --> T"prod" "pair" [T"list" "list" [alpha], bool]))),
   C"?" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"u" (T"list" "list" [alpha]), V"v" (T"list" "list" [alpha]),
   C"IN" "bool"
    ((T"list" "list" [alpha] -->
      ((T"list" "list" [alpha] --> bool) --> bool))),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"!" "bool" ((((alpha --> bool) --> bool) --> bool)),
   V"as" ((alpha --> bool)), V"bs" ((alpha --> bool)),
   C"=" "min" (((alpha --> bool) --> ((alpha --> bool) --> bool))),
   C"union" "regexp"
    (((alpha --> bool) --> ((alpha --> bool) --> (alpha --> bool)))),
   C"GSPEC" "pred_set"
    (((alpha --> T"prod" "pair" [alpha, bool]) --> (alpha --> bool))),
   C"," "pair" ((alpha --> (bool --> T"prod" "pair" [alpha, bool]))),
   C"IN" "bool" ((alpha --> ((alpha --> bool) --> bool))),
   C"=" "min"
    (((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       --> (T"list" "list" [alpha] --> bool)) -->
      ((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        --> (T"list" "list" [alpha] --> bool)) --> bool))),
   C"starn_tupled" "regexp"
    ((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
      --> (T"list" "list" [alpha] --> bool))),
   C"WFREC" "relation"
    (((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       -->
       (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        --> bool)) -->
      (((T"prod" "pair"
          [(T"list" "list" [alpha] --> bool), T"num" "num" []] -->
         (T"list" "list" [alpha] --> bool)) -->
        (T"prod" "pair"
          [(T"list" "list" [alpha] --> bool), T"num" "num" []] -->
         (T"list" "list" [alpha] --> bool))) -->
       (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        --> (T"list" "list" [alpha] --> bool))))),
   C"@" "min"
    ((((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        -->
        (T"prod" "pair"
          [(T"list" "list" [alpha] --> bool), T"num" "num" []] --> bool))
       --> bool) -->
      (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       -->
       (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        --> bool)))),
   V"R"
    ((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
      -->
      (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       --> bool))),
   C"WF" "relation"
    (((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       -->
       (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
        --> bool)) --> bool)),
   C"!" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"v2" (T"num" "num" []), V"l" ((T"list" "list" [alpha] --> bool)),
   C"," "pair"
    (((T"list" "list" [alpha] --> bool) -->
      (T"num" "num" [] -->
       T"prod" "pair"
        [(T"list" "list" [alpha] --> bool), T"num" "num" []]))),
   C"-" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   V"starn_tupled"
    ((T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
      --> (T"list" "list" [alpha] --> bool))),
   V"a"
    (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]),
   C"pair_case" "pair"
    ((((T"list" "list" [alpha] --> bool) -->
       (T"num" "num" [] --> (T"list" "list" [alpha] --> bool))) -->
      (T"prod" "pair" [(T"list" "list" [alpha] --> bool), T"num" "num" []]
       --> (T"list" "list" [alpha] --> bool)))), V"v1" (T"num" "num" []),
   C"num_case" "arithmetic"
    (((T"list" "list" [alpha] --> bool) -->
      ((T"num" "num" [] --> (T"list" "list" [alpha] --> bool)) -->
       (T"num" "num" [] --> (T"list" "list" [alpha] --> bool))))),
   C"I" "combin"
    (((T"list" "list" [alpha] --> bool) -->
      (T"list" "list" [alpha] --> bool))),
   C"INSERT" "pred_set"
    ((T"list" "list" [alpha] -->
      ((T"list" "list" [alpha] --> bool) -->
       (T"list" "list" [alpha] --> bool)))),
   C"NIL" "list" (T"list" "list" [alpha]),
   C"EMPTY" "pred_set" ((T"list" "list" [alpha] --> bool)),
   V"v3" (T"num" "num" []), V"x" ((T"list" "list" [alpha] --> bool)),
   V"x1" (T"num" "num" []),
   C"starn" "regexp"
    (((T"list" "list" [alpha] --> bool) -->
      (T"num" "num" [] --> (T"list" "list" [alpha] --> bool)))),
   C"=" "min"
    ((((T"list" "list" [alpha] --> bool) -->
       (T"list" "list" [alpha] --> bool)) -->
      (((T"list" "list" [alpha] --> bool) -->
        (T"list" "list" [alpha] --> bool)) --> bool))),
   C"star" "regexp"
    (((T"list" "list" [alpha] --> bool) -->
      (T"list" "list" [alpha] --> bool))),
   V"A" ((T"list" "list" [alpha] --> bool)),
   V"a0" (T"list" "list" [alpha]),
   V"star'" ((T"list" "list" [alpha] --> bool)),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"s1" (T"list" "list" [alpha]), V"s2" (T"list" "list" [alpha]),
   C"lang" "regexp"
    ((T"rexp" "regexp" [alpha, alpha] -->
      (T"list" "list" [alpha] --> bool))),
   C"EmptyLang" "regexp" (T"rexp" "regexp" [alpha, alpha]),
   C"!" "bool" (((T"symbol" "regexp" [alpha, alpha] --> bool) --> bool)),
   V"tmnl" (T"symbol" "regexp" [alpha, alpha]),
   C"Atom" "regexp"
    ((T"symbol" "regexp" [alpha, alpha] -->
      T"rexp" "regexp" [alpha, alpha])),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"!" "bool" (((T"rexp" "regexp" [alpha, alpha] --> bool) --> bool)),
   V"r" (T"rexp" "regexp" [alpha, alpha]),
   V"s" (T"rexp" "regexp" [alpha, alpha]),
   C"Union" "regexp"
    ((T"rexp" "regexp" [alpha, alpha] -->
      (T"rexp" "regexp" [alpha, alpha] -->
       T"rexp" "regexp" [alpha, alpha]))),
   C"UNION" "pred_set"
    (((T"list" "list" [alpha] --> bool) -->
      ((T"list" "list" [alpha] --> bool) -->
       (T"list" "list" [alpha] --> bool)))),
   C"Conc" "regexp"
    ((T"rexp" "regexp" [alpha, alpha] -->
      (T"rexp" "regexp" [alpha, alpha] -->
       T"rexp" "regexp" [alpha, alpha]))),
   C"Star" "regexp"
    ((T"rexp" "regexp" [alpha, alpha] -->
      T"rexp" "regexp" [alpha, alpha])),
   C"!" "bool"
    (((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"ldNts" "regexp"
    ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
      --> T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"FILTER" "list"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
      --> T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"distinctldNts" "regexp"
    ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
      --> T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"rmDupes" "listLemmas"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"DATATYPE" "bool" ((bool --> bool)),
   V"symbol"
    (((U"'nts" --> T"symbol" "regexp" [U"'nts", U"'ts"]) -->
      ((U"'ts" --> T"symbol" "regexp" [U"'nts", U"'ts"]) --> bool))),
   V"a'" (U"'nts"), C"=" "min" ((U"'nts" --> (U"'nts" --> bool))),
   V"a'" (U"'ts"), C"=" "min" ((U"'ts" --> (U"'ts" --> bool))),
   C"~" "bool" ((bool --> bool)),
   V"M" (T"symbol" "regexp" [U"'nts", U"'ts"]),
   V"M'" (T"symbol" "regexp" [U"'nts", U"'ts"]),
   V"f'" ((U"'nts" --> alpha)), V"f1'" ((U"'ts" --> alpha)),
   V"ss" (T"symbol" "regexp" [U"'nts", U"'ts"]), V"n" (U"'nts"),
   V"t" (U"'ts"), V"f0" ((U"'nts" --> alpha)),
   C"?" "bool"
    ((((T"symbol" "regexp" [U"'nts", U"'ts"] --> alpha) --> bool) -->
      bool)), V"fn" ((T"symbol" "regexp" [U"'nts", U"'ts"] --> alpha)),
   C"!" "bool"
    ((((T"symbol" "regexp" [U"'nts", U"'ts"] --> bool) --> bool) -->
      bool)), V"P" ((T"symbol" "regexp" [U"'nts", U"'ts"] --> bool)),
   V"s" (T"symbol" "regexp" [U"'nts", U"'ts"]),
   V"e" (T"symbol" "regexp" [alpha, beta]), V"n" (alpha),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"v" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"EVERY" "list"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"?" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"n" (T"symbol" "regexp" [alpha, beta]),
   C"?" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"s1" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s2" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"CONS" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"MEM" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   V"s" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l1" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l2" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"rexp"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      ((T"symbol" "regexp" [U"'ts", U"'nts"] -->
        T"rexp" "regexp" [U"'nts", U"'ts"]) -->
       ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
         (T"rexp" "regexp" [U"'nts", U"'ts"] -->
          T"rexp" "regexp" [U"'nts", U"'ts"])) -->
        ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
          (T"rexp" "regexp" [U"'nts", U"'ts"] -->
           T"rexp" "regexp" [U"'nts", U"'ts"])) -->
         ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
           T"rexp" "regexp" [U"'nts", U"'ts"]) --> bool)))))),
   V"a'" (T"symbol" "regexp" [U"'ts", U"'nts"]),
   C"=" "min"
    ((T"symbol" "regexp" [U"'ts", U"'nts"] -->
      (T"symbol" "regexp" [U"'ts", U"'nts"] --> bool))),
   V"a0'" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"a1'" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"a'" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"M" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"M'" (T"rexp" "regexp" [U"'nts", U"'ts"]), V"v'" (alpha),
   V"f'" ((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha)),
   V"f1'"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha))),
   V"f2'"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha))),
   V"f3'" ((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)),
   V"rr" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"s" (T"symbol" "regexp" [U"'ts", U"'nts"]),
   C"?" "bool" (((T"rexp" "regexp" [U"'nts", U"'ts"] --> bool) --> bool)),
   V"r" (T"rexp" "regexp" [U"'nts", U"'ts"]),
   V"r0" (T"rexp" "regexp" [U"'nts", U"'ts"]), V"f0" (alpha),
   V"f1" ((T"symbol" "regexp" [U"'ts", U"'nts"] --> alpha)),
   C"!" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] -->
        (T"rexp" "regexp" [U"'nts", U"'ts"] -->
         (alpha --> (alpha --> alpha)))) --> bool) --> bool)),
   V"f2"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] -->
       (alpha --> (alpha --> alpha))))),
   V"f3"
    ((T"rexp" "regexp" [U"'nts", U"'ts"] -->
      (T"rexp" "regexp" [U"'nts", U"'ts"] -->
       (alpha --> (alpha --> alpha))))),
   C"!" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] --> (alpha --> alpha)) --> bool)
      --> bool)),
   V"f4" ((T"rexp" "regexp" [U"'nts", U"'ts"] --> (alpha --> alpha))),
   C"?" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha) --> bool) --> bool)),
   V"fn" ((T"rexp" "regexp" [U"'nts", U"'ts"] --> alpha)),
   C"!" "bool"
    ((((T"rexp" "regexp" [U"'nts", U"'ts"] --> bool) --> bool) --> bool)),
   V"P" ((T"rexp" "regexp" [U"'nts", U"'ts"] --> bool)),
   C"!" "bool"
    (((((T"list" "list" [alpha] --> bool) --> (T"num" "num" [] --> bool))
       --> bool) --> bool)),
   V"P"
    (((T"list" "list" [alpha] --> bool) --> (T"num" "num" [] --> bool))),
   V"v" ((T"list" "list" [alpha] --> bool)),
   V"t" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"t'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]), V"N" (alpha),
   V"rst" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"pfx" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"sfx" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"lhs" (alpha),
   V"x" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"m" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"y" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"h" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"sfx'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"e0" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"v'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]), V"B" (alpha),
   V"w" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s0" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"t"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   V"A" (alpha), V"e" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"MEM" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       --> bool))),
   V"l1"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   V"l2"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   C"APPEND" "list"
    ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
      -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       -->
       T"list" "list"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   C"CONS" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       -->
       T"list" "list"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   C"NIL" "list"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]])]
  val DT = Thm.disk_thm share_table
  in
  val symbol_TY_DEF =
    DT(["DISK_THM"], [],
       `(%0 (\%1. ((%2 (\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 ((%8 (%9 (\%10.
       ((%11 $1) ((\%10. (((%12 %13) ((%14 $0) %15)) (\%16. %17))) $0)))))
       (%18 (\%19. ((%11 $1) ((\%19. (((%12 (%20 %13)) ((%14 %21) $0))
       (\%16. %17))) $0)))))) ($1 $0))))) ($0 $1)))))) $0)))`)
  val symbol_repfns =
    DT(["DISK_THM"], [],
       `((%22 (%23 (\%24. ((%25 (%26 (%27 $0))) $0)))) (%7 (\%28. ((%29
       ((\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 ((%8 (%9 (\%10. ((%11 $1)
       ((\%10. (((%12 %13) ((%14 $0) %15)) (\%16. %17))) $0))))) (%18
       (\%19. ((%11 $1) ((\%19. (((%12 (%20 %13)) ((%14 %21) $0)) (\%16.
       %17))) $0)))))) ($1 $0))))) ($0 $1))))) $0)) ((%11 (%27 (%26 $0)))
       $0)))))`)
  val symbol_case_def =
    DT(["DISK_THM"], [],
       `((%22 (%30 (\%31. (%32 (\%33. (%34 (\%10. ((%35 (((%36 $2) $1) (%37
       $0))) ($2 $0))))))))) (%30 (\%31. (%32 (\%33. (%38 (\%19. ((%35
       (((%36 $2) $1) (%39 $0))) ($1 $0)))))))))`)
  val symbol_size_def =
    DT(["DISK_THM"], [],
       `((%22 (%40 (\%41. (%42 (\%43. (%34 (\%10. ((%44 (((%45 $2) $1) (%37
       $0))) ((%46 (%47 (%48 %49))) ($2 $0)))))))))) (%40 (\%41. (%42
       (\%43. (%38 (\%19. ((%44 (((%45 $2) $1) (%39 $0))) ((%46 (%47 (%48
       %49))) ($1 $0))))))))))`)
  val isTmnlSym_def =
    DT([], [],
       `(%50 (\%51. ((%29 (%52 $0)) (%53 (\%54. ((%55 $1) (%56 $0)))))))`)
  val isNonTmnlSym_def =
    DT([], [],
       `(%50 (\%51. ((%29 (%57 $0)) ((%8 (%58 (\%59. ((%55 $1) (%60 $0)))))
       %61))))`)
  val tmnlSym_def =
    DT(["DISK_THM"], [], `(%62 (\%63. ((%35 (%64 (%65 $0))) $0)))`)
  val nonTmnlSym_def =
    DT(["DISK_THM"], [], `(%62 (\%66. ((%35 (%67 (%60 $0))) $0)))`)
  val nts2str_def =
    DT(["DISK_THM"], [], `(%62 (\%59. ((%35 (%68 (%60 $0))) $0)))`)
  val ts2str_def =
    DT(["DISK_THM"], [], `(%62 (\%59. ((%35 (%69 (%65 $0))) $0)))`)
  val toTmnlSym_def = DT([], [], `(%70 (\%54. ((%55 (%71 $0)) (%56 $0))))`)
  val symToStr_def =
    DT(["DISK_THM"], [],
       `((%22 (%62 (\%59. ((%35 (%72 (%73 $0))) $0)))) (%62 (\%59. ((%35
       (%72 (%74 $0))) $0))))`)
  val rexp_TY_DEF =
    DT(["DISK_THM"], [],
       `(%75 (\%76. ((%77 (\%78. (%79 (\%80. ((%6 (%81 (\%78. ((%6 ((%8
       ((%82 $0) (((%83 %13) %84) (\%16. %85)))) ((%8 (%86 (\%87. ((%82 $1)
       ((\%87. (((%83 (%20 %13)) $0) (\%16. %85))) $0))))) ((%8 (%88 (\%89.
       (%88 (\%90. ((%22 ((%82 $2) (((\%89. (\%90. (((%83 (%20 (%20 %13)))
       %84) ((%91 $1) ((%91 $0) (\%16. %85)))))) $1) $0))) ((%22 ($3 $1))
       ($3 $0)))))))) ((%8 (%88 (\%89. (%88 (\%90. ((%22 ((%82 $2) (((\%89.
       (\%90. (((%83 (%20 (%20 (%20 %13)))) %84) ((%91 $1) ((%91 $0) (\%16.
       %85)))))) $1) $0))) ((%22 ($3 $1)) ($3 $0)))))))) (%88 (\%92. ((%22
       ((%82 $1) ((\%92. (((%83 (%20 (%20 (%20 (%20 %13))))) %84) ((%91 $0)
       (\%16. %85)))) $0))) ($2 $0))))))))) ($1 $0))))) ($0 $1))))))
       $0)))`)
  val rexp_repfns =
    DT(["DISK_THM"], [],
       `((%22 (%93 (\%94. ((%95 (%96 (%97 $0))) $0)))) (%81 (\%98. ((%29
       ((\%78. (%79 (\%80. ((%6 (%81 (\%78. ((%6 ((%8 ((%82 $0) (((%83 %13)
       %84) (\%16. %85)))) ((%8 (%86 (\%87. ((%82 $1) ((\%87. (((%83 (%20
       %13)) $0) (\%16. %85))) $0))))) ((%8 (%88 (\%89. (%88 (\%90. ((%22
       ((%82 $2) (((\%89. (\%90. (((%83 (%20 (%20 %13))) %84) ((%91 $1)
       ((%91 $0) (\%16. %85)))))) $1) $0))) ((%22 ($3 $1)) ($3 $0))))))))
       ((%8 (%88 (\%89. (%88 (\%90. ((%22 ((%82 $2) (((\%89. (\%90. (((%83
       (%20 (%20 (%20 %13)))) %84) ((%91 $1) ((%91 $0) (\%16. %85)))))) $1)
       $0))) ((%22 ($3 $1)) ($3 $0)))))))) (%88 (\%92. ((%22 ((%82 $1)
       ((\%92. (((%83 (%20 (%20 (%20 (%20 %13))))) %84) ((%91 $0) (\%16.
       %85)))) $0))) ($2 $0))))))))) ($1 $0))))) ($0 $1))))) $0)) ((%82
       (%97 (%96 $0))) $0)))))`)
  val rexp_case_def =
    DT(["DISK_THM"], [],
       `((%22 (%62 (\%99. (%100 (\%101. (%102 (\%103. (%102 (\%104. (%105
       (\%106. ((%35 ((((((%107 $4) $3) $2) $1) $0) %108)) $4))))))))))))
       ((%22 (%62 (\%99. (%100 (\%101. (%102 (\%103. (%102 (\%104. (%105
       (\%106. (%109 (\%87. ((%35 ((((((%107 $5) $4) $3) $2) $1) (%110
       $0))) ($4 $0))))))))))))))) ((%22 (%62 (\%99. (%100 (\%101. (%102
       (\%103. (%102 (\%104. (%105 (\%106. (%93 (\%111. (%93 (\%112. ((%35
       ((((((%107 $6) $5) $4) $3) $2) ((%113 $1) $0))) (($4 $1)
       $0))))))))))))))))) ((%22 (%62 (\%99. (%100 (\%101. (%102 (\%103.
       (%102 (\%104. (%105 (\%106. (%93 (\%111. (%93 (\%112. ((%35
       ((((((%107 $6) $5) $4) $3) $2) ((%114 $1) $0))) (($3 $1)
       $0))))))))))))))))) (%62 (\%99. (%100 (\%101. (%102 (\%103. (%102
       (\%104. (%105 (\%106. (%93 (\%94. ((%35 ((((((%107 $5) $4) $3) $2)
       $1) (%115 $0))) ($1 $0))))))))))))))))))`)
  val rexp_size_def =
    DT(["DISK_THM"], [],
       `((%22 (%40 (\%41. (%42 (\%43. ((%44 (((%116 $1) $0) %108))
       %13)))))) ((%22 (%40 (\%41. (%42 (\%43. (%109 (\%87. ((%44 (((%116
       $2) $1) (%110 $0))) ((%46 (%47 (%48 %49))) (((%117 $1) $2)
       $0)))))))))) ((%22 (%40 (\%41. (%42 (\%43. (%93 (\%111. (%93 (\%112.
       ((%44 (((%116 $3) $2) ((%113 $1) $0))) ((%46 (%47 (%48 %49))) ((%46
       (((%116 $3) $2) $1)) (((%116 $3) $2) $0))))))))))))) ((%22 (%40
       (\%41. (%42 (\%43. (%93 (\%111. (%93 (\%112. ((%44 (((%116 $3) $2)
       ((%114 $1) $0))) ((%46 (%47 (%48 %49))) ((%46 (((%116 $3) $2) $1))
       (((%116 $3) $2) $0))))))))))))) (%40 (\%41. (%42 (\%43. (%93 (\%94.
       ((%44 (((%116 $2) $1) (%115 $0))) ((%46 (%47 (%48 %49))) (((%116 $2)
       $1) $0)))))))))))))`)
  val conc_def =
    DT([], [],
       `(%118 (\%119. (%118 (\%120. ((%121 ((%122 $1) $0)) (%123 (\%124.
       ((%125 $0) (%126 (\%127. (%126 (\%128. ((%22 ((%129 $1) $4)) ((%22
       ((%129 $0) $3)) ((%130 $2) ((%131 $1) $0))))))))))))))))`)
  val union_def =
    DT([], [],
       `(%132 (\%133. (%132 (\%134. ((%135 ((%136 $1) $0)) (%137 (\%59.
       ((%138 $0) ((%8 ((%139 $0) $2)) ((%139 $0) $1))))))))))`)
  val starn_tupled_primitive_def =
    DT([], [],
       `((%140 %141) ((%142 (%143 (\%144. ((%22 (%145 $0)) (%146 (\%147.
       (%118 (\%148. (($2 ((%149 $0) ((%150 (%20 $1)) (%47 (%48 %49)))))
       ((%149 $0) (%20 $1))))))))))) (\%151. (\%152. ((%153 (\%148. (\%154.
       (((%155 (%156 ((%157 %158) %159))) (\%160. (%156 (%123 (\%124.
       ((%125 $0) (%126 (\%127. (%126 (\%128. ((%22 ((%129 $1) $5)) ((%22
       ((%129 $0) ($7 ((%149 $5) ((%150 (%20 $3)) (%47 (%48 %49)))))))
       ((%130 $2) ((%131 $1) $0)))))))))))))) $0)))) $0)))))`)
  val starn_curried_def =
    DT([], [],
       `(%118 (\%161. (%146 (\%162. ((%121 ((%163 $1) $0)) (%141 ((%149 $1)
       $0)))))))`)
  val star =
    DT([], [],
       `((%164 %165) (\%166. (\%167. (%118 (\%168. ((%6 (%169 (\%167. ((%6
       ((%8 ((%130 $0) %158)) ((%8 ((%129 $0) $3)) (%126 (\%170. (%126
       (\%171. ((%22 ((%130 $2) ((%131 $1) $0))) ((%22 ((%129 $1) $5)) ($3
       $0)))))))))) ($1 $0))))) ($0 $1)))))))`)
  val lang_def =
    DT(["DISK_THM"], [],
       `((%22 ((%121 (%172 %173)) %159)) ((%22 (%174 (\%175. ((%121 (%172
       (%176 $0))) ((%157 ((%177 (%72 $0)) %158)) %159))))) ((%22 (%178
       (\%179. (%178 (\%180. ((%121 (%172 ((%181 $1) $0))) ((%182 (%172
       $1)) (%172 $0)))))))) ((%22 (%178 (\%179. (%178 (\%180. ((%121 (%172
       ((%183 $1) $0))) ((%122 (%172 $1)) (%172 $0)))))))) (%178 (\%179.
       ((%121 (%172 (%184 $0))) (%165 (%172 $0)))))))))`)
  val ldNts_def =
    DT([], [], `(%185 (\%186. ((%187 (%188 $0)) ((%189 %57) (%190 $0)))))`)
  val distinctldNts_def =
    DT([], [], `(%185 (\%186. ((%187 (%191 $0)) (%192 (%188 $0)))))`)
  val datatype_symbol = DT(["DISK_THM"], [], `(%193 ((%194 %37) %39))`)
  val symbol_11 =
    DT(["DISK_THM"], [],
       `((%22 (%34 (\%10. (%34 (\%195. ((%29 ((%25 (%37 $1)) (%37 $0)))
       ((%196 $1) $0))))))) (%38 (\%19. (%38 (\%197. ((%29 ((%25 (%39 $1))
       (%39 $0))) ((%198 $1) $0)))))))`)
  val symbol_distinct =
    DT(["DISK_THM"], [],
       `(%38 (\%197. (%34 (\%10. (%199 ((%25 (%37 $0)) (%39 $1)))))))`)
  val symbol_case_cong =
    DT(["DISK_THM"], [],
       `(%23 (\%200. (%23 (\%201. (%30 (\%31. (%32 (\%33. ((%6 ((%22 ((%25
       $3) $2)) ((%22 (%34 (\%10. ((%6 ((%25 $3) (%37 $0))) ((%35 ($2 $0))
       (%202 $0)))))) (%38 (\%19. ((%6 ((%25 $3) (%39 $0))) ((%35 ($1 $0))
       (%203 $0)))))))) ((%35 (((%36 $1) $0) $3)) (((%36 %202) %203)
       $2)))))))))))`)
  val symbol_nchotomy =
    DT(["DISK_THM"], [],
       `(%23 (\%204. ((%8 (%9 (\%205. ((%25 $1) (%37 $0))))) (%18 (\%206.
       ((%25 $1) (%39 $0)))))))`)
  val symbol_Axiom =
    DT(["DISK_THM"], [],
       `(%30 (\%207. (%32 (\%33. (%208 (\%209. ((%22 (%34 (\%10. ((%35 ($1
       (%37 $0))) ($3 $0))))) (%38 (\%19. ((%35 ($1 (%39 $0))) ($2
       $0)))))))))))`)
  val symbol_induction =
    DT(["DISK_THM"], [],
       `(%210 (\%211. ((%6 ((%22 (%34 (\%205. ($1 (%37 $0))))) (%38 (\%206.
       ($1 (%39 $0)))))) (%23 (\%212. ($1 $0))))))`)
  val sym_r1a = DT(["DISK_THM"], [], `((%6 (%52 %213)) (%199 (%57 %213)))`)
  val sym_r1b =
    DT(["DISK_THM"], [], `((%29 (%199 (%52 %213))) (%57 %213))`)
  val sym_r2 =
    DT(["DISK_THM"], [],
       `((%6 (%52 %213)) (%199 (%58 (\%214. ((%55 %213) (%60 $0))))))`)
  val sym_r3 =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 ((%217 %52) $0)) (%199 (%218 (\%219. (%220
       (\%221. (%220 (\%222. ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2)
       %225))) $0))) (%57 $2))))))))))))`)
  val sym_r3b =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 ((%217 %57) $0)) (%199 (%218 (\%219. (%220
       (\%221. (%220 (\%222. ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2)
       %225))) $0))) (%52 $2))))))))))))`)
  val sym_r4 =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 ((%217 %52) $0)) (%199 (%218 (\%219. ((%22
       ((%226 $0) $1)) (%199 (%52 $0)))))))))`)
  val sym_r4b =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 (%199 ((%217 %52) $0))) (%218 (\%219. ((%22
       ((%226 $0) $1)) (%57 $0)))))))`)
  val sym_r5 =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 (%199 (%218 (\%219. (%220 (\%221. (%220 (\%222.
       ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2) %225))) $0))) (%57
       $2)))))))))) ((%217 %52) $0))))`)
  val sym_r6 =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%29 ((%217 %52) $0)) (%199 (%218 (\%219. (%220
       (\%221. (%220 (\%222. ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2)
       %225))) $0))) (%57 $2))))))))))))`)
  val sym_r7 =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 (%199 ((%217 %52) $0))) (%218 (\%219. (%220
       (\%221. (%220 (\%222. ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2)
       %225))) $0))) (%57 $2)))))))))))`)
  val sym_r7b =
    DT(["DISK_THM"], [],
       `(%215 (\%216. ((%6 (%199 ((%217 %57) $0))) (%218 (\%219. (%220
       (\%221. (%220 (\%222. ((%22 ((%187 $3) ((%223 ((%223 $1) ((%224 $2)
       %225))) $0))) (%52 $2)))))))))))`)
  val rightnt =
    DT(["DISK_THM"], [],
       `(%215 (\%227. ((%6 (%199 ((%217 %52) $0))) (%220 (\%228. (%58
       (\%214. (%220 (\%229. ((%22 ((%187 $3) ((%223 ((%223 $2) ((%224 (%60
       $1)) %225))) $0))) ((%217 %52) $0)))))))))))`)
  val datatype_rexp =
    DT(["DISK_THM"], [], `(%193 (((((%230 %108) %110) %113) %114) %115))`)
  val rexp_11 =
    DT(["DISK_THM"], [],
       `((%22 (%109 (\%87. (%109 (\%231. ((%29 ((%95 (%110 $1)) (%110 $0)))
       ((%232 $1) $0))))))) ((%22 (%93 (\%111. (%93 (\%112. (%93 (\%233.
       (%93 (\%234. ((%29 ((%95 ((%113 $3) $2)) ((%113 $1) $0))) ((%22
       ((%95 $3) $1)) ((%95 $2) $0)))))))))))) ((%22 (%93 (\%111. (%93
       (\%112. (%93 (\%233. (%93 (\%234. ((%29 ((%95 ((%114 $3) $2)) ((%114
       $1) $0))) ((%22 ((%95 $3) $1)) ((%95 $2) $0)))))))))))) (%93 (\%94.
       (%93 (\%235. ((%29 ((%95 (%115 $1)) (%115 $0))) ((%95 $1)
       $0)))))))))`)
  val rexp_distinct =
    DT(["DISK_THM"], [],
       `((%22 (%109 (\%87. (%199 ((%95 %108) (%110 $0)))))) ((%22 (%93
       (\%112. (%93 (\%111. (%199 ((%95 %108) ((%113 $0) $1)))))))) ((%22
       (%93 (\%112. (%93 (\%111. (%199 ((%95 %108) ((%114 $0) $1))))))))
       ((%22 (%93 (\%94. (%199 ((%95 %108) (%115 $0)))))) ((%22 (%93
       (\%112. (%93 (\%111. (%109 (\%87. (%199 ((%95 (%110 $0)) ((%113 $1)
       $2)))))))))) ((%22 (%93 (\%112. (%93 (\%111. (%109 (\%87. (%199
       ((%95 (%110 $0)) ((%114 $1) $2)))))))))) ((%22 (%93 (\%235. (%109
       (\%87. (%199 ((%95 (%110 $0)) (%115 $1)))))))) ((%22 (%93 (\%234.
       (%93 (\%112. (%93 (\%233. (%93 (\%111. (%199 ((%95 ((%113 $0) $2))
       ((%114 $1) $3)))))))))))) ((%22 (%93 (\%112. (%93 (\%111. (%93
       (\%94. (%199 ((%95 ((%113 $1) $2)) (%115 $0)))))))))) (%93 (\%112.
       (%93 (\%111. (%93 (\%94. (%199 ((%95 ((%114 $1) $2)) (%115
       $0))))))))))))))))))`)
  val rexp_case_cong =
    DT(["DISK_THM"], [],
       `(%93 (\%236. (%93 (\%237. (%62 (\%99. (%100 (\%101. (%102 (\%103.
       (%102 (\%104. (%105 (\%106. ((%6 ((%22 ((%95 $6) $5)) ((%22 ((%6
       ((%95 $5) %108)) ((%35 $4) %238))) ((%22 (%109 (\%87. ((%6 ((%95 $6)
       (%110 $0))) ((%35 ($4 $0)) (%239 $0)))))) ((%22 (%93 (\%111. (%93
       (\%112. ((%6 ((%95 $7) ((%113 $1) $0))) ((%35 (($4 $1) $0)) ((%240
       $1) $0)))))))) ((%22 (%93 (\%111. (%93 (\%112. ((%6 ((%95 $7) ((%114
       $1) $0))) ((%35 (($3 $1) $0)) ((%241 $1) $0)))))))) (%93 (\%94. ((%6
       ((%95 $6) (%115 $0))) ((%35 ($1 $0)) (%242 $0))))))))))) ((%35
       ((((((%107 $4) $3) $2) $1) $0) $6)) ((((((%107 %238) %239) %240)
       %241) %242) $5)))))))))))))))))`)
  val rexp_nchotomy =
    DT(["DISK_THM"], [],
       `(%93 (\%243. ((%8 ((%95 $0) %108)) ((%8 (%86 (\%244. ((%95 $1)
       (%110 $0))))) ((%8 (%245 (\%246. (%245 (\%247. ((%95 $2) ((%113 $1)
       $0))))))) ((%8 (%245 (\%246. (%245 (\%247. ((%95 $2) ((%114 $1)
       $0))))))) (%245 (\%246. ((%95 $1) (%115 $0))))))))))`)
  val rexp_Axiom =
    DT(["DISK_THM"], [],
       `(%62 (\%248. (%100 (\%249. (%250 (\%251. (%250 (\%252. (%253
       (\%254. (%255 (\%256. ((%22 ((%35 ($0 %108)) $5)) ((%22 (%109 (\%87.
       ((%35 ($1 (%110 $0))) ($5 $0))))) ((%22 (%93 (\%111. (%93 (\%112.
       ((%35 ($2 ((%113 $1) $0))) (((($5 $1) $0) ($2 $1)) ($2 $0))))))))
       ((%22 (%93 (\%111. (%93 (\%112. ((%35 ($2 ((%114 $1) $0))) (((($4
       $1) $0) ($2 $1)) ($2 $0)))))))) (%93 (\%94. ((%35 ($1 (%115 $0)))
       (($2 $0) ($1 $0)))))))))))))))))))))`)
  val rexp_induction =
    DT(["DISK_THM"], [],
       `(%257 (\%258. ((%6 ((%22 ($0 %108)) ((%22 (%109 (\%244. ($1 (%110
       $0))))) ((%22 (%93 (\%246. (%93 (\%247. ((%6 ((%22 ($2 $1)) ($2
       $0))) ($2 ((%113 $1) $0)))))))) ((%22 (%93 (\%246. (%93 (\%247. ((%6
       ((%22 ($2 $1)) ($2 $0))) ($2 ((%114 $1) $0)))))))) (%93 (\%246. ((%6
       ($1 $0)) ($1 (%115 $0)))))))))) (%93 (\%246. ($1 $0))))))`)
  val starn_ind =
    DT(["DISK_THM"], [],
       `(%259 (\%260. ((%6 ((%22 (%118 (\%148. (($1 $0) %13)))) (%118
       (\%148. (%146 (\%147. ((%6 (($2 $1) ((%150 (%20 $0)) (%47 (%48
       %49))))) (($2 $1) (%20 $0))))))))) (%118 (\%261. (%146 (\%154. (($2
       $1) $0))))))))`)
  val starn_def =
    DT(["DISK_THM"], [],
       `((%22 (%118 (\%148. ((%121 ((%163 $0) %13)) ((%157 %158) %159)))))
       (%146 (\%147. (%118 (\%148. ((%121 ((%163 $0) (%20 $1))) (%123
       (\%124. ((%125 $0) (%126 (\%127. (%126 (\%128. ((%22 ((%129 $1) $3))
       ((%22 ((%129 $0) ((%163 $3) ((%150 (%20 $4)) (%47 (%48 %49))))))
       ((%130 $2) ((%131 $1) $0)))))))))))))))))`)
  val star_rules =
    DT(["DISK_THM"], [],
       `(%118 (\%166. ((%22 ((%165 $0) %158)) ((%22 (%169 (\%124. ((%6
       ((%129 $0) $1)) ((%165 $1) $0))))) (%169 (\%170. (%169 (\%171. ((%6
       ((%22 ((%129 $1) $2)) ((%165 $2) $0))) ((%165 $2) ((%131 $1)
       $0)))))))))))`)
  val star_ind =
    DT(["DISK_THM"], [],
       `(%118 (\%166. (%118 (\%168. ((%6 ((%22 ($0 %158)) ((%22 (%169
       (\%124. ((%6 ((%129 $0) $2)) ($1 $0))))) (%169 (\%170. (%169 (\%171.
       ((%6 ((%22 ((%129 $1) $3)) ($2 $0))) ($2 ((%131 $1) $0))))))))))
       (%169 (\%167. ((%6 ((%165 $2) $0)) ($1 $0)))))))))`)
  val star_cases =
    DT(["DISK_THM"], [],
       `(%118 (\%166. (%169 (\%167. ((%29 ((%165 $1) $0)) ((%8 ((%130 $0)
       %158)) ((%8 ((%129 $0) $1)) (%126 (\%170. (%126 (\%171. ((%22 ((%130
       $2) ((%131 $1) $0))) ((%22 ((%129 $1) $3)) ((%165 $3)
       $0))))))))))))))`)
  val listCompLens =
    DT(["DISK_THM"], [],
       `(%215 (\%262. (%215 (\%263. (%215 (\%222. (%62 (\%264. (%215
       (\%265. ((%6 ((%187 ((%223 $3) $2)) ((%223 ((%223 $4) ((%224 (%60
       $1)) %225))) $0))) ((%8 ((%187 $4) $3)) ((%8 (%220 (\%266. (%220
       (\%267. ((%22 ((%187 $5) ((%223 ((%223 $6) ((%224 (%60 $3)) %225)))
       $1))) ((%187 $2) ((%223 $1) $0)))))))) (%220 (\%266. (%220 (\%267.
       ((%22 ((%187 $6) ((%223 $1) $0))) ((%187 $5) $1)))))))))))))))))))`)
  val symlistnil =
    DT(["DISK_THM"], [],
       `((%29 ((%22 ((%217 %52) %268)) ((%217 %57) %268))) ((%187 %268)
       %225))`)
  val symListDiv =
    DT(["DISK_THM"], [],
       `((%6 ((%22 ((%187 ((%223 %266) %267)) ((%223 ((%223 %221) ((%224
       (%60 %269)) %225))) %222))) ((%22 ((%217 %52) %266)) ((%22 ((%217
       %57) %267)) ((%217 %52) %221))))) ((%22 ((%187 %266) %221)) ((%187
       %267) ((%223 ((%224 (%60 %269)) %225)) %222))))`)
  val symlistdiv3 =
    DT(["DISK_THM"], [],
       `((%6 ((%22 ((%187 ((%223 ((%223 %221) ((%224 (%60 %269)) %225)))
       %222)) ((%223 ((%223 %270) %271)) %272))) ((%22 (%199 ((%187 %271)
       %225))) ((%22 ((%217 %52) %221)) ((%22 ((%217 %52) %270)) ((%217
       %57) %271)))))) ((%22 ((%187 %221) %270)) ((%187 ((%223 ((%224 (%60
       %269)) %225)) %222)) ((%223 %271) %272))))`)
  val symlistBdwn =
    DT(["DISK_THM"], [],
       `((%6 ((%22 ((%187 ((%223 ((%223 %273) %267)) %274)) ((%223 ((%223
       ((%223 ((%223 ((%223 %275) %267)) %276)) ((%224 (%60 %277)) %225)))
       %278)) %222))) ((%217 %52) ((%223 ((%223 ((%223 %273) %267)) %275))
       %276)))) (%220 (\%279. (%220 (\%221. ((%22 ((%187 %274) ((%223
       ((%223 $1) ((%224 (%60 %277)) %225))) $0))) ((%22 ((%217 %52) $1))
       ((%22 ((%187 ((%223 ((%223 %273) %267)) $1)) ((%223 ((%223 %275)
       %267)) %276))) ((%187 ((%223 ((%224 (%60 %277)) %225)) $0)) ((%223
       ((%223 ((%224 (%60 %277)) %225)) %278)) %222))))))))))`)
  val memldNts =
    DT(["DISK_THM"], [],
       `(%185 (\%280. ((%29 ((%226 (%60 %281)) (%188 $0))) (%220 (\%282.
       ((%22 ((%283 $0) $1)) ((%226 (%60 %281)) $0)))))))`)
  val memdistNtsApp =
    DT(["DISK_THM"], [],
       `(%185 (\%284. (%185 (\%285. ((%29 ((%8 ((%226 %213) (%191 $1)))
       ((%226 %213) (%191 $0)))) ((%226 %213) (%191 ((%286 $1) $0))))))))`)
  val memdistNtsApp' =
    DT(["DISK_THM"], [],
       `(%215 (\%270. (%215 (\%272. ((%29 ((%8 ((%226 %213) (%191 ((%287
       $1) %288)))) ((%226 %213) (%191 ((%287 $0) %288))))) ((%226 %213)
       (%191 ((%287 ((%223 $1) $0)) %288))))))))`)
  val ldNtsApp =
    DT(["DISK_THM"], [],
       `(%185 (\%284. (%185 (\%285. ((%187 (%188 ((%286 $1) $0))) ((%223
       (%188 $1)) (%188 $0)))))))`)
  end
  val _ = DB.bindl "regexp"
  [("symbol_TY_DEF",symbol_TY_DEF,DB.Def),
   ("symbol_repfns",symbol_repfns,DB.Def),
   ("symbol_case_def",symbol_case_def,DB.Def),
   ("symbol_size_def",symbol_size_def,DB.Def),
   ("isTmnlSym_def",isTmnlSym_def,DB.Def),
   ("isNonTmnlSym_def",isNonTmnlSym_def,DB.Def),
   ("tmnlSym_def",tmnlSym_def,DB.Def),
   ("nonTmnlSym_def",nonTmnlSym_def,DB.Def),
   ("nts2str_def",nts2str_def,DB.Def), ("ts2str_def",ts2str_def,DB.Def),
   ("toTmnlSym_def",toTmnlSym_def,DB.Def),
   ("symToStr_def",symToStr_def,DB.Def),
   ("rexp_TY_DEF",rexp_TY_DEF,DB.Def), ("rexp_repfns",rexp_repfns,DB.Def),
   ("rexp_case_def",rexp_case_def,DB.Def),
   ("rexp_size_def",rexp_size_def,DB.Def), ("conc_def",conc_def,DB.Def),
   ("union_def",union_def,DB.Def),
   ("starn_tupled_primitive_def",starn_tupled_primitive_def,DB.Def),
   ("starn_curried_def",starn_curried_def,DB.Def), ("star",star,DB.Def),
   ("lang_def",lang_def,DB.Def), ("ldNts_def",ldNts_def,DB.Def),
   ("distinctldNts_def",distinctldNts_def,DB.Def),
   ("datatype_symbol",datatype_symbol,DB.Thm),
   ("symbol_11",symbol_11,DB.Thm),
   ("symbol_distinct",symbol_distinct,DB.Thm),
   ("symbol_case_cong",symbol_case_cong,DB.Thm),
   ("symbol_nchotomy",symbol_nchotomy,DB.Thm),
   ("symbol_Axiom",symbol_Axiom,DB.Thm),
   ("symbol_induction",symbol_induction,DB.Thm),
   ("sym_r1a",sym_r1a,DB.Thm), ("sym_r1b",sym_r1b,DB.Thm),
   ("sym_r2",sym_r2,DB.Thm), ("sym_r3",sym_r3,DB.Thm),
   ("sym_r3b",sym_r3b,DB.Thm), ("sym_r4",sym_r4,DB.Thm),
   ("sym_r4b",sym_r4b,DB.Thm), ("sym_r5",sym_r5,DB.Thm),
   ("sym_r6",sym_r6,DB.Thm), ("sym_r7",sym_r7,DB.Thm),
   ("sym_r7b",sym_r7b,DB.Thm), ("rightnt",rightnt,DB.Thm),
   ("datatype_rexp",datatype_rexp,DB.Thm), ("rexp_11",rexp_11,DB.Thm),
   ("rexp_distinct",rexp_distinct,DB.Thm),
   ("rexp_case_cong",rexp_case_cong,DB.Thm),
   ("rexp_nchotomy",rexp_nchotomy,DB.Thm),
   ("rexp_Axiom",rexp_Axiom,DB.Thm),
   ("rexp_induction",rexp_induction,DB.Thm),
   ("starn_ind",starn_ind,DB.Thm), ("starn_def",starn_def,DB.Thm),
   ("star_rules",star_rules,DB.Thm), ("star_ind",star_ind,DB.Thm),
   ("star_cases",star_cases,DB.Thm), ("listCompLens",listCompLens,DB.Thm),
   ("symlistnil",symlistnil,DB.Thm), ("symListDiv",symListDiv,DB.Thm),
   ("symlistdiv3",symlistdiv3,DB.Thm), ("symlistBdwn",symlistBdwn,DB.Thm),
   ("memldNts",memldNts,DB.Thm), ("memdistNtsApp",memdistNtsApp,DB.Thm),
   ("memdistNtsApp'",memdistNtsApp',DB.Thm), ("ldNtsApp",ldNtsApp,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("listLemmasTheory.listLemmas_grammars",
                          listLemmasTheory.listLemmas_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "symbol"
  val _ = update_grms
       temp_overload_on
       ("dest_symbol", (Term.prim_mk_const { Name = "dest_symbol", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("mk_symbol", (Term.prim_mk_const { Name = "mk_symbol", Thy = "regexp"}))
  
  
  val _ = update_grms
       temp_overload_on
       ("NTS", (Term.prim_mk_const { Name = "NTS", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("TS", (Term.prim_mk_const { Name = "TS", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("symbol_case", (Term.prim_mk_const { Name = "symbol_case", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("symbol_size", (Term.prim_mk_const { Name = "symbol_size", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("isTmnlSym", (Term.prim_mk_const { Name = "isTmnlSym", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("isNonTmnlSym", (Term.prim_mk_const { Name = "isNonTmnlSym", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("tmnlSym", (Term.prim_mk_const { Name = "tmnlSym", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("nonTmnlSym", (Term.prim_mk_const { Name = "nonTmnlSym", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("nts2str", (Term.prim_mk_const { Name = "nts2str", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("ts2str", (Term.prim_mk_const { Name = "ts2str", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("toTmnlSym", (Term.prim_mk_const { Name = "toTmnlSym", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("symToStr", (Term.prim_mk_const { Name = "symToStr", Thy = "regexp"}))
  val _ = update_grms temp_add_type "rexp"
  val _ = update_grms
       temp_overload_on
       ("dest_rexp", (Term.prim_mk_const { Name = "dest_rexp", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("mk_rexp", (Term.prim_mk_const { Name = "mk_rexp", Thy = "regexp"}))
  
  
  
  
  
  val _ = update_grms
       temp_overload_on
       ("EmptyLang", (Term.prim_mk_const { Name = "EmptyLang", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("Atom", (Term.prim_mk_const { Name = "Atom", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("Union", (Term.prim_mk_const { Name = "Union", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("Conc", (Term.prim_mk_const { Name = "Conc", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("Star", (Term.prim_mk_const { Name = "Star", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("rexp_case", (Term.prim_mk_const { Name = "rexp_case", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("rexp_size", (Term.prim_mk_const { Name = "rexp_size", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("conc", (Term.prim_mk_const { Name = "conc", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("union", (Term.prim_mk_const { Name = "union", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("starn_tupled", (Term.prim_mk_const { Name = "starn_tupled", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("starn", (Term.prim_mk_const { Name = "starn", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("star", (Term.prim_mk_const { Name = "star", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("lang", (Term.prim_mk_const { Name = "lang", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("ldNts", (Term.prim_mk_const { Name = "ldNts", Thy = "regexp"}))
  val _ = update_grms
       temp_overload_on
       ("distinctldNts", (Term.prim_mk_const { Name = "distinctldNts", Thy = "regexp"}))
  val regexp_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ =
    TypeBase.write [
      let
        open TypeBasePure
        val tyinfo0 = mk_datatype_info
          {ax=ORIG symbol_Axiom,
           case_def=symbol_case_def,
           case_cong=symbol_case_cong,
           induction=ORIG symbol_induction,
           nchotomy=symbol_nchotomy,
           size=SOME(Parse.Term`(regexp$symbol_size) :('nts -> (num$num)) ->
('ts -> (num$num)) -> (('nts, 'ts) regexp$symbol) -> (num$num)`,
                     ORIG symbol_size_def),
           encode = NONE,
           lift=NONE,
           one_one=SOME symbol_11,
           distinct=SOME symbol_distinct,
           fields=let fun T t s A = mk_thy_type{Thy=t,Tyop=s,Args=A}
    val U = mk_vartype
in
[] end,
           accessors=[],
           updates=[]}
        val tyinfo0 = tyinfo0
        val () = computeLib.write_datatype_info tyinfo0
      in
        tyinfo0
      end
    ];
  
  
  val _ = computeLib.add_funs [isTmnlSym_def];  
  
  val _ = computeLib.add_funs [isNonTmnlSym_def];  
  
  val _ = computeLib.add_funs [tmnlSym_def];  
  
  val _ = computeLib.add_funs [nonTmnlSym_def];  
  
  val _ = computeLib.add_funs [nts2str_def];  
  
  val _ = computeLib.add_funs [ts2str_def];  
  
  val _ = computeLib.add_funs [toTmnlSym_def];  
  
  val _ = computeLib.add_funs [symToStr_def];  
  
  val _ =
    TypeBase.write [
      let
        open TypeBasePure
        val tyinfo0 = mk_datatype_info
          {ax=ORIG rexp_Axiom,
           case_def=rexp_case_def,
           case_cong=rexp_case_cong,
           induction=ORIG rexp_induction,
           nchotomy=rexp_nchotomy,
           size=SOME(Parse.Term`(regexp$rexp_size) :('nts -> (num$num)) ->
('ts -> (num$num)) -> (('nts, 'ts) regexp$rexp) -> (num$num)`,
                     ORIG rexp_size_def),
           encode = NONE,
           lift=NONE,
           one_one=SOME rexp_11,
           distinct=SOME rexp_distinct,
           fields=let fun T t s A = mk_thy_type{Thy=t,Tyop=s,Args=A}
    val U = mk_vartype
in
[] end,
           accessors=[],
           updates=[]}
        val tyinfo0 = tyinfo0
        val () = computeLib.write_datatype_info tyinfo0
      in
        tyinfo0
      end
    ];
  
  
  val _ = computeLib.add_funs [conc_def];  
  
  val _ = computeLib.add_funs [union_def];  
  
  val _ = computeLib.add_funs [starn_def,
                               (Conv.CONV_RULE numLib.SUC_TO_NUMERAL_DEFN_CONV starn_def)];
  
  
  val _ = computeLib.add_funs [lang_def];  
  
  val _ = computeLib.add_funs [ldNts_def];  
  
  val _ = computeLib.add_funs [distinctldNts_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
