signature relationLemmasTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val listderiv_def : thm
    val rtc2list_curried_def : thm
    val rtc2list_tupled_primitive_def : thm
  
  (*  Theorems  *)
    val ldMemLast : thm
    val ldMemRel : thm
    val ldTl : thm
    val listDerivHdBrk : thm
    val listderivNrc : thm
    val listderiv_thm : thm
    val listderivfront : thm
    val nrcListExists : thm
    val rtc2listExistsLen : thm
    val rtc2listLastFront : thm
    val rtc2listRtcHdLast : thm
    val rtc2listRtcRdHdLast : thm
    val rtc2list_append_right : thm
    val rtc2list_def : thm
    val rtc2list_distrib_append_fst : thm
    val rtc2list_distrib_append_snd : thm
    val rtc2list_exists' : thm
    val rtc2list_ind : thm
    val rtc2list_mem : thm
    val rtc2list_split : thm
    val rtcRderivesRtc2list : thm
  
  val relationLemmas_grammars : type_grammar.grammar * term_grammar.grammar
  
  val relationLemmas_rwts : simpLib.ssfrag
(*
   [listLemmas] Parent theory of "relationLemmas"
   
   [setLemmas] Parent theory of "relationLemmas"
   
   [listderiv_def]  Definition
      
      |- ∀R d s0 s1. R ⊢ d ◁ s0 → s1 ⇔ rtc2list R d ∧ (HD d = s0) ∧ (LAST d = s1)
   
   [rtc2list_curried_def]  Definition
      
      |- ∀x x1. rtc2list x x1 ⇔ rtc2list_tupled (x,x1)
   
   [rtc2list_tupled_primitive_def]  Definition
      
      |- rtc2list_tupled =
         WFREC (@R'. WF R' ∧ ∀x rst y R. R' (R,y::rst) (R,x::y::rst))
           (λrtc2list_tupled a.
              case a of
                 (R,[]) -> I F
              || (R,[x]) -> I T
              || (R,x::y::rst) -> I (R x y ∧ rtc2list_tupled (R,y::rst)))
   
   [ldMemLast]  Theorem
      
      |- ∀dl x r1 r2. R ⊢ dl ◁ x → y ∧ (dl = r1 ++ [e] ++ r2) ⇒ R ⊢ [e] ++ r2 ◁ e → y
   
   [ldMemRel]  Theorem
      
      |- ∀dl x e1 e2 p m s.
           R ⊢ dl ◁ x → y ∧ (dl = p ++ [e1] ++ m ++ [e2] ++ s) ⇒ R^* e1 e2
   
   [ldTl]  Theorem
      
      |- R ⊢ h::h'::t' ◁ x → y ⇒ R ⊢ h'::t' ◁ h' → y
   
   [listDerivHdBrk]  Theorem
      
      |- R ⊢ h::h'::t' ◁ x → y ⇒ R h h' ∧ R ⊢ h'::t' ◁ h' → y
   
   [listderivNrc]  Theorem
      
      |- ∀l l' x y.
           R ⊢ l ◁ x → y ∧ LENGTH l < LENGTH l' ⇒ ∃m. m < LENGTH l' ∧ NRC R m x y
   
   [listderiv_thm]  Theorem
      
      |- R ⊢ h::t ◁ x → y ⇔
         (h = x) ∧
         ((t = []) ∧ (h = y) ∨ ∃h' t'. (t = h'::t') ∧ R h h' ∧ R ⊢ t ◁ h' → y)
   
   [listderivfront]  Theorem
      
      |- ∀dl x y. R ⊢ dl ◁ x → y ⇒ FRONT dl ≠ [] ⇒ R ⊢ FRONT dl ◁ x → LAST (FRONT dl)
   
   [nrcListExists]  Theorem
      
      |- ∀x y m. NRC R m x y ⇒ ∃l. R ⊢ l ◁ x → y ∧ (LENGTH l = SUC m)
   
   [rtc2listExistsLen]  Theorem
      
      |- ∀t. rtc2list R t ⇒ ∃l. (LENGTH l = LENGTH t) ∧ R ⊢ l ◁ HD t → LAST t
   
   [rtc2listLastFront]  Theorem
      
      |- ∀l. rtc2list R l ∧ FRONT l ≠ [] ⇒ rtc2list R ([LAST (FRONT l)] ++ [LAST l])
   
   [rtc2listRtcHdLast]  Theorem
      
      |- ∀t. rtc2list R t ⇒ t ≠ [] ⇒ R^* (HD t) (LAST t)
   
   [rtc2listRtcRdHdLast]  Theorem
      
      |- ∀t. rtc2list (rderives ag) t ⇒ t ≠ [] ⇒ (rderives ag)^* (HD t) (LAST t)
   
   [rtc2list_append_right]  Theorem
      
      |- ∀l R v. rtc2list R l ⇒ R (LAST l) v ⇒ rtc2list R (l ++ [v])
   
   [rtc2list_def]  Theorem
      
      |- (∀R. rtc2list R [] ⇔ F) ∧ (∀x R. rtc2list R [x] ⇔ T) ∧
         ∀y x rst R. rtc2list R (x::y::rst) ⇔ R x y ∧ rtc2list R (y::rst)
   
   [rtc2list_distrib_append_fst]  Theorem
      
      |- rtc2list R (l1 ++ l2) ∧ l1 ≠ [] ⇒ rtc2list R l1
   
   [rtc2list_distrib_append_snd]  Theorem
      
      |- ∀l1 l2 R. rtc2list R (l1 ++ l2) ⇒ l2 ≠ [] ⇒ rtc2list R l2
   
   [rtc2list_exists']  Theorem
      
      |- ∀u v. R^* u v ⇒ ∃l. R ⊢ l ◁ u → v
   
   [rtc2list_ind]  Theorem
      
      |- ∀P.
           (∀R. P R []) ∧ (∀R x. P R [x]) ∧
           (∀R x y rst. P R (y::rst) ⇒ P R (x::y::rst)) ⇒
           ∀v v1. P v v1
   
   [rtc2list_mem]  Theorem
      
      |- ∀l e1 e2. R ⊢ l ◁ e1 → e2 ∧ MEM e' l ⇒ R^* e1 e' ∧ R^* e' e2
   
   [rtc2list_split]  Theorem
      
      |- rtc2list R l ⇒
         MEM e l ⇒
         ∃l1 l2. rtc2list R (l1 ++ [e]) ∧ rtc2list R (e::l2) ∧ (l1 ++ [e] ++ l2 = l)
   
   [rtcRderivesRtc2list]  Theorem
      
      |- ∀h h'.
           (rderives ag)^* h h' ⇒
           rtc2list (rderives ag) (h'::dl) ⇒
           (rderives ag)^* h (LAST (h'::dl))
   
   
*)
end
