signature setLemmasTheory =
sig
  type thm = Thm.thm
  
  (*  Theorems  *)
    val INFINITE_STR_UNIV : thm
    val card_same_inter : thm
    val f_diff : thm
    val f_diff1 : thm
    val insert_absorption : thm
    val insert_union : thm
    val inter_card_less : thm
    val inter_l1 : thm
    val inter_l2 : thm
    val new_exists : thm
    val not_in_inter : thm
    val set_l1 : thm
    val set_l2 : thm
    val set_l3 : thm
    val set_l4 : thm
    val set_neq : thm
    val stl_mem : thm
    val subsetInterNil : thm
    val subset_inter : thm
  
  val setLemmas_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [string] Parent theory of "setLemmas"
   
   [INFINITE_STR_UNIV]  Theorem
      
      |- INFINITE UNIV
   
   [card_same_inter]  Theorem
      
      |- ∀s2.
           FINITE s2 ⇒
           s1 PSUBSET s2 ⇒
           e ∉ s1 ⇒
           e ∈ s2 ⇒
           e ∈ t ⇒
           CARD (s1 ∩ t) < CARD (s2 ∩ t)
   
   [f_diff]  Theorem
      
      |- ∀s1.
           FINITE s1 ⇒ ∀f s2. SIGMA f (s1 DIFF s2) = SIGMA f s1 − SIGMA f (s1 ∩ s2)
   
   [f_diff1]  Theorem
      
      |- ∀s1. FINITE s1 ⇒ ∀f s2. SIGMA f (s1 ∩ s2) ≤ SIGMA f s1
   
   [insert_absorption]  Theorem
      
      |- ∀s. FINITE s ⇒ e ∈ s ⇒ (e INSERT s = s)
   
   [insert_union]  Theorem
      
      |- s1 ∪ (x INSERT s2) = x INSERT s1 ∪ s2
   
   [inter_card_less]  Theorem
      
      |- ∀s1. FINITE s1 ⇒ e ∈ s1 ⇒ e ∉ s2 ⇒ CARD s1 − CARD (s1 ∩ s2) > 0
   
   [inter_l1]  Theorem
      
      |- ∀s e. e ∈ s ⇒ (s ∩ {e} = {e})
   
   [inter_l2]  Theorem
      
      |- ∀s e. e ∉ s ⇒ (s ∩ {e} = {})
   
   [new_exists]  Theorem
      
      |- ∀s. FINITE s ⇒ ∃x. x ∉ s
   
   [not_in_inter]  Theorem
      
      |- ∀s1. FINITE s1 ⇒ e ∈ s1 ⇒ e ∉ s2 ⇒ e ∉ s1 ∩ s2
   
   [set_l1]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀f. 0 < SIGMA f s ⇒ ∃e. e ∈ s ∧ 0 < f e
   
   [set_l2]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀f. (∃e. e ∈ s ∧ 0 < f e) ⇒ 0 < SIGMA f s
   
   [set_l3]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀f. (∃e. e ∈ s ∧ n ≤ f e) ⇒ n ≤ SIGMA f s
   
   [set_l4]  Theorem
      
      |- ∀s. FINITE s ⇒ ∀f. (SIGMA f s = 0) ⇒ ∀e. e ∈ s ⇒ (f e = 0)
   
   [set_neq]  Theorem
      
      |- ∀s2. FINITE s2 ⇒ ∀s1. FINITE s1 ⇒ CARD s1 > CARD s2 ⇒ ∃e. e ∉ s2 ∧ e ∈ s1
   
   [stl_mem]  Theorem
      
      |- ∀s. FINITE s ⇒ (s = set l) ⇒ MEM e (SET_TO_LIST (set l)) ⇒ MEM e l
   
   [subsetInterNil]  Theorem
      
      |- s ⊆ t ⇒ (t ∩ t' = {}) ⇒ (s ∩ t' = {})
   
   [subset_inter]  Theorem
      
      |- ∀s2. FINITE s2 ⇒ ∀s1. s1 ⊆ s2 ⇒ ∀t. s1 ∩ t ⊆ s2 ∩ t
   
   
*)
end
