structure whileLemmasTheory :> whileLemmasTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading whileLemmasTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open boolLemmasTheory
  in end;
  val _ = Theory.link_parents
          ("whileLemmas",
          Arbnum.fromString "1260381321",
          Arbnum.fromString "89355")
          [("boolLemmas",
           Arbnum.fromString "1260375984",
           Arbnum.fromString "825324")];
  val _ = Theory.incorporate_types "whileLemmas" [];
  val _ = Theory.incorporate_consts "whileLemmas"
     [("terminates",
       ((T"prod" "pair"
          [(alpha --> bool), T"prod" "pair" [(alpha --> alpha), alpha]] -->
         bool))),
      ("owhile",
       (((alpha --> bool) -->
         ((alpha --> alpha) --> (alpha --> T"option" "option" [alpha]))))),
      ("mwhile",
       (((alpha --> bool) -->
         ((alpha --> T"option" "option" [alpha]) -->
          (alpha --> T"option" "option" [T"option" "option" [alpha]])))))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" ((((alpha --> bool) --> bool) --> bool)),
   V"C" ((alpha --> bool)),
   C"!" "bool" ((((alpha --> alpha) --> bool) --> bool)),
   V"f" ((alpha --> alpha)), C"!" "bool" (((alpha --> bool) --> bool)),
   V"s" (alpha),
   C"=" "min"
    ((T"option" "option" [alpha] -->
      (T"option" "option" [alpha] --> bool))),
   C"owhile" "whileLemmas"
    (((alpha --> bool) -->
      ((alpha --> alpha) --> (alpha --> T"option" "option" [alpha])))),
   C"COND" "bool"
    ((bool -->
      (T"option" "option" [alpha] -->
       (T"option" "option" [alpha] --> T"option" "option" [alpha])))),
   C"?" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"n" (T"num" "num" []), C"~" "bool" ((bool --> bool)),
   C"FUNPOW" "arithmetic"
    (((alpha --> alpha) --> (T"num" "num" [] --> (alpha --> alpha)))),
   C"SOME" "option" ((alpha --> T"option" "option" [alpha])),
   C"LEAST" "while" (((T"num" "num" [] --> bool) --> T"num" "num" [])),
   C"NONE" "option" (T"option" "option" [alpha]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"terminates" "whileLemmas"
    ((T"prod" "pair"
       [(alpha --> bool), T"prod" "pair" [(alpha --> alpha), alpha]] -->
      bool)),
   C"," "pair"
    (((alpha --> bool) -->
      (T"prod" "pair" [(alpha --> alpha), alpha] -->
       T"prod" "pair"
        [(alpha --> bool), T"prod" "pair" [(alpha --> alpha), alpha]]))),
   C"," "pair"
    (((alpha --> alpha) -->
      (alpha --> T"prod" "pair" [(alpha --> alpha), alpha]))),
   V"g" ((alpha --> bool)),
   C"!" "bool"
    ((((alpha --> T"option" "option" [alpha]) --> bool) --> bool)),
   V"f" ((alpha --> T"option" "option" [alpha])),
   C"=" "min"
    ((T"option" "option" [T"option" "option" [alpha]] -->
      (T"option" "option" [T"option" "option" [alpha]] --> bool))),
   C"mwhile" "whileLemmas"
    (((alpha --> bool) -->
      ((alpha --> T"option" "option" [alpha]) -->
       (alpha --> T"option" "option" [T"option" "option" [alpha]])))),
   C"owhile" "whileLemmas"
    (((T"option" "option" [alpha] --> bool) -->
      ((T"option" "option" [alpha] --> T"option" "option" [alpha]) -->
       (T"option" "option" [alpha] -->
        T"option" "option" [T"option" "option" [alpha]])))),
   V"opt" (T"option" "option" [alpha]),
   C"option_case" "option"
    ((bool -->
      ((alpha --> bool) --> (T"option" "option" [alpha] --> bool)))),
   C"F" "bool" (bool),
   C"option_case" "option"
    ((T"option" "option" [alpha] -->
      ((alpha --> T"option" "option" [alpha]) -->
       (T"option" "option" [alpha] --> T"option" "option" [alpha])))),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"/\\" "bool" ((bool --> (bool --> bool))), V"x" (alpha),
   V"P" ((alpha --> bool)), C"?" "bool" (((alpha --> bool) --> bool)),
   V"s'" (alpha), C"!" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"m" (T"num" "num" []),
   C"<" "prim_rec" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"COND" "bool"
    ((bool -->
      (T"option" "option" [T"option" "option" [alpha]] -->
       (T"option" "option" [T"option" "option" [alpha]] -->
        T"option" "option" [T"option" "option" [alpha]])))),
   C"option_case" "option"
    ((T"option" "option" [T"option" "option" [alpha]] -->
      ((alpha --> T"option" "option" [T"option" "option" [alpha]]) -->
       (T"option" "option" [alpha] -->
        T"option" "option" [T"option" "option" [alpha]])))),
   C"SOME" "option"
    ((T"option" "option" [alpha] -->
      T"option" "option" [T"option" "option" [alpha]])), V"x'" (alpha)]
  val DT = Thm.disk_thm share_table
  in
  val owhile_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%4 (\%5. ((%6 (((%7 $2) $1) $0)) (((%8 (%9
       (\%10. (%11 ($3 (((%12 $2) $0) $1)))))) (%13 (((%12 $1) (%14 (\%10.
       (%11 ($3 (((%12 $2) $0) $1)))))) $0))) %15))))))))`)
  val terminates_def =
    DT(["DISK_THM"], [],
       `(%0 (\%1. (%2 (\%3. (%4 (\%5. ((%16 (%17 ((%18 $2) ((%19 $1) $0))))
       (%9 (\%10. (%11 ($3 (((%12 $2) $0) $1))))))))))))`)
  val mwhile_def =
    DT([], [],
       `(%0 (\%20. (%21 (\%22. (%4 (\%5. ((%23 (((%24 $2) $1) $0)) (((%25
       (\%26. (((%27 %28) (\%5. ($4 $0))) $0))) (\%26. (((%29 %15) (\%5.
       ($3 $0))) $0))) (%13 $0)))))))))`)
  val owhile_thm =
    DT(["DISK_THM"], [],
       `((%6 (((%7 %1) %3) %5)) (((%8 (%1 %5)) (((%7 %1) %3) (%3 %5))) (%13
       %5)))`)
  val owhile_EQ_NONE =
    DT(["DISK_THM"], [],
       `((%16 ((%6 (((%7 %1) %3) %5)) %15)) (%11 (%17 ((%18 %1) ((%19 %3)
       %5)))))`)
  val obua_induct2 =
    DT(["DISK_THM"], [],
       `((%30 ((%31 (%17 ((%18 %1) ((%19 %3) %5)))) (%4 (\%32. ((%30 ((%30
       (%1 $0)) (%33 (%3 $0)))) (%33 $0)))))) (%33 %5))`)
  val owhile_EQ_SOME =
    DT(["DISK_THM"], [],
       `((%16 (%34 (\%35. ((%6 (((%7 %1) %3) %5)) (%13 $0))))) (%17 ((%18
       %1) ((%19 %3) %5))))`)
  val owhileEndCond =
    DT(["DISK_THM"], [],
       `(%4 (\%35. ((%30 ((%6 (((%7 %1) %3) %5)) (%13 $0))) (%11 (%1
       $0)))))`)
  val nthStateProp =
    DT(["DISK_THM"], [],
       `((%30 (%4 (\%32. ((%30 ((%31 (%33 $0)) (%1 $0))) (%33 (%3 $0))))))
       (%36 (\%10. (%4 (\%5. ((%30 ((%31 (%33 $0)) (%36 (\%37. ((%30 ((%38
       $0) $2)) (%1 (((%12 %3) $0) $1))))))) (%33 (((%12 %3) $1)
       $0))))))))`)
  val owhileEndState =
    DT(["DISK_THM"], [],
       `((%30 ((%31 ((%6 (((%7 %1) %3) %5)) (%13 %35))) ((%31 (%4 (\%32.
       ((%30 ((%31 (%33 $0)) (%1 $0))) (%33 (%3 $0)))))) (%33 %5)))) (%33
       %35))`)
  val mwhile_COND =
    DT(["DISK_THM"], [],
       `((%23 (((%24 %20) %22) %5)) (((%39 (%20 %5)) (((%40 (%41 %15))
       (\%35. (((%24 %20) %22) $0))) (%22 %5))) (%41 (%13 %5))))`)
  val mwhileEndCond =
    DT(["DISK_THM"], [],
       `((%30 ((%23 (((%24 %1) %22) %5)) (%41 (%13 %35)))) (%11 (%1
       %35)))`)
  val mwhileEndState =
    DT(["DISK_THM"], [],
       `((%30 ((%31 ((%23 (((%24 %1) %22) %5)) (%41 (%13 %35)))) ((%31 (%4
       (\%32. (%4 (\%42. ((%30 ((%31 (%33 $1)) ((%31 (%1 $1)) ((%6 (%22
       $1)) (%13 $0))))) (%33 $0))))))) (%33 %5)))) (%33 %35))`)
  end
  val _ = DB.bindl "whileLemmas"
  [("owhile_def",owhile_def,DB.Def),
   ("terminates_def",terminates_def,DB.Def),
   ("mwhile_def",mwhile_def,DB.Def), ("owhile_thm",owhile_thm,DB.Thm),
   ("owhile_EQ_NONE",owhile_EQ_NONE,DB.Thm),
   ("obua_induct2",obua_induct2,DB.Thm),
   ("owhile_EQ_SOME",owhile_EQ_SOME,DB.Thm),
   ("owhileEndCond",owhileEndCond,DB.Thm),
   ("nthStateProp",nthStateProp,DB.Thm),
   ("owhileEndState",owhileEndState,DB.Thm),
   ("mwhile_COND",mwhile_COND,DB.Thm),
   ("mwhileEndCond",mwhileEndCond,DB.Thm),
   ("mwhileEndState",mwhileEndState,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("boolLemmasTheory.boolLemmas_grammars",
                          boolLemmasTheory.boolLemmas_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("owhile", (Term.prim_mk_const { Name = "owhile", Thy = "whileLemmas"}))
  val _ = update_grms
       temp_overload_on
       ("terminates", (Term.prim_mk_const { Name = "terminates", Thy = "whileLemmas"}))
  val _ = update_grms
       temp_overload_on
       ("mwhile", (Term.prim_mk_const { Name = "mwhile", Thy = "whileLemmas"}))
  val whileLemmas_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ = computeLib.add_funs [owhile_def];  
  
  val _ = computeLib.add_funs [terminates_def];  
  
  val _ = computeLib.add_funs [mwhile_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
