signature closureTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val fringe_defn_primitive_def : thm
    val grClosure_def : thm
    val grConcat_def : thm
    val grNt2Nt'R_def : thm
    val grNt2Nt'_def : thm
    val grUnion_def : thm
    val rename_def : thm
    val replace_curried_def : thm
    val replace_tupled_primitive_def : thm
    val root_primitive_def : thm
    val ruleNt2Nt'_def : thm
    val star : thm
    val stripNts_def : thm
    val substGr_def : thm
    val substRule_curried_def : thm
    val substRule_tupled_primitive_def : thm
    val substitutel_curried_def : thm
    val substitutel_tupled_primitive_def : thm
    val sym2ptree_def : thm
  
  (*  Theorems  *)
    val IS_SUFFIX_CONS2_E : thm
    val closure_cfg : thm
    val concat_cfg : thm
    val derivImpRenameD : thm
    val derivgImpsbg : thm
    val disjoint : thm
    val everyTmMapTs : thm
    val fringeTmsEq : thm
    val getSymsEqRoot : thm
    val getSymsTmsEq : thm
    val grImpSubst : thm
    val grNt2Nt'RAll : thm
    val grNt2Nt'RNtInNewg : thm
    val grNt2Nt'RNtSame : thm
    val grNt2Nt'RNts : thm
    val grNt2Nt'RSymInG' : thm
    val grNt2Nt'RSymInRuleG' : thm
    val grSSymRtcdSubs : thm
    val grcDerivImpg1g2 : thm
    val grcRtcDTog1 : thm
    val grcRtcDTog2 : thm
    val grcRtcDeriv : thm
    val grcStartRule : thm
    val grcStartRuleRhs : thm
    val grclDerivNil : thm
    val grclDerivesAppend : thm
    val grclDerivesAppend' : thm
    val grclImpStarLd : thm
    val grclRtcDSsym : thm
    val grclRtcDTog : thm
    val grclRtcImpD : thm
    val grcls0Deriv : thm
    val grcls0ld : thm
    val gruDerivFrmg1 : thm
    val gruDerivFrmg2 : thm
    val gruLdNtRtcDNt : thm
    val gruNtNotInRhs : thm
    val gruNtRtcDNt : thm
    val gruRtcDeriv : thm
    val gruRtcDerivgNt : thm
    val gruRtcSsg1 : thm
    val gruRtcSsg2 : thm
    val gruStartRuleRhs : thm
    val gsubDerives : thm
    val gsubRtcd : thm
    val isSfxMem : thm
    val leafRtcd : thm
    val lpexImpvpt : thm
    val mapRenameListEq : thm
    val mapRenameTwice : thm
    val memGetSyms : thm
    val memRuleInsbg : thm
    val memRulegsub : thm
    val notMemSymsbg : thm
    val notMemsbl : thm
    val nt2nt'LangEq : thm
    val nt2nt'ListRuleInG : thm
    val nt2nt'RuleInG : thm
    val ptLangThm : thm
    val ptlRtcd : thm
    val renameAllTms : thm
    val renameDImpD : thm
    val renameListSame : thm
    val renameNtInList : thm
    val renameNtNeNt'InList : thm
    val renameNtNotMem : thm
    val renameRtcDImpD : thm
    val renameRuleSame : thm
    val renameTwice : thm
    val replTmnls : thm
    val replaceApp : thm
    val replace_def : thm
    val replace_ind : thm
    val root_def : thm
    val root_ind : thm
    val rtcDerivImpRenameD : thm
    val rtcdImpVpt : thm
    val ruleNilsbg : thm
    val ruleNt2Nt'Mem1 : thm
    val ruleNt2Nt'Mem1' : thm
    val ruleNt2Nt'Mem2 : thm
    val ruleNt2Nt'Mem2' : thm
    val ruleNt2Nt'MemInOld : thm
    val ruleNt2Nt'Repl : thm
    val ruleg1NoDerivg2 : thm
    val ruleg2NoDerivg1 : thm
    val sb1 : thm
    val sbSSymEq : thm
    val sbgNtsIng : thm
    val sbl1Mem : thm
    val sblAppend : thm
    val sblImprepl : thm
    val sblRuleMemMapsbr : thm
    val starImpgrcl : thm
    val star_cases : thm
    val star_ind : thm
    val star_rules : thm
    val subsEqNil : thm
    val substImpGr : thm
    val substRule_def : thm
    val substRule_ind : thm
    val substThm : thm
    val substTwice : thm
    val substitutel_def : thm
    val substitutel_ind : thm
    val substlEqNil : thm
    val union_cfg : thm
    val vptRtcd : thm
    val vptSbgrImpGr : thm
    val vptgsubInLang : thm
  
  val closure_grammars : type_grammar.grammar * term_grammar.grammar
  
  val closure_rwts : simpLib.ssfrag
(*
   [parseTree] Parent theory of "closure"
   
   [pdaDef] Parent theory of "closure"
   
   [fringe_defn_primitive_def]  Definition
      
      |- fringe =
         WFREC (@R. WF R ∧ ∀x ptl a. MEM a ptl ⇒ R a (Node x ptl))
           (λfringe a.
              case a of
                 Leaf tm -> I [tm]
              || Node x ptl -> I (FLAT (MAP (λa. fringe a) ptl)))
   
   [grClosure_def]  Definition
      
      |- ∀s0 g.
           grClosure s0 g =
           G (rules g ++ [rule s0 [NTS (startSym g); NTS s0]] ++ [rule s0 []]) s0
   
   [grConcat_def]  Definition
      
      |- ∀s0 g1 g2.
           grConcat s0 g1 g2 =
           G
             (rules g1 ++ rules g2 ++
              [rule s0 [NTS (startSym g1); NTS (startSym g2)]]) s0
   
   [grNt2Nt'R_def]  Definition
      
      |- ∀g'' nt nt' g g'.
           grNt2Nt'R g'' (nt,nt') g g' ⇔
           NTS nt' ∉ nonTerminals g'' ∧ (grNt2Nt' nt nt' g = g')
   
   [grNt2Nt'_def]  Definition
      
      |- ∀nt nt' p s.
           grNt2Nt' nt nt' (G p s) = G (MAP (ruleNt2Nt' nt nt') p) (rename nt nt' s)
   
   [grUnion_def]  Definition
      
      |- ∀s0 g1 g2.
           grUnion s0 g1 g2 =
           G
             (rules g1 ++ rules g2 ++ [rule s0 [NTS (startSym g1)]] ++
              [rule s0 [NTS (startSym g2)]]) s0
   
   [rename_def]  Definition
      
      |- ∀x x' e. rename x x' e = if e = x then x' else e
   
   [replace_curried_def]  Definition
      
      |- ∀x x1 x2. replace x x1 x2 = replace_tupled (x,x1,x2)
   
   [replace_tupled_primitive_def]  Definition
      
      |- replace_tupled =
         WFREC
           (@R.
              WF R ∧ (∀x s sym rst. R (rst,sym,s) (NTS x::rst,sym,s)) ∧
              (∀s rst sym t. ¬(t ≠ sym) ⇒ R (rst,sym,s) (TS t::rst,sym,s)) ∧
              ∀s rst sym t. t ≠ sym ⇒ R (rst,sym,s) (TS t::rst,sym,s))
           (λreplace_tupled a.
              case a of
                 ([],sym,s) -> I {[]}
              || (NTS x::rst,sym',s') ->
                   I (IMAGE (CONS (NTS x)) (replace_tupled (rst,sym',s')))
              || (TS t::rst,sym'',s'') ->
                   I
                     (if t ≠ sym'' then
                        IMAGE (CONS (TS t)) (replace_tupled (rst,sym'',s''))
                      else
                        conc s'' (replace_tupled (rst,sym'',s''))))
   
   [root_primitive_def]  Definition
      
      |- root =
         WFREC (@R. WF R)
           (λroot a. case a of Leaf tm -> I (TS tm) || Node x ptl -> I (NTS x))
   
   [ruleNt2Nt'_def]  Definition
      
      |- ∀nt nt' l r.
           ruleNt2Nt' nt nt' (rule l r) =
           rule (rename nt nt' l) (MAP (rename (NTS nt) (NTS nt')) r)
   
   [star]  Definition
      
      |- star =
         (λA a0.
            ∀star'.
              (∀a0.
                 (a0 = []) ∨ a0 ∈ A ∨ (∃s1 s2. (a0 = s1 ++ s2) ∧ s1 ∈ A ∧ star' s2) ⇒
                 star' a0) ⇒
              star' a0)
   
   [stripNts_def]  Definition
      
      |- ∀a. stripNts (NTS a) = a
   
   [substGr_def]  Definition
      
      |- ∀tm gsub g.
           substGr (tm,gsub) g =
           G (rules gsub ++ MAP (substRule (TS tm,NTS (startSym gsub))) (rules g))
             (startSym g)
   
   [substRule_curried_def]  Definition
      
      |- ∀x x1. substRule x x1 = substRule_tupled (x,x1)
   
   [substRule_tupled_primitive_def]  Definition
      
      |- substRule_tupled =
         WFREC (@R. WF R)
           (λsubstRule_tupled a.
              case a of ((e,e'),rule l r) -> I (rule l (substitutel (e,[e']) r)))
   
   [substitutel_curried_def]  Definition
      
      |- ∀x x1. substitutel x x1 = substitutel_tupled (x,x1)
   
   [substitutel_tupled_primitive_def]  Definition
      
      |- substitutel_tupled =
         WFREC
           (@R.
              WF R ∧ (∀rst l e h. h ≠ e ⇒ R ((e,l),rst) ((e,l),h::rst)) ∧
              ∀rst l e h. (h = e) ⇒ R ((e,l),rst) ((e,l),h::rst))
           (λsubstitutel_tupled a.
              case a of
                 ((e,l),[]) -> I []
              || ((e,l),h::rst) ->
                   I
                     (if h = e then
                        l ++ substitutel_tupled ((e,l),rst)
                      else
                        h::substitutel_tupled ((e,l),rst)))
   
   [sym2ptree_def]  Definition
      
      |- (∀s. sym2ptree (TS s) = Leaf s) ∧ ∀n. sym2ptree (NTS n) = Node n []
   
   [IS_SUFFIX_CONS2_E]  Theorem
      
      |- IS_SUFFIX s (h::t) ⇒ IS_SUFFIX s t
   
   [closure_cfg]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- ∀g.
           INFINITE UNIV ⇒
           ∃s0.
             NTS s0 ∉ nonTerminals g ∧ star (language g) w ⇔
             w ∈ language (grClosure s0 g)
   
   [concat_cfg]  Theorem
      
      |- ∀g1 g2.
           INFINITE UNIV ∧ DISJOINT (nonTerminals g1) (nonTerminals g2) ⇒
           ∃s0.
             NTS s0 ∉ nonTerminals g1 ∪ nonTerminals g2 ∧
             (w ∈ conc (language g1) (language g2) ⇔
              w ∈ language (grConcat s0 g1 g2))
   
   [derivImpRenameD]  Theorem
      
      |- derives g w w' ⇒
         derives (grNt2Nt' nt nt' g) (MAP (rename (NTS nt) (NTS nt')) w)
           (MAP (rename (NTS nt) (NTS nt')) w')
   
   [derivgImpsbg]  Theorem
      
      |- derives g w w' ⇒
         derives (substGr (tm,gsub) g) (substitutel (TS tm,[NTS (startSym gsub)]) w)
           (substitutel (TS tm,[NTS (startSym gsub)]) w')
   
   [disjoint]  Theorem
      
      |- INFINITE UNIV ⇒
         ∃g'.
           (language g = language g') ∧ DISJOINT (nonTerminals g') (nonTerminals g'')
   
   [everyTmMapTs]  Theorem
      
      |- ∀l. EVERY isTmnlSym (MAP TS l)
   
   [fringeTmsEq]  Theorem
      
      |- EVERY isTmnlSym x ⇒
         (MAP TS (FLAT (MAP fringe (MAP Leaf (MAP ts2str x)))) = x)
   
   [getSymsEqRoot]  Theorem
      
      |- ∀ptl. getSymbols ptl = MAP root ptl
   
   [getSymsTmsEq]  Theorem
      
      |- EVERY isTmnlSym x ⇒ (getSymbols (MAP Leaf (MAP ts2str x)) = x)
   
   [grImpSubst]  Theorem
      
      |- DISJOINT (nonTerminals g) (nonTerminals gsub) ∧ w ∈ language g ∧
         w' ∈ replace w tm (language gsub) ⇒
         w' ∈ language (substGr (tm,gsub) g)
   
   [grNt2Nt'RAll]  Theorem
      
      |- ∀s.
           FINITE s ⇒
           ∀g g''.
             (s = nonTerminals g ∩ nonTerminals g'') ⇒
             INFINITE UNIV ⇒
             ∃g'.
               (λx y. ∃nt nt'. grNt2Nt'R g'' (nt,nt') x y)^* g g' ∧
               (language g = language g') ∧
               DISJOINT (nonTerminals g') (nonTerminals g'')
   
   [grNt2Nt'RNtInNewg]  Theorem
      
      |- ∀l.
           nt ≠ nt' ∧ grNt2Nt'R g'' (nt,nt') g g0 ⇒
           ∀e. NTS e ∈ nonTerminals g0 ⇒ (e = nt') ∨ NTS e ∈ nonTerminals g ∧ e ≠ nt
   
   [grNt2Nt'RNtSame]  Theorem
      
      |- ∀l.
           nt ≠ nt' ⇒
           grNt2Nt'R g'' (nt,nt') g g0 ⇒
           ∀e. NTS e ∈ nonTerminals g ∧ NTS e ≠ NTS nt ⇒ NTS e ∈ nonTerminals g0
   
   [grNt2Nt'RNts]  Theorem
      
      |- grNt2Nt'R g'' (nt,nt') g g0 ⇒
         nt ≠ nt' ⇒
         NTS nt ∈ nonTerminals g ⇒
         (nonTerminals g0 = NTS nt' INSERT nonTerminals g DELETE NTS nt)
   
   [grNt2Nt'RSymInG']  Theorem
      
      |- nt ≠ nt' ⇒
         NTS nt ∈ nonTerminals g ⇒
         grNt2Nt'R g'' (nt,nt') g g0 ⇒
         NTS nt' ∈ nonTerminals g0
   
   [grNt2Nt'RSymInRuleG']  Theorem
      
      |- nt ≠ nt' ⇒
         NTS nt ∈ nonTerminals g ⇒
         grNt2Nt'R g'' (nt,nt') g g0 ⇒
         ∃rhs.
           MEM (rule nt' rhs) (rules g0) ∨
           ∃l p s.
             MEM (rule l (p ++ [NTS nt'] ++ s)) (rules g0) ∨ (nt' = startSym g0)
   
   [grSSymRtcdSubs]  Theorem
      
      |- ∀s w.
           (derives g)^* s w ⇒
           (s = [NTS (startSym g)]) ⇒
           (derives (substGr (tm,gsub) g))^* [NTS (startSym g)]
             (substitutel (TS tm,[NTS (startSym gsub)]) w)
   
   [grcDerivImpg1g2]  Theorem
      
      |- DISJOINT (nonTerminals g1) (nonTerminals g2) ∧
         NTS s0 ∉ nonTerminals g1 ∪ nonTerminals g2 ∧
         (derives g1)^* [NTS (startSym g1)] u ∧
         (derives g2)^* [NTS (startSym g2)] v ∧
         derives (grConcat s0 g1 g2) (u ++ v) w'' ⇒
         ∃u' v'.
           (w'' = u' ++ v) ∧ derives g1 u u' ∨
           ∃u' v'. (w'' = u ++ v') ∧ derives g2 v v'
   
   [grcRtcDTog1]  Theorem
      
      |- ∀w w'. (derives g1)^* w w' ⇒ (derives (grConcat s0 g1 g2))^* w w'
   
   [grcRtcDTog2]  Theorem
      
      |- ∀w w'. (derives g2)^* w w' ⇒ (derives (grConcat s0 g1 g2))^* w w'
   
   [grcRtcDeriv]  Theorem
      
      |- ∀w w'.
           (derives (grConcat s0 g1 g2))^* w w' ⇒
           (w = [NTS s0]) ⇒
           NTS s0 ∉ nonTerminals g1 ∪ nonTerminals g2 ⇒
           DISJOINT (nonTerminals g1) (nonTerminals g2) ⇒
           (w = w') ∨
           ∃u v.
             (w' = u ++ v) ∧ (derives g1)^* [NTS (startSym g1)] u ∧
             (derives g2)^* [NTS (startSym g2)] v
   
   [grcStartRule]  Theorem
      
      |- derives (grConcat s0 g1 g2) [NTS s0] [NTS (startSym g1); NTS (startSym g2)]
   
   [grcStartRuleRhs]  Theorem
      
      |- MEM (rule lhs rhs) (rules (grConcat lhs g1 g2)) ∧
         NTS lhs ∉ nonTerminals g1 ∪ nonTerminals g2 ⇒
         (rhs = [NTS (startSym g1); NTS (startSym g2)])
   
   [grclDerivNil]  Theorem
      
      |- derives (grClosure s0 g) [NTS s0] []
   
   [grclDerivesAppend]  Theorem
      
      |- (derives g)^* [NTS (startSym g)] s1 ∧ (derives g)^* [NTS (startSym g)] s2 ⇒
         (derives (grClosure s0 g))^* [NTS s0] (s1 ++ s2)
   
   [grclDerivesAppend']  Theorem
      
      |- (derives (grClosure s0 g))^* [NTS (startSym g)] s1 ∧
         (derives (grClosure s0 g))^* [NTS s0] s2 ⇒
         (derives (grClosure s0 g))^* [NTS s0] (s1 ++ s2)
   
   [grclImpStarLd]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- ∀w'.
           derives (grClosure s0 g) ⊢ dl ◁ [NTS s0] → w' ⇒
           EVERY isTmnlSym w' ⇒
           NTS s0 ∉ nonTerminals g ⇒
           star (language g) w'
   
   [grclRtcDSsym]  Theorem
      
      |- (derives (grClosure s0 g))^* [NTS s0] [NTS (startSym g)]
   
   [grclRtcDTog]  Theorem
      
      |- ∀w w'. (derives g)^* w w' ⇒ (derives (grClosure s0 g))^* w w'
   
   [grclRtcImpD]  Theorem
      
      |- ∀w w'.
           (derives (grClosure s0 g))^* w w' ⇒
           (w = [NTS (startSym g)]) ⇒
           NTS s0 ∉ nonTerminals g ⇒
           (derives g)^* w w'
   
   [grcls0Deriv]  Theorem
      
      |- NTS s0 ∉ nonTerminals g ⇒
         derives (grClosure s0 g) [NTS s0] h ⇒
         (h = []) ∨ (h = [NTS (startSym g); NTS s0])
   
   [grcls0ld]  Theorem
      
      |- derives (grClosure s0 g) ⊢ h::h'::t' ◁ [NTS s0] → w ∧
         NTS s0 ∉ nonTerminals g ⇒
         (h' = []) ∨
         derives (grClosure s0 g) ⊢ h'::t' ◁ [NTS (startSym g)] ++ [NTS s0] → w
   
   [gruDerivFrmg1]  Theorem
      
      |- ∀w w'. (derives g1)^* w w' ⇒ (derives (grUnion s0 g1 g2))^* w w'
   
   [gruDerivFrmg2]  Theorem
      
      |- ∀w w'. (derives g2)^* w w' ⇒ (derives (grUnion s0 g1 g2))^* w w'
   
   [gruLdNtRtcDNt]  Theorem
      
      |- NTS nt ∉ nonTerminals g1 ∪ nonTerminals g2 ∧
         (derives (grUnion nt g1 g2))^* [NTS nt] (s1 ++ [NTS nt] ++ s2) ⇒
         (s1 = []) ∧ (s2 = [])
   
   [gruNtNotInRhs]  Theorem
      
      |- NTS nt ∉ nonTerminals g1 ∪ nonTerminals g2 ⇒
         ¬∃lhs p s. MEM (rule lhs (p ++ [NTS nt] ++ s)) (rules (grUnion nt g1 g2))
   
   [gruNtRtcDNt]  Theorem
      
      |- NTS nt ∉ nonTerminals g1 ∪ nonTerminals g2 ∧
         (derives (grUnion nt g1 g2))^* [NTS nt] (s1 ++ [NTS nt] ++ s2) ⇒
         (s1 = []) ∧ (s2 = [])
   
   [gruRtcDeriv]  Theorem
      
      |- ∀w w'.
           (derives (grUnion s0 g1 g2))^* w w' ⇒
           (w = [NTS s0]) ⇒
           NTS s0 ∉ nonTerminals g1 ∪ nonTerminals g2 ⇒
           DISJOINT (nonTerminals g1) (nonTerminals g2) ⇒
           (w = w') ∨ (derives g1)^* [NTS (startSym g1)] w' ∨
           (derives g2)^* [NTS (startSym g2)] w'
   
   [gruRtcDerivgNt]  Theorem
      
      |- ∀w w'.
           (derives g)^* w w' ⇒
           ¬MEM (NTS nt) w ⇒
           NTS nt ∉ nonTerminals g ⇒
           ¬MEM (NTS nt) w'
   
   [gruRtcSsg1]  Theorem
      
      |- (derives (grUnion s0 g1 g2))^* [NTS s0] [NTS (startSym g1)]
   
   [gruRtcSsg2]  Theorem
      
      |- (derives (grUnion s0 g1 g2))^* [NTS s0] [NTS (startSym g2)]
   
   [gruStartRuleRhs]  Theorem
      
      |- MEM (rule lhs rhs) (rules (grUnion lhs g1 g2)) ∧
         NTS lhs ∉ nonTerminals g1 ∪ nonTerminals g2 ⇒
         (rhs = [NTS (startSym g1)]) ∨ (rhs = [NTS (startSym g2)])
   
   [gsubDerives]  Theorem
      
      |- derives gsub x y ⇒ derives (substGr (tm,gsub) g) x y
   
   [gsubRtcd]  Theorem
      
      |- ∀x y. (derives gsub)^* x y ⇒ (derives (substGr (tm,gsub) g))^* x y
   
   [isSfxMem]  Theorem
      
      |- ∀ptl l. IS_SUFFIX ptl l ⇒ ∀e. MEM e l ⇒ MEM e ptl
   
   [leafRtcd]  Theorem
      
      |- ∀t. isLeaf t ⇒ (derives g)^* [root t] (MAP TS (fringe t))
   
   [lpexImpvpt]  Theorem
      
      |- ∀l.
           (∀a b.
              MEM (a,b) l ⇒
              (isNonTmnlSym a ⇒
               ∃t. validptree g t ∧ (MAP TS (fringe t) = b) ∧ (root t = a)) ∧
              (isTmnlSym a ⇒ ([a] = b))) ⇒
           ∃ts.
             (MAP root ts = MAP FST l) ∧
             (MAP TS (FLAT (MAP fringe ts)) = FLAT (MAP SND l)) ∧
             ∀e. MEM e ts ∧ isNode e ⇒ validptree g e
   
   [mapRenameListEq]  Theorem
      
      |- ¬MEM (NTS nt') l ∧ (l' = MAP (rename (NTS nt) (NTS nt')) l) ⇒
         (l = MAP (rename (NTS nt') (NTS nt)) l')
   
   [mapRenameTwice]  Theorem
      
      |- ¬MEM (NTS nt') l ⇒
         (MAP (rename (NTS nt') (NTS nt)) (MAP (rename (NTS nt) (NTS nt')) l) = l)
   
   [memGetSyms]  Theorem
      
      |- ∀l. MEM (Node n' ts) l ⇒ MEM (NTS n') (getSymbols l)
   
   [memRuleInsbg]  Theorem
      
      |- MEM (rule lhs rhs) (rules g) ⇒
         MEM (rule lhs (substitutel (TS tm,[NTS (startSym gsub)]) rhs))
           (rules (substGr (tm,gsub) g))
   
   [memRulegsub]  Theorem
      
      |- DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
         NTS n ∈ nonTerminals gsub ⇒
         MEM (rule n l) (rules (substGr (sym,gsub) g)) ⇒
         MEM (rule n l) (rules gsub)
   
   [notMemSymsbg]  Theorem
      
      |- MEM (rule n l) (rules (substGr (sym,gsub) g)) ∧ NTS n ∈ nonTerminals g ∧
         DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
         ¬MEM (TS sym) l
   
   [notMemsbl]  Theorem
      
      |- ∀l. ¬MEM (TS sym) (substitutel (TS sym,[NTS (startSym gsub)]) l)
   
   [nt2nt'LangEq]  Theorem
      
      |- INFINITE UNIV ⇒
         NTS nt' ∉ nonTerminals g ⇒
         (language g = language (grNt2Nt' nt nt' g))
   
   [nt2nt'ListRuleInG]  Theorem
      
      |- ∀l.
           MEM (rule lhs rhs) (MAP (ruleNt2Nt' nt nt') l) ∧
           ¬(∃rhs.
               MEM (rule nt' rhs) l ∨
               ∃lhs p s.
                 MEM (rule lhs (p ++ [NTS nt'] ++ s)) l ∨ (nt' = startSym g)) ⇒
           MEM (rule (rename nt' nt lhs) (MAP (rename (NTS nt') (NTS nt)) rhs)) l
   
   [nt2nt'RuleInG]  Theorem
      
      |- MEM (rule lhs rhs) (rules (grNt2Nt' nt nt' g)) ⇒
         NTS nt' ∉ nonTerminals g ⇒
         MEM (rule (rename nt' nt lhs) (MAP (rename (NTS nt') (NTS nt)) rhs))
           (rules g)
   
   [ptLangThm]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- ∀w.
           w ∈ language g ⇔
           ∃t. validptree g t ∧ (MAP TS (fringe t) = w) ∧ (root t = NTS (startSym g))
   
   [ptlRtcd]  Theorem
      
      |- ∀ptl.
           (∀e. MEM e ptl ⇒ (derives g)^* [root e] (MAP TS (fringe e))) ⇒
           (derives g)^* (MAP root ptl) (MAP TS (FLAT (MAP fringe ptl)))
   
   [renameAllTms]  Theorem
      
      |- EVERY isTmnlSym w ⇒ (MAP (rename (NTS nt) (NTS nt')) w = w)
   
   [renameDImpD]  Theorem
      
      |- derives (grNt2Nt' nt nt' g) w w' ⇒
         NTS nt' ∉ nonTerminals g ⇒
         derives g (MAP (rename (NTS nt') (NTS nt)) w)
           (MAP (rename (NTS nt') (NTS nt)) w')
   
   [renameListSame]  Theorem
      
      |- ¬MEM (NTS nt) l ⇒ (MAP (rename (NTS nt) (NTS nt')) l = l)
   
   [renameNtInList]  Theorem
      
      |- ¬MEM (NTS nt') l ⇒
         MEM (NTS nt') (MAP (rename (NTS nt) (NTS nt')) l) ⇒
         MEM (NTS nt) l
   
   [renameNtNeNt'InList]  Theorem
      
      |- x ≠ nt' ∧ MEM (NTS x) (MAP (rename (NTS nt) (NTS nt')) l) ⇒ MEM (NTS x) l
   
   [renameNtNotMem]  Theorem
      
      |- nt ≠ nt' ⇒ ¬MEM (NTS nt) (MAP (rename (NTS nt) (NTS nt')) l)
   
   [renameRtcDImpD]  Theorem
      
      |- ∀w w'.
           (derives (grNt2Nt' nt nt' g))^* w w' ⇒
           NTS nt' ∉ nonTerminals g ⇒
           (derives g)^* (MAP (rename (NTS nt') (NTS nt)) w)
             (MAP (rename (NTS nt') (NTS nt)) w')
   
   [renameRuleSame]  Theorem
      
      |- NTS nt ∉ nonTerminals g ∧ MEM ru (rules g) ⇒ (ruleNt2Nt' nt nt' ru = ru)
   
   [renameTwice]  Theorem
      
      |- nt' ≠ n ⇒ (rename nt' nt (rename nt nt' n) = n)
   
   [replTmnls]  Theorem
      
      |- ∀w w'.
           EVERY isTmnlSym w ⇒ w' ∈ replace w tm (language g) ⇒ EVERY isTmnlSym w'
   
   [replaceApp]  Theorem
      
      |- ∀l1 l2 l1' l2'.
           l1' ∈ replace l1 sym s ∧ l2' ∈ replace l2 sym s ⇒
           l1' ++ l2' ∈ replace (l1 ++ l2) sym s
   
   [replace_def]  Theorem
      
      |- (∀sym s. replace [] sym s = {[]}) ∧
         (∀x sym s rst.
            replace (NTS x::rst) sym s = IMAGE (CONS (NTS x)) (replace rst sym s)) ∧
         ∀t sym s rst.
           replace (TS t::rst) sym s =
           if t ≠ sym then
             IMAGE (CONS (TS t)) (replace rst sym s)
           else
             conc s (replace rst sym s)
   
   [replace_ind]  Theorem
      
      |- ∀P.
           (∀sym s. P [] sym s) ∧
           (∀x rst sym s. P rst sym s ⇒ P (NTS x::rst) sym s) ∧
           (∀t rst sym s.
              (¬(t ≠ sym) ⇒ P rst sym s) ∧ (t ≠ sym ⇒ P rst sym s) ⇒
              P (TS t::rst) sym s) ⇒
           ∀v v1 v2. P v v1 v2
   
   [root_def]  Theorem
      
      |- (root (Leaf tm) = TS tm) ∧ (root (Node x ptl) = NTS x)
   
   [root_ind]  Theorem
      
      |- ∀P. (∀tm. P (Leaf tm)) ∧ (∀x ptl. P (Node x ptl)) ⇒ ∀v. P v
   
   [rtcDerivImpRenameD]  Theorem
      
      |- ∀w w'.
           (derives g)^* w w' ⇒
           (derives (grNt2Nt' nt nt' g))^* (MAP (rename (NTS nt) (NTS nt')) w)
             (MAP (rename (NTS nt) (NTS nt')) w')
   
   [rtcdImpVpt]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- ∀A y.
           derives g ⊢ dl ◁ [NTS A] → y ⇒
           EVERY isTmnlSym y ⇒
           ∃t. validptree g t ∧ (MAP TS (fringe t) = y) ∧ (root t = NTS A)
   
   [ruleNilsbg]  Theorem
      
      |- MEM (rule n []) (rules (substGr (sym,gsub) g)) ∧ NTS n ∈ nonTerminals g ∧
         DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
         MEM (rule n []) (rules g)
   
   [ruleNt2Nt'Mem1]  Theorem
      
      |- MEM (rule nt rhs) l ⇒ ∃rhs'. MEM (rule nt' rhs') (MAP (ruleNt2Nt' nt nt') l)
   
   [ruleNt2Nt'Mem1']  Theorem
      
      |- ∀l.
           MEM (rule ntx rhs) l ∧ ntx ≠ nt ⇒
           MEM (rule ntx (MAP (rename (NTS nt) (NTS nt')) rhs))
             (MAP (ruleNt2Nt' nt nt') l)
   
   [ruleNt2Nt'Mem2]  Theorem
      
      |- MEM (rule l' (p ++ [NTS nt] ++ s)) l ⇒
         ∃lhs p' s'.
           MEM (rule lhs (p' ++ [NTS nt'] ++ s')) (MAP (ruleNt2Nt' nt nt') l)
   
   [ruleNt2Nt'Mem2']  Theorem
      
      |- MEM (rule l' (p ++ [NTS ntx] ++ s)) l ∧ ntx ≠ nt ⇒
         ∃lhs p' s'.
           MEM (rule lhs (p' ++ [NTS ntx] ++ s')) (MAP (ruleNt2Nt' nt nt') l)
   
   [ruleNt2Nt'MemInOld]  Theorem
      
      |- MEM (rule lhs (p ++ [NTS x] ++ s)) (MAP (ruleNt2Nt' nt nt') l) ⇒
         ((x = nt') ⇒
          (∃lhs' p' s'. MEM (rule lhs' (p' ++ [NTS nt] ++ s')) l) ∨
          ∃lhs' p' s'. MEM (rule lhs' (p' ++ [NTS nt'] ++ s')) l) ∧
         (x ≠ nt' ⇒ ∃lhs' p' s'. MEM (rule lhs' (p' ++ [NTS x] ++ s')) l)
   
   [ruleNt2Nt'Repl]  Theorem
      
      |- ∀l.
           nt ≠ nt' ∧ MEM (rule lhs rhs) (MAP (ruleNt2Nt' nt nt') l) ⇒
           lhs ≠ nt ∧ ¬MEM (NTS nt) rhs
   
   [ruleg1NoDerivg2]  Theorem
      
      |- ∀g1 g2.
           DISJOINT (nonTerminals g1) (nonTerminals g2) ∧
           MEM (rule lhs rhs) (rules g1) ∧ NTS nt ≠ NTS lhs ⇒
           ¬(derives g2)^* [NTS nt] (pfx ++ [NTS lhs] ++ sfx)
   
   [ruleg2NoDerivg1]  Theorem
      
      |- ∀g1 g2.
           DISJOINT (nonTerminals g1) (nonTerminals g2) ∧
           MEM (rule lhs rhs) (rules g2) ∧ NTS nt ≠ NTS lhs ⇒
           ¬(derives g1)^* [NTS nt] (pfx ++ [NTS lhs] ++ sfx)
   
   [sb1]  Theorem
      
      |- isTmnlSym tm ⇒ (substitutel (tm,l') [NTS s] = [NTS s])
   
   [sbSSymEq]  Theorem
      
      |- startSym g = startSym (substGr (tm,gsub) g)
   
   [sbgNtsIng]  Theorem
      
      |- DISJOINT (nonTerminals g) (nonTerminals gsub) ∧ NTS n ∈ nonTerminals g ∧
         MEM (rule n rhs) (rules (substGr (sym,gsub) g)) ⇒
         ∀e. MEM (NTS e) rhs ⇒ (e = startSym gsub) ∨ NTS e ∈ nonTerminals g
   
   [sbl1Mem]  Theorem
      
      |- ∀l. MEM x (substitutel (e,[e']) l) ⇒ (x = e') ∨ MEM x l
   
   [sblAppend]  Theorem
      
      |- ∀w1 w2.
           substitutel (tm,l) (w1 ++ w2) =
           substitutel (tm,l) w1 ++ substitutel (tm,l) w2
   
   [sblImprepl]  Theorem
      
      |- ∀w w'.
           w' ∈ replace w tm (language gsub) ⇒
           (derives (substGr (tm,gsub) g))^*
             (substitutel (TS tm,[NTS (startSym gsub)]) w) w'
   
   [sblRuleMemMapsbr]  Theorem
      
      |- ∀l.
           MEM (rule lhs rhs) l ⇒
           MEM (rule lhs (substitutel (tm,[NTS n]) rhs))
             (MAP (substRule (tm,NTS n)) l)
   
   [starImpgrcl]  Theorem
      
      |- ∀w. star (language g) w ⇒ w ∈ language (grClosure s0 g)
   
   [star_cases]  Theorem
      
      |- ∀A a0.
           star A a0 ⇔
           (a0 = []) ∨ a0 ∈ A ∨ ∃s1 s2. (a0 = s1 ++ s2) ∧ s1 ∈ A ∧ star A s2
   
   [star_ind]  Theorem
      
      |- ∀A star'.
           star' [] ∧ (∀s. s ∈ A ⇒ star' s) ∧
           (∀s1 s2. s1 ∈ A ∧ star' s2 ⇒ star' (s1 ++ s2)) ⇒
           ∀a0. star A a0 ⇒ star' a0
   
   [star_rules]  Theorem
      
      |- ∀A.
           star A [] ∧ (∀s. s ∈ A ⇒ star A s) ∧
           ∀s1 s2. s1 ∈ A ∧ star A s2 ⇒ star A (s1 ++ s2)
   
   [subsEqNil]  Theorem
      
      |- ((rule n [] = substRule (e,e') y) ⇔ (y = rule n [])) ∧
         ((substRule (e,e') y = rule n []) ⇔ (y = rule n []))
   
   [substImpGr]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- DISJOINT (nonTerminals g) (nonTerminals gsub) ∧
         w' ∈ language (substGr (tm,gsub) g) ⇒
         ∃w. w ∈ language g ∧ w' ∈ replace w tm (language gsub)
   
   [substRule_def]  Theorem
      
      |- substRule (e,e') (rule l r) = rule l (substitutel (e,[e']) r)
   
   [substRule_ind]  Theorem
      
      |- ∀P. (∀e e' l r. P (e,e') (rule l r)) ⇒ ∀v v1 v2. P (v,v1) v2
   
   [substThm]  Theorem
      
      [oracles: DISK_THM, tactic_failed] [axioms: ] []
      |- DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
         (w' ∈ language (substGr (tm,gsub) g) ⇔
          ∃w. w ∈ language g ∧ w' ∈ replace w tm (language gsub))
   
   [substTwice]  Theorem
      
      |- ∀l. ¬MEM n l ⇒ (substitutel (n,[t]) (substitutel (t,[n]) l) = l)
   
   [substitutel_def]  Theorem
      
      |- (∀l e. substitutel (e,l) [] = []) ∧
         ∀rst l h e.
           substitutel (e,l) (h::rst) =
           if h = e then l ++ substitutel (e,l) rst else h::substitutel (e,l) rst
   
   [substitutel_ind]  Theorem
      
      |- ∀P.
           (∀e l. P (e,l) []) ∧
           (∀e l h rst.
              (h ≠ e ⇒ P (e,l) rst) ∧ ((h = e) ⇒ P (e,l) rst) ⇒ P (e,l) (h::rst)) ⇒
           ∀v v1 v2. P (v,v1) v2
   
   [substlEqNil]  Theorem
      
      |- e' ≠ [] ⇒
         ((substitutel (e,e') l = []) ⇔ (l = [])) ∧
         (([] = substitutel (e,e') l) ⇔ (l = []))
   
   [union_cfg]  Theorem
      
      |- ∀g1 g2.
           DISJOINT (nonTerminals g1) (nonTerminals g2) ∧ INFINITE UNIV ⇒
           ∃s0.
             NTS s0 ∉ nonTerminals g1 ∪ nonTerminals g2 ∧
             (w ∈ language g1 ∪ language g2 ⇔ w ∈ language (grUnion s0 g1 g2))
   
   [vptRtcd]  Theorem
      
      |- ∀g t. validptree g t ⇒ (derives g)^* [root t] (MAP TS (fringe t))
   
   [vptSbgrImpGr]  Theorem
      
      |- ∀g t.
           validptree (substGr (sym,gsub) g) t ∧ root t ∈ nonTerminals g ∧
           DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
           ∃t' w.
             (MAP TS (fringe t') = w) ∧
             MAP TS (fringe t) ∈ replace w sym (language gsub) ∧ validptree g t' ∧
             (root t' = root t)
   
   [vptgsubInLang]  Theorem
      
      |- ∀g' t.
           validptree g' t ⇒
           (g' = substGr (sym,gsub) g) ⇒
           DISJOINT (nonTerminals g) (nonTerminals gsub) ⇒
           root t ∈ nonTerminals gsub ⇒
           (derives gsub)^* [root t] (MAP TS (fringe t))
   
   
*)
end
