structure closureTheory :> closureTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading closureTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open parseTreeTheory pdaDefTheory
  in end;
  val _ = Theory.link_parents
          ("closure",
          Arbnum.fromString "1259372382",
          Arbnum.fromString "997014")
          [("pdaDef",
           Arbnum.fromString "1259372202",
           Arbnum.fromString "356145"),
           ("parseTree",
           Arbnum.fromString "1259372179",
           Arbnum.fromString "410922")];
  val _ = Theory.incorporate_types "closure" [];
  val _ = Theory.incorporate_consts "closure"
     [("sym2ptree",
       ((T"symbol" "regexp" [alpha, beta] -->
         T"ptree" "parseTree" [alpha, beta]))),
      ("substitutel_tupled",
       ((T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [alpha]],
           T"list" "list" [alpha]] --> T"list" "list" [alpha]))),
      ("substitutel",
       ((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
         (T"list" "list" [alpha] --> T"list" "list" [alpha])))),
      ("substRule_tupled",
       ((T"prod" "pair"
          [T"prod" "pair"
            [T"symbol" "regexp" [alpha, beta],
             T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"rule" "grammarDef" [alpha, beta]))),
      ("substRule",
       ((T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]] -->
         (T"rule" "grammarDef" [alpha, beta] -->
          T"rule" "grammarDef" [alpha, beta])))),
      ("substGr",
       ((T"prod" "pair" [beta, T"grammar" "grammarDef" [alpha, beta]] -->
         (T"grammar" "grammarDef" [alpha, beta] -->
          T"grammar" "grammarDef" [alpha, beta])))),
      ("stripNts",((T"symbol" "regexp" [alpha, beta] --> alpha))),
      ("star",
       (((T"list" "list" [alpha] --> bool) -->
         (T"list" "list" [alpha] --> bool)))),
      ("ruleNt2Nt'",
       ((alpha -->
         (alpha -->
          (T"rule" "grammarDef" [alpha, beta] -->
           T"rule" "grammarDef" [alpha, beta]))))),
      ("root",
       ((T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta]))),
      ("replace_tupled",
       ((T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair"
            [beta,
             (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
         -->
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
      ("replace",
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         (beta -->
          ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
            bool)))))),
      ("rename",((alpha --> (alpha --> (alpha --> alpha))))),
      ("grUnion",
       ((alpha -->
         (T"grammar" "grammarDef" [alpha, beta] -->
          (T"grammar" "grammarDef" [alpha, beta] -->
           T"grammar" "grammarDef" [alpha, beta]))))),
      ("grNt2Nt'R",
       ((T"grammar" "grammarDef" [alpha, beta] -->
         (T"prod" "pair" [alpha, alpha] -->
          (T"grammar" "grammarDef" [alpha, beta] -->
           (T"grammar" "grammarDef" [alpha, beta] --> bool)))))),
      ("grNt2Nt'",
       ((alpha -->
         (alpha -->
          (T"grammar" "grammarDef" [alpha, beta] -->
           T"grammar" "grammarDef" [alpha, beta]))))),
      ("grConcat",
       ((alpha -->
         (T"grammar" "grammarDef" [alpha, beta] -->
          (T"grammar" "grammarDef" [alpha, beta] -->
           T"grammar" "grammarDef" [alpha, beta]))))),
      ("grClosure",
       ((alpha -->
         (T"grammar" "grammarDef" [alpha, beta] -->
          T"grammar" "grammarDef" [alpha, beta])))),
      ("fringe",
       ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((alpha --> bool) --> bool)), V"s0" (alpha),
   C"!" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"g1" (T"grammar" "grammarDef" [alpha, beta]),
   V"g2" (T"grammar" "grammarDef" [alpha, beta]),
   C"=" "min"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"grammar" "grammarDef" [alpha, beta] --> bool))),
   C"grUnion" "closure"
    ((alpha -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] -->
        T"grammar" "grammarDef" [alpha, beta])))),
   C"G" "grammarDef"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (alpha --> T"grammar" "grammarDef" [alpha, beta]))),
   C"APPEND" "list"
    ((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   C"CONS" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"rule" "grammarDef"
    ((alpha -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   C"CONS" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, beta])),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] --> alpha)),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"NIL" "list" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"x" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"!" "bool" (((beta --> bool) --> bool)), V"x1" (beta),
   C"!" "bool"
    ((((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       bool) --> bool)),
   V"x2" ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   C"=" "min"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       bool))),
   C"replace" "closure"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (beta -->
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   C"replace_tupled" "closure"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"prod" "pair"
         [beta,
          (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
      --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"," "pair"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"prod" "pair"
        [beta,
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)] -->
       T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
            bool)]]))),
   C"," "pair"
    ((beta -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       T"prod" "pair"
        [beta,
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]))),
   C"=" "min"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))
      -->
      ((T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))
       --> bool))),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        --> bool)) -->
      (((T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair"
            [beta,
             (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
         --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))
        -->
        (T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair"
            [beta,
             (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
         --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))
       -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        -->
        (T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair"
            [beta,
             (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
         --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"prod" "pair"
         [beta,
          (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
      -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       --> bool))), C"/\\" "bool" ((bool --> (bool --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       -->
       (T"prod" "pair"
         [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair"
           [beta,
            (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
        --> bool)) --> bool)), V"x" (alpha),
   V"s" ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   V"sym" (beta),
   V"rst" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]), V"t" (beta),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"~" "bool" ((bool --> bool)), C"=" "min" ((beta --> (beta --> bool))),
   C"TS" "regexp" ((beta --> T"symbol" "regexp" [alpha, beta])),
   V"replace_tupled"
    ((T"prod" "pair"
       [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
        T"prod" "pair"
         [beta,
          (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
      --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   V"a"
    (T"prod" "pair"
      [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
       T"prod" "pair"
        [beta,
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]),
   C"pair_case" "pair"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"prod" "pair"
         [beta,
          (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))) -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair"
          [beta,
           (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]]
       --> (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   V"v" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"v1"
    (T"prod" "pair"
      [beta,
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)]),
   C"list_case" "list"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      ((T"symbol" "regexp" [alpha, beta] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   C"pair_case" "pair"
    (((beta -->
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))) -->
      (T"prod" "pair"
        [beta,
         (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   C"I" "combin"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"INSERT" "pred_set"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   C"EMPTY" "pred_set"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   V"v2" (T"symbol" "regexp" [alpha, beta]),
   C"symbol_case" "regexp"
    (((alpha -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
      ((beta -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
       (T"symbol" "regexp" [alpha, beta] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   V"sym'" (beta),
   V"s'" ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   C"IMAGE" "pred_set"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   V"sym''" (beta),
   V"s''" ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   C"COND" "bool"
    ((bool -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   C"conc" "regexp"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   V"tm" (beta), V"gsub" (T"grammar" "grammarDef" [alpha, beta]),
   V"g" (T"grammar" "grammarDef" [alpha, beta]),
   C"substGr" "closure"
    ((T"prod" "pair" [beta, T"grammar" "grammarDef" [alpha, beta]] -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       T"grammar" "grammarDef" [alpha, beta]))),
   C"," "pair"
    ((beta -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       T"prod" "pair" [beta, T"grammar" "grammarDef" [alpha, beta]]))),
   C"MAP" "list"
    (((T"rule" "grammarDef" [alpha, beta] -->
       T"rule" "grammarDef" [alpha, beta]) -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list" [T"rule" "grammarDef" [alpha, beta]]))),
   C"substRule" "closure"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta]]
      -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"rule" "grammarDef" [alpha, beta]))),
   C"," "pair"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] -->
       T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta]]))),
   C"!" "bool"
    (((T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta]] --> bool) --> bool)),
   V"x"
    (T"prod" "pair"
      [T"symbol" "regexp" [alpha, beta],
       T"symbol" "regexp" [alpha, beta]]),
   C"!" "bool" (((T"rule" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"x1" (T"rule" "grammarDef" [alpha, beta]),
   C"=" "min"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"rule" "grammarDef" [alpha, beta] --> bool))),
   C"substRule_tupled" "closure"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"rule" "grammarDef" [alpha, beta])),
   C"," "pair"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta]]
      -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]]))),
   C"=" "min"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]) -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        T"rule" "grammarDef" [alpha, beta]) --> bool))),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)) -->
      (((T"prod" "pair"
          [T"prod" "pair"
            [T"symbol" "regexp" [alpha, beta],
             T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"rule" "grammarDef" [alpha, beta]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"symbol" "regexp" [alpha, beta],
             T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] -->
         T"rule" "grammarDef" [alpha, beta])) -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        T"rule" "grammarDef" [alpha, beta])))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"symbol" "regexp" [alpha, beta],
             T"symbol" "regexp" [alpha, beta]],
           T"rule" "grammarDef" [alpha, beta]] --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"symbol" "regexp" [alpha, beta],
            T"symbol" "regexp" [alpha, beta]],
          T"rule" "grammarDef" [alpha, beta]] --> bool)) --> bool)),
   V"substRule_tupled"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta]],
        T"rule" "grammarDef" [alpha, beta]] -->
      T"rule" "grammarDef" [alpha, beta])),
   V"a"
    (T"prod" "pair"
      [T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta]],
       T"rule" "grammarDef" [alpha, beta]]),
   C"pair_case" "pair"
    (((T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta]] -->
       (T"rule" "grammarDef" [alpha, beta] -->
        T"rule" "grammarDef" [alpha, beta])) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"symbol" "regexp" [alpha, beta]],
         T"rule" "grammarDef" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   V"v"
    (T"prod" "pair"
      [T"symbol" "regexp" [alpha, beta],
       T"symbol" "regexp" [alpha, beta]]),
   V"v1" (T"rule" "grammarDef" [alpha, beta]),
   C"pair_case" "pair"
    (((T"symbol" "regexp" [alpha, beta] -->
       (T"symbol" "regexp" [alpha, beta] -->
        T"rule" "grammarDef" [alpha, beta])) -->
      (T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   V"e" (T"symbol" "regexp" [alpha, beta]),
   V"e'" (T"symbol" "regexp" [alpha, beta]),
   C"rule_case" "grammarDef"
    (((alpha -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        T"rule" "grammarDef" [alpha, beta])) -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"rule" "grammarDef" [alpha, beta]))), V"l" (alpha),
   V"r" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"I" "combin"
    ((T"rule" "grammarDef" [alpha, beta] -->
      T"rule" "grammarDef" [alpha, beta])),
   C"substitutel" "closure"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta],
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"," "pair"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   C"!" "bool"
    (((T"prod" "pair" [alpha, T"list" "list" [alpha]] --> bool) --> bool)),
   V"x" (T"prod" "pair" [alpha, T"list" "list" [alpha]]),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"x1" (T"list" "list" [alpha]),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"substitutel" "closure"
    ((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"substitutel_tupled" "closure"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"list" "list" [alpha]],
        T"list" "list" [alpha]] --> T"list" "list" [alpha])),
   C"," "pair"
    ((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
      (T"list" "list" [alpha] -->
       T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]]))),
   C"=" "min"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] --> T"list" "list" [alpha]) -->
      ((T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] --> T"list" "list" [alpha]) --> bool))),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] --> bool)) -->
      (((T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [alpha]],
           T"list" "list" [alpha]] --> T"list" "list" [alpha]) -->
        (T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [alpha]],
           T"list" "list" [alpha]] --> T"list" "list" [alpha])) -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] --> T"list" "list" [alpha])))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] -->
        (T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [alpha]],
           T"list" "list" [alpha]] --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"list" "list" [alpha]],
        T"list" "list" [alpha]] -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [alpha]],
          T"list" "list" [alpha]] --> bool)) --> bool)),
   V"rst" (T"list" "list" [alpha]), V"l" (T"list" "list" [alpha]),
   V"e" (alpha), V"h" (alpha), C"=" "min" ((alpha --> (alpha --> bool))),
   C"," "pair"
    ((alpha -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [alpha, T"list" "list" [alpha]]))),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   V"substitutel_tupled"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"list" "list" [alpha]],
        T"list" "list" [alpha]] --> T"list" "list" [alpha])),
   V"a"
    (T"prod" "pair"
      [T"prod" "pair" [alpha, T"list" "list" [alpha]],
       T"list" "list" [alpha]]),
   C"pair_case" "pair"
    (((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
       (T"list" "list" [alpha] --> T"list" "list" [alpha])) -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [alpha]],
         T"list" "list" [alpha]] --> T"list" "list" [alpha]))),
   V"v" (T"prod" "pair" [alpha, T"list" "list" [alpha]]),
   V"v1" (T"list" "list" [alpha]),
   C"pair_case" "pair"
    (((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha])) -->
      (T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
       T"list" "list" [alpha]))),
   C"list_case" "list"
    ((T"list" "list" [alpha] -->
      ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha])) -->
       (T"list" "list" [alpha] --> T"list" "list" [alpha])))),
   C"I" "combin" ((T"list" "list" [alpha] --> T"list" "list" [alpha])),
   C"NIL" "list" (T"list" "list" [alpha]),
   C"COND" "bool"
    ((bool -->
      (T"list" "list" [alpha] -->
       (T"list" "list" [alpha] --> T"list" "list" [alpha])))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))), V"s" (beta),
   C"=" "min"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))),
   C"sym2ptree" "closure"
    ((T"symbol" "regexp" [alpha, beta] -->
      T"ptree" "parseTree" [alpha, beta])),
   C"Leaf" "parseTree" ((beta --> T"ptree" "parseTree" [alpha, beta])),
   V"n" (alpha),
   C"Node" "parseTree"
    ((alpha -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"ptree" "parseTree" [alpha, beta]))),
   C"NIL" "list" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"=" "min"
    (((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]) -->
      ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]) -->
       bool))),
   C"fringe" "closure"
    ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [beta, alpha] -->
       (T"ptree" "parseTree" [beta, alpha] --> bool)) -->
      (((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]) -->
        (T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]))
       -->
       (T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])))),
   C"@" "min"
    ((((T"ptree" "parseTree" [beta, alpha] -->
        (T"ptree" "parseTree" [beta, alpha] --> bool)) --> bool) -->
      (T"ptree" "parseTree" [beta, alpha] -->
       (T"ptree" "parseTree" [beta, alpha] --> bool)))),
   V"R"
    ((T"ptree" "parseTree" [beta, alpha] -->
      (T"ptree" "parseTree" [beta, alpha] --> bool))),
   C"WF" "relation"
    (((T"ptree" "parseTree" [beta, alpha] -->
       (T"ptree" "parseTree" [beta, alpha] --> bool)) --> bool)),
   V"x" (beta),
   C"!" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [beta, alpha]] --> bool) -->
      bool)), V"ptl" (T"list" "list" [T"ptree" "parseTree" [beta, alpha]]),
   C"!" "bool" (((T"ptree" "parseTree" [beta, alpha] --> bool) --> bool)),
   V"a" (T"ptree" "parseTree" [beta, alpha]),
   C"MEM" "list"
    ((T"ptree" "parseTree" [beta, alpha] -->
      (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] --> bool))),
   C"Node" "parseTree"
    ((beta -->
      (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
       T"ptree" "parseTree" [beta, alpha]))),
   V"fringe"
    ((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])),
   C"ptree_case" "parseTree"
    (((alpha --> T"list" "list" [alpha]) -->
      ((beta -->
        (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
         T"list" "list" [alpha])) -->
       (T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha])))),
   V"tm" (alpha),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [alpha]] --> T"list" "list" [alpha])),
   C"MAP" "list"
    (((T"ptree" "parseTree" [beta, alpha] --> T"list" "list" [alpha]) -->
      (T"list" "list" [T"ptree" "parseTree" [beta, alpha]] -->
       T"list" "list" [T"list" "list" [alpha]]))),
   C"=" "min"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      ((T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta]) --> bool))),
   C"root" "closure"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   C"WFREC" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) -->
      (((T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta]) -->
        (T"ptree" "parseTree" [alpha, beta] -->
         T"symbol" "regexp" [alpha, beta])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))),
   C"@" "min"
    ((((T"ptree" "parseTree" [alpha, beta] -->
        (T"ptree" "parseTree" [alpha, beta] --> bool)) --> bool) -->
      (T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)))),
   V"R"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))),
   C"WF" "relation"
    (((T"ptree" "parseTree" [alpha, beta] -->
       (T"ptree" "parseTree" [alpha, beta] --> bool)) --> bool)),
   V"root"
    ((T"ptree" "parseTree" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   V"a" (T"ptree" "parseTree" [alpha, beta]),
   C"ptree_case" "parseTree"
    (((beta --> T"symbol" "regexp" [alpha, beta]) -->
      ((alpha -->
        (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
         T"symbol" "regexp" [alpha, beta])) -->
       (T"ptree" "parseTree" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))),
   C"I" "combin"
    ((T"symbol" "regexp" [alpha, beta] -->
      T"symbol" "regexp" [alpha, beta])),
   V"ptl" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   V"g''" (T"grammar" "grammarDef" [alpha, beta]), V"nt" (alpha),
   V"nt'" (alpha), V"g'" (T"grammar" "grammarDef" [alpha, beta]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"grNt2Nt'R" "closure"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"prod" "pair" [alpha, alpha] -->
       (T"grammar" "grammarDef" [alpha, beta] -->
        (T"grammar" "grammarDef" [alpha, beta] --> bool))))),
   C"," "pair" ((alpha --> (alpha --> T"prod" "pair" [alpha, alpha]))),
   C"IN" "bool"
    ((T"symbol" "regexp" [alpha, beta] -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) --> bool))),
   C"nonTerminals" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"grNt2Nt'" "closure"
    ((alpha -->
      (alpha -->
       (T"grammar" "grammarDef" [alpha, beta] -->
        T"grammar" "grammarDef" [alpha, beta])))),
   C"!" "bool"
    (((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool) -->
      bool)), V"p" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   V"s" (alpha),
   C"ruleNt2Nt'" "closure"
    ((alpha -->
      (alpha -->
       (T"rule" "grammarDef" [alpha, beta] -->
        T"rule" "grammarDef" [alpha, beta])))),
   C"rename" "closure" ((alpha --> (alpha --> (alpha --> alpha)))),
   C"MAP" "list"
    (((T"symbol" "regexp" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"rename" "closure"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] -->
       (T"symbol" "regexp" [alpha, beta] -->
        T"symbol" "regexp" [alpha, beta])))), V"x'" (alpha),
   C"COND" "bool" ((bool --> (alpha --> (alpha --> alpha)))), V"a" (alpha),
   C"stripNts" "closure" ((T"symbol" "regexp" [alpha, beta] --> alpha)),
   C"grConcat" "closure"
    ((alpha -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] -->
        T"grammar" "grammarDef" [alpha, beta])))),
   C"grClosure" "closure"
    ((alpha -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       T"grammar" "grammarDef" [alpha, beta]))),
   C"=" "min"
    ((((T"list" "list" [alpha] --> bool) -->
       (T"list" "list" [alpha] --> bool)) -->
      (((T"list" "list" [alpha] --> bool) -->
        (T"list" "list" [alpha] --> bool)) --> bool))),
   C"star" "closure"
    (((T"list" "list" [alpha] --> bool) -->
      (T"list" "list" [alpha] --> bool))),
   V"A" ((T"list" "list" [alpha] --> bool)),
   V"a0" (T"list" "list" [alpha]),
   C"!" "bool" ((((T"list" "list" [alpha] --> bool) --> bool) --> bool)),
   V"star'" ((T"list" "list" [alpha] --> bool)),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"IN" "bool"
    ((T"list" "list" [alpha] -->
      ((T"list" "list" [alpha] --> bool) --> bool))),
   C"?" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"s1" (T"list" "list" [alpha]), V"s2" (T"list" "list" [alpha]),
   V"w" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"w'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"RTC" "relation"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   C"derives" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   C"DISJOINT" "pred_set"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) --> bool))),
   C"IN" "bool"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       bool))),
   C"language" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"?" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)),
   C"EVERY" "list"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   V"y" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"MEM" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   V"lhs" (alpha),
   V"rhs" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   V"tm" (T"symbol" "regexp" [alpha, beta]),
   V"w1" (T"list" "list" [alpha]), V"w2" (T"list" "list" [alpha]),
   V"l'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"!" "bool" (((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool)),
   V"t" (T"ptree" "parseTree" [alpha, beta]),
   C"validptree" "parseTree"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"ptree" "parseTree" [alpha, beta] --> bool))),
   C"?" "bool" (((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool)),
   V"t'" (T"ptree" "parseTree" [alpha, beta]),
   C"MAP" "list"
    (((beta --> T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list" [beta] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"fringe" "closure"
    ((T"ptree" "parseTree" [alpha, beta] --> T"list" "list" [beta])),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"!" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool) -->
      bool)), V"l" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"MEM" "list"
    ((T"ptree" "parseTree" [alpha, beta] -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool))),
   V"n'" (alpha),
   V"ts" (T"list" "list" [T"ptree" "parseTree" [alpha, beta]]),
   C"MEM" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"getSymbols" "parseTree"
    ((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"l" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l1" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l2" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l1'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"l2'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   V"e'" (alpha), V"ptl" (T"list" "list" [alpha]),
   C"IS_SUFFIX" "rich_list"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, gamma] --> alpha)),
   V"gsub" (T"grammar" "grammarDef" [alpha, gamma]),
   V"s" (T"list" "list" [alpha]), V"t" (T"list" "list" [alpha]),
   V"t" (alpha), V"y" (T"rule" "grammarDef" [alpha, beta]),
   V"e'" (T"list" "list" [alpha]),
   C"!" "bool"
    ((((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        (beta -->
         ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
          bool))) --> bool) --> bool)),
   V"P"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (beta -->
       ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
        bool)))), V"v1" (beta),
   V"v2" ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)),
   C"!" "bool"
    ((((T"prod" "pair"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta]] -->
        (T"rule" "grammarDef" [alpha, beta] --> bool)) --> bool) -->
      bool)),
   V"P"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta]]
      --> (T"rule" "grammarDef" [alpha, beta] --> bool))),
   C"!" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"v" (T"symbol" "regexp" [alpha, beta]),
   V"v1" (T"symbol" "regexp" [alpha, beta]),
   V"v2" (T"rule" "grammarDef" [alpha, beta]),
   C"!" "bool"
    ((((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
        (T"list" "list" [alpha] --> bool)) --> bool) --> bool)),
   V"P"
    ((T"prod" "pair" [alpha, T"list" "list" [alpha]] -->
      (T"list" "list" [alpha] --> bool))), V"v" (alpha),
   V"v2" (T"list" "list" [alpha]),
   C"EVERY" "list"
    (((T"symbol" "regexp" [beta, alpha] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [beta, alpha]] --> bool))),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [beta, alpha] --> bool)),
   C"MAP" "list"
    (((alpha --> T"symbol" "regexp" [beta, alpha]) -->
      (T"list" "list" [alpha] -->
       T"list" "list" [T"symbol" "regexp" [beta, alpha]]))),
   C"TS" "regexp" ((alpha --> T"symbol" "regexp" [beta, alpha])),
   V"A" (alpha),
   C"listderiv" "relationLemmas"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   V"dl"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] --> bool)
      --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]),
   V"a" (T"symbol" "regexp" [alpha, beta]),
   V"b" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta],
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] --> bool))),
   C"isNonTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"?" "bool"
    (((T"list" "list" [T"ptree" "parseTree" [alpha, beta]] --> bool) -->
      bool)),
   C"MAP" "list"
    (((T"ptree" "parseTree" [alpha, beta] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"MAP" "list"
    (((T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
       T"symbol" "regexp" [alpha, beta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"FST" "pair"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta],
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
      T"symbol" "regexp" [alpha, beta])),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [beta]] --> T"list" "list" [beta])),
   C"MAP" "list"
    (((T"ptree" "parseTree" [alpha, beta] --> T"list" "list" [beta]) -->
      (T"list" "list" [T"ptree" "parseTree" [alpha, beta]] -->
       T"list" "list" [T"list" "list" [beta]]))),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
      --> T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   C"MAP" "list"
    (((T"prod" "pair"
        [T"symbol" "regexp" [alpha, beta],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp" [alpha, beta],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       T"list" "list"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   C"SND" "pair"
    ((T"prod" "pair"
       [T"symbol" "regexp" [alpha, beta],
        T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
      T"list" "list" [T"symbol" "regexp" [alpha, beta]])),
   V"e" (T"ptree" "parseTree" [alpha, beta]),
   C"isNode" "parseTree" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"MAP" "list"
    (((T"ptree" "parseTree" [gamma, beta] --> T"list" "list" [beta]) -->
      (T"list" "list" [T"ptree" "parseTree" [gamma, beta]] -->
       T"list" "list" [T"list" "list" [beta]]))),
   C"fringe" "closure"
    ((T"ptree" "parseTree" [gamma, beta] --> T"list" "list" [beta])),
   C"MAP" "list"
    (((beta --> T"ptree" "parseTree" [gamma, beta]) -->
      (T"list" "list" [beta] -->
       T"list" "list" [T"ptree" "parseTree" [gamma, beta]]))),
   C"Leaf" "parseTree" ((beta --> T"ptree" "parseTree" [gamma, beta])),
   C"MAP" "list"
    (((T"symbol" "regexp" [alpha, beta] --> beta) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [beta]))),
   C"ts2str" "regexp" ((T"symbol" "regexp" [alpha, beta] --> beta)),
   C"MAP" "list"
    (((beta --> T"ptree" "parseTree" [alpha, beta]) -->
      (T"list" "list" [beta] -->
       T"list" "list" [T"ptree" "parseTree" [alpha, beta]]))),
   C"isLeaf" "parseTree" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   C"!" "bool"
    ((((T"ptree" "parseTree" [alpha, beta] --> bool) --> bool) --> bool)),
   V"P" ((T"ptree" "parseTree" [alpha, beta] --> bool)),
   V"v" (T"ptree" "parseTree" [alpha, beta]),
   C"INFINITE" "pred_set" (((alpha --> bool) --> bool)),
   C"UNIV" "pred_set" ((alpha --> bool)),
   C"?" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool)),
   C"!" "bool"
    ((((T"symbol" "regexp" [alpha, beta] --> bool) --> bool) --> bool)),
   V"s" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"FINITE" "pred_set"
    (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   C"=" "min"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) --> bool))),
   C"INTER" "pred_set"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) -->
       (T"symbol" "regexp" [alpha, beta] --> bool)))),
   C"RTC" "relation"
    (((T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] --> bool)) -->
      (T"grammar" "grammarDef" [alpha, beta] -->
       (T"grammar" "grammarDef" [alpha, beta] --> bool)))),
   V"x" (T"grammar" "grammarDef" [alpha, beta]),
   V"y" (T"grammar" "grammarDef" [alpha, beta]),
   C"?" "bool" (((alpha --> bool) --> bool)),
   V"g0" (T"grammar" "grammarDef" [alpha, beta]),
   C"INSERT" "pred_set"
    ((T"symbol" "regexp" [alpha, beta] -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) -->
       (T"symbol" "regexp" [alpha, beta] --> bool)))),
   C"DELETE" "pred_set"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"symbol" "regexp" [alpha, beta] -->
       (T"symbol" "regexp" [alpha, beta] --> bool)))), V"nt" (beta),
   V"nt'" (beta),
   C"grNt2Nt'R" "closure"
    ((T"grammar" "grammarDef" [beta, gamma] -->
      (T"prod" "pair" [beta, beta] -->
       (T"grammar" "grammarDef" [beta, gamma] -->
        (T"grammar" "grammarDef" [beta, gamma] --> bool))))),
   V"g''" (T"grammar" "grammarDef" [beta, gamma]),
   C"," "pair" ((beta --> (beta --> T"prod" "pair" [beta, beta]))),
   V"g" (T"grammar" "grammarDef" [beta, gamma]),
   V"g0" (T"grammar" "grammarDef" [beta, gamma]), V"e" (beta),
   C"IN" "bool"
    ((T"symbol" "regexp" [beta, gamma] -->
      ((T"symbol" "regexp" [beta, gamma] --> bool) --> bool))),
   C"NTS" "regexp" ((beta --> T"symbol" "regexp" [beta, gamma])),
   C"nonTerminals" "grammarDef"
    ((T"grammar" "grammarDef" [beta, gamma] -->
      (T"symbol" "regexp" [beta, gamma] --> bool))),
   C"=" "min"
    ((T"symbol" "regexp" [beta, delta] -->
      (T"symbol" "regexp" [beta, delta] --> bool))),
   C"NTS" "regexp" ((beta --> T"symbol" "regexp" [beta, delta])),
   V"l'" (alpha), V"p" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"ntx" (alpha),
   V"p'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"lhs'" (alpha),
   V"rhs'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"g" (T"grammar" "grammarDef" [alpha, gamma]),
   V"ru" (T"rule" "grammarDef" [alpha, beta]),
   C"UNION" "pred_set"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      ((T"symbol" "regexp" [alpha, beta] --> bool) -->
       (T"symbol" "regexp" [alpha, beta] --> bool)))),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, gamma] -->
      (T"symbol" "regexp" [alpha, gamma] --> bool))),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, gamma])),
   V"pfx" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"sfx" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s1" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s2" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"UNION" "pred_set"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   V"u" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"w''" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"u'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"?" "bool" (((gamma --> bool) --> bool)), V"v'" (gamma),
   C"?" "bool" (((delta --> bool) --> bool)), V"u'" (delta),
   V"v'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"star" "closure"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   V"h" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"CONS" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       -->
       T"list" "list"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   V"h'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"t'"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]])]
  val DT = Thm.disk_thm share_table
  in
  val grUnion_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%2 (\%4. ((%5 (((%6 $2) $1) $0)) ((%7 ((%8
       ((%8 ((%8 (%9 $1)) (%9 $0))) ((%10 ((%11 $2) ((%12 (%13 (%14 $1)))
       %15))) %16))) ((%10 ((%11 $2) ((%12 (%13 (%14 $0))) %15))) %16)))
       $2))))))))`)
  val replace_curried_def =
    DT([], [],
       `(%17 (\%18. (%19 (\%20. (%21 (\%22. ((%23 (((%24 $2) $1) $0)) (%25
       ((%26 $2) ((%27 $1) $0))))))))))`)
  val replace_tupled_primitive_def =
    DT([], [],
       `((%28 %25) ((%29 (%30 (\%31. ((%32 (%33 $0)) ((%32 (%0 (\%34. (%21
       (\%35. (%19 (\%36. (%17 (\%37. (($4 ((%26 $0) ((%27 $1) $2))) ((%26
       ((%12 (%13 $3)) $0)) ((%27 $1) $2)))))))))))) ((%32 (%21 (\%35. (%17
       (\%37. (%19 (\%36. (%19 (\%38. ((%39 (%40 (%40 ((%41 $0) $1)))) (($4
       ((%26 $2) ((%27 $1) $3))) ((%26 ((%12 (%42 $0)) $2)) ((%27 $1)
       $3))))))))))))) (%21 (\%35. (%17 (\%37. (%19 (\%36. (%19 (\%38.
       ((%39 (%40 ((%41 $0) $1))) (($4 ((%26 $2) ((%27 $1) $3))) ((%26
       ((%12 (%42 $0)) $2)) ((%27 $1) $3)))))))))))))))))) (\%43. (\%44.
       ((%45 (\%46. (\%47. (((%48 ((%49 (\%36. (\%35. (%50 ((%51 %15)
       %52))))) $0)) (\%53. (\%37. (((%54 (\%34. ((%49 (\%55. (\%56. (%50
       ((%57 (%12 (%13 $2))) ($8 ((%26 $3) ((%27 $1) $0)))))))) $3)))
       (\%38. ((%49 (\%58. (\%59. (%50 (((%60 (%40 ((%41 $2) $1))) ((%57
       (%12 (%42 $2))) ($8 ((%26 $3) ((%27 $1) $0))))) ((%61 $0) ($8 ((%26
       $3) ((%27 $1) $0))))))))) $3))) $1)))) $1)))) $0)))))`)
  val substGr_def =
    DT(["DISK_THM"], [],
       `(%19 (\%62. (%2 (\%63. (%2 (\%64. ((%5 ((%65 ((%66 $2) $1)) $0))
       ((%7 ((%8 (%9 $1)) ((%67 (%68 ((%69 (%42 $2)) (%13 (%14 $1))))) (%9
       $0)))) (%14 $0)))))))))`)
  val substRule_curried_def =
    DT([], [],
       `(%70 (\%71. (%72 (\%73. ((%74 ((%68 $1) $0)) (%75 ((%76 $1)
       $0)))))))`)
  val substRule_tupled_primitive_def =
    DT([], [],
       `((%77 %75) ((%78 (%79 (\%80. (%81 $0)))) (\%82. (\%83. ((%84 (\%85.
       (\%86. ((%87 (\%88. (\%89. ((%90 (\%91. (\%92. (%93 ((%11 $1) ((%94
       ((%95 $3) ((%12 $2) %15))) $0)))))) $2)))) $1)))) $0)))))`)
  val substitutel_curried_def =
    DT([], [],
       `(%96 (\%97. (%98 (\%99. ((%100 ((%101 $1) $0)) (%102 ((%103 $1)
       $0)))))))`)
  val substitutel_tupled_primitive_def =
    DT([], [],
       `((%104 %102) ((%105 (%106 (\%107. ((%32 (%108 $0)) ((%32 (%98
       (\%109. (%98 (\%110. (%0 (\%111. (%0 (\%112. ((%39 (%40 ((%113 $0)
       $1))) (($4 ((%103 ((%114 $1) $2)) $3)) ((%103 ((%114 $1) $2)) ((%115
       $0) $3))))))))))))) (%98 (\%109. (%98 (\%110. (%0 (\%111. (%0
       (\%112. ((%39 ((%113 $0) $1)) (($4 ((%103 ((%114 $1) $2)) $3))
       ((%103 ((%114 $1) $2)) ((%115 $0) $3))))))))))))))))) (\%116.
       (\%117. ((%118 (\%119. (\%120. ((%121 (\%111. (\%110. (((%122 (%123
       %124)) (\%112. (\%109. (%123 (((%125 ((%113 $1) $3)) ((%126 $2) ($7
       ((%103 ((%114 $3) $2)) $0)))) ((%115 $1) ($7 ((%103 ((%114 $3) $2))
       $0)))))))) $2)))) $1)))) $0)))))`)
  val sym2ptree_def =
    DT(["DISK_THM"], [],
       `((%32 (%19 (\%127. ((%128 (%129 (%42 $0))) (%130 $0))))) (%0
       (\%131. ((%128 (%129 (%13 $0))) ((%132 $0) %133)))))`)
  val fringe_defn_primitive_def =
    DT([], [],
       `((%134 %135) ((%136 (%137 (\%138. ((%32 (%139 $0)) (%19 (\%140.
       (%141 (\%142. (%143 (\%144. ((%39 ((%145 $0) $1)) (($3 $0) ((%146
       $2) $1))))))))))))) (\%147. (\%144. (((%148 (\%149. (%123 ((%115 $0)
       %124)))) (\%140. (\%142. (%123 (%150 ((%151 (\%144. ($4 $0)))
       $0)))))) $0)))))`)
  val root_primitive_def =
    DT([], [],
       `((%152 %153) ((%154 (%155 (\%156. (%157 $0)))) (\%158. (\%159.
       (((%160 (\%62. (%161 (%42 $0)))) (\%34. (\%162. (%161 (%13 $1)))))
       $0)))))`)
  val grNt2Nt'R_def =
    DT(["DISK_THM"], [],
       `(%2 (\%163. (%0 (\%164. (%0 (\%165. (%2 (\%64. (%2 (\%166. ((%167
       ((((%168 $4) ((%169 $3) $2)) $1) $0)) ((%32 (%40 ((%170 (%13 $2))
       (%171 $4)))) ((%5 (((%172 $3) $2) $1)) $0)))))))))))))`)
  val grNt2Nt'_def =
    DT(["DISK_THM"], [],
       `(%0 (\%164. (%0 (\%165. (%173 (\%174. (%0 (\%175. ((%5 (((%172 $3)
       $2) ((%7 $1) $0))) ((%7 ((%67 ((%176 $3) $2)) $1)) (((%177 $3) $2)
       $0)))))))))))`)
  val ruleNt2Nt'_def =
    DT(["DISK_THM"], [],
       `(%0 (\%164. (%0 (\%165. (%0 (\%91. (%17 (\%92. ((%74 (((%176 $3)
       $2) ((%11 $1) $0))) ((%11 (((%177 $3) $2) $1)) ((%178 ((%179 (%13
       $3)) (%13 $2))) $0)))))))))))`)
  val rename_def =
    DT([], [],
       `(%0 (\%34. (%0 (\%180. (%0 (\%111. ((%113 (((%177 $2) $1) $0))
       (((%181 ((%113 $0) $2)) $1) $0))))))))`)
  val stripNts_def =
    DT(["DISK_THM"], [], `(%0 (\%182. ((%113 (%183 (%13 $0))) $0)))`)
  val grConcat_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%2 (\%4. ((%5 (((%184 $2) $1) $0)) ((%7 ((%8
       ((%8 (%9 $1)) (%9 $0))) ((%10 ((%11 $2) ((%12 (%13 (%14 $1))) ((%12
       (%13 (%14 $0))) %15)))) %16))) $2))))))))`)
  val grClosure_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%64. ((%5 ((%185 $1) $0)) ((%7 ((%8 ((%8 (%9 $0))
       ((%10 ((%11 $1) ((%12 (%13 (%14 $0))) ((%12 (%13 $1)) %15)))) %16)))
       ((%10 ((%11 $1) %15)) %16))) $1))))))`)
  val star =
    DT([], [],
       `((%186 %187) (\%188. (\%189. (%190 (\%191. ((%39 (%98 (\%189. ((%39
       ((%192 ((%100 $0) %124)) ((%192 ((%193 $0) $3)) (%194 (\%195. (%194
       (\%196. ((%32 ((%100 $2) ((%126 $1) $0))) ((%32 ((%193 $1) $5)) ($3
       $0)))))))))) ($1 $0))))) ($0 $1)))))))`)
  val gruDerivFrmg1 =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %3)) $1) $0)) (((%199
       (%200 (((%6 %1) %3) %4))) $1) $0))))))`)
  val gruRtcSsg2 =
    DT(["DISK_THM"], [],
       `(((%199 (%200 (((%6 %1) %3) %4))) ((%12 (%13 %1)) %15)) ((%12 (%13
       (%14 %4))) %15))`)
  val gruRtcSsg1 =
    DT(["DISK_THM"], [],
       `(((%199 (%200 (((%6 %1) %3) %4))) ((%12 (%13 %1)) %15)) ((%12 (%13
       (%14 %3))) %15))`)
  val substThm =
    DT(["DISK_THM", "tactic_failed"], [],
       `((%39 ((%201 (%171 %64)) (%171 %63))) ((%167 ((%202 %198) (%203
       ((%65 ((%66 %62) %63)) %64)))) (%204 (\%197. ((%32 ((%202 $0) (%203
       %64))) ((%202 %198) (((%24 $0) %62) (%203 %63))))))))`)
  val substImpGr =
    DT(["DISK_THM", "tactic_failed"], [],
       `((%39 ((%32 ((%201 (%171 %64)) (%171 %63))) ((%202 %198) (%203
       ((%65 ((%66 %62) %63)) %64))))) (%204 (\%197. ((%32 ((%202 $0) (%203
       %64))) ((%202 %198) (((%24 $0) %62) (%203 %63)))))))`)
  val grImpSubst =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%201 (%171 %64)) (%171 %63))) ((%32 ((%202 %197)
       (%203 %64))) ((%202 %198) (((%24 %197) %62) (%203 %63)))))) ((%202
       %198) (%203 ((%65 ((%66 %62) %63)) %64))))`)
  val replTmnls =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 ((%205 %206) $1)) ((%39 ((%202 $0)
       (((%24 $1) %62) (%203 %64)))) ((%205 %206) $0)))))))`)
  val sblImprepl =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 ((%202 $0) (((%24 $1) %62) (%203
       %63)))) (((%199 (%200 ((%65 ((%66 %62) %63)) %64))) ((%94 ((%95 (%42
       %62)) ((%12 (%13 (%14 %63))) %15))) $1)) $0))))))`)
  val gsubRtcd =
    DT(["DISK_THM"], [],
       `(%17 (\%18. (%17 (\%207. ((%39 (((%199 (%200 %63)) $1) $0)) (((%199
       (%200 ((%65 ((%66 %62) %63)) %64))) $1) $0))))))`)
  val gsubDerives =
    DT(["DISK_THM"], [],
       `((%39 (((%200 %63) %18) %207)) (((%200 ((%65 ((%66 %62) %63)) %64))
       %18) %207))`)
  val grSSymRtcdSubs =
    DT(["DISK_THM"], [],
       `(%17 (\%208. (%17 (\%197. ((%39 (((%199 (%200 %64)) $1) $0)) ((%39
       ((%209 $1) ((%12 (%13 (%14 %64))) %15))) (((%199 (%200 ((%65 ((%66
       %62) %63)) %64))) ((%12 (%13 (%14 %64))) %15)) ((%94 ((%95 (%42
       %62)) ((%12 (%13 (%14 %63))) %15))) $0))))))))`)
  val derivgImpsbg =
    DT(["DISK_THM"], [],
       `((%39 (((%200 %64) %197) %198)) (((%200 ((%65 ((%66 %62) %63))
       %64)) ((%94 ((%95 (%42 %62)) ((%12 (%13 (%14 %63))) %15))) %197))
       ((%94 ((%95 (%42 %62)) ((%12 (%13 (%14 %63))) %15))) %198)))`)
  val memRuleInsbg =
    DT(["DISK_THM"], [],
       `((%39 ((%210 ((%11 %211) %212)) (%9 %64))) ((%210 ((%11 %211) ((%94
       ((%95 (%42 %62)) ((%12 (%13 (%14 %63))) %15))) %212))) (%9 ((%65
       ((%66 %62) %63)) %64))))`)
  val sblRuleMemMapsbr =
    DT(["DISK_THM"], [],
       `(%173 (\%213. ((%39 ((%210 ((%11 %211) %212)) $0)) ((%210 ((%11
       %211) ((%94 ((%95 %214) ((%12 (%13 %131)) %15))) %212))) ((%67 (%68
       ((%69 %214) (%13 %131)))) $0)))))`)
  val sblAppend =
    DT(["DISK_THM"], [],
       `(%98 (\%215. (%98 (\%216. ((%100 ((%101 ((%114 %149) %110)) ((%126
       $1) $0))) ((%126 ((%101 ((%114 %149) %110)) $1)) ((%101 ((%114 %149)
       %110)) $0)))))))`)
  val sb1 =
    DT(["DISK_THM"], [],
       `((%39 (%206 %214)) ((%209 ((%94 ((%95 %214) %217)) ((%12 (%13
       %175)) %15))) ((%12 (%13 %175)) %15)))`)
  val sbSSymEq =
    DT(["DISK_THM"], [],
       `((%113 (%14 %64)) (%14 ((%65 ((%66 %62) %63)) %64)))`)
  val vptSbgrImpGr =
    DT(["DISK_THM"], [],
       `(%2 (\%64. (%218 (\%219. ((%39 ((%32 ((%220 ((%65 ((%66 %36) %63))
       $1)) $0)) ((%32 ((%170 (%153 $0)) (%171 $1))) ((%201 (%171 $1))
       (%171 %63))))) (%221 (\%222. (%204 (\%197. ((%32 ((%209 ((%223 %42)
       (%224 $1))) $0)) ((%32 ((%202 ((%223 %42) (%224 $2))) (((%24 $0)
       %36) (%203 %63)))) ((%32 ((%220 $3) $1)) ((%225 (%153 $1)) (%153
       $2))))))))))))))`)
  val vptgsubInLang =
    DT(["DISK_THM"], [],
       `(%2 (\%166. (%218 (\%219. ((%39 ((%220 $1) $0)) ((%39 ((%5 $1)
       ((%65 ((%66 %36) %63)) %64))) ((%39 ((%201 (%171 %64)) (%171 %63)))
       ((%39 ((%170 (%153 $0)) (%171 %63))) (((%199 (%200 %63)) ((%12 (%153
       $0)) %15)) ((%223 %42) (%224 $0)))))))))))`)
  val memGetSyms =
    DT(["DISK_THM"], [],
       `(%226 (\%227. ((%39 ((%228 ((%132 %229) %230)) $0)) ((%231 (%13
       %229)) (%232 $0)))))`)
  val memRulegsub =
    DT(["DISK_THM"], [],
       `((%39 ((%201 (%171 %64)) (%171 %63))) ((%39 ((%170 (%13 %131))
       (%171 %63))) ((%39 ((%210 ((%11 %131) %233)) (%9 ((%65 ((%66 %36)
       %63)) %64)))) ((%210 ((%11 %131) %233)) (%9 %63)))))`)
  val replaceApp =
    DT(["DISK_THM"], [],
       `(%17 (\%234. (%17 (\%235. (%17 (\%236. (%17 (\%237. ((%39 ((%32
       ((%202 $1) (((%24 $3) %36) %35))) ((%202 $0) (((%24 $2) %36) %35))))
       ((%202 ((%238 $1) $0)) (((%24 ((%238 $3) $2)) %36) %35)))))))))))`)
  val sbgNtsIng =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%201 (%171 %64)) (%171 %63))) ((%32 ((%170 (%13
       %131)) (%171 %64))) ((%210 ((%11 %131) %212)) (%9 ((%65 ((%66 %36)
       %63)) %64)))))) (%0 (\%111. ((%39 ((%231 (%13 $0)) %212)) ((%192
       ((%113 $0) (%14 %63))) ((%170 (%13 $0)) (%171 %64)))))))`)
  val sbl1Mem =
    DT(["DISK_THM"], [],
       `(%98 (\%110. ((%39 ((%239 %34) ((%101 ((%114 %111) ((%115 %240)
       %124))) $0))) ((%192 ((%113 %34) %240)) ((%239 %34) $0)))))`)
  val isSfxMem =
    DT(["DISK_THM"], [],
       `(%98 (\%241. (%98 (\%110. ((%39 ((%242 $1) $0)) (%0 (\%111. ((%39
       ((%239 $0) $1)) ((%239 $0) $2)))))))))`)
  val notMemSymsbg =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%210 ((%11 %131) %233)) (%9 ((%65 ((%66 %36) %63))
       %64)))) ((%32 ((%170 (%13 %131)) (%171 %64))) ((%201 (%171 %64))
       (%171 %63))))) (%40 ((%231 (%42 %36)) %233)))`)
  val notMemsbl =
    DT(["DISK_THM"], [],
       `(%17 (\%233. (%40 ((%231 (%42 %36)) ((%94 ((%95 (%42 %36)) ((%12
       (%13 (%243 %244))) %15))) $0)))))`)
  val IS_SUFFIX_CONS2_E =
    DT(["DISK_THM"], [],
       `((%39 ((%242 %245) ((%115 %112) %246))) ((%242 %245) %246))`)
  val substTwice =
    DT(["DISK_THM"], [],
       `(%98 (\%110. ((%39 (%40 ((%239 %131) $0))) ((%100 ((%101 ((%114
       %131) ((%115 %247) %124))) ((%101 ((%114 %247) ((%115 %131) %124)))
       $0))) $0))))`)
  val ruleNilsbg =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%210 ((%11 %131) %15)) (%9 ((%65 ((%66 %36) %63))
       %64)))) ((%32 ((%170 (%13 %131)) (%171 %64))) ((%201 (%171 %64))
       (%171 %63))))) ((%210 ((%11 %131) %15)) (%9 %64)))`)
  val subsEqNil =
    DT(["DISK_THM"], [],
       `((%32 ((%167 ((%74 ((%11 %131) %15)) ((%68 ((%69 %88) %89)) %248)))
       ((%74 %248) ((%11 %131) %15)))) ((%167 ((%74 ((%68 ((%69 %88) %89))
       %248)) ((%11 %131) %15))) ((%74 %248) ((%11 %131) %15))))`)
  val substlEqNil =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%100 %249) %124))) ((%32 ((%167 ((%100 ((%101 ((%114
       %111) %249)) %110)) %124)) ((%100 %110) %124))) ((%167 ((%100 %124)
       ((%101 ((%114 %111) %249)) %110))) ((%100 %110) %124))))`)
  val replace_def =
    DT(["DISK_THM"], [],
       `((%32 (%19 (\%36. (%21 (\%35. ((%23 (((%24 %15) $1) $0)) ((%51 %15)
       %52))))))) ((%32 (%0 (\%34. (%19 (\%36. (%21 (\%35. (%17 (\%37.
       ((%23 (((%24 ((%12 (%13 $3)) $0)) $2) $1)) ((%57 (%12 (%13 $3)))
       (((%24 $0) $2) $1)))))))))))) (%19 (\%38. (%19 (\%36. (%21 (\%35.
       (%17 (\%37. ((%23 (((%24 ((%12 (%42 $3)) $0)) $2) $1)) (((%60 (%40
       ((%41 $3) $2))) ((%57 (%12 (%42 $3))) (((%24 $0) $2) $1))) ((%61 $1)
       (((%24 $0) $2) $1))))))))))))))`)
  val replace_ind =
    DT(["DISK_THM"], [],
       `(%250 (\%251. ((%39 ((%32 (%19 (\%36. (%21 (\%35. ((($2 %15) $1)
       $0)))))) ((%32 (%0 (\%34. (%17 (\%37. (%19 (\%36. (%21 (\%35. ((%39
       ((($4 $2) $1) $0)) ((($4 ((%12 (%13 $3)) $2)) $1) $0))))))))))) (%19
       (\%38. (%17 (\%37. (%19 (\%36. (%21 (\%35. ((%39 ((%32 ((%39 (%40
       (%40 ((%41 $3) $1)))) ((($4 $2) $1) $0))) ((%39 (%40 ((%41 $3) $1)))
       ((($4 $2) $1) $0)))) ((($4 ((%12 (%42 $3)) $2)) $1) $0)))))))))))))
       (%17 (\%46. (%19 (\%252. (%21 (\%253. ((($3 $2) $1) $0))))))))))`)
  val substRule_def =
    DT(["DISK_THM"], [],
       `((%74 ((%68 ((%69 %88) %89)) ((%11 %91) %92))) ((%11 %91) ((%94
       ((%95 %88) ((%12 %89) %15))) %92)))`)
  val substRule_ind =
    DT(["DISK_THM"], [],
       `(%254 (\%255. ((%39 (%256 (\%88. (%256 (\%89. (%0 (\%91. (%17
       (\%92. (($4 ((%69 $3) $2)) ((%11 $1) $0))))))))))) (%256 (\%257.
       (%256 (\%258. (%72 (\%259. (($3 ((%69 $2) $1)) $0))))))))))`)
  val substitutel_def =
    DT(["DISK_THM"], [],
       `((%32 (%98 (\%110. (%0 (\%111. ((%100 ((%101 ((%114 $0) $1)) %124))
       %124)))))) (%98 (\%109. (%98 (\%110. (%0 (\%112. (%0 (\%111. ((%100
       ((%101 ((%114 $0) $2)) ((%115 $1) $3))) (((%125 ((%113 $1) $0))
       ((%126 $2) ((%101 ((%114 $0) $2)) $3))) ((%115 $1) ((%101 ((%114 $0)
       $2)) $3)))))))))))))`)
  val substitutel_ind =
    DT(["DISK_THM"], [],
       `(%260 (\%261. ((%39 ((%32 (%0 (\%111. (%98 (\%110. (($2 ((%114 $1)
       $0)) %124)))))) (%0 (\%111. (%98 (\%110. (%0 (\%112. (%98 (\%109.
       ((%39 ((%32 ((%39 (%40 ((%113 $1) $3))) (($4 ((%114 $3) $2)) $0)))
       ((%39 ((%113 $1) $3)) (($4 ((%114 $3) $2)) $0)))) (($4 ((%114 $3)
       $2)) ((%115 $1) $0))))))))))))) (%0 (\%262. (%98 (\%120. (%98
       (\%263. (($3 ((%114 $2) $1)) $0))))))))))`)
  val ptLangThm =
    DT(["DISK_THM", "tactic_failed"], [],
       `(%17 (\%197. ((%167 ((%202 $0) (%203 %64))) (%221 (\%219. ((%32
       ((%220 %64) $0)) ((%32 ((%209 ((%223 %42) (%224 $0))) $1)) ((%225
       (%153 $0)) (%13 (%14 %64))))))))))`)
  val everyTmMapTs =
    DT(["DISK_THM"], [], `(%98 (\%110. ((%264 %265) ((%266 %267) $0))))`)
  val rtcdImpVpt =
    DT(["DISK_THM", "tactic_failed"], [],
       `(%0 (\%268. (%17 (\%207. ((%39 ((((%269 (%200 %64)) %270) ((%12
       (%13 $1)) %15)) $0)) ((%39 ((%205 %206) $0)) (%221 (\%219. ((%32
       ((%220 %64) $0)) ((%32 ((%209 ((%223 %42) (%224 $0))) $1)) ((%225
       (%153 $0)) (%13 $2))))))))))))`)
  val lpexImpvpt =
    DT(["DISK_THM"], [],
       `(%271 (\%272. ((%39 (%256 (\%273. (%17 (\%274. ((%39 ((%275 ((%95
       $1) $0)) $2)) ((%32 ((%39 (%276 $1)) (%221 (\%219. ((%32 ((%220 %64)
       $0)) ((%32 ((%209 ((%223 %42) (%224 $0))) $1)) ((%225 (%153 $0))
       $2))))))) ((%39 (%206 $1)) ((%209 ((%12 $1) %15)) $0))))))))) (%277
       (\%230. ((%32 ((%209 ((%278 %153) $0)) ((%279 %280) $1))) ((%32
       ((%209 ((%223 %42) (%281 ((%282 %224) $0)))) (%283 ((%284 %285)
       $1)))) (%218 (\%286. ((%39 ((%32 ((%228 $0) $1)) (%287 $0))) ((%220
       %64) $0)))))))))))`)
  val fringeTmsEq =
    DT(["DISK_THM"], [],
       `((%39 ((%205 %206) %18)) ((%209 ((%223 %42) (%281 ((%288 %289)
       ((%290 %291) ((%292 %293) %18)))))) %18))`)
  val getSymsTmsEq =
    DT(["DISK_THM"], [],
       `((%39 ((%205 %206) %18)) ((%209 (%232 ((%294 %130) ((%292 %293)
       %18)))) %18))`)
  val vptRtcd =
    DT(["DISK_THM"], [],
       `(%2 (\%64. (%218 (\%219. ((%39 ((%220 $1) $0)) (((%199 (%200 $1))
       ((%12 (%153 $0)) %15)) ((%223 %42) (%224 $0))))))))`)
  val getSymsEqRoot =
    DT(["DISK_THM"], [],
       `(%226 (\%162. ((%209 (%232 $0)) ((%278 %153) $0))))`)
  val ptlRtcd =
    DT(["DISK_THM"], [],
       `(%226 (\%162. ((%39 (%218 (\%286. ((%39 ((%228 $0) $1)) (((%199
       (%200 %64)) ((%12 (%153 $0)) %15)) ((%223 %42) (%224 $0)))))))
       (((%199 (%200 %64)) ((%278 %153) $0)) ((%223 %42) (%281 ((%282 %224)
       $0)))))))`)
  val leafRtcd =
    DT(["DISK_THM"], [],
       `(%218 (\%219. ((%39 (%295 $0)) (((%199 (%200 %64)) ((%12 (%153 $0))
       %15)) ((%223 %42) (%224 $0))))))`)
  val root_def =
    DT(["DISK_THM"], [],
       `((%32 ((%225 (%153 (%130 %62))) (%42 %62))) ((%225 (%153 ((%132
       %34) %162))) (%13 %34)))`)
  val root_ind =
    DT(["DISK_THM"], [],
       `(%296 (\%297. ((%39 ((%32 (%19 (\%62. ($1 (%130 $0))))) (%0 (\%34.
       (%226 (\%162. ($2 ((%132 $1) $0)))))))) (%218 (\%298. ($1 $0))))))`)
  val disjoint =
    DT(["DISK_THM"], [],
       `((%39 (%299 %300)) (%301 (\%166. ((%32 ((%23 (%203 %64)) (%203
       $0))) ((%201 (%171 $0)) (%171 %163))))))`)
  val grNt2Nt'RAll =
    DT(["DISK_THM"], [],
       `(%302 (\%303. ((%39 (%304 $0)) (%2 (\%64. (%2 (\%163. ((%39 ((%305
       $2) ((%306 (%171 $1)) (%171 $0)))) ((%39 (%299 %300)) (%301 (\%166.
       ((%32 (((%307 (\%308. (\%309. (%310 (\%164. (%310 (\%165. ((((%168
       $5) ((%169 $1) $0)) $3) $2)))))))) $2) $0)) ((%32 ((%23 (%203 $2))
       (%203 $0))) ((%201 (%171 $0)) (%171 $1)))))))))))))))`)
  val grNt2Nt'RNts =
    DT(["DISK_THM"], [],
       `((%39 ((((%168 %163) ((%169 %164) %165)) %64) %311)) ((%39 (%40
       ((%113 %164) %165))) ((%39 ((%170 (%13 %164)) (%171 %64))) ((%305
       (%171 %311)) ((%312 (%13 %165)) ((%313 (%171 %64)) (%13
       %164)))))))`)
  val grNt2Nt'RNtInNewg =
    DT(["DISK_THM"], [],
       `(%0 (\%91. ((%39 ((%32 (%40 ((%41 %314) %315))) ((((%316 %317)
       ((%318 %314) %315)) %319) %320))) (%19 (\%321. ((%39 ((%322 (%323
       $0)) (%324 %320))) ((%192 ((%41 $0) %315)) ((%32 ((%322 (%323 $0))
       (%324 %319))) (%40 ((%41 $0) %314))))))))))`)
  val grNt2Nt'RNtSame =
    DT(["DISK_THM"], [],
       `(%0 (\%91. ((%39 (%40 ((%41 %314) %315))) ((%39 ((((%316 %317)
       ((%318 %314) %315)) %319) %320)) (%19 (\%321. ((%39 ((%32 ((%322
       (%323 $0)) (%324 %319))) (%40 ((%325 (%326 $0)) (%326 %314)))))
       ((%322 (%323 $0)) (%324 %320)))))))))`)
  val ruleNt2Nt'Mem2' =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%210 ((%11 %327) ((%238 ((%238 %328) ((%12 (%13
       %329)) %15))) %208))) %213)) (%40 ((%113 %329) %164)))) (%310
       (\%211. (%204 (\%330. (%204 (\%331. ((%210 ((%11 $2) ((%238 ((%238
       $1) ((%12 (%13 %329)) %15))) $0))) ((%67 ((%176 %164) %165))
       %213)))))))))`)
  val ruleNt2Nt'Mem1' =
    DT(["DISK_THM"], [],
       `(%173 (\%213. ((%39 ((%32 ((%210 ((%11 %329) %212)) $0)) (%40
       ((%113 %329) %164)))) ((%210 ((%11 %329) ((%178 ((%179 (%13 %164))
       (%13 %165))) %212))) ((%67 ((%176 %164) %165)) $0)))))`)
  val grNt2Nt'RSymInG' =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%113 %164) %165))) ((%39 ((%170 (%13 %164)) (%171
       %64))) ((%39 ((((%168 %163) ((%169 %164) %165)) %64) %311)) ((%170
       (%13 %165)) (%171 %311)))))`)
  val grNt2Nt'RSymInRuleG' =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%113 %164) %165))) ((%39 ((%170 (%13 %164)) (%171
       %64))) ((%39 ((((%168 %163) ((%169 %164) %165)) %64) %311)) (%204
       (\%212. ((%192 ((%210 ((%11 %165) $0)) (%9 %311))) (%310 (\%91.
       (%204 (\%328. (%204 (\%208. ((%192 ((%210 ((%11 $2) ((%238 ((%238
       $1) ((%12 (%13 %165)) %15))) $0))) (%9 %311))) ((%113 %165) (%14
       %311)))))))))))))))`)
  val ruleNt2Nt'Mem2 =
    DT(["DISK_THM"], [],
       `((%39 ((%210 ((%11 %327) ((%238 ((%238 %328) ((%12 (%13 %164))
       %15))) %208))) %213)) (%310 (\%211. (%204 (\%330. (%204 (\%331.
       ((%210 ((%11 $2) ((%238 ((%238 $1) ((%12 (%13 %165)) %15))) $0)))
       ((%67 ((%176 %164) %165)) %213)))))))))`)
  val ruleNt2Nt'MemInOld =
    DT(["DISK_THM"], [],
       `((%39 ((%210 ((%11 %211) ((%238 ((%238 %328) ((%12 (%13 %34))
       %15))) %208))) ((%67 ((%176 %164) %165)) %213))) ((%32 ((%39 ((%113
       %34) %165)) ((%192 (%310 (\%332. (%204 (\%330. (%204 (\%331. ((%210
       ((%11 $2) ((%238 ((%238 $1) ((%12 (%13 %164)) %15))) $0)))
       %213)))))))) (%310 (\%332. (%204 (\%330. (%204 (\%331. ((%210 ((%11
       $2) ((%238 ((%238 $1) ((%12 (%13 %165)) %15))) $0))) %213))))))))))
       ((%39 (%40 ((%113 %34) %165))) (%310 (\%332. (%204 (\%330. (%204
       (\%331. ((%210 ((%11 $2) ((%238 ((%238 $1) ((%12 (%13 %34)) %15)))
       $0))) %213))))))))))`)
  val renameNtNeNt'InList =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (%40 ((%113 %34) %165))) ((%231 (%13 %34)) ((%178
       ((%179 (%13 %164)) (%13 %165))) %233)))) ((%231 (%13 %34)) %233))`)
  val renameNtInList =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%231 (%13 %165)) %233))) ((%39 ((%231 (%13 %165))
       ((%178 ((%179 (%13 %164)) (%13 %165))) %233))) ((%231 (%13 %164))
       %233)))`)
  val mapRenameListEq =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (%40 ((%231 (%13 %165)) %233))) ((%209 %217) ((%178
       ((%179 (%13 %164)) (%13 %165))) %233)))) ((%209 %233) ((%178 ((%179
       (%13 %165)) (%13 %164))) %217)))`)
  val ruleNt2Nt'Repl =
    DT(["DISK_THM"], [],
       `(%173 (\%213. ((%39 ((%32 (%40 ((%113 %164) %165))) ((%210 ((%11
       %211) %212)) ((%67 ((%176 %164) %165)) $0)))) ((%32 (%40 ((%113
       %211) %164))) (%40 ((%231 (%13 %164)) %212))))))`)
  val renameNtNotMem =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%113 %164) %165))) (%40 ((%231 (%13 %164)) ((%178
       ((%179 (%13 %164)) (%13 %165))) %233))))`)
  val ruleNt2Nt'Mem1 =
    DT(["DISK_THM"], [],
       `((%39 ((%210 ((%11 %164) %212)) %213)) (%204 (\%333. ((%210 ((%11
       %165) $0)) ((%67 ((%176 %164) %165)) %213)))))`)
  val nt2nt'LangEq =
    DT(["DISK_THM"], [],
       `((%39 (%299 %300)) ((%39 (%40 ((%170 (%13 %165)) (%171 %64))))
       ((%23 (%203 %64)) (%203 (((%172 %164) %165) %64)))))`)
  val renameRtcDImpD =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 (((%172 %164) %165)
       %64))) $1) $0)) ((%39 (%40 ((%170 (%13 %165)) (%171 %64)))) (((%199
       (%200 %64)) ((%178 ((%179 (%13 %165)) (%13 %164))) $1)) ((%178
       ((%179 (%13 %165)) (%13 %164))) $0))))))))`)
  val renameDImpD =
    DT(["DISK_THM"], [],
       `((%39 (((%200 (((%172 %164) %165) %64)) %197) %198)) ((%39 (%40
       ((%170 (%13 %165)) (%171 %64)))) (((%200 %64) ((%178 ((%179 (%13
       %165)) (%13 %164))) %197)) ((%178 ((%179 (%13 %165)) (%13 %164)))
       %198))))`)
  val nt2nt'RuleInG =
    DT(["DISK_THM"], [],
       `((%39 ((%210 ((%11 %211) %212)) (%9 (((%172 %164) %165) %64))))
       ((%39 (%40 ((%170 (%13 %165)) (%171 %64)))) ((%210 ((%11 (((%177
       %165) %164) %211)) ((%178 ((%179 (%13 %165)) (%13 %164))) %212)))
       (%9 %64))))`)
  val nt2nt'ListRuleInG =
    DT(["DISK_THM"], [],
       `(%173 (\%213. ((%39 ((%32 ((%210 ((%11 %211) %212)) ((%67 ((%176
       %164) %165)) $0))) (%40 (%204 (\%212. ((%192 ((%210 ((%11 %165) $0))
       $1)) (%310 (\%211. (%204 (\%328. (%204 (\%208. ((%192 ((%210 ((%11
       $2) ((%238 ((%238 $1) ((%12 (%13 %165)) %15))) $0))) $4)) ((%113
       %165) (%243 %334))))))))))))))) ((%210 ((%11 (((%177 %165) %164)
       %211)) ((%178 ((%179 (%13 %165)) (%13 %164))) %212))) $0))))`)
  val mapRenameTwice =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%231 (%13 %165)) %233))) ((%209 ((%178 ((%179 (%13
       %165)) (%13 %164))) ((%178 ((%179 (%13 %164)) (%13 %165))) %233)))
       %233))`)
  val renameTwice =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%113 %165) %131))) ((%113 (((%177 %165) %164) (((%177
       %164) %165) %131))) %131))`)
  val rtcDerivImpRenameD =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %64)) $1) $0))
       (((%199 (%200 (((%172 %164) %165) %64))) ((%178 ((%179 (%13 %164))
       (%13 %165))) $1)) ((%178 ((%179 (%13 %164)) (%13 %165))) $0)))))))`)
  val renameAllTms =
    DT(["DISK_THM"], [],
       `((%39 ((%205 %206) %197)) ((%209 ((%178 ((%179 (%13 %164)) (%13
       %165))) %197)) %197))`)
  val derivImpRenameD =
    DT(["DISK_THM"], [],
       `((%39 (((%200 %64) %197) %198)) (((%200 (((%172 %164) %165) %64))
       ((%178 ((%179 (%13 %164)) (%13 %165))) %197)) ((%178 ((%179 (%13
       %164)) (%13 %165))) %198)))`)
  val renameRuleSame =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (%40 ((%170 (%13 %164)) (%171 %64)))) ((%210 %335) (%9
       %64)))) ((%74 (((%176 %164) %165) %335)) %335))`)
  val renameListSame =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%231 (%13 %164)) %233))) ((%209 ((%178 ((%179 (%13
       %164)) (%13 %165))) %233)) %233))`)
  val gruDerivFrmg2 =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %4)) $1) $0)) (((%199
       (%200 (((%6 %1) %3) %4))) $1) $0))))))`)
  val gruStartRuleRhs =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%210 ((%11 %211) %212)) (%9 (((%6 %211) %3) %4))))
       (%40 ((%170 (%13 %211)) ((%336 (%171 %3)) (%171 %4)))))) ((%192
       ((%209 %212) ((%12 (%13 (%14 %3))) %15))) ((%209 %212) ((%12 (%13
       (%14 %4))) %15))))`)
  val gruRtcDerivgNt =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %64)) $1) $0)) ((%39
       (%40 ((%231 (%13 %164)) $1))) ((%39 (%40 ((%170 (%13 %164)) (%171
       %64)))) (%40 ((%231 (%13 %164)) $0)))))))))`)
  val ruleg2NoDerivg1 =
    DT(["DISK_THM"], [],
       `(%2 (\%3. (%2 (\%4. ((%39 ((%32 ((%201 (%171 $1)) (%171 $0))) ((%32
       ((%210 ((%11 %211) %212)) (%9 $0))) (%40 ((%337 (%338 %164)) (%338
       %211)))))) (%40 (((%199 (%200 $1)) ((%12 (%13 %164)) %15)) ((%238
       ((%238 %339) ((%12 (%13 %211)) %15))) %340))))))))`)
  val ruleg1NoDerivg2 =
    DT(["DISK_THM"], [],
       `(%2 (\%3. (%2 (\%4. ((%39 ((%32 ((%201 (%171 $1)) (%171 $0))) ((%32
       ((%210 ((%11 %211) %212)) (%9 $1))) (%40 ((%337 (%338 %164)) (%338
       %211)))))) (%40 (((%199 (%200 $0)) ((%12 (%13 %164)) %15)) ((%238
       ((%238 %339) ((%12 (%13 %211)) %15))) %340))))))))`)
  val gruNtNotInRhs =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%170 (%13 %164)) ((%336 (%171 %3)) (%171 %4))))) (%40
       (%310 (\%211. (%204 (\%328. (%204 (\%208. ((%210 ((%11 $2) ((%238
       ((%238 $1) ((%12 (%13 %164)) %15))) $0))) (%9 (((%6 %164) %3)
       %4)))))))))))`)
  val gruLdNtRtcDNt =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (%40 ((%170 (%13 %164)) ((%336 (%171 %3)) (%171 %4)))))
       (((%199 (%200 (((%6 %164) %3) %4))) ((%12 (%13 %164)) %15)) ((%238
       ((%238 %341) ((%12 (%13 %164)) %15))) %342)))) ((%32 ((%209 %341)
       %15)) ((%209 %342) %15)))`)
  val gruNtRtcDNt =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (%40 ((%170 (%13 %164)) ((%336 (%171 %3)) (%171 %4)))))
       (((%199 (%200 (((%6 %164) %3) %4))) ((%12 (%13 %164)) %15)) ((%238
       ((%238 %341) ((%12 (%13 %164)) %15))) %342)))) ((%32 ((%209 %341)
       %15)) ((%209 %342) %15)))`)
  val gruRtcDeriv =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 (((%6 %1) %3) %4)))
       $1) $0)) ((%39 ((%209 $1) ((%12 (%13 %1)) %15))) ((%39 (%40 ((%170
       (%13 %1)) ((%336 (%171 %3)) (%171 %4))))) ((%39 ((%201 (%171 %3))
       (%171 %4))) ((%192 ((%209 $1) $0)) ((%192 (((%199 (%200 %3)) ((%12
       (%13 (%14 %3))) %15)) $0)) (((%199 (%200 %4)) ((%12 (%13 (%14 %4)))
       %15)) $0)))))))))))`)
  val union_cfg =
    DT(["DISK_THM"], [],
       `(%2 (\%3. (%2 (\%4. ((%39 ((%32 ((%201 (%171 $1)) (%171 $0))) (%299
       %300))) (%310 (\%1. ((%32 (%40 ((%170 (%13 $0)) ((%336 (%171 $2))
       (%171 $1))))) ((%167 ((%202 %197) ((%343 (%203 $2)) (%203 $1))))
       ((%202 %197) (%203 (((%6 $0) $2) $1))))))))))))`)
  val grcRtcDTog1 =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %3)) $1) $0)) (((%199
       (%200 (((%184 %1) %3) %4))) $1) $0))))))`)
  val grcRtcDTog2 =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %4)) $1) $0)) (((%199
       (%200 (((%184 %1) %3) %4))) $1) $0))))))`)
  val grcStartRule =
    DT(["DISK_THM"], [],
       `(((%200 (((%184 %1) %3) %4)) ((%12 (%13 %1)) %15)) ((%12 (%13 (%14
       %3))) ((%12 (%13 (%14 %4))) %15)))`)
  val grcStartRuleRhs =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%210 ((%11 %211) %212)) (%9 (((%184 %211) %3) %4))))
       (%40 ((%170 (%13 %211)) ((%336 (%171 %3)) (%171 %4)))))) ((%209
       %212) ((%12 (%13 (%14 %3))) ((%12 (%13 (%14 %4))) %15))))`)
  val grcDerivImpg1g2 =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((%201 (%171 %3)) (%171 %4))) ((%32 (%40 ((%170 (%13
       %1)) ((%336 (%171 %3)) (%171 %4))))) ((%32 (((%199 (%200 %3)) ((%12
       (%13 (%14 %3))) %15)) %344)) ((%32 (((%199 (%200 %4)) ((%12 (%13
       (%14 %4))) %15)) %46)) (((%200 (((%184 %1) %3) %4)) ((%238 %344)
       %46)) %345)))))) (%204 (\%346. (%347 (\%348. ((%192 ((%32 ((%209
       %345) ((%238 $1) %46))) (((%200 %3) %344) $1))) (%349 (\%350. (%204
       (\%351. ((%32 ((%209 %345) ((%238 %344) $0))) (((%200 %4) %46)
       $0))))))))))))`)
  val grcRtcDeriv =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 (((%184 %1) %3) %4)))
       $1) $0)) ((%39 ((%209 $1) ((%12 (%13 %1)) %15))) ((%39 (%40 ((%170
       (%13 %1)) ((%336 (%171 %3)) (%171 %4))))) ((%39 ((%201 (%171 %3))
       (%171 %4))) ((%192 ((%209 $1) $0)) (%204 (\%344. (%204 (\%46. ((%32
       ((%209 $2) ((%238 $1) $0))) ((%32 (((%199 (%200 %3)) ((%12 (%13 (%14
       %3))) %15)) $1)) (((%199 (%200 %4)) ((%12 (%13 (%14 %4))) %15))
       $0))))))))))))))))`)
  val concat_cfg =
    DT(["DISK_THM"], [],
       `(%2 (\%3. (%2 (\%4. ((%39 ((%32 (%299 %300)) ((%201 (%171 $1))
       (%171 $0)))) (%310 (\%1. ((%32 (%40 ((%170 (%13 $0)) ((%336 (%171
       $2)) (%171 $1))))) ((%167 ((%202 %197) ((%61 (%203 $2)) (%203 $1))))
       ((%202 %197) (%203 (((%184 $0) $2) $1))))))))))))`)
  val grclRtcDTog =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 %64)) $1) $0))
       (((%199 (%200 ((%185 %1) %64))) $1) $0))))))`)
  val grclRtcDSsym =
    DT(["DISK_THM"], [],
       `(((%199 (%200 ((%185 %1) %64))) ((%12 (%13 %1)) %15)) ((%12 (%13
       (%14 %64))) %15))`)
  val grclDerivNil =
    DT(["DISK_THM"], [],
       `(((%200 ((%185 %1) %64)) ((%12 (%13 %1)) %15)) %15)`)
  val grclDerivesAppend =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (((%199 (%200 %64)) ((%12 (%13 (%14 %64))) %15)) %341))
       (((%199 (%200 %64)) ((%12 (%13 (%14 %64))) %15)) %342))) (((%199
       (%200 ((%185 %1) %64))) ((%12 (%13 %1)) %15)) ((%238 %341) %342)))`)
  val grclDerivesAppend' =
    DT(["DISK_THM"], [],
       `((%39 ((%32 (((%199 (%200 ((%185 %1) %64))) ((%12 (%13 (%14 %64)))
       %15)) %341)) (((%199 (%200 ((%185 %1) %64))) ((%12 (%13 %1)) %15))
       %342))) (((%199 (%200 ((%185 %1) %64))) ((%12 (%13 %1)) %15)) ((%238
       %341) %342)))`)
  val grclRtcImpD =
    DT(["DISK_THM"], [],
       `(%17 (\%197. (%17 (\%198. ((%39 (((%199 (%200 ((%185 %1) %64))) $1)
       $0)) ((%39 ((%209 $1) ((%12 (%13 (%14 %64))) %15))) ((%39 (%40
       ((%170 (%13 %1)) (%171 %64)))) (((%199 (%200 %64)) $1) $0))))))))`)
  val star_rules =
    DT(["DISK_THM"], [],
       `(%190 (\%188. ((%32 ((%187 $0) %124)) ((%32 (%98 (\%245. ((%39
       ((%193 $0) $1)) ((%187 $1) $0))))) (%98 (\%195. (%98 (\%196. ((%39
       ((%32 ((%193 $1) $2)) ((%187 $2) $0))) ((%187 $2) ((%126 $1)
       $0)))))))))))`)
  val star_ind =
    DT(["DISK_THM"], [],
       `(%190 (\%188. (%190 (\%191. ((%39 ((%32 ($0 %124)) ((%32 (%98
       (\%245. ((%39 ((%193 $0) $2)) ($1 $0))))) (%98 (\%195. (%98 (\%196.
       ((%39 ((%32 ((%193 $1) $3)) ($2 $0))) ($2 ((%126 $1) $0))))))))))
       (%98 (\%189. ((%39 ((%187 $2) $0)) ($1 $0)))))))))`)
  val star_cases =
    DT(["DISK_THM"], [],
       `(%190 (\%188. (%98 (\%189. ((%167 ((%187 $1) $0)) ((%192 ((%100 $0)
       %124)) ((%192 ((%193 $0) $1)) (%194 (\%195. (%194 (\%196. ((%32
       ((%100 $2) ((%126 $1) $0))) ((%32 ((%193 $1) $3)) ((%187 $3)
       $0))))))))))))))`)
  val starImpgrcl =
    DT(["DISK_THM"], [],
       `(%17 (\%197. ((%39 ((%352 (%203 %64)) $0)) ((%202 $0) (%203 ((%185
       %1) %64))))))`)
  val grcls0Deriv =
    DT(["DISK_THM"], [],
       `((%39 (%40 ((%170 (%13 %1)) (%171 %64)))) ((%39 (((%200 ((%185 %1)
       %64)) ((%12 (%13 %1)) %15)) %353)) ((%192 ((%209 %353) %15)) ((%209
       %353) ((%12 (%13 (%14 %64))) ((%12 (%13 %1)) %15))))))`)
  val grcls0ld =
    DT(["DISK_THM"], [],
       `((%39 ((%32 ((((%269 (%200 ((%185 %1) %64))) ((%354 %353) ((%354
       %355) %356))) ((%12 (%13 %1)) %15)) %197)) (%40 ((%170 (%13 %1))
       (%171 %64))))) ((%192 ((%209 %355) %15)) ((((%269 (%200 ((%185 %1)
       %64))) ((%354 %355) %356)) ((%238 ((%12 (%13 (%14 %64))) %15)) ((%12
       (%13 %1)) %15))) %197)))`)
  val grclImpStarLd =
    DT(["DISK_THM", "tactic_failed"], [],
       `(%17 (\%198. ((%39 ((((%269 (%200 ((%185 %1) %64))) %270) ((%12
       (%13 %1)) %15)) $0)) ((%39 ((%205 %206) $0)) ((%39 (%40 ((%170 (%13
       %1)) (%171 %64)))) ((%352 (%203 %64)) $0))))))`)
  val closure_cfg =
    DT(["DISK_THM", "tactic_failed"], [],
       `(%2 (\%64. ((%39 (%299 %300)) (%310 (\%1. ((%167 ((%32 (%40 ((%170
       (%13 $0)) (%171 $1)))) ((%352 (%203 $1)) %197))) ((%202 %197) (%203
       ((%185 $0) $1)))))))))`)
  end
  val _ = DB.bindl "closure"
  [("grUnion_def",grUnion_def,DB.Def),
   ("replace_curried_def",replace_curried_def,DB.Def),
   ("replace_tupled_primitive_def",replace_tupled_primitive_def,DB.Def),
   ("substGr_def",substGr_def,DB.Def),
   ("substRule_curried_def",substRule_curried_def,DB.Def),
   ("substRule_tupled_primitive_def",
    substRule_tupled_primitive_def,
    DB.Def), ("substitutel_curried_def",substitutel_curried_def,DB.Def),
   ("substitutel_tupled_primitive_def",
    substitutel_tupled_primitive_def,
    DB.Def), ("sym2ptree_def",sym2ptree_def,DB.Def),
   ("fringe_defn_primitive_def",fringe_defn_primitive_def,DB.Def),
   ("root_primitive_def",root_primitive_def,DB.Def),
   ("grNt2Nt'R_def",grNt2Nt'R_def,DB.Def),
   ("grNt2Nt'_def",grNt2Nt'_def,DB.Def),
   ("ruleNt2Nt'_def",ruleNt2Nt'_def,DB.Def),
   ("rename_def",rename_def,DB.Def), ("stripNts_def",stripNts_def,DB.Def),
   ("grConcat_def",grConcat_def,DB.Def),
   ("grClosure_def",grClosure_def,DB.Def), ("star",star,DB.Def),
   ("gruDerivFrmg1",gruDerivFrmg1,DB.Thm),
   ("gruRtcSsg2",gruRtcSsg2,DB.Thm), ("gruRtcSsg1",gruRtcSsg1,DB.Thm),
   ("substThm",substThm,DB.Thm), ("substImpGr",substImpGr,DB.Thm),
   ("grImpSubst",grImpSubst,DB.Thm), ("replTmnls",replTmnls,DB.Thm),
   ("sblImprepl",sblImprepl,DB.Thm), ("gsubRtcd",gsubRtcd,DB.Thm),
   ("gsubDerives",gsubDerives,DB.Thm),
   ("grSSymRtcdSubs",grSSymRtcdSubs,DB.Thm),
   ("derivgImpsbg",derivgImpsbg,DB.Thm),
   ("memRuleInsbg",memRuleInsbg,DB.Thm),
   ("sblRuleMemMapsbr",sblRuleMemMapsbr,DB.Thm),
   ("sblAppend",sblAppend,DB.Thm), ("sb1",sb1,DB.Thm),
   ("sbSSymEq",sbSSymEq,DB.Thm), ("vptSbgrImpGr",vptSbgrImpGr,DB.Thm),
   ("vptgsubInLang",vptgsubInLang,DB.Thm),
   ("memGetSyms",memGetSyms,DB.Thm), ("memRulegsub",memRulegsub,DB.Thm),
   ("replaceApp",replaceApp,DB.Thm), ("sbgNtsIng",sbgNtsIng,DB.Thm),
   ("sbl1Mem",sbl1Mem,DB.Thm), ("isSfxMem",isSfxMem,DB.Thm),
   ("notMemSymsbg",notMemSymsbg,DB.Thm), ("notMemsbl",notMemsbl,DB.Thm),
   ("IS_SUFFIX_CONS2_E",IS_SUFFIX_CONS2_E,DB.Thm),
   ("substTwice",substTwice,DB.Thm), ("ruleNilsbg",ruleNilsbg,DB.Thm),
   ("subsEqNil",subsEqNil,DB.Thm), ("substlEqNil",substlEqNil,DB.Thm),
   ("replace_def",replace_def,DB.Thm), ("replace_ind",replace_ind,DB.Thm),
   ("substRule_def",substRule_def,DB.Thm),
   ("substRule_ind",substRule_ind,DB.Thm),
   ("substitutel_def",substitutel_def,DB.Thm),
   ("substitutel_ind",substitutel_ind,DB.Thm),
   ("ptLangThm",ptLangThm,DB.Thm), ("everyTmMapTs",everyTmMapTs,DB.Thm),
   ("rtcdImpVpt",rtcdImpVpt,DB.Thm), ("lpexImpvpt",lpexImpvpt,DB.Thm),
   ("fringeTmsEq",fringeTmsEq,DB.Thm),
   ("getSymsTmsEq",getSymsTmsEq,DB.Thm), ("vptRtcd",vptRtcd,DB.Thm),
   ("getSymsEqRoot",getSymsEqRoot,DB.Thm), ("ptlRtcd",ptlRtcd,DB.Thm),
   ("leafRtcd",leafRtcd,DB.Thm), ("root_def",root_def,DB.Thm),
   ("root_ind",root_ind,DB.Thm), ("disjoint",disjoint,DB.Thm),
   ("grNt2Nt'RAll",grNt2Nt'RAll,DB.Thm),
   ("grNt2Nt'RNts",grNt2Nt'RNts,DB.Thm),
   ("grNt2Nt'RNtInNewg",grNt2Nt'RNtInNewg,DB.Thm),
   ("grNt2Nt'RNtSame",grNt2Nt'RNtSame,DB.Thm),
   ("ruleNt2Nt'Mem2'",ruleNt2Nt'Mem2',DB.Thm),
   ("ruleNt2Nt'Mem1'",ruleNt2Nt'Mem1',DB.Thm),
   ("grNt2Nt'RSymInG'",grNt2Nt'RSymInG',DB.Thm),
   ("grNt2Nt'RSymInRuleG'",grNt2Nt'RSymInRuleG',DB.Thm),
   ("ruleNt2Nt'Mem2",ruleNt2Nt'Mem2,DB.Thm),
   ("ruleNt2Nt'MemInOld",ruleNt2Nt'MemInOld,DB.Thm),
   ("renameNtNeNt'InList",renameNtNeNt'InList,DB.Thm),
   ("renameNtInList",renameNtInList,DB.Thm),
   ("mapRenameListEq",mapRenameListEq,DB.Thm),
   ("ruleNt2Nt'Repl",ruleNt2Nt'Repl,DB.Thm),
   ("renameNtNotMem",renameNtNotMem,DB.Thm),
   ("ruleNt2Nt'Mem1",ruleNt2Nt'Mem1,DB.Thm),
   ("nt2nt'LangEq",nt2nt'LangEq,DB.Thm),
   ("renameRtcDImpD",renameRtcDImpD,DB.Thm),
   ("renameDImpD",renameDImpD,DB.Thm),
   ("nt2nt'RuleInG",nt2nt'RuleInG,DB.Thm),
   ("nt2nt'ListRuleInG",nt2nt'ListRuleInG,DB.Thm),
   ("mapRenameTwice",mapRenameTwice,DB.Thm),
   ("renameTwice",renameTwice,DB.Thm),
   ("rtcDerivImpRenameD",rtcDerivImpRenameD,DB.Thm),
   ("renameAllTms",renameAllTms,DB.Thm),
   ("derivImpRenameD",derivImpRenameD,DB.Thm),
   ("renameRuleSame",renameRuleSame,DB.Thm),
   ("renameListSame",renameListSame,DB.Thm),
   ("gruDerivFrmg2",gruDerivFrmg2,DB.Thm),
   ("gruStartRuleRhs",gruStartRuleRhs,DB.Thm),
   ("gruRtcDerivgNt",gruRtcDerivgNt,DB.Thm),
   ("ruleg2NoDerivg1",ruleg2NoDerivg1,DB.Thm),
   ("ruleg1NoDerivg2",ruleg1NoDerivg2,DB.Thm),
   ("gruNtNotInRhs",gruNtNotInRhs,DB.Thm),
   ("gruLdNtRtcDNt",gruLdNtRtcDNt,DB.Thm),
   ("gruNtRtcDNt",gruNtRtcDNt,DB.Thm), ("gruRtcDeriv",gruRtcDeriv,DB.Thm),
   ("union_cfg",union_cfg,DB.Thm), ("grcRtcDTog1",grcRtcDTog1,DB.Thm),
   ("grcRtcDTog2",grcRtcDTog2,DB.Thm),
   ("grcStartRule",grcStartRule,DB.Thm),
   ("grcStartRuleRhs",grcStartRuleRhs,DB.Thm),
   ("grcDerivImpg1g2",grcDerivImpg1g2,DB.Thm),
   ("grcRtcDeriv",grcRtcDeriv,DB.Thm), ("concat_cfg",concat_cfg,DB.Thm),
   ("grclRtcDTog",grclRtcDTog,DB.Thm),
   ("grclRtcDSsym",grclRtcDSsym,DB.Thm),
   ("grclDerivNil",grclDerivNil,DB.Thm),
   ("grclDerivesAppend",grclDerivesAppend,DB.Thm),
   ("grclDerivesAppend'",grclDerivesAppend',DB.Thm),
   ("grclRtcImpD",grclRtcImpD,DB.Thm), ("star_rules",star_rules,DB.Thm),
   ("star_ind",star_ind,DB.Thm), ("star_cases",star_cases,DB.Thm),
   ("starImpgrcl",starImpgrcl,DB.Thm), ("grcls0Deriv",grcls0Deriv,DB.Thm),
   ("grcls0ld",grcls0ld,DB.Thm), ("grclImpStarLd",grclImpStarLd,DB.Thm),
   ("closure_cfg",closure_cfg,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("pdaDefTheory.pdaDef_grammars",
                          pdaDefTheory.pdaDef_grammars),
                         ("parseTreeTheory.parseTree_grammars",
                          parseTreeTheory.parseTree_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("stripNts", (Term.prim_mk_const { Name = "stripNts", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("rename", (Term.prim_mk_const { Name = "rename", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("ruleNt2Nt'", (Term.prim_mk_const { Name = "ruleNt2Nt'", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("grNt2Nt'", (Term.prim_mk_const { Name = "grNt2Nt'", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("grNt2Nt'R", (Term.prim_mk_const { Name = "grNt2Nt'R", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("root", (Term.prim_mk_const { Name = "root", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("fringe", (Term.prim_mk_const { Name = "fringe", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("sym2ptree", (Term.prim_mk_const { Name = "sym2ptree", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("substitutel_tupled", (Term.prim_mk_const { Name = "substitutel_tupled", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("substitutel", (Term.prim_mk_const { Name = "substitutel", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("substRule_tupled", (Term.prim_mk_const { Name = "substRule_tupled", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("substRule", (Term.prim_mk_const { Name = "substRule", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("substGr", (Term.prim_mk_const { Name = "substGr", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("replace_tupled", (Term.prim_mk_const { Name = "replace_tupled", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("replace", (Term.prim_mk_const { Name = "replace", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("grUnion", (Term.prim_mk_const { Name = "grUnion", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("grConcat", (Term.prim_mk_const { Name = "grConcat", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("grClosure", (Term.prim_mk_const { Name = "grClosure", Thy = "closure"}))
  val _ = update_grms
       temp_overload_on
       ("star", (Term.prim_mk_const { Name = "star", Thy = "closure"}))
  val closure_grammars = Parse.current_lgrms()
  end
  
  
  
  
  val closure_rwts = simpLib.named_rewrites "closure_rwts" [
            substlEqNil, subsEqNil];
  val _ = BasicProvers.augment_srw_ss [closure_rwts]

  
  val _ = computeLib.add_funs [stripNts_def];  
  
  val _ = computeLib.add_funs [rename_def];  
  
  val _ = computeLib.add_funs [ruleNt2Nt'_def];  
  
  val _ = computeLib.add_funs [grNt2Nt'_def];  
  
  val _ = computeLib.add_funs [grNt2Nt'R_def];  
  
  val _ = computeLib.add_funs [root_def];  
  
  val _ = computeLib.add_funs [sym2ptree_def];  
  
  val _ = computeLib.add_funs [substitutel_def];  
  
  val _ = computeLib.add_funs [substRule_def];  
  
  val _ = computeLib.add_funs [substGr_def];  
  
  val _ = computeLib.add_funs [replace_def];  
  
  val _ = computeLib.add_funs [grUnion_def];  
  
  val _ = computeLib.add_funs [grConcat_def];  
  
  val _ = computeLib.add_funs [grClosure_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
