signature homomorphismTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val hInvpda_def : thm
    val rule1_def : thm
    val rule2_def : thm
    val rule3_def : thm
    val stkSymsInPda_def : thm
  
  (*  Theorems  *)
    val idMemStkSyms : thm
    val idStkSymsPdaInv : thm
    val idTransOnInpPfx : thm
    val idTransOnInpPfxToNil : thm
    val idZ0Inv : thm
    val idcBufLen : thm
    val idcMemStates : thm
    val idcStkLastStep : thm
    val idcStkNil' : thm
    val invhEq : thm
    val ldImprtc2list : thm
    val listDerivLastBrk : thm
    val listDiv2 : thm
    val m'FinState : thm
    val m'FstStep : thm
    val m'Impm : thm
    val m'ImpmBufInpSame : thm
    val m'ImpmNil : thm
    val m'ImpmhTohh' : thm
    val m'Rule1 : thm
    val m'StateImpm : thm
    val m'StepBufNilH : thm
    val m'StepBufToNil : thm
    val m'isSuff : thm
    val m'toBufInpNil : thm
    val m'toBufNil : thm
    val mImpm' : thm
    val mImpm'HNil : thm
    val mImpm'InpNil : thm
    val mImpm'OneSym : thm
    val mImpm'Trans1 : thm
    val mImpm'Trans2 : thm
    val mSsymInm' : thm
    val memMRule1 : thm
    val memStates : thm
    val memStkSyms : thm
    val memStkSymsEq : thm
    val memStksymsm' : thm
    val memld : thm
    val rule3Stk : thm
    val stkSymsInPdaApp : thm
    val stkSymsPdaInv : thm
    val stkSymsPdaInvm'm : thm
    val stkSymsm'Impm : thm
    val z0Inv : thm
  
  val homomorphism_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [parseTree] Parent theory of "homomorphism"
   
   [pdaDef] Parent theory of "homomorphism"
   
   [hInvpda_def]  Definition
      
      |- ∀m m' h.
           hInvpda m m' h ⇔
           ∃z0.
             z0 ∉ stkSyms m ∧ (m'.ssSym = z0) ∧
             ∃q0.
               q0 ∉ states m ∧ (m'.start = (q0,[])) ∧
               (∀q r. MEM (q,r) m'.final ⇔ MEM q m.final ∧ (r = [])) ∧
               ∀r.
                 MEM r m'.next ⇔
                 r ∈
                 rule1 m m' h ∪ rule2 m m' h ∪ rule3 m m' h ∪
                 {((NONE,m'.ssSym,m'.start),(m.start,[]),[m.ssSym; m'.ssSym])}
   
   [rule1_def]  Definition
      
      |- ∀m m' h.
           rule1 m m' h =
           {((NONE,ssym,q,x),(p,x),ssyms) |
            ∃a. isSuffix x (h a) ∧ MEM ((NONE,ssym,q),p,ssyms) m.next}
   
   [rule2_def]  Definition
      
      |- ∀m m' h.
           rule2 m m' h =
           {((NONE,ssym,q,isym::x),(p,x),ssyms) |
            ∃a. isSuffix (isym::x) (h a) ∧ MEM ((SOME isym,ssym,q),p,ssyms) m.next}
   
   [rule3_def]  Definition
      
      |- ∀m m' h.
           rule3 m m' h =
           {((SOME a,ssym,q,[]),(q,h a),[ssym]) |
            (a,ssym,q) |
            q ∈ states m ∧ ssym ∈ stkSyms m ∪ {m'.ssSym} ∧ h a ∈ IMAGE h {a}}
   
   [stkSymsInPda_def]  Definition
      
      |- ∀m ssyms. stkSymsInPda m ssyms ⇔ ∀e. MEM e ssyms ⇒ e ∈ stkSyms m
   
   [idMemStkSyms]  Theorem
      
      |- stkSymsInPda m r' ∧ m ⊢ (q'',q''',r') → (q',i',s') ⇒ stkSymsInPda m s'
   
   [idStkSymsPdaInv]  Theorem
      
      |- m ⊢ (q,i,s) → (q'',q''',r') ∧ stkSymsInPda m s ⇒ stkSymsInPda m r'
   
   [idTransOnInpPfx]  Theorem
      
      |- ∀q x y ssyms.
           ID m ⊢ dl ◁ (q,x ++ y,ssyms) → (p,[],ssyms') ⇒
           ∃q0 ssyms0.
             IDC m (q,x ++ y,ssyms) (q0,y,ssyms0) ∧ IDC m (q0,y,ssyms0) (p,[],ssyms')
   
   [idTransOnInpPfxToNil]  Theorem
      
      |- ∀dl q x y ssyms.
           ID m ⊢ dl ◁ (q,x ++ y,ssyms) → (p,y,ssyms') ⇒
           IDC m (q,x,ssyms) (p,[],ssyms')
   
   [idZ0Inv]  Theorem
      
      |- m' ⊢ (q,i,p ++ [m'.ssSym]) → (q0,i0,s0) ∧ hInvpda m m' h ⇒
         ∃pfx. s0 = pfx ++ [m'.ssSym]
   
   [idcBufLen]  Theorem
      
      |- ∀x y.
           (ID m')^* x y ⇒
           hInvpda m m' h ⇒
           ∀q b i s q' b' s'.
             (x = ((q,b),i,s)) ⇒ (y = ((q',b'),i,s')) ⇒ LENGTH b' ≤ LENGTH b
   
   [idcMemStates]  Theorem
      
      |- ∀x y.
           (ID m)^* x y ⇒
           ∀q i s. (x = (q,i,s)) ⇒ (y = (q',i',s')) ⇒ q ∈ states m ⇒ q' ∈ states m
   
   [idcStkLastStep]  Theorem
      
      |- ∀x y.
           (ID m)^* x y ⇒
           ∀q i s.
             (x = (q,i,s)) ⇒
             (y = (q',i',[])) ⇒
             LENGTH s > 0 ⇒
             ∃q0 i0 e. (ID m)^* (q,i,s) (q0,i0,[e]) ∧ m ⊢ (q0,i0,[e]) → (q',i',[])
   
   [idcStkNil']  Theorem
      
      |- ∀x y. (ID m)^* x y ⇒ (x = (q,i,[])) ⇒ (y = (q,i,[]))
   
   [invhEq]  Theorem
      
      |- ∀m m'. hInvpda m m' h ⇒ (x ∈ lafs m' ⇔ x ∈ {w | FLAT (MAP h w) ∈ lafs m})
   
   [ldImprtc2list]  Theorem
      
      |- ∀dl x y. R ⊢ dl ◁ x → y ⇒ R^* x y
   
   [listDerivLastBrk]  Theorem
      
      |- R ⊢ l ++ [e] ◁ x → z ∧ l ≠ [] ⇒ R ⊢ l ◁ x → LAST l ∧ (e = z) ∧ R (LAST l) e
   
   [listDiv2]  Theorem
      
      |- ∀l. ∃x y. l = x ++ y
   
   [m'FinState]  Theorem
      
      |- MEM (q,r) m'.final ∧ hInvpda m m' h ⇒ (q,r) ≠ m'.start ∧ (r = [])
   
   [m'FstStep]  Theorem
      
      |- ID m' ⊢ l ◁ (m'.start,x,[m'.ssSym]) → (state,[],stack) ∧ state ≠ m'.start ∧
         hInvpda m m' h ⇒
         ID m' ⊢ TL l ◁ ((m.start,[]),x,[m.ssSym] ++ [m'.ssSym]) → (state,[],stack)
   
   [m'Impm]  Theorem
      
      |- ∀dl q pfx.
           ID m' ⊢ dl ◁
              ((q,[]),x,pfx ++ [m'.ssSym]) → ((p,[]),[],ssyms' ++ [m'.ssSym]) ∧
           stkSymsInPda m pfx ∧ q ∈ states m ∧ hInvpda m m' h ⇒
           ∃dl'. ID m ⊢ dl' ◁ (q,FLAT (MAP h x),pfx) → (p,[],ssyms')
   
   [m'ImpmBufInpSame]  Theorem
      
      |- ∀dl q b x pfx.
           ID m' ⊢ dl ◁
              ((q,b),x,pfx ++ [m'.ssSym]) → ((p,b'),x,ssyms' ++ [m'.ssSym]) ∧
           q ∈ states m ∧ hInvpda m m' h ⇒
           IDC m (q,b,pfx) (p,b',ssyms')
   
   [m'ImpmNil]  Theorem
      
      |- ∀dl q pfx.
           ID m' ⊢ dl ◁
              ((q,[]),[],pfx ++ [m'.ssSym]) → ((p,[]),[],ssyms' ++ [m'.ssSym]) ∧
           q ∈ states m ∧ hInvpda m m' h ∧ stkSymsInPda m pfx ⇒
           IDC m (q,[],pfx) (p,[],ssyms')
   
   [m'ImpmhTohh']  Theorem
      
      |- ∀dl q' ssyms'.
           ID m' ⊢ dl ◁
              ((q,[]),[h'],pfx ++ [m'.ssSym]) → ((q',h h'),[],ssyms' ++ [m'.ssSym]) ∧
           hInvpda m m' h ∧ q ∈ states m ⇒
           IDC m (q,[],pfx) (q',[],ssyms')
   
   [m'Rule1]  Theorem
      
      |- MEM ((NONE,sh,q,[]),(q'',r),st') m'.next ∧ hInvpda m m' h ⇒ (r = [])
   
   [m'StateImpm]  Theorem
      
      |- ∀q b i s.
           ID m' ⊢ dl ◁ ((q,b),i,s) → ((q',b'),i',s') ∧ hInvpda m m' h ∧
           q ∈ states m ⇒
           q' ∈ states m
   
   [m'StepBufNilH]  Theorem
      
      |- ∀dl p b ssyms'.
           ID m' ⊢ dl ◁
              ((q,[]),[e],pfx ++ [m'.ssSym]) → ((p,b),[],ssyms' ++ [m'.ssSym]) ∧
           hInvpda m m' h ⇒
           ∃q0 ssyms0.
             IDC m' ((q,[]),[e],pfx ++ [m'.ssSym])
               ((q0,h e),[],ssyms0 ++ [m'.ssSym]) ∧
             IDC m' ((q0,h e),[],ssyms0 ++ [m'.ssSym])
               ((p,b),[],ssyms' ++ [m'.ssSym])
   
   [m'StepBufToNil]  Theorem
      
      |- ∀dl q b x pfx.
           ID m' ⊢ dl ◁
              ((q,b),x,pfx ++ [m'.ssSym]) → ((p,[]),[],ssyms' ++ [m'.ssSym]) ∧
           hInvpda m m' h ⇒
           ∃q0 ssyms0.
             IDC m' ((q,b),x,pfx ++ [m'.ssSym]) ((q0,[]),x,ssyms0 ++ [m'.ssSym]) ∧
             IDC m' ((q0,[]),x,ssyms0 ++ [m'.ssSym]) ((p,[]),[],ssyms' ++ [m'.ssSym])
   
   [m'isSuff]  Theorem
      
      |- ∀dl q' b ssyms'.
           ID m' ⊢ dl ◁
              ((q,[]),[h'],pfx ++ [m'.ssSym]) → ((q',b),[],ssyms' ++ [m'.ssSym]) ∧
           hInvpda m m' h ⇒
           isSuffix b (h h')
   
   [m'toBufInpNil]  Theorem
      
      |- ∀dl q ssyms.
           ID m' ⊢ dl ◁ ((q,[]),[],ssyms) → ((p,r),[],ssyms') ⇒
           hInvpda m m' h ⇒
           (r = [])
   
   [m'toBufNil]  Theorem
      
      |- ∀dl q e ssyms.
           ID m' ⊢ dl ◁ ((q,[]),[e],ssyms) → ((p,r),[],ssyms') ∧ hInvpda m m' h ∧
           (h e = []) ⇒
           (r = [])
   
   [mImpm']  Theorem
      
      |- ∀x dl q ssyms.
           ID m ⊢ dl ◁ (q,FLAT (MAP h x),ssyms) → (p,[],ssyms') ∧ hInvpda m m' h ∧
           LENGTH dl > 1 ∧ stkSymsInPda m' ssyms ∧ q ∈ states m ⇒
           IDC m' ((q,[]),x,ssyms ++ [m'.ssSym]) ((p,[]),[],ssyms' ++ [m'.ssSym])
   
   [mImpm'HNil]  Theorem
      
      |- ∀l1.
           hInvpda m m' h ∧ (∀e. MEM e l1 ⇒ (h e = [])) ∧ q ∈ states m ∧
           stkSymsInPda m' s ⇒
           IDC m' ((q,[]),l1,s ++ [m'.ssSym]) ((q,[]),[],s ++ [m'.ssSym])
   
   [mImpm'InpNil]  Theorem
      
      |- ∀dl q ssyms p.
           ID m ⊢ dl ◁ (q,[],ssyms) → (p,[],ssyms') ∧ hInvpda m m' h ⇒
           IDC m' ((q,[]),[],ssyms) ((p,[]),[],ssyms')
   
   [mImpm'OneSym]  Theorem
      
      |- ∀dl p isyms ssyms'.
           ID m ⊢ dl ◁ (q,h a,ssyms) → (p,isyms,ssyms') ∧ LENGTH dl > 1 ∧
           hInvpda m m' h ⇒
           IDC m' ((q,[]),[a],ssyms) ((p,isyms),[],ssyms')
   
   [mImpm'Trans1]  Theorem
      
      |- MEM ((NONE,sh,q),p,st') m.next ∧ hInvpda m m' h ⇒
         IDC m' ((q,[]),[a],sh::st) ((p,h a),[],st' ++ st)
   
   [mImpm'Trans2]  Theorem
      
      |- MEM ((SOME ih,sh,q),p,st') m.next ∧ (h a = ih::isyms) ∧ hInvpda m m' h ⇒
         IDC m' ((q,[]),[a],sh::st) ((p,isyms),[],st' ++ st)
   
   [mSsymInm']  Theorem
      
      |- hInvpda m m' h ⇒ stkSymsInPda m' [m.ssSym]
   
   [memMRule1]  Theorem
      
      |- MEM ((NONE,sh,q),p,st') m.next ∧ hInvpda m m' h ∧ isSuffix x (h a) ⇒
         MEM ((NONE,sh,q,x),(p,x),st') m'.next
   
   [memStates]  Theorem
      
      |- ∀dl q i s.
           ID m ⊢ dl ◁ (q,i,s) → (q',i',s') ∧ LENGTH dl > 1 ⇒
           q ∈ states m ∧ q' ∈ states m
   
   [memStkSyms]  Theorem
      
      |- ∀ssyms'.
           MEM ((io,ssym,q),q',ssyms') m.next ⇒
           ssym ∈ stkSyms m ∧ ∀e. MEM e ssyms' ⇒ e ∈ stkSyms m
   
   [memStkSymsEq]  Theorem
      
      |- e ∈ stkSyms m ⇔
         (e = m.ssSym) ∨
         ∃io ssym q q' ssyms.
           MEM ((io,ssym,q),q',ssyms) m.next ∧ ((e = ssym) ∨ MEM e ssyms)
   
   [memStksymsm']  Theorem
      
      |- ∀e. e ∈ stkSyms m' ∧ hInvpda m m' h ⇒ e ∈ stkSyms m ∨ (e = m'.ssSym)
   
   [memld]  Theorem
      
      |- R ⊢ dl ◁ x → y ⇒ MEM x dl ∧ MEM y dl
   
   [rule3Stk]  Theorem
      
      |- ((SOME ih,h',q),q',st') ∈ rule3 m m' h ⇒ (st' = [h'])
   
   [stkSymsInPdaApp]  Theorem
      
      |- ∀l1 l2. stkSymsInPda m (l1 ++ l2) ⇔ stkSymsInPda m l1 ∧ stkSymsInPda m l2
   
   [stkSymsPdaInv]  Theorem
      
      |- ∀x y.
           (ID m)^* x y ⇒
           ∀q i s.
             (x = (q,i,s)) ⇒ (y = (q',i',s')) ⇒ stkSymsInPda m s ⇒ stkSymsInPda m s'
   
   [stkSymsPdaInvm'm]  Theorem
      
      |- ∀x y.
           (ID m')^* x y ⇒
           hInvpda m m' h ⇒
           ∀q' i' s'.
             (x = (q,i,s ++ [m'.ssSym])) ⇒
             (y = (q',i',s' ++ [m'.ssSym])) ⇒
             stkSymsInPda m s ⇒
             stkSymsInPda m s'
   
   [stkSymsm'Impm]  Theorem
      
      |- stkSymsInPda m' l ∧ hInvpda m m' h ⇒
         ∀e. MEM e l ⇒ e ∈ stkSyms m ∨ (e = m'.ssSym)
   
   [z0Inv]  Theorem
      
      |- ∀dl q i s p.
           ID m' ⊢ dl ◁ (q,i,s) → (q',i',s') ∧ hInvpda m m' h ∧
           (s = p ++ [m'.ssSym]) ⇒
           ∀q0 i0 s0. MEM (q0,i0,s0) dl ⇒ ∃pfx. s0 = pfx ++ [m'.ssSym]
   
   
*)
end
