structure homomorphismTheory :> homomorphismTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading homomorphismTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open parseTreeTheory pdaDefTheory
  in end;
  val _ = Theory.link_parents
          ("homomorphism",
          Arbnum.fromString "1259372504",
          Arbnum.fromString "333671")
          [("pdaDef",
           Arbnum.fromString "1259372202",
           Arbnum.fromString "356145"),
           ("parseTree",
           Arbnum.fromString "1259372179",
           Arbnum.fromString "410922")];
  val _ = Theory.incorporate_types "homomorphism" [];
  val _ = Theory.incorporate_consts "homomorphism"
     [("stkSymsInPda",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"list" "list" [beta] --> bool)))),
      ("rule3",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"pda" "pdaDef"
           [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]
          -->
          ((alpha --> T"list" "list" [alpha]) -->
           (T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [alpha],
                T"prod" "pair"
                 [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
              T"prod" "pair"
               [T"prod" "pair" [gamma, T"list" "list" [alpha]],
                T"list" "list" [beta]]] --> bool)))))),
      ("rule2",
       ((T"pda" "pdaDef" [delta, beta, gamma] -->
         (U"'e" -->
          ((U"'f" --> T"list" "list" [delta]) -->
           (T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [alpha],
                T"prod" "pair"
                 [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
              T"prod" "pair"
               [T"prod" "pair" [gamma, T"list" "list" [delta]],
                T"list" "list" [beta]]] --> bool)))))),
      ("rule1",
       ((T"pda" "pdaDef" [U"'e", beta, gamma] -->
         (U"'f" -->
          ((U"'g" --> T"list" "list" [delta]) -->
           (T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [alpha],
                T"prod" "pair"
                 [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
              T"prod" "pair"
               [T"prod" "pair" [gamma, T"list" "list" [delta]],
                T"list" "list" [beta]]] --> bool)))))),
      ("hInvpda",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"pda" "pdaDef"
           [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]
          --> ((alpha --> T"list" "list" [alpha]) --> bool)))))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool"
    (((T"pda" "pdaDef" [alpha, beta, gamma] --> bool) --> bool)),
   V"m" (T"pda" "pdaDef" [alpha, beta, gamma]),
   C"!" "bool"
    (((T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       bool) --> bool)),
   V"m'"
    (T"pda" "pdaDef"
      [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]),
   C"!" "bool" ((((alpha --> T"list" "list" [alpha]) --> bool) --> bool)),
   V"h" ((alpha --> T"list" "list" [alpha])),
   C"=" "min" ((bool --> (bool --> bool))),
   C"hInvpda" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) --> bool)))),
   C"?" "bool" (((beta --> bool) --> bool)), V"z0" (beta),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"~" "bool" ((bool --> bool)),
   C"IN" "bool" ((beta --> ((beta --> bool) --> bool))),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (beta --> bool))),
   C"=" "min" ((beta --> (beta --> bool))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      beta)), C"?" "bool" (((gamma --> bool) --> bool)), V"q0" (gamma),
   C"IN" "bool" ((gamma --> ((gamma --> bool) --> bool))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (gamma --> bool))),
   C"=" "min"
    ((T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
      (T"prod" "pair" [gamma, T"list" "list" [alpha]] --> bool))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      T"prod" "pair" [gamma, T"list" "list" [alpha]])),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [gamma, T"list" "list" [alpha]]))),
   C"NIL" "list" (T"list" "list" [alpha]),
   C"!" "bool" (((gamma --> bool) --> bool)), V"q" (gamma),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"r" (T"list" "list" [alpha]),
   C"MEM" "list"
    ((T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
      (T"list" "list" [T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      T"list" "list" [T"prod" "pair" [gamma, T"list" "list" [alpha]]])),
   C"MEM" "list" ((gamma --> (T"list" "list" [gamma] --> bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> T"list" "list" [gamma])),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"!" "bool"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]] --> bool) --> bool)),
   V"r"
    (T"prod" "pair"
      [T"prod" "pair"
        [T"option" "option" [alpha],
         T"prod" "pair"
          [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
       T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"list" "list" [beta]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]]] --> bool))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]]])),
   C"IN" "bool"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool) --> bool))),
   C"UNION" "pred_set"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]] --> bool) -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool) -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool)))),
   C"rule1" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]] --> bool))))),
   C"rule2" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]] --> bool))))),
   C"rule3" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]] --> bool))))),
   C"INSERT" "pred_set"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool) -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool)))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha],
        T"prod" "pair"
         [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       T"prod" "pair"
        [T"option" "option" [alpha],
         T"prod" "pair"
          [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]]))),
   C"NONE" "option" (T"option" "option" [alpha]),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
       T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]))),
   C"," "pair"
    ((T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
      (T"list" "list" [beta] -->
       T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"list" "list" [beta]]))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> gamma)),
   C"CONS" "list"
    ((beta --> (T"list" "list" [beta] --> T"list" "list" [beta]))),
   C"pda_ssSym" "pdaDef" ((T"pda" "pdaDef" [alpha, beta, gamma] --> beta)),
   C"NIL" "list" (T"list" "list" [beta]),
   C"EMPTY" "pred_set"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] --> bool)),
   C"=" "min"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]] --> bool) -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool) --> bool))),
   C"rule3" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"pda" "pdaDef"
        [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]] --> bool))))),
   C"GSPEC" "pred_set"
    (((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]], bool]) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]] --> bool))),
   C"UNCURRY" "pair"
    (((alpha -->
       (T"prod" "pair" [beta, gamma] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [alpha]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]], bool]))), V"a" (alpha),
   C"UNCURRY" "pair"
    (((beta -->
       (gamma -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [alpha]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]], bool]))), V"ssym" (beta),
   C"," "pair"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] -->
      (bool -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [alpha]],
             T"list" "list" [beta]]], bool]))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha],
        T"prod" "pair"
         [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]] -->
       T"prod" "pair"
        [T"option" "option" [alpha],
         T"prod" "pair"
          [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]]))),
   C"SOME" "option" ((alpha --> T"option" "option" [alpha])),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, T"list" "list" [delta]] -->
       T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]))),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [delta] -->
       T"prod" "pair" [gamma, T"list" "list" [delta]]))),
   C"NIL" "list" (T"list" "list" [delta]),
   C"UNION" "pred_set"
    (((beta --> bool) --> ((beta --> bool) --> (beta --> bool)))),
   C"INSERT" "pred_set" ((beta --> ((beta --> bool) --> (beta --> bool)))),
   C"EMPTY" "pred_set" ((beta --> bool)),
   C"IN" "bool"
    ((T"list" "list" [alpha] -->
      ((T"list" "list" [alpha] --> bool) --> bool))),
   C"IMAGE" "pred_set"
    (((alpha --> T"list" "list" [alpha]) -->
      ((alpha --> bool) --> (T"list" "list" [alpha] --> bool)))),
   C"INSERT" "pred_set"
    ((alpha --> ((alpha --> bool) --> (alpha --> bool)))),
   C"EMPTY" "pred_set" ((alpha --> bool)),
   C"!" "bool"
    (((T"pda" "pdaDef" [delta, beta, gamma] --> bool) --> bool)),
   V"m" (T"pda" "pdaDef" [delta, beta, gamma]),
   C"!" "bool" (((U"'e" --> bool) --> bool)), V"m'" (U"'e"),
   C"!" "bool" ((((U"'f" --> T"list" "list" [delta]) --> bool) --> bool)),
   V"h" ((U"'f" --> T"list" "list" [delta])),
   C"=" "min"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [delta]],
           T"list" "list" [beta]]] --> bool) -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [delta]],
            T"list" "list" [beta]]] --> bool) --> bool))),
   C"rule2" "homomorphism"
    ((T"pda" "pdaDef" [delta, beta, gamma] -->
      (U"'e" -->
       ((U"'f" --> T"list" "list" [delta]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]] --> bool))))),
   C"GSPEC" "pred_set"
    (((T"prod" "pair"
        [beta,
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [delta,
             T"prod" "pair"
              [T"list" "list" [delta],
               T"prod" "pair" [gamma, T"list" "list" [beta]]]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [delta]],
           T"list" "list" [beta]]] --> bool))),
   C"UNCURRY" "pair"
    (((beta -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair"
           [delta,
            T"prod" "pair"
             [T"list" "list" [delta],
              T"prod" "pair" [gamma, T"list" "list" [beta]]]]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [beta,
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [delta,
             T"prod" "pair"
              [T"list" "list" [delta],
               T"prod" "pair" [gamma, T"list" "list" [beta]]]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   C"UNCURRY" "pair"
    (((gamma -->
       (T"prod" "pair"
         [delta,
          T"prod" "pair"
           [T"list" "list" [delta],
            T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [delta,
           T"prod" "pair"
            [T"list" "list" [delta],
             T"prod" "pair" [gamma, T"list" "list" [beta]]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   C"UNCURRY" "pair"
    (((delta -->
       (T"prod" "pair"
         [T"list" "list" [delta],
          T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [delta,
         T"prod" "pair"
          [T"list" "list" [delta],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))), V"isym" (delta),
   C"UNCURRY" "pair"
    (((T"list" "list" [delta] -->
       (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [T"list" "list" [delta],
         T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   V"x" (T"list" "list" [delta]),
   C"UNCURRY" "pair"
    (((gamma -->
       (T"list" "list" [beta] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))), V"p" (gamma),
   V"ssyms" (T"list" "list" [beta]),
   C"," "pair"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [delta]],
          T"list" "list" [beta]]] -->
      (bool -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha],
        T"prod" "pair"
         [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [delta]],
         T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [delta]],
           T"list" "list" [beta]]]))),
   C"CONS" "list"
    ((delta --> (T"list" "list" [delta] --> T"list" "list" [delta]))),
   C"," "pair"
    ((T"prod" "pair" [gamma, T"list" "list" [delta]] -->
      (T"list" "list" [beta] -->
       T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [delta]],
         T"list" "list" [beta]]))),
   C"?" "bool" (((U"'f" --> bool) --> bool)), V"a" (U"'f"),
   C"isSuffix" "listLemmas"
    ((T"list" "list" [delta] --> (T"list" "list" [delta] --> bool))),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [delta], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [delta], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [delta], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [delta], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [delta] -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"option" "option" [delta], T"prod" "pair" [beta, gamma]]))),
   C"SOME" "option" ((delta --> T"option" "option" [delta])),
   C"," "pair" ((beta --> (gamma --> T"prod" "pair" [beta, gamma]))),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [gamma, T"list" "list" [beta]]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [delta, beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [delta], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   C"!" "bool"
    (((T"pda" "pdaDef" [U"'e", beta, gamma] --> bool) --> bool)),
   V"m" (T"pda" "pdaDef" [U"'e", beta, gamma]),
   C"!" "bool" (((U"'f" --> bool) --> bool)), V"m'" (U"'f"),
   C"!" "bool" ((((U"'g" --> T"list" "list" [delta]) --> bool) --> bool)),
   V"h" ((U"'g" --> T"list" "list" [delta])),
   C"rule1" "homomorphism"
    ((T"pda" "pdaDef" [U"'e", beta, gamma] -->
      (U"'f" -->
       ((U"'g" --> T"list" "list" [delta]) -->
        (T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]] --> bool))))),
   C"GSPEC" "pred_set"
    (((T"prod" "pair"
        [beta,
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [T"list" "list" [delta],
             T"prod" "pair" [gamma, T"list" "list" [beta]]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha],
           T"prod" "pair"
            [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
         T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [delta]],
           T"list" "list" [beta]]] --> bool))),
   C"UNCURRY" "pair"
    (((beta -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair"
           [T"list" "list" [delta],
            T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [beta,
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [T"list" "list" [delta],
             T"prod" "pair" [gamma, T"list" "list" [beta]]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   C"UNCURRY" "pair"
    (((gamma -->
       (T"prod" "pair"
         [T"list" "list" [delta],
          T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha],
              T"prod" "pair"
               [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
            T"prod" "pair"
             [T"prod" "pair" [gamma, T"list" "list" [delta]],
              T"list" "list" [beta]]], bool])) -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [delta],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha],
             T"prod" "pair"
              [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
           T"prod" "pair"
            [T"prod" "pair" [gamma, T"list" "list" [delta]],
             T"list" "list" [beta]]], bool]))),
   C"?" "bool" (((U"'g" --> bool) --> bool)), V"a" (U"'g"),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [U"'e"] -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]]))),
   C"NONE" "option" (T"option" "option" [U"'e"]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'e", beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'e"], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   C"!" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   C"stkSymsInPda" "homomorphism"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"list" "list" [beta] --> bool))),
   C"!" "bool" (((beta --> bool) --> bool)), V"e" (beta),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"MEM" "list" ((beta --> (T"list" "list" [beta] --> bool))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"!" "bool" (((alpha --> bool) --> bool)), V"q" (alpha),
   V"x" (T"list" "list" [beta]), V"y" (T"list" "list" [beta]),
   C"!" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"ssyms" (T"list" "list" [gamma]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [beta, gamma, alpha]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]))),
   C"APPEND" "list"
    ((T"list" "list" [beta] -->
      (T"list" "list" [beta] --> T"list" "list" [beta]))), V"p" (alpha),
   V"ssyms'" (T"list" "list" [gamma]),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), C"?" "bool" (((alpha --> bool) --> bool)),
   V"q0" (alpha),
   C"?" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"ssyms0" (T"list" "list" [gamma]),
   C"hInvpda" "homomorphism"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"pda" "pdaDef"
        [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
       ((beta --> T"list" "list" [beta]) --> bool)))),
   V"m'"
    (T"pda" "pdaDef"
      [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]]),
   V"h" ((beta --> T"list" "list" [beta])),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))),
   C"," "pair"
    ((T"prod" "pair" [alpha, T"list" "list" [beta]] -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((alpha -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [alpha, T"list" "list" [beta]]))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]),
   V"isyms" (T"list" "list" [alpha]), V"ssyms'" (T"list" "list" [beta]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        -->
        (T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
       T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]))),
   C">" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
      --> T"num" "num" [])),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   C"," "pair"
    ((T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [beta]]]))),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]]))),
   V"ih" (alpha), V"sh" (beta), V"st'" (T"list" "list" [beta]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   V"st" (T"list" "list" [beta]),
   C"isSuffix" "listLemmas"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   V"x" (T"list" "list" [alpha]),
   C"listderiv" "relationLemmas"
    (((alpha --> (alpha --> bool)) -->
      (T"list" "list" [alpha] --> (alpha --> (alpha --> bool))))),
   V"R" ((alpha --> (alpha --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   V"l" (T"list" "list" [alpha]), V"e" (alpha), V"x" (alpha), V"z" (alpha),
   C"LAST" "list" ((T"list" "list" [alpha] --> alpha)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"?" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"y" (T"list" "list" [alpha]),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool) --> bool)),
   V"x"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   V"y"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"RTC" "relation"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"i" (T"list" "list" [beta]),
   V"s" (T"list" "list" [gamma]),
   C"=" "min"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool))), V"q'" (alpha), V"i'" (T"list" "list" [beta]),
   V"s'" (T"list" "list" [gamma]),
   C"IN" "bool" ((alpha --> ((alpha --> bool) --> bool))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> (alpha --> bool))),
   C"NIL" "list" (T"list" "list" [gamma]), V"dl" (T"list" "list" [alpha]),
   V"y" (alpha),
   C"RTC" "relation"
    (((alpha --> (alpha --> bool)) --> (alpha --> (alpha --> bool)))),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"stkSymsInPda" "homomorphism"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"list" "list" [gamma] --> bool))),
   V"ssyms'" (T"list" "list" [alpha]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [alpha]]]))),
   C"," "pair"
    ((T"option" "option" [beta] -->
      (T"prod" "pair" [alpha, gamma] -->
       T"prod" "pair"
        [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]]))),
   V"io" (T"option" "option" [beta]),
   C"," "pair" ((alpha --> (gamma --> T"prod" "pair" [alpha, gamma]))),
   V"ssym" (alpha), V"q'" (gamma),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]])),
   V"m" (T"pda" "pdaDef" [beta, alpha, gamma]),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> (alpha --> bool))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [beta]],
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [beta]],
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [beta]],
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"r" (T"list" "list" [beta]),
   C"=" "min"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   V"q''" (gamma),
   C"LENGTH" "list" ((T"list" "list" [gamma] --> T"num" "num" [])),
   C"0" "num" (T"num" "num" []),
   C"?" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"i0" (T"list" "list" [beta]), V"e" (gamma),
   C"CONS" "list"
    ((gamma --> (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      --> T"num" "num" [])),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   V"q" (T"prod" "pair" [gamma, T"list" "list" [alpha]]),
   V"i" (T"list" "list" [alpha]), V"p" (T"list" "list" [beta]),
   V"q0" (T"prod" "pair" [gamma, T"list" "list" [alpha]]),
   V"i0" (T"list" "list" [alpha]), V"s0" (T"list" "list" [beta]),
   V"pfx" (T"list" "list" [beta]),
   C"!" "bool"
    (((T"prod" "pair" [alpha, T"list" "list" [beta]] --> bool) --> bool)),
   V"q" (T"prod" "pair" [alpha, T"list" "list" [beta]]),
   V"p" (T"list" "list" [gamma]),
   V"q'" (T"prod" "pair" [alpha, T"list" "list" [beta]]),
   C"=" "min"
    ((T"list" "list" [gamma] --> (T"list" "list" [gamma] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [gamma] -->
      (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      gamma)), V"q0" (T"prod" "pair" [alpha, T"list" "list" [beta]]),
   V"s0" (T"list" "list" [gamma]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"list" "list" [beta]],
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"list" "list" [beta]],
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))), V"pfx" (T"list" "list" [gamma]),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> alpha)),
   C"?" "bool" (((T"option" "option" [beta] --> bool) --> bool)),
   V"ssyms" (T"list" "list" [alpha]),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, alpha, T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (alpha --> bool))),
   V"m'"
    (T"pda" "pdaDef"
      [beta, alpha, T"prod" "pair" [gamma, T"list" "list" [beta]]]),
   C"hInvpda" "homomorphism"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"pda" "pdaDef"
        [beta, alpha, T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
       ((beta --> T"list" "list" [beta]) --> bool)))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, alpha, T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      alpha)), V"l1" (T"list" "list" [alpha]),
   C"stkSymsInPda" "homomorphism"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"list" "list" [beta] --> bool))), V"s" (T"list" "list" [beta]),
   V"r'" (T"list" "list" [beta]), V"q'''" (T"list" "list" [alpha]),
   V"i'" (T"list" "list" [alpha]), V"s'" (T"list" "list" [beta]),
   V"l" (T"list" "list" [beta]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [beta,
           T"prod" "pair"
            [T"list" "list" [alpha], T"list" "list" [gamma]]]] --> bool)
      --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [beta,
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [gamma]]]]), V"q" (beta),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [beta,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [beta,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [beta,
           T"prod" "pair"
            [T"list" "list" [alpha], T"list" "list" [gamma]]]] -->
       (T"prod" "pair"
         [beta,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [beta,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [alpha, gamma, beta] -->
      (T"prod" "pair"
        [beta,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [beta,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [alpha, gamma, beta]),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [beta,
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]))),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [alpha]] --> T"list" "list" [alpha])),
   C"MAP" "list"
    (((alpha --> T"list" "list" [alpha]) -->
      (T"list" "list" [alpha] -->
       T"list" "list" [T"list" "list" [alpha]]))), V"p" (beta),
   C"hInvpda" "homomorphism"
    ((T"pda" "pdaDef" [alpha, gamma, beta] -->
      (T"pda" "pdaDef"
        [alpha, gamma, T"prod" "pair" [beta, T"list" "list" [alpha]]] -->
       ((alpha --> T"list" "list" [alpha]) --> bool)))),
   V"m'"
    (T"pda" "pdaDef"
      [alpha, gamma, T"prod" "pair" [beta, T"list" "list" [alpha]]]),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [beta,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]]
      --> T"num" "num" [])),
   C"stkSymsInPda" "homomorphism"
    ((T"pda" "pdaDef"
       [alpha, gamma, T"prod" "pair" [beta, T"list" "list" [alpha]]] -->
      (T"list" "list" [gamma] --> bool))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [alpha, gamma, beta] --> (beta --> bool))),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, gamma, T"prod" "pair" [beta, T"list" "list" [alpha]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [beta, T"list" "list" [alpha]],
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [beta, T"list" "list" [alpha]],
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]]]
        --> bool)))),
   C"," "pair"
    ((T"prod" "pair" [beta, T"list" "list" [alpha]] -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [T"prod" "pair" [beta, T"list" "list" [alpha]],
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((beta -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [beta, T"list" "list" [alpha]]))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, gamma, T"prod" "pair" [beta, T"list" "list" [alpha]]] -->
      gamma)), V"l2" (T"list" "list" [alpha]),
   C"stkSymsInPda" "homomorphism"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list" [alpha] --> bool))),
   C"!" "bool"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool) --> bool)),
   V"x"
    (T"prod" "pair"
      [T"prod" "pair" [alpha, T"list" "list" [beta]],
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   V"y"
    (T"prod" "pair"
      [T"prod" "pair" [alpha, T"list" "list" [beta]],
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"RTC" "relation"
    (((T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"b" (T"list" "list" [beta]),
   V"b'" (T"list" "list" [beta]),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"list" "list" [beta]],
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool))),
   C"<=" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list" ((T"list" "list" [beta] --> T"num" "num" [])),
   C"IN" "bool"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha],
          T"prod" "pair"
           [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
        T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"list" "list" [beta]]] -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha],
            T"prod" "pair"
             [beta, T"prod" "pair" [gamma, T"list" "list" [delta]]]],
          T"prod" "pair"
           [T"prod" "pair" [gamma, T"list" "list" [alpha]],
            T"list" "list" [beta]]] --> bool) --> bool))), V"h'" (beta),
   V"q" (T"prod" "pair" [gamma, T"list" "list" [delta]]),
   V"q'" (T"prod" "pair" [gamma, T"list" "list" [alpha]]),
   C"isSuffix" "listLemmas"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [T"prod" "pair" [gamma, T"list" "list" [alpha]],
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       -->
       (T"prod" "pair"
         [T"prod" "pair" [gamma, T"list" "list" [alpha]],
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        -->
        (T"prod" "pair"
          [T"prod" "pair" [gamma, T"list" "list" [alpha]],
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
         --> bool))))),
   C"?" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       --> bool) --> bool)),
   V"dl'"
    (T"list" "list"
      [T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"list" "list" [beta]],
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      T"prod" "pair" [alpha, T"list" "list" [beta]])),
   V"state" (T"prod" "pair" [alpha, T"list" "list" [beta]]),
   V"stack" (T"list" "list" [gamma]),
   C"=" "min"
    ((T"prod" "pair" [alpha, T"list" "list" [beta]] -->
      (T"prod" "pair" [alpha, T"list" "list" [beta]] --> bool))),
   C"TL" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"list" "list" [beta]],
          T"prod" "pair"
           [T"list" "list" [beta], T"list" "list" [gamma]]]])),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> alpha)),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> gamma)),
   C"MEM" "list"
    ((T"prod" "pair" [alpha, T"list" "list" [beta]] -->
      (T"list" "list" [T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
       bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef"
       [beta, gamma, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      T"list" "list" [T"prod" "pair" [alpha, T"list" "list" [beta]]])),
   C"lafs" "pdaDef"
    ((T"pda" "pdaDef"
       [alpha, beta, T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"list" "list" [alpha] --> bool))),
   C"GSPEC" "pred_set"
    (((T"list" "list" [alpha] -->
       T"prod" "pair" [T"list" "list" [alpha], bool]) -->
      (T"list" "list" [alpha] --> bool))), V"w" (T"list" "list" [alpha]),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (bool --> T"prod" "pair" [T"list" "list" [alpha], bool]))),
   C"lafs" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"list" "list" [alpha] --> bool)))]
  val DT = Thm.disk_thm share_table
  in
  val hInvpda_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%4 (\%5. ((%6 (((%7 $2) $1) $0)) (%8 (\%9.
       ((%10 (%11 ((%12 $0) (%13 $3)))) ((%10 ((%14 (%15 $2)) $0)) (%16
       (\%17. ((%10 (%11 ((%18 $0) (%19 $4)))) ((%10 ((%20 (%21 $3)) ((%22
       $0) %23))) ((%10 (%24 (\%25. (%26 (\%27. ((%6 ((%28 ((%22 $1) $0))
       (%29 $5))) ((%10 ((%30 $1) (%31 $6))) ((%32 $0) %23)))))))) (%33
       (\%34. ((%6 ((%35 $0) (%36 $4))) ((%37 $0) ((%38 ((%38 ((%38 (((%39
       $5) $4) $3)) (((%40 $5) $4) $3))) (((%41 $5) $4) $3))) ((%42 ((%43
       ((%44 %45) ((%46 (%15 $4)) (%21 $4)))) ((%47 ((%22 (%48 $5)) %23))
       ((%49 (%50 $5)) ((%49 (%15 $4)) %51))))) %52))))))))))))))))))))))`)
  val rule3_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%4 (\%5. ((%53 (((%54 $2) $1) $0)) (%55 (%56
       (\%57. (%58 (\%59. (\%25. ((%60 ((%61 ((%62 (%63 $2)) ((%64 $1)
       ((%65 $0) %66)))) ((%47 ((%22 $0) ($3 $2))) ((%49 $1) %51)))) ((%10
       ((%18 $0) (%19 $5))) ((%10 ((%12 $1) ((%67 (%13 $5)) ((%68 (%15 $4))
       %69)))) ((%70 ($3 $2)) ((%71 $3) ((%72 $2) %73)))))))))))))))))))`)
  val rule2_def =
    DT([], [],
       `(%74 (\%75. (%76 (\%77. (%78 (\%79. ((%80 (((%81 $2) $1) $0)) (%82
       (%83 (\%59. (%84 (\%25. (%85 (\%86. (%87 (\%88. (%89 (\%90. (\%91.
       ((%92 ((%93 ((%62 %45) ((%64 $5) ((%65 $4) ((%94 $3) $2))))) ((%95
       ((%65 $1) $2)) $0))) (%96 (\%97. ((%10 ((%98 ((%94 $4) $3)) ($7
       $0))) ((%99 ((%100 ((%101 (%102 $4)) ((%103 $6) $5))) ((%104 $2)
       $1))) (%105 $9)))))))))))))))))))))))))`)
  val rule1_def =
    DT([], [],
       `(%106 (\%107. (%108 (\%109. (%110 (\%111. ((%80 (((%112 $2) $1)
       $0)) (%113 (%114 (\%59. (%115 (\%25. (%87 (\%88. (%89 (\%90. (\%91.
       ((%92 ((%93 ((%62 %45) ((%64 $4) ((%65 $3) $2)))) ((%95 ((%65 $1)
       $2)) $0))) (%116 (\%117. ((%10 ((%98 $3) ($6 $0))) ((%118 ((%119
       ((%120 %121) ((%103 $5) $4))) ((%104 $2) $1))) (%122
       $8)))))))))))))))))))))))`)
  val stkSymsInPda_def =
    DT([], [],
       `(%0 (\%1. (%123 (\%91. ((%6 ((%124 $1) $0)) (%125 (\%126. ((%127
       ((%128 $0) $1)) ((%12 $0) (%13 $2))))))))))`)
  val idTransOnInpPfxToNil =
    DT(["DISK_THM"], [],
       `(%129 (\%130. (%131 (\%132. (%123 (\%133. (%123 (\%134. (%135
       (\%136. ((%127 ((((%137 (%138 %139)) $4) ((%140 $3) ((%141 ((%142
       $2) $1)) $0))) ((%140 %143) ((%141 $1) %144)))) (((%145 %139) ((%140
       $3) ((%141 $2) $0))) ((%140 %143) ((%141 %51) %144))))))))))))))`)
  val idTransOnInpPfx =
    DT(["DISK_THM"], [],
       `(%131 (\%132. (%123 (\%133. (%123 (\%134. (%135 (\%136. ((%127
       ((((%137 (%138 %139)) %130) ((%140 $3) ((%141 ((%142 $2) $1)) $0)))
       ((%140 %143) ((%141 %51) %144)))) (%146 (\%147. (%148 (\%149. ((%10
       (((%145 %139) ((%140 $5) ((%141 ((%142 $4) $3)) $2))) ((%140 $1)
       ((%141 $3) $0)))) (((%145 %139) ((%140 $1) ((%141 $3) $0))) ((%140
       %143) ((%141 %51) %144)))))))))))))))))`)
  val mImpm'InpNil =
    DT(["DISK_THM"], [],
       `(%129 (\%130. (%131 (\%132. (%135 (\%136. (%131 (\%143. ((%127
       ((%10 ((((%137 (%138 %139)) $3) ((%140 $2) ((%141 %51) $1))) ((%140
       $0) ((%141 %51) %144)))) (((%150 %139) %151) %152))) (((%153 %151)
       ((%154 ((%155 $2) %51)) ((%141 %51) $1))) ((%154 ((%155 $0) %51))
       ((%141 %51) %144))))))))))))`)
  val mImpm'OneSym =
    DT(["DISK_THM"], [],
       `(%156 (\%157. (%24 (\%90. (%26 (\%158. (%123 (\%159. ((%127 ((%10
       ((((%160 (%161 %1)) $3) ((%162 %25) ((%163 (%5 %57)) %91))) ((%162
       $2) ((%163 $1) $0)))) ((%10 ((%164 (%165 $3)) (%166 (%167 %168))))
       (((%7 %1) %3) %5)))) (((%169 %3) ((%170 ((%22 %25) %23)) ((%163
       ((%171 %57) %23)) %91))) ((%170 ((%22 $2) $1)) ((%163 %23)
       $0))))))))))))`)
  val mImpm'Trans2 =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%172 ((%173 ((%174 (%63 %175)) ((%103 %176) %25)))
       ((%104 %90) %177))) (%178 %1))) ((%10 ((%32 (%5 %57)) ((%171 %175)
       %158))) (((%7 %1) %3) %5)))) (((%169 %3) ((%170 ((%22 %25) %23))
       ((%163 ((%171 %57) %23)) ((%49 %176) %179)))) ((%170 ((%22 %90)
       %158)) ((%163 %23) ((%142 %177) %179)))))`)
  val mImpm'Trans1 =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%172 ((%173 ((%174 %45) ((%103 %176) %25))) ((%104
       %90) %177))) (%178 %1))) (((%7 %1) %3) %5))) (((%169 %3) ((%170
       ((%22 %25) %23)) ((%163 ((%171 %57) %23)) ((%49 %176) %179))))
       ((%170 ((%22 %90) (%5 %57))) ((%163 %23) ((%142 %177) %179)))))`)
  val memMRule1 =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%172 ((%173 ((%174 %45) ((%103 %176) %25))) ((%104
       %90) %177))) (%178 %1))) ((%10 (((%7 %1) %3) %5)) ((%180 %181) (%5
       %57))))) ((%35 ((%43 ((%44 %45) ((%46 %176) ((%22 %25) %181))))
       ((%47 ((%22 %90) %181)) %177))) (%36 %3)))`)
  val listDerivLastBrk =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((((%182 %183) ((%184 %185) ((%171 %186) %23))) %187)
       %188)) (%11 ((%32 %185) %23)))) ((%10 ((((%182 %183) %185) %187)
       (%189 %185))) ((%10 ((%190 %186) %188)) ((%183 (%189 %185))
       %186))))`)
  val listDiv2 =
    DT(["DISK_THM"], [],
       `(%26 (\%185. (%191 (\%181. (%191 (\%192. ((%32 $2) ((%184 $1)
       $0))))))))`)
  val idcMemStates =
    DT(["DISK_THM"], [],
       `(%193 (\%194. (%193 (\%195. ((%127 (((%196 (%138 %139)) $1) $0))
       (%131 (\%132. (%123 (\%197. (%135 (\%198. ((%127 ((%199 $4) ((%140
       $2) ((%141 $1) $0)))) ((%127 ((%199 $3) ((%140 %200) ((%141 %201)
       %202)))) ((%127 ((%203 $2) (%204 %139))) ((%203 %200) (%204
       %139))))))))))))))))`)
  val idcStkNil' =
    DT(["DISK_THM"], [],
       `(%193 (\%194. (%193 (\%195. ((%127 (((%196 (%138 %139)) $1) $0))
       ((%127 ((%199 $1) ((%140 %132) ((%141 %197) %205)))) ((%199 $0)
       ((%140 %132) ((%141 %197) %205)))))))))`)
  val ldImprtc2list =
    DT(["DISK_THM"], [],
       `(%26 (\%206. (%131 (\%187. (%131 (\%207. ((%127 ((((%182 %183) $2)
       $1) $0)) (((%208 %183) $1) $0))))))))`)
  val memld =
    DT(["DISK_THM"], [],
       `((%127 ((((%182 %183) %206) %187) %207)) ((%10 ((%209 %187) %206))
       ((%209 %207) %206)))`)
  val stkSymsPdaInv =
    DT(["DISK_THM"], [],
       `(%193 (\%194. (%193 (\%195. ((%127 (((%196 (%138 %139)) $1) $0))
       (%131 (\%132. (%123 (\%197. (%135 (\%198. ((%127 ((%199 $4) ((%140
       $2) ((%141 $1) $0)))) ((%127 ((%199 $3) ((%140 %200) ((%141 %201)
       %202)))) ((%127 ((%210 %139) $0)) ((%210 %139) %202)))))))))))))))`)
  val memStkSyms =
    DT(["DISK_THM"], [],
       `(%26 (\%211. ((%127 ((%212 ((%213 ((%214 %215) ((%216 %217) %25)))
       ((%22 %218) $0))) (%219 %220))) ((%10 ((%203 %217) (%221 %220)))
       (%131 (\%186. ((%127 ((%209 $0) $1)) ((%203 $0) (%221
       %220)))))))))`)
  val m'toBufInpNil =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%132. (%135 (\%136. ((%127 ((((%224 (%225
       %151)) $2) ((%154 ((%155 $1) %51)) ((%141 %51) $0))) ((%154 ((%155
       %143) %226)) ((%141 %51) %144)))) ((%127 (((%150 %139) %151) %152))
       ((%227 %226) %51)))))))))`)
  val m'toBufNil =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%132. (%125 (\%126. (%135 (\%136. ((%127
       ((%10 ((((%224 (%225 %151)) $3) ((%154 ((%155 $2) %51)) ((%141 ((%49
       $1) %51)) $0))) ((%154 ((%155 %143) %226)) ((%141 %51) %144))))
       ((%10 (((%150 %139) %151) %152)) ((%227 (%152 $1)) %51)))) ((%227
       %226) %51))))))))))`)
  val m'Rule1 =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%35 ((%43 ((%44 %45) ((%46 %176) ((%22 %25) %23))))
       ((%47 ((%22 %228) %27)) %177))) (%36 %3))) (((%7 %1) %3) %5))) ((%32
       %27) %23))`)
  val idcStkLastStep =
    DT(["DISK_THM"], [],
       `(%193 (\%194. (%193 (\%195. ((%127 (((%196 (%138 %139)) $1) $0))
       (%131 (\%132. (%123 (\%197. (%135 (\%198. ((%127 ((%199 $4) ((%140
       $2) ((%141 $1) $0)))) ((%127 ((%199 $3) ((%140 %200) ((%141 %201)
       %205)))) ((%127 ((%164 (%229 $0)) %230)) (%146 (\%147. (%231 (\%232.
       (%16 (\%233. ((%10 (((%196 (%138 %139)) ((%140 $5) ((%141 $4) $3)))
       ((%140 $2) ((%141 $1) ((%234 $0) %205))))) (((%138 %139) ((%140 $2)
       ((%141 $1) ((%234 $0) %205)))) ((%140 %200) ((%141 %201)
       %205))))))))))))))))))))))))`)
  val memStates =
    DT(["DISK_THM"], [],
       `(%129 (\%130. (%131 (\%132. (%123 (\%197. (%135 (\%198. ((%127
       ((%10 ((((%137 (%138 %139)) $3) ((%140 $2) ((%141 $1) $0))) ((%140
       %200) ((%141 %201) %202)))) ((%164 (%235 $3)) (%166 (%167 %168)))))
       ((%10 ((%203 $2) (%204 %139))) ((%203 %200) (%204 %139))))))))))))`)
  val idZ0Inv =
    DT(["DISK_THM"], [],
       `((%127 ((%10 (((%236 %3) ((%170 %237) ((%163 %238) ((%142 %239)
       ((%49 (%15 %3)) %51))))) ((%170 %240) ((%163 %241) %242)))) (((%7
       %1) %3) %5))) (%231 (\%243. ((%227 %242) ((%142 $0) ((%49 (%15 %3))
       %51))))))`)
  val z0Inv =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%244 (\%245. (%123 (\%197. (%135 (\%198. (%135
       (\%246. ((%127 ((%10 ((((%224 (%225 %151)) $4) ((%154 $3) ((%141 $2)
       $1))) ((%154 %247) ((%141 %201) %202)))) ((%10 (((%150 %139) %151)
       %152)) ((%248 $1) ((%249 $0) ((%234 (%250 %151)) %205)))))) (%244
       (\%251. (%123 (\%232. (%135 (\%252. ((%127 ((%253 ((%154 $2) ((%141
       $1) $0))) $7)) (%148 (\%254. ((%248 $1) ((%249 $0) ((%234 (%250
       %151)) %205)))))))))))))))))))))))`)
  val memStkSymsEq =
    DT(["DISK_THM"], [],
       `((%6 ((%203 %186) (%221 %220))) ((%255 ((%190 %186) (%256 %220)))
       (%257 (\%215. (%146 (\%217. (%16 (\%25. (%16 (\%218. (%191 (\%258.
       ((%10 ((%212 ((%213 ((%214 $4) ((%216 $3) $2))) ((%22 $1) $0)))
       (%219 %220))) ((%255 ((%190 %186) $3)) ((%209 %186)
       $0)))))))))))))))`)
  val memStksymsm' =
    DT(["DISK_THM"], [],
       `(%131 (\%186. ((%127 ((%10 ((%203 $0) (%259 %260))) (((%261 %220)
       %260) %152))) ((%255 ((%203 $0) (%221 %220))) ((%190 $0) (%262
       %260))))))`)
  val mImpm'HNil =
    DT(["DISK_THM"], [],
       `(%26 (\%263. ((%127 ((%10 (((%7 %1) %3) %5)) ((%10 (%131 (\%186.
       ((%127 ((%209 $0) $1)) ((%32 (%5 $0)) %23))))) ((%10 ((%18 %25) (%19
       %1))) ((%264 %3) %265))))) (((%169 %3) ((%170 ((%22 %25) %23))
       ((%163 $0) ((%142 %265) ((%49 (%15 %3)) %51))))) ((%170 ((%22 %25)
       %23)) ((%163 %23) ((%142 %265) ((%49 (%15 %3)) %51))))))))`)
  val idMemStkSyms =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%124 %1) %266)) (((%161 %1) ((%162 %228) ((%163
       %267) %266))) ((%162 %218) ((%163 %268) %269))))) ((%124 %1)
       %269))`)
  val idStkSymsPdaInv =
    DT(["DISK_THM"], [],
       `((%127 ((%10 (((%161 %1) ((%162 %25) ((%163 %238) %265))) ((%162
       %228) ((%163 %267) %266)))) ((%124 %1) %265))) ((%124 %1) %266))`)
  val stkSymsm'Impm =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%264 %3) %270)) (((%7 %1) %3) %5))) (%125 (\%126.
       ((%127 ((%128 $0) %270)) ((%255 ((%12 $0) (%13 %1))) ((%14 $0) (%15
       %3)))))))`)
  val mImpm' =
    DT(["DISK_THM"], [],
       `(%26 (\%181. (%271 (\%272. (%125 (\%273. (%135 (\%136. ((%127 ((%10
       ((((%274 (%275 %276)) $2) ((%277 $1) ((%278 (%279 ((%280 %5) $3)))
       $0))) ((%277 %281) ((%278 %23) %144)))) ((%10 (((%282 %276) %283)
       %5)) ((%10 ((%164 (%284 $2)) (%166 (%167 %168)))) ((%10 ((%285 %283)
       $0)) ((%12 $1) (%286 %276))))))) (((%287 %283) ((%288 ((%289 $1)
       %23)) ((%278 $3) ((%249 $0) ((%234 (%290 %283)) %205))))) ((%288
       ((%289 %281) %23)) ((%278 %23) ((%249 %144) ((%234 (%290 %283))
       %205))))))))))))))`)
  val stkSymsInPdaApp =
    DT(["DISK_THM"], [],
       `(%26 (\%263. (%26 (\%291. ((%6 ((%292 %220) ((%184 $1) $0))) ((%10
       ((%292 %220) $1)) ((%292 %220) $0)))))))`)
  val idcBufLen =
    DT(["DISK_THM"], [],
       `(%293 (\%294. (%293 (\%295. ((%127 (((%296 (%225 %151)) $1) $0))
       ((%127 (((%150 %139) %151) %152)) (%131 (\%132. (%123 (\%297. (%123
       (\%197. (%135 (\%198. (%131 (\%200. (%123 (\%298. (%135 (\%202.
       ((%127 ((%299 $8) ((%154 ((%155 $6) $5)) ((%141 $4) $3)))) ((%127
       ((%299 $7) ((%154 ((%155 $2) $1)) ((%141 $4) $0)))) ((%300 (%301
       $1)) (%301 $5))))))))))))))))))))))))`)
  val rule3Stk =
    DT(["DISK_THM"], [],
       `((%127 ((%302 ((%61 ((%62 (%63 %175)) ((%64 %303) %304))) ((%47
       %305) %177))) (((%54 %1) %3) %5))) ((%227 %177) ((%49 %303) %51)))`)
  val stkSymsPdaInvm'm =
    DT(["DISK_THM"], [],
       `(%293 (\%294. (%293 (\%295. ((%127 (((%296 (%225 %151)) $1) $0))
       ((%127 (((%150 %139) %151) %152)) (%244 (\%247. (%123 (\%201. (%135
       (\%202. ((%127 ((%299 $4) ((%154 %245) ((%141 %197) ((%249 %198)
       ((%234 (%250 %151)) %205)))))) ((%127 ((%299 $3) ((%154 $2) ((%141
       $1) ((%249 $0) ((%234 (%250 %151)) %205)))))) ((%127 ((%210 %139)
       %198)) ((%210 %139) $0))))))))))))))))`)
  val m'ImpmNil =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%132. (%135 (\%254. ((%127 ((%10 ((((%224
       (%225 %151)) $2) ((%154 ((%155 $1) %51)) ((%141 %51) ((%249 $0)
       ((%234 (%250 %151)) %205))))) ((%154 ((%155 %143) %51)) ((%141 %51)
       ((%249 %144) ((%234 (%250 %151)) %205)))))) ((%10 ((%203 $1) (%204
       %139))) ((%10 (((%150 %139) %151) %152)) ((%210 %139) $0)))))
       (((%145 %139) ((%140 $1) ((%141 %51) $0))) ((%140 %143) ((%141 %51)
       %144))))))))))`)
  val m'StepBufToNil =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%132. (%123 (\%297. (%123 (\%133. (%135
       (\%254. ((%127 ((%10 ((((%224 (%225 %151)) $4) ((%154 ((%155 $3)
       $2)) ((%141 $1) ((%249 $0) ((%234 (%250 %151)) %205))))) ((%154
       ((%155 %143) %51)) ((%141 %51) ((%249 %144) ((%234 (%250 %151))
       %205)))))) (((%150 %139) %151) %152))) (%146 (\%147. (%148 (\%149.
       ((%10 (((%153 %151) ((%154 ((%155 $5) $4)) ((%141 $3) ((%249 $2)
       ((%234 (%250 %151)) %205))))) ((%154 ((%155 $1) %51)) ((%141 $3)
       ((%249 $0) ((%234 (%250 %151)) %205)))))) (((%153 %151) ((%154
       ((%155 $1) %51)) ((%141 $3) ((%249 $0) ((%234 (%250 %151)) %205)))))
       ((%154 ((%155 %143) %51)) ((%141 %51) ((%249 %144) ((%234 (%250
       %151)) %205)))))))))))))))))))))`)
  val m'StepBufNilH =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%143. (%123 (\%297. (%135 (\%144. ((%127
       ((%10 ((((%224 (%225 %151)) $3) ((%154 ((%155 %132) %51)) ((%141
       ((%49 %126) %51)) ((%249 %254) ((%234 (%250 %151)) %205))))) ((%154
       ((%155 $2) $1)) ((%141 %51) ((%249 $0) ((%234 (%250 %151))
       %205)))))) (((%150 %139) %151) %152))) (%146 (\%147. (%148 (\%149.
       ((%10 (((%153 %151) ((%154 ((%155 %132) %51)) ((%141 ((%49 %126)
       %51)) ((%249 %254) ((%234 (%250 %151)) %205))))) ((%154 ((%155 $1)
       (%152 %126))) ((%141 %51) ((%249 $0) ((%234 (%250 %151)) %205))))))
       (((%153 %151) ((%154 ((%155 $1) (%152 %126))) ((%141 %51) ((%249 $0)
       ((%234 (%250 %151)) %205))))) ((%154 ((%155 $4) $3)) ((%141 %51)
       ((%249 $2) ((%234 (%250 %151)) %205)))))))))))))))))))`)
  val m'ImpmBufInpSame =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%132. (%123 (\%297. (%123 (\%133. (%135
       (\%254. ((%127 ((%10 ((((%224 (%225 %151)) $4) ((%154 ((%155 $3)
       $2)) ((%141 $1) ((%249 $0) ((%234 (%250 %151)) %205))))) ((%154
       ((%155 %143) %298)) ((%141 $1) ((%249 %144) ((%234 (%250 %151))
       %205)))))) ((%10 ((%203 $3) (%204 %139))) (((%150 %139) %151)
       %152)))) (((%145 %139) ((%140 $3) ((%141 $2) $0))) ((%140 %143)
       ((%141 %298) %144))))))))))))))`)
  val m'isSuff =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%200. (%123 (\%297. (%135 (\%144. ((%127
       ((%10 ((((%224 (%225 %151)) $3) ((%154 ((%155 %132) %51)) ((%141
       ((%49 %303) %51)) ((%249 %254) ((%234 (%250 %151)) %205))))) ((%154
       ((%155 $2) $1)) ((%141 %51) ((%249 $0) ((%234 (%250 %151))
       %205)))))) (((%150 %139) %151) %152))) ((%306 $1) (%152
       %303)))))))))))`)
  val m'ImpmhTohh' =
    DT(["DISK_THM"], [],
       `(%222 (\%223. (%131 (\%200. (%135 (\%144. ((%127 ((%10 ((((%224
       (%225 %151)) $2) ((%154 ((%155 %132) %51)) ((%141 ((%49 %303) %51))
       ((%249 %254) ((%234 (%250 %151)) %205))))) ((%154 ((%155 $1) (%152
       %303))) ((%141 %51) ((%249 $0) ((%234 (%250 %151)) %205)))))) ((%10
       (((%150 %139) %151) %152)) ((%203 %132) (%204 %139))))) (((%145
       %139) ((%140 %132) ((%141 %51) %254))) ((%140 $1) ((%141 %51)
       $0))))))))))`)
  val m'StateImpm =
    DT(["DISK_THM"], [],
       `(%131 (\%132. (%123 (\%297. (%123 (\%197. (%135 (\%198. ((%127
       ((%10 ((((%224 (%225 %151)) %223) ((%154 ((%155 $3) $2)) ((%141 $1)
       $0))) ((%154 ((%155 %200) %298)) ((%141 %201) %202)))) ((%10 (((%150
       %139) %151) %152)) ((%203 $3) (%204 %139))))) ((%203 %200) (%204
       %139)))))))))))`)
  val m'Impm =
    DT(["DISK_THM"], [],
       `(%307 (\%308. (%24 (\%25. (%123 (\%243. ((%127 ((%10 ((((%309 (%236
       %3)) $2) ((%170 ((%22 $1) %23)) ((%163 %181) ((%142 $0) ((%49 (%15
       %3)) %51))))) ((%170 ((%22 %90) %23)) ((%163 %23) ((%142 %159) ((%49
       (%15 %3)) %51)))))) ((%10 ((%124 %1) $0)) ((%10 ((%18 $1) (%19 %1)))
       (((%7 %1) %3) %5))))) (%310 (\%311. ((((%160 (%161 %1)) $0) ((%162
       $2) ((%163 (%279 ((%280 %5) %181))) $1))) ((%162 %90) ((%163 %23)
       %159))))))))))))`)
  val m'FstStep =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((((%224 (%225 %151)) %312) ((%154 (%313 %151)) ((%141
       %133) ((%234 (%250 %151)) %205)))) ((%154 %314) ((%141 %51) %315))))
       ((%10 (%11 ((%316 %314) (%313 %151)))) (((%150 %139) %151) %152))))
       ((((%224 (%225 %151)) (%317 %312)) ((%154 ((%155 (%318 %139)) %51))
       ((%141 %133) ((%249 ((%234 (%319 %139)) %205)) ((%234 (%250 %151))
       %205))))) ((%154 %314) ((%141 %51) %315))))`)
  val m'FinState =
    DT(["DISK_THM"], [],
       `((%127 ((%10 ((%320 ((%155 %132) %226)) (%321 %151))) (((%150 %139)
       %151) %152))) ((%10 (%11 ((%316 ((%155 %132) %226)) (%313 %151))))
       ((%227 %226) %51)))`)
  val mSsymInm' =
    DT(["DISK_THM"], [],
       `((%127 (((%7 %1) %3) %5)) ((%264 %3) ((%49 (%50 %1)) %51)))`)
  val invhEq =
    DT(["DISK_THM"], [],
       `(%0 (\%1. (%2 (\%3. ((%127 (((%7 $1) $0) %5)) ((%6 ((%70 %181)
       (%322 $0))) ((%70 %181) (%323 (\%324. ((%325 $0) ((%70 (%279 ((%280
       %5) $0))) (%326 $2))))))))))))`)
  end
  val _ = DB.bindl "homomorphism"
  [("hInvpda_def",hInvpda_def,DB.Def), ("rule3_def",rule3_def,DB.Def),
   ("rule2_def",rule2_def,DB.Def), ("rule1_def",rule1_def,DB.Def),
   ("stkSymsInPda_def",stkSymsInPda_def,DB.Def),
   ("idTransOnInpPfxToNil",idTransOnInpPfxToNil,DB.Thm),
   ("idTransOnInpPfx",idTransOnInpPfx,DB.Thm),
   ("mImpm'InpNil",mImpm'InpNil,DB.Thm),
   ("mImpm'OneSym",mImpm'OneSym,DB.Thm),
   ("mImpm'Trans2",mImpm'Trans2,DB.Thm),
   ("mImpm'Trans1",mImpm'Trans1,DB.Thm), ("memMRule1",memMRule1,DB.Thm),
   ("listDerivLastBrk",listDerivLastBrk,DB.Thm),
   ("listDiv2",listDiv2,DB.Thm), ("idcMemStates",idcMemStates,DB.Thm),
   ("idcStkNil'",idcStkNil',DB.Thm),
   ("ldImprtc2list",ldImprtc2list,DB.Thm), ("memld",memld,DB.Thm),
   ("stkSymsPdaInv",stkSymsPdaInv,DB.Thm),
   ("memStkSyms",memStkSyms,DB.Thm),
   ("m'toBufInpNil",m'toBufInpNil,DB.Thm),
   ("m'toBufNil",m'toBufNil,DB.Thm), ("m'Rule1",m'Rule1,DB.Thm),
   ("idcStkLastStep",idcStkLastStep,DB.Thm),
   ("memStates",memStates,DB.Thm), ("idZ0Inv",idZ0Inv,DB.Thm),
   ("z0Inv",z0Inv,DB.Thm), ("memStkSymsEq",memStkSymsEq,DB.Thm),
   ("memStksymsm'",memStksymsm',DB.Thm), ("mImpm'HNil",mImpm'HNil,DB.Thm),
   ("idMemStkSyms",idMemStkSyms,DB.Thm),
   ("idStkSymsPdaInv",idStkSymsPdaInv,DB.Thm),
   ("stkSymsm'Impm",stkSymsm'Impm,DB.Thm), ("mImpm'",mImpm',DB.Thm),
   ("stkSymsInPdaApp",stkSymsInPdaApp,DB.Thm),
   ("idcBufLen",idcBufLen,DB.Thm), ("rule3Stk",rule3Stk,DB.Thm),
   ("stkSymsPdaInvm'm",stkSymsPdaInvm'm,DB.Thm),
   ("m'ImpmNil",m'ImpmNil,DB.Thm),
   ("m'StepBufToNil",m'StepBufToNil,DB.Thm),
   ("m'StepBufNilH",m'StepBufNilH,DB.Thm),
   ("m'ImpmBufInpSame",m'ImpmBufInpSame,DB.Thm),
   ("m'isSuff",m'isSuff,DB.Thm), ("m'ImpmhTohh'",m'ImpmhTohh',DB.Thm),
   ("m'StateImpm",m'StateImpm,DB.Thm), ("m'Impm",m'Impm,DB.Thm),
   ("m'FstStep",m'FstStep,DB.Thm), ("m'FinState",m'FinState,DB.Thm),
   ("mSsymInm'",mSsymInm',DB.Thm), ("invhEq",invhEq,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("pdaDefTheory.pdaDef_grammars",
                          pdaDefTheory.pdaDef_grammars),
                         ("parseTreeTheory.parseTree_grammars",
                          parseTreeTheory.parseTree_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("stkSymsInPda", (Term.prim_mk_const { Name = "stkSymsInPda", Thy = "homomorphism"}))
  val _ = update_grms
       temp_overload_on
       ("rule1", (Term.prim_mk_const { Name = "rule1", Thy = "homomorphism"}))
  val _ = update_grms
       temp_overload_on
       ("rule2", (Term.prim_mk_const { Name = "rule2", Thy = "homomorphism"}))
  val _ = update_grms
       temp_overload_on
       ("rule3", (Term.prim_mk_const { Name = "rule3", Thy = "homomorphism"}))
  val _ = update_grms
       temp_overload_on
       ("hInvpda", (Term.prim_mk_const { Name = "hInvpda", Thy = "homomorphism"}))
  val homomorphism_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ = computeLib.add_funs [stkSymsInPda_def];  
  
  val _ = computeLib.add_funs [rule1_def];  
  
  val _ = computeLib.add_funs [rule2_def];  
  
  val _ = computeLib.add_funs [rule3_def];  
  
  val _ = computeLib.add_funs [hInvpda_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
