signature laeslafsTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val finalStateTrans_def : thm
    val fst1_def : thm
    val newStateTrans_def : thm
    val newm'_def : thm
    val newm_def : thm
    val toFinalStateTrans_def : thm
  
  (*  Theorems  *)
    val finalStateRule : thm
    val fsTransPfxNil : thm
    val fstApp : thm
    val idFromQeInpSame : thm
    val idFsToQeInpSame : thm
    val idLaesImpLafs' : thm
    val idLafsImpLaes : thm
    val idMemStkSyms : thm
    val idNewm'EndSt : thm
    val idNewm'FstStep : thm
    val idNewm'ImpOldm : thm
    val idNewmFstStep : thm
    val idNewmImpOldm : thm
    val idNewmQe : thm
    val idQeTrans : thm
    val idStatesMem : thm
    val idStatesMem' : thm
    val idcLaesImpLafs' : thm
    val idcLafsImpLaes : thm
    val idcMemStkSyms : thm
    val idcNewm'ImpOldm : thm
    val idcNewmFinalToQe : thm
    val idcNewmFinalToQe' : thm
    val idcNewmImpOldm : thm
    val idcNewmPopStk : thm
    val idcNewmPopStkQe : thm
    val laesImpLafs : thm
    val laesImpLafs' : thm
    val lafsImpLaes : thm
    val lafsImpLaes' : thm
    val listFsExists : thm
    val listFsExists' : thm
    val listQeOnly : thm
    val listQeTrans : thm
    val listQeTransInpSame : thm
    val memFslFst : thm
    val memFslFst' : thm
    val memFst1 : thm
    val memNewmStkSyms : thm
    val memOldmStkSyms : thm
    val memStartStateNewm' : thm
    val memToQeNewm : thm
    val newm'ssSym : thm
    val newm'start : thm
    val newm'toFs : thm
    val newmFstRule : thm
    val newmFstStep : thm
    val newmNullStkStQe : thm
    val newmNullStkStQeLd : thm
    val newmQeRule : thm
    val newmStartRule : thm
    val newmssSym : thm
    val newmstart : thm
    val notSomeInpMemFst : thm
    val notSomeInpMemFst' : thm
    val notSomeInpMemNst : thm
    val notSomeMemNewm : thm
    val notSomeMemQeNewm : thm
    val nstApp : thm
    val ruleMemStkSyms : thm
    val slFslNil : thm
    val slNstNil : thm
    val stEqNst : thm
    val stkSymsFst : thm
    val stkSymsNst : thm
    val thm51 : thm
    val thm52 : thm
    val toFsFromOldSt : thm
    val toFsStk : thm
    val toFsTrans : thm
    val toStEqFs : thm
    val toStEqNFst : thm
    val toStEqNst : thm
    val transStIsFs : thm
    val x0TransStIsQe : thm
  
  val laeslafs_grammars : type_grammar.grammar * term_grammar.grammar
  
  
(*
   [pdaDef] Parent theory of "laeslafs"
   
   [finalStateTrans_def]  Definition
      
      |- (∀ns fsl. finalStateTrans ns fsl [] = []) ∧
         ∀ns fsl s rst.
           finalStateTrans ns fsl (s::rst) =
           MAP (fst1 ns s) fsl ++ finalStateTrans ns fsl rst
   
   [fst1_def]  Definition
      
      |- ∀ns ssym fs. fst1 ns ssym fs = ((NONE,ssym,fs),ns,[])
   
   [newStateTrans_def]  Definition
      
      |- (∀ns. newStateTrans ns [] = []) ∧
         ∀ns s rst.
           newStateTrans ns (s::rst) = ((NONE,s,ns),ns,[])::newStateTrans ns rst
   
   [newm'_def]  Definition
      
      |- ∀p q0' x0 qf.
           newm' p (q0',x0,qf) =
           (let d =
                  [((NONE,x0,q0'),p.start,[p.ssSym; x0])] ++ p.next ++
                  MAP (toFinalStateTrans x0 qf) (statesList p p.next)
            in
              <|start := q0'; ssSym := x0; next := d; final := [qf]|>)
   
   [newm_def]  Definition
      
      |- ∀p q0 x0 qe.
           newm p (q0,x0,qe) =
           (let d =
                  [((NONE,x0,q0),p.start,[p.ssSym; x0])] ++ p.next ++
                  finalStateTrans qe p.final (x0::stkSymsList p p.next) ++
                  newStateTrans qe (x0::stkSymsList p p.next)
            in
              <|start := q0; ssSym := x0; next := d; final := []|>)
   
   [toFinalStateTrans_def]  Definition
      
      |- ∀x0 qf st. toFinalStateTrans x0 qf st = ((NONE,x0,st),qf,[])
   
   [finalStateRule]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
         (m' = newm' m (q0',x0,qf)) ∧ MEM state (statesList m m.next) ⇒
         MEM ((NONE,x0,state),qf,[]) m'.next
   
   [fsTransPfxNil]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ ¬MEM x0 p' ∧
         newm' m (q0',x0,qf) ⊢ (q,i,p' ++ [x0]) → (qf,i',stk) ⇒
         (p' = []) ∧ (stk = [])
   
   [fstApp]  Theorem
      
      |- ∀p1 p2.
           finalStateTrans ns fsl (p1 ++ p2) =
           finalStateTrans ns fsl p1 ++ finalStateTrans ns fsl p2
   
   [idFromQeInpSame]  Theorem
      
      |- ∀dl qe inp stk inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           newm m (q0',x0,qe) ⊢ (qe,inp,stk) → (q',inp',stk') ⇒
           (inp = inp') ∧ (q' = qe)
   
   [idFsToQeInpSame]  Theorem
      
      |- ∀dl qe inp stk inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           MEM qf m.final ∧ newm m (q0',x0,qe) ⊢ (qf,inp,stk) → (qe,inp',stk') ⇒
           (inp = inp')
   
   [idLaesImpLafs']  Theorem
      
      |- ∀x y.
           m ⊢ x → y ∧ x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ⇒
           newm' m (q0',x0,qf) ⊢ x → y
   
   [idLafsImpLaes]  Theorem
      
      |- ∀x y.
           m ⊢ x → y ∧ x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
           newm m (q0',x0,qe) ⊢ x → y
   
   [idMemStkSyms]  Theorem
      
      |- m ⊢ (q,s0,stk) → (q',s1,stk') ∧
         (∀e. MEM e stk ⇒ MEM e (stkSymsList m m.next)) ⇒
         ∀e. MEM e stk' ⇒ MEM e (stkSymsList m m.next)
   
   [idNewm'EndSt]  Theorem
      
      |- ∀i s q' i' s'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ qf ≠ q0' ⇒
           ¬(newm' m (q0',x0,qf) ⊢ (qf,i,s) → (q',i',s'))
   
   [idNewm'FstStep]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ q0' ≠ qf ∧
         newm' m (q0',x0,qf) ⊢ (q0',i,[x0]) → (q,q'',r') ⇒
         (q = m.start) ∧ (q'' = i) ∧ (r' = [m.ssSym; x0])
   
   [idNewm'ImpOldm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
         newm' m (q0',x0,qf) ⊢ (q,i,s) → (q',i',s') ∧ q' ∈ states m ⇒
         (q = q0') ∨ q ∈ states m ∧ m ⊢ (q,i,s) → (q',i',s')
   
   [idNewmFstStep]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         newm m (q0',x0,qe) ⊢ (q0',i,[x0]) → (q,q'',r') ⇒
         (q = m.start) ∧ (q'' = i) ∧ (r' = [m.ssSym; x0])
   
   [idNewmImpOldm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         newm m (q0',x0,qe) ⊢ (q,i,s) → (q',i',s') ∧ q' ∈ states m ⇒
         (q = q0') ∨ q ∈ states m ∧ m ⊢ (q,i,s) → (q',i',s')
   
   [idNewmQe]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         (∀e. MEM e (h::stk) ⇒ MEM e (stkSymsList m m.next) ∨ (e = x0)) ⇒
         newm m (q0',x0,qe) ⊢ (qe,inp,h::stk) → (qe,inp,stk)
   
   [idQeTrans]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         newm m (q0',x0,qe) ⊢ (q,inp,stk) → (qe,q'',r') ⇒
         (q'' = inp) ∧ (r' = TL stk)
   
   [idStatesMem]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         newm m (q0',x0,qe) ⊢ (q,s,stk) → (q',s',stk') ∧ q ∈ states m ⇒
         (q' = qe) ∨ q' ∈ states m
   
   [idStatesMem']  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ q0' ≠ qf ∧
         newm' m (q0',x0,qf) ⊢ (q,s,stk) → (q',s',stk') ∧ q ∈ states m ⇒
         (q' = qf) ∨ q' ∈ states m
   
   [idcLaesImpLafs']  Theorem
      
      |- ∀x y.
           (ID m)^* x y ⇒
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ⇒
           (ID (newm' m (q0',x0,qf)))^* x y
   
   [idcLafsImpLaes]  Theorem
      
      |- ∀x y.
           (ID m)^* x y ⇒
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
           (ID (newm m (q0',x0,qe)))^* x y
   
   [idcMemStkSyms]  Theorem
      
      |- (ID m)^* (s,inp,st) (s',inp',st') ∧
         (∀e. MEM e st ⇒ MEM e (stkSymsList m m.next)) ⇒
         ∀e. MEM e st' ⇒ MEM e (stkSymsList m m.next)
   
   [idcNewm'ImpOldm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ q0' ≠ qf ∧
         (ID (newm' m (q0',x0,qf)))^* (q,i,s) (q',i',s') ∧ q' ∈ states m ∧
         q ∈ states m ⇒
         (ID m)^* (q,i,s) (q',i',s')
   
   [idcNewmFinalToQe]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         (ID (newm m (q0',x0,qe)))^* (st,inp,sk) (qe,inp',sk') ⇒
         (st = qe) ∨
         ∃y st' i s.
           (ID (newm m (q0',x0,qe)))^* (st,inp,sk) y ∧
           (ID (newm m (q0',x0,qe)))^* y (qe,inp',sk') ∧ (y = (st',i,s)) ∧
           MEM st' m.final
   
   [idcNewmFinalToQe']  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         (ID (newm m (q0',x0,qe)))^* (st,inp,sk) (qe,inp',sk') ⇒
         (st = qe) ∨
         ∃y st' i s sk''.
           (ID (newm m (q0',x0,qe)))^* (st,inp,sk) y ∧
           newm m (q0',x0,qe) ⊢ y → (qe,inp',sk'') ∧
           (ID (newm m (q0',x0,qe)))^* (qe,inp',sk'') (qe,inp',sk') ∧
           (y = (st',i,s)) ∧ MEM st' m.final
   
   [idcNewmImpOldm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         (ID (newm m (q0',x0,qe)))^* (q,i,s) (q',i',s') ∧ q' ∈ states m ∧
         q ∈ states m ⇒
         (ID m)^* (q,i,s) (q',i',s')
   
   [idcNewmPopStk]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ MEM q m.final ∧ stk ≠ [] ∧
         (∀e. MEM e stk ⇒ MEM e (stkSymsList m m.next) ∨ (e = x0)) ⇒
         (ID (newm m (q0',x0,qe)))^* (q,inp,stk) (qe,inp,[])
   
   [idcNewmPopStkQe]  Theorem
      
      |- ∀stk.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ MEM q m.final ∧
           stk ≠ [] ∧ (∀e. MEM e stk ⇒ MEM e (stkSymsList m m.next) ∨ (e = x0)) ⇒
           (ID (newm m (q0',x0,qe)))^* (qe,inp,stk) (qe,inp,[])
   
   [laesImpLafs]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ⇒
         x ∈ laes (newm m (q0',x0,qe)) ⇒
         x ∈ lafs m
   
   [laesImpLafs']  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ⇒
         x ∈ laes m ⇒
         x ∈ lafs (newm' m (q0',x0,qf))
   
   [lafsImpLaes]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         x ∈ lafs m ⇒
         x ∈ laes (newm m (q0',x0,qe))
   
   [lafsImpLaes']  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ q0' ≠ qf ⇒
         x ∈ lafs (newm' m (q0',x0,qf)) ⇒
         x ∈ laes m
   
   [listFsExists]  Theorem
      
      |- ∀dl q inp stk qe inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (q,inp,stk) → (qe,inp',stk') ∧ q ≠ qe ⇒
           ∃qf sk. MEM (qf,inp',sk) dl ∧ MEM qf m.final
   
   [listFsExists']  Theorem
      
      |- ∀dl q inp stk qe inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (q,inp,stk) → (qe,inp',stk') ∧ q ≠ qe ⇒
           ∃p s qf sk.
             (dl = p ++ [(qf,inp',sk)] ++ s) ∧ MEM qf m.final ∧
             ∀e. MEM e s ⇒ ∃i sk. e = (qe,i,sk)
   
   [listQeOnly]  Theorem
      
      |- ∀dl inp stk qe q' inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (qe,inp,stk) → (q',inp,stk') ⇒
           ∀e. MEM e dl ⇒ ∃i sk. e = (qe,inp,sk)
   
   [listQeTrans]  Theorem
      
      |- ∀dl qe inp stk st inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (qe,inp,stk) → (st,inp',stk') ⇒
           (st = qe)
   
   [listQeTransInpSame]  Theorem
      
      |- ∀dl qe inp stk inp' stk'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (qe,inp,stk) → (qe,inp',stk') ⇒
           (inp = inp')
   
   [memFslFst]  Theorem
      
      |- ∀fl sl'. MEM ((NONE,h,q),q',sl) (finalStateTrans qe fl sl') ⇒ MEM q fl
   
   [memFslFst']  Theorem
      
      |- ∀fl sl'.
           MEM ((NONE,h,q),q',sl) (MAP (toFinalStateTrans x0 qf) sl') ⇒ MEM q sl'
   
   [memFst1]  Theorem
      
      |- ∀e fsl.
           MEM e (MAP (fst1 ns ssym) fsl) ⇒
           ∃fs. (e = ((NONE,ssym,fs),ns,[])) ∧ MEM fs fsl
   
   [memNewmStkSyms]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         (m' = newm m (q0',x0,qe)) ⇒
         MEM x0 (stkSymsList m' m'.next) ∧ MEM m.ssSym (stkSymsList m' m'.next)
   
   [memOldmStkSyms]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         (m' = newm m (q0',x0,qe)) ⇒
         ∀e. MEM e (stkSymsList m' m'.next) ⇒ (e = x0) ∨ MEM e (stkSymsList m m.next)
   
   [memStartStateNewm']  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
         (m' = newm' m (q0',x0,qf)) ⇒
         MEM m.start (statesList m' m'.next)
   
   [memToQeNewm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         MEM ((NONE,h,qe),q,sl) (newm m (q0',x0,qe)).next ⇒
         (q = qe) ∧ (sl = [])
   
   [newm'ssSym]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ⇒
         ((newm' m (q0',x0,qf)).ssSym = x0)
   
   [newm'start]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ⇒
         ((newm' m (q0',x0,qf)).start = q0')
   
   [newm'toFs]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
         newm' m (q0',x0,qf) ⊢ (q,i,s) → (qf,i',s') ⇒
         (i = i') ∧ (s' = TL s)
   
   [newmFstRule]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ MEM q m.final ∧
         (MEM h (stkSymsList m m.next) ∨ (h = x0)) ⇒
         newm m (q0',x0,qe) ⊢ (q,inp,h::t) → (qe,inp,t)
   
   [newmFstStep]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         (ID (newm m (q0',x0,qe)))^* (q0',i,[x0]) (q',i',s') ∧ q0' ≠ q' ⇒
         newm m (q0',x0,qe) ⊢ (q0',i,[x0]) → (m.start,i,[m.ssSym; x0]) ∧
         (ID (newm m (q0',x0,qe)))^* (m.start,i,[m.ssSym; x0]) (q',i',s')
   
   [newmNullStkStQe]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         (ID (newm m (q0',x0,qe)))^* (q,inp,stk ++ [x0]) (state,[],[]) ⇒
         (state = qe)
   
   [newmNullStkStQeLd]  Theorem
      
      |- ∀dl q inp stk.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
           ID (newm m (q0',x0,qe)) ⊢ dl ◁ (q,inp,stk) → (state,[],[]) ∧ MEM x0 stk ⇒
           (state = qe)
   
   [newmQeRule]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         (MEM h (stkSymsList m m.next) ∨ (h = x0)) ⇒
         MEM ((NONE,h,qe),qe,[]) (newm m (q0',x0,qe)).next
   
   [newmStartRule]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         MEM ((NONE,x0,q0'),m.start,[m.ssSym; x0]) (newm m (q0',x0,qe)).next
   
   [newmssSym]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         ((newm m (q0',x0,qe)).ssSym = x0)
   
   [newmstart]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         ((newm m (q0',x0,qe)).start = q0')
   
   [notSomeInpMemFst]  Theorem
      
      |- ∀fsl sl'. ¬MEM ((SOME h,h',q),q',sl) (finalStateTrans qe fsl sl')
   
   [notSomeInpMemFst']  Theorem
      
      |- ∀fsl sl'. ¬MEM ((SOME h,h',q),q',sl) (MAP (toFinalStateTrans x0 qf) stl)
   
   [notSomeInpMemNst]  Theorem
      
      |- ∀fsl sl'. ¬MEM ((SOME h,h',q),q',sl) (newStateTrans qe sl')
   
   [notSomeMemNewm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         ¬MEM ((SOME h,h',q),qe,sl) (newm m (q0',x0,qe)).next
   
   [notSomeMemQeNewm]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ⇒
         ¬MEM ((SOME h,h',qe),q,sl) (newm m (q0',x0,qe)).next
   
   [nstApp]  Theorem
      
      |- ∀p1 p2.
           newStateTrans ns (p1 ++ p2) = newStateTrans ns p1 ++ newStateTrans ns p2
   
   [ruleMemStkSyms]  Theorem
      
      |- ∀sl.
           MEM ((x,h,q),q',sl) m.next ⇒
           MEM h (stkSymsList m m.next) ∧ ∀e. MEM e sl ⇒ MEM e (stkSymsList m m.next)
   
   [slFslNil]  Theorem
      
      |- ∀fl sl'. MEM ((NONE,h,q),q',sl) (finalStateTrans qe fl sl') ⇒ (sl = [])
   
   [slNstNil]  Theorem
      
      |- ∀sl'. MEM ((NONE,h,q),q',sl) (newStateTrans qe sl') ⇒ (sl = [])
   
   [stEqNst]  Theorem
      
      |- ∀sl'. MEM ((NONE,h,q),q',sl) (newStateTrans qe sl') ⇒ (q = qe)
   
   [stkSymsFst]  Theorem
      
      |- ∀sl stl e. MEM e (stkSymsList' (finalStateTrans q stl sl)) ⇒ MEM e sl
   
   [stkSymsNst]  Theorem
      
      |- ∀sl e. MEM e (stkSymsList' (newStateTrans q sl)) ⇒ MEM e sl
   
   [thm51]  Theorem
      
      |- INFINITE SYMUNIV ∧ INFINITE STUNIV ⇒ ∀m. ∃m'. lafs m = laes m'
   
   [thm52]  Theorem
      
      |- INFINITE SYMUNIV ∧ INFINITE STUNIV ⇒ ∀m. ∃m'. laes m = lafs m'
   
   [toFsFromOldSt]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
         newm' m (q0',x0,qf) ⊢ (q,i,s) → (qf,i',s') ⇒
         q ∈ states m
   
   [toFsStk]  Theorem
      
      |- ∀q i s i' s'.
           x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧
           newm' m (q0',x0,qf) ⊢ (q,i,s) → (qf,i',s') ⇒
           ∃sfx. (s = [x0] ++ sfx) ∧ (s' = sfx)
   
   [toFsTrans]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qf ∉ states m ∧ state ∈ states m ∧
         (m' = newm' m (q0',x0,qf)) ⇒
         MEM ((NONE,x0,state),qf,[]) m'.next
   
   [toStEqFs]  Theorem
      
      |- ∀fsl sl'.
           MEM ((NONE,h',q),q',sl) (MAP (toFinalStateTrans x0 qf) stl) ⇒
           (q' = qf) ∧ (sl = []) ∧ (h' = x0)
   
   [toStEqNFst]  Theorem
      
      |- ∀fsl sl'. MEM ((NONE,h,q),q',sl) (finalStateTrans qe fsl sl') ⇒ (q' = qe)
   
   [toStEqNst]  Theorem
      
      |- ∀sl'. MEM ((NONE,h,q),q',sl) (newStateTrans qe sl') ⇒ (q' = qe)
   
   [transStIsFs]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧
         MEM ((NONE,h,q),qe,sl) (newm m (q0',x0,qe)).next ∧ q ≠ qe ⇒
         MEM q m.final ∧ (sl = [])
   
   [x0TransStIsQe]  Theorem
      
      |- x0 ∉ stkSyms m ∧ q0' ∉ states m ∧ qe ∉ states m ∧ q0' ≠ qe ∧
         newm m (q0',x0,qe) ⊢ (q,inp,stk) → (q',q'',r') ∧ MEM x0 stk ∧ ¬MEM x0 r' ⇒
         (q' = qe)
   
   
*)
end
