structure laeslafsTheory :> laeslafsTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading laeslafsTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open pdaDefTheory
  in end;
  val _ = Theory.link_parents
          ("laeslafs",
          Arbnum.fromString "1259372907",
          Arbnum.fromString "333872")
          [("pdaDef",
           Arbnum.fromString "1259372202",
           Arbnum.fromString "356145")];
  val _ = Theory.incorporate_types "laeslafs" [];
  val _ = Theory.incorporate_consts "laeslafs"
     [("toFinalStateTrans",
       ((beta -->
         (delta -->
          (gamma -->
           T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
             T"prod" "pair" [delta, T"list" "list" [U"'e"]]]))))),
      ("newm'",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         (T"prod" "pair" [U"'state", T"prod" "pair" [U"'ssym", U"'state"]]
          --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("newm",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         (T"prod" "pair" [U"'state", T"prod" "pair" [U"'ssym", U"'state"]]
          --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("newStateTrans",
       ((U"'state" -->
         (T"list" "list" [U"'ssym"] -->
          T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [U"'isym"],
                T"prod" "pair" [U"'ssym", U"'state"]],
              T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])))),
      ("fst1",
       ((U"'state" -->
         (U"'ssym" -->
          (U"'state" -->
           T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]))))),
      ("finalStateTrans",
       ((gamma -->
         (T"list" "list" [gamma] -->
          (T"list" "list" [beta] -->
           T"list" "list"
            [T"prod" "pair"
              [T"prod" "pair"
                [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
               T"prod" "pair" [gamma, T"list" "list" [beta]]]])))))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((U"'state" --> bool) --> bool)), V"ns" (U"'state"),
   C"!" "bool" (((U"'ssym" --> bool) --> bool)), V"ssym" (U"'ssym"),
   V"fs" (U"'state"),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'isym"],
          T"prod" "pair" [U"'ssym", U"'state"]],
        T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]] -->
       bool))),
   C"fst1" "laeslafs"
    ((U"'state" -->
      (U"'ssym" -->
       (U"'state" -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]])))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [U"'isym"],
        T"prod" "pair" [U"'ssym", U"'state"]] -->
      (T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]))),
   C"," "pair"
    ((T"option" "option" [U"'isym"] -->
      (T"prod" "pair" [U"'ssym", U"'state"] -->
       T"prod" "pair"
        [T"option" "option" [U"'isym"],
         T"prod" "pair" [U"'ssym", U"'state"]]))),
   C"NONE" "option" (T"option" "option" [U"'isym"]),
   C"," "pair"
    ((U"'ssym" --> (U"'state" --> T"prod" "pair" [U"'ssym", U"'state"]))),
   C"," "pair"
    ((U"'state" -->
      (T"list" "list" [U"'ssym"] -->
       T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]))),
   C"NIL" "list" (T"list" "list" [U"'ssym"]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool" (((gamma --> bool) --> bool)), V"ns" (gamma),
   C"!" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"fsl" (T"list" "list" [gamma]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   C"finalStateTrans" "laeslafs"
    ((gamma -->
      (T"list" "list" [gamma] -->
       (T"list" "list" [beta] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
            T"prod" "pair" [gamma, T"list" "list" [beta]]]])))),
   C"NIL" "list" (T"list" "list" [beta]),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]]),
   C"!" "bool" (((beta --> bool) --> bool)), V"s" (beta),
   C"!" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"rst" (T"list" "list" [beta]),
   C"CONS" "list"
    ((beta --> (T"list" "list" [beta] --> T"list" "list" [beta]))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]]))),
   C"MAP" "list"
    (((gamma -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]) -->
      (T"list" "list" [gamma] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]]))),
   C"fst1" "laeslafs"
    ((gamma -->
      (beta -->
       (gamma -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]])))),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       bool))),
   C"newStateTrans" "laeslafs"
    ((U"'state" -->
      (T"list" "list" [U"'ssym"] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"s" (U"'ssym"),
   C"!" "bool" (((T"list" "list" [U"'ssym"] --> bool) --> bool)),
   V"rst" (T"list" "list" [U"'ssym"]),
   C"CONS" "list"
    ((U"'ssym" -->
      (T"list" "list" [U"'ssym"] --> T"list" "list" [U"'ssym"]))),
   C"CONS" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'isym"],
          T"prod" "pair" [U"'ssym", U"'state"]],
        T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"!" "bool"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool) -->
      bool)), V"p" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   V"q0" (U"'state"), V"x0" (U"'ssym"), V"qe" (U"'state"),
   C"=" "min"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool))),
   C"newm" "laeslafs"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"prod" "pair" [U"'state", T"prod" "pair" [U"'ssym", U"'state"]] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"," "pair"
    ((U"'state" -->
      (T"prod" "pair" [U"'ssym", U"'state"] -->
       T"prod" "pair" [U"'state", T"prod" "pair" [U"'ssym", U"'state"]]))),
   C"LET" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   V"d"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   C"pda_start_fupd" "pdaDef"
    (((U"'state" --> U"'state") -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"K" "combin" ((U"'state" --> (U"'state" --> U"'state"))),
   C"pda_ssSym_fupd" "pdaDef"
    (((U"'ssym" --> U"'ssym") -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"K" "combin" ((U"'ssym" --> (U"'ssym" --> U"'ssym"))),
   C"pda_next_fupd" "pdaDef"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"K" "combin"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"pda_final_fupd" "pdaDef"
    (((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"K" "combin"
    ((T"list" "list" [U"'state"] -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"NIL" "list" (T"list" "list" [U"'state"]),
   C"ARB" "bool" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'state")),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'ssym")),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])),
   C"finalStateTrans" "laeslafs"
    ((U"'state" -->
      (T"list" "list" [U"'state"] -->
       (T"list" "list" [U"'ssym"] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"list" "list" [U"'state"])),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list" [U"'ssym"]))), V"x0" (beta),
   C"!" "bool" (((delta --> bool) --> bool)), V"qf" (delta), V"st" (gamma),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [delta, T"list" "list" [U"'e"]]] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [U"'e"]]] --> bool))),
   C"toFinalStateTrans" "laeslafs"
    ((beta -->
      (delta -->
       (gamma -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [delta, T"list" "list" [U"'e"]]])))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [delta, T"list" "list" [U"'e"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [U"'e"]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]]))),
   C"NONE" "option" (T"option" "option" [alpha]),
   C"," "pair" ((beta --> (gamma --> T"prod" "pair" [beta, gamma]))),
   C"," "pair"
    ((delta -->
      (T"list" "list" [U"'e"] -->
       T"prod" "pair" [delta, T"list" "list" [U"'e"]]))),
   C"NIL" "list" (T"list" "list" [U"'e"]), V"q0'" (U"'state"),
   V"qf" (U"'state"),
   C"newm'" "laeslafs"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"prod" "pair" [U"'state", T"prod" "pair" [U"'ssym", U"'state"]] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"CONS" "list"
    ((U"'state" -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"MAP" "list"
    (((U"'state" -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]) -->
      (T"list" "list" [U"'state"] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"toFinalStateTrans" "laeslafs"
    ((U"'ssym" -->
      (U"'state" -->
       (U"'state" -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]])))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list" [U"'state"]))),
   C"!" "bool"
    (((T"prod" "pair"
        [U"'st",
         T"prod" "pair" [T"list" "list" [U"'i"], T"list" "list" [U"'s"]]]
       --> bool) --> bool)),
   V"x"
    (T"prod" "pair"
      [U"'st",
       T"prod" "pair" [T"list" "list" [U"'i"], T"list" "list" [U"'s"]]]),
   V"y"
    (T"prod" "pair"
      [U"'st",
       T"prod" "pair" [T"list" "list" [U"'i"], T"list" "list" [U"'s"]]]),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [U"'i", U"'s", U"'st"] -->
      (T"prod" "pair"
        [U"'st",
         T"prod" "pair" [T"list" "list" [U"'i"], T"list" "list" [U"'s"]]]
       -->
       (T"prod" "pair"
         [U"'st",
          T"prod" "pair" [T"list" "list" [U"'i"], T"list" "list" [U"'s"]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [U"'i", U"'s", U"'st"]),
   C"~" "bool" ((bool --> bool)),
   C"IN" "bool" ((U"'s" --> ((U"'s" --> bool) --> bool))), V"x0" (U"'s"),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [U"'i", U"'s", U"'st"] --> (U"'s" --> bool))),
   C"IN" "bool" ((U"'st" --> ((U"'st" --> bool) --> bool))),
   V"q0'" (U"'st"),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [U"'i", U"'s", U"'st"] --> (U"'st" --> bool))),
   V"qe" (U"'st"),
   C"newm" "laeslafs"
    ((T"pda" "pdaDef" [U"'i", U"'s", U"'st"] -->
      (T"prod" "pair" [U"'st", T"prod" "pair" [U"'s", U"'st"]] -->
       T"pda" "pdaDef" [U"'i", U"'s", U"'st"]))),
   C"," "pair"
    ((U"'st" -->
      (T"prod" "pair" [U"'s", U"'st"] -->
       T"prod" "pair" [U"'st", T"prod" "pair" [U"'s", U"'st"]]))),
   C"," "pair" ((U"'s" --> (U"'st" --> T"prod" "pair" [U"'s", U"'st"]))),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool) --> bool)),
   V"x"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   V"y"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"RTC" "relation"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [beta, gamma, alpha]),
   C"IN" "bool" ((gamma --> ((gamma --> bool) --> bool))), V"x0" (gamma),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> (gamma --> bool))),
   C"IN" "bool" ((alpha --> ((alpha --> bool) --> bool))), V"q0'" (alpha),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> (alpha --> bool))),
   V"qe" (alpha),
   C"newm" "laeslafs"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]] -->
       T"pda" "pdaDef" [beta, gamma, alpha]))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]]))),
   C"," "pair" ((gamma --> (alpha --> T"prod" "pair" [gamma, alpha]))),
   C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"p1" (T"list" "list" [alpha]), V"p2" (T"list" "list" [alpha]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] --> bool))),
   C"newStateTrans" "laeslafs"
    ((gamma -->
      (T"list" "list" [alpha] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]]))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]]))),
   V"x0" (alpha),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> (alpha --> bool))),
   V"m" (T"pda" "pdaDef" [beta, alpha, gamma]), V"q0'" (gamma),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> (gamma --> bool))),
   V"qe" (gamma), C"\\/" "bool" ((bool --> (bool --> bool))),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   V"h" (alpha),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
       T"list" "list" [alpha]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]])),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [alpha]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [alpha]]]))),
   C"," "pair"
    ((T"option" "option" [beta] -->
      (T"prod" "pair" [alpha, gamma] -->
       T"prod" "pair"
        [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]]))),
   C"NONE" "option" (T"option" "option" [beta]),
   C"," "pair" ((alpha --> (gamma --> T"prod" "pair" [alpha, gamma]))),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [gamma, T"list" "list" [alpha]]))),
   C"NIL" "list" (T"list" "list" [alpha]),
   C"newm" "laeslafs"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"prod" "pair" [gamma, T"prod" "pair" [alpha, gamma]] -->
       T"pda" "pdaDef" [beta, alpha, gamma]))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [alpha, gamma] -->
       T"prod" "pair" [gamma, T"prod" "pair" [alpha, gamma]]))),
   C"!" "bool" (((alpha --> bool) --> bool)), V"e" (alpha),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   V"stk" (T"list" "list" [alpha]),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
        --> bool)))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]] -->
       T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [alpha]]]))),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]))),
   V"inp" (T"list" "list" [beta]),
   C"MEM" "list" ((gamma --> (T"list" "list" [gamma] --> bool))),
   V"q" (gamma),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> T"list" "list" [gamma])),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   C"RTC" "relation"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
        --> bool)) -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
        --> bool)))),
   C"finalStateTrans" "laeslafs"
    ((gamma -->
      (T"list" "list" [gamma] -->
       (T"list" "list" [alpha] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [gamma, T"list" "list" [alpha]]]])))),
   V"t" (T"list" "list" [alpha]), V"sl" (T"list" "list" [alpha]),
   V"x" (T"option" "option" [beta]), V"q'" (gamma),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [alpha, beta, gamma]),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
       T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]))),
   V"s0" (T"list" "list" [alpha]), V"stk" (T"list" "list" [beta]),
   V"s1" (T"list" "list" [alpha]), V"stk'" (T"list" "list" [beta]),
   V"e" (beta),
   C"MEM" "list" ((beta --> (T"list" "list" [beta] --> bool))),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"list" "list" [beta]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   V"s" (alpha),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]))),
   V"st" (T"list" "list" [gamma]), V"s'" (alpha),
   V"inp'" (T"list" "list" [beta]), V"st'" (T"list" "list" [gamma]),
   V"e" (gamma),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] -->
       T"list" "list" [gamma]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [gamma]]]])),
   C"=" "min"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"pda" "pdaDef" [beta, alpha, gamma] --> bool))),
   V"m'" (T"pda" "pdaDef" [beta, alpha, gamma]),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> alpha)),
   V"stl" (T"list" "list" [beta]),
   C"stkSymsList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [gamma], T"prod" "pair" [alpha, beta]],
          T"prod" "pair" [beta, T"list" "list" [alpha]]]] -->
      T"list" "list" [alpha])),
   C"finalStateTrans" "laeslafs"
    ((beta -->
      (T"list" "list" [beta] -->
       (T"list" "list" [alpha] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [gamma], T"prod" "pair" [alpha, beta]],
            T"prod" "pair" [beta, T"list" "list" [alpha]]]])))),
   V"q" (beta),
   C"stkSymsList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
      T"list" "list" [alpha])),
   C"IN" "bool"
    ((T"list" "list" [beta] -->
      ((T"list" "list" [beta] --> bool) --> bool))),
   V"x" (T"list" "list" [beta]),
   C"lafs" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list" [beta] --> bool))),
   C"laes" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list" [beta] --> bool))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> gamma)),
   V"fl" (T"list" "list" [alpha]), V"sl'" (T"list" "list" [beta]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]],
        T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]] -->
      (T"prod" "pair" [alpha, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]],
         T"prod" "pair" [alpha, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [gamma] -->
      (T"prod" "pair" [beta, alpha] -->
       T"prod" "pair"
        [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]]))),
   C"NONE" "option" (T"option" "option" [gamma]),
   C"," "pair" ((beta --> (alpha --> T"prod" "pair" [beta, alpha]))),
   V"h" (beta), V"q" (alpha),
   C"," "pair"
    ((alpha -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [alpha, T"list" "list" [beta]]))), V"q'" (alpha),
   V"sl" (T"list" "list" [beta]),
   C"finalStateTrans" "laeslafs"
    ((alpha -->
      (T"list" "list" [alpha] -->
       (T"list" "list" [beta] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [gamma], T"prod" "pair" [beta, alpha]],
            T"prod" "pair" [alpha, T"list" "list" [beta]]]])))),
   C"=" "min"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   V"sl'" (T"list" "list" [alpha]),
   C"=" "min" ((gamma --> (gamma --> bool))),
   V"fsl" (T"list" "list" [alpha]),
   C"SOME" "option" ((gamma --> T"option" "option" [gamma])), V"h" (gamma),
   V"h'" (beta),
   C"!" "bool"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]] --> bool) -->
      bool)),
   V"e"
    (T"prod" "pair"
      [T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
       T"prod" "pair" [gamma, T"list" "list" [beta]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   V"ssym" (beta), C"?" "bool" (((gamma --> bool) --> bool)),
   V"fs" (gamma),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]))),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [gamma, T"list" "list" [beta]]))), V"fsl" (alpha),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [gamma], T"prod" "pair" [beta, delta]],
        T"prod" "pair" [delta, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [beta, delta]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [gamma], T"prod" "pair" [beta, delta]] -->
      (T"prod" "pair" [delta, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [beta, delta]],
         T"prod" "pair" [delta, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [gamma] -->
      (T"prod" "pair" [beta, delta] -->
       T"prod" "pair"
        [T"option" "option" [gamma], T"prod" "pair" [beta, delta]]))),
   C"," "pair" ((beta --> (delta --> T"prod" "pair" [beta, delta]))),
   V"q" (delta),
   C"," "pair"
    ((delta -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [delta, T"list" "list" [beta]]))), V"q'" (delta),
   C"newStateTrans" "laeslafs"
    ((delta -->
      (T"list" "list" [beta] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [beta, delta]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]]))),
   V"qe" (delta), C"SOME" "option" ((beta --> T"option" "option" [beta])),
   V"h'" (alpha),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   V"stk" (T"list" "list" [gamma]), V"stk'" (T"list" "list" [gamma]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))), V"dl" (alpha), V"qe" (beta),
   V"inp" (T"list" "list" [gamma]),
   C"!" "bool" (((T"list" "list" [delta] --> bool) --> bool)),
   V"stk" (T"list" "list" [delta]), V"inp'" (T"list" "list" [gamma]),
   V"stk'" (T"list" "list" [delta]),
   C"IN" "bool" ((delta --> ((delta --> bool) --> bool))), V"x0" (delta),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [gamma, delta, beta] --> (delta --> bool))),
   V"m" (T"pda" "pdaDef" [gamma, delta, beta]),
   C"IN" "bool" ((beta --> ((beta --> bool) --> bool))), V"q0'" (beta),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [gamma, delta, beta] --> (beta --> bool))),
   C"=" "min" ((beta --> (beta --> bool))), V"qf" (beta),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [gamma, delta, beta] --> T"list" "list" [beta])),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [gamma, delta, beta] -->
      (T"prod" "pair"
        [beta,
         T"prod" "pair" [T"list" "list" [gamma], T"list" "list" [delta]]]
       -->
       (T"prod" "pair"
         [beta,
          T"prod" "pair" [T"list" "list" [gamma], T"list" "list" [delta]]]
        --> bool)))),
   C"newm" "laeslafs"
    ((T"pda" "pdaDef" [gamma, delta, beta] -->
      (T"prod" "pair" [beta, T"prod" "pair" [delta, beta]] -->
       T"pda" "pdaDef" [gamma, delta, beta]))),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [delta, beta] -->
       T"prod" "pair" [beta, T"prod" "pair" [delta, beta]]))),
   C"," "pair" ((delta --> (beta --> T"prod" "pair" [delta, beta]))),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [T"list" "list" [gamma], T"list" "list" [delta]] -->
       T"prod" "pair"
        [beta,
         T"prod" "pair"
          [T"list" "list" [gamma], T"list" "list" [delta]]]))),
   C"," "pair"
    ((T"list" "list" [gamma] -->
      (T"list" "list" [delta] -->
       T"prod" "pair" [T"list" "list" [gamma], T"list" "list" [delta]]))),
   C"=" "min"
    ((T"list" "list" [gamma] --> (T"list" "list" [gamma] --> bool))),
   V"q'" (beta), V"st" (alpha), V"q''" (T"list" "list" [beta]),
   V"r'" (T"list" "list" [alpha]),
   C"TL" "list" ((T"list" "list" [alpha] --> T"list" "list" [alpha])),
   C"?" "bool" (((alpha --> bool) --> bool)), V"qf" (alpha),
   C"?" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"sk" (T"list" "list" [gamma]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> T"list" "list" [alpha])),
   V"inp'" (delta),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"?" "bool" (((U"'e" --> bool) --> bool)), V"i" (U"'e"),
   C"=" "min"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool))),
   C"?" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"p"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   V"s"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"list" "list" [gamma]]]]))),
   C"CONS" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"list" "list" [gamma]]]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"?" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"i" (T"list" "list" [beta]), V"sk" (T"list" "list" [alpha]),
   V"sk'" (T"list" "list" [alpha]),
   C"?" "bool"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
       --> bool) --> bool)),
   V"y"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]),
   V"st'" (gamma),
   C"?" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"s" (T"list" "list" [alpha]),
   C"=" "min"
    ((T"prod" "pair"
       [gamma,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [alpha]]]
       --> bool))), V"sk''" (T"list" "list" [alpha]), V"state" (alpha),
   C"NIL" "list" (T"list" "list" [gamma]), V"state" (gamma),
   V"i'" (T"list" "list" [beta]), V"s'" (T"list" "list" [alpha]),
   V"s" (T"list" "list" [beta]), V"s'" (T"list" "list" [beta]),
   V"stk'" (T"list" "list" [alpha]),
   C"INFINITE" "pred_set" (((U"'ssym" --> bool) --> bool)),
   V"SYMUNIV" ((U"'ssym" --> bool)),
   C"INFINITE" "pred_set" (((U"'state" --> bool) --> bool)),
   V"STUNIV" ((U"'state" --> bool)),
   V"m" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"?" "bool"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool) -->
      bool)), V"m'" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"=" "min"
    (((T"list" "list" [U"'isym"] --> bool) -->
      ((T"list" "list" [U"'isym"] --> bool) --> bool))),
   C"lafs" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list" [U"'isym"] --> bool))),
   C"laes" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list" [U"'isym"] --> bool))), V"qf" (U"'st"),
   C"newm'" "laeslafs"
    ((T"pda" "pdaDef" [U"'i", U"'s", U"'st"] -->
      (T"prod" "pair" [U"'st", T"prod" "pair" [U"'s", U"'st"]] -->
       T"pda" "pdaDef" [U"'i", U"'s", U"'st"]))),
   C"newm'" "laeslafs"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]] -->
       T"pda" "pdaDef" [beta, gamma, alpha]))), V"qf" (gamma),
   C"newm'" "laeslafs"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"prod" "pair" [gamma, T"prod" "pair" [alpha, gamma]] -->
       T"pda" "pdaDef" [beta, alpha, gamma]))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
       T"list" "list" [gamma]))), V"sl'" (beta),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
        T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
           T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]] -->
      (T"prod" "pair" [U"'f", T"list" "list" [U"'g"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
         T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]]))),
   C"," "pair"
    ((T"option" "option" [gamma] -->
      (T"prod" "pair" [delta, U"'e"] -->
       T"prod" "pair"
        [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]]))),
   C"," "pair" ((delta --> (U"'e" --> T"prod" "pair" [delta, U"'e"]))),
   V"h'" (delta), V"q" (U"'e"),
   C"," "pair"
    ((U"'f" -->
      (T"list" "list" [U"'g"] -->
       T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]))), V"q'" (U"'f"),
   V"sl" (T"list" "list" [U"'g"]),
   C"MAP" "list"
    (((U"'e" -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
         T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]]) -->
      (T"list" "list" [U"'e"] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
           T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]]]))),
   C"toFinalStateTrans" "laeslafs"
    ((delta -->
      (U"'f" -->
       (U"'e" -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [gamma], T"prod" "pair" [delta, U"'e"]],
          T"prod" "pair" [U"'f", T"list" "list" [U"'g"]]])))),
   V"qf" (U"'f"), V"stl" (T"list" "list" [U"'e"]),
   C"=" "min" ((U"'f" --> (U"'f" --> bool))),
   C"=" "min"
    ((T"list" "list" [U"'g"] --> (T"list" "list" [U"'g"] --> bool))),
   C"NIL" "list" (T"list" "list" [U"'g"]),
   C"=" "min" ((delta --> (delta --> bool))),
   V"s" (T"list" "list" [gamma]), V"s'" (T"list" "list" [gamma]),
   V"sfx" (T"list" "list" [gamma]),
   C"APPEND" "list"
    ((T"list" "list" [gamma] -->
      (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"CONS" "list"
    ((gamma --> (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   V"fl" (alpha),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
        T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
           T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [gamma], T"prod" "pair" [delta, beta]] -->
      (T"prod" "pair" [U"'e", T"list" "list" [U"'f"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
         T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]]))),
   C"," "pair"
    ((T"option" "option" [gamma] -->
      (T"prod" "pair" [delta, beta] -->
       T"prod" "pair"
        [T"option" "option" [gamma], T"prod" "pair" [delta, beta]]))),
   V"h" (delta),
   C"," "pair"
    ((U"'e" -->
      (T"list" "list" [U"'f"] -->
       T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]))), V"q'" (U"'e"),
   V"sl" (T"list" "list" [U"'f"]),
   C"MAP" "list"
    (((beta -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
         T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]]) -->
      (T"list" "list" [beta] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
           T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]]]))),
   C"toFinalStateTrans" "laeslafs"
    ((delta -->
      (U"'e" -->
       (beta -->
        T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [gamma], T"prod" "pair" [delta, beta]],
          T"prod" "pair" [U"'e", T"list" "list" [U"'f"]]])))),
   V"qf" (U"'e"), V"i" (T"list" "list" [alpha]),
   V"i'" (T"list" "list" [alpha]),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (beta --> bool))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (gamma --> bool))),
   C"newm'" "laeslafs"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair" [gamma, T"prod" "pair" [beta, gamma]] -->
       T"pda" "pdaDef" [alpha, beta, gamma]))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair" [gamma, T"prod" "pair" [beta, gamma]]))),
   V"p'" (T"list" "list" [alpha])]
  val DT = Thm.disk_thm share_table
  in
  val fst1_def =
    DT([], [],
       `(%0 (\%1. (%2 (\%3. (%0 (\%4. ((%5 (((%6 $2) $1) $0)) ((%7 ((%8 %9)
       ((%10 $1) $0))) ((%11 $2) %12)))))))))`)
  val finalStateTrans_def =
    DT(["DISK_THM"], [],
       `((%13 (%14 (\%15. (%16 (\%17. ((%18 (((%19 $1) $0) %20)) %21))))))
       (%14 (\%15. (%16 (\%17. (%22 (\%23. (%24 (\%25. ((%18 (((%19 $3) $2)
       ((%26 $1) $0))) ((%27 ((%28 ((%29 $3) $1)) $2)) (((%19 $3) $2)
       $0))))))))))))`)
  val newStateTrans_def =
    DT(["DISK_THM"], [],
       `((%13 (%0 (\%1. ((%30 ((%31 $0) %12)) %32)))) (%0 (\%1. (%2 (\%33.
       (%34 (\%35. ((%30 ((%31 $2) ((%36 $1) $0))) ((%37 ((%7 ((%8 %9)
       ((%10 $1) $2))) ((%11 $2) %12))) ((%31 $2) $0))))))))))`)
  val newm_def =
    DT(["DISK_THM"], [],
       `(%38 (\%39. (%0 (\%40. (%2 (\%41. (%0 (\%42. ((%43 ((%44 $3) ((%45
       $2) ((%10 $1) $0)))) ((%46 (\%47. ((%48 (%49 $3)) ((%50 (%51 $2))
       ((%52 (%53 $0)) ((%54 (%55 %56)) %57)))))) ((%58 ((%58 ((%58 ((%37
       ((%7 ((%8 %9) ((%10 $1) $2))) ((%11 (%59 $3)) ((%36 (%60 $3)) ((%36
       $1) %12))))) %32)) (%61 $3))) (((%62 $0) (%63 $3)) ((%36 $1) ((%64
       $3) (%61 $3)))))) ((%31 $0) ((%36 $1) ((%64 $3) (%61
       $3)))))))))))))))`)
  val toFinalStateTrans_def =
    DT([], [],
       `(%22 (\%65. (%66 (\%67. (%14 (\%68. ((%69 (((%70 $2) $1) $0)) ((%71
       ((%72 %73) ((%74 $2) $0))) ((%75 $1) %76)))))))))`)
  val newm'_def =
    DT(["DISK_THM"], [],
       `(%38 (\%39. (%0 (\%77. (%2 (\%41. (%0 (\%78. ((%43 ((%79 $3) ((%45
       $2) ((%10 $1) $0)))) ((%46 (\%47. ((%48 (%49 $3)) ((%50 (%51 $2))
       ((%52 (%53 $0)) ((%54 (%55 ((%80 $1) %56))) %57)))))) ((%58 ((%58
       ((%37 ((%7 ((%8 %9) ((%10 $1) $2))) ((%11 (%59 $3)) ((%36 (%60 $3))
       ((%36 $1) %12))))) %32)) (%61 $3))) ((%81 ((%82 $1) $0)) ((%83 $3)
       (%61 $3))))))))))))))`)
  val idLafsImpLaes =
    DT(["DISK_THM"], [],
       `(%84 (\%85. (%84 (\%86. ((%87 ((%13 (((%88 %89) $1) $0)) ((%13 (%90
       ((%91 %92) (%93 %89)))) ((%13 (%90 ((%94 %95) (%96 %89)))) (%90
       ((%94 %97) (%96 %89))))))) (((%88 ((%98 %89) ((%99 %95) ((%100 %92)
       %97)))) $1) $0))))))`)
  val idcLafsImpLaes =
    DT(["DISK_THM"], [],
       `(%101 (\%102. (%101 (\%103. ((%87 (((%104 (%105 %106)) $1) $0))
       ((%87 ((%13 (%90 ((%107 %108) (%109 %106)))) ((%13 (%90 ((%110 %111)
       (%112 %106)))) (%90 ((%110 %113) (%112 %106)))))) (((%104 (%105
       ((%114 %106) ((%115 %111) ((%116 %108) %113))))) $1) $0)))))))`)
  val nstApp =
    DT(["DISK_THM"], [],
       `(%117 (\%118. (%117 (\%119. ((%120 ((%121 %15) ((%122 $1) $0)))
       ((%123 ((%121 %15) $1)) ((%121 %15) $0)))))))`)
  val newmQeRule =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%130
       ((%131 %132) ((%133 %126) (%134 %126)))) ((%135 %132) %124))))))
       ((%136 ((%137 ((%138 %139) ((%140 %132) %129))) ((%141 %129) %142)))
       (%134 ((%143 %126) ((%144 %127) ((%140 %124) %129))))))`)
  val idNewmQe =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) (%145
       (\%146. ((%87 ((%131 $0) ((%147 %132) %148))) ((%130 ((%131 $0)
       ((%133 %126) (%134 %126)))) ((%135 $0) %124))))))))) (((%149 ((%143
       %126) ((%144 %127) ((%140 %124) %129)))) ((%150 %129) ((%151 %152)
       ((%147 %132) %148)))) ((%150 %129) ((%151 %152) %148))))`)
  val idcNewmPopStkQe =
    DT(["DISK_THM"], [],
       `(%117 (\%148. ((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13
       (%90 ((%107 %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128
       %126)))) ((%13 ((%153 %154) (%155 %126))) ((%13 (%90 ((%156 $0)
       %142))) (%145 (\%146. ((%87 ((%131 $0) $1)) ((%130 ((%131 $0) ((%133
       %126) (%134 %126)))) ((%135 $0) %124))))))))))) (((%157 (%149 ((%143
       %126) ((%144 %127) ((%140 %124) %129))))) ((%150 %129) ((%151 %152)
       $0))) ((%150 %129) ((%151 %152) %142))))))`)
  val fstApp =
    DT(["DISK_THM"], [],
       `(%117 (\%118. (%117 (\%119. ((%120 (((%158 %15) %17) ((%122 $1)
       $0))) ((%123 (((%158 %15) %17) $1)) (((%158 %15) %17) $0)))))))`)
  val newmFstRule =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       ((%153 %154) (%155 %126))) ((%130 ((%131 %132) ((%133 %126) (%134
       %126)))) ((%135 %132) %124))))))) (((%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129)))) ((%150 %154) ((%151 %152) ((%147 %132)
       %159)))) ((%150 %129) ((%151 %152) %159))))`)
  val idcNewmPopStk =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       ((%153 %154) (%155 %126))) ((%13 (%90 ((%156 %148) %142))) (%145
       (\%146. ((%87 ((%131 $0) %148)) ((%130 ((%131 $0) ((%133 %126) (%134
       %126)))) ((%135 $0) %124))))))))))) (((%157 (%149 ((%143 %126)
       ((%144 %127) ((%140 %124) %129))))) ((%150 %154) ((%151 %152)
       %148))) ((%150 %129) ((%151 %152) %142))))`)
  val ruleMemStkSyms =
    DT(["DISK_THM"], [],
       `(%117 (\%160. ((%87 ((%136 ((%137 ((%138 %161) ((%140 %132) %154)))
       ((%141 %162) $0))) (%134 %126))) ((%13 ((%131 %132) ((%133 %126)
       (%134 %126)))) (%145 (\%146. ((%87 ((%131 $0) $1)) ((%131 $0) ((%133
       %126) (%134 %126))))))))))`)
  val idMemStkSyms =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (((%163 %164) ((%165 %154) ((%166 %167) %168))) ((%165
       %162) ((%166 %169) %170)))) (%22 (\%171. ((%87 ((%172 $0) %168))
       ((%172 $0) ((%173 %164) (%174 %164)))))))) (%22 (\%171. ((%87 ((%172
       $0) %170)) ((%172 $0) ((%173 %164) (%174 %164)))))))`)
  val idcMemStkSyms =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (((%104 (%105 %106)) ((%175 %176) ((%177 %152) %178)))
       ((%175 %179) ((%177 %180) %181)))) (%14 (\%182. ((%87 ((%153 $0)
       %178)) ((%153 $0) ((%183 %106) (%184 %106)))))))) (%14 (\%182. ((%87
       ((%153 $0) %181)) ((%153 $0) ((%183 %106) (%184 %106)))))))`)
  val memNewmStkSyms =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%185
       %186) ((%143 %126) ((%144 %127) ((%140 %124) %129)))))))) ((%13
       ((%131 %124) ((%133 %186) (%134 %186)))) ((%131 (%187 %126)) ((%133
       %186) (%134 %186)))))`)
  val stkSymsFst =
    DT(["DISK_THM"], [],
       `(%117 (\%160. (%24 (\%188. (%145 (\%146. ((%87 ((%131 $0) (%189
       (((%190 %191) $1) $2)))) ((%131 $0) $2))))))))`)
  val stkSymsNst =
    DT(["DISK_THM"], [],
       `(%117 (\%160. (%145 (\%146. ((%87 ((%131 $0) (%192 ((%121 %154)
       $1)))) ((%131 $0) $1))))))`)
  val memOldmStkSyms =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%185
       %186) ((%143 %126) ((%144 %127) ((%140 %124) %129)))))))) (%145
       (\%146. ((%87 ((%131 $0) ((%133 %186) (%134 %186)))) ((%130 ((%135
       $0) %124)) ((%131 $0) ((%133 %126) (%134 %126))))))))`)
  val lafsImpLaes =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) ((%87 ((%193
       %194) (%195 %126))) ((%193 %194) (%196 ((%143 %126) ((%144 %127)
       ((%140 %124) %129)))))))`)
  val newmStartRule =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) ((%136
       ((%137 ((%138 %139) ((%140 %124) %127))) ((%141 (%197 %126)) ((%147
       (%187 %126)) ((%147 %124) %142))))) (%134 ((%143 %126) ((%144 %127)
       ((%140 %124) %129))))))`)
  val memFslFst =
    DT(["DISK_THM"], [],
       `(%117 (\%198. (%24 (\%199. ((%87 ((%200 ((%201 ((%202 %203) ((%204
       %205) %206))) ((%207 %208) %209))) (((%210 %113) $1) $0))) ((%131
       %206) $1))))))`)
  val slFslNil =
    DT(["DISK_THM"], [],
       `(%117 (\%198. (%24 (\%199. ((%87 ((%200 ((%201 ((%202 %203) ((%204
       %205) %206))) ((%207 %208) %209))) (((%210 %113) $1) $0))) ((%211
       %209) %20))))))`)
  val stEqNst =
    DT(["DISK_THM"], [],
       `(%117 (\%212. ((%87 ((%136 ((%137 ((%138 %139) ((%140 %132) %154)))
       ((%141 %162) %160))) ((%121 %129) $0))) ((%213 %154) %129))))`)
  val slNstNil =
    DT(["DISK_THM"], [],
       `(%117 (\%212. ((%87 ((%136 ((%137 ((%138 %139) ((%140 %132) %154)))
       ((%141 %162) %160))) ((%121 %129) $0))) ((%156 %160) %142))))`)
  val toStEqNst =
    DT(["DISK_THM"], [],
       `(%117 (\%212. ((%87 ((%136 ((%137 ((%138 %139) ((%140 %132) %154)))
       ((%141 %162) %160))) ((%121 %129) $0))) ((%213 %162) %129))))`)
  val transStIsFs =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       ((%136 ((%137 ((%138 %139) ((%140 %132) %154))) ((%141 %129) %160)))
       (%134 ((%143 %126) ((%144 %127) ((%140 %124) %129)))))) (%90 ((%213
       %154) %129))))))) ((%13 ((%153 %154) (%155 %126))) ((%156 %160)
       %142)))`)
  val notSomeInpMemFst =
    DT(["DISK_THM"], [],
       `(%117 (\%214. (%24 (\%199. (%90 ((%200 ((%201 ((%202 (%215 %216))
       ((%204 %217) %206))) ((%207 %208) %209))) (((%210 %113) $1)
       $0)))))))`)
  val memFst1 =
    DT(["DISK_THM"], [],
       `(%218 (\%219. (%16 (\%17. ((%87 ((%220 $1) ((%28 ((%29 %15) %221))
       $0))) (%222 (\%223. ((%13 ((%224 $2) ((%225 ((%72 %73) ((%74 %221)
       $0))) ((%226 %15) %20)))) ((%153 $0) $1)))))))))`)
  val toStEqNFst =
    DT(["DISK_THM"], [],
       `(%117 (\%214. (%24 (\%199. ((%87 ((%200 ((%201 ((%202 %203) ((%204
       %205) %206))) ((%207 %208) %209))) (((%210 %113) $1) $0))) ((%135
       %208) %113))))))`)
  val notSomeInpMemNst =
    DT(["DISK_THM"], [],
       `(%145 (\%227. (%24 (\%199. (%90 ((%228 ((%229 ((%230 (%215 %216))
       ((%231 %217) %232))) ((%233 %234) %209))) ((%235 %236) $0)))))))`)
  val notSomeMemNewm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) (%90 ((%136
       ((%137 ((%138 (%237 %205)) ((%140 %238) %154))) ((%141 %129) %160)))
       (%134 ((%143 %126) ((%144 %127) ((%140 %124) %129)))))))`)
  val memToQeNewm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) ((%136 ((%137 ((%138 %139) ((%140 %132)
       %129))) ((%141 %154) %160))) (%134 ((%143 %126) ((%144 %127) ((%140
       %124) %129)))))))))) ((%13 ((%213 %154) %129)) ((%156 %160)
       %142)))`)
  val notSomeMemQeNewm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) (%90 ((%136
       ((%137 ((%138 (%237 %205)) ((%140 %238) %129))) ((%141 %154) %160)))
       (%134 ((%143 %126) ((%144 %127) ((%140 %124) %129)))))))`)
  val listQeTransInpSame =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%145 (\%113. (%24 (\%152. (%16 (\%241. (%24 (\%180.
       (%16 (\%242. ((%87 ((%13 (%90 ((%107 %108) (%109 %106)))) ((%13 (%90
       ((%110 %111) (%112 %106)))) ((%13 (%90 ((%110 $4) (%112 %106))))
       ((%13 (%90 ((%135 %111) $4))) ((((%243 (%105 ((%114 %106) ((%115
       %111) ((%116 %108) $4))))) $5) ((%175 $4) ((%177 $3) $2))) ((%175
       $4) ((%177 $1) $0)))))))) ((%211 $3) $1))))))))))))))`)
  val idFsToQeInpSame =
    DT(["DISK_THM"], [],
       `(%145 (\%244. (%22 (\%245. (%16 (\%246. (%247 (\%248. (%16 (\%249.
       (%247 (\%250. ((%87 ((%13 (%90 ((%251 %252) (%253 %254)))) ((%13
       (%90 ((%255 %256) (%257 %254)))) ((%13 (%90 ((%255 $4) (%257
       %254)))) ((%13 (%90 ((%258 %256) $4))) ((%13 ((%172 %259) (%260
       %254))) (((%261 ((%262 %254) ((%263 %256) ((%264 %252) $4)))) ((%265
       %259) ((%266 $3) $2))) ((%265 $4) ((%266 $1) $0))))))))) ((%267 $3)
       $1))))))))))))))`)
  val idFromQeInpSame =
    DT(["DISK_THM"], [],
       `(%145 (\%244. (%22 (\%245. (%16 (\%246. (%247 (\%248. (%16 (\%249.
       (%247 (\%250. ((%87 ((%13 (%90 ((%251 %252) (%253 %254)))) ((%13
       (%90 ((%255 %256) (%257 %254)))) ((%13 (%90 ((%255 $4) (%257
       %254)))) ((%13 (%90 ((%258 %256) $4))) (((%261 ((%262 %254) ((%263
       %256) ((%264 %252) $4)))) ((%265 $4) ((%266 $3) $2))) ((%265 %268)
       ((%266 $1) $0)))))))) ((%13 ((%267 $3) $1)) ((%258 %268)
       $4)))))))))))))))`)
  val listQeTrans =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%145 (\%113. (%24 (\%152. (%16 (\%241. (%145 (\%269.
       (%24 (\%180. (%16 (\%242. ((%87 ((%13 (%90 ((%107 %108) (%109
       %106)))) ((%13 (%90 ((%110 %111) (%112 %106)))) ((%13 (%90 ((%110
       $5) (%112 %106)))) ((%13 (%90 ((%135 %111) $5))) ((((%243 (%105
       ((%114 %106) ((%115 %111) ((%116 %108) $5))))) $6) ((%175 $5) ((%177
       $4) $3))) ((%175 $2) ((%177 $1) $0)))))))) ((%135 $2)
       $5))))))))))))))))`)
  val idQeTrans =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) (((%149 ((%143 %126) ((%144 %127) ((%140
       %124) %129)))) ((%150 %154) ((%151 %152) %148))) ((%150 %129) ((%151
       %270) %271)))))))) ((%13 ((%211 %270) %152)) ((%156 %271) (%272
       %148))))`)
  val listFsExists =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%145 (\%206. (%24 (\%152. (%16 (\%241. (%145 (\%113.
       (%24 (\%180. (%16 (\%242. ((%87 ((%13 (%90 ((%107 %108) (%109
       %106)))) ((%13 (%90 ((%110 %111) (%112 %106)))) ((%13 (%90 ((%110
       $2) (%112 %106)))) ((%13 (%90 ((%135 %111) $2))) ((%13 ((((%243
       (%105 ((%114 %106) ((%115 %111) ((%116 %108) $2))))) $6) ((%175 $5)
       ((%177 $4) $3))) ((%175 $2) ((%177 $1) $0)))) (%90 ((%135 $5)
       $2)))))))) (%273 (\%274. (%275 (\%276. ((%13 ((%277 ((%175 $1)
       ((%177 $3) $0))) $8)) ((%131 $1) (%278 %106))))))))))))))))))))))`)
  val listQeOnly =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%24 (\%152. (%16 (\%241. (%145 (\%113. (%145 (\%208.
       (%66 (\%279. (%16 (\%242. ((%87 ((%13 (%90 ((%107 %108) (%109
       %106)))) ((%13 (%90 ((%110 %111) (%112 %106)))) ((%13 (%90 ((%110
       $3) (%112 %106)))) ((%13 (%90 ((%135 %111) $3))) ((((%243 (%105
       ((%114 %106) ((%115 %111) ((%116 %108) $3))))) $6) ((%175 $3) ((%177
       $5) $4))) ((%175 $2) ((%177 $5) $0)))))))) (%101 (\%280. ((%87
       ((%277 $0) $7)) (%281 (\%282. (%275 (\%276. ((%283 $2) ((%175 $6)
       ((%177 $8) $0)))))))))))))))))))))))))`)
  val listFsExists' =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%145 (\%206. (%24 (\%152. (%16 (\%241. (%145 (\%113.
       (%24 (\%180. (%16 (\%242. ((%87 ((%13 (%90 ((%107 %108) (%109
       %106)))) ((%13 (%90 ((%110 %111) (%112 %106)))) ((%13 (%90 ((%110
       $2) (%112 %106)))) ((%13 (%90 ((%135 %111) $2))) ((%13 ((((%243
       (%105 ((%114 %106) ((%115 %111) ((%116 %108) $2))))) $6) ((%175 $5)
       ((%177 $4) $3))) ((%175 $2) ((%177 $1) $0)))) (%90 ((%135 $5)
       $2)))))))) (%284 (\%285. (%284 (\%286. (%273 (\%274. (%275 (\%276.
       ((%13 ((%287 $10) ((%288 ((%288 $3) ((%289 ((%175 $1) ((%177 $5)
       $0))) %290))) $2))) ((%13 ((%131 $1) (%278 %106))) (%101 (\%280.
       ((%87 ((%277 $0) $3)) (%291 (\%292. (%275 (\%276. ((%283 $2) ((%175
       $9) ((%177 $1) $0)))))))))))))))))))))))))))))))))))`)
  val idcNewmFinalToQe =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) (((%157 (%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129))))) ((%150 %68) ((%151 %152) %293))) ((%150 %129)
       ((%151 %180) %294)))))))) ((%130 ((%213 %68) %129)) (%295 (\%296.
       (%222 (\%297. (%291 (\%292. (%298 (\%299. ((%13 (((%157 (%149 ((%143
       %126) ((%144 %127) ((%140 %124) %129))))) ((%150 %68) ((%151 %152)
       %293))) $3)) ((%13 (((%157 (%149 ((%143 %126) ((%144 %127) ((%140
       %124) %129))))) $3) ((%150 %129) ((%151 %180) %294)))) ((%13 ((%300
       $3) ((%150 $2) ((%151 $1) $0)))) ((%153 $2) (%155
       %126)))))))))))))))`)
  val idcNewmFinalToQe' =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) (((%157 (%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129))))) ((%150 %68) ((%151 %152) %293))) ((%150 %129)
       ((%151 %180) %294)))))))) ((%130 ((%213 %68) %129)) (%295 (\%296.
       (%222 (\%297. (%291 (\%292. (%298 (\%299. (%298 (\%301. ((%13
       (((%157 (%149 ((%143 %126) ((%144 %127) ((%140 %124) %129)))))
       ((%150 %68) ((%151 %152) %293))) $4)) ((%13 (((%149 ((%143 %126)
       ((%144 %127) ((%140 %124) %129)))) $4) ((%150 %129) ((%151 %180)
       $0)))) ((%13 (((%157 (%149 ((%143 %126) ((%144 %127) ((%140 %124)
       %129))))) ((%150 %129) ((%151 %180) $0))) ((%150 %129) ((%151 %180)
       %294)))) ((%13 ((%300 $4) ((%150 $3) ((%151 $2) $1)))) ((%153 $3)
       (%155 %126))))))))))))))))))`)
  val x0TransStIsQe =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) ((%13 (((%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129)))) ((%150 %154) ((%151 %152) %148))) ((%150 %162)
       ((%151 %270) %271)))) ((%13 ((%131 %124) %148)) (%90 ((%131 %124)
       %271))))))))) ((%213 %162) %129))`)
  val newmNullStkStQeLd =
    DT(["DISK_THM"], [],
       `(%239 (\%240. (%145 (\%206. (%24 (\%152. (%16 (\%241. ((%87 ((%13
       (%90 ((%107 %108) (%109 %106)))) ((%13 (%90 ((%110 %111) (%112
       %106)))) ((%13 (%90 ((%110 %113) (%112 %106)))) ((%13 (%90 ((%135
       %111) %113))) ((%13 ((((%243 (%105 ((%114 %106) ((%115 %111) ((%116
       %108) %113))))) $3) ((%175 $2) ((%177 $1) $0))) ((%175 %302) ((%177
       %20) %303)))) ((%153 %108) $0))))))) ((%135 %302) %113))))))))))`)
  val newmNullStkStQe =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) (((%157 (%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129))))) ((%150 %154) ((%151 %152) ((%122 %148) ((%147
       %124) %142))))) ((%150 %304) ((%151 %20) %142)))))))) ((%213 %304)
       %129))`)
  val idNewmImpOldm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (((%149 ((%143 %126) ((%144 %127) ((%140 %124) %129)))) ((%150 %154)
       ((%151 %292) %299))) ((%150 %162) ((%151 %305) %306)))) ((%107 %162)
       (%128 %126))))))) ((%130 ((%213 %154) %127)) ((%13 ((%107 %154)
       (%128 %126))) (((%149 %126) ((%150 %154) ((%151 %292) %299))) ((%150
       %162) ((%151 %305) %306))))))`)
  val idStatesMem =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) ((%13 (((%149 ((%143 %126) ((%144 %127)
       ((%140 %124) %129)))) ((%150 %154) ((%151 %307) %148))) ((%150 %162)
       ((%151 %308) %309)))) ((%107 %154) (%128 %126)))))))) ((%130 ((%213
       %162) %129)) ((%107 %162) (%128 %126))))`)
  val idcNewmImpOldm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) ((%13 (((%157 (%149 ((%143 %126) ((%144
       %127) ((%140 %124) %129))))) ((%150 %154) ((%151 %292) %299)))
       ((%150 %162) ((%151 %305) %306)))) ((%13 ((%107 %162) (%128 %126)))
       ((%107 %154) (%128 %126))))))))) (((%157 (%149 %126)) ((%150 %154)
       ((%151 %292) %299))) ((%150 %162) ((%151 %305) %306))))`)
  val idNewmFstStep =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) (((%149 ((%143 %126) ((%144 %127) ((%140
       %124) %129)))) ((%150 %127) ((%151 %292) ((%147 %124) %142))))
       ((%150 %154) ((%151 %270) %271)))))))) ((%13 ((%213 %154) (%197
       %126))) ((%13 ((%211 %270) %292)) ((%156 %271) ((%147 (%187 %126))
       ((%147 %124) %142))))))`)
  val newmFstStep =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) ((%13
       (%90 ((%213 %127) %129))) ((%13 (((%157 (%149 ((%143 %126) ((%144
       %127) ((%140 %124) %129))))) ((%150 %127) ((%151 %292) ((%147 %124)
       %142)))) ((%150 %162) ((%151 %305) %306)))) (%90 ((%213 %127)
       %162)))))))) ((%13 (((%149 ((%143 %126) ((%144 %127) ((%140 %124)
       %129)))) ((%150 %127) ((%151 %292) ((%147 %124) %142)))) ((%150
       (%197 %126)) ((%151 %292) ((%147 (%187 %126)) ((%147 %124)
       %142)))))) (((%157 (%149 ((%143 %126) ((%144 %127) ((%140 %124)
       %129))))) ((%150 (%197 %126)) ((%151 %292) ((%147 (%187 %126))
       ((%147 %124) %142))))) ((%150 %162) ((%151 %305) %306)))))`)
  val newmssSym =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) ((%135 (%187
       ((%143 %126) ((%144 %127) ((%140 %124) %129))))) %124))`)
  val newmstart =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %129) (%128 %126)))))) ((%213 (%197
       ((%143 %126) ((%144 %127) ((%140 %124) %129))))) %127))`)
  val laesImpLafs =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %129) (%128 %126)))) (%90
       ((%213 %127) %129)))))) ((%87 ((%193 %194) (%196 ((%143 %126) ((%144
       %127) ((%140 %124) %129)))))) ((%193 %194) (%195 %126))))`)
  val thm51 =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%310 %311)) (%312 %313))) (%38 (\%314. (%315 (\%316.
       ((%317 (%318 $1)) (%319 $0)))))))`)
  val idLaesImpLafs' =
    DT(["DISK_THM"], [],
       `(%84 (\%85. (%84 (\%86. ((%87 ((%13 (((%88 %89) $1) $0)) ((%13 (%90
       ((%91 %92) (%93 %89)))) ((%13 (%90 ((%94 %95) (%96 %89)))) (%90
       ((%94 %320) (%96 %89))))))) (((%88 ((%321 %89) ((%99 %95) ((%100
       %92) %320)))) $1) $0))))))`)
  val idcLaesImpLafs' =
    DT(["DISK_THM"], [],
       `(%101 (\%102. (%101 (\%103. ((%87 (((%104 (%105 %106)) $1) $0))
       ((%87 ((%13 (%90 ((%107 %108) (%109 %106)))) ((%13 (%90 ((%110 %111)
       (%112 %106)))) (%90 ((%110 %274) (%112 %106)))))) (((%104 (%105
       ((%322 %106) ((%115 %111) ((%116 %108) %274))))) $1) $0)))))))`)
  val finalStateRule =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       ((%185 %186) ((%324 %126) ((%144 %127) ((%140 %124) %323))))) ((%153
       %304) ((%325 %126) (%134 %126)))))))) ((%136 ((%137 ((%138 %139)
       ((%140 %124) %304))) ((%141 %323) %142))) (%134 %186)))`)
  val memStartStateNewm' =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%185
       %186) ((%324 %126) ((%144 %127) ((%140 %124) %323)))))))) ((%153
       (%197 %126)) ((%325 %186) (%134 %186))))`)
  val toStEqFs =
    DT(["DISK_THM"], [],
       `(%145 (\%227. (%22 (\%326. ((%87 ((%327 ((%328 ((%329 %203) ((%330
       %331) %332))) ((%333 %334) %335))) ((%336 ((%337 %252) %338))
       %339))) ((%13 ((%340 %334) %338)) ((%13 ((%341 %335) %342)) ((%343
       %331) %252))))))))`)
  val toFsTrans =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       ((%107 %304) (%128 %126))) ((%185 %186) ((%324 %126) ((%144 %127)
       ((%140 %124) %323))))))))) ((%136 ((%137 ((%138 %139) ((%140 %124)
       %304))) ((%141 %323) %142))) (%134 %186)))`)
  val laesImpLafs' =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %323) (%128 %126)))))) ((%87 ((%193
       %194) (%196 %126))) ((%193 %194) (%195 ((%324 %126) ((%144 %127)
       ((%140 %124) %323)))))))`)
  val notSomeInpMemFst' =
    DT(["DISK_THM"], [],
       `(%145 (\%227. (%22 (\%326. (%90 ((%327 ((%328 ((%329 (%215 %216))
       ((%330 %331) %332))) ((%333 %334) %335))) ((%336 ((%337 %252) %338))
       %339)))))))`)
  val toFsStk =
    DT(["DISK_THM"], [],
       `(%145 (\%206. (%24 (\%292. (%16 (\%344. (%24 (\%305. (%16 (\%345.
       ((%87 ((%13 (%90 ((%107 %108) (%109 %106)))) ((%13 (%90 ((%110 %111)
       (%112 %106)))) ((%13 (%90 ((%110 %274) (%112 %106)))) (((%105 ((%322
       %106) ((%115 %111) ((%116 %108) %274)))) ((%175 $4) ((%177 $3) $2)))
       ((%175 %274) ((%177 $1) $0))))))) (%275 (\%346. ((%13 ((%267 $3)
       ((%347 ((%348 %108) %303)) $0))) ((%267 $1) $0)))))))))))))))`)
  val idStatesMem' =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       (%90 ((%213 %127) %323))) ((%13 (((%149 ((%324 %126) ((%144 %127)
       ((%140 %124) %323)))) ((%150 %154) ((%151 %307) %148))) ((%150 %162)
       ((%151 %308) %309)))) ((%107 %154) (%128 %126)))))))) ((%130 ((%213
       %162) %323)) ((%107 %162) (%128 %126))))`)
  val idNewm'ImpOldm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       (((%149 ((%324 %126) ((%144 %127) ((%140 %124) %323)))) ((%150 %154)
       ((%151 %292) %299))) ((%150 %162) ((%151 %305) %306)))) ((%107 %162)
       (%128 %126))))))) ((%130 ((%213 %154) %127)) ((%13 ((%107 %154)
       (%128 %126))) (((%149 %126) ((%150 %154) ((%151 %292) %299))) ((%150
       %162) ((%151 %305) %306))))))`)
  val memFslFst' =
    DT(["DISK_THM"], [],
       `(%145 (\%349. (%24 (\%199. ((%87 ((%350 ((%351 ((%352 %203) ((%264
       %353) %191))) ((%354 %355) %356))) ((%357 ((%358 %252) %359)) $0)))
       ((%172 %191) $0))))))`)
  val idNewm'EndSt =
    DT(["DISK_THM"], [],
       `(%117 (\%360. (%24 (\%307. (%14 (\%162. (%117 (\%361. (%24 (\%308.
       ((%87 ((%13 (%90 ((%255 %65) (%362 %164)))) ((%13 (%90 ((%107 %127)
       (%363 %164)))) ((%13 (%90 ((%107 %323) (%363 %164)))) (%90 ((%213
       %323) %127)))))) (%90 (((%163 ((%364 %164) ((%365 %127) ((%74 %65)
       %323)))) ((%165 %323) ((%166 $4) $3))) ((%165 $2) ((%166 $1)
       $0)))))))))))))))`)
  val idcNewm'ImpOldm =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       (%90 ((%213 %127) %323))) ((%13 (((%157 (%149 ((%324 %126) ((%144
       %127) ((%140 %124) %323))))) ((%150 %154) ((%151 %292) %299)))
       ((%150 %162) ((%151 %305) %306)))) ((%13 ((%107 %162) (%128 %126)))
       ((%107 %154) (%128 %126))))))))) (((%157 (%149 %126)) ((%150 %154)
       ((%151 %292) %299))) ((%150 %162) ((%151 %305) %306))))`)
  val idNewm'FstStep =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       (%90 ((%213 %127) %323))) (((%149 ((%324 %126) ((%144 %127) ((%140
       %124) %323)))) ((%150 %127) ((%151 %292) ((%147 %124) %142))))
       ((%150 %154) ((%151 %270) %271)))))))) ((%13 ((%213 %154) (%197
       %126))) ((%13 ((%211 %270) %292)) ((%156 %271) ((%147 (%187 %126))
       ((%147 %124) %142))))))`)
  val newm'start =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %323) (%128 %126)))))) ((%213 (%197
       ((%324 %126) ((%144 %127) ((%140 %124) %323))))) %127))`)
  val newm'ssSym =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) (%90 ((%107 %323) (%128 %126)))))) ((%135 (%187
       ((%324 %126) ((%144 %127) ((%140 %124) %323))))) %124))`)
  val newm'toFs =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) (((%149
       ((%324 %126) ((%144 %127) ((%140 %124) %323)))) ((%150 %154) ((%151
       %292) %299))) ((%150 %323) ((%151 %305) %306))))))) ((%13 ((%211
       %292) %305)) ((%156 %306) (%272 %299))))`)
  val toFsFromOldSt =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) (((%149
       ((%324 %126) ((%144 %127) ((%140 %124) %323)))) ((%150 %154) ((%151
       %292) %299))) ((%150 %323) ((%151 %305) %306))))))) ((%107 %154)
       (%128 %126)))`)
  val fsTransPfxNil =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) ((%13
       (%90 ((%131 %124) %366))) (((%149 ((%324 %126) ((%144 %127) ((%140
       %124) %323)))) ((%150 %154) ((%151 %292) ((%122 %366) ((%147 %124)
       %142))))) ((%150 %323) ((%151 %305) %148)))))))) ((%13 ((%156 %366)
       %142)) ((%156 %148) %142)))`)
  val lafsImpLaes' =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%90 ((%110 %124) (%125 %126)))) ((%13 (%90 ((%107
       %127) (%128 %126)))) ((%13 (%90 ((%107 %323) (%128 %126)))) (%90
       ((%213 %127) %323)))))) ((%87 ((%193 %194) (%195 ((%324 %126) ((%144
       %127) ((%140 %124) %323)))))) ((%193 %194) (%196 %126))))`)
  val thm52 =
    DT(["DISK_THM"], [],
       `((%87 ((%13 (%310 %311)) (%312 %313))) (%38 (\%314. (%315 (\%316.
       ((%317 (%319 $1)) (%318 $0)))))))`)
  end
  val _ = DB.bindl "laeslafs"
  [("fst1_def",fst1_def,DB.Def),
   ("finalStateTrans_def",finalStateTrans_def,DB.Def),
   ("newStateTrans_def",newStateTrans_def,DB.Def),
   ("newm_def",newm_def,DB.Def),
   ("toFinalStateTrans_def",toFinalStateTrans_def,DB.Def),
   ("newm'_def",newm'_def,DB.Def), ("idLafsImpLaes",idLafsImpLaes,DB.Thm),
   ("idcLafsImpLaes",idcLafsImpLaes,DB.Thm), ("nstApp",nstApp,DB.Thm),
   ("newmQeRule",newmQeRule,DB.Thm), ("idNewmQe",idNewmQe,DB.Thm),
   ("idcNewmPopStkQe",idcNewmPopStkQe,DB.Thm), ("fstApp",fstApp,DB.Thm),
   ("newmFstRule",newmFstRule,DB.Thm),
   ("idcNewmPopStk",idcNewmPopStk,DB.Thm),
   ("ruleMemStkSyms",ruleMemStkSyms,DB.Thm),
   ("idMemStkSyms",idMemStkSyms,DB.Thm),
   ("idcMemStkSyms",idcMemStkSyms,DB.Thm),
   ("memNewmStkSyms",memNewmStkSyms,DB.Thm),
   ("stkSymsFst",stkSymsFst,DB.Thm), ("stkSymsNst",stkSymsNst,DB.Thm),
   ("memOldmStkSyms",memOldmStkSyms,DB.Thm),
   ("lafsImpLaes",lafsImpLaes,DB.Thm),
   ("newmStartRule",newmStartRule,DB.Thm), ("memFslFst",memFslFst,DB.Thm),
   ("slFslNil",slFslNil,DB.Thm), ("stEqNst",stEqNst,DB.Thm),
   ("slNstNil",slNstNil,DB.Thm), ("toStEqNst",toStEqNst,DB.Thm),
   ("transStIsFs",transStIsFs,DB.Thm),
   ("notSomeInpMemFst",notSomeInpMemFst,DB.Thm),
   ("memFst1",memFst1,DB.Thm), ("toStEqNFst",toStEqNFst,DB.Thm),
   ("notSomeInpMemNst",notSomeInpMemNst,DB.Thm),
   ("notSomeMemNewm",notSomeMemNewm,DB.Thm),
   ("memToQeNewm",memToQeNewm,DB.Thm),
   ("notSomeMemQeNewm",notSomeMemQeNewm,DB.Thm),
   ("listQeTransInpSame",listQeTransInpSame,DB.Thm),
   ("idFsToQeInpSame",idFsToQeInpSame,DB.Thm),
   ("idFromQeInpSame",idFromQeInpSame,DB.Thm),
   ("listQeTrans",listQeTrans,DB.Thm), ("idQeTrans",idQeTrans,DB.Thm),
   ("listFsExists",listFsExists,DB.Thm), ("listQeOnly",listQeOnly,DB.Thm),
   ("listFsExists'",listFsExists',DB.Thm),
   ("idcNewmFinalToQe",idcNewmFinalToQe,DB.Thm),
   ("idcNewmFinalToQe'",idcNewmFinalToQe',DB.Thm),
   ("x0TransStIsQe",x0TransStIsQe,DB.Thm),
   ("newmNullStkStQeLd",newmNullStkStQeLd,DB.Thm),
   ("newmNullStkStQe",newmNullStkStQe,DB.Thm),
   ("idNewmImpOldm",idNewmImpOldm,DB.Thm),
   ("idStatesMem",idStatesMem,DB.Thm),
   ("idcNewmImpOldm",idcNewmImpOldm,DB.Thm),
   ("idNewmFstStep",idNewmFstStep,DB.Thm),
   ("newmFstStep",newmFstStep,DB.Thm), ("newmssSym",newmssSym,DB.Thm),
   ("newmstart",newmstart,DB.Thm), ("laesImpLafs",laesImpLafs,DB.Thm),
   ("thm51",thm51,DB.Thm), ("idLaesImpLafs'",idLaesImpLafs',DB.Thm),
   ("idcLaesImpLafs'",idcLaesImpLafs',DB.Thm),
   ("finalStateRule",finalStateRule,DB.Thm),
   ("memStartStateNewm'",memStartStateNewm',DB.Thm),
   ("toStEqFs",toStEqFs,DB.Thm), ("toFsTrans",toFsTrans,DB.Thm),
   ("laesImpLafs'",laesImpLafs',DB.Thm),
   ("notSomeInpMemFst'",notSomeInpMemFst',DB.Thm),
   ("toFsStk",toFsStk,DB.Thm), ("idStatesMem'",idStatesMem',DB.Thm),
   ("idNewm'ImpOldm",idNewm'ImpOldm,DB.Thm),
   ("memFslFst'",memFslFst',DB.Thm), ("idNewm'EndSt",idNewm'EndSt,DB.Thm),
   ("idcNewm'ImpOldm",idcNewm'ImpOldm,DB.Thm),
   ("idNewm'FstStep",idNewm'FstStep,DB.Thm),
   ("newm'start",newm'start,DB.Thm), ("newm'ssSym",newm'ssSym,DB.Thm),
   ("newm'toFs",newm'toFs,DB.Thm), ("toFsFromOldSt",toFsFromOldSt,DB.Thm),
   ("fsTransPfxNil",fsTransPfxNil,DB.Thm),
   ("lafsImpLaes'",lafsImpLaes',DB.Thm), ("thm52",thm52,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("pdaDefTheory.pdaDef_grammars",
                          pdaDefTheory.pdaDef_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("fst1", (Term.prim_mk_const { Name = "fst1", Thy = "laeslafs"}))
  val _ = update_grms
       temp_overload_on
       ("finalStateTrans", (Term.prim_mk_const { Name = "finalStateTrans", Thy = "laeslafs"}))
  val _ = update_grms
       temp_overload_on
       ("newStateTrans", (Term.prim_mk_const { Name = "newStateTrans", Thy = "laeslafs"}))
  val _ = update_grms
       temp_overload_on
       ("newm", (Term.prim_mk_const { Name = "newm", Thy = "laeslafs"}))
  val _ = update_grms
       temp_overload_on
       ("toFinalStateTrans", (Term.prim_mk_const { Name = "toFinalStateTrans", Thy = "laeslafs"}))
  val _ = update_grms
       temp_overload_on
       ("newm'", (Term.prim_mk_const { Name = "newm'", Thy = "laeslafs"}))
  val laeslafs_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ = computeLib.add_funs [fst1_def];  
  
  val _ = computeLib.add_funs [finalStateTrans_def];  
  
  val _ = computeLib.add_funs [newStateTrans_def];  
  
  val _ = computeLib.add_funs [newm_def];  
  
  val _ = computeLib.add_funs [toFinalStateTrans_def];  
  
  val _ = computeLib.add_funs [newm'_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
