signature pdaDefTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val IDC_def : thm
    val ID_curried_def : thm
    val ID_tupled_primitive_def : thm
    val inpSymsList_primitive_def : thm
    val inpSyms_def : thm
    val laes_def : thm
    val lafs_def : thm
    val pda_TY_DEF : thm
    val pda_case_def : thm
    val pda_final : thm
    val pda_final_fupd : thm
    val pda_next : thm
    val pda_next_fupd : thm
    val pda_repfns : thm
    val pda_size_def : thm
    val pda_ssSym : thm
    val pda_ssSym_fupd : thm
    val pda_start : thm
    val pda_start_fupd : thm
    val pdainp_def : thm
    val pdastate_def : thm
    val pdastk_def : thm
    val statesList'_primitive_def : thm
    val statesList_def : thm
    val states_def : thm
    val stkLen_def : thm
    val stkSymsList'_primitive_def : thm
    val stkSymsList_def : thm
    val stkSyms_def : thm
  
  (*  Theorems  *)
    val EXISTS_pda : thm
    val EXISTS_trans : thm
    val FORALL_pda : thm
    val FORALL_trans : thm
    val ID_def : thm
    val ID_ind : thm
    val datatype_pda : thm
    val dlprop : thm
    val dlpropGen : thm
    val finiteInpSyms : thm
    val finiteStates : thm
    val finiteStkSyms : thm
    val frontLem1 : thm
    val frontLem1' : thm
    val frontdlProp : thm
    val frontdlPropGen : thm
    val idInpInsert : thm
    val idStackInsert : thm
    val idStkPop : thm
    val id_thm : thm
    val idcInpInsert : thm
    val idcInpSplit : thm
    val idcStackInsert : thm
    val idcStkLastSplit : thm
    val idcStkNil : thm
    val idcStkPop : thm
    val inpSymsList_def : thm
    val inpSymsList_ind : thm
    val inpSyms_list_eqresult : thm
    val ldIdcInpLen : thm
    val ldIdcInpSuffix : thm
    val ldIdcSplit : thm
    val ldIdcStkLen : thm
    val lem1 : thm
    val memState : thm
    val memStateRule : thm
    val memssl' : thm
    val memstl' : thm
    val new_ssym_exists : thm
    val new_state_exists : thm
    val pdaTransOnPfx : thm
    val pdaTransOnPfxLd : thm
    val pda_11 : thm
    val pda_Axiom : thm
    val pda_accessors : thm
    val pda_accfupds : thm
    val pda_case_cong : thm
    val pda_component_equality : thm
    val pda_fn_updates : thm
    val pda_fupdcanon : thm
    val pda_fupdcanon_comp : thm
    val pda_fupdfupds : thm
    val pda_fupdfupds_comp : thm
    val pda_induction : thm
    val pda_literal_11 : thm
    val pda_literal_nchotomy : thm
    val pda_nchotomy : thm
    val pda_updates_eq_literal : thm
    val rtc2listFstMemState : thm
    val rtc2listIdStkNil : thm
    val rtc2listLastMemState : thm
    val ssymslApp : thm
    val stackRedGen : thm
    val statesList'_def : thm
    val statesList'_ind : thm
    val statesListApp : thm
    val states_list_eqresult : thm
    val stkSymsList'_def : thm
    val stkSymsList'_ind : thm
    val stkSyms_list_eqresult : thm
  
  val pdaDef_grammars : type_grammar.grammar * term_grammar.grammar
  
  val pdaDef_rwts : simpLib.ssfrag
(*
   [relationLemmas] Parent theory of "pdaDef"
   
   [IDC_def]  Definition
      
      |- ∀p s1 s2. IDC p s1 s2 ⇔ (ID p)^* s1 s2
   
   [ID_curried_def]  Definition
      
      |- ∀x x1 x2. x ⊢ x1 → x2 ⇔ ID_tupled (x,x1,x2)
   
   [ID_tupled_primitive_def]  Definition
      
      |- ID_tupled =
         WFREC (@R. WF R)
           (λID_tupled a.
              case a of
                 (p,(q,[],[]),v3) -> I F
              || (p,(q,[],ssym::srst),q',inp',ssyms') ->
                   I
                     ((inp' = []) ∧
                      ∃sl. MEM ((NONE,ssym,q),q',sl) p.next ∧ (ssyms' = sl ++ srst))
              || (p,(q,inp::irst,[]),v3) -> I F
              || (p,(q,inp::irst,ssym'::srst'),q'',inp'',ssyms'') ->
                   I
                     ((inp'' = irst) ∧
                      (∃sl.
                         MEM ((SOME inp,ssym',q),q'',sl) p.next ∧
                         (ssyms'' = sl ++ srst')) ∨
                      (inp'' = inp::irst) ∧
                      ∃sl.
                        MEM ((NONE,ssym',q),q'',sl) p.next ∧
                        (ssyms'' = sl ++ srst')))
   
   [inpSymsList_primitive_def]  Definition
      
      |- inpSymsList =
         WFREC
           (@R.
              WF R ∧ (∀out q ssym isym rst. R rst (((SOME isym,ssym,q),out)::rst)) ∧
              ∀out q ssym rst. R rst (((NONE,ssym,q),out)::rst))
           (λinpSymsList a.
              case a of
                 [] -> I []
              || ((NONE,ssym',q'),out)::rst -> I (inpSymsList rst)
              || ((SOME isym,ssym,q),out)::rst -> I (isym::inpSymsList rst))
   
   [inpSyms_def]  Definition
      
      |- ∀p. inpSyms p = {isym | ∃out q ssym. MEM ((SOME isym,ssym,q),out) p.next}
   
   [laes_def]  Definition
      
      |- ∀p. laes p = {w | ∃state. IDC p (p.start,w,[p.ssSym]) (state,[],[])}
   
   [lafs_def]  Definition
      
      |- ∀p.
           lafs p =
           {w |
            ∃state stack.
              IDC p (p.start,w,[p.ssSym]) (state,[],stack) ∧ MEM state p.final}
   
   [pda_TY_DEF]  Definition
      
      |- ∃rep.
           TYPE_DEFINITION
             (λa0'.
                ∀'pda' .
                  (∀a0'.
                     (∃a0 a1 a2 a3.
                        a0' =
                        (λa0 a1 a2 a3.
                           ind_type$CONSTR 0 (a0,a1,a2,a3) (λn. ind_type$BOTTOM)) a0
                          a1 a2 a3) ⇒
                     'pda' a0') ⇒
                  'pda' a0') rep
   
   [pda_case_def]  Definition
      
      |- ∀f a0 a1 a2 a3. pda_case f (pda a0 a1 a2 a3) = f a0 a1 a2 a3
   
   [pda_final]  Definition
      
      |- ∀s s0 l l0. (pda s s0 l l0).final = l0
   
   [pda_final_fupd]  Definition
      
      |- ∀f s s0 l l0. pda s s0 l l0 with final updated_by f = pda s s0 l (f l0)
   
   [pda_next]  Definition
      
      |- ∀s s0 l l0. (pda s s0 l l0).next = l
   
   [pda_next_fupd]  Definition
      
      |- ∀f s s0 l l0. pda s s0 l l0 with next updated_by f = pda s s0 (f l) l0
   
   [pda_repfns]  Definition
      
      |- (∀a. mk_pda (dest_pda a) = a) ∧
         ∀r.
           (λa0'.
              ∀'pda' .
                (∀a0'.
                   (∃a0 a1 a2 a3.
                      a0' =
                      (λa0 a1 a2 a3.
                         ind_type$CONSTR 0 (a0,a1,a2,a3) (λn. ind_type$BOTTOM)) a0 a1
                        a2 a3) ⇒
                   'pda' a0') ⇒
                'pda' a0') r ⇔ (dest_pda (mk_pda r) = r)
   
   [pda_size_def]  Definition
      
      |- ∀f f1 f2 a0 a1 a2 a3.
           pda_size f f1 f2 (pda a0 a1 a2 a3) =
           1 +
           (f2 a0 +
            (f1 a1 +
             (list_size
                (pair_size (pair_size (option_size f) (pair_size f1 f2))
                   (pair_size f2 (list_size f1))) a2 + list_size f2 a3)))
   
   [pda_ssSym]  Definition
      
      |- ∀s s0 l l0. (pda s s0 l l0).ssSym = s0
   
   [pda_ssSym_fupd]  Definition
      
      |- ∀f s s0 l l0. pda s s0 l l0 with ssSym updated_by f = pda s (f s0) l l0
   
   [pda_start]  Definition
      
      |- ∀s s0 l l0. (pda s s0 l l0).start = s
   
   [pda_start_fupd]  Definition
      
      |- ∀f s s0 l l0. pda s s0 l l0 with start updated_by f = pda (f s) s0 l l0
   
   [pdainp_def]  Definition
      
      |- ∀state inp stk. pdainp (state,inp,stk) = inp
   
   [pdastate_def]  Definition
      
      |- ∀state inp stk. pdastate (state,inp,stk) = state
   
   [pdastk_def]  Definition
      
      |- ∀state inp stk. pdastk (state,inp,stk) = stk
   
   [statesList'_primitive_def]  Definition
      
      |- statesList' =
         WFREC
           (@R.
              WF R ∧
              ∀ssyms q' q ssym isym rst. R rst (((isym,ssym,q),q',ssyms)::rst))
           (λstatesList' a.
              case a of
                 [] -> I []
              || ((isym,ssym,q),q',ssyms)::rst -> I (q::q'::statesList' rst))
   
   [statesList_def]  Definition
      
      |- ∀p d. statesList p d = p.start::p.final ++ statesList' d
   
   [states_def]  Definition
      
      |- ∀p.
           states p =
           {p.start} ∪ set p.final ∪
           {q | ∃out isym ssym. MEM ((isym,ssym,q),out) p.next} ∪
           {q' | ∃isym ssym q ssyms. MEM ((isym,ssym,q),q',ssyms) p.next}
   
   [stkLen_def]  Definition
      
      |- ∀e. stkLen e = LENGTH (pdastk e)
   
   [stkSymsList'_primitive_def]  Definition
      
      |- stkSymsList' =
         WFREC
           (@R.
              WF R ∧
              ∀ssyms q' q ssym isym rst. R rst (((isym,ssym,q),q',ssyms)::rst))
           (λstkSymsList' a.
              case a of
                 [] -> I []
              || ((isym,ssym,q),q',ssyms)::rst ->
                   I (ssym::ssyms ++ stkSymsList' rst))
   
   [stkSymsList_def]  Definition
      
      |- ∀p l. stkSymsList p l = [p.ssSym] ++ stkSymsList' l
   
   [stkSyms_def]  Definition
      
      |- ∀p.
           stkSyms p =
           {p.ssSym} ∪ {ssym | ∃out isym q. MEM ((isym,ssym,q),out) p.next} ∪
           BIGUNION
             {set ssyms | ∃isym ssym q q'. MEM ((isym,ssym,q),q',ssyms) p.next}
   
   [EXISTS_pda]  Theorem
      
      |- ∀P.
           (∃p. P p) ⇔
           ∃s0 s l0 l. P <|start := s0; ssSym := s; next := l0; final := l|>
   
   [EXISTS_trans]  Theorem
      
      |- ∀P. (∃t. P t) ⇔ ∃isopt ss st st' syms. P ((isopt,ss,st),st',syms)
   
   [FORALL_pda]  Theorem
      
      |- ∀P.
           (∀p. P p) ⇔
           ∀s0 s l0 l. P <|start := s0; ssSym := s; next := l0; final := l|>
   
   [FORALL_trans]  Theorem
      
      |- ∀P. (∀t. P t) ⇔ ∀isopt ss st st' syms. P ((isopt,ss,st),st',syms)
   
   [ID_def]  Theorem
      
      |- (p ⊢ (q,[],[]) → y ⇔ F) ∧ (p ⊢ (q,v8::v9,[]) → y ⇔ F) ∧
         (p ⊢ (q,[],ssym::srst) → (q',inp',ssyms') ⇔
          (inp' = []) ∧
          ∃sl. MEM ((NONE,ssym,q),q',sl) p.next ∧ (ssyms' = sl ++ srst)) ∧
         (p ⊢ (q,inp::irst,ssym::srst) → (q',inp',ssyms') ⇔
          (inp' = irst) ∧
          (∃sl. MEM ((SOME inp,ssym,q),q',sl) p.next ∧ (ssyms' = sl ++ srst)) ∨
          (inp' = inp::irst) ∧
          ∃sl. MEM ((NONE,ssym,q),q',sl) p.next ∧ (ssyms' = sl ++ srst))
   
   [ID_ind]  Theorem
      
      |- ∀P.
           (∀p q y. P p (q,[],[]) y) ∧ (∀p q v8 v9 y. P p (q,v8::v9,[]) y) ∧
           (∀p q ssym srst q' inp' ssyms'. P p (q,[],ssym::srst) (q',inp',ssyms')) ∧
           (∀p q inp irst ssym srst q' inp' ssyms'.
              P p (q,inp::irst,ssym::srst) (q',inp',ssyms')) ⇒
           ∀v v1 v2 v3 v4. P v (v1,v2,v3) v4
   
   [datatype_pda]  Theorem
      
      |- DATATYPE (record pda start ssSym next final)
   
   [dlprop]  Theorem
      
      |- ∀dl q q' h rst.
           ID p ⊢ dl ◁ (q,[],h::rst) → (q',[],rst) ⇒
           (∀e. MEM e (FRONT dl) ⇒ LENGTH (h::rst) ≤ LENGTH (pdastk e)) ⇒
           ∀e. MEM e (FRONT dl) ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ rst)
   
   [dlpropGen]  Theorem
      
      |- ∀q i0 isfx r0 rst q' i' isfx r' rst.
           ID p ⊢ dl ◁ (q,i0 ++ isfx,r0 ++ rst) → (q',i' ++ isfx,r' ++ rst) ⇒
           r0 ≠ [] ⇒
           (∀e. MEM e (FRONT dl) ⇒ LENGTH (r0 ++ rst) ≤ LENGTH (pdastk e)) ⇒
           ∀e. MEM e (FRONT dl) ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ rst)
   
   [finiteInpSyms]  Theorem
      
      |- ∀p. FINITE (inpSyms p)
   
   [finiteStates]  Theorem
      
      |- ∀p. FINITE (states p)
   
   [finiteStkSyms]  Theorem
      
      |- ∀p. FINITE (stkSyms p)
   
   [frontLem1]  Theorem
      
      |- ∀q inp stk q0 i0 s0 spfx.
           ID p ⊢ dl ◁ (q,inp,stk) → (q0,i0,s0) ∧
           (∀q' i' s'. MEM (q',i',s') dl ⇒ LENGTH stk ≤ LENGTH s') ⇒
           ∃stk0 stk1 s0'. (stk = stk0 ++ stk1) ∧ (s0 = s0' ++ stk1)
   
   [frontLem1']  Theorem
      
      |- ∀q inp stk q0 i0 s0 spfx.
           ID p ⊢ dl ◁ (q,inp,stk) → (q0,i0,s0) ∧ stk ≠ [] ∧
           (∀q' i' s'. MEM (q',i',s') dl ⇒ LENGTH stk ≤ LENGTH s') ⇒
           ∃stk1 s0'. (stk = HD stk::stk1) ∧ (s0 = s0' ++ stk1)
   
   [frontdlProp]  Theorem
      
      |- ∀q q' r rst r' h.
           ID p ⊢ dl ◁ (q,[],[h] ++ rst) → (q',[],r' ++ rst) ⇒
           (∀e. MEM e dl ⇒ LENGTH ([h] ++ rst) ≤ LENGTH (pdastk e)) ⇒
           ∀e. MEM e dl ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ rst)
   
   [frontdlPropGen]  Theorem
      
      |- ∀q i0 isfx r0 rst q' i' isfx r' rst.
           ID p ⊢ dl ◁ (q,i0 ++ isfx,r0 ++ rst) → (q',i' ++ isfx,r' ++ rst) ⇒
           r0 ≠ [] ⇒
           (∀e. MEM e dl ⇒ LENGTH (r0 ++ rst) ≤ LENGTH (pdastk e)) ⇒
           ∀e. MEM e dl ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ rst)
   
   [idInpInsert]  Theorem
      
      |- m ⊢ (q,x,stk) → (q',x',stk') ⇒ ∀l. m ⊢ (q,x ++ l,stk) → (q',x' ++ l,stk')
   
   [idStackInsert]  Theorem
      
      |- m ⊢ (q,x,stk) → (q',x',stk') ⇒ ∀l. m ⊢ (q,x,stk ++ l) → (q',x',stk' ++ l)
   
   [idStkPop]  Theorem
      
      |- ∀q i p sym s q' i' stk'.
           m ⊢ (q,i,p ++ [sym] ++ s) → (q',i',stk') ∧ ¬MEM sym p ∧ sym ∉ stkSyms m ⇒
           ∃p'. (stk' = p' ++ [sym] ++ s) ∧ ¬MEM sym p' ∧ m ⊢ (q,i,p) → (q',i',p')
   
   [id_thm]  Theorem
      
      |- p ⊢ (q0,i0,s0) → (q,i,s) ⇔
         (∃sh st st'.
            (s0 = sh::st) ∧ MEM ((NONE,sh,q0),q,st') p.next ∧ (s = st' ++ st) ∧
            (i = i0)) ∨
         ∃sh st st' ih.
           (s0 = sh::st) ∧ MEM ((SOME ih,sh,q0),q,st') p.next ∧ (s = st' ++ st) ∧
           (i0 = ih::i)
   
   [idcInpInsert]  Theorem
      
      |- (ID m)^* (q,x,stk) (q',x',stk') ⇒
         ∀l. (ID m)^* (q,x ++ l,stk) (q',x' ++ l,stk')
   
   [idcInpSplit]  Theorem
      
      |- ∀q i s q' i' s'. ID p ⊢ dl ◁ (q,i,s) → (q',i',s') ⇒ ∃ipfx. i = ipfx ++ i'
   
   [idcStackInsert]  Theorem
      
      |- (ID m)^* (q,x,stk) (q',x',stk') ⇒
         ∀l. (ID m)^* (q,x,stk ++ l) (q',x',stk' ++ l)
   
   [idcStkLastSplit]  Theorem
      
      |- ∀dl q i s q' i' s'.
           ID p ⊢ dl ◁ (q,i,s) → (q',i',s') ⇒
           (∀qx ix sx. MEM (qx,ix,sx) (FRONT dl) ⇒ LENGTH s ≤ LENGTH sx) ⇒
           (s = []) ∨ ∃p. s' = p ++ TL s
   
   [idcStkNil]  Theorem
      
      |- ∀x y. (ID p)^* x y ⇒ (x = (q,i,[])) ⇒ (y = (q',i',[])) ⇒ (x = y)
   
   [idcStkPop]  Theorem
      
      |- ∀l q i s q' i' stk' p.
           ID m ⊢ l ◁ (q,i,p ++ [sym] ++ s) → (q',i',stk') ∧ ¬MEM sym p ∧
           sym ∉ stkSyms m ⇒
           ∃l' p'.
             (stk' = p' ++ [sym] ++ s) ∧ ¬MEM sym p' ∧
             ID m ⊢ l' ◁ (q,i,p) → (q',i',p')
   
   [inpSymsList_def]  Theorem
      
      |- (inpSymsList [] = []) ∧
         (∀ssym rst q out isym.
            inpSymsList (((SOME isym,ssym,q),out)::rst) = isym::inpSymsList rst) ∧
         ∀ssym rst q out. inpSymsList (((NONE,ssym,q),out)::rst) = inpSymsList rst
   
   [inpSymsList_ind]  Theorem
      
      |- ∀P.
           P [] ∧ (∀isym ssym q out rst. P rst ⇒ P (((SOME isym,ssym,q),out)::rst)) ∧
           (∀ssym q out rst. P rst ⇒ P (((NONE,ssym,q),out)::rst)) ⇒
           ∀v. P v
   
   [inpSyms_list_eqresult]  Theorem
      
      |- inpSyms p = set (inpSymsList p.next)
   
   [ldIdcInpLen]  Theorem
      
      |- ∀q q' i i' s s'. ID p ⊢ dl ◁ (q,i,s) → (q',i',s') ⇒ LENGTH i' ≤ LENGTH i
   
   [ldIdcInpSuffix]  Theorem
      
      |- ∀q q' inp inp' stk stk'.
           ID p ⊢ dl ◁ (q,inp,stk) → (q',inp',stk') ⇒
           ∃p. (inp = p ++ inp') ∧ isSuffix inp' inp
   
   [ldIdcSplit]  Theorem
      
      [oracles: DISK_THM, MK_THM] [axioms: ] []
      |- ∀dl q inp stk qf.
           ID p ⊢ dl ◁ (q,inp,stk) → (qf,[],[]) ⇒
           ∃dl0 q0 i0 s0 spfx.
             ID p ⊢ dl0 ◁ (q,inp,stk) → (q0,i0,s0) ∧ (LENGTH s0 = LENGTH stk − 1) ∧
             (∀q' i' s'. MEM (q',i',s') (FRONT dl0) ⇒ LENGTH stk ≤ LENGTH s') ∧
             ((∃dl1.
                 ID p ⊢ dl1 ◁ (q0,i0,s0) → (qf,[],[]) ∧ LENGTH dl1 < LENGTH dl ∧
                 LENGTH dl0 < LENGTH dl) ∨ ((q0,i0,s0) = (qf,[],[])))
   
   [ldIdcStkLen]  Theorem
      
      [oracles: MK_THM] [axioms: ] []
      |- ∀l q inp s q' inp' s'.
           ID p ⊢ l ◁ (q,inp,s) → (q',inp',s') ⇒
           ∀i.
             i + 1 < LENGTH l ∧ stkLen (EL (i + 1) l) < stkLen (EL i l) ⇒
             (stkLen (EL i l) = stkLen (EL (i + 1) l) + 1)
   
   [lem1]  Theorem
      
      |- ∀q inp stk q0 i0 s0 spfx.
           ID p ⊢ dl ◁ (q,inp,stk) → (q0,i0,s0) ∧ (LENGTH s0 = LENGTH stk − 1) ⇒
           stk ≠ [] ⇒
           (∀q' i' s'. MEM (q',i',s') (FRONT dl) ⇒ LENGTH stk ≤ LENGTH s') ⇒
           (stk = HD stk::s0)
   
   [memState]  Theorem
      
      |- IDC m (st,inp,stk) (st',inp',stk') ⇒
         (st = st') ∨ MEM st (statesList m m.next) ∧ MEM st' (statesList m m.next)
   
   [memStateRule]  Theorem
      
      |- MEM ((x,h,st),q,sl) m.next ⇒
         MEM st (statesList m m.next) ∧ MEM q (statesList m m.next)
   
   [memssl']  Theorem
      
      |- ∀l.
           MEM ssym (stkSymsList' l) ⇒
           ∃isym q q' ssyms.
             MEM ((isym,ssym,q),q',ssyms) l ∨
             ∃isym q q' x ssyms. MEM ((isym,x,q),q',ssyms) l ∧ MEM ssym ssyms
   
   [memstl']  Theorem
      
      |- ∀l.
           MEM q (statesList' l) ⇒
           ∃isym ssym q' ssyms.
             MEM ((isym,ssym,q),q',ssyms) l ∨
             ∃isym ssym q' ssyms. MEM ((isym,ssym,q'),q,ssyms) l
   
   [new_ssym_exists]  Theorem
      
      |- ∀s. INFINITE UNIV ⇒ FINITE s ⇒ ∃x. x ∉ s
   
   [new_state_exists]  Theorem
      
      |- ∀s. INFINITE UNIV ⇒ FINITE s ⇒ ∃x. x ∉ s
   
   [pdaTransOnPfx]  Theorem
      
      |- ∀q q' ipfx isfx spfx ssfx.
           ID p ⊢ dl ◁ (q,ipfx ++ isfx,spfx ++ ssfx) → (q',isfx,ssfx) ⇒
           (∀e. MEM e (FRONT dl) ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ ssfx)) ⇒
           (ID p)^* (q,ipfx,spfx) (q',[],[])
   
   [pdaTransOnPfxLd]  Theorem
      
      |- ∀q q' ipfx isfx spfx ssfx.
           ID p ⊢ dl ◁ (q,ipfx ++ isfx,spfx ++ ssfx) → (q',isfx,ssfx) ⇒
           (∀e. MEM e (FRONT dl) ⇒ ∃p. p ≠ [] ∧ (pdastk e = p ++ ssfx)) ⇒
           ∃l. LENGTH l ≤ LENGTH dl ∧ ID p ⊢ l ◁ (q,ipfx,spfx) → (q',[],[])
   
   [pda_11]  Theorem
      
      |- ∀a0 a1 a2 a3 a0' a1' a2' a3'.
           (pda a0 a1 a2 a3 = pda a0' a1' a2' a3') ⇔
           (a0 = a0') ∧ (a1 = a1') ∧ (a2 = a2') ∧ (a3 = a3')
   
   [pda_Axiom]  Theorem
      
      |- ∀f. ∃fn. ∀a0 a1 a2 a3. fn (pda a0 a1 a2 a3) = f a0 a1 a2 a3
   
   [pda_accessors]  Theorem
      
      |- (∀s s0 l l0. (pda s s0 l l0).start = s) ∧
         (∀s s0 l l0. (pda s s0 l l0).ssSym = s0) ∧
         (∀s s0 l l0. (pda s s0 l l0).next = l) ∧
         ∀s s0 l l0. (pda s s0 l l0).final = l0
   
   [pda_accfupds]  Theorem
      
      |- (∀p f. (p with ssSym updated_by f).start = p.start) ∧
         (∀p f. (p with next updated_by f).start = p.start) ∧
         (∀p f. (p with final updated_by f).start = p.start) ∧
         (∀p f. (p with start updated_by f).ssSym = p.ssSym) ∧
         (∀p f. (p with next updated_by f).ssSym = p.ssSym) ∧
         (∀p f. (p with final updated_by f).ssSym = p.ssSym) ∧
         (∀p f. (p with start updated_by f).next = p.next) ∧
         (∀p f. (p with ssSym updated_by f).next = p.next) ∧
         (∀p f. (p with final updated_by f).next = p.next) ∧
         (∀p f. (p with start updated_by f).final = p.final) ∧
         (∀p f. (p with ssSym updated_by f).final = p.final) ∧
         (∀p f. (p with next updated_by f).final = p.final) ∧
         (∀p f. (p with start updated_by f).start = f p.start) ∧
         (∀p f. (p with ssSym updated_by f).ssSym = f p.ssSym) ∧
         (∀p f. (p with next updated_by f).next = f p.next) ∧
         ∀p f. (p with final updated_by f).final = f p.final
   
   [pda_case_cong]  Theorem
      
      |- ∀M M' f.
           (M = M') ∧
           (∀a0 a1 a2 a3.
              (M' = pda a0 a1 a2 a3) ⇒ (f a0 a1 a2 a3 = f' a0 a1 a2 a3)) ⇒
           (pda_case f M = pda_case f' M')
   
   [pda_component_equality]  Theorem
      
      |- ∀p1 p2.
           (p1 = p2) ⇔
           (p1.start = p2.start) ∧ (p1.ssSym = p2.ssSym) ∧ (p1.next = p2.next) ∧
           (p1.final = p2.final)
   
   [pda_fn_updates]  Theorem
      
      |- (∀f s s0 l l0. pda s s0 l l0 with start updated_by f = pda (f s) s0 l l0) ∧
         (∀f s s0 l l0. pda s s0 l l0 with ssSym updated_by f = pda s (f s0) l l0) ∧
         (∀f s s0 l l0. pda s s0 l l0 with next updated_by f = pda s s0 (f l) l0) ∧
         ∀f s s0 l l0. pda s s0 l l0 with final updated_by f = pda s s0 l (f l0)
   
   [pda_fupdcanon]  Theorem
      
      |- (∀p g f.
            p with <|ssSym updated_by f; start updated_by g|> =
            p with <|start updated_by g; ssSym updated_by f|>) ∧
         (∀p g f.
            p with <|next updated_by f; start updated_by g|> =
            p with <|start updated_by g; next updated_by f|>) ∧
         (∀p g f.
            p with <|next updated_by f; ssSym updated_by g|> =
            p with <|ssSym updated_by g; next updated_by f|>) ∧
         (∀p g f.
            p with <|final updated_by f; start updated_by g|> =
            p with <|start updated_by g; final updated_by f|>) ∧
         (∀p g f.
            p with <|final updated_by f; ssSym updated_by g|> =
            p with <|ssSym updated_by g; final updated_by f|>) ∧
         ∀p g f.
           p with <|final updated_by f; next updated_by g|> =
           p with <|next updated_by g; final updated_by f|>
   
   [pda_fupdcanon_comp]  Theorem
      
      |- ((∀g f.
              _ record fupdatessSym f o  _ record fupdatestart g =
              _ record fupdatestart g o  _ record fupdatessSym f) ∧
          ∀h g f.
             _ record fupdatessSym f o  _ record fupdatestart g o h =
             _ record fupdatestart g o  _ record fupdatessSym f o h) ∧
         ((∀g f.
              _ record fupdatenext f o  _ record fupdatestart g =
              _ record fupdatestart g o  _ record fupdatenext f) ∧
          ∀h g f.
             _ record fupdatenext f o  _ record fupdatestart g o h =
             _ record fupdatestart g o  _ record fupdatenext f o h) ∧
         ((∀g f.
              _ record fupdatenext f o  _ record fupdatessSym g =
              _ record fupdatessSym g o  _ record fupdatenext f) ∧
          ∀h g f.
             _ record fupdatenext f o  _ record fupdatessSym g o h =
             _ record fupdatessSym g o  _ record fupdatenext f o h) ∧
         ((∀g f.
              _ record fupdatefinal f o  _ record fupdatestart g =
              _ record fupdatestart g o  _ record fupdatefinal f) ∧
          ∀h g f.
             _ record fupdatefinal f o  _ record fupdatestart g o h =
             _ record fupdatestart g o  _ record fupdatefinal f o h) ∧
         ((∀g f.
              _ record fupdatefinal f o  _ record fupdatessSym g =
              _ record fupdatessSym g o  _ record fupdatefinal f) ∧
          ∀h g f.
             _ record fupdatefinal f o  _ record fupdatessSym g o h =
             _ record fupdatessSym g o  _ record fupdatefinal f o h) ∧
         (∀g f.
             _ record fupdatefinal f o  _ record fupdatenext g =
             _ record fupdatenext g o  _ record fupdatefinal f) ∧
         ∀h g f.
            _ record fupdatefinal f o  _ record fupdatenext g o h =
            _ record fupdatenext g o  _ record fupdatefinal f o h
   
   [pda_fupdfupds]  Theorem
      
      |- (∀p g f.
            p with <|start updated_by f; start updated_by g|> =
            p with start updated_by f o g) ∧
         (∀p g f.
            p with <|ssSym updated_by f; ssSym updated_by g|> =
            p with ssSym updated_by f o g) ∧
         (∀p g f.
            p with <|next updated_by f; next updated_by g|> =
            p with next updated_by f o g) ∧
         ∀p g f.
           p with <|final updated_by f; final updated_by g|> =
           p with final updated_by f o g
   
   [pda_fupdfupds_comp]  Theorem
      
      |- ((∀g f.
              _ record fupdatestart f o  _ record fupdatestart g =
              _ record fupdatestart (f o g)) ∧
          ∀h g f.
             _ record fupdatestart f o  _ record fupdatestart g o h =
             _ record fupdatestart (f o g) o h) ∧
         ((∀g f.
              _ record fupdatessSym f o  _ record fupdatessSym g =
              _ record fupdatessSym (f o g)) ∧
          ∀h g f.
             _ record fupdatessSym f o  _ record fupdatessSym g o h =
             _ record fupdatessSym (f o g) o h) ∧
         ((∀g f.
              _ record fupdatenext f o  _ record fupdatenext g =
              _ record fupdatenext (f o g)) ∧
          ∀h g f.
             _ record fupdatenext f o  _ record fupdatenext g o h =
             _ record fupdatenext (f o g) o h) ∧
         (∀g f.
             _ record fupdatefinal f o  _ record fupdatefinal g =
             _ record fupdatefinal (f o g)) ∧
         ∀h g f.
            _ record fupdatefinal f o  _ record fupdatefinal g o h =
            _ record fupdatefinal (f o g) o h
   
   [pda_induction]  Theorem
      
      |- ∀P. (∀s s0 l l0. P (pda s s0 l l0)) ⇒ ∀p. P p
   
   [pda_literal_11]  Theorem
      
      |- ∀s01 s1 l01 l1 s02 s2 l02 l2.
           (<|start := s01; ssSym := s1; next := l01; final := l1|> =
            <|start := s02; ssSym := s2; next := l02; final := l2|>) ⇔
           (s01 = s02) ∧ (s1 = s2) ∧ (l01 = l02) ∧ (l1 = l2)
   
   [pda_literal_nchotomy]  Theorem
      
      |- ∀p. ∃s0 s l0 l. p = <|start := s0; ssSym := s; next := l0; final := l|>
   
   [pda_nchotomy]  Theorem
      
      |- ∀pp. ∃s s0 l l0. pp = pda s s0 l l0
   
   [pda_updates_eq_literal]  Theorem
      
      |- ∀p s0 s l0 l.
           p with <|start := s0; ssSym := s; next := l0; final := l|> =
           <|start := s0; ssSym := s; next := l0; final := l|>
   
   [rtc2listFstMemState]  Theorem
      
      |- ∀q i s t.
           rtc2list (ID p) ((q,i,s)::t) ∧ t ≠ [] ⇒ MEM q (statesList p p.next)
   
   [rtc2listIdStkNil]  Theorem
      
      |- rtc2list (ID p) ((q,i,[])::t) ⇒ (t = [])
   
   [rtc2listLastMemState]  Theorem
      
      |- ∀q i s t.
           rtc2list (ID p) ((q,i,s)::t) ∧ t ≠ [] ⇒
           MEM (pdastate (LAST t)) (statesList p p.next)
   
   [ssymslApp]  Theorem
      
      |- ∀l1 l2. stkSymsList' (l1 ++ l2) = stkSymsList' l1 ++ stkSymsList' l2
   
   [stackRedGen]  Theorem
      
      |- (f (LAST l) = 0) ∧ l ≠ [] ∧
         (∀i.
            i + 1 < LENGTH l ∧ f (EL (i + 1) l) < f (EL i l) ⇒
            (f (EL i l) = f (EL (i + 1) l) + 1)) ⇒
         ∀n.
           n ≤ f (HD l) ⇒
           ∃i. (f (EL i l) = n) ∧ i < LENGTH l ∧ ∀j. j < i ⇒ n < f (EL j l)
   
   [statesList'_def]  Theorem
      
      |- (statesList' [] = []) ∧
         ∀ssyms ssym rst q' q isym.
           statesList' (((isym,ssym,q),q',ssyms)::rst) = q::q'::statesList' rst
   
   [statesList'_ind]  Theorem
      
      |- ∀P.
           P [] ∧
           (∀isym ssym q q' ssyms rst. P rst ⇒ P (((isym,ssym,q),q',ssyms)::rst)) ⇒
           ∀v. P v
   
   [statesListApp]  Theorem
      
      |- ∀p1 p2. statesList' (p1 ++ p2) = statesList' p1 ++ statesList' p2
   
   [states_list_eqresult]  Theorem
      
      |- states p = set (statesList p p.next)
   
   [stkSymsList'_def]  Theorem
      
      |- (stkSymsList' [] = []) ∧
         ∀ssyms ssym rst q' q isym.
           stkSymsList' (((isym,ssym,q),q',ssyms)::rst) =
           ssym::ssyms ++ stkSymsList' rst
   
   [stkSymsList'_ind]  Theorem
      
      |- ∀P.
           P [] ∧
           (∀isym ssym q q' ssyms rst. P rst ⇒ P (((isym,ssym,q),q',ssyms)::rst)) ⇒
           ∀v. P v
   
   [stkSyms_list_eqresult]  Theorem
      
      |- stkSyms p = set (stkSymsList p p.next)
   
   
*)
end
