structure pdaDefTheory :> pdaDefTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading pdaDefTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open relationLemmasTheory
  in end;
  val _ = Theory.link_parents
          ("pdaDef",
          Arbnum.fromString "1259522262",
          Arbnum.fromString "507894")
          [("relationLemmas",
           Arbnum.fromString "1259448260",
           Arbnum.fromString "412289")];
  val _ = Theory.incorporate_types "pdaDef" [("pda",3)];
  val _ = Theory.incorporate_consts "pdaDef"
     [("stkSymsList'",
       ((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
             T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
         T"list" "list" [alpha]))),
      ("stkSymsList",
       ((T"pda" "pdaDef" [alpha, U"'ssym", beta] -->
         (T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair" [gamma, T"prod" "pair" [U"'ssym", delta]],
              T"prod" "pair" [U"'e", T"list" "list" [U"'ssym"]]]] -->
          T"list" "list" [U"'ssym"])))),
      ("stkSyms",
       ((T"pda" "pdaDef" [alpha, U"'ssym", beta] -->
         (U"'ssym" --> bool)))),
      ("stkLen",
       ((T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"list" "list" [gamma]]] -->
         T"num" "num" []))),
      ("statesList'",
       ((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
             T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha]))),
      ("statesList",
       ((T"pda" "pdaDef" [alpha, beta, U"'state"] -->
         (T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair" [gamma, T"prod" "pair" [delta, U"'state"]],
              T"prod" "pair" [U"'state", U"'e"]]] -->
          T"list" "list" [U"'state"])))),
      ("states",
       ((T"pda" "pdaDef" [alpha, beta, U"'state"] -->
         (U"'state" --> bool)))),
      ("pdastk",
       ((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] --> alpha))),
      ("pdastate",
       ((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> alpha))),
      ("pdainp",
       ((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] --> alpha))),
      ("pda_start_fupd",
       (((U"'state" --> U"'state") -->
         (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
          T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("pda_start",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'state"))),
      ("pda_ssSym_fupd",
       (((U"'ssym" --> U"'ssym") -->
         (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
          T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("pda_ssSym",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'ssym"))),
      ("pda_size",
       (((U"'isym" --> T"num" "num" []) -->
         ((U"'ssym" --> T"num" "num" []) -->
          ((U"'state" --> T"num" "num" []) -->
           (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
            T"num" "num" [])))))),
      ("pda_next_fupd",
       (((T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [U"'isym"],
                T"prod" "pair" [U"'ssym", U"'state"]],
              T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
          T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [U"'isym"],
                T"prod" "pair" [U"'ssym", U"'state"]],
              T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
         (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
          T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("pda_next",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
      ("pda_final_fupd",
       (((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
         (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
          T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
      ("pda_final",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         T"list" "list" [U"'state"]))),
      ("pda_case",
       (((U"'state" -->
          (U"'ssym" -->
           (T"list" "list"
             [T"prod" "pair"
               [T"prod" "pair"
                 [T"option" "option" [U"'isym"],
                  T"prod" "pair" [U"'ssym", U"'state"]],
                T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
            (T"list" "list" [U"'state"] --> alpha)))) -->
         (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> alpha)))),
      ("pda",
       ((U"'state" -->
         (U"'ssym" -->
          (T"list" "list"
            [T"prod" "pair"
              [T"prod" "pair"
                [T"option" "option" [U"'isym"],
                 T"prod" "pair" [U"'ssym", U"'state"]],
               T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
           (T"list" "list" [U"'state"] -->
            T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))))),
      ("mk_pda",
       ((T"recspace" "ind_type"
          [T"prod" "pair"
            [U"'state",
             T"prod" "pair"
              [U"'ssym",
               T"prod" "pair"
                [T"list" "list"
                  [T"prod" "pair"
                    [T"prod" "pair"
                      [T"option" "option" [U"'isym"],
                       T"prod" "pair" [U"'ssym", U"'state"]],
                     T"prod" "pair"
                      [U"'state", T"list" "list" [U"'ssym"]]]],
                 T"list" "list" [U"'state"]]]]] -->
         T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
      ("lafs",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         (T"list" "list" [U"'isym"] --> bool)))),
      ("laes",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         (T"list" "list" [U"'isym"] --> bool)))),
      ("inpSymsList",
       ((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [alpha, beta]], gamma]] -->
         T"list" "list" [U"'isym"]))),
      ("inpSyms",
       ((T"pda" "pdaDef" [U"'isym", alpha, beta] -->
         (U"'isym" --> bool)))),
      ("dest_pda",
       ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [U"'state",
             T"prod" "pair"
              [U"'ssym",
               T"prod" "pair"
                [T"list" "list"
                  [T"prod" "pair"
                    [T"prod" "pair"
                      [T"option" "option" [U"'isym"],
                       T"prod" "pair" [U"'ssym", U"'state"]],
                     T"prod" "pair"
                      [U"'state", T"list" "list" [U"'ssym"]]]],
                 T"list" "list" [U"'state"]]]]]))),
      ("ID_tupled",
       ((T"prod" "pair"
          [T"pda" "pdaDef" [alpha, beta, gamma],
           T"prod" "pair"
            [T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]],
             T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
         bool))),
      ("IDC",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"prod" "pair"
           [gamma,
            T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
          -->
          (T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]] -->
           bool))))),
      ("ID",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"prod" "pair"
           [gamma,
            T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
          -->
          (T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]] -->
           bool)))))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [U"'state",
            T"prod" "pair"
             [U"'ssym",
              T"prod" "pair"
               [T"list" "list"
                 [T"prod" "pair"
                   [T"prod" "pair"
                     [T"option" "option" [U"'isym"],
                      T"prod" "pair" [U"'ssym", U"'state"]],
                    T"prod" "pair"
                     [U"'state", T"list" "list" [U"'ssym"]]]],
                T"list" "list" [U"'state"]]]]]) --> bool) --> bool)),
   V"rep"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [U"'ssym",
            T"prod" "pair"
             [T"list" "list"
               [T"prod" "pair"
                 [T"prod" "pair"
                   [T"option" "option" [U"'isym"],
                    T"prod" "pair" [U"'ssym", U"'state"]],
                  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
              T"list" "list" [U"'state"]]]]])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [U"'state",
           T"prod" "pair"
            [U"'ssym",
             T"prod" "pair"
              [T"list" "list"
                [T"prod" "pair"
                  [T"prod" "pair"
                    [T"option" "option" [U"'isym"],
                     T"prod" "pair" [U"'ssym", U"'state"]],
                   T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
               T"list" "list" [U"'state"]]]]] --> bool) -->
      ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [U"'state",
            T"prod" "pair"
             [U"'ssym",
              T"prod" "pair"
               [T"list" "list"
                 [T"prod" "pair"
                   [T"prod" "pair"
                     [T"option" "option" [U"'isym"],
                      T"prod" "pair" [U"'ssym", U"'state"]],
                    T"prod" "pair"
                     [U"'state", T"list" "list" [U"'ssym"]]]],
                T"list" "list" [U"'state"]]]]]) --> bool))),
   V"a0'"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [U"'ssym",
           T"prod" "pair"
            [T"list" "list"
              [T"prod" "pair"
                [T"prod" "pair"
                  [T"option" "option" [U"'isym"],
                   T"prod" "pair" [U"'ssym", U"'state"]],
                 T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
             T"list" "list" [U"'state"]]]]]),
   C"!" "bool"
    ((((T"recspace" "ind_type"
         [T"prod" "pair"
           [U"'state",
            T"prod" "pair"
             [U"'ssym",
              T"prod" "pair"
               [T"list" "list"
                 [T"prod" "pair"
                   [T"prod" "pair"
                     [T"option" "option" [U"'isym"],
                      T"prod" "pair" [U"'ssym", U"'state"]],
                    T"prod" "pair"
                     [U"'state", T"list" "list" [U"'ssym"]]]],
                T"list" "list" [U"'state"]]]]] --> bool) --> bool) -->
      bool)),
   V"'pda'"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [U"'ssym",
            T"prod" "pair"
             [T"list" "list"
               [T"prod" "pair"
                 [T"prod" "pair"
                   [T"option" "option" [U"'isym"],
                    T"prod" "pair" [U"'ssym", U"'state"]],
                  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
              T"list" "list" [U"'state"]]]]] --> bool)),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type"
        [T"prod" "pair"
          [U"'state",
           T"prod" "pair"
            [U"'ssym",
             T"prod" "pair"
              [T"list" "list"
                [T"prod" "pair"
                  [T"prod" "pair"
                    [T"option" "option" [U"'isym"],
                     T"prod" "pair" [U"'ssym", U"'state"]],
                   T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
               T"list" "list" [U"'state"]]]]] --> bool) --> bool)),
   C"?" "bool" (((U"'state" --> bool) --> bool)), V"a0" (U"'state"),
   C"?" "bool" (((U"'ssym" --> bool) --> bool)), V"a1" (U"'ssym"),
   C"?" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       bool) --> bool)),
   V"a2"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   C"?" "bool" (((T"list" "list" [U"'state"] --> bool) --> bool)),
   V"a3" (T"list" "list" [U"'state"]),
   C"=" "min"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [U"'ssym",
            T"prod" "pair"
             [T"list" "list"
               [T"prod" "pair"
                 [T"prod" "pair"
                   [T"option" "option" [U"'isym"],
                    T"prod" "pair" [U"'ssym", U"'state"]],
                  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
              T"list" "list" [U"'state"]]]]] -->
      (T"recspace" "ind_type"
        [T"prod" "pair"
          [U"'state",
           T"prod" "pair"
            [U"'ssym",
             T"prod" "pair"
              [T"list" "list"
                [T"prod" "pair"
                  [T"prod" "pair"
                    [T"option" "option" [U"'isym"],
                     T"prod" "pair" [U"'ssym", U"'state"]],
                   T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
               T"list" "list" [U"'state"]]]]] --> bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [U"'ssym",
           T"prod" "pair"
            [T"list" "list"
              [T"prod" "pair"
                [T"prod" "pair"
                  [T"option" "option" [U"'isym"],
                   T"prod" "pair" [U"'ssym", U"'state"]],
                 T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
             T"list" "list" [U"'state"]]]] -->
       ((T"num" "num" [] -->
         T"recspace" "ind_type"
          [T"prod" "pair"
            [U"'state",
             T"prod" "pair"
              [U"'ssym",
               T"prod" "pair"
                [T"list" "list"
                  [T"prod" "pair"
                    [T"prod" "pair"
                      [T"option" "option" [U"'isym"],
                       T"prod" "pair" [U"'ssym", U"'state"]],
                     T"prod" "pair"
                      [U"'state", T"list" "list" [U"'ssym"]]]],
                 T"list" "list" [U"'state"]]]]]) -->
        T"recspace" "ind_type"
         [T"prod" "pair"
           [U"'state",
            T"prod" "pair"
             [U"'ssym",
              T"prod" "pair"
               [T"list" "list"
                 [T"prod" "pair"
                   [T"prod" "pair"
                     [T"option" "option" [U"'isym"],
                      T"prod" "pair" [U"'ssym", U"'state"]],
                    T"prod" "pair"
                     [U"'state", T"list" "list" [U"'ssym"]]]],
                T"list" "list" [U"'state"]]]]])))),
   C"0" "num" (T"num" "num" []),
   C"," "pair"
    ((U"'state" -->
      (T"prod" "pair"
        [U"'ssym",
         T"prod" "pair"
          [T"list" "list"
            [T"prod" "pair"
              [T"prod" "pair"
                [T"option" "option" [U"'isym"],
                 T"prod" "pair" [U"'ssym", U"'state"]],
               T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
           T"list" "list" [U"'state"]]] -->
       T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [U"'ssym",
           T"prod" "pair"
            [T"list" "list"
              [T"prod" "pair"
                [T"prod" "pair"
                  [T"option" "option" [U"'isym"],
                   T"prod" "pair" [U"'ssym", U"'state"]],
                 T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
             T"list" "list" [U"'state"]]]]))),
   C"," "pair"
    ((U"'ssym" -->
      (T"prod" "pair"
        [T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
         T"list" "list" [U"'state"]] -->
       T"prod" "pair"
        [U"'ssym",
         T"prod" "pair"
          [T"list" "list"
            [T"prod" "pair"
              [T"prod" "pair"
                [T"option" "option" [U"'isym"],
                 T"prod" "pair" [U"'ssym", U"'state"]],
               T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
           T"list" "list" [U"'state"]]]))),
   C"," "pair"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list" [U"'state"] -->
       T"prod" "pair"
        [T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
         T"list" "list" [U"'state"]]))), V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [U"'ssym",
           T"prod" "pair"
            [T"list" "list"
              [T"prod" "pair"
                [T"prod" "pair"
                  [T"option" "option" [U"'isym"],
                   T"prod" "pair" [U"'ssym", U"'state"]],
                 T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
             T"list" "list" [U"'state"]]]]]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool) -->
      bool)), V"a" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"=" "min"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool))),
   C"mk_pda" "pdaDef"
    ((T"recspace" "ind_type"
       [T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [U"'ssym",
            T"prod" "pair"
             [T"list" "list"
               [T"prod" "pair"
                 [T"prod" "pair"
                   [T"option" "option" [U"'isym"],
                    T"prod" "pair" [U"'ssym", U"'state"]],
                  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
              T"list" "list" [U"'state"]]]]] -->
      T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])),
   C"dest_pda" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"recspace" "ind_type"
       [T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [U"'ssym",
            T"prod" "pair"
             [T"list" "list"
               [T"prod" "pair"
                 [T"prod" "pair"
                   [T"option" "option" [U"'isym"],
                    T"prod" "pair" [U"'ssym", U"'state"]],
                  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
              T"list" "list" [U"'state"]]]]])),
   V"r"
    (T"recspace" "ind_type"
      [T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [U"'ssym",
           T"prod" "pair"
            [T"list" "list"
              [T"prod" "pair"
                [T"prod" "pair"
                  [T"option" "option" [U"'isym"],
                   T"prod" "pair" [U"'ssym", U"'state"]],
                 T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]],
             T"list" "list" [U"'state"]]]]]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    ((((U"'state" -->
        (U"'ssym" -->
         (T"list" "list"
           [T"prod" "pair"
             [T"prod" "pair"
               [T"option" "option" [U"'isym"],
                T"prod" "pair" [U"'ssym", U"'state"]],
              T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
          (T"list" "list" [U"'state"] --> alpha)))) --> bool) --> bool)),
   V"f"
    ((U"'state" -->
      (U"'ssym" -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        (T"list" "list" [U"'state"] --> alpha))))),
   C"!" "bool" (((U"'state" --> bool) --> bool)),
   C"!" "bool" (((U"'ssym" --> bool) --> bool)),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       bool) --> bool)),
   C"!" "bool" (((T"list" "list" [U"'state"] --> bool) --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"pda_case" "pdaDef"
    (((U"'state" -->
       (U"'ssym" -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
         (T"list" "list" [U"'state"] --> alpha)))) -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> alpha))),
   C"pda" "pdaDef"
    ((U"'state" -->
      (U"'ssym" -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        (T"list" "list" [U"'state"] -->
         T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))))),
   C"!" "bool" ((((U"'isym" --> T"num" "num" []) --> bool) --> bool)),
   V"f" ((U"'isym" --> T"num" "num" [])),
   C"!" "bool" ((((U"'ssym" --> T"num" "num" []) --> bool) --> bool)),
   V"f1" ((U"'ssym" --> T"num" "num" [])),
   C"!" "bool" ((((U"'state" --> T"num" "num" []) --> bool) --> bool)),
   V"f2" ((U"'state" --> T"num" "num" [])),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"pda_size" "pdaDef"
    (((U"'isym" --> T"num" "num" []) -->
      ((U"'ssym" --> T"num" "num" []) -->
       ((U"'state" --> T"num" "num" []) -->
        (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
         T"num" "num" []))))),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   C"list_size" "list"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]] -->
       T"num" "num" []) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"num" "num" []))),
   C"pair_size" "basicSize"
    (((T"prod" "pair"
        [T"option" "option" [U"'isym"],
         T"prod" "pair" [U"'ssym", U"'state"]] --> T"num" "num" []) -->
      ((T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]] -->
        T"num" "num" []) -->
       (T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]] -->
        T"num" "num" [])))),
   C"pair_size" "basicSize"
    (((T"option" "option" [U"'isym"] --> T"num" "num" []) -->
      ((T"prod" "pair" [U"'ssym", U"'state"] --> T"num" "num" []) -->
       (T"prod" "pair"
         [T"option" "option" [U"'isym"],
          T"prod" "pair" [U"'ssym", U"'state"]] --> T"num" "num" [])))),
   C"option_size" "basicSize"
    (((U"'isym" --> T"num" "num" []) -->
      (T"option" "option" [U"'isym"] --> T"num" "num" []))),
   C"pair_size" "basicSize"
    (((U"'ssym" --> T"num" "num" []) -->
      ((U"'state" --> T"num" "num" []) -->
       (T"prod" "pair" [U"'ssym", U"'state"] --> T"num" "num" [])))),
   C"pair_size" "basicSize"
    (((U"'state" --> T"num" "num" []) -->
      ((T"list" "list" [U"'ssym"] --> T"num" "num" []) -->
       (T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]] -->
        T"num" "num" [])))),
   C"list_size" "list"
    (((U"'ssym" --> T"num" "num" []) -->
      (T"list" "list" [U"'ssym"] --> T"num" "num" []))),
   C"list_size" "list"
    (((U"'state" --> T"num" "num" []) -->
      (T"list" "list" [U"'state"] --> T"num" "num" []))), V"s" (U"'state"),
   V"s0" (U"'ssym"),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"l0" (T"list" "list" [U"'state"]),
   C"=" "min" ((U"'state" --> (U"'state" --> bool))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'state")),
   C"=" "min" ((U"'ssym" --> (U"'ssym" --> bool))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> U"'ssym")),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       bool))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])),
   C"=" "min"
    ((T"list" "list" [U"'state"] -->
      (T"list" "list" [U"'state"] --> bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      T"list" "list" [U"'state"])),
   C"!" "bool" ((((U"'state" --> U"'state") --> bool) --> bool)),
   V"f" ((U"'state" --> U"'state")),
   C"pda_start_fupd" "pdaDef"
    (((U"'state" --> U"'state") -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"!" "bool" ((((U"'ssym" --> U"'ssym") --> bool) --> bool)),
   V"f" ((U"'ssym" --> U"'ssym")),
   C"pda_ssSym_fupd" "pdaDef"
    (((U"'ssym" --> U"'ssym") -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"!" "bool"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
       bool) --> bool)),
   V"f"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])),
   C"pda_next_fupd" "pdaDef"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"!" "bool"
    ((((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
       bool) --> bool)),
   V"f" ((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"])),
   C"pda_final_fupd" "pdaDef"
    (((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
      (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]))),
   C"!" "bool"
    (((T"pda" "pdaDef" [U"'isym", alpha, beta] --> bool) --> bool)),
   V"p" (T"pda" "pdaDef" [U"'isym", alpha, beta]),
   C"=" "min" (((U"'isym" --> bool) --> ((U"'isym" --> bool) --> bool))),
   C"inpSyms" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", alpha, beta] --> (U"'isym" --> bool))),
   C"GSPEC" "pred_set"
    (((U"'isym" --> T"prod" "pair" [U"'isym", bool]) -->
      (U"'isym" --> bool))), V"isym" (U"'isym"),
   C"," "pair" ((U"'isym" --> (bool --> T"prod" "pair" [U"'isym", bool]))),
   C"?" "bool"
    (((T"prod" "pair" [beta, T"list" "list" [alpha]] --> bool) --> bool)),
   V"out" (T"prod" "pair" [beta, T"list" "list" [alpha]]),
   C"?" "bool" (((beta --> bool) --> bool)), V"q" (beta),
   C"?" "bool" (((alpha --> bool) --> bool)), V"ssym" (alpha),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
        T"prod" "pair" [beta, T"list" "list" [alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           T"prod" "pair" [beta, T"list" "list" [alpha]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]] -->
      (T"prod" "pair" [beta, T"list" "list" [alpha]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         T"prod" "pair" [beta, T"list" "list" [alpha]]]))),
   C"," "pair"
    ((T"option" "option" [U"'isym"] -->
      (T"prod" "pair" [alpha, beta] -->
       T"prod" "pair"
        [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]]))),
   C"SOME" "option" ((U"'isym" --> T"option" "option" [U"'isym"])),
   C"," "pair" ((alpha --> (beta --> T"prod" "pair" [alpha, beta]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", alpha, beta] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          T"prod" "pair" [beta, T"list" "list" [alpha]]]])),
   C"=" "min"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] --> T"list" "list" [U"'isym"]) -->
      ((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> T"list" "list" [U"'isym"]) --> bool))),
   C"inpSymsList" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          gamma]] --> T"list" "list" [U"'isym"])),
   C"WFREC" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> bool)) -->
      (((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [alpha, beta]], gamma]] -->
         T"list" "list" [U"'isym"]) -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [alpha, beta]], gamma]] -->
         T"list" "list" [U"'isym"])) -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> T"list" "list" [U"'isym"])))),
   C"@" "min"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [alpha, beta]], gamma]] --> bool)) --> bool)
      -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> bool)))),
   V"R"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          gamma]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] --> bool))),
   C"WF" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> bool)) --> bool)),
   C"!" "bool" (((gamma --> bool) --> bool)), V"out" (gamma),
   C"!" "bool" (((beta --> bool) --> bool)),
   C"!" "bool" (((alpha --> bool) --> bool)),
   C"!" "bool" (((U"'isym" --> bool) --> bool)),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] --> bool) --> bool)),
   V"rst"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma]]),
   C"CONS" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
        gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
           gamma]]))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]] -->
      (gamma -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma]))), C"NONE" "option" (T"option" "option" [U"'isym"]),
   V"inpSymsList"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          gamma]] --> T"list" "list" [U"'isym"])),
   V"a"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma]]),
   C"list_case" "list"
    ((T"list" "list" [U"'isym"] -->
      ((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          gamma] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [alpha, beta]], gamma]] -->
         T"list" "list" [U"'isym"])) -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> T"list" "list" [U"'isym"])))),
   C"I" "combin"
    ((T"list" "list" [U"'isym"] --> T"list" "list" [U"'isym"])),
   C"NIL" "list" (T"list" "list" [U"'isym"]),
   V"v"
    (T"prod" "pair"
      [T"prod" "pair"
        [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
       gamma]),
   C"pair_case" "pair"
    (((T"prod" "pair"
        [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]] -->
       (gamma --> T"list" "list" [U"'isym"])) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma] --> T"list" "list" [U"'isym"]))),
   V"v2"
    (T"prod" "pair"
      [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]]),
   C"pair_case" "pair"
    (((T"option" "option" [U"'isym"] -->
       (T"prod" "pair" [alpha, beta] --> T"list" "list" [U"'isym"])) -->
      (T"prod" "pair"
        [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]] -->
       T"list" "list" [U"'isym"]))), V"v4" (T"option" "option" [U"'isym"]),
   V"v5" (T"prod" "pair" [alpha, beta]),
   C"option_case" "option"
    ((T"list" "list" [U"'isym"] -->
      ((U"'isym" --> T"list" "list" [U"'isym"]) -->
       (T"option" "option" [U"'isym"] --> T"list" "list" [U"'isym"])))),
   C"pair_case" "pair"
    (((alpha --> (beta --> T"list" "list" [U"'isym"])) -->
      (T"prod" "pair" [alpha, beta] --> T"list" "list" [U"'isym"]))),
   V"ssym'" (alpha), V"q'" (beta),
   C"CONS" "list"
    ((U"'isym" -->
      (T"list" "list" [U"'isym"] --> T"list" "list" [U"'isym"]))),
   C"!" "bool"
    (((T"pda" "pdaDef" [alpha, U"'ssym", beta] --> bool) --> bool)),
   V"p" (T"pda" "pdaDef" [alpha, U"'ssym", beta]),
   C"=" "min" (((U"'ssym" --> bool) --> ((U"'ssym" --> bool) --> bool))),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [alpha, U"'ssym", beta] --> (U"'ssym" --> bool))),
   C"UNION" "pred_set"
    (((U"'ssym" --> bool) -->
      ((U"'ssym" --> bool) --> (U"'ssym" --> bool)))),
   C"INSERT" "pred_set"
    ((U"'ssym" --> ((U"'ssym" --> bool) --> (U"'ssym" --> bool)))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [alpha, U"'ssym", beta] --> U"'ssym")),
   C"EMPTY" "pred_set" ((U"'ssym" --> bool)),
   C"GSPEC" "pred_set"
    (((U"'ssym" --> T"prod" "pair" [U"'ssym", bool]) -->
      (U"'ssym" --> bool))), V"ssym" (U"'ssym"),
   C"," "pair" ((U"'ssym" --> (bool --> T"prod" "pair" [U"'ssym", bool]))),
   C"?" "bool"
    (((T"prod" "pair" [beta, T"list" "list" [U"'ssym"]] --> bool) -->
      bool)), V"out" (T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]),
   C"?" "bool" (((T"option" "option" [alpha] --> bool) --> bool)),
   V"isym" (T"option" "option" [alpha]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]],
        T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]],
           T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]] -->
      (T"prod" "pair" [beta, T"list" "list" [U"'ssym"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]],
         T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair" [U"'ssym", beta] -->
       T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]]))),
   C"," "pair" ((U"'ssym" --> (beta --> T"prod" "pair" [U"'ssym", beta]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, U"'ssym", beta] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [U"'ssym", beta]],
          T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]]])),
   C"BIGUNION" "pred_set"
    ((((U"'ssym" --> bool) --> bool) --> (U"'ssym" --> bool))),
   C"GSPEC" "pred_set"
    (((T"list" "list" [U"'ssym"] -->
       T"prod" "pair" [(U"'ssym" --> bool), bool]) -->
      ((U"'ssym" --> bool) --> bool))),
   V"ssyms" (T"list" "list" [U"'ssym"]),
   C"," "pair"
    (((U"'ssym" --> bool) -->
      (bool --> T"prod" "pair" [(U"'ssym" --> bool), bool]))),
   C"LIST_TO_SET" "list"
    ((T"list" "list" [U"'ssym"] --> (U"'ssym" --> bool))),
   C"," "pair"
    ((beta -->
      (T"list" "list" [U"'ssym"] -->
       T"prod" "pair" [beta, T"list" "list" [U"'ssym"]]))),
   C"=" "min"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
       T"list" "list" [alpha]) -->
      ((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
        T"list" "list" [alpha]) --> bool))),
   C"stkSymsList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
      T"list" "list" [alpha])),
   C"WFREC" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool)) -->
      (((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
             T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
         T"list" "list" [alpha]) -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
             T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
         T"list" "list" [alpha])) -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
        T"list" "list" [alpha])))),
   C"@" "min"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
             T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool))
       --> bool) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool)))),
   V"R"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool))),
   C"WF" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool)) -->
      bool)), C"!" "bool" (((T"list" "list" [alpha] --> bool) --> bool)),
   V"ssyms" (T"list" "list" [alpha]),
   C"!" "bool" (((delta --> bool) --> bool)), V"q'" (delta), V"q" (gamma),
   V"isym" (beta),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool) -->
      bool)),
   V"rst"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]]]),
   C"CONS" "list"
    ((T"prod" "pair"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
        T"prod" "pair" [delta, T"list" "list" [alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [delta, T"list" "list" [alpha]]]]))),
   C"," "pair"
    ((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] -->
      (T"prod" "pair" [delta, T"list" "list" [alpha]] -->
       T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]]))),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [alpha, gamma] -->
       T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]]))),
   C"," "pair" ((alpha --> (gamma --> T"prod" "pair" [alpha, gamma]))),
   C"," "pair"
    ((delta -->
      (T"list" "list" [alpha] -->
       T"prod" "pair" [delta, T"list" "list" [alpha]]))),
   V"stkSymsList'"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
      T"list" "list" [alpha])),
   V"a"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]]]),
   C"list_case" "list"
    ((T"list" "list" [alpha] -->
      ((T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [delta, T"list" "list" [alpha]]] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
             T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
         T"list" "list" [alpha])) -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] -->
        T"list" "list" [alpha])))),
   C"I" "combin" ((T"list" "list" [alpha] --> T"list" "list" [alpha])),
   C"NIL" "list" (T"list" "list" [alpha]),
   V"v"
    (T"prod" "pair"
      [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
       T"prod" "pair" [delta, T"list" "list" [alpha]]]),
   C"pair_case" "pair"
    (((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] -->
       (T"prod" "pair" [delta, T"list" "list" [alpha]] -->
        T"list" "list" [alpha])) -->
      (T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]] -->
       T"list" "list" [alpha]))),
   V"v2" (T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]]),
   V"v3" (T"prod" "pair" [delta, T"list" "list" [alpha]]),
   C"pair_case" "pair"
    (((beta --> (T"prod" "pair" [alpha, gamma] --> T"list" "list" [alpha]))
      -->
      (T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] -->
       T"list" "list" [alpha]))), V"v5" (T"prod" "pair" [alpha, gamma]),
   C"pair_case" "pair"
    (((alpha --> (gamma --> T"list" "list" [alpha])) -->
      (T"prod" "pair" [alpha, gamma] --> T"list" "list" [alpha]))),
   C"pair_case" "pair"
    (((delta --> (T"list" "list" [alpha] --> T"list" "list" [alpha])) -->
      (T"prod" "pair" [delta, T"list" "list" [alpha]] -->
       T"list" "list" [alpha]))),
   C"APPEND" "list"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"CONS" "list"
    ((alpha --> (T"list" "list" [alpha] --> T"list" "list" [alpha]))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'ssym", delta]],
           T"prod" "pair" [U"'e", T"list" "list" [U"'ssym"]]]] --> bool)
      --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'ssym", delta]],
         T"prod" "pair" [U"'e", T"list" "list" [U"'ssym"]]]]),
   C"=" "min"
    ((T"list" "list" [U"'ssym"] --> (T"list" "list" [U"'ssym"] --> bool))),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [alpha, U"'ssym", beta] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'ssym", delta]],
           T"prod" "pair" [U"'e", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list" [U"'ssym"]))),
   C"APPEND" "list"
    ((T"list" "list" [U"'ssym"] -->
      (T"list" "list" [U"'ssym"] --> T"list" "list" [U"'ssym"]))),
   C"CONS" "list"
    ((U"'ssym" -->
      (T"list" "list" [U"'ssym"] --> T"list" "list" [U"'ssym"]))),
   C"NIL" "list" (T"list" "list" [U"'ssym"]),
   C"stkSymsList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'ssym", delta]],
          T"prod" "pair" [U"'e", T"list" "list" [U"'ssym"]]]] -->
      T"list" "list" [U"'ssym"])),
   C"!" "bool"
    (((T"pda" "pdaDef" [alpha, beta, U"'state"] --> bool) --> bool)),
   V"p" (T"pda" "pdaDef" [alpha, beta, U"'state"]),
   C"=" "min" (((U"'state" --> bool) --> ((U"'state" --> bool) --> bool))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, U"'state"] --> (U"'state" --> bool))),
   C"UNION" "pred_set"
    (((U"'state" --> bool) -->
      ((U"'state" --> bool) --> (U"'state" --> bool)))),
   C"INSERT" "pred_set"
    ((U"'state" --> ((U"'state" --> bool) --> (U"'state" --> bool)))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, U"'state"] --> U"'state")),
   C"EMPTY" "pred_set" ((U"'state" --> bool)),
   C"LIST_TO_SET" "list"
    ((T"list" "list" [U"'state"] --> (U"'state" --> bool))),
   C"pda_final" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, U"'state"] -->
      T"list" "list" [U"'state"])),
   C"GSPEC" "pred_set"
    (((U"'state" --> T"prod" "pair" [U"'state", bool]) -->
      (U"'state" --> bool))), V"q" (U"'state"),
   C"," "pair"
    ((U"'state" --> (bool --> T"prod" "pair" [U"'state", bool]))),
   C"?" "bool"
    (((T"prod" "pair" [U"'state", T"list" "list" [beta]] --> bool) -->
      bool)), V"out" (T"prod" "pair" [U"'state", T"list" "list" [beta]]),
   V"ssym" (beta),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]],
        T"prod" "pair" [U"'state", T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]] -->
      (T"prod" "pair" [U"'state", T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair" [beta, U"'state"] -->
       T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]]))),
   C"," "pair"
    ((beta --> (U"'state" --> T"prod" "pair" [beta, U"'state"]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, U"'state"] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [beta]]]])),
   V"q'" (U"'state"),
   C"?" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"ssyms" (T"list" "list" [beta]),
   C"," "pair"
    ((U"'state" -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [U"'state", T"list" "list" [beta]]))),
   C"=" "min"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha]) -->
      ((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha]) -->
       bool))),
   C"statesList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha])),
   C"WFREC" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> bool)) -->
      (((T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
             T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha])
        -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
             T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha]))
       -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha])))),
   C"@" "min"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
             T"prod" "pair" [alpha, delta]]] --> bool)) --> bool) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> bool)))),
   V"R"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, delta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] --> bool))),
   C"WF" "relation"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> bool)) --> bool)),
   V"ssyms" (delta), V"q'" (alpha), V"q" (alpha), V"ssym" (gamma),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] --> bool) --> bool)),
   V"rst"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]]]),
   C"CONS" "list"
    ((T"prod" "pair"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
        T"prod" "pair" [alpha, delta]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, delta]]]))),
   C"," "pair"
    ((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] -->
      (T"prod" "pair" [alpha, delta] -->
       T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]]))),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]))),
   C"," "pair" ((gamma --> (alpha --> T"prod" "pair" [gamma, alpha]))),
   C"," "pair" ((alpha --> (delta --> T"prod" "pair" [alpha, delta]))),
   V"statesList'"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha])),
   V"a"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]]]),
   C"list_case" "list"
    ((T"list" "list" [alpha] -->
      ((T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, delta]] -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
             T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha]))
       -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> T"list" "list" [alpha])))),
   V"v"
    (T"prod" "pair"
      [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
       T"prod" "pair" [alpha, delta]]),
   C"pair_case" "pair"
    (((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] -->
       (T"prod" "pair" [alpha, delta] --> T"list" "list" [alpha])) -->
      (T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]] --> T"list" "list" [alpha]))),
   V"v2" (T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]),
   V"v3" (T"prod" "pair" [alpha, delta]),
   C"pair_case" "pair"
    (((beta --> (T"prod" "pair" [gamma, alpha] --> T"list" "list" [alpha]))
      -->
      (T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] -->
       T"list" "list" [alpha]))), V"v5" (T"prod" "pair" [gamma, alpha]),
   C"pair_case" "pair"
    (((gamma --> (alpha --> T"list" "list" [alpha])) -->
      (T"prod" "pair" [gamma, alpha] --> T"list" "list" [alpha]))),
   C"pair_case" "pair"
    (((alpha --> (delta --> T"list" "list" [alpha])) -->
      (T"prod" "pair" [alpha, delta] --> T"list" "list" [alpha]))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"prod" "pair" [delta, U"'state"]],
           T"prod" "pair" [U"'state", U"'e"]]] --> bool) --> bool)),
   V"d"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [gamma, T"prod" "pair" [delta, U"'state"]],
         T"prod" "pair" [U"'state", U"'e"]]]),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, U"'state"] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [gamma, T"prod" "pair" [delta, U"'state"]],
           T"prod" "pair" [U"'state", U"'e"]]] -->
       T"list" "list" [U"'state"]))),
   C"APPEND" "list"
    ((T"list" "list" [U"'state"] -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"CONS" "list"
    ((U"'state" -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"statesList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [gamma, T"prod" "pair" [delta, U"'state"]],
          T"prod" "pair" [U"'state", U"'e"]]] -->
      T"list" "list" [U"'state"])), V"state" (beta), V"inp" (gamma),
   V"stk" (alpha),
   C"pdastk" "pdaDef"
    ((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] --> alpha)),
   V"inp" (alpha), V"stk" (gamma),
   C"pdainp" "pdaDef"
    ((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] --> alpha)),
   V"state" (alpha), V"inp" (beta),
   C"pdastate" "pdaDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> alpha)),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]]))),
   C"," "pair" ((beta --> (gamma --> T"prod" "pair" [beta, gamma]))),
   C"=" "min"
    (((T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] --> bool)
      -->
      ((T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] --> bool)
       --> bool))),
   C"ID_tupled" "pdaDef"
    ((T"prod" "pair"
       [T"pda" "pdaDef" [alpha, beta, gamma],
        T"prod" "pair"
         [T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]],
          T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]]]] --> bool)),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
       (T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
        bool)) -->
      (((T"prod" "pair"
          [T"pda" "pdaDef" [alpha, beta, gamma],
           T"prod" "pair"
            [T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]],
             T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
         bool) -->
        (T"prod" "pair"
          [T"pda" "pdaDef" [alpha, beta, gamma],
           T"prod" "pair"
            [T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]],
             T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
         bool)) -->
       (T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
        bool)))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
        (T"prod" "pair"
          [T"pda" "pdaDef" [alpha, beta, gamma],
           T"prod" "pair"
            [T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]],
             T"prod" "pair"
              [gamma,
               T"prod" "pair"
                [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
         bool)) --> bool) -->
      (T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
       (T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
        bool)))),
   V"R"
    ((T"prod" "pair"
       [T"pda" "pdaDef" [alpha, beta, gamma],
        T"prod" "pair"
         [T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]],
          T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
      (T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
       bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
       (T"prod" "pair"
         [T"pda" "pdaDef" [alpha, beta, gamma],
          T"prod" "pair"
           [T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]],
            T"prod" "pair"
             [gamma,
              T"prod" "pair"
               [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
        bool)) --> bool)),
   V"ID_tupled"
    ((T"prod" "pair"
       [T"pda" "pdaDef" [alpha, beta, gamma],
        T"prod" "pair"
         [T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]],
          T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]]]] --> bool)),
   V"a"
    (T"prod" "pair"
      [T"pda" "pdaDef" [alpha, beta, gamma],
       T"prod" "pair"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]],
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [T"list" "list" [alpha], T"list" "list" [beta]]]]]),
   C"pair_case" "pair"
    (((T"pda" "pdaDef" [alpha, beta, gamma] -->
       (T"prod" "pair"
         [T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]],
          T"prod" "pair"
           [gamma,
            T"prod" "pair"
             [T"list" "list" [alpha], T"list" "list" [beta]]]] --> bool))
      -->
      (T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]] -->
       bool))), V"p" (T"pda" "pdaDef" [alpha, beta, gamma]),
   V"v1"
    (T"prod" "pair"
      [T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]],
       T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]),
   C"pair_case" "pair"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)) -->
      (T"prod" "pair"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]],
         T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       --> bool))),
   V"v2"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   V"v3"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   C"pair_case" "pair"
    (((gamma -->
       (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
        bool)) -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       --> bool))),
   V"v5" (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]),
   C"pair_case" "pair"
    (((T"list" "list" [alpha] --> (T"list" "list" [beta] --> bool)) -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
       bool))), V"v6" (T"list" "list" [alpha]),
   V"v7" (T"list" "list" [beta]),
   C"list_case" "list"
    ((bool -->
      ((alpha --> (T"list" "list" [alpha] --> bool)) -->
       (T"list" "list" [alpha] --> bool)))),
   C"list_case" "list"
    ((bool -->
      ((beta --> (T"list" "list" [beta] --> bool)) -->
       (T"list" "list" [beta] --> bool)))),
   C"I" "combin" ((bool --> bool)), C"F" "bool" (bool),
   V"srst" (T"list" "list" [beta]), V"q'" (gamma),
   V"v15" (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]),
   V"inp'" (T"list" "list" [alpha]), V"ssyms'" (T"list" "list" [beta]),
   C"=" "min"
    ((T"list" "list" [alpha] --> (T"list" "list" [alpha] --> bool))),
   V"sl" (T"list" "list" [beta]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [alpha] -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair"
        [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]]))),
   C"NONE" "option" (T"option" "option" [alpha]),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [gamma, T"list" "list" [beta]]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   C"=" "min"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   C"APPEND" "list"
    ((T"list" "list" [beta] -->
      (T"list" "list" [beta] --> T"list" "list" [beta]))),
   V"irst" (T"list" "list" [alpha]), V"ssym'" (beta),
   V"srst'" (T"list" "list" [beta]), V"q''" (gamma),
   V"v21" (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]),
   V"inp''" (T"list" "list" [alpha]), V"ssyms''" (T"list" "list" [beta]),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"SOME" "option" ((alpha --> T"option" "option" [alpha])),
   C"!" "bool"
    (((T"pda" "pdaDef" [alpha, beta, gamma] --> bool) --> bool)),
   V"x" (T"pda" "pdaDef" [alpha, beta, gamma]),
   C"!" "bool"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       --> bool) --> bool)),
   V"x1"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   V"x2"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   C"," "pair"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]],
         T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]]
       -->
       T"prod" "pair"
        [T"pda" "pdaDef" [alpha, beta, gamma],
         T"prod" "pair"
          [T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]],
           T"prod" "pair"
            [gamma,
             T"prod" "pair"
              [T"list" "list" [alpha], T"list" "list" [beta]]]]]))),
   C"," "pair"
    ((T"prod" "pair"
       [gamma,
        T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       T"prod" "pair"
        [T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]],
         T"prod" "pair"
          [gamma,
           T"prod" "pair"
            [T"list" "list" [alpha], T"list" "list" [beta]]]]))),
   V"s1"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   V"s2"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   C"RTC" "relation"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)) -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   V"p" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"=" "min"
    (((T"list" "list" [U"'isym"] --> bool) -->
      ((T"list" "list" [U"'isym"] --> bool) --> bool))),
   C"lafs" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list" [U"'isym"] --> bool))),
   C"GSPEC" "pred_set"
    (((T"list" "list" [U"'isym"] -->
       T"prod" "pair" [T"list" "list" [U"'isym"], bool]) -->
      (T"list" "list" [U"'isym"] --> bool))),
   V"w" (T"list" "list" [U"'isym"]),
   C"," "pair"
    ((T"list" "list" [U"'isym"] -->
      (bool --> T"prod" "pair" [T"list" "list" [U"'isym"], bool]))),
   V"state" (U"'state"),
   C"?" "bool" (((T"list" "list" [U"'ssym"] --> bool) --> bool)),
   V"stack" (T"list" "list" [U"'ssym"]),
   C"IDC" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [T"list" "list" [U"'isym"], T"list" "list" [U"'ssym"]]] -->
       (T"prod" "pair"
         [U"'state",
          T"prod" "pair"
           [T"list" "list" [U"'isym"], T"list" "list" [U"'ssym"]]] -->
        bool)))),
   C"," "pair"
    ((U"'state" -->
      (T"prod" "pair"
        [T"list" "list" [U"'isym"], T"list" "list" [U"'ssym"]] -->
       T"prod" "pair"
        [U"'state",
         T"prod" "pair"
          [T"list" "list" [U"'isym"], T"list" "list" [U"'ssym"]]]))),
   C"," "pair"
    ((T"list" "list" [U"'isym"] -->
      (T"list" "list" [U"'ssym"] -->
       T"prod" "pair"
        [T"list" "list" [U"'isym"], T"list" "list" [U"'ssym"]]))),
   C"MEM" "list" ((U"'state" --> (T"list" "list" [U"'state"] --> bool))),
   C"laes" "pdaDef"
    ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
      (T"list" "list" [U"'isym"] --> bool))),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"list" "list" [gamma]]] --> bool)
      --> bool)),
   V"e"
    (T"prod" "pair"
      [alpha, T"prod" "pair" [beta, T"list" "list" [gamma]]]),
   C"stkLen" "pdaDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, T"list" "list" [gamma]]]
      --> T"num" "num" [])),
   C"LENGTH" "list" ((T"list" "list" [gamma] --> T"num" "num" [])),
   C"pdastk" "pdaDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, T"list" "list" [gamma]]]
      --> T"list" "list" [gamma])), V"g" ((U"'state" --> U"'state")),
   C"o" "combin"
    (((U"'state" --> U"'state") -->
      ((U"'state" --> U"'state") --> (U"'state" --> U"'state")))),
   V"g" ((U"'ssym" --> U"'ssym")),
   C"o" "combin"
    (((U"'ssym" --> U"'ssym") -->
      ((U"'ssym" --> U"'ssym") --> (U"'ssym" --> U"'ssym")))),
   V"g"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])),
   C"o" "combin"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
      ((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]) -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]])))),
   V"g" ((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"])),
   C"o" "combin"
    (((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
      ((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
       (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"])))),
   C"=" "min"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
      ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
        T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) --> bool))),
   C"o" "combin"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
      ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
        T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
       (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
        T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
   C"!" "bool"
    ((((alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
       bool) --> bool)),
   V"h" ((alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])),
   C"=" "min"
    (((alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
      ((alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
       bool))),
   C"o" "combin"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] -->
       T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
      ((alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]) -->
       (alpha --> T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"])))),
   V"p1" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   V"p2" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   V"s0" (U"'state"), V"s" (U"'ssym"),
   V"l0"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"l" (T"list" "list" [U"'state"]),
   C"K" "combin" ((U"'state" --> (U"'state" --> U"'state"))),
   C"K" "combin" ((U"'ssym" --> (U"'ssym" --> U"'ssym"))),
   C"K" "combin"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"],
            T"prod" "pair" [U"'ssym", U"'state"]],
          T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'isym"],
             T"prod" "pair" [U"'ssym", U"'state"]],
           T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]))),
   C"K" "combin"
    ((T"list" "list" [U"'state"] -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"ARB" "bool" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"!" "bool"
    ((((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool) --> bool)
      --> bool)),
   V"P" ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool)),
   C"?" "bool"
    (((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> bool) -->
      bool)), V"s01" (U"'state"), V"s1" (U"'ssym"),
   V"l01"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"l1" (T"list" "list" [U"'state"]), V"s02" (U"'state"),
   V"s2" (U"'ssym"),
   V"l02"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"l2" (T"list" "list" [U"'state"]),
   C"DATATYPE" "bool" ((bool --> bool)),
   V"record"
    ((ind -->
      (U"'state" -->
       (U"'ssym" -->
        (T"list" "list"
          [T"prod" "pair"
            [T"prod" "pair"
              [T"option" "option" [U"'isym"],
               T"prod" "pair" [U"'ssym", U"'state"]],
             T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
         (T"list" "list" [U"'state"] --> bool)))))), V"pda" (ind),
   V"start" (U"'state"), V"ssSym" (U"'ssym"),
   V"next"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"final" (T"list" "list" [U"'state"]), V"a0'" (U"'state"),
   V"a1'" (U"'ssym"),
   V"a2'"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"],
           T"prod" "pair" [U"'ssym", U"'state"]],
         T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]]),
   V"a3'" (T"list" "list" [U"'state"]),
   V"M" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   V"M'" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   V"f'"
    ((U"'state" -->
      (U"'ssym" -->
       (T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"],
              T"prod" "pair" [U"'ssym", U"'state"]],
            T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]]] -->
        (T"list" "list" [U"'state"] --> alpha))))),
   V"pp" (T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"]),
   C"?" "bool"
    ((((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> alpha) -->
       bool) --> bool)),
   V"fn" ((T"pda" "pdaDef" [U"'isym", U"'ssym", U"'state"] --> alpha)),
   C"!" "bool"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
            gamma]] --> bool) --> bool) --> bool)),
   V"P"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
          gamma]] --> bool)),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma]]),
   V"v"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'isym"], T"prod" "pair" [alpha, beta]],
         gamma]]),
   C"=" "min"
    ((T"list" "list" [U"'isym"] --> (T"list" "list" [U"'isym"] --> bool))),
   C"!" "bool"
    ((((T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
          T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]] --> bool) -->
       bool) --> bool)),
   V"P"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
        T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]] --> bool)),
   C"!" "bool"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
         T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]] --> bool) -->
      bool)),
   V"t"
    (T"prod" "pair"
      [T"prod" "pair"
        [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
       T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]]),
   C"!" "bool" (((T"option" "option" [U"'is"] --> bool) --> bool)),
   V"isopt" (T"option" "option" [U"'is"]),
   C"!" "bool" (((U"'ss" --> bool) --> bool)), V"ss" (U"'ss"),
   C"!" "bool" (((U"'st" --> bool) --> bool)), V"st" (U"'st"),
   V"st'" (U"'st"),
   C"!" "bool" (((T"list" "list" [U"'ss"] --> bool) --> bool)),
   V"syms" (T"list" "list" [U"'ss"]),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]] -->
      (T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
         T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]]))),
   C"," "pair"
    ((T"option" "option" [U"'is"] -->
      (T"prod" "pair" [U"'ss", U"'st"] -->
       T"prod" "pair"
        [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]]))),
   C"," "pair" ((U"'ss" --> (U"'st" --> T"prod" "pair" [U"'ss", U"'st"]))),
   C"," "pair"
    ((U"'st" -->
      (T"list" "list" [U"'ss"] -->
       T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]))),
   C"?" "bool"
    (((T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [U"'is"], T"prod" "pair" [U"'ss", U"'st"]],
         T"prod" "pair" [U"'st", T"list" "list" [U"'ss"]]] --> bool) -->
      bool)),
   C"?" "bool" (((T"option" "option" [U"'is"] --> bool) --> bool)),
   C"?" "bool" (((U"'ss" --> bool) --> bool)),
   C"?" "bool" (((U"'st" --> bool) --> bool)),
   C"?" "bool" (((T"list" "list" [U"'ss"] --> bool) --> bool)),
   C"=" "min" (((alpha --> bool) --> ((alpha --> bool) --> bool))),
   C"inpSyms" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (alpha --> bool))),
   C"LIST_TO_SET" "list" ((T"list" "list" [alpha] --> (alpha --> bool))),
   C"inpSymsList" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
      T"list" "list" [alpha])),
   C"!" "bool"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
            T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool) -->
       bool) --> bool)),
   V"P"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [delta, T"list" "list" [alpha]]]] --> bool)),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]]]),
   V"v"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]],
         T"prod" "pair" [delta, T"list" "list" [alpha]]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]] --> bool) -->
      bool)),
   V"l1"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [beta]]]]),
   V"l2"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [beta]]]]),
   C"stkSymsList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [delta, T"list" "list" [beta]]]] -->
      T"list" "list" [beta])),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [delta, T"list" "list" [beta]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]]))),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [beta]]]]),
   C"MEM" "list" ((beta --> (T"list" "list" [beta] --> bool))),
   V"isym" (alpha), C"?" "bool" (((gamma --> bool) --> bool)),
   C"?" "bool" (((delta --> bool) --> bool)),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [delta, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [delta, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [delta, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [delta, T"list" "list" [beta]]]))),
   C"," "pair"
    ((delta -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [delta, T"list" "list" [beta]]))), V"x" (beta),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] --> (alpha --> bool))),
   V"p" (T"pda" "pdaDef" [beta, alpha, gamma]),
   C"stkSymsList" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [alpha]]]] -->
       T"list" "list" [alpha]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, alpha, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [alpha, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [alpha]]]])),
   C"!" "bool"
    ((((T"list" "list"
         [T"prod" "pair"
           [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
            T"prod" "pair" [alpha, delta]]] --> bool) --> bool) --> bool)),
   V"P"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, delta]]] --> bool)),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]]]),
   V"v"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, delta]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, delta]]] --> bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, delta]]]),
   C"MEM" "list" ((gamma --> (T"list" "list" [gamma] --> bool))),
   C"statesList'" "pdaDef"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, delta]]] --> T"list" "list" [gamma])),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
        T"prod" "pair" [gamma, delta]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, delta]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, delta]]))),
   C"," "pair" ((gamma --> (delta --> T"prod" "pair" [gamma, delta]))),
   V"p1"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, delta]]]),
   V"p2"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
         T"prod" "pair" [gamma, delta]]]),
   C"=" "min"
    ((T"list" "list" [gamma] --> (T"list" "list" [gamma] --> bool))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, delta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, delta]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, delta]]]))),
   C"APPEND" "list"
    ((T"list" "list" [gamma] -->
      (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> (alpha --> bool))),
   V"p" (T"pda" "pdaDef" [beta, gamma, alpha]),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] -->
       T"list" "list" [alpha]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [gamma]]]])),
   C"FINITE" "pred_set" (((alpha --> bool) --> bool)),
   C"FINITE" "pred_set" (((beta --> bool) --> bool)),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (beta --> bool))),
   C"FINITE" "pred_set" (((gamma --> bool) --> bool)),
   C"states" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] --> (gamma --> bool))),
   C"!" "bool"
    ((((T"pda" "pdaDef" [alpha, beta, gamma] -->
        (T"prod" "pair"
          [gamma,
           T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
         -->
         (T"prod" "pair"
           [gamma,
            T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
          --> bool))) --> bool) --> bool)),
   V"P"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]
        --> bool)))),
   V"y"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]] -->
       T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [alpha], T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"list" "list" [alpha] -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]))),
   C"NIL" "list" (T"list" "list" [beta]), V"v8" (alpha),
   V"v9" (T"list" "list" [alpha]),
   C"!" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   C"CONS" "list"
    ((beta --> (T"list" "list" [beta] --> T"list" "list" [beta]))),
   V"v" (T"pda" "pdaDef" [alpha, beta, gamma]), V"v1" (gamma),
   V"v2" (T"list" "list" [alpha]), V"v3" (T"list" "list" [beta]),
   V"v4"
    (T"prod" "pair"
      [gamma,
       T"prod" "pair" [T"list" "list" [alpha], T"list" "list" [beta]]]),
   C"!" "bool" ((((U"'ssym" --> bool) --> bool) --> bool)),
   V"s" ((U"'ssym" --> bool)),
   C"INFINITE" "pred_set" (((U"'ssym" --> bool) --> bool)),
   C"UNIV" "pred_set" ((U"'ssym" --> bool)),
   C"FINITE" "pred_set" (((U"'ssym" --> bool) --> bool)), V"x" (U"'ssym"),
   C"~" "bool" ((bool --> bool)),
   C"IN" "bool" ((U"'ssym" --> ((U"'ssym" --> bool) --> bool))),
   C"!" "bool" ((((U"'state" --> bool) --> bool) --> bool)),
   V"s" ((U"'state" --> bool)),
   C"INFINITE" "pred_set" (((U"'state" --> bool) --> bool)),
   C"UNIV" "pred_set" ((U"'state" --> bool)),
   C"FINITE" "pred_set" (((U"'state" --> bool) --> bool)),
   V"x" (U"'state"),
   C"IN" "bool" ((U"'state" --> ((U"'state" --> bool) --> bool))),
   V"x" (T"option" "option" [alpha]), V"h" (beta), V"st" (gamma),
   V"m" (T"pda" "pdaDef" [alpha, beta, gamma]),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"list" "list" [gamma]))), V"inp" (T"list" "list" [alpha]),
   V"stk" (T"list" "list" [beta]), V"st'" (gamma),
   V"stk'" (T"list" "list" [beta]),
   C"=" "min" ((gamma --> (gamma --> bool))),
   V"x" (T"list" "list" [alpha]), V"x'" (T"list" "list" [alpha]),
   V"l" (T"list" "list" [beta]),
   C"RTC" "relation"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [beta, gamma, alpha]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]))),
   V"x" (T"list" "list" [beta]), V"stk" (T"list" "list" [gamma]),
   V"x'" (T"list" "list" [beta]), V"stk'" (T"list" "list" [gamma]),
   C"!" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"l" (T"list" "list" [gamma]), V"i" (T"list" "list" [beta]),
   V"p" (T"list" "list" [gamma]), V"sym" (gamma),
   V"s" (T"list" "list" [gamma]), V"i'" (T"list" "list" [beta]),
   C"CONS" "list"
    ((gamma --> (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"NIL" "list" (T"list" "list" [gamma]),
   C"IN" "bool" ((gamma --> ((gamma --> bool) --> bool))),
   C"stkSyms" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] --> (gamma --> bool))),
   C"?" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"p'" (T"list" "list" [gamma]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))),
   C"?" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool) --> bool)),
   V"l'"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   V"l" (T"list" "list" [alpha]), V"q0" (gamma),
   V"i0" (T"list" "list" [alpha]), V"s0" (T"list" "list" [beta]),
   V"i" (T"list" "list" [alpha]), V"s" (T"list" "list" [beta]),
   V"sh" (beta), V"st" (T"list" "list" [beta]),
   V"st'" (T"list" "list" [beta]), V"ih" (alpha),
   V"s'" (T"list" "list" [gamma]),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"<=" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list" ((T"list" "list" [beta] --> T"num" "num" [])),
   V"ipfx" (T"list" "list" [beta]), V"isfx" (T"list" "list" [beta]),
   V"spfx" (T"list" "list" [gamma]), V"ssfx" (T"list" "list" [gamma]),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool) --> bool)),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))),
   C"FRONT" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [beta], T"list" "list" [gamma]]]])),
   C"pdastk" "pdaDef"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      T"list" "list" [gamma])), V"inp" (T"list" "list" [beta]),
   V"inp'" (T"list" "list" [beta]), V"p" (T"list" "list" [beta]),
   C"isSuffix" "listLemmas"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   V"r" (beta), V"rst" (T"list" "list" [gamma]),
   V"r'" (T"list" "list" [gamma]), V"h" (gamma),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [delta], T"list" "list" [gamma]]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [delta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
        --> bool)))), V"p" (T"pda" "pdaDef" [delta, gamma, alpha]),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [delta], T"list" "list" [gamma]]]]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [delta], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"list" "list" [delta] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]))),
   C"NIL" "list" (T"list" "list" [delta]),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
       --> bool) --> bool)),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [delta], T"list" "list" [gamma]]]] --> bool))),
   C"pdastk" "pdaDef"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [delta], T"list" "list" [gamma]]]
      --> T"list" "list" [gamma])), V"i0" (T"list" "list" [beta]),
   V"isfx" (gamma),
   C"!" "bool" (((T"list" "list" [delta] --> bool) --> bool)),
   V"r0" (T"list" "list" [delta]),
   C"!" "bool" (((U"'e" --> bool) --> bool)), V"rst" (U"'e"),
   V"r'" (T"list" "list" [delta]), V"rst" (T"list" "list" [delta]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, delta, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
        --> bool)))), V"p" (T"pda" "pdaDef" [beta, delta, alpha]),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [delta]]]))),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [delta] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]))),
   C"APPEND" "list"
    ((T"list" "list" [delta] -->
      (T"list" "list" [delta] --> T"list" "list" [delta]))),
   C"=" "min"
    ((T"list" "list" [delta] --> (T"list" "list" [delta] --> bool))),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]
       --> bool) --> bool)),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]]
       --> bool))),
   C"LENGTH" "list" ((T"list" "list" [delta] --> T"num" "num" [])),
   C"pdastk" "pdaDef"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]] -->
      T"list" "list" [delta])),
   C"?" "bool" (((T"list" "list" [delta] --> bool) --> bool)),
   V"p" (T"list" "list" [delta]),
   C"FRONT" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [delta]]]]
      -->
      T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [beta], T"list" "list" [delta]]]])),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      --> T"num" "num" [])), V"f" ((alpha --> T"num" "num" [])),
   C"LAST" "list" ((T"list" "list" [alpha] --> alpha)),
   C"!" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"i" (T"num" "num" []),
   C"<" "prim_rec" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list" ((T"list" "list" [alpha] --> T"num" "num" [])),
   C"EL" "list" ((T"num" "num" [] --> (T"list" "list" [alpha] --> alpha))),
   C"HD" "list" ((T"list" "list" [alpha] --> alpha)),
   C"?" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"j" (T"num" "num" []),
   C"stkLen" "pdaDef"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      T"num" "num" [])),
   C"EL" "list"
    ((T"num" "num" [] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   C"rtc2list" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))),
   C"CONS" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"list" "list" [gamma]]]]))),
   V"t"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       --> bool))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   V"qx" (alpha), V"ix" (T"list" "list" [beta]),
   V"sx" (T"list" "list" [gamma]),
   C"TL" "list" ((T"list" "list" [gamma] --> T"list" "list" [gamma])),
   V"q0" (alpha), V"s0" (T"list" "list" [gamma]), V"spfx" (delta),
   V"stk0" (T"list" "list" [gamma]), V"stk1" (T"list" "list" [gamma]),
   V"s0'" (T"list" "list" [gamma]),
   C"HD" "list" ((T"list" "list" [gamma] --> gamma)),
   C"-" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   V"qf" (alpha),
   V"dl0"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   V"dl1"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"=" "min"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       --> bool))),
   V"x"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   V"y"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"pdastate" "pdaDef"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]] -->
      alpha)),
   C"LAST" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      -->
      T"prod" "pair"
       [alpha,
        T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]))]
  val DT = Thm.disk_thm share_table
  in
  val pda_TY_DEF =
    DT(["DISK_THM"], [],
       `(%0 (\%1. ((%2 (\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 (%8 (\%9. (%10
       (\%11. (%12 (\%13. (%14 (\%15. ((%16 $4) (((((\%9. (\%11. (\%13.
       (\%15. (((%17 %18) ((%19 $3) ((%20 $2) ((%21 $1) $0)))) (\%22.
       %23)))))) $3) $2) $1) $0))))))))))) ($1 $0))))) ($0 $1)))))) $0)))`)
  val pda_repfns =
    DT(["DISK_THM"], [],
       `((%24 (%25 (\%26. ((%27 (%28 (%29 $0))) $0)))) (%7 (\%30. ((%31
       ((\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 (%8 (\%9. (%10 (\%11. (%12
       (\%13. (%14 (\%15. ((%16 $4) (((((\%9. (\%11. (\%13. (\%15. (((%17
       %18) ((%19 $3) ((%20 $2) ((%21 $1) $0)))) (\%22. %23)))))) $3) $2)
       $1) $0))))))))))) ($1 $0))))) ($0 $1))))) $0)) ((%16 (%29 (%28 $0)))
       $0)))))`)
  val pda_case_def =
    DT(["DISK_THM"], [],
       `(%32 (\%33. (%34 (\%9. (%35 (\%11. (%36 (\%13. (%37 (\%15. ((%38
       ((%39 $4) ((((%40 $3) $2) $1) $0))) (((($4 $3) $2) $1)
       $0))))))))))))`)
  val pda_size_def =
    DT(["DISK_THM"], [],
       `(%41 (\%42. (%43 (\%44. (%45 (\%46. (%34 (\%9. (%35 (\%11. (%36
       (\%13. (%37 (\%15. ((%47 ((((%48 $6) $5) $4) ((((%40 $3) $2) $1)
       $0))) ((%49 (%50 (%51 %52))) ((%49 ($4 $3)) ((%49 ($5 $2)) ((%49
       ((%53 ((%54 ((%55 (%56 $6)) ((%57 $5) $4))) ((%58 $4) (%59 $5))))
       $1)) ((%60 $4) $0))))))))))))))))))))`)
  val pda_start =
    DT(["DISK_THM"], [],
       `(%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%65 (%66 ((((%40
       $3) $2) $1) $0))) $3)))))))))`)
  val pda_ssSym =
    DT(["DISK_THM"], [],
       `(%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%67 (%68 ((((%40
       $3) $2) $1) $0))) $2)))))))))`)
  val pda_next =
    DT(["DISK_THM"], [],
       `(%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%69 (%70 ((((%40
       $3) $2) $1) $0))) $1)))))))))`)
  val pda_final =
    DT(["DISK_THM"], [],
       `(%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%71 (%72 ((((%40
       $3) $2) $1) $0))) $0)))))))))`)
  val pda_start_fupd =
    DT(["DISK_THM"], [],
       `(%73 (\%74. (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%27
       ((%75 $4) ((((%40 $3) $2) $1) $0))) ((((%40 ($4 $3)) $2) $1)
       $0))))))))))))`)
  val pda_ssSym_fupd =
    DT(["DISK_THM"], [],
       `(%76 (\%77. (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%27
       ((%78 $4) ((((%40 $3) $2) $1) $0))) ((((%40 $3) ($4 $2)) $1)
       $0))))))))))))`)
  val pda_next_fupd =
    DT(["DISK_THM"], [],
       `(%79 (\%80. (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%27
       ((%81 $4) ((((%40 $3) $2) $1) $0))) ((((%40 $3) $2) ($4 $1))
       $0))))))))))))`)
  val pda_final_fupd =
    DT(["DISK_THM"], [],
       `(%82 (\%83. (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%27
       ((%84 $4) ((((%40 $3) $2) $1) $0))) ((((%40 $3) $2) $1) ($4
       $0)))))))))))))`)
  val inpSyms_def =
    DT([], [],
       `(%85 (\%86. ((%87 (%88 $0)) (%89 (\%90. ((%91 $0) (%92 (\%93. (%94
       (\%95. (%96 (\%97. ((%98 ((%99 ((%100 (%101 $3)) ((%102 $0) $1)))
       $2)) (%103 $4))))))))))))))`)
  val inpSymsList_primitive_def =
    DT([], [],
       `((%104 %105) ((%106 (%107 (\%108. ((%24 (%109 $0)) ((%24 (%110
       (\%111. (%112 (\%95. (%113 (\%97. (%114 (\%90. (%115 (\%116. (($5
       $0) ((%117 ((%118 ((%100 (%101 $1)) ((%102 $2) $3))) $4))
       $0))))))))))))) (%110 (\%111. (%112 (\%95. (%113 (\%97. (%115
       (\%116. (($4 $0) ((%117 ((%118 ((%100 %119) ((%102 $1) $2))) $3))
       $0))))))))))))))) (\%120. (\%121. (((%122 (%123 %124)) (\%125.
       (\%116. ((%126 (\%127. (\%111. ((%128 (\%129. (\%130. (((%131 ((%132
       (\%133. (\%134. (%123 ($9 $6))))) $0)) (\%90. ((%132 (\%97. (\%95.
       (%123 ((%135 $2) ($10 $7)))))) $1))) $1)))) $1)))) $1)))) $0)))))`)
  val stkSyms_def =
    DT([], [],
       `(%136 (\%137. ((%138 (%139 $0)) ((%140 ((%140 ((%141 (%142 $0))
       %143)) (%144 (\%145. ((%146 $0) (%147 (\%148. (%149 (\%150. (%94
       (\%95. ((%151 ((%152 ((%153 $1) ((%154 $3) $0))) $2)) (%155
       $4))))))))))))) (%156 (%157 (\%158. ((%159 (%160 $0)) (%149 (\%150.
       (%10 (\%145. (%94 (\%95. (%94 (\%134. ((%151 ((%152 ((%153 $3)
       ((%154 $2) $1))) ((%161 $0) $4))) (%155 $5))))))))))))))))))`)
  val stkSymsList'_primitive_def =
    DT([], [],
       `((%162 %163) ((%164 (%165 (\%166. ((%24 (%167 $0)) (%168 (\%169.
       (%170 (\%171. (%110 (\%172. (%113 (\%97. (%112 (\%173. (%174 (\%175.
       (($6 $0) ((%176 ((%177 ((%178 $1) ((%179 $2) $3))) ((%180 $4) $5)))
       $0)))))))))))))))))) (\%181. (\%182. (((%183 (%184 %185)) (\%186.
       (\%175. ((%187 (\%188. (\%189. ((%190 (\%173. (\%191. ((%192 (\%97.
       (\%172. ((%193 (\%171. (\%169. (%184 ((%194 ((%195 $3) $0)) ($11
       $8)))))) $4)))) $0)))) $1)))) $1)))) $0)))))`)
  val stkSymsList_def =
    DT([], [],
       `(%136 (\%137. (%196 (\%197. ((%198 ((%199 $1) $0)) ((%200 ((%201
       (%142 $1)) %202)) (%203 $0)))))))`)
  val states_def =
    DT([], [],
       `(%204 (\%205. ((%206 (%207 $0)) ((%208 ((%208 ((%208 ((%209 (%210
       $0)) %211)) (%212 (%213 $0)))) (%214 (\%215. ((%216 $0) (%217
       (\%218. (%149 (\%150. (%94 (\%219. ((%220 ((%221 ((%222 $1) ((%223
       $0) $3))) $2)) (%224 $4))))))))))))) (%214 (\%225. ((%216 $0) (%149
       (\%150. (%94 (\%219. (%8 (\%215. (%226 (\%227. ((%220 ((%221 ((%222
       $3) ((%223 $2) $1))) ((%228 $4) $0))) (%224 $5)))))))))))))))))`)
  val statesList'_primitive_def =
    DT([], [],
       `((%229 %230) ((%231 (%232 (\%233. ((%24 (%234 $0)) (%170 (\%235.
       (%113 (\%236. (%113 (\%237. (%110 (\%238. (%112 (\%173. (%239
       (\%240. (($6 $0) ((%241 ((%242 ((%243 $1) ((%244 $2) $3))) ((%245
       $4) $5))) $0)))))))))))))))))) (\%246. (\%247. (((%248 (%184 %185))
       (\%249. (\%240. ((%250 (\%251. (\%252. ((%253 (\%173. (\%254. ((%255
       (\%238. (\%237. ((%256 (\%236. (\%235. (%184 ((%195 $2) ((%195 $1)
       ($11 $8))))))) $4)))) $0)))) $1)))) $1)))) $0)))))`)
  val statesList_def =
    DT([], [],
       `(%204 (\%205. (%257 (\%258. ((%71 ((%259 $1) $0)) ((%260 ((%261
       (%210 $1)) (%213 $1))) (%262 $0)))))))`)
  val pdastk_def =
    DT(["DISK_THM"], [],
       `(%112 (\%263. (%110 (\%264. (%113 (\%265. ((%38 (%266 ((%243 $2)
       ((%244 $1) $0)))) $0)))))))`)
  val pdainp_def =
    DT(["DISK_THM"], [],
       `(%112 (\%263. (%113 (\%267. (%110 (\%268. ((%38 (%269 ((%178 $2)
       ((%179 $1) $0)))) $1)))))))`)
  val pdastate_def =
    DT(["DISK_THM"], [],
       `(%113 (\%270. (%112 (\%271. (%110 (\%268. ((%38 (%272 ((%273 $2)
       ((%274 $1) $0)))) $2)))))))`)
  val ID_tupled_primitive_def =
    DT([], [],
       `((%275 %276) ((%277 (%278 (\%279. (%280 $0)))) (\%281. (\%282.
       ((%283 (\%284. (\%285. ((%286 (\%287. (\%288. ((%289 (\%172. (\%290.
       ((%291 (\%292. (\%293. (((%294 (((%295 (%296 %297)) (\%219. (\%298.
       ((%289 (\%299. (\%300. ((%291 (\%301. (\%302. (%296 ((%24 ((%303 $1)
       %185)) (%226 (\%304. ((%24 ((%305 ((%306 ((%307 %308) ((%274 $6)
       $10))) ((%309 $4) $0))) (%310 $14))) ((%311 $1) ((%312 $0)
       $5)))))))))) $0)))) $6)))) $0)) (\%267. (\%313. (((%295 (%296 %297))
       (\%314. (\%315. ((%289 (\%316. (\%317. ((%291 (\%318. (\%319. (%296
       ((%320 ((%24 ((%303 $1) $6)) (%226 (\%304. ((%24 ((%305 ((%306
       ((%307 (%321 $8)) ((%274 $6) $12))) ((%309 $4) $0))) (%310 $16)))
       ((%311 $1) ((%312 $0) $5))))))) ((%24 ((%303 $1) ((%195 $7) $6)))
       (%226 (\%304. ((%24 ((%305 ((%306 ((%307 %308) ((%274 $6) $12)))
       ((%309 $4) $0))) (%310 $16))) ((%311 $1) ((%312 $0) $5)))))))))))
       $0)))) $8)))) $2)))) $1)))) $0)))) $1)))) $0)))) $0)))))`)
  val ID_curried_def =
    DT([], [],
       `(%322 (\%323. (%324 (\%325. (%324 (\%326. ((%31 (((%327 $2) $1)
       $0)) (%276 ((%328 $2) ((%329 $1) $0))))))))))`)
  val IDC_def =
    DT([], [],
       `(%322 (\%284. (%324 (\%330. (%324 (\%331. ((%31 (((%332 $2) $1)
       $0)) (((%333 (%327 $2)) $1) $0))))))))`)
  val lafs_def =
    DT([], [],
       `(%25 (\%334. ((%335 (%336 $0)) (%337 (\%338. ((%339 $0) (%8 (\%340.
       (%341 (\%342. ((%24 (((%343 $3) ((%344 (%66 $3)) ((%345 $2) ((%201
       (%68 $3)) %202)))) ((%344 $1) ((%345 %124) $0)))) ((%346 $1) (%72
       $3)))))))))))))`)
  val laes_def =
    DT([], [],
       `(%25 (\%334. ((%335 (%347 $0)) (%337 (\%338. ((%339 $0) (%8 (\%340.
       (((%343 $2) ((%344 (%66 $2)) ((%345 $1) ((%201 (%68 $2)) %202))))
       ((%344 $0) ((%345 %124) %202)))))))))))`)
  val stkLen_def =
    DT([], [], `(%348 (\%349. ((%47 (%350 $0)) (%351 (%352 $0)))))`)
  val pda_accessors =
    DT(["DISK_THM"], [],
       `((%24 (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%65 (%66
       ((((%40 $3) $2) $1) $0))) $3)))))))))) ((%24 (%34 (\%61. (%35 (\%62.
       (%36 (\%63. (%37 (\%64. ((%67 (%68 ((((%40 $3) $2) $1) $0)))
       $2)))))))))) ((%24 (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64.
       ((%69 (%70 ((((%40 $3) $2) $1) $0))) $1)))))))))) (%34 (\%61. (%35
       (\%62. (%36 (\%63. (%37 (\%64. ((%71 (%72 ((((%40 $3) $2) $1) $0)))
       $0))))))))))))`)
  val pda_fn_updates =
    DT(["DISK_THM"], [],
       `((%24 (%73 (\%74. (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64.
       ((%27 ((%75 $4) ((((%40 $3) $2) $1) $0))) ((((%40 ($4 $3)) $2) $1)
       $0))))))))))))) ((%24 (%76 (\%77. (%34 (\%61. (%35 (\%62. (%36
       (\%63. (%37 (\%64. ((%27 ((%78 $4) ((((%40 $3) $2) $1) $0))) ((((%40
       $3) ($4 $2)) $1) $0))))))))))))) ((%24 (%79 (\%80. (%34 (\%61. (%35
       (\%62. (%36 (\%63. (%37 (\%64. ((%27 ((%81 $4) ((((%40 $3) $2) $1)
       $0))) ((((%40 $3) $2) ($4 $1)) $0))))))))))))) (%82 (\%83. (%34
       (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64. ((%27 ((%84 $4) ((((%40
       $3) $2) $1) $0))) ((((%40 $3) $2) $1) ($4 $0))))))))))))))))`)
  val pda_accfupds =
    DT(["DISK_THM"], [],
       `((%24 (%25 (\%334. (%76 (\%77. ((%65 (%66 ((%78 $0) $1))) (%66
       $1))))))) ((%24 (%25 (\%334. (%79 (\%80. ((%65 (%66 ((%81 $0) $1)))
       (%66 $1))))))) ((%24 (%25 (\%334. (%82 (\%83. ((%65 (%66 ((%84 $0)
       $1))) (%66 $1))))))) ((%24 (%25 (\%334. (%73 (\%74. ((%67 (%68 ((%75
       $0) $1))) (%68 $1))))))) ((%24 (%25 (\%334. (%79 (\%80. ((%67 (%68
       ((%81 $0) $1))) (%68 $1))))))) ((%24 (%25 (\%334. (%82 (\%83. ((%67
       (%68 ((%84 $0) $1))) (%68 $1))))))) ((%24 (%25 (\%334. (%73 (\%74.
       ((%69 (%70 ((%75 $0) $1))) (%70 $1))))))) ((%24 (%25 (\%334. (%76
       (\%77. ((%69 (%70 ((%78 $0) $1))) (%70 $1))))))) ((%24 (%25 (\%334.
       (%82 (\%83. ((%69 (%70 ((%84 $0) $1))) (%70 $1))))))) ((%24 (%25
       (\%334. (%73 (\%74. ((%71 (%72 ((%75 $0) $1))) (%72 $1))))))) ((%24
       (%25 (\%334. (%76 (\%77. ((%71 (%72 ((%78 $0) $1))) (%72 $1)))))))
       ((%24 (%25 (\%334. (%79 (\%80. ((%71 (%72 ((%81 $0) $1))) (%72
       $1))))))) ((%24 (%25 (\%334. (%73 (\%74. ((%65 (%66 ((%75 $0) $1)))
       ($0 (%66 $1)))))))) ((%24 (%25 (\%334. (%76 (\%77. ((%67 (%68 ((%78
       $0) $1))) ($0 (%68 $1)))))))) ((%24 (%25 (\%334. (%79 (\%80. ((%69
       (%70 ((%81 $0) $1))) ($0 (%70 $1)))))))) (%25 (\%334. (%82 (\%83.
       ((%71 (%72 ((%84 $0) $1))) ($0 (%72 $1))))))))))))))))))))))`)
  val pda_fupdfupds =
    DT(["DISK_THM"], [],
       `((%24 (%25 (\%334. (%73 (\%353. (%73 (\%74. ((%27 ((%75 $0) ((%75
       $1) $2))) ((%75 ((%354 $0) $1)) $2))))))))) ((%24 (%25 (\%334. (%76
       (\%355. (%76 (\%77. ((%27 ((%78 $0) ((%78 $1) $2))) ((%78 ((%356 $0)
       $1)) $2))))))))) ((%24 (%25 (\%334. (%79 (\%357. (%79 (\%80. ((%27
       ((%81 $0) ((%81 $1) $2))) ((%81 ((%358 $0) $1)) $2))))))))) (%25
       (\%334. (%82 (\%359. (%82 (\%83. ((%27 ((%84 $0) ((%84 $1) $2)))
       ((%84 ((%360 $0) $1)) $2)))))))))))`)
  val pda_fupdfupds_comp =
    DT(["DISK_THM"], [],
       `((%24 ((%24 (%73 (\%353. (%73 (\%74. ((%361 ((%362 (%75 $0)) (%75
       $1))) (%75 ((%354 $0) $1)))))))) (%363 (\%364. (%73 (\%353. (%73
       (\%74. ((%365 ((%366 (%75 $0)) ((%366 (%75 $1)) $2))) ((%366 (%75
       ((%354 $0) $1))) $2)))))))))) ((%24 ((%24 (%76 (\%355. (%76 (\%77.
       ((%361 ((%362 (%78 $0)) (%78 $1))) (%78 ((%356 $0) $1)))))))) (%363
       (\%364. (%76 (\%355. (%76 (\%77. ((%365 ((%366 (%78 $0)) ((%366 (%78
       $1)) $2))) ((%366 (%78 ((%356 $0) $1))) $2)))))))))) ((%24 ((%24
       (%79 (\%357. (%79 (\%80. ((%361 ((%362 (%81 $0)) (%81 $1))) (%81
       ((%358 $0) $1)))))))) (%363 (\%364. (%79 (\%357. (%79 (\%80. ((%365
       ((%366 (%81 $0)) ((%366 (%81 $1)) $2))) ((%366 (%81 ((%358 $0) $1)))
       $2)))))))))) ((%24 (%82 (\%359. (%82 (\%83. ((%361 ((%362 (%84 $0))
       (%84 $1))) (%84 ((%360 $0) $1)))))))) (%363 (\%364. (%82 (\%359.
       (%82 (\%83. ((%365 ((%366 (%84 $0)) ((%366 (%84 $1)) $2))) ((%366
       (%84 ((%360 $0) $1))) $2))))))))))))`)
  val pda_fupdcanon =
    DT(["DISK_THM"], [],
       `((%24 (%25 (\%334. (%73 (\%353. (%76 (\%77. ((%27 ((%78 $0) ((%75
       $1) $2))) ((%75 $1) ((%78 $0) $2)))))))))) ((%24 (%25 (\%334. (%73
       (\%353. (%79 (\%80. ((%27 ((%81 $0) ((%75 $1) $2))) ((%75 $1) ((%81
       $0) $2)))))))))) ((%24 (%25 (\%334. (%76 (\%355. (%79 (\%80. ((%27
       ((%81 $0) ((%78 $1) $2))) ((%78 $1) ((%81 $0) $2)))))))))) ((%24
       (%25 (\%334. (%73 (\%353. (%82 (\%83. ((%27 ((%84 $0) ((%75 $1)
       $2))) ((%75 $1) ((%84 $0) $2)))))))))) ((%24 (%25 (\%334. (%76
       (\%355. (%82 (\%83. ((%27 ((%84 $0) ((%78 $1) $2))) ((%78 $1) ((%84
       $0) $2)))))))))) (%25 (\%334. (%79 (\%357. (%82 (\%83. ((%27 ((%84
       $0) ((%81 $1) $2))) ((%81 $1) ((%84 $0) $2))))))))))))))`)
  val pda_fupdcanon_comp =
    DT(["DISK_THM"], [],
       `((%24 ((%24 (%73 (\%353. (%76 (\%77. ((%361 ((%362 (%78 $0)) (%75
       $1))) ((%362 (%75 $1)) (%78 $0)))))))) (%363 (\%364. (%73 (\%353.
       (%76 (\%77. ((%365 ((%366 (%78 $0)) ((%366 (%75 $1)) $2))) ((%366
       (%75 $1)) ((%366 (%78 $0)) $2))))))))))) ((%24 ((%24 (%73 (\%353.
       (%79 (\%80. ((%361 ((%362 (%81 $0)) (%75 $1))) ((%362 (%75 $1)) (%81
       $0)))))))) (%363 (\%364. (%73 (\%353. (%79 (\%80. ((%365 ((%366 (%81
       $0)) ((%366 (%75 $1)) $2))) ((%366 (%75 $1)) ((%366 (%81 $0))
       $2))))))))))) ((%24 ((%24 (%76 (\%355. (%79 (\%80. ((%361 ((%362
       (%81 $0)) (%78 $1))) ((%362 (%78 $1)) (%81 $0)))))))) (%363 (\%364.
       (%76 (\%355. (%79 (\%80. ((%365 ((%366 (%81 $0)) ((%366 (%78 $1))
       $2))) ((%366 (%78 $1)) ((%366 (%81 $0)) $2))))))))))) ((%24 ((%24
       (%73 (\%353. (%82 (\%83. ((%361 ((%362 (%84 $0)) (%75 $1))) ((%362
       (%75 $1)) (%84 $0)))))))) (%363 (\%364. (%73 (\%353. (%82 (\%83.
       ((%365 ((%366 (%84 $0)) ((%366 (%75 $1)) $2))) ((%366 (%75 $1))
       ((%366 (%84 $0)) $2))))))))))) ((%24 ((%24 (%76 (\%355. (%82 (\%83.
       ((%361 ((%362 (%84 $0)) (%78 $1))) ((%362 (%78 $1)) (%84 $0))))))))
       (%363 (\%364. (%76 (\%355. (%82 (\%83. ((%365 ((%366 (%84 $0))
       ((%366 (%78 $1)) $2))) ((%366 (%78 $1)) ((%366 (%84 $0))
       $2))))))))))) ((%24 (%79 (\%357. (%82 (\%83. ((%361 ((%362 (%84 $0))
       (%81 $1))) ((%362 (%81 $1)) (%84 $0)))))))) (%363 (\%364. (%79
       (\%357. (%82 (\%83. ((%365 ((%366 (%84 $0)) ((%366 (%81 $1)) $2)))
       ((%366 (%81 $1)) ((%366 (%84 $0)) $2)))))))))))))))`)
  val pda_component_equality =
    DT(["DISK_THM"], [],
       `(%25 (\%367. (%25 (\%368. ((%31 ((%27 $1) $0)) ((%24 ((%65 (%66
       $1)) (%66 $0))) ((%24 ((%67 (%68 $1)) (%68 $0))) ((%24 ((%69 (%70
       $1)) (%70 $0))) ((%71 (%72 $1)) (%72 $0))))))))))`)
  val pda_updates_eq_literal =
    DT(["DISK_THM"], [],
       `(%25 (\%334. (%34 (\%369. (%35 (\%370. (%36 (\%371. (%37 (\%372.
       ((%27 ((%75 (%373 $3)) ((%78 (%374 $2)) ((%81 (%375 $1)) ((%84 (%376
       $0)) $4))))) ((%75 (%373 $3)) ((%78 (%374 $2)) ((%81 (%375 $1))
       ((%84 (%376 $0)) %377)))))))))))))))`)
  val pda_literal_nchotomy =
    DT(["DISK_THM"], [],
       `(%25 (\%334. (%8 (\%369. (%10 (\%370. (%12 (\%371. (%14 (\%372.
       ((%27 $4) ((%75 (%373 $3)) ((%78 (%374 $2)) ((%81 (%375 $1)) ((%84
       (%376 $0)) %377)))))))))))))))`)
  val FORALL_pda =
    DT(["DISK_THM"], [],
       `(%378 (\%379. ((%31 (%25 (\%334. ($1 $0)))) (%34 (\%369. (%35
       (\%370. (%36 (\%371. (%37 (\%372. ($4 ((%75 (%373 $3)) ((%78 (%374
       $2)) ((%81 (%375 $1)) ((%84 (%376 $0)) %377))))))))))))))))`)
  val EXISTS_pda =
    DT(["DISK_THM"], [],
       `(%378 (\%379. ((%31 (%380 (\%334. ($1 $0)))) (%8 (\%369. (%10
       (\%370. (%12 (\%371. (%14 (\%372. ($4 ((%75 (%373 $3)) ((%78 (%374
       $2)) ((%81 (%375 $1)) ((%84 (%376 $0)) %377))))))))))))))))`)
  val pda_literal_11 =
    DT(["DISK_THM"], [],
       `(%34 (\%381. (%35 (\%382. (%36 (\%383. (%37 (\%384. (%34 (\%385.
       (%35 (\%386. (%36 (\%387. (%37 (\%388. ((%31 ((%27 ((%75 (%373 $7))
       ((%78 (%374 $6)) ((%81 (%375 $5)) ((%84 (%376 $4)) %377))))) ((%75
       (%373 $3)) ((%78 (%374 $2)) ((%81 (%375 $1)) ((%84 (%376 $0))
       %377)))))) ((%24 ((%65 $7) $3)) ((%24 ((%67 $6) $2)) ((%24 ((%69 $5)
       $1)) ((%71 $4) $0)))))))))))))))))))))`)
  val datatype_pda =
    DT(["DISK_THM"], [], `(%389 (((((%390 %391) %392) %393) %394) %395))`)
  val pda_11 =
    DT(["DISK_THM"], [],
       `(%34 (\%9. (%35 (\%11. (%36 (\%13. (%37 (\%15. (%34 (\%396. (%35
       (\%397. (%36 (\%398. (%37 (\%399. ((%31 ((%27 ((((%40 $7) $6) $5)
       $4)) ((((%40 $3) $2) $1) $0))) ((%24 ((%65 $7) $3)) ((%24 ((%67 $6)
       $2)) ((%24 ((%69 $5) $1)) ((%71 $4) $0)))))))))))))))))))))`)
  val pda_case_cong =
    DT(["DISK_THM"], [],
       `(%25 (\%400. (%25 (\%401. (%32 (\%33. ((%6 ((%24 ((%27 $2) $1))
       (%34 (\%9. (%35 (\%11. (%36 (\%13. (%37 (\%15. ((%6 ((%27 $5)
       ((((%40 $3) $2) $1) $0))) ((%38 (((($4 $3) $2) $1) $0)) ((((%402 $3)
       $2) $1) $0))))))))))))) ((%38 ((%39 $0) $2)) ((%39 %402)
       $1)))))))))`)
  val pda_nchotomy =
    DT(["DISK_THM"], [],
       `(%25 (\%403. (%8 (\%61. (%10 (\%62. (%12 (\%63. (%14 (\%64. ((%27
       $4) ((((%40 $3) $2) $1) $0))))))))))))`)
  val pda_Axiom =
    DT(["DISK_THM"], [],
       `(%32 (\%33. (%404 (\%405. (%34 (\%9. (%35 (\%11. (%36 (\%13. (%37
       (\%15. ((%38 ($4 ((((%40 $3) $2) $1) $0))) (((($5 $3) $2) $1)
       $0))))))))))))))`)
  val pda_induction =
    DT(["DISK_THM"], [],
       `(%378 (\%379. ((%6 (%34 (\%61. (%35 (\%62. (%36 (\%63. (%37 (\%64.
       ($4 ((((%40 $3) $2) $1) $0))))))))))) (%25 (\%334. ($1 $0))))))`)
  val inpSymsList_ind =
    DT(["DISK_THM"], [],
       `(%406 (\%407. ((%6 ((%24 ($0 %408)) ((%24 (%114 (\%90. (%113 (\%97.
       (%112 (\%95. (%110 (\%111. (%115 (\%116. ((%6 ($5 $0)) ($5 ((%117
       ((%118 ((%100 (%101 $4)) ((%102 $3) $2))) $1)) $0))))))))))))))
       (%113 (\%97. (%112 (\%95. (%110 (\%111. (%115 (\%116. ((%6 ($4 $0))
       ($4 ((%117 ((%118 ((%100 %119) ((%102 $3) $2))) $1))
       $0)))))))))))))) (%115 (\%409. ($1 $0))))))`)
  val inpSymsList_def =
    DT(["DISK_THM"], [],
       `((%24 ((%410 (%105 %408)) %124)) ((%24 (%113 (\%97. (%115 (\%116.
       (%112 (\%95. (%110 (\%111. (%114 (\%90. ((%410 (%105 ((%117 ((%118
       ((%100 (%101 $0)) ((%102 $4) $2))) $1)) $3))) ((%135 $0) (%105
       $3)))))))))))))) (%113 (\%97. (%115 (\%116. (%112 (\%95. (%110
       (\%111. ((%410 (%105 ((%117 ((%118 ((%100 %119) ((%102 $3) $1)))
       $0)) $2))) (%105 $2))))))))))))`)
  val FORALL_trans =
    DT(["DISK_THM"], [],
       `(%411 (\%412. ((%31 (%413 (\%414. ($1 $0)))) (%415 (\%416. (%417
       (\%418. (%419 (\%420. (%419 (\%421. (%422 (\%423. ($5 ((%424 ((%425
       $4) ((%426 $3) $2))) ((%427 $1) $0))))))))))))))))`)
  val EXISTS_trans =
    DT(["DISK_THM"], [],
       `(%411 (\%412. ((%31 (%428 (\%414. ($1 $0)))) (%429 (\%416. (%430
       (\%418. (%431 (\%420. (%431 (\%421. (%432 (\%423. ($5 ((%424 ((%425
       $4) ((%426 $3) $2))) ((%427 $1) $0))))))))))))))))`)
  val inpSyms_list_eqresult =
    DT(["DISK_THM"], [], `((%433 (%434 %284)) (%435 (%436 (%310 %284))))`)
  val stkSymsList'_ind =
    DT(["DISK_THM"], [],
       `(%437 (\%438. ((%6 ((%24 ($0 %439)) (%112 (\%173. (%113 (\%97.
       (%110 (\%172. (%170 (\%171. (%168 (\%169. (%174 (\%175. ((%6 ($6
       $0)) ($6 ((%176 ((%177 ((%178 $5) ((%179 $4) $3))) ((%180 $2) $1)))
       $0))))))))))))))))) (%174 (\%440. ($1 $0))))))`)
  val stkSymsList'_def =
    DT(["DISK_THM"], [],
       `((%24 ((%303 (%163 %439)) %185)) (%168 (\%169. (%113 (\%97. (%174
       (\%175. (%170 (\%171. (%110 (\%172. (%112 (\%173. ((%303 (%163
       ((%176 ((%177 ((%178 $0) ((%179 $4) $1))) ((%180 $2) $5))) $3)))
       ((%194 ((%195 $4) $5)) (%163 $3))))))))))))))))`)
  val ssymslApp =
    DT(["DISK_THM"], [],
       `(%441 (\%442. (%441 (\%443. ((%311 (%444 ((%445 $1) $0))) ((%312
       (%444 $1)) (%444 $0)))))))`)
  val memssl' =
    DT(["DISK_THM"], [],
       `(%441 (\%446. ((%6 ((%447 %219) (%444 $0))) (%96 (\%448. (%449
       (\%172. (%450 (\%171. (%226 (\%227. ((%320 ((%451 ((%452 ((%273 $3)
       ((%274 %219) $2))) ((%453 $1) $0))) $4)) (%96 (\%448. (%449 (\%172.
       (%450 (\%171. (%94 (\%454. (%226 (\%227. ((%24 ((%451 ((%452 ((%273
       $4) ((%274 $1) $3))) ((%453 $2) $0))) $9)) ((%447 %219)
       $0))))))))))))))))))))))))`)
  val stkSyms_list_eqresult =
    DT(["DISK_THM"], [],
       `((%433 (%455 %456)) (%435 ((%457 %456) (%458 %456))))`)
  val statesList'_ind =
    DT(["DISK_THM"], [],
       `(%459 (\%460. ((%6 ((%24 ($0 %461)) (%112 (\%173. (%110 (\%238.
       (%113 (\%237. (%113 (\%236. (%170 (\%235. (%239 (\%240. ((%6 ($6
       $0)) ($6 ((%241 ((%242 ((%243 $5) ((%244 $4) $3))) ((%245 $2) $1)))
       $0))))))))))))))))) (%239 (\%462. ($1 $0))))))`)
  val statesList'_def =
    DT(["DISK_THM"], [],
       `((%24 ((%303 (%230 %461)) %185)) (%170 (\%235. (%110 (\%238. (%239
       (\%240. (%113 (\%236. (%113 (\%237. (%112 (\%173. ((%303 (%230
       ((%241 ((%242 ((%243 $0) ((%244 $4) $1))) ((%245 $2) $5))) $3)))
       ((%195 $1) ((%195 $2) (%230 $3)))))))))))))))))`)
  val memstl' =
    DT(["DISK_THM"], [],
       `(%463 (\%464. ((%6 ((%465 %172) (%466 $0))) (%96 (\%448. (%94
       (\%219. (%449 (\%299. (%450 (\%235. ((%320 ((%467 ((%468 ((%273 $3)
       ((%274 $2) %172))) ((%469 $1) $0))) $4)) (%96 (\%448. (%94 (\%219.
       (%449 (\%299. (%450 (\%235. ((%467 ((%468 ((%273 $3) ((%274 $2)
       $1))) ((%469 %172) $0))) $8)))))))))))))))))))))`)
  val statesListApp =
    DT(["DISK_THM"], [],
       `(%463 (\%470. (%463 (\%471. ((%472 (%466 ((%473 $1) $0))) ((%474
       (%466 $1)) (%466 $0)))))))`)
  val states_list_eqresult =
    DT(["DISK_THM"], [],
       `((%433 (%475 %476)) (%435 ((%477 %476) (%478 %476))))`)
  val finiteInpSyms =
    DT(["DISK_THM"], [], `(%322 (\%284. (%479 (%434 $0))))`)
  val finiteStkSyms =
    DT(["DISK_THM"], [], `(%322 (\%284. (%480 (%481 $0))))`)
  val finiteStates =
    DT(["DISK_THM"], [], `(%322 (\%284. (%482 (%483 $0))))`)
  val ID_ind =
    DT(["DISK_THM"], [],
       `(%484 (\%485. ((%6 ((%24 (%322 (\%284. (%110 (\%172. (%324 (\%486.
       ((($3 $2) ((%487 $1) ((%488 %185) %489))) $0)))))))) ((%24 (%322
       (\%284. (%110 (\%172. (%113 (\%490. (%168 (\%491. (%324 (\%486.
       ((($5 $4) ((%487 $3) ((%488 ((%195 $2) $1)) %489))) $0))))))))))))
       ((%24 (%322 (\%284. (%110 (\%172. (%112 (\%219. (%492 (\%298. (%110
       (\%299. (%168 (\%301. (%492 (\%302. ((($7 $6) ((%487 $5) ((%488
       %185) ((%493 $4) $3)))) ((%487 $2) ((%488 $1) $0))))))))))))))))))
       (%322 (\%284. (%110 (\%172. (%113 (\%267. (%168 (\%313. (%112
       (\%219. (%492 (\%298. (%110 (\%299. (%168 (\%301. (%492 (\%302.
       ((($9 $8) ((%487 $7) ((%488 ((%195 $6) $5)) ((%493 $4) $3)))) ((%487
       $2) ((%488 $1) $0))))))))))))))))))))))))) (%322 (\%494. (%110
       (\%495. (%168 (\%496. (%492 (\%497. (%324 (\%498. ((($5 $4) ((%487
       $3) ((%488 $2) $1))) $0))))))))))))))`)
  val ID_def =
    DT(["DISK_THM"], [],
       `((%24 ((%31 (((%327 %284) ((%487 %172) ((%488 %185) %489))) %486))
       %297)) ((%24 ((%31 (((%327 %284) ((%487 %172) ((%488 ((%195 %490)
       %491)) %489))) %486)) %297)) ((%24 ((%31 (((%327 %284) ((%487 %172)
       ((%488 %185) ((%493 %219) %298)))) ((%487 %299) ((%488 %301)
       %302)))) ((%24 ((%303 %301) %185)) (%226 (\%304. ((%24 ((%305 ((%306
       ((%307 %308) ((%274 %219) %172))) ((%309 %299) $0))) (%310 %284)))
       ((%311 %302) ((%312 $0) %298)))))))) ((%31 (((%327 %284) ((%487
       %172) ((%488 ((%195 %267) %313)) ((%493 %219) %298)))) ((%487 %299)
       ((%488 %301) %302)))) ((%320 ((%24 ((%303 %301) %313)) (%226 (\%304.
       ((%24 ((%305 ((%306 ((%307 (%321 %267)) ((%274 %219) %172))) ((%309
       %299) $0))) (%310 %284))) ((%311 %302) ((%312 $0) %298))))))) ((%24
       ((%303 %301) ((%195 %267) %313))) (%226 (\%304. ((%24 ((%305 ((%306
       ((%307 %308) ((%274 %219) %172))) ((%309 %299) $0))) (%310 %284)))
       ((%311 %302) ((%312 $0) %298)))))))))))`)
  val new_ssym_exists =
    DT(["DISK_THM"], [],
       `(%499 (\%500. ((%6 (%501 %502)) ((%6 (%503 $0)) (%10 (\%504. (%505
       ((%506 $0) $1))))))))`)
  val new_state_exists =
    DT(["DISK_THM"], [],
       `(%507 (\%508. ((%6 (%509 %510)) ((%6 (%511 $0)) (%8 (\%512. (%505
       ((%513 $0) $1))))))))`)
  val memStateRule =
    DT(["DISK_THM"], [],
       `((%6 ((%305 ((%306 ((%307 %514) ((%274 %515) %516))) ((%309 %172)
       %304))) (%310 %517))) ((%24 ((%465 %516) ((%518 %517) (%310 %517))))
       ((%465 %172) ((%518 %517) (%310 %517)))))`)
  val memState =
    DT(["DISK_THM"], [],
       `((%6 (((%332 %517) ((%487 %516) ((%488 %519) %520))) ((%487 %521)
       ((%488 %301) %522)))) ((%320 ((%523 %516) %521)) ((%24 ((%465 %516)
       ((%518 %517) (%310 %517)))) ((%465 %521) ((%518 %517) (%310
       %517))))))`)
  val idStackInsert =
    DT(["DISK_THM"], [],
       `((%6 (((%327 %517) ((%487 %172) ((%488 %524) %520))) ((%487 %299)
       ((%488 %525) %522)))) (%492 (\%526. (((%327 %517) ((%487 %172)
       ((%488 %524) ((%312 %520) $0)))) ((%487 %299) ((%488 %525) ((%312
       %522) $0)))))))`)
  val idcStackInsert =
    DT(["DISK_THM"], [],
       `((%6 (((%527 (%528 %529)) ((%530 %237) ((%531 %532) %533))) ((%530
       %236) ((%531 %534) %535)))) (%536 (\%537. (((%527 (%528 %529))
       ((%530 %237) ((%531 %532) ((%474 %533) $0)))) ((%530 %236) ((%531
       %534) ((%474 %535) $0)))))))`)
  val idStkPop =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%538. (%536 (\%539. (%110 (\%540. (%536
       (\%541. (%113 (\%236. (%492 (\%542. (%536 (\%535. ((%6 ((%24 (((%528
       %529) ((%530 $7) ((%531 $6) ((%474 ((%474 $5) ((%543 $4) %544)))
       $3)))) ((%530 $2) ((%531 $1) $0)))) ((%24 (%505 ((%465 $4) $5)))
       (%505 ((%545 $4) (%546 %529)))))) (%547 (\%548. ((%24 ((%472 $1)
       ((%474 ((%474 $0) ((%543 $5) %544))) $4))) ((%24 (%505 ((%465 $5)
       $0))) (((%528 %529) ((%530 $8) ((%531 $7) $6))) ((%530 $3) ((%531
       $2) $0))))))))))))))))))))))))`)
  val idcStkPop =
    DT(["DISK_THM"], [],
       `(%549 (\%550. (%113 (\%237. (%492 (\%538. (%536 (\%541. (%113
       (\%236. (%492 (\%542. (%536 (\%535. (%536 (\%539. ((%6 ((%24
       ((((%551 (%528 %529)) $7) ((%530 $6) ((%531 $5) ((%474 ((%474 $0)
       ((%543 %540) %544))) $4)))) ((%530 $3) ((%531 $2) $1)))) ((%24 (%505
       ((%465 %540) $0))) (%505 ((%545 %540) (%546 %529)))))) (%552 (\%553.
       (%547 (\%548. ((%24 ((%472 $3) ((%474 ((%474 $0) ((%543 %540)
       %544))) $6))) ((%24 (%505 ((%465 %540) $0))) ((((%551 (%528 %529))
       $1) ((%530 $8) ((%531 $7) $2))) ((%530 $5) ((%531 $4)
       $0))))))))))))))))))))))))))`)
  val idInpInsert =
    DT(["DISK_THM"], [],
       `((%6 (((%327 %517) ((%487 %172) ((%488 %524) %520))) ((%487 %299)
       ((%488 %525) %522)))) (%168 (\%554. (((%327 %517) ((%487 %172)
       ((%488 ((%194 %524) $0)) %520))) ((%487 %299) ((%488 ((%194 %525)
       $0)) %522))))))`)
  val idcInpInsert =
    DT(["DISK_THM"], [],
       `((%6 (((%527 (%528 %529)) ((%530 %237) ((%531 %532) %533))) ((%530
       %236) ((%531 %534) %535)))) (%492 (\%526. (((%527 (%528 %529))
       ((%530 %237) ((%531 ((%312 %532) $0)) %533))) ((%530 %236) ((%531
       ((%312 %534) $0)) %535))))))`)
  val id_thm =
    DT(["DISK_THM"], [],
       `((%31 (((%327 %284) ((%487 %555) ((%488 %556) %557))) ((%487 %172)
       ((%488 %558) %559)))) ((%320 (%94 (\%560. (%226 (\%561. (%226
       (\%562. ((%24 ((%311 %557) ((%493 $2) $1))) ((%24 ((%305 ((%306
       ((%307 %308) ((%274 $2) %555))) ((%309 %172) $0))) (%310 %284)))
       ((%24 ((%311 %559) ((%312 $0) $1))) ((%303 %558) %556)))))))))))
       (%94 (\%560. (%226 (\%561. (%226 (\%562. (%96 (\%563. ((%24 ((%311
       %557) ((%493 $3) $2))) ((%24 ((%305 ((%306 ((%307 (%321 $0)) ((%274
       $3) %555))) ((%309 %172) $1))) (%310 %284))) ((%24 ((%311 %559)
       ((%312 $1) $2))) ((%303 %556) ((%195 $0) %558)))))))))))))))`)
  val ldIdcInpLen =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%113 (\%236. (%492 (\%538. (%492 (\%542. (%536
       (\%541. (%536 (\%564. ((%6 ((((%551 (%528 %476)) %565) ((%530 $5)
       ((%531 $3) $1))) ((%530 $4) ((%531 $2) $0)))) ((%566 (%567 $2))
       (%567 $3)))))))))))))))`)
  val pdaTransOnPfx =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%113 (\%236. (%492 (\%568. (%492 (\%569. (%536
       (\%570. (%536 (\%571. ((%6 ((((%551 (%528 %476)) %565) ((%530 $5)
       ((%531 ((%312 $3) $2)) ((%474 $1) $0)))) ((%530 $4) ((%531 $2)
       $0)))) ((%6 (%572 (\%573. ((%6 ((%574 $0) (%575 %565))) (%547
       (\%539. ((%24 (%505 ((%472 $0) %544))) ((%472 (%576 $1)) ((%474 $0)
       $2))))))))) (((%527 (%528 %476)) ((%530 $5) ((%531 $3) $1))) ((%530
       $4) ((%531 %489) %544)))))))))))))))))`)
  val ldIdcInpSuffix =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%113 (\%236. (%492 (\%577. (%492 (\%578. (%536
       (\%533. (%536 (\%535. ((%6 ((((%551 (%528 %476)) %565) ((%530 $5)
       ((%531 $3) $1))) ((%530 $4) ((%531 $2) $0)))) (%226 (\%579. ((%24
       ((%311 $4) ((%312 $0) $3))) ((%580 $3) $4)))))))))))))))))`)
  val frontdlProp =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%113 (\%236. (%112 (\%581. (%536 (\%582. (%536
       (\%583. (%110 (\%584. ((%6 ((((%585 (%586 %587)) %588) ((%589 $5)
       ((%590 %591) ((%474 ((%543 $0) %544)) $2)))) ((%589 $4) ((%590 %591)
       ((%474 $1) $2))))) ((%6 (%592 (\%593. ((%6 ((%594 $0) %588)) ((%566
       (%351 ((%474 ((%543 $1) %544)) $3))) (%351 (%595 $0))))))) (%592
       (\%593. ((%6 ((%594 $0) %588)) (%547 (\%539. ((%24 (%505 ((%472 $0)
       %544))) ((%472 (%595 $1)) ((%474 $0) $4))))))))))))))))))))))`)
  val frontdlPropGen =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%596. (%110 (\%597. (%598 (\%599. (%600
       (\%601. (%113 (\%236. (%492 (\%542. (%492 (\%569. (%598 (\%602.
       (%598 (\%603. ((%6 ((((%604 (%605 %606)) %607) ((%608 $9) ((%609
       ((%312 $8) $2)) ((%610 $6) $0)))) ((%608 $4) ((%609 ((%312 $3) $2))
       ((%610 $1) $0))))) ((%6 (%505 ((%611 $6) %591))) ((%6 (%612 (\%613.
       ((%6 ((%614 $0) %607)) ((%566 (%615 ((%610 $7) $1))) (%615 (%616
       $0))))))) (%612 (\%613. ((%6 ((%614 $0) %607)) (%617 (\%618. ((%24
       (%505 ((%611 $0) %591))) ((%611 (%616 $1)) ((%610 $0)
       $2)))))))))))))))))))))))))))))))`)
  val dlprop =
    DT(["DISK_THM"], [],
       `(%549 (\%565. (%113 (\%237. (%113 (\%236. (%110 (\%584. (%536
       (\%582. ((%6 ((((%551 (%528 %476)) $4) ((%530 $3) ((%531 %489)
       ((%543 $1) $0)))) ((%530 $2) ((%531 %489) $0)))) ((%6 (%572 (\%573.
       ((%6 ((%574 $0) (%575 $5))) ((%566 (%351 ((%543 $2) $1))) (%351
       (%576 $0))))))) (%572 (\%573. ((%6 ((%574 $0) (%575 $5))) (%547
       (\%539. ((%24 (%505 ((%472 $0) %544))) ((%472 (%576 $1)) ((%474 $0)
       $2))))))))))))))))))))`)
  val dlpropGen =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%596. (%110 (\%597. (%598 (\%599. (%600
       (\%601. (%113 (\%236. (%492 (\%542. (%492 (\%569. (%598 (\%602.
       (%598 (\%603. ((%6 ((((%604 (%605 %606)) %607) ((%608 $9) ((%609
       ((%312 $8) $2)) ((%610 $6) $0)))) ((%608 $4) ((%609 ((%312 $3) $2))
       ((%610 $1) $0))))) ((%6 (%505 ((%611 $6) %591))) ((%6 (%612 (\%613.
       ((%6 ((%614 $0) (%619 %607))) ((%566 (%615 ((%610 $7) $1))) (%615
       (%616 $0))))))) (%612 (\%613. ((%6 ((%614 $0) (%619 %607))) (%617
       (\%618. ((%24 (%505 ((%611 $0) %591))) ((%611 (%616 $1)) ((%610 $0)
       $2)))))))))))))))))))))))))))))))`)
  val pdaTransOnPfxLd =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%113 (\%236. (%492 (\%568. (%492 (\%569. (%536
       (\%570. (%536 (\%571. ((%6 ((((%551 (%528 %476)) %565) ((%530 $5)
       ((%531 ((%312 $3) $2)) ((%474 $1) $0)))) ((%530 $4) ((%531 $2)
       $0)))) ((%6 (%572 (\%573. ((%6 ((%574 $0) (%575 %565))) (%547
       (\%539. ((%24 (%505 ((%472 $0) %544))) ((%472 (%576 $1)) ((%474 $0)
       $2))))))))) (%552 (\%550. ((%24 ((%566 (%620 $0)) (%620 %565)))
       ((((%551 (%528 %476)) $0) ((%530 $6) ((%531 $4) $2))) ((%530 $5)
       ((%531 %489) %544))))))))))))))))))))`)
  val stackRedGen =
    DT(["DISK_THM"], [],
       `((%6 ((%24 ((%47 (%621 (%622 %554))) %18)) ((%24 (%505 ((%303 %554)
       %185))) (%623 (\%624. ((%6 ((%24 ((%625 ((%49 $0) (%50 (%51 %52))))
       (%626 %554))) ((%625 (%621 ((%627 ((%49 $0) (%50 (%51 %52))))
       %554))) (%621 ((%627 $0) %554))))) ((%47 (%621 ((%627 $0) %554)))
       ((%49 (%621 ((%627 ((%49 $0) (%50 (%51 %52)))) %554))) (%50 (%51
       %52)))))))))) (%623 (\%22. ((%6 ((%566 $0) (%621 (%628 %554))))
       (%629 (\%624. ((%24 ((%47 (%621 ((%627 $0) %554))) $1)) ((%24 ((%625
       $0) (%626 %554))) (%623 (\%630. ((%6 ((%625 $0) $1)) ((%625 $2)
       (%621 ((%627 $0) %554))))))))))))))`)
  val ldIdcStkLen =
    DT(["MK_THM"], [],
       `(%549 (\%550. (%113 (\%237. (%492 (\%577. (%536 (\%541. (%113
       (\%236. (%492 (\%578. (%536 (\%564. ((%6 ((((%551 (%528 %476)) $6)
       ((%530 $5) ((%531 $4) $3))) ((%530 $2) ((%531 $1) $0)))) (%623
       (\%624. ((%6 ((%24 ((%625 ((%49 $0) (%50 (%51 %52)))) (%620 $7)))
       ((%625 (%631 ((%632 ((%49 $0) (%50 (%51 %52)))) $7))) (%631 ((%632
       $0) $7))))) ((%47 (%631 ((%632 $0) $7))) ((%49 (%631 ((%632 ((%49
       $0) (%50 (%51 %52)))) $7))) (%50 (%51 %52))))))))))))))))))))))`)
  val idcInpSplit =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%538. (%536 (\%541. (%113 (\%236. (%492
       (\%542. (%536 (\%564. ((%6 ((((%551 (%528 %476)) %565) ((%530 $5)
       ((%531 $4) $3))) ((%530 $2) ((%531 $1) $0)))) (%226 (\%568. ((%311
       $5) ((%312 $0) $2)))))))))))))))))`)
  val rtc2listIdStkNil =
    DT(["DISK_THM"], [],
       `((%6 ((%633 (%528 %476)) ((%634 ((%530 %237) ((%531 %538) %544)))
       %635))) ((%636 %635) %637))`)
  val idcStkLastSplit =
    DT(["DISK_THM"], [],
       `(%549 (\%565. (%113 (\%237. (%492 (\%538. (%536 (\%541. (%113
       (\%236. (%492 (\%542. (%536 (\%564. ((%6 ((((%551 (%528 %476)) $6)
       ((%530 $5) ((%531 $4) $3))) ((%530 $2) ((%531 $1) $0)))) ((%6 (%113
       (\%638. (%492 (\%639. (%536 (\%640. ((%6 ((%574 ((%530 $2) ((%531
       $1) $0))) (%575 $9))) ((%566 (%351 $6)) (%351 $0)))))))))) ((%320
       ((%472 $3) %544)) (%547 (\%539. ((%472 $1) ((%474 $0) (%641
       $4))))))))))))))))))))))`)
  val frontLem1 =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%577. (%536 (\%533. (%113 (\%642. (%492
       (\%596. (%536 (\%643. (%170 (\%644. ((%6 ((%24 ((((%551 (%528 %476))
       %565) ((%530 $6) ((%531 $5) $4))) ((%530 $3) ((%531 $2) $1)))) (%113
       (\%236. (%492 (\%542. (%536 (\%564. ((%6 ((%574 ((%530 $2) ((%531
       $1) $0))) %565)) ((%566 (%351 $7)) (%351 $0))))))))))) (%547 (\%645.
       (%547 (\%646. (%547 (\%647. ((%24 ((%472 $7) ((%474 $2) $1))) ((%472
       $4) ((%474 $0) $1))))))))))))))))))))))))`)
  val frontLem1' =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%577. (%536 (\%533. (%113 (\%642. (%492
       (\%596. (%536 (\%643. (%170 (\%644. ((%6 ((%24 ((((%551 (%528 %476))
       %565) ((%530 $6) ((%531 $5) $4))) ((%530 $3) ((%531 $2) $1)))) ((%24
       (%505 ((%472 $4) %544))) (%113 (\%236. (%492 (\%542. (%536 (\%564.
       ((%6 ((%574 ((%530 $2) ((%531 $1) $0))) %565)) ((%566 (%351 $7))
       (%351 $0)))))))))))) (%547 (\%646. (%547 (\%647. ((%24 ((%472 $6)
       ((%543 (%648 $6)) $1))) ((%472 $3) ((%474 $0)
       $1))))))))))))))))))))))`)
  val lem1 =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%577. (%536 (\%533. (%113 (\%642. (%492
       (\%596. (%536 (\%643. (%170 (\%644. ((%6 ((%24 ((((%551 (%528 %476))
       %565) ((%530 $6) ((%531 $5) $4))) ((%530 $3) ((%531 $2) $1)))) ((%47
       (%351 $1)) ((%649 (%351 $4)) (%50 (%51 %52)))))) ((%6 (%505 ((%472
       $4) %544))) ((%6 (%113 (\%236. (%492 (\%542. (%536 (\%564. ((%6
       ((%574 ((%530 $2) ((%531 $1) $0))) (%575 %565))) ((%566 (%351 $7))
       (%351 $0)))))))))) ((%472 $4) ((%543 (%648 $4))
       $1)))))))))))))))))))`)
  val ldIdcSplit =
    DT(["DISK_THM", "MK_THM"], [],
       `(%549 (\%565. (%113 (\%237. (%492 (\%577. (%536 (\%533. (%113
       (\%650. ((%6 ((((%551 (%528 %476)) $4) ((%530 $3) ((%531 $2) $1)))
       ((%530 $0) ((%531 %489) %544)))) (%552 (\%651. (%96 (\%642. (%226
       (\%596. (%547 (\%643. (%450 (\%644. ((%24 ((((%551 (%528 %476)) $4)
       ((%530 $8) ((%531 $7) $6))) ((%530 $3) ((%531 $2) $1)))) ((%24 ((%47
       (%351 $1)) ((%649 (%351 $6)) (%50 (%51 %52))))) ((%24 (%113 (\%236.
       (%492 (\%542. (%536 (\%564. ((%6 ((%574 ((%530 $2) ((%531 $1) $0)))
       (%575 $7))) ((%566 (%351 $9)) (%351 $0)))))))))) ((%320 (%552
       (\%652. ((%24 ((((%551 (%528 %476)) $0) ((%530 $4) ((%531 $3) $2)))
       ((%530 $6) ((%531 %489) %544)))) ((%24 ((%625 (%620 $0)) (%620
       $10))) ((%625 (%620 $5)) (%620 $10))))))) ((%653 ((%530 $3) ((%531
       $2) $1))) ((%530 $5) ((%531 %489) %544))))))))))))))))))))))))))))`)
  val idcStkNil =
    DT(["DISK_THM"], [],
       `(%572 (\%654. (%572 (\%655. ((%6 (((%527 (%528 %476)) $1) $0)) ((%6
       ((%653 $1) ((%530 %237) ((%531 %538) %544)))) ((%6 ((%653 $0) ((%530
       %236) ((%531 %542) %544)))) ((%653 $1) $0))))))))`)
  val rtc2listLastMemState =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%538. (%536 (\%541. (%549 (\%635. ((%6 ((%24
       ((%633 (%528 %476)) ((%634 ((%530 $3) ((%531 $2) $1))) $0))) (%505
       ((%636 $0) %637)))) ((%656 (%657 (%658 $0))) ((%477 %476) (%478
       %476))))))))))))`)
  val rtc2listFstMemState =
    DT(["DISK_THM"], [],
       `(%113 (\%237. (%492 (\%538. (%536 (\%541. (%549 (\%635. ((%6 ((%24
       ((%633 (%528 %476)) ((%634 ((%530 $3) ((%531 $2) $1))) $0))) (%505
       ((%636 $0) %637)))) ((%656 $3) ((%477 %476) (%478 %476))))))))))))`)
  end
  val _ = DB.bindl "pdaDef"
  [("pda_TY_DEF",pda_TY_DEF,DB.Def), ("pda_repfns",pda_repfns,DB.Def),
   ("pda_case_def",pda_case_def,DB.Def),
   ("pda_size_def",pda_size_def,DB.Def), ("pda_start",pda_start,DB.Def),
   ("pda_ssSym",pda_ssSym,DB.Def), ("pda_next",pda_next,DB.Def),
   ("pda_final",pda_final,DB.Def),
   ("pda_start_fupd",pda_start_fupd,DB.Def),
   ("pda_ssSym_fupd",pda_ssSym_fupd,DB.Def),
   ("pda_next_fupd",pda_next_fupd,DB.Def),
   ("pda_final_fupd",pda_final_fupd,DB.Def),
   ("inpSyms_def",inpSyms_def,DB.Def),
   ("inpSymsList_primitive_def",inpSymsList_primitive_def,DB.Def),
   ("stkSyms_def",stkSyms_def,DB.Def),
   ("stkSymsList'_primitive_def",stkSymsList'_primitive_def,DB.Def),
   ("stkSymsList_def",stkSymsList_def,DB.Def),
   ("states_def",states_def,DB.Def),
   ("statesList'_primitive_def",statesList'_primitive_def,DB.Def),
   ("statesList_def",statesList_def,DB.Def),
   ("pdastk_def",pdastk_def,DB.Def), ("pdainp_def",pdainp_def,DB.Def),
   ("pdastate_def",pdastate_def,DB.Def),
   ("ID_tupled_primitive_def",ID_tupled_primitive_def,DB.Def),
   ("ID_curried_def",ID_curried_def,DB.Def), ("IDC_def",IDC_def,DB.Def),
   ("lafs_def",lafs_def,DB.Def), ("laes_def",laes_def,DB.Def),
   ("stkLen_def",stkLen_def,DB.Def),
   ("pda_accessors",pda_accessors,DB.Thm),
   ("pda_fn_updates",pda_fn_updates,DB.Thm),
   ("pda_accfupds",pda_accfupds,DB.Thm),
   ("pda_fupdfupds",pda_fupdfupds,DB.Thm),
   ("pda_fupdfupds_comp",pda_fupdfupds_comp,DB.Thm),
   ("pda_fupdcanon",pda_fupdcanon,DB.Thm),
   ("pda_fupdcanon_comp",pda_fupdcanon_comp,DB.Thm),
   ("pda_component_equality",pda_component_equality,DB.Thm),
   ("pda_updates_eq_literal",pda_updates_eq_literal,DB.Thm),
   ("pda_literal_nchotomy",pda_literal_nchotomy,DB.Thm),
   ("FORALL_pda",FORALL_pda,DB.Thm), ("EXISTS_pda",EXISTS_pda,DB.Thm),
   ("pda_literal_11",pda_literal_11,DB.Thm),
   ("datatype_pda",datatype_pda,DB.Thm), ("pda_11",pda_11,DB.Thm),
   ("pda_case_cong",pda_case_cong,DB.Thm),
   ("pda_nchotomy",pda_nchotomy,DB.Thm), ("pda_Axiom",pda_Axiom,DB.Thm),
   ("pda_induction",pda_induction,DB.Thm),
   ("inpSymsList_ind",inpSymsList_ind,DB.Thm),
   ("inpSymsList_def",inpSymsList_def,DB.Thm),
   ("FORALL_trans",FORALL_trans,DB.Thm),
   ("EXISTS_trans",EXISTS_trans,DB.Thm),
   ("inpSyms_list_eqresult",inpSyms_list_eqresult,DB.Thm),
   ("stkSymsList'_ind",stkSymsList'_ind,DB.Thm),
   ("stkSymsList'_def",stkSymsList'_def,DB.Thm),
   ("ssymslApp",ssymslApp,DB.Thm), ("memssl'",memssl',DB.Thm),
   ("stkSyms_list_eqresult",stkSyms_list_eqresult,DB.Thm),
   ("statesList'_ind",statesList'_ind,DB.Thm),
   ("statesList'_def",statesList'_def,DB.Thm), ("memstl'",memstl',DB.Thm),
   ("statesListApp",statesListApp,DB.Thm),
   ("states_list_eqresult",states_list_eqresult,DB.Thm),
   ("finiteInpSyms",finiteInpSyms,DB.Thm),
   ("finiteStkSyms",finiteStkSyms,DB.Thm),
   ("finiteStates",finiteStates,DB.Thm), ("ID_ind",ID_ind,DB.Thm),
   ("ID_def",ID_def,DB.Thm), ("new_ssym_exists",new_ssym_exists,DB.Thm),
   ("new_state_exists",new_state_exists,DB.Thm),
   ("memStateRule",memStateRule,DB.Thm), ("memState",memState,DB.Thm),
   ("idStackInsert",idStackInsert,DB.Thm),
   ("idcStackInsert",idcStackInsert,DB.Thm), ("idStkPop",idStkPop,DB.Thm),
   ("idcStkPop",idcStkPop,DB.Thm), ("idInpInsert",idInpInsert,DB.Thm),
   ("idcInpInsert",idcInpInsert,DB.Thm), ("id_thm",id_thm,DB.Thm),
   ("ldIdcInpLen",ldIdcInpLen,DB.Thm),
   ("pdaTransOnPfx",pdaTransOnPfx,DB.Thm),
   ("ldIdcInpSuffix",ldIdcInpSuffix,DB.Thm),
   ("frontdlProp",frontdlProp,DB.Thm),
   ("frontdlPropGen",frontdlPropGen,DB.Thm), ("dlprop",dlprop,DB.Thm),
   ("dlpropGen",dlpropGen,DB.Thm),
   ("pdaTransOnPfxLd",pdaTransOnPfxLd,DB.Thm),
   ("stackRedGen",stackRedGen,DB.Thm), ("ldIdcStkLen",ldIdcStkLen,DB.Thm),
   ("idcInpSplit",idcInpSplit,DB.Thm),
   ("rtc2listIdStkNil",rtc2listIdStkNil,DB.Thm),
   ("idcStkLastSplit",idcStkLastSplit,DB.Thm),
   ("frontLem1",frontLem1,DB.Thm), ("frontLem1'",frontLem1',DB.Thm),
   ("lem1",lem1,DB.Thm), ("ldIdcSplit",ldIdcSplit,DB.Thm),
   ("idcStkNil",idcStkNil,DB.Thm),
   ("rtc2listLastMemState",rtc2listLastMemState,DB.Thm),
   ("rtc2listFstMemState",rtc2listFstMemState,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("relationLemmasTheory.relationLemmas_grammars",
                          relationLemmasTheory.relationLemmas_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_type_abbrev
       ("trans", T"prod" "pair"
 [T"prod" "pair"
   [T"option" "option" [U"'isym"],
    T"prod" "pair" [U"'ssym", U"'state"]],
  T"prod" "pair" [U"'state", T"list" "list" [U"'ssym"]]])
  val _ = update_grms temp_add_type "pda"
  val _ = update_grms
       temp_overload_on
       ("dest_pda", (Term.prim_mk_const { Name = "dest_pda", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("mk_pda", (Term.prim_mk_const { Name = "mk_pda", Thy = "pdaDef"}))
  
  val _ = update_grms
       temp_overload_on
       ("pda", (Term.prim_mk_const { Name = "pda", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_case", (Term.prim_mk_const { Name = "pda_case", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_size", (Term.prim_mk_const { Name = "pda_size", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_start", (Term.prim_mk_const { Name = "pda_start", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_ssSym", (Term.prim_mk_const { Name = "pda_ssSym", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_next", (Term.prim_mk_const { Name = "pda_next", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_final", (Term.prim_mk_const { Name = "pda_final", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_start_fupd", (Term.prim_mk_const { Name = "pda_start_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_ssSym_fupd", (Term.prim_mk_const { Name = "pda_ssSym_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_next_fupd", (Term.prim_mk_const { Name = "pda_next_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pda_final_fupd", (Term.prim_mk_const { Name = "pda_final_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record selectstart", (Term.prim_mk_const { Name = "pda_start", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record selectssSym", (Term.prim_mk_const { Name = "pda_ssSym", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record selectnext", (Term.prim_mk_const { Name = "pda_next", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record selectfinal", (Term.prim_mk_const { Name = "pda_final", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("start_fupd", (Term.prim_mk_const { Name = "pda_start_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("ssSym_fupd", (Term.prim_mk_const { Name = "pda_ssSym_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("next_fupd", (Term.prim_mk_const { Name = "pda_next_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("final_fupd", (Term.prim_mk_const { Name = "pda_final_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record fupdatestart", (Term.prim_mk_const { Name = "pda_start_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record fupdatessSym", (Term.prim_mk_const { Name = "pda_ssSym_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record fupdatenext", (Term.prim_mk_const { Name = "pda_next_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       (" _ record fupdatefinal", (Term.prim_mk_const { Name = "pda_final_fupd", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("inpSyms", (Term.prim_mk_const { Name = "inpSyms", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("inpSymsList", (Term.prim_mk_const { Name = "inpSymsList", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("stkSyms", (Term.prim_mk_const { Name = "stkSyms", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("stkSymsList'", (Term.prim_mk_const { Name = "stkSymsList'", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("stkSymsList", (Term.prim_mk_const { Name = "stkSymsList", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("states", (Term.prim_mk_const { Name = "states", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("statesList'", (Term.prim_mk_const { Name = "statesList'", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("statesList", (Term.prim_mk_const { Name = "statesList", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pdastk", (Term.prim_mk_const { Name = "pdastk", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pdainp", (Term.prim_mk_const { Name = "pdainp", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("pdastate", (Term.prim_mk_const { Name = "pdastate", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("ID_tupled", (Term.prim_mk_const { Name = "ID_tupled", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("ID", (Term.prim_mk_const { Name = "ID", Thy = "pdaDef"}))
  val _ = update_grms
       temp_add_rule
       {term_name = "ID", fixity = Infix(HOLgrammars.NONASSOC, 550),
pp_elements = [BreakSpace(1, 1), TOK "\226\138\162", BreakSpace(1, 2), BeginFinalBlock (INCONSISTENT, 2), TM, HardSpace 1, TOK "\226\134\146", BreakSpace(1, 2)],
paren_style = OnlyIfNecessary,
block_style = (AroundEachPhrase, (INCONSISTENT, 2))}
  val _ = update_grms
       temp_overload_on
       ("IDC", (Term.prim_mk_const { Name = "IDC", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("lafs", (Term.prim_mk_const { Name = "lafs", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("laes", (Term.prim_mk_const { Name = "laes", Thy = "pdaDef"}))
  val _ = update_grms
       temp_overload_on
       ("stkLen", (Term.prim_mk_const { Name = "stkLen", Thy = "pdaDef"}))
  val pdaDef_grammars = Parse.current_lgrms()
  end
  
  
  
  
  val pdaDef_rwts = simpLib.named_rewrites "pdaDef_rwts" [
            inpSymsList_def];
  val _ = BasicProvers.augment_srw_ss [pdaDef_rwts]

  
  val _ =
    TypeBase.write [
      let
        open TypeBasePure
        val tyinfo0 = mk_datatype_info
          {ax=ORIG pda_Axiom,
           case_def=pda_case_def,
           case_cong=pda_case_cong,
           induction=ORIG pda_induction,
           nchotomy=pda_nchotomy,
           size=SOME(Parse.Term`(pdaDef$pda_size) :('isym -> (num$num)) ->
('ssym -> (num$num)) ->
('state -> (num$num)) ->
(('isym, 'ssym, 'state) pdaDef$pda) -> (num$num)`,
                     ORIG pda_size_def),
           encode = NONE,
           lift=NONE,
           one_one=SOME pda_11,
           distinct=NONE,
           fields=let fun T t s A = mk_thy_type{Thy=t,Tyop=s,Args=A}
    val U = mk_vartype
in
[("start",U"'state"), ("ssSym",U"'ssym"),
 ("next",T"list" "list"
          [T"pair" "prod"
            [T"pair" "prod"
              [T"option" "option" [U"'isym"],
               T"pair" "prod" [U"'ssym", U"'state"]],
             T"pair" "prod"
              [U"'state", T"list" "list" [U"'ssym"]]]]),
 ("final",T"list" "list" [U"'state"])] end,
           accessors=Drule.CONJUNCTS pda_accessors,
           updates=Drule.CONJUNCTS pda_fn_updates}
        val tyinfo0 = RecordType.update_tyinfo NONE [pda_accessors, pda_updates_eq_literal, pda_accfupds, pda_fupdfupds, pda_literal_11, pda_fupdfupds_comp, pda_fupdcanon, pda_fupdcanon_comp] tyinfo0
        val () = computeLib.write_datatype_info tyinfo0
      in
        tyinfo0
      end
    ];
  
  
  val _ = computeLib.add_funs [inpSyms_def];  
  
  val _ = computeLib.add_funs [inpSymsList_def];  
  
  val _ = computeLib.add_funs [stkSyms_def];  
  
  val _ = computeLib.add_funs [stkSymsList'_def];  
  
  val _ = computeLib.add_funs [stkSymsList_def];  
  
  val _ = computeLib.add_funs [states_def];  
  
  val _ = computeLib.add_funs [statesList'_def];  
  
  val _ = computeLib.add_funs [statesList_def];  
  
  val _ = computeLib.add_funs [pdastk_def];  
  
  val _ = computeLib.add_funs [pdainp_def];  
  
  val _ = computeLib.add_funs [pdastate_def];  
  
  val _ = computeLib.add_funs [ID_def];  
  
  val _ = computeLib.add_funs [IDC_def];  
  
  val _ = computeLib.add_funs [lafs_def];  
  
  val _ = computeLib.add_funs [laes_def];  
  
  val _ = computeLib.add_funs [stkLen_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
