structure pdaEqCfgTheory :> pdaEqCfgTheory =
struct
  val _ = if !Globals.print_thy_loads then print "Loading pdaEqCfgTheory ... " else ()
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open grammarDefTheory pdaDefTheory
  in end;
  val _ = Theory.link_parents
          ("pdaEqCfg",
          Arbnum.fromString "1259525660",
          Arbnum.fromString "860045")
          [("pdaDef",
           Arbnum.fromString "1259522262",
           Arbnum.fromString "507894"),
           ("grammarDef",
           Arbnum.fromString "1259448278",
           Arbnum.fromString "141041")];
  val _ = Theory.incorporate_types "pdaEqCfg" [];
  val _ = Theory.incorporate_consts "pdaEqCfg"
     [("validGnfProd",((T"rule" "grammarDef" [alpha, beta] --> bool))),
      ("tuptost",
       ((T"prod" "pair"
          [beta, T"prod" "pair" [gamma, T"prod" "pair" [delta, alpha]]] -->
         alpha))),
      ("tupstk",
       ((T"prod" "pair"
          [beta, T"prod" "pair" [gamma, T"prod" "pair" [alpha, delta]]] -->
         alpha))),
      ("tupinp",
       ((T"prod" "pair"
          [beta, T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]]] -->
         alpha))),
      ("tupfrmst",
       ((T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
         alpha))),
      ("transToState",
       ((T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
         alpha))),
      ("transSym",
       ((T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
         alpha))),
      ("transFrmState",
       ((T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
         alpha))),
      ("trans",
       ((U"'state" -->
         (T"rule" "grammarDef" [beta, U"'isym"] -->
          T"prod" "pair"
           [T"prod" "pair"
             [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
              T"prod" "pair"
               [T"symbol" "regexp" [beta, U"'isym"], U"'state"]],
            T"prod" "pair"
             [U"'state",
              T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]])))),
      ("toRhs",
       ((T"prod" "pair"
          [alpha, T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]] -->
         T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta]))),
      ("pda2grammar",
       ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta]
         -->
         (T"grammar" "grammarDef"
           [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]
          --> bool)))),
      ("p2gtrans",
       ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta]
         -->
         (T"rule" "grammarDef"
           [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]
          --> bool)))),
      ("ntslCond",
       ((T"pda" "pdaDef" [alpha, beta, gamma] -->
         (T"prod" "pair" [gamma, T"prod" "pair" [gamma, delta]] -->
          (T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]],
               U"'f"]] --> bool))))),
      ("nextToStk",
       ((T"prod" "pair"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]],
           T"prod" "pair" [U"'e", alpha]] --> alpha))),
      ("isGnf",((T"grammar" "grammarDef" [alpha, beta] --> bool))),
      ("grammar2pda",
       ((T"grammar" "grammarDef" [U"'n", U"'t"] -->
         (U"'state" -->
          T"pda" "pdaDef"
           [T"symbol" "regexp" [U"'n", U"'t"],
            T"symbol" "regexp" [U"'n", U"'t"], U"'state"])))),
      ("adj_tupled",
       ((T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
           T"symbol" "regexp"
            [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
         --> bool))),
      ("adj",
       ((T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
         (T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]
          --> bool))))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" (((alpha --> bool) --> bool)), V"l" (alpha),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"r" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"validGnfProd" "pdaEqCfg"
    ((T"rule" "grammarDef" [alpha, beta] --> bool)),
   C"rule" "grammarDef"
    ((alpha -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"rule" "grammarDef" [alpha, beta]))),
   C"?" "bool" (((T"symbol" "regexp" [alpha, beta] --> bool) --> bool)),
   V"ts" (T"symbol" "regexp" [alpha, beta]),
   C"?" "bool"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)), V"ntsl" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"CONS" "list"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"EVERY" "list"
    (((T"symbol" "regexp" [alpha, beta] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"isNonTmnlSym" "regexp" ((T"symbol" "regexp" [alpha, beta] --> bool)),
   C"!" "bool"
    (((T"grammar" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"g" (T"grammar" "grammarDef" [alpha, beta]),
   C"isGnf" "pdaEqCfg" ((T"grammar" "grammarDef" [alpha, beta] --> bool)),
   C"EVERY" "list"
    (((T"rule" "grammarDef" [alpha, beta] --> bool) -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      T"list" "list" [T"rule" "grammarDef" [alpha, beta]])),
   C"!" "bool" (((U"'state" --> bool) --> bool)), V"q" (U"'state"),
   C"!" "bool" (((beta --> bool) --> bool)), V"l" (beta),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]] --> bool) -->
      bool)), V"r" (T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
          T"prod" "pair" [T"symbol" "regexp" [beta, U"'isym"], U"'state"]],
        T"prod" "pair"
         [U"'state", T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]]
      -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
           T"prod" "pair"
            [T"symbol" "regexp" [beta, U"'isym"], U"'state"]],
         T"prod" "pair"
          [U"'state",
           T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]] -->
       bool))),
   C"trans" "pdaEqCfg"
    ((U"'state" -->
      (T"rule" "grammarDef" [beta, U"'isym"] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
           T"prod" "pair"
            [T"symbol" "regexp" [beta, U"'isym"], U"'state"]],
         T"prod" "pair"
          [U"'state",
           T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]]))),
   C"rule" "grammarDef"
    ((beta -->
      (T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]] -->
       T"rule" "grammarDef" [beta, U"'isym"]))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
        T"prod" "pair" [T"symbol" "regexp" [beta, U"'isym"], U"'state"]]
      -->
      (T"prod" "pair"
        [U"'state", T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]
       -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
           T"prod" "pair"
            [T"symbol" "regexp" [beta, U"'isym"], U"'state"]],
         T"prod" "pair"
          [U"'state",
           T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]]))),
   C"," "pair"
    ((T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]] -->
      (T"prod" "pair" [T"symbol" "regexp" [beta, U"'isym"], U"'state"] -->
       T"prod" "pair"
        [T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]],
         T"prod" "pair"
          [T"symbol" "regexp" [beta, U"'isym"], U"'state"]]))),
   C"SOME" "option"
    ((T"symbol" "regexp" [beta, U"'isym"] -->
      T"option" "option" [T"symbol" "regexp" [beta, U"'isym"]])),
   C"HD" "list"
    ((T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]] -->
      T"symbol" "regexp" [beta, U"'isym"])),
   C"," "pair"
    ((T"symbol" "regexp" [beta, U"'isym"] -->
      (U"'state" -->
       T"prod" "pair" [T"symbol" "regexp" [beta, U"'isym"], U"'state"]))),
   C"NTS" "regexp" ((beta --> T"symbol" "regexp" [beta, U"'isym"])),
   C"," "pair"
    ((U"'state" -->
      (T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]] -->
       T"prod" "pair"
        [U"'state",
         T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]]]))),
   C"TL" "list"
    ((T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]] -->
      T"list" "list" [T"symbol" "regexp" [beta, U"'isym"]])),
   C"!" "bool"
    (((T"grammar" "grammarDef" [U"'n", U"'t"] --> bool) --> bool)),
   V"g" (T"grammar" "grammarDef" [U"'n", U"'t"]),
   C"=" "min"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [U"'n", U"'t"],
        T"symbol" "regexp" [U"'n", U"'t"], U"'state"] -->
      (T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"] --> bool))),
   C"grammar2pda" "pdaEqCfg"
    ((T"grammar" "grammarDef" [U"'n", U"'t"] -->
      (U"'state" -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   C"LET" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   V"ts"
    (T"list" "list"
      [T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
           T"prod" "pair" [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
         T"prod" "pair"
          [U"'state",
           T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]]),
   C"pda_start_fupd" "pdaDef"
    (((U"'state" --> U"'state") -->
      (T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   C"K" "combin" ((U"'state" --> (U"'state" --> U"'state"))),
   C"pda_ssSym_fupd" "pdaDef"
    (((T"symbol" "regexp" [U"'n", U"'t"] -->
       T"symbol" "regexp" [U"'n", U"'t"]) -->
      (T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   C"K" "combin"
    ((T"symbol" "regexp" [U"'n", U"'t"] -->
      (T"symbol" "regexp" [U"'n", U"'t"] -->
       T"symbol" "regexp" [U"'n", U"'t"]))),
   C"NTS" "regexp" ((U"'n" --> T"symbol" "regexp" [U"'n", U"'t"])),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef" [U"'n", U"'t"] --> U"'n")),
   C"pda_next_fupd" "pdaDef"
    (((T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]]) -->
      (T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   C"K" "combin"
    ((T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
            T"prod" "pair" [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
          T"prod" "pair"
           [U"'state",
            T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]]))),
   C"pda_final_fupd" "pdaDef"
    (((T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]) -->
      (T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"] -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'n", U"'t"],
         T"symbol" "regexp" [U"'n", U"'t"], U"'state"]))),
   C"K" "combin"
    ((T"list" "list" [U"'state"] -->
      (T"list" "list" [U"'state"] --> T"list" "list" [U"'state"]))),
   C"NIL" "list" (T"list" "list" [U"'state"]),
   C"ARB" "bool"
    (T"pda" "pdaDef"
      [T"symbol" "regexp" [U"'n", U"'t"],
       T"symbol" "regexp" [U"'n", U"'t"], U"'state"]),
   C"MAP" "list"
    (((T"rule" "grammarDef" [U"'n", U"'t"] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
           T"prod" "pair" [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
         T"prod" "pair"
          [U"'state", T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]])
      -->
      (T"list" "list" [T"rule" "grammarDef" [U"'n", U"'t"]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
             T"prod" "pair"
              [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
           T"prod" "pair"
            [U"'state",
             T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]]))),
   C"trans" "pdaEqCfg"
    ((U"'state" -->
      (T"rule" "grammarDef" [U"'n", U"'t"] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [U"'n", U"'t"]],
           T"prod" "pair" [T"symbol" "regexp" [U"'n", U"'t"], U"'state"]],
         T"prod" "pair"
          [U"'state",
           T"list" "list" [T"symbol" "regexp" [U"'n", U"'t"]]]]))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef" [U"'n", U"'t"] -->
      T"list" "list" [T"rule" "grammarDef" [U"'n", U"'t"]])),
   C"=" "min"
    (((T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       --> bool) -->
      ((T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        --> bool) --> bool))),
   C"adj_tupled" "pdaEqCfg"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
        T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
      --> bool)),
   C"WFREC" "relation"
    (((T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       -->
       (T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        --> bool)) -->
      (((T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
           T"symbol" "regexp"
            [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
         --> bool) -->
        (T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
           T"symbol" "regexp"
            [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
         --> bool)) -->
       (T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        --> bool)))),
   C"@" "min"
    ((((T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        -->
        (T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
           T"symbol" "regexp"
            [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
         --> bool)) --> bool) -->
      (T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       -->
       (T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        --> bool)))),
   V"R"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
        T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
      -->
      (T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       --> bool))),
   C"WF" "relation"
    (((T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       -->
       (T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
          T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
        --> bool)) --> bool)),
   V"adj_tupled"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
        T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
      --> bool)),
   V"a"
    (T"prod" "pair"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
       T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]),
   C"pair_case" "pair"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
        bool)) -->
      (T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]]
       --> bool))),
   V"v"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta]),
   V"v1"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]),
   C"symbol_case" "regexp"
    (((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> bool) -->
      ((delta --> bool) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        bool)))),
   V"v2" (T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]]),
   C"pair_case" "pair"
    (((alpha --> (T"prod" "pair" [beta, gamma] --> bool)) -->
      (T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> bool))),
   V"q" (alpha), V"v6" (T"prod" "pair" [beta, gamma]),
   C"pair_case" "pair"
    (((beta --> (gamma --> bool)) -->
      (T"prod" "pair" [beta, gamma] --> bool))), V"e" (beta),
   V"q'" (gamma),
   C"symbol_case" "regexp"
    (((T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]] --> bool) -->
      ((U"'g" --> bool) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
        bool)))),
   V"v9" (T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]]),
   C"pair_case" "pair"
    (((gamma --> (T"prod" "pair" [U"'e", U"'f"] --> bool)) -->
      (T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]] --> bool))),
   V"r" (gamma), V"v13" (T"prod" "pair" [U"'e", U"'f"]),
   C"pair_case" "pair"
    (((U"'e" --> (U"'f" --> bool)) -->
      (T"prod" "pair" [U"'e", U"'f"] --> bool))), V"e'" (U"'e"),
   V"r'" (U"'f"), C"I" "combin" ((bool --> bool)),
   C"=" "min" ((gamma --> (gamma --> bool))), V"v10" (U"'g"),
   C"ARB" "bool" (bool), V"v3" (delta),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       bool) --> bool)),
   V"x"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta]),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
       bool) --> bool)),
   V"x1"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]),
   C"adj" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
       bool))),
   C"," "pair"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
       T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta],
         T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]],
           U"'g"]]))),
   C"=" "min"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       alpha) -->
      ((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        alpha) --> bool))),
   C"transSym" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
      alpha)),
   C"WFREC" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        bool)) -->
      (((T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
         alpha) -->
        (T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
         alpha)) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        alpha)))),
   C"@" "min"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        (T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
         bool)) --> bool) -->
      (T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        bool)))),
   V"R"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       bool))),
   C"WF" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        bool)) --> bool)),
   V"transSym"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
      alpha)),
   V"a"
    (T"symbol" "regexp"
      [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta]),
   C"symbol_case" "regexp"
    (((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] --> alpha) -->
      ((delta --> alpha) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        alpha)))),
   V"v" (T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]]),
   C"pair_case" "pair"
    (((beta --> (T"prod" "pair" [alpha, gamma] --> alpha)) -->
      (T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] --> alpha))),
   V"st" (beta), V"v4" (T"prod" "pair" [alpha, gamma]),
   C"pair_case" "pair"
    (((alpha --> (gamma --> alpha)) -->
      (T"prod" "pair" [alpha, gamma] --> alpha))), V"sym" (alpha),
   V"st'" (gamma), C"I" "combin" ((alpha --> alpha)), V"v1" (delta),
   C"ARB" "bool" (alpha),
   C"=" "min"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       alpha) -->
      ((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        alpha) --> bool))),
   C"transToState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
      alpha)),
   C"WFREC" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        bool)) -->
      (((T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
         alpha) -->
        (T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
         alpha)) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        alpha)))),
   C"@" "min"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        (T"symbol" "regexp"
          [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
         bool)) --> bool) -->
      (T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        bool)))),
   V"R"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       bool))),
   C"WF" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        bool)) --> bool)),
   V"transToState"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
      alpha)),
   V"a"
    (T"symbol" "regexp"
      [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta]),
   C"symbol_case" "regexp"
    (((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] --> alpha) -->
      ((delta --> alpha) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        alpha)))),
   V"v" (T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]),
   C"pair_case" "pair"
    (((beta --> (T"prod" "pair" [gamma, alpha] --> alpha)) -->
      (T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] --> alpha))),
   V"v4" (T"prod" "pair" [gamma, alpha]),
   C"pair_case" "pair"
    (((gamma --> (alpha --> alpha)) -->
      (T"prod" "pair" [gamma, alpha] --> alpha))), V"sym" (gamma),
   V"st'" (alpha),
   C"=" "min"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       alpha) -->
      ((T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        alpha) --> bool))),
   C"transFrmState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      alpha)),
   C"WFREC" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        bool)) -->
      (((T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
         alpha) -->
        (T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
         alpha)) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        alpha)))),
   C"@" "min"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        (T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
         bool)) --> bool) -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        bool)))),
   V"R"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       bool))),
   C"WF" "relation"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        bool)) --> bool)),
   V"transFrmState"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      alpha)),
   V"a"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta]),
   C"symbol_case" "regexp"
    (((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> alpha) -->
      ((delta --> alpha) -->
       (T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        alpha)))),
   V"v" (T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]]),
   C"pair_case" "pair"
    (((alpha --> (T"prod" "pair" [beta, gamma] --> alpha)) -->
      (T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] --> alpha))),
   V"st" (alpha), V"v4" (T"prod" "pair" [beta, gamma]),
   C"pair_case" "pair"
    (((beta --> (gamma --> alpha)) -->
      (T"prod" "pair" [beta, gamma] --> alpha))), V"sym" (beta),
   C"!" "bool"
    (((T"pda" "pdaDef" [alpha, beta, gamma] --> bool) --> bool)),
   V"m" (T"pda" "pdaDef" [alpha, beta, gamma]),
   C"!" "bool" (((gamma --> bool) --> bool)), V"ql" (gamma),
   C"!" "bool" (((delta --> bool) --> bool)), V"mrhs" (delta),
   C"!" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       --> bool) --> bool)),
   V"ntsl"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]),
   C"ntslCond" "pdaEqCfg"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"prod" "pair" [gamma, T"prod" "pair" [gamma, delta]] -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
        --> bool)))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair" [gamma, T"prod" "pair" [gamma, delta]]))),
   C"," "pair" ((gamma --> (delta --> T"prod" "pair" [gamma, delta]))),
   C"EVERY" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
       bool) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       --> bool))),
   C"isNonTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      bool)),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
       bool) --> bool)),
   V"e1"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]),
   V"e2"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]),
   V"p"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]),
   V"s"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"=" "min"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
      -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       --> bool))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
      -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]],
           U"'f"]]))),
   C"CONS" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]],
           U"'f"]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]),
   C"adj" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
       bool))),
   C"transFrmState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      gamma)),
   C"HD" "list"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
      -->
      T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"])),
   C"transToState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      gamma)),
   C"LAST" "list"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
      -->
      T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"])),
   V"e"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]),
   C"MEM" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", gamma]], U"'f"]]
       --> bool))),
   C"MEM" "list" ((gamma --> (T"list" "list" [gamma] --> bool))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
           T"prod" "pair" [gamma, T"list" "list" [beta]]]] -->
       T"list" "list" [gamma]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [alpha, beta, gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [alpha], T"prod" "pair" [beta, gamma]],
          T"prod" "pair" [gamma, T"list" "list" [beta]]]])),
   C"!" "bool"
    (((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
       bool) --> bool)),
   V"m" (T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta]),
   C"!" "bool"
    (((T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]] --> bool) -->
      bool)), V"l" (T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]]),
   C"!" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       --> bool) --> bool)),
   V"ntsl"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]),
   C"p2gtrans" "pdaEqCfg"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      (T"rule" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool))),
   C"rule" "grammarDef"
    ((T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       -->
       T"rule" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]))),
   C"?" "bool"
    (((T"option" "option" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
      bool)),
   V"isymo" (T"option" "option" [T"symbol" "regexp" [alpha, beta]]),
   C"?" "bool" (((gamma --> bool) --> bool)), V"ssym" (gamma),
   C"?" "bool" (((delta --> bool) --> bool)), V"q" (delta), V"q'" (delta),
   V"p" (delta),
   C"?" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"mrhs" (T"list" "list" [gamma]),
   C"MEM" "list" ((delta --> (T"list" "list" [delta] --> bool))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
             T"prod" "pair" [gamma, delta]],
           T"prod" "pair" [delta, T"list" "list" [gamma]]]] -->
       T"list" "list" [delta]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
            T"prod" "pair" [gamma, delta]],
          T"prod" "pair" [delta, T"list" "list" [gamma]]]])),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair" [gamma, delta]],
        T"prod" "pair" [delta, T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
             T"prod" "pair" [gamma, delta]],
           T"prod" "pair" [delta, T"list" "list" [gamma]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
        T"prod" "pair" [gamma, delta]] -->
      (T"prod" "pair" [delta, T"list" "list" [gamma]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair" [gamma, delta]],
         T"prod" "pair" [delta, T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"option" "option" [T"symbol" "regexp" [alpha, beta]] -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair"
        [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair" [gamma, delta]]))),
   C"," "pair"
    ((delta -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [delta, T"list" "list" [gamma]]))),
   C"=" "min"
    ((T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]] -->
      (T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]] --> bool))),
   C"," "pair"
    ((delta -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]]))),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"=" "min"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       --> bool))),
   C"NIL" "list"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]),
   C"=" "min"
    ((T"option" "option" [T"symbol" "regexp" [alpha, beta]] -->
      (T"option" "option" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"NONE" "option"
    (T"option" "option" [T"symbol" "regexp" [alpha, beta]]),
   C"=" "min" ((delta --> (delta --> bool))),
   C"=" "min"
    ((T"list" "list" [gamma] --> (T"list" "list" [gamma] --> bool))),
   C"NIL" "list" (T"list" "list" [gamma]),
   C"?" "bool" (((beta --> bool) --> bool)), V"ts" (beta),
   C"CONS" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]],
           beta]]))),
   C"TS" "regexp"
    ((beta -->
      T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta])),
   C"SOME" "option"
    ((T"symbol" "regexp" [alpha, beta] -->
      T"option" "option" [T"symbol" "regexp" [alpha, beta]])),
   C"TS" "regexp" ((beta --> T"symbol" "regexp" [alpha, beta])),
   C"?" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool) --> bool)),
   V"h"
    (T"symbol" "regexp"
      [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]),
   C"?" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       --> bool) --> bool)),
   V"t"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]),
   C"~" "bool" ((bool --> bool)),
   C"=" "min"
    ((T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool))),
   C"MAP" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       gamma) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       --> T"list" "list" [gamma]))),
   C"transSym" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      gamma)),
   C"ntslCond" "pdaEqCfg"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      (T"prod" "pair"
        [delta, T"prod" "pair" [delta, T"list" "list" [gamma]]] -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
        --> bool)))),
   C"," "pair"
    ((delta -->
      (T"prod" "pair" [delta, T"list" "list" [gamma]] -->
       T"prod" "pair"
        [delta, T"prod" "pair" [delta, T"list" "list" [gamma]]]))),
   C"!" "bool"
    (((T"grammar" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool) --> bool)),
   V"g"
    (T"grammar" "grammarDef"
      [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]),
   C"pda2grammar" "pdaEqCfg"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      (T"grammar" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool))),
   C"MEM" "list"
    ((T"rule" "grammarDef"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      (T"list" "list"
        [T"rule" "grammarDef"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]
       --> bool))),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]])),
   C"NTS" "regexp"
    ((T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta])),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      delta)),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [alpha, beta], gamma, delta] -->
      gamma)),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      T"list" "list"
       [T"rule" "grammarDef"
         [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]])),
   C"!" "bool"
    (((T"rule" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool) --> bool)),
   V"r"
    (T"rule" "grammarDef"
      [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]),
   V"syms" (beta), V"stk" (gamma), V"st'" (delta),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
      alpha)),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]] -->
       T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]))),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]))),
   V"syms" (gamma), V"stk" (delta),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [gamma, T"prod" "pair" [delta, alpha]]] -->
      alpha)),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, T"prod" "pair" [delta, alpha]] -->
       T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"prod" "pair" [delta, alpha]]]))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [delta, alpha] -->
       T"prod" "pair" [gamma, T"prod" "pair" [delta, alpha]]))),
   C"," "pair" ((delta --> (alpha --> T"prod" "pair" [delta, alpha]))),
   V"syms" (alpha),
   C"tupinp" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]]] -->
      alpha)),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]] -->
       T"prod" "pair"
        [beta, T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]]]))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [gamma, delta] -->
       T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]]))),
   V"stk" (alpha),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [gamma, T"prod" "pair" [alpha, delta]]] -->
      alpha)),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, T"prod" "pair" [alpha, delta]] -->
       T"prod" "pair"
        [beta, T"prod" "pair" [gamma, T"prod" "pair" [alpha, delta]]]))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [alpha, delta] -->
       T"prod" "pair" [gamma, T"prod" "pair" [alpha, delta]]))),
   C"," "pair" ((alpha --> (delta --> T"prod" "pair" [alpha, delta]))),
   V"frm" (alpha), C"!" "bool" (((U"'e" --> bool) --> bool)),
   V"inp" (U"'e"), V"stk" (beta), V"tost" (gamma),
   C"=" "min"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
       bool))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta])),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]] -->
       T"prod" "pair"
        [alpha, T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]]))),
   C"," "pair"
    ((U"'e" -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]))),
   C"," "pair" ((beta --> (gamma --> T"prod" "pair" [beta, gamma]))),
   C"NTS" "regexp"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta])),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [beta, gamma] -->
       T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]]))),
   V"a" (beta), V"b" (gamma), V"c" (delta), V"d" (U"'e"), V"e" (alpha),
   C"nextToStk" "pdaEqCfg"
    ((T"prod" "pair"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]],
        T"prod" "pair" [U"'e", alpha]] --> alpha)),
   C"," "pair"
    ((T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]] -->
      (T"prod" "pair" [U"'e", alpha] -->
       T"prod" "pair"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]],
         T"prod" "pair" [U"'e", alpha]]))),
   C"," "pair" ((U"'e" --> (alpha --> T"prod" "pair" [U"'e", alpha]))),
   C"?" "bool"
    ((((gamma -->
        T"pda" "pdaDef"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta], gamma]) --> bool) --> bool)),
   V"m"
    ((gamma -->
      T"pda" "pdaDef"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta],
        gamma])),
   C"=" "min"
    (((gamma -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta], gamma]) -->
      ((gamma -->
        T"pda" "pdaDef"
         [T"symbol" "regexp" [alpha, beta],
          T"symbol" "regexp" [alpha, beta], gamma]) --> bool))),
   C"grammar2pda" "pdaEqCfg"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (gamma -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [alpha, beta],
         T"symbol" "regexp" [alpha, beta], gamma]))),
   C"pda_start" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [beta, gamma], T"symbol" "regexp" [beta, gamma],
        alpha] --> alpha)),
   C"grammar2pda" "pdaEqCfg"
    ((T"grammar" "grammarDef" [beta, gamma] -->
      (alpha -->
       T"pda" "pdaDef"
        [T"symbol" "regexp" [beta, gamma],
         T"symbol" "regexp" [beta, gamma], alpha]))),
   V"g" (T"grammar" "grammarDef" [beta, gamma]),
   C"=" "min"
    ((T"symbol" "regexp" [alpha, beta] -->
      (T"symbol" "regexp" [alpha, beta] --> bool))),
   C"pda_ssSym" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta],
        gamma] --> T"symbol" "regexp" [alpha, beta])), V"q" (gamma),
   C"NTS" "regexp" ((alpha --> T"symbol" "regexp" [alpha, beta])),
   C"startSym" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] --> alpha)),
   C"!" "bool" (((T"rule" "grammarDef" [alpha, beta] --> bool) --> bool)),
   V"l" (T"rule" "grammarDef" [alpha, beta]),
   V"sym" (T"symbol" "regexp" [alpha, beta]),
   V"stk" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"=" "min"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
        T"prod" "pair"
         [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
      (T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
         T"prod" "pair"
          [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       bool))),
   C"trans" "pdaEqCfg"
    ((gamma -->
      (T"rule" "grammarDef" [alpha, beta] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
         T"prod" "pair"
          [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
        T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]] -->
      (T"prod" "pair"
        [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
         T"prod" "pair"
          [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]))),
   C"," "pair"
    ((T"option" "option" [T"symbol" "regexp" [alpha, beta]] -->
      (T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma] -->
       T"prod" "pair"
        [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
         T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]]))),
   C"," "pair"
    ((T"symbol" "regexp" [alpha, beta] -->
      (gamma -->
       T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]))),
   C"," "pair"
    ((gamma -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"prod" "pair"
        [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   C"!" "bool"
    (((T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool) -->
      bool)), V"l" (T"list" "list" [T"rule" "grammarDef" [alpha, beta]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
          T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
        T"prod" "pair"
         [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
             T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
           T"prod" "pair"
            [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]]
       --> bool))),
   V"h" (T"option" "option" [T"symbol" "regexp" [alpha, beta]]),
   V"h'" (T"symbol" "regexp" [alpha, beta]),
   V"sl'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"MAP" "list"
    (((T"rule" "grammarDef" [alpha, beta] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
           T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
         T"prod" "pair"
          [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]) -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
             T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
           T"prod" "pair"
            [gamma,
             T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]]))),
   V"h" (T"symbol" "regexp" [alpha, beta]),
   V"sl" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"?" "bool" (((alpha --> bool) --> bool)), V"nts" (alpha),
   C"MEM" "list"
    ((T"rule" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"rule" "grammarDef" [alpha, beta]] --> bool))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta],
        gamma] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [T"symbol" "regexp" [alpha, beta]],
            T"prod" "pair" [T"symbol" "regexp" [alpha, beta], gamma]],
          T"prod" "pair"
           [gamma, T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]])),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
             T"list" "list" [T"symbol" "regexp" [beta, gamma]]]]] --> bool)
      --> bool)),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
           T"list" "list" [T"symbol" "regexp" [beta, gamma]]]]]),
   C"!" "bool"
    (((T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool) -->
      bool)), V"sfx" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   V"stk" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   V"stk'" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
           T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
            T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] --> bool))
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
             T"list" "list" [T"symbol" "regexp" [beta, gamma]]]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
            T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
             T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] -->
         bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [beta, gamma], T"symbol" "regexp" [beta, gamma],
        alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
           T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
            T"list" "list" [T"symbol" "regexp" [beta, gamma]]]] -->
        bool)))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
         T"list" "list" [T"symbol" "regexp" [beta, gamma]]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
           T"list" "list" [T"symbol" "regexp" [beta, gamma]]]]))),
   C"," "pair"
    ((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
         T"list" "list" [T"symbol" "regexp" [beta, gamma]]]))),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       T"list" "list" [T"symbol" "regexp" [beta, gamma]]))),
   V"pfx" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   C"isGnf" "pdaEqCfg" ((T"grammar" "grammarDef" [beta, gamma] --> bool)),
   C"EVERY" "list"
    (((T"symbol" "regexp" [beta, gamma] --> bool) -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool))),
   C"isTmnlSym" "regexp" ((T"symbol" "regexp" [beta, gamma] --> bool)),
   V"q'" (alpha),
   V"inp" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   V"inp'" (T"list" "list" [T"symbol" "regexp" [beta, gamma]]),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta],
        gamma] -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
            T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
        bool)))),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]] -->
       T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]]))),
   C"," "pair"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"prod" "pair"
        [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
         T"list" "list" [T"symbol" "regexp" [alpha, beta]]]))),
   V"inp" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"inp'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"stk'" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"<" "prim_rec" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      T"num" "num" [])),
   C">" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [beta, gamma]],
            T"list" "list" [T"symbol" "regexp" [beta, gamma]]]]] -->
      T"num" "num" [])),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ZERO" "arithmetic" (T"num" "num" []),
   C"LENGTH" "list"
    ((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
      T"num" "num" [])),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool))),
   C"RTC" "relation"
    (((T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool)) -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool)))),
   C"lderives" "grammarDef"
    ((T"grammar" "grammarDef" [beta, gamma] -->
      (T"list" "list" [T"symbol" "regexp" [beta, gamma]] -->
       (T"list" "list" [T"symbol" "regexp" [beta, gamma]] --> bool)))),
   C"IN" "bool"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool) -->
       bool))), V"x" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"laes" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [alpha, beta], T"symbol" "regexp" [alpha, beta],
        gamma] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   C"language" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))),
   V"y" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"RTC" "relation"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   C"lderives" "grammarDef"
    ((T"grammar" "grammarDef" [alpha, beta] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)))),
   V"n" (alpha),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"p" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   V"s" (T"list" "list" [T"symbol" "regexp" [alpha, beta]]),
   C"APPEND" "list"
    ((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
      (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       T"list" "list" [T"symbol" "regexp" [alpha, beta]]))),
   C"!" "bool"
    (((T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       --> bool) --> bool)),
   V"dl"
    (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]),
   C"listderiv" "relationLemmas"
    (((T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool)) -->
      (T"list" "list" [T"list" "list" [T"symbol" "regexp" [alpha, beta]]]
       -->
       (T"list" "list" [T"symbol" "regexp" [alpha, beta]] -->
        (T"list" "list" [T"symbol" "regexp" [alpha, beta]] --> bool))))),
   C"RTC" "relation"
    (((T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
            T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] --> bool))
      -->
      (T"prod" "pair"
        [gamma,
         T"prod" "pair"
          [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
           T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
       (T"prod" "pair"
         [gamma,
          T"prod" "pair"
           [T"list" "list" [T"symbol" "regexp" [alpha, beta]],
            T"list" "list" [T"symbol" "regexp" [alpha, beta]]]] -->
        bool)))),
   C"!" "bool"
    (((T"grammar" "grammarDef" [U"'nts", U"'ts"] --> bool) --> bool)),
   V"g" (T"grammar" "grammarDef" [U"'nts", U"'ts"]),
   C"isGnf" "pdaEqCfg"
    ((T"grammar" "grammarDef" [U"'nts", U"'ts"] --> bool)),
   C"?" "bool"
    (((T"pda" "pdaDef"
        [T"symbol" "regexp" [U"'nts", U"'ts"],
         T"symbol" "regexp" [U"'nts", U"'ts"], U"'state"] --> bool) -->
      bool)),
   V"m"
    (T"pda" "pdaDef"
      [T"symbol" "regexp" [U"'nts", U"'ts"],
       T"symbol" "regexp" [U"'nts", U"'ts"], U"'state"]),
   C"IN" "bool"
    ((T"list" "list" [T"symbol" "regexp" [U"'nts", U"'ts"]] -->
      ((T"list" "list" [T"symbol" "regexp" [U"'nts", U"'ts"]] --> bool) -->
       bool))),
   V"x" (T"list" "list" [T"symbol" "regexp" [U"'nts", U"'ts"]]),
   C"language" "grammarDef"
    ((T"grammar" "grammarDef" [U"'nts", U"'ts"] -->
      (T"list" "list" [T"symbol" "regexp" [U"'nts", U"'ts"]] --> bool))),
   C"laes" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp" [U"'nts", U"'ts"],
        T"symbol" "regexp" [U"'nts", U"'ts"], U"'state"] -->
      (T"list" "list" [T"symbol" "regexp" [U"'nts", U"'ts"]] --> bool))),
   C"!" "bool"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        (T"symbol" "regexp"
          [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]
         --> bool)) --> bool) --> bool)),
   V"P"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"] -->
       bool))), C"!" "bool" (((U"'f" --> bool) --> bool)),
   C"NTS" "regexp"
    ((T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"])),
   C"," "pair"
    ((gamma -->
      (T"prod" "pair" [U"'e", U"'f"] -->
       T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]]))),
   C"," "pair" ((U"'e" --> (U"'f" --> T"prod" "pair" [U"'e", U"'f"]))),
   C"!" "bool" (((U"'g" --> bool) --> bool)), V"v11" (U"'g"),
   C"TS" "regexp"
    ((U"'g" -->
      T"symbol" "regexp"
       [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"])),
   V"v4" (delta),
   V"v16"
    (T"symbol" "regexp"
      [T"prod" "pair" [gamma, T"prod" "pair" [U"'e", U"'f"]], U"'g"]),
   C"TS" "regexp"
    ((delta -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta])),
   C"!" "bool"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
        bool) --> bool) --> bool)),
   V"P"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
      bool)),
   C"NTS" "regexp"
    ((T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta])),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [alpha, gamma] -->
       T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]]))),
   C"," "pair" ((alpha --> (gamma --> T"prod" "pair" [alpha, gamma]))),
   V"v2" (delta),
   C"TS" "regexp"
    ((delta -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta])),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta] -->
       bool) --> bool)),
   V"v"
    (T"symbol" "regexp"
      [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta]),
   C"!" "bool"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
        bool) --> bool) --> bool)),
   V"P"
    ((T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
      bool)),
   C"NTS" "regexp"
    ((T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta])),
   C"," "pair"
    ((beta -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]))),
   C"," "pair" ((gamma --> (alpha --> T"prod" "pair" [gamma, alpha]))),
   C"TS" "regexp"
    ((delta -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta])),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta] -->
       bool) --> bool)),
   V"v"
    (T"symbol" "regexp"
      [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta]),
   C"!" "bool"
    ((((T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
        bool) --> bool) --> bool)),
   V"P"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      bool)),
   C"?" "bool"
    ((((T"grammar" "grammarDef"
         [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
        bool) --> bool) --> bool)),
   V"g"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
      bool)),
   C"=" "min"
    (((T"grammar" "grammarDef"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
       bool) -->
      ((T"grammar" "grammarDef"
         [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta] -->
        bool) --> bool))), V"qf" (alpha),
   C"!" "bool" (((T"list" "list" [beta] --> bool) --> bool)),
   V"inp" (T"list" "list" [beta]),
   C"!" "bool" (((T"list" "list" [gamma] --> bool) --> bool)),
   V"stk" (T"list" "list" [gamma]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)))), V"p" (T"pda" "pdaDef" [beta, gamma, alpha]),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"list" "list" [beta] -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]))),
   C"NIL" "list" (T"list" "list" [beta]),
   C"?" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]),
   C"=" "min"
    ((T"list" "list" [beta] --> (T"list" "list" [beta] --> bool))),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [beta]] --> T"list" "list" [beta])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
       T"list" "list" [beta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       T"list" "list" [T"list" "list" [beta]]))),
   C"tupinp" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      T"list" "list" [beta])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
       gamma) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       T"list" "list" [gamma]))),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      gamma)),
   C"MEM" "list" ((alpha --> (T"list" "list" [alpha] --> bool))),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
       alpha) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       T"list" "list" [alpha]))),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      alpha)),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] -->
       T"list" "list" [alpha]))),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [beta, gamma, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [beta], T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [gamma]]]])),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      alpha)),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] --> bool)
      --> bool)),
   V"h"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       bool) --> bool)),
   V"t"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       bool))),
   C"CONS" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]))),
   C"HD" "list" ((T"list" "list" [gamma] --> gamma)),
   C"LAST" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
      T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]])),
   V"e1"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]),
   V"e2"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]),
   V"pfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]),
   V"sfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]]),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, alpha]]]] -->
       bool))), C"?" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"m" (T"num" "num" []),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]]
      --> T"num" "num" [])),
   C"NRC" "arithmetic"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        --> bool)) -->
      (T"num" "num" [] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
        -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair" [T"list" "list" [beta], T"list" "list" [gamma]]]
         --> bool))))),
   C"CONS" "list"
    ((gamma --> (T"list" "list" [gamma] --> T"list" "list" [gamma]))),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]] -->
       bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]]),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] --> bool)
      --> bool)),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]] -->
       bool))),
   C"RTC" "relation"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
        --> bool)) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
        --> bool)))),
   C"derives" "grammarDef"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
        --> bool)))),
   V"g"
    (T"grammar" "grammarDef"
      [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]),
   C"CONS" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]],
           beta]]))),
   C"NTS" "regexp"
    ((T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta])),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      alpha)),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      gamma)),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      delta)),
   C"NIL" "list"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]]),
   C"MAP" "list"
    (((beta -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]) -->
      (T"list" "list" [beta] -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]],
           beta]]))),
   C"toTmnlSym" "regexp"
    ((beta -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta])),
   C"tupinp" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      T"list" "list" [beta])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]] -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]],
           beta]]))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], beta])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]] -->
       T"list" "list" [beta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list" [beta], T"prod" "pair" [gamma, delta]]]] -->
       T"list" "list" [T"list" "list" [beta]]))), V"A" (gamma),
   C"MAP" "list"
    (((T"prod" "pair"
        [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]] -->
       gamma) -->
      (T"list" "list"
        [T"prod" "pair"
          [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]]]
       --> T"list" "list" [gamma]))),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]] -->
      gamma)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]]]),
   V"mrhs"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]]),
   C"MAP" "list"
    (((T"prod" "pair"
        [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]],
           beta]]))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [delta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, delta]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [delta, T"prod" "pair" [gamma, delta]], beta])),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]],
        T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
        T"prod" "pair" [beta, alpha]] -->
      (T"prod" "pair" [alpha, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]],
         T"prod" "pair" [alpha, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]] -->
      (T"prod" "pair" [beta, alpha] -->
       T"prod" "pair"
        [T"option" "option"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"prod" "pair" [beta, alpha]]))),
   C"SOME" "option"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      T"option" "option"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]])),
   V"ih"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   C"," "pair" ((beta --> (alpha --> T"prod" "pair" [beta, alpha]))),
   V"A" (beta),
   C"," "pair"
    ((alpha -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [alpha, T"list" "list" [beta]]))),
   C"MAP" "list"
    (((T"prod" "pair"
        [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]] -->
       beta) -->
      (T"list" "list"
        [T"prod" "pair"
          [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]]]
       --> T"list" "list" [beta]))),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]] -->
      beta)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]]]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        beta, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"prod" "pair" [beta, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [beta]]]])),
   V"m"
    (T"pda" "pdaDef"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
       beta, alpha]),
   C"pda2grammar" "pdaEqCfg"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        beta, alpha] -->
      (T"grammar" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool))),
   V"g"
    (T"grammar" "grammarDef"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]]] -->
      T"num" "num" [])), V"p" (alpha),
   C"?" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> bool) --> bool)),
   V"ntsl"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   C"MEM" "list"
    ((T"rule" "grammarDef"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"list" "list"
        [T"rule" "grammarDef"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> bool))),
   C"rule" "grammarDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       T"rule" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [beta, alpha] -->
       T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]]))),
   C"rules" "grammarDef"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      T"list" "list"
       [T"rule" "grammarDef"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]])),
   C"?" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool) --> bool)),
   V"h"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   V"t"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   C"=" "min"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> bool))),
   C"CONS" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
           gamma]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   C"=" "min"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool))),
   C"MAP" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       beta) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> T"list" "list" [beta]))),
   C"transSym" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      beta)),
   C"ntslCond" "pdaEqCfg"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        beta, alpha] -->
      (T"prod" "pair"
        [alpha, T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        --> bool)))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [alpha, T"list" "list" [beta]] -->
       T"prod" "pair"
        [alpha, T"prod" "pair" [alpha, T"list" "list" [beta]]]))),
   C"CONS" "list"
    ((beta --> (T"list" "list" [beta] --> T"list" "list" [beta]))),
   V"h"
    (T"prod" "pair"
      [delta, T"prod" "pair" [U"'e", T"prod" "pair" [beta, U"'f"]]]),
   C"?" "bool"
    (((T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]] --> bool) -->
      bool)), V"ntsl" (T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]]),
   C"?" "bool" (((U"'h" --> bool) --> bool)), V"ts" (U"'h"),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]] -->
      (T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]] --> bool))),
   C"CONS" "list"
    ((T"symbol" "regexp" [U"'g", U"'h"] -->
      (T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]] -->
       T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]]))),
   C"TS" "regexp" ((U"'h" --> T"symbol" "regexp" [U"'g", U"'h"])),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [U"'g", U"'h"]]),
   C"=" "min"
    ((T"option" "option" [T"symbol" "regexp" [U"'i", U"'h"]] -->
      (T"option" "option" [T"symbol" "regexp" [U"'i", U"'h"]] --> bool))),
   V"isymo" (T"option" "option" [T"symbol" "regexp" [U"'i", U"'h"]]),
   C"SOME" "option"
    ((T"symbol" "regexp" [U"'i", U"'h"] -->
      T"option" "option" [T"symbol" "regexp" [U"'i", U"'h"]])),
   C"TS" "regexp" ((U"'h" --> T"symbol" "regexp" [U"'i", U"'h"])),
   C"=" "min"
    ((T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]] -->
      (T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]] --> bool))),
   V"mrhs" (T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]]),
   C"CONS" "list"
    ((T"symbol" "regexp" [U"'j", U"'h"] -->
      (T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]] -->
       T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]]))),
   C"TS" "regexp" ((U"'h" --> T"symbol" "regexp" [U"'j", U"'h"])),
   C"NIL" "list" (T"list" "list" [T"symbol" "regexp" [U"'j", U"'h"]]),
   C"pda2grammar" "pdaEqCfg"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [delta, gamma], beta, alpha] -->
      (T"grammar" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool))),
   V"m" (T"pda" "pdaDef" [T"symbol" "regexp" [delta, gamma], beta, alpha]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
          T"prod" "pair" [beta, alpha]],
        T"prod" "pair" [alpha, T"list" "list" [beta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
             T"prod" "pair" [beta, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [beta]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
        T"prod" "pair" [beta, alpha]] -->
      (T"prod" "pair" [alpha, T"list" "list" [beta]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
           T"prod" "pair" [beta, alpha]],
         T"prod" "pair" [alpha, T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"option" "option" [T"symbol" "regexp" [delta, gamma]] -->
      (T"prod" "pair" [beta, alpha] -->
       T"prod" "pair"
        [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
         T"prod" "pair" [beta, alpha]]))),
   C"NONE" "option"
    (T"option" "option" [T"symbol" "regexp" [delta, gamma]]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [delta, gamma], beta, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [T"symbol" "regexp" [delta, gamma]],
            T"prod" "pair" [beta, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [beta]]]])),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] --> bool) -->
      bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]]]),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]] --> bool) -->
      bool)),
   V"e1"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"prod" "pair" [beta, alpha]]]),
   V"e2"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"prod" "pair" [beta, alpha]]]),
   V"pfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]]]),
   V"sfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"prod" "pair" [beta, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] --> bool))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"prod" "pair" [beta, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]]))),
   C"CONS" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]]]),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] --> alpha)),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] --> alpha)),
   V"e"
    (T"prod" "pair"
      [alpha,
       T"prod" "pair"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"prod" "pair" [beta, alpha]]]),
   C"MEM" "list"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] --> bool))),
   C"RTC" "relation"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        --> bool)) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        --> bool)))),
   C"derives" "grammarDef"
    ((T"grammar" "grammarDef"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        --> bool)))),
   C"NTS" "regexp"
    ((T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma])),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] --> beta)),
   C"tupinp" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] -->
      T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
           gamma]]))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha,
        T"prod" "pair"
         [T"list" "list"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
              gamma]], T"prod" "pair" [beta, alpha]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma])),
   C"FLAT" "list"
    ((T"list" "list"
       [T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]]
      -->
      T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"prod" "pair" [beta, alpha]]] -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]])
      -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"prod" "pair" [beta, alpha]]]] -->
       T"list" "list"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
             gamma]]]))),
   C"!" "bool"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
       bool) --> bool)),
   V"e1"
    (T"prod" "pair"
      [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]),
   V"e2"
    (T"prod" "pair"
      [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       --> bool) --> bool)),
   V"pfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]),
   V"sfx"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       --> bool))),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]),
   C"APPEND" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]))),
   C"CONS" "list"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       -->
       T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]))),
   C"NIL" "list"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      alpha)),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      alpha)),
   C"adj" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"] -->
       bool))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta])),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"])),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [U"'e", T"prod" "pair" [alpha, gamma]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [alpha, gamma]], delta])),
   V"h"
    (T"prod" "pair"
      [beta, T"prod" "pair" [U"'e", T"prod" "pair" [alpha, gamma]]]),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [U"'e", T"prod" "pair" [alpha, gamma]]] -->
      alpha)),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]
       --> bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]),
   C"MAP" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
       gamma) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"]]
       --> T"list" "list" [gamma]))),
   C"transSym" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
      gamma)),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]],
           U"'e"]]))),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"])),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
       gamma) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]
       --> T"list" "list" [gamma]))),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
      gamma)),
   C"isNonTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, gamma]], delta] -->
      bool)),
   V"h"
    (T"prod" "pair"
      [alpha, T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]]),
   C"EVERY" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
       bool) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"]]
       --> bool))),
   C"isNonTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
      bool)),
   C"tupfrmst" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [U"'e", T"prod" "pair" [beta, gamma]]] -->
      alpha)),
   C"toRhs" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, alpha]]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]], delta])),
   V"h"
    (T"prod" "pair"
      [beta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, alpha]]]),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [beta, T"prod" "pair" [U"'e", T"prod" "pair" [gamma, alpha]]] -->
      alpha)),
   V"t"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]),
   C"MEM" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"]]
       --> bool))),
   V"e"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"]),
   V"e" (delta),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
       delta) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]
       --> T"list" "list" [delta]))),
   C"tuptost" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
      delta)),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [U"'f", U"'g", delta] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'f"], T"prod" "pair" [U"'g", delta]],
           T"prod" "pair" [delta, T"list" "list" [U"'g"]]]] -->
       T"list" "list" [delta]))),
   V"m" (T"pda" "pdaDef" [U"'f", U"'g", delta]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'f", U"'g", delta] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'f"], T"prod" "pair" [U"'g", delta]],
          T"prod" "pair" [delta, T"list" "list" [U"'g"]]]])),
   C"transToState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
      delta)),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]] -->
       alpha) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, delta]]]]
       --> T"list" "list" [alpha]))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [U"'f", U"'g", alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [U"'f"], T"prod" "pair" [U"'g", alpha]],
           T"prod" "pair" [alpha, T"list" "list" [U"'g"]]]] -->
       T"list" "list" [alpha]))),
   V"m" (T"pda" "pdaDef" [U"'f", U"'g", alpha]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [U"'f", U"'g", alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [U"'f"], T"prod" "pair" [U"'g", alpha]],
          T"prod" "pair" [alpha, T"list" "list" [U"'g"]]]])),
   C"transFrmState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, delta]], U"'e"] -->
      alpha)),
   V"t"
    (T"list" "list"
      [T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]),
   C"!" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
       --> bool) --> bool)),
   V"p"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]),
   V"s"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]),
   C"=" "min"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
      -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
       --> bool))),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
           delta]]))),
   C"APPEND" "list"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
      -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
           delta]]))),
   C"CONS" "list"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
           delta]]))),
   V"e1"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]),
   V"e2"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]),
   C"NIL" "list"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]),
   C"adj" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
       bool))),
   C">=" "arithmetic" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"LENGTH" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]] -->
      T"num" "num" [])),
   C"BIT2" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
          T"prod" "pair" [gamma, alpha]],
        T"prod" "pair" [alpha, T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
             T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
        T"prod" "pair" [gamma, alpha]] -->
      (T"prod" "pair" [alpha, T"list" "list" [gamma]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
           T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"option" "option" [T"symbol" "regexp" [delta, U"'e"]] -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair"
        [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
         T"prod" "pair" [gamma, alpha]]))),
   C"NONE" "option"
    (T"option" "option" [T"symbol" "regexp" [delta, U"'e"]]),
   C"," "pair"
    ((alpha -->
      (T"list" "list" [gamma] -->
       T"prod" "pair" [alpha, T"list" "list" [gamma]]))),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
       gamma) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       --> T"list" "list" [gamma]))),
   C"tupstk" "pdaEqCfg"
    ((T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
      gamma)),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [delta, U"'e"], gamma, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
            T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [gamma]]]])),
   V"m"
    (T"pda" "pdaDef" [T"symbol" "regexp" [delta, U"'e"], gamma, alpha]),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
       alpha) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       --> T"list" "list" [alpha]))),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [delta, U"'e"], gamma, alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option" [T"symbol" "regexp" [delta, U"'e"]],
             T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] -->
       T"list" "list" [alpha]))),
   V"h"
    (T"prod" "pair"
      [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]),
   C"LAST" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]] -->
      T"prod" "pair"
       [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]])),
   C"p2gtrans" "pdaEqCfg"
    ((T"pda" "pdaDef" [T"symbol" "regexp" [delta, U"'e"], gamma, alpha] -->
      (T"rule" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"] -->
       bool))),
   C"rule" "grammarDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"]]
       -->
       T"rule" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"]))),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]]))),
   C"MAP" "list"
    (((T"prod" "pair"
        [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], U"'e"]) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha, T"prod" "pair" [beta, T"prod" "pair" [gamma, alpha]]]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
           U"'e"]]))),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"prod" "pair"
         [T"option" "option"
           [T"symbol" "regexp"
             [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
              delta]], T"prod" "pair" [gamma, alpha]],
        T"prod" "pair" [alpha, T"list" "list" [gamma]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
                 delta]], T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] --> bool))),
   C"," "pair"
    ((T"prod" "pair"
       [T"option" "option"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]],
        T"prod" "pair" [gamma, alpha]] -->
      (T"prod" "pair" [alpha, T"list" "list" [gamma]] -->
       T"prod" "pair"
        [T"prod" "pair"
          [T"option" "option"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
               delta]], T"prod" "pair" [gamma, alpha]],
         T"prod" "pair" [alpha, T"list" "list" [gamma]]]))),
   C"," "pair"
    ((T"option" "option"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
      -->
      (T"prod" "pair" [gamma, alpha] -->
       T"prod" "pair"
        [T"option" "option"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
             delta]], T"prod" "pair" [gamma, alpha]]))),
   C"SOME" "option"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
      T"option" "option"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]])),
   V"ih"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]),
   C"pda_next" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta],
        gamma, alpha] -->
      T"list" "list"
       [T"prod" "pair"
         [T"prod" "pair"
           [T"option" "option"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
                delta]], T"prod" "pair" [gamma, alpha]],
          T"prod" "pair" [alpha, T"list" "list" [gamma]]]])),
   V"m"
    (T"pda" "pdaDef"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta],
       gamma, alpha]),
   C"isTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
      bool)),
   C"statesList" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta],
        gamma, alpha] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"prod" "pair"
            [T"option" "option"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]],
                 delta]], T"prod" "pair" [gamma, alpha]],
           T"prod" "pair" [alpha, T"list" "list" [gamma]]]] -->
       T"list" "list" [alpha]))),
   C"p2gtrans" "pdaEqCfg"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta],
        gamma, alpha] -->
      (T"rule" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta] -->
       bool))),
   C"rule" "grammarDef"
    ((T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]]
       -->
       T"rule" "grammarDef"
        [T"prod" "pair" [alpha, T"prod" "pair" [gamma, alpha]], delta]))),
   C"!" "bool"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> bool) --> bool)),
   V"x"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   C"listderiv" "relationLemmas"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"list" "list" [beta]]] --> bool)) -->
      (T"list" "list"
        [T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"list" "list" [beta]]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"list" "list" [beta]]] -->
        (T"prod" "pair"
          [alpha,
           T"prod" "pair"
            [T"list" "list"
              [T"symbol" "regexp"
                [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                 gamma]], T"list" "list" [beta]]] --> bool))))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        beta, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"list" "list" [beta]]] --> bool)))),
   V"dl"
    (T"list" "list"
      [T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]]]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"list" "list" [beta]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]]))),
   C"," "pair"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]] -->
      (T"list" "list" [beta] -->
       T"prod" "pair"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]],
         T"list" "list" [beta]]))),
   C"EVERY" "list"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool) -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       --> bool))),
   C"isTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      bool)),
   C"!" "bool"
    (((T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] --> bool) --> bool)),
   V"l"
    (T"list" "list"
      [T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]]]),
   C"!" "bool"
    (((T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool) --> bool)),
   V"e1"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   C"!" "bool" (((T"list" "list" [delta] --> bool) --> bool)),
   V"e2" (T"list" "list" [delta]),
   C"MEM" "list"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] --> bool))),
   C"," "pair"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"list" "list" [delta] -->
       T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]]))),
   C"RTC" "relation"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
        --> bool)) -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
        --> bool)))),
   C"ID" "pdaDef"
    ((T"pda" "pdaDef" [delta, beta, alpha] -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
       -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]]
        --> bool)))), V"m" (T"pda" "pdaDef" [delta, beta, alpha]),
   C"," "pair"
    ((alpha -->
      (T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]] -->
       T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list" [delta], T"list" "list" [beta]]]))),
   C"transFrmState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      alpha)),
   C"," "pair"
    ((T"list" "list" [delta] -->
      (T"list" "list" [beta] -->
       T"prod" "pair" [T"list" "list" [delta], T"list" "list" [beta]]))),
   C"transToState" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      alpha)), C"NIL" "list" (T"list" "list" [delta]),
   V"e2"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   V"p"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   V"s"
    (T"list" "list"
      [T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]),
   C"MAP" "list"
    (((T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]] -->
       T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
           gamma]]))),
   C"FST" "pair"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]] -->
      T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma])),
   C"APPEND" "list"
    ((T"list" "list"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]] -->
      (T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
           gamma]]))),
   C"adj" "pdaEqCfg"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      (T"symbol" "regexp"
        [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
       bool))),
   C"isNonTmnlSym" "regexp"
    ((T"symbol" "regexp"
       [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma] -->
      bool)),
   V"h1"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   V"h2" (T"list" "list" [delta]),
   V"i1"
    (T"symbol" "regexp"
      [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]),
   V"i2" (T"list" "list" [delta]),
   V"t"
    (T"list" "list"
      [T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]]]),
   C"=" "min"
    ((T"list" "list"
       [T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
          T"list" "list" [delta]]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] --> bool))),
   C"CONS" "list"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]] -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] -->
       T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]]))),
   C"=" "min"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]] -->
      (T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]] --> bool))),
   C"LAST" "list"
    ((T"list" "list"
       [T"prod" "pair"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
          T"list" "list" [delta]]] -->
      T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]])),
   C"APPEND" "list"
    ((T"list" "list" [delta] -->
      (T"list" "list" [delta] --> T"list" "list" [delta]))),
   C"FLAT" "list"
    ((T"list" "list" [T"list" "list" [delta]] --> T"list" "list" [delta])),
   C"MAP" "list"
    (((T"prod" "pair"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
         T"list" "list" [delta]] --> T"list" "list" [delta]) -->
      (T"list" "list"
        [T"prod" "pair"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
           T"list" "list" [delta]]] -->
       T"list" "list" [T"list" "list" [delta]]))),
   C"SND" "pair"
    ((T"prod" "pair"
       [T"symbol" "regexp"
         [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma],
        T"list" "list" [delta]] --> T"list" "list" [delta])),
   C"APPEND" "list"
    ((T"list" "list" [beta] -->
      (T"list" "list" [beta] --> T"list" "list" [beta]))),
   C"listderiv" "relationLemmas"
    (((T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        --> bool)) -->
      (T"list" "list"
        [T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]]
       -->
       (T"list" "list"
         [T"symbol" "regexp"
           [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
        -->
        (T"list" "list"
          [T"symbol" "regexp"
            [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]
         --> bool))))),
   V"dl"
    (T"list" "list"
      [T"list" "list"
        [T"symbol" "regexp"
          [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]], gamma]]]),
   C"RTC" "relation"
    (((T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"list" "list" [beta]]] --> bool)) -->
      (T"prod" "pair"
        [alpha,
         T"prod" "pair"
          [T"list" "list"
            [T"symbol" "regexp"
              [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
               gamma]], T"list" "list" [beta]]] -->
       (T"prod" "pair"
         [alpha,
          T"prod" "pair"
           [T"list" "list"
             [T"symbol" "regexp"
               [T"prod" "pair" [alpha, T"prod" "pair" [beta, alpha]],
                gamma]], T"list" "list" [beta]]] --> bool))))]
  val DT = Thm.disk_thm share_table
  in
  val validGnfProd_def =
    DT(["DISK_THM"], [],
       `(%0 (\%1. (%2 (\%3. ((%4 (%5 ((%6 $1) $0))) (%7 (\%8. (%9 (\%10.
       ((%11 ((%12 $2) ((%13 $1) $0))) ((%11 (%14 $1)) ((%15 %16)
       $0))))))))))))`)
  val isGnf_def =
    DT([], [], `(%17 (\%18. ((%4 (%19 $0)) ((%20 %5) (%21 $0)))))`)
  val trans_def =
    DT(["DISK_THM"], [],
       `(%22 (\%23. (%24 (\%25. (%26 (\%27. ((%28 ((%29 $2) ((%30 $1) $0)))
       ((%31 ((%32 (%33 (%34 $0))) ((%35 (%36 $1)) $2))) ((%37 $2) (%38
       $0))))))))))`)
  val grammar2pda_def =
    DT([], [],
       `(%39 (\%40. (%22 (\%23. ((%41 ((%42 $1) $0)) ((%43 (\%44. ((%45
       (%46 $1)) ((%47 (%48 (%49 (%50 $2)))) ((%51 (%52 $0)) ((%53 (%54
       %55)) %56)))))) ((%57 (%58 $0)) (%59 $1))))))))`)
  val adj_tupled_primitive_def =
    DT([], [],
       `((%60 %61) ((%62 (%63 (\%64. (%65 $0)))) (\%66. (\%67. ((%68 (\%69.
       (\%70. (((%71 (\%72. ((%73 (\%74. (\%75. ((%76 (\%77. (\%78. (((%79
       (\%80. ((%81 (\%82. (\%83. ((%84 (\%85. (\%86. (%87 ((%88 $5)
       $3))))) $0)))) $0))) (\%89. %90)) $5)))) $0)))) $0))) (\%91. %90))
       $1)))) $0)))))`)
  val adj_curried_def =
    DT([], [],
       `(%92 (\%93. (%94 (\%95. ((%4 ((%96 $1) $0)) (%61 ((%97 $1)
       $0)))))))`)
  val transSym_primitive_def =
    DT([], [],
       `((%98 %99) ((%100 (%101 (\%102. (%103 $0)))) (\%104. (\%105.
       (((%106 (\%107. ((%108 (\%109. (\%110. ((%111 (\%112. (\%113. (%114
       $1)))) $0)))) $0))) (\%115. %116)) $0)))))`)
  val transToState_primitive_def =
    DT([], [],
       `((%117 %118) ((%119 (%120 (\%121. (%122 $0)))) (\%123. (\%124.
       (((%125 (\%126. ((%127 (\%109. (\%128. ((%129 (\%130. (\%131. (%114
       $0)))) $0)))) $0))) (\%115. %116)) $0)))))`)
  val transFrmState_primitive_def =
    DT([], [],
       `((%132 %133) ((%134 (%135 (\%136. (%137 $0)))) (\%138. (\%139.
       (((%140 (\%141. ((%142 (\%143. (\%144. ((%145 (\%146. (\%113. (%114
       $3)))) $0)))) $0))) (\%115. %116)) $0)))))`)
  val ntslCond_def =
    DT(["DISK_THM"], [],
       `(%147 (\%148. (%149 (\%78. (%149 (\%150. (%151 (\%152. (%153
       (\%154. ((%4 (((%155 $4) ((%156 $3) ((%157 $2) $1))) $0)) ((%11
       ((%158 %159) $0)) ((%11 (%160 (\%161. (%160 (\%162. (%153 (\%163.
       (%153 (\%164. ((%165 ((%166 $4) ((%167 ((%167 $1) ((%168 $3) ((%168
       $2) %169)))) $0))) ((%170 $3) $2))))))))))) ((%11 ((%88 (%171 (%172
       $0))) $3)) ((%11 ((%88 (%173 (%174 $0))) $2)) ((%11 (%160 (\%175.
       ((%165 ((%176 $0) $1)) ((%177 (%173 $0)) ((%178 $5) (%179 $5)))))))
       (%160 (\%175. ((%165 ((%176 $0) $1)) ((%177 (%171 $0)) ((%178 $5)
       (%179 $5))))))))))))))))))))))`)
  val p2gtrans_def =
    DT(["DISK_THM"], [],
       `(%180 (\%181. (%182 (\%183. (%184 (\%185. ((%4 ((%186 $2) ((%187
       $1) $0))) (%188 (\%189. (%190 (\%191. (%192 (\%193. (%192 (\%194.
       (%192 (\%195. (%196 (\%197. ((%11 ((%198 $3) ((%199 $8) (%200 $8))))
       ((%11 ((%198 $2) ((%199 $8) (%200 $8)))) ((%11 ((%198 $1) ((%199 $8)
       (%200 $8)))) ((%11 ((%11 ((%201 ((%202 ((%203 $5) ((%157 $4) $3)))
       ((%204 $2) $0))) (%200 $8))) ((%205 $7) ((%206 $3) ((%157 $4)
       $1))))) ((%207 ((%11 ((%208 $6) %209)) ((%11 ((%210 $5) %211)) ((%11
       ((%212 $2) $1)) ((%213 $0) %214))))) ((%207 (%215 (\%216. ((%11
       ((%208 $7) ((%217 (%218 $0)) %209))) ((%11 ((%210 $6) (%219 (%220
       $0)))) ((%11 ((%212 $3) $2)) ((%213 $1) %214))))))) (%221 (\%222.
       (%223 (\%224. ((%11 ((%11 ((%208 $8) ((%217 $1) $0))) (%225 ((%208
       $0) %209)))) ((%207 (%215 (\%216. ((%11 ((%226 $2) (%218 $0))) ((%11
       ((%210 $8) (%219 (%220 $0)))) ((%11 ((%213 ((%227 %228) $1)) $3))
       (((%229 $11) ((%230 $5) ((%204 $4) $3))) $1))))))) ((%11 ((%210 $7)
       %211)) ((%11 ((%213 ((%227 %228) $8)) $2)) (((%229 $10) ((%230 $4)
       ((%204 $3) $2))) $8))))))))))))))))))))))))))))))))))`)
  val pda2grammar_def =
    DT([], [],
       `(%180 (\%181. (%231 (\%232. ((%4 ((%233 $1) $0)) ((%11 (%151
       (\%193. ((%4 ((%198 $0) ((%199 $2) (%200 $2)))) ((%234 ((%187 (%235
       $1)) ((%217 (%236 ((%206 (%237 $2)) ((%157 (%238 $2)) $0)))) %209)))
       (%239 $1)))))) (%240 (\%241. ((%4 ((%234 $0) (%239 $1))) ((%186 $2)
       $0))))))))))`)
  val tupfrmst_def =
    DT(["DISK_THM"], [],
       `(%0 (\%143. (%24 (\%242. (%149 (\%243. (%151 (\%244. ((%245 (%246
       ((%247 $3) ((%248 $2) ((%157 $1) $0))))) $3)))))))))`)
  val tuptost_def =
    DT(["DISK_THM"], [],
       `(%24 (\%109. (%149 (\%249. (%151 (\%250. (%0 (\%131. ((%245 (%251
       ((%252 $3) ((%253 $2) ((%254 $1) $0))))) $0)))))))))`)
  val tupinp_def =
    DT(["DISK_THM"], [],
       `(%24 (\%109. (%0 (\%255. (%149 (\%243. (%151 (\%244. ((%245 (%256
       ((%257 $3) ((%258 $2) ((%157 $1) $0))))) $2)))))))))`)
  val tupstk_def =
    DT(["DISK_THM"], [],
       `(%24 (\%109. (%149 (\%249. (%0 (\%259. (%151 (\%244. ((%245 (%260
       ((%261 $3) ((%262 $2) ((%263 $1) $0))))) $1)))))))))`)
  val toRhs_def =
    DT(["DISK_THM"], [],
       `(%0 (\%264. (%265 (\%266. (%24 (\%267. (%149 (\%268. ((%269 (%270
       ((%271 $3) ((%272 $2) ((%273 $1) $0))))) (%274 ((%275 $3) ((%273 $1)
       $0))))))))))))`)
  val nextToStk_def =
    DT(["DISK_THM"], [],
       `(%24 (\%276. (%149 (\%277. (%151 (\%278. (%265 (\%279. (%0 (\%280.
       ((%245 (%281 ((%282 ((%248 $4) ((%157 $3) $2))) ((%283 $1) $0))))
       $0)))))))))))`)
  val g2pPdaExists =
    DT(["DISK_THM"], [],
       `(%17 (\%18. (%284 (\%285. ((%286 $0) (%287 $1))))))`)
  val pdaStartState =
    DT(["DISK_THM"], [], `((%245 (%288 ((%289 %290) %74))) %74)`)
  val pdaStackSym =
    DT(["DISK_THM"], [],
       `((%291 (%292 ((%287 %18) %293))) (%294 (%295 %18)))`)
  val notNoneTrans =
    DT(["DISK_THM"], [],
       `(%296 (\%297. (%149 (\%293. (%149 (\%78. (%225 (%7 (\%298. (%9
       (\%299. ((%300 ((%301 $3) $4)) ((%302 ((%303 %211) ((%304 $1) $3)))
       ((%305 $2) $0))))))))))))))`)
  val transStateEq =
    DT(["DISK_THM"], [],
       `(%306 (\%307. (%149 (\%293. (%149 (\%78. ((%165 ((%207 ((%308
       ((%302 ((%303 %309) ((%304 %310) $1))) ((%305 $0) %311))) ((%312
       (%301 $1)) $2))) ((%308 ((%302 ((%303 %309) ((%304 %310) $0)))
       ((%305 $1) %311))) ((%312 (%301 $1)) $2)))) ((%88 $1) $0))))))))`)
  val transMemList =
    DT(["DISK_THM"], [],
       `(%306 (\%307. ((%165 ((%11 ((%308 ((%302 ((%303 (%219 %313)) ((%304
       %310) %293))) ((%305 %293) %314))) ((%312 (%301 %293)) $0))) ((%20
       %5) $0))) (%315 (\%316. ((%11 ((%291 %310) (%294 $0))) (%215 (\%216.
       ((%11 ((%291 %313) (%220 $0))) ((%11 ((%15 %16) %314)) ((%317 ((%6
       $1) ((%13 %313) %314))) $2)))))))))))`)
  val transMemRule =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%308 ((%302 ((%303 (%219 %313)) ((%304 %310) %293)))
       ((%305 %293) %314))) (%318 ((%287 %18) %293)))) (%19 %18))) (%315
       (\%316. ((%11 ((%291 %310) (%294 $0))) (%215 (\%216. ((%11 ((%291
       %313) (%220 $0))) ((%11 ((%15 %16) %314)) ((%317 ((%6 $1) ((%13
       %313) %314))) (%21 %18))))))))))`)
  val idcImpEvTmnl =
    DT(["DISK_THM"], [],
       `(%319 (\%320. (%321 (\%322. (%321 (\%323. (%321 (\%324. ((%165
       ((%11 ((((%325 (%326 ((%289 %290) %74))) $3) ((%327 %74) ((%328
       ((%329 %330) $2)) $1))) ((%327 %74) ((%328 $2) $0)))) (%331 %290)))
       ((%332 %333) %330))))))))))`)
  val idlStateEq =
    DT(["DISK_THM"], [],
       `(%319 (\%320. (%0 (\%74. (%0 (\%334. (%321 (\%335. (%321 (\%336.
       (%321 (\%323. (%321 (\%324. ((%165 ((((%325 (%326 ((%289 %290) $5)))
       $6) ((%327 $5) ((%328 $3) $1))) ((%327 $4) ((%328 $2) $0)))) ((%245
       $5) $4))))))))))))))))`)
  val idInpLen =
    DT(["DISK_THM"], [],
       `((%165 (((%337 ((%287 %18) %293)) ((%338 %293) ((%339 %340) %299)))
       ((%338 %78) ((%339 %341) %342)))) ((%343 (%344 %341)) (%344
       %340)))`)
  val idStateEq =
    DT(["DISK_THM"], [],
       `((%165 (((%337 ((%287 %18) %293)) ((%338 %293) ((%339 %340) %299)))
       ((%338 %78) ((%339 %341) %342)))) ((%88 %293) %78))`)
  val idcInpLen =
    DT(["DISK_THM"], [],
       `(%319 (\%320. (%0 (\%74. (%321 (\%335. (%321 (\%336. (%321 (\%323.
       (%321 (\%324. ((%165 ((%11 ((((%325 (%326 ((%289 %290) $4))) $5)
       ((%327 $4) ((%328 $3) $1))) ((%327 $4) ((%328 $2) $0)))) ((%345
       (%346 $5)) (%347 (%348 %349))))) ((%343 (%350 $2)) (%350
       $3)))))))))))))))`)
  val idlStkEq =
    DT(["DISK_THM"], [],
       `(%319 (\%320. (%0 (\%74. (%321 (\%335. (%321 (\%323. (%321 (\%324.
       ((%165 ((((%325 (%326 ((%289 %290) $3))) $4) ((%327 $3) ((%328 $2)
       $1))) ((%327 $3) ((%328 $2) $0)))) ((%351 $1) $0))))))))))))`)
  val idcImpLd =
    DT(["DISK_THM"], [],
       `(%319 (\%320. (%321 (\%322. (%321 (\%323. (%321 (\%324. ((%165
       ((%11 ((((%325 (%326 ((%289 %290) %74))) $3) ((%327 %74) ((%328
       ((%329 %330) $2)) $1))) ((%327 %74) ((%328 $2) $0)))) (%331 %290)))
       (((%352 (%353 %290)) $1) ((%329 %330) $0)))))))))))`)
  val laesImpLang =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%354 %355) (%356 ((%287 %18) %293)))) (%19 %18)))
       ((%354 %355) (%357 %18)))`)
  val gnfNotLastTmns =
    DT(["DISK_THM"], [],
       `(%2 (\%355. (%2 (\%358. ((%165 (((%359 (%360 %18)) $1) $0)) ((%165
       ((%12 $1) ((%13 (%294 %361)) %362))) ((%165 (%19 %18)) (%2 (\%363.
       (%2 (\%364. (%0 (\%316. ((%165 ((%12 $3) ((%365 ((%365 $2) ((%13
       (%294 $0)) %362))) $1))) ((%15 %16) $1)))))))))))))))`)
  val ldImpIdc =
    DT(["tactic_failed"], [],
       `(%366 (\%367. (%2 (\%355. (%2 (\%358. ((%165 ((%11 ((((%368 (%360
       %18)) $2) ((%13 (%294 (%295 %18))) %362)) ((%365 $1) $0))) ((%11
       (%19 %18)) ((%11 ((%15 %14) $1)) ((%15 %16) $0))))) (((%369 (%337
       ((%287 %18) %293))) ((%338 %293) ((%339 $1) ((%13 (%294 (%295 %18)))
       %362)))) ((%338 %293) ((%339 %362) $0))))))))))`)
  val langImpLaes =
    DT(["DISK_THM", "MK_THM", "tactic_failed"], [],
       `((%165 ((%11 ((%354 %355) (%357 %18))) (%19 %18))) ((%354 %355)
       (%356 ((%287 %18) %293))))`)
  val thm5_3 =
    DT(["DISK_THM", "MK_THM", "tactic_failed"], [],
       `(%370 (\%371. ((%165 (%372 $0)) (%373 (\%374. ((%4 ((%375 %376)
       (%377 $1))) ((%375 %376) (%378 $0))))))))`)
  val adj_ind =
    DT(["DISK_THM"], [],
       `(%379 (\%380. ((%165 ((%11 (%0 (\%74. (%24 (\%77. (%149 (\%78.
       (%149 (\%82. (%265 (\%85. (%381 (\%86. (($6 (%274 ((%275 $5) ((%273
       $4) $3)))) (%382 ((%383 $2) ((%384 $1) $0))))))))))))))))) ((%11 (%0
       (\%74. (%24 (\%77. (%149 (\%78. (%385 (\%386. (($4 (%274 ((%275 $3)
       ((%273 $2) $1)))) (%387 $0))))))))))) (%151 (\%388. (%94 (\%389.
       (($2 (%390 $1)) $0)))))))) (%92 (\%69. (%94 (\%70. (($2 $1)
       $0))))))))`)
  val adj_def =
    DT(["DISK_THM"], [],
       `((%4 ((%96 (%274 ((%275 %74) ((%273 %77) %78)))) (%382 ((%383 %82)
       ((%384 %85) %86))))) ((%88 %78) %82))`)
  val transSym_ind =
    DT(["DISK_THM"], [],
       `(%391 (\%392. ((%165 ((%11 (%24 (\%109. (%0 (\%112. (%149 (\%113.
       ($3 (%393 ((%394 $2) ((%395 $1) $0))))))))))) (%151 (\%396. ($1
       (%397 $0)))))) (%398 (\%399. ($1 $0))))))`)
  val transSym_def =
    DT(["DISK_THM"], [],
       `((%245 (%99 (%393 ((%394 %109) ((%395 %112) %113))))) %112)`)
  val transToState_ind =
    DT(["DISK_THM"], [],
       `(%400 (\%401. ((%165 ((%11 (%24 (\%109. (%149 (\%130. (%0 (\%131.
       ($3 (%402 ((%403 $2) ((%404 $1) $0))))))))))) (%151 (\%396. ($1
       (%405 $0)))))) (%406 (\%407. ($1 $0))))))`)
  val transToState_def =
    DT(["DISK_THM"], [],
       `((%245 (%118 (%402 ((%403 %109) ((%404 %130) %131))))) %131)`)
  val transFrmState_ind =
    DT(["DISK_THM"], [],
       `(%408 (\%409. ((%165 ((%11 (%0 (\%143. (%24 (\%146. (%149 (\%113.
       ($3 (%274 ((%275 $2) ((%273 $1) $0))))))))))) (%151 (\%396. ($1
       (%390 $0)))))) (%92 (\%69. ($1 $0))))))`)
  val transFrmState_def =
    DT(["DISK_THM"], [],
       `((%245 (%133 (%274 ((%275 %143) ((%273 %146) %113))))) %143)`)
  val p2gGrExists =
    DT(["DISK_THM"], [],
       `(%180 (\%181. (%410 (\%411. ((%412 $0) (%233 $1))))))`)
  val pdaTransSplit =
    DT(["DISK_THM", "MK_THM"], [],
       `(%0 (\%74. (%0 (\%413. (%414 (\%415. (%416 (\%417. ((%165 ((((%418
       (%419 %420)) %421) ((%422 $3) ((%423 $1) $0))) ((%422 $2) ((%423
       %424) %214)))) (%425 (\%426. ((%11 ((%427 $2) (%428 ((%429 %430)
       $0)))) ((%11 ((%213 $1) ((%431 %432) $0))) ((%11 (%0 (\%280. ((%165
       ((%433 $0) ((%434 %435) $1))) ((%433 $0) ((%436 %420) (%437
       %420))))))) ((%11 (%0 (\%280. ((%165 ((%433 $0) ((%434 %438) $1)))
       ((%433 $0) ((%436 %420) (%437 %420))))))) ((%11 (%439 (\%440. (%441
       (\%442. ((%165 ((%443 $2) ((%444 $1) $0))) ((%11 ((%245 (%438 $1))
       $6)) ((%11 ((%88 (%432 $1)) (%445 $3))) ((%245 (%435 (%446 $2)))
       $5))))))))) (%439 (\%447. (%439 (\%448. (%441 (\%449. (%441 (\%450.
       ((%165 ((%443 $4) ((%451 ((%451 $1) ((%444 $3) ((%444 $2) %452))))
       $0))) ((%11 ((%245 (%438 $2)) (%435 $3))) (%439 (\%453. ((%165
       ((%454 $0) $5)) (%455 (\%456. ((%11 ((%343 $0) (%457 %421)))
       ((((%458 (%419 %420)) $0) ((%422 (%438 $1)) ((%423 (%430 $1)) ((%459
       (%432 $1)) %214)))) ((%422 (%435 $1)) ((%423 %424)
       %214)))))))))))))))))))))))))))))))))))`)
  val toRhsLd =
    DT(["DISK_THM"], [],
       `(%460 (\%461. ((%165 (%462 (\%463. ((%165 ((%464 $0) $1)) (((%465
       (%466 %467)) ((%468 (%469 ((%258 (%470 $0)) ((%157 (%471 $0)) (%472
       $0))))) %473)) ((%474 %475) (%476 $0))))))) (((%465 (%466 %467))
       ((%477 %478) $0)) ((%474 %475) (%428 ((%479 %476) $0)))))))`)
  val nextMemRuleExistsNone =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%201 ((%202 ((%203 %211) ((%157 %480) %193))) ((%204
       %194) ((%481 %482) %483)))) (%200 %181))) ((%233 %181) %232))) (%192
       (\%195. (%223 (\%484. ((%11 ((%234 ((%187 ((%206 %193) ((%157 %480)
       $1))) $0)) (%239 %232))) ((%208 $0) ((%485 %486) %483))))))))`)
  val nextMemRuleExistsSome =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%487 ((%488 ((%489 (%490 %491)) ((%492 %493) %74)))
       ((%494 %334) ((%495 %496) %497)))) (%498 %499))) ((%11 ((%500 %499)
       %501)) ((%345 (%502 %497)) (%347 (%348 %349)))))) (%315 (\%503.
       (%504 (\%505. ((%11 ((%506 ((%507 ((%508 %74) ((%492 %493) $1)))
       $0)) (%509 %501))) (%510 (\%511. (%504 (\%512. ((%11 ((%513 $2)
       ((%514 $1) $0))) ((%11 (%225 ((%513 $0) %515))) ((%11 ((%516 $1)
       %491)) ((%11 ((%427 ((%517 %518) $0)) ((%495 %496) %497))) (((%519
       %499) ((%520 %334) ((%494 $3) ((%495 %496) %497))))
       $0)))))))))))))))`)
  val nextMemRuleExistsSome1 =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%487 ((%488 ((%489 (%490 %491)) ((%492 %493) %74)))
       ((%494 %334) ((%521 (%496 %522)) %424)))) (%498 %499))) ((%500 %499)
       %501))) ((%11 ((%506 ((%507 ((%508 %74) ((%492 %493) %334))) ((%514
       %491) %515))) (%509 %501))) (%523 (\%524. (%525 (\%526. ((%11 ((%527
       $1) ((%528 (%529 $0)) %530))) ((%11 ((%531 %532) (%533 (%534 $0))))
       ((%535 %536) ((%537 (%538 $0)) %539))))))))))`)
  val nextMem2RuleNone =
    DT(["DISK_THM"], [],
       `((%165 ((%201 ((%202 ((%203 %211) ((%157 %480) %193))) ((%204 %195)
       %214))) (%200 %181))) ((%165 ((%233 %181) %232)) ((%234 ((%187
       ((%206 %193) ((%157 %480) %195))) %209)) (%239 %232))))`)
  val ruleMem2nextMemNone =
    DT(["DISK_THM"], [],
       `((%165 ((%506 ((%507 ((%508 %74) ((%492 %493) %503))) %515)) (%509
       %501))) ((%165 ((%540 %541) %501)) ((%542 ((%543 ((%544 %545) ((%492
       %493) %74))) ((%494 %503) %424))) (%546 %541))))`)
  val ruleMem2nextMemSome =
    DT(["DISK_THM"], [],
       `((%165 ((%506 ((%507 ((%508 %74) ((%492 %493) %503))) ((%514 %491)
       %515))) (%509 %501))) ((%165 ((%500 %499) %501)) ((%487 ((%488
       ((%489 (%490 %491)) ((%492 %493) %74))) ((%494 %503) %424))) (%498
       %499))))`)
  val nextMem2RuleSome =
    DT(["DISK_THM"], [],
       `((%165 ((%487 ((%488 ((%489 (%490 %491)) ((%492 %493) %74))) ((%494
       %503) %424))) (%498 %499))) ((%165 ((%500 %499) %501)) ((%506 ((%507
       ((%508 %74) ((%492 %493) %503))) ((%514 %491) %515))) (%509
       %501))))`)
  val pdaTransListDerives =
    DT(["DISK_THM"], [],
       `(%547 (\%548. ((%165 ((%11 (%549 (\%550. (%549 (\%551. (%547
       (\%552. (%547 (\%553. ((%165 ((%554 $4) ((%555 ((%555 $1) ((%556 $3)
       ((%556 $2) %557)))) $0))) ((%245 (%558 $2)) (%559 $3))))))))))))
       (%549 (\%560. ((%165 ((%561 $0) $1)) (((%562 (%563 %501)) ((%514
       (%564 ((%508 (%558 $0)) ((%492 (%565 $0)) (%559 $0))))) %515)) (%566
       $0))))))) (((%562 (%563 %501)) ((%567 %568) $0)) (%569 ((%570 %566)
       $0))))))`)
  val isAdj =
    DT(["DISK_THM"], [],
       `(%571 (\%572. (%571 (\%573. (%574 (\%575. (%574 (\%576. ((%165
       ((%577 %578) ((%579 ((%579 $1) ((%580 $3) ((%580 $2) %581)))) $0)))
       ((%165 ((%245 (%582 $2)) (%583 $3))) ((%584 (%585 $3)) (%586
       $2))))))))))))`)
  val transSymtupStk =
    DT(["DISK_THM"], [], `((%245 (%99 (%587 %588))) (%589 %588))`)
  val maptransSymtupStk =
    DT(["DISK_THM"], [],
       `(%590 (\%591. ((%213 ((%592 %593) ((%594 %595) $0))) ((%596 %597)
       $0))))`)
  val isNttoRhs = DT(["DISK_THM"], [], `(%598 (%270 %599))`)
  val everyIsNttoRhs =
    DT(["DISK_THM"], [], `(%590 (\%591. ((%600 %601) ((%594 %595) $0))))`)
  val transFrmStEq =
    DT(["DISK_THM"], [], `((%245 (%133 (%270 %599))) (%602 %599))`)
  val transToStEq =
    DT(["DISK_THM"], [], `((%245 (%118 (%603 %604))) (%605 %604))`)
  val memMapToRhsSl =
    DT(["DISK_THM"], [],
       `(%590 (\%606. ((%165 ((%11 ((%607 %608) ((%594 %595) $0))) (%151
       (\%609. ((%165 ((%198 $0) ((%610 %611) $1))) ((%198 $0) ((%612 %613)
       (%614 %613)))))))) ((%198 (%615 %608)) ((%612 %613) (%614
       %613))))))`)
  val memMapToRhsSl' =
    DT(["DISK_THM"], [],
       `(%590 (\%606. ((%165 ((%11 ((%607 %608) ((%594 %595) $0))) (%0
       (\%280. ((%165 ((%433 $0) ((%616 %246) $1))) ((%433 $0) ((%617 %618)
       (%619 %618)))))))) ((%433 (%620 %608)) ((%617 %618) (%619
       %618))))))`)
  val isAdjList =
    DT(["DISK_THM"], [],
       `(%574 (\%621. (%622 (\%623. (%622 (\%624. ((%165 (%571 (\%572.
       (%571 (\%573. (%574 (\%575. (%574 (\%576. ((%165 ((%577 $6) ((%579
       ((%579 $1) ((%580 $3) ((%580 $2) %581)))) $0))) ((%245 (%582 $2))
       (%583 $3)))))))))))) ((%165 ((%625 ((%626 %585) $2)) ((%627 ((%627
       $1) ((%628 %629) ((%628 %630) %631)))) $0))) ((%632 %629)
       %630)))))))))`)
  val p2gtransNone =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%633 (%634 %578)) (%347 (%635 %349)))) ((%11 ((%636
       ((%637 ((%638 %639) ((%404 %480) %74))) ((%640 %334) ((%641 %642)
       %578)))) (%643 %644))) ((%11 (%0 (\%280. ((%165 ((%433 $0) ((%645
       %583) %578))) ((%433 $0) ((%646 %644) (%643 %644))))))) ((%11 (%0
       (\%280. ((%165 ((%433 $0) ((%645 %582) %578))) ((%433 $0) ((%646
       %644) (%643 %644))))))) ((%11 (%571 (\%647. (%574 (\%621. ((%165
       ((%577 %578) ((%580 $1) $0))) ((%11 ((%245 (%582 $1)) %334)) ((%245
       (%583 (%648 ((%580 $1) $0)))) %503)))))))) (%571 (\%572. (%571
       (\%573. (%574 (\%575. (%574 (\%576. ((%165 ((%577 %578) ((%579
       ((%579 $1) ((%580 $3) ((%580 $2) %581)))) $0))) ((%245 (%582 $2))
       (%583 $3))))))))))))))))) ((%649 %644) ((%650 ((%651 %74) ((%404
       %480) %503))) ((%652 %586) %578))))`)
  val p2gtransSome =
    DT(["DISK_THM"], [],
       `((%165 ((%11 ((%633 (%634 %578)) (%347 (%635 %349)))) ((%11 ((%653
       ((%654 ((%655 (%656 %657)) ((%404 %480) %74))) ((%640 %334) ((%641
       %642) %578)))) (%658 %659))) ((%11 (%660 %657)) ((%11 (%0 (\%280.
       ((%165 ((%433 $0) ((%645 %583) %578))) ((%433 $0) ((%661 %659) (%658
       %659))))))) ((%11 (%0 (\%280. ((%165 ((%433 $0) ((%645 %582) %578)))
       ((%433 $0) ((%661 %659) (%658 %659))))))) ((%11 (%571 (\%647. (%574
       (\%621. ((%165 ((%577 %578) ((%580 $1) $0))) ((%11 ((%245 (%582 $1))
       %334)) ((%245 (%583 (%648 ((%580 $1) $0)))) %503)))))))) (%571
       (\%572. (%571 (\%573. (%574 (\%575. (%574 (\%576. ((%165 ((%577
       %578) ((%579 ((%579 $1) ((%580 $3) ((%580 $2) %581)))) $0))) ((%245
       (%582 $2)) (%583 $3)))))))))))))))))) ((%662 %659) ((%663 ((%651
       %74) ((%404 %480) %503))) ((%628 %657) ((%626 %585) %578)))))`)
  val pdaImpP2g =
    DT(["DISK_THM", "MK_THM"], [],
       `(%664 (\%665. (%0 (\%74. (%24 (\%493. (%0 (\%503. ((%165 ((%11
       ((((%666 (%667 %499)) %668) ((%669 $2) ((%670 $3) ((%521 $1)
       %424)))) ((%669 $0) ((%670 %515) %424)))) ((%11 ((%671 %672) $3))
       ((%500 %499) %501)))) (((%562 (%563 %501)) ((%514 (%564 ((%508 $2)
       ((%492 $1) $0)))) %515)) $3))))))))))`)
  val listPairImpIdc =
    DT(["DISK_THM"], [],
       `(%673 (\%674. ((%165 ((%11 (%675 (\%676. (%677 (\%678. ((%165
       ((%679 ((%680 $1) $0)) $2)) (((%681 (%682 %683)) ((%684 (%685 $1))
       ((%686 $0) ((%521 (%518 $1)) %424)))) ((%684 (%687 $1)) ((%686 %688)
       %424))))))))) (%675 (\%676. (%675 (\%689. (%664 (\%690. (%664
       (\%691. ((%165 ((%513 ((%692 %693) $4)) ((%694 ((%694 $1) ((%514 $3)
       ((%514 $2) %515)))) $0))) ((%695 $3) $2)))))))))))) ((%165 ((%671
       %696) ((%692 %693) $0))) (%675 (\%697. (%677 (\%698. (%675 (\%699.
       (%677 (\%700. (%673 (\%701. ((%165 ((%11 ((%702 $5) ((%703 ((%680
       $4) $3)) $0))) ((%704 (%705 $5)) ((%680 $2) $1)))) (((%681 (%682
       %683)) ((%684 (%685 $4)) ((%686 ((%706 $3) (%707 ((%708 %709) $0))))
       ((%710 ((%521 (%518 $4)) %424)) ((%517 %518) ((%692 %693) $0))))))
       ((%684 (%687 $2)) ((%686 %688) %424))))))))))))))))))`)
  val p2gImpPda =
    DT(["DISK_THM", "tactic_failed"], [],
       `(%0 (\%74. (%24 (\%493. (%0 (\%503. (%664 (\%665. ((%165 ((((%711
       (%563 %501)) %712) ((%514 (%564 ((%508 $3) ((%492 $2) $1)))) %515))
       $0)) ((%165 ((%671 %672) $0)) ((%165 ((%500 %499) %501)) (((%713
       (%667 %499)) ((%669 $3) ((%670 $0) ((%521 $2) %424)))) ((%669 $1)
       ((%670 %515) %424))))))))))))))`)
  val p2gEqPda =
    DT(["DISK_THM", "MK_THM", "tactic_failed"], [],
       `((%165 ((%11 ((%500 %499) %501)) ((%671 %672) %665))) (%0 (\%74.
       (%24 (\%493. (%0 (\%503. ((%4 (((%562 (%563 %501)) ((%514 (%564
       ((%508 $2) ((%492 $1) $0)))) %515)) %665)) (((%713 (%667 %499))
       ((%669 $2) ((%670 %665) ((%521 $1) %424)))) ((%669 $0) ((%670 %515)
       %424)))))))))))`)
  end
  val _ = DB.bindl "pdaEqCfg"
  [("validGnfProd_def",validGnfProd_def,DB.Def),
   ("isGnf_def",isGnf_def,DB.Def), ("trans_def",trans_def,DB.Def),
   ("grammar2pda_def",grammar2pda_def,DB.Def),
   ("adj_tupled_primitive_def",adj_tupled_primitive_def,DB.Def),
   ("adj_curried_def",adj_curried_def,DB.Def),
   ("transSym_primitive_def",transSym_primitive_def,DB.Def),
   ("transToState_primitive_def",transToState_primitive_def,DB.Def),
   ("transFrmState_primitive_def",transFrmState_primitive_def,DB.Def),
   ("ntslCond_def",ntslCond_def,DB.Def),
   ("p2gtrans_def",p2gtrans_def,DB.Def),
   ("pda2grammar_def",pda2grammar_def,DB.Def),
   ("tupfrmst_def",tupfrmst_def,DB.Def),
   ("tuptost_def",tuptost_def,DB.Def), ("tupinp_def",tupinp_def,DB.Def),
   ("tupstk_def",tupstk_def,DB.Def), ("toRhs_def",toRhs_def,DB.Def),
   ("nextToStk_def",nextToStk_def,DB.Def),
   ("g2pPdaExists",g2pPdaExists,DB.Thm),
   ("pdaStartState",pdaStartState,DB.Thm),
   ("pdaStackSym",pdaStackSym,DB.Thm),
   ("notNoneTrans",notNoneTrans,DB.Thm),
   ("transStateEq",transStateEq,DB.Thm),
   ("transMemList",transMemList,DB.Thm),
   ("transMemRule",transMemRule,DB.Thm),
   ("idcImpEvTmnl",idcImpEvTmnl,DB.Thm), ("idlStateEq",idlStateEq,DB.Thm),
   ("idInpLen",idInpLen,DB.Thm), ("idStateEq",idStateEq,DB.Thm),
   ("idcInpLen",idcInpLen,DB.Thm), ("idlStkEq",idlStkEq,DB.Thm),
   ("idcImpLd",idcImpLd,DB.Thm), ("laesImpLang",laesImpLang,DB.Thm),
   ("gnfNotLastTmns",gnfNotLastTmns,DB.Thm), ("ldImpIdc",ldImpIdc,DB.Thm),
   ("langImpLaes",langImpLaes,DB.Thm), ("thm5_3",thm5_3,DB.Thm),
   ("adj_ind",adj_ind,DB.Thm), ("adj_def",adj_def,DB.Thm),
   ("transSym_ind",transSym_ind,DB.Thm),
   ("transSym_def",transSym_def,DB.Thm),
   ("transToState_ind",transToState_ind,DB.Thm),
   ("transToState_def",transToState_def,DB.Thm),
   ("transFrmState_ind",transFrmState_ind,DB.Thm),
   ("transFrmState_def",transFrmState_def,DB.Thm),
   ("p2gGrExists",p2gGrExists,DB.Thm),
   ("pdaTransSplit",pdaTransSplit,DB.Thm), ("toRhsLd",toRhsLd,DB.Thm),
   ("nextMemRuleExistsNone",nextMemRuleExistsNone,DB.Thm),
   ("nextMemRuleExistsSome",nextMemRuleExistsSome,DB.Thm),
   ("nextMemRuleExistsSome1",nextMemRuleExistsSome1,DB.Thm),
   ("nextMem2RuleNone",nextMem2RuleNone,DB.Thm),
   ("ruleMem2nextMemNone",ruleMem2nextMemNone,DB.Thm),
   ("ruleMem2nextMemSome",ruleMem2nextMemSome,DB.Thm),
   ("nextMem2RuleSome",nextMem2RuleSome,DB.Thm),
   ("pdaTransListDerives",pdaTransListDerives,DB.Thm),
   ("isAdj",isAdj,DB.Thm), ("transSymtupStk",transSymtupStk,DB.Thm),
   ("maptransSymtupStk",maptransSymtupStk,DB.Thm),
   ("isNttoRhs",isNttoRhs,DB.Thm),
   ("everyIsNttoRhs",everyIsNttoRhs,DB.Thm),
   ("transFrmStEq",transFrmStEq,DB.Thm),
   ("transToStEq",transToStEq,DB.Thm),
   ("memMapToRhsSl",memMapToRhsSl,DB.Thm),
   ("memMapToRhsSl'",memMapToRhsSl',DB.Thm),
   ("isAdjList",isAdjList,DB.Thm), ("p2gtransNone",p2gtransNone,DB.Thm),
   ("p2gtransSome",p2gtransSome,DB.Thm), ("pdaImpP2g",pdaImpP2g,DB.Thm),
   ("listPairImpIdc",listPairImpIdc,DB.Thm),
   ("p2gImpPda",p2gImpPda,DB.Thm), ("p2gEqPda",p2gEqPda,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("pdaDefTheory.pdaDef_grammars",
                          pdaDefTheory.pdaDef_grammars),
                         ("grammarDefTheory.grammarDef_grammars",
                          grammarDefTheory.grammarDef_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       temp_overload_on
       ("validGnfProd", (Term.prim_mk_const { Name = "validGnfProd", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("isGnf", (Term.prim_mk_const { Name = "isGnf", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("trans", (Term.prim_mk_const { Name = "trans", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("grammar2pda", (Term.prim_mk_const { Name = "grammar2pda", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("adj_tupled", (Term.prim_mk_const { Name = "adj_tupled", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("adj", (Term.prim_mk_const { Name = "adj", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("transSym", (Term.prim_mk_const { Name = "transSym", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("transToState", (Term.prim_mk_const { Name = "transToState", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("transFrmState", (Term.prim_mk_const { Name = "transFrmState", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("ntslCond", (Term.prim_mk_const { Name = "ntslCond", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("p2gtrans", (Term.prim_mk_const { Name = "p2gtrans", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("pda2grammar", (Term.prim_mk_const { Name = "pda2grammar", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("tupfrmst", (Term.prim_mk_const { Name = "tupfrmst", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("tuptost", (Term.prim_mk_const { Name = "tuptost", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("tupinp", (Term.prim_mk_const { Name = "tupinp", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("tupstk", (Term.prim_mk_const { Name = "tupstk", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("toRhs", (Term.prim_mk_const { Name = "toRhs", Thy = "pdaEqCfg"}))
  val _ = update_grms
       temp_overload_on
       ("nextToStk", (Term.prim_mk_const { Name = "nextToStk", Thy = "pdaEqCfg"}))
  val pdaEqCfg_grammars = Parse.current_lgrms()
  end
  
  
  
  
  
  
  val _ = computeLib.add_funs [validGnfProd_def];  
  
  val _ = computeLib.add_funs [isGnf_def];  
  
  val _ = computeLib.add_funs [trans_def];  
  
  val _ = computeLib.add_funs [grammar2pda_def];  
  
  val _ = computeLib.add_funs [adj_def];  
  
  val _ = computeLib.add_funs [transSym_def];  
  
  val _ = computeLib.add_funs [transToState_def];  
  
  val _ = computeLib.add_funs [transFrmState_def];  
  
  val _ = computeLib.add_funs [ntslCond_def];  
  
  val _ = computeLib.add_funs [p2gtrans_def];  
  
  val _ = computeLib.add_funs [pda2grammar_def];  
  
  val _ = computeLib.add_funs [tupfrmst_def];  
  
  val _ = computeLib.add_funs [tuptost_def];  
  
  val _ = computeLib.add_funs [tupinp_def];  
  
  val _ = computeLib.add_funs [tupstk_def];  
  
  val _ = computeLib.add_funs [toRhs_def];  
  
  val _ = computeLib.add_funs [nextToStk_def];
  val _ = if !Globals.print_thy_loads then print "done\n" else ()

end
